;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; O2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
                    LDA #$04		;03FNbpNE 04FuCuC̊Ŕ
                    STA $C2,x            
                    JSL $03DD7D
                    STZ $1570,x             
					STZ $C2,x
					LDA #$20
					STA $38
					STA $39
					STZ $157C,x
					STZ $1602,x
					LDA #$12
					STA $00212C
					LDA #$05
					STA $00212D
					STZ $40
                    RTL   
                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;                  
START_HB_CODE       LDA $C2,x
					CMP #$80
					BCS ENE_MODE
					CMP #$77
					BEQ STAR_MODE
					LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN4              ; /
                    LDA $9D                 ; \ if sprites locked, return
					BNE RETURN4
					JSR HDMA1
					JSR BAG_CHECK
					JSR MODE_CHECK
					JSL $01802A
					JSR POS_SET
RETURN4				RTS

ENE_MODE			JSR E_SUB_GFX
					LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN4              ; /
                    LDA $9D                 ; \ if sprites locked, return
					BNE RETURN4
					JSL $01A7DC
					LDA $C2,x
					AND #$7F
					CMP #$01
					BEQ ENE_MODE1
					CMP #$02
					BEQ ENE_MODE2
					BRA ENE_MODE0
ENE_MODE2			STZ $B6,x
					LDA #$30
					STA $AA,x
					LDA $D8,x
					CMP #$B0
					BCC ENE_MODE0
					JSR SPEED_DEC4
					LDA #$81
					STA $C2,x
					BRA ENE_MODE0
ENE_MODE1			LDA $1504,x
					STA $B6,x
					LDA $151C,x
					STA $AA,x
ENE_MODE0			JSL $01802A
					LDA $14E0,x
					BNE DEL_ENE
					LDA $14D4,x
					BNE DEL_ENE
					RTS
DEL_ENE				STZ $14C8,x
					RTS
					
STAR_MODE			JSR STAR_SUB_GFX
					LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN4              ; /
                    LDA $9D                 ; \ if sprites locked, return
					BNE RETURN4
					STZ $AA,x
					LDA $157C,x
					TAY
					LDA STAR_SPEED,y
					STA $B6,x
					JSL $01802A
					LDA $14E0,x
					BNE DEL_ENE
					RTS

STAR_SPEED			dcb $B0,$50
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Action Routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X_SPEED				dcb $10,$F0

MODE_CHECK			LDA $C2,x
					BNE NOT_MODE0
					JSR MODE0
					RTS
NOT_MODE0			CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$02
					BNE NOT_MODE2
					JSR MODE2
					RTS
NOT_MODE2			CMP #$03
					BNE NOT_MODE3
					JSR MODE3
					RTS
NOT_MODE3			CMP #$04
					;BNE NOT_MODE4
					JSR MODE4
					RTS

STAR_CHECK_R		RTS
STAR_CHECK			LDA $18
					AND #$10
					BEQ STAR_CHECK_R
					JSR STAR_CHECK2
					TYA
					CMP #$02
					BCS STAR_CHECK_R
					LDA $E4,x
					PHA
					LDA $14E0,x
					PHA
					LDA $D8,x
					PHA
					LDA $14D8,x
					PHA
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					CLC
					ADC #$10
					STA $D8,x
					LDA $97
					ADC #$00
					STA $14D4,x
					JSR GEN_ENE
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					LDA #$77
					STA $00C2,y
					LDA $76
					STA $157C,y
					RTS

STAR_CHECK2			LDY #$00
					PHX
					LDX #$00
STAR_CHECK2_LOOP	LDA $14C8,x
					CMP #$08
					BNE STAR_CHECK2_2
					LDA $C2,x
					CMP #$77
					BNE STAR_CHECK2_2
					INY
STAR_CHECK2_2		INX
					CPX #$0A
					BCC STAR_CHECK2_LOOP
					PLX
					RTS

MODE0				LDA $1570,x
					CMP #$FF
					BCC MODE0_H
					LDA #$13
					STA $00212C
					LDA #$04
					STA $00212D
					LDA $D8,x
					CMP #$61
					BCS MODE0_1
					STZ $AA,x
					LDA $15AC,x
					CMP #$E0
					BCS MODE0_7
					CMP #$C0
					BCS MODE0_8_0
					CMP #$B0
					BCS MODE0_7
					CMP #$A0
					BCS MODE0_2
					CMP #$90
					BCS MODE0_3
					CMP #$80
					BCS MODE0_4
					CMP #$70
					BCS MODE0_5
					CMP #$60
					BCS MODE0_2
					CMP #$50
					BCS MODE0_3
					CMP #$40
					BCS MODE0_4
					CMP #$30
					BCS MODE0_5
					CMP #$20
					BEQ MODE0_6
					DEC $38
					DEC $39
					RTS
MODE0_H				LDA #$12
					STA $00212C
					LDA #$05
					STA $00212D
					STZ $40
					INC $1570,x
					STZ $AA,x
					RTS
MODE0_1				LDA #$FC
					STA $AA,x
					STZ $B6,x
					LDA #$F0
					STA $15AC,x
					RTS
MODE0_2				STZ $30
					DEC $38
					RTS
MODE0_3				INC $38
					RTS
MODE0_4				DEC $39
					RTS
MODE0_5				INC $39
					RTS
MODE0_8_0			JMP MODE0_8
MODE0_6				LDA #$10
					STA $38
					STA $39
					LDA #$01
					STA $C2,x
					LDA #$20
					STA $1540,x
					LDA #$60
					STA $15AC,x
					RTS
MODE0_7				LDA $7FF030
					CLC
					ADC #$10
					STA $30
					STA $7FF030
					LDA $7FF031
					ADC #$00
					STA $7FF031
					STA $31
					RTS
MODE0_8				LDA $7FF030
					SEC
					SBC #$10
					STA $30
					STA $7FF030
					LDA $7FF031
					SBC #$00
					STA $7FF031
					STA $31
					RTS

					
MODE1				LDA $1540,x
					BNE MODE1_4
					JSR STAR_CHECK
					JSR DAMAGE_CHECK
					LDA $15AC,x
					BNE MODE1_1
					LDA #$33
					STA $15AC,x
					INC $1602,x
					LDA $1602,x
					AND #$03
					BNE MODE1_0
					LDA $38
					CMP #$0D
					BCS MODE1_0
					CMP #$09
					BCC MODE1_5
					JSR GEN_ENE
					LDA #$11
					STA $167A,y
					LDA #$1B
					STA $166E,y
					LDA #$82
					STA $00C2,y
					LDA #$07
					STA $1602,y
					BRA MODE1_1
MODE1_4				STZ $AA,x
					STZ $B6,x
					RTS
MODE1_5				JSR GEN_ENE
					LDA #$11
					STA $167A,y
					LDA #$1B
					STA $166E,y
					LDA #$81
					STA $00C2,y
					JSR SPEED_DEC3
					LDA #$0B
					STA $1602,y
					BRA MODE1_1
MODE1_0				JSR GEN_ENE
					LDA #$11
					STA $167A,y
					LDA #$1B
					STA $166E,y 
					JSR SPEED_DEC
					LDA #$80
					STA $00C2,y
					LDA #$05
					STA $1602,y
MODE1_1				LDA $D8,x
					CMP #$A0
					BCC MODE1_2
					LDA #$A0
					STA $AA,x
MODE1_2				LDA $157C,x
					TAY
					LDA X_SPEED,y
					STA $B6,x
					LDA $E4,x
					CMP #$F0
					BCS MODE1_2_R
					CMP #$10
					BCC MODE1_2_L
					RTS
MODE1_2_R			LDA #$01
					STA $157C,x
					RTS
MODE1_2_L			STZ $157C,x
					RTS


MODE2				STZ $AA,x
					STZ $B6,x
					LDA $15AC,x
					BNE MODE2_R
					PHP
					REP #$20
					LDA $36
					CLC
					;ADC.W #$0004 ;eS߂̂Ŗv
					ADC.W #$0002
                    AND.W #$01FF
					STA $36
                    PLP
					LDA $36
					AND #$1F
					BNE MODE2_R
					JSR GEN_ENE
					LDA #$11
					STA $167A,y
					LDA #$1B
					STA $166E,y 
					JSR SPEED_DEC2
					LDA #$81
					STA $00C2,y
					LDA #$05
					STA $1602,y
					INC $1570,x
					LDA $1570,x
					;CMP #$20
					CMP #$10
					BEQ MODE2_2
MODE2_R				RTS
MODE2_2				STZ $1570,x
					LDA #$01
					STA $C2,x
					LDA #$40
					STA $15AC,x
					JSR DEL_ALL_ENE
					RTS
MODE3				LDA $1570,x
					CMP #$01
					BEQ MODE3_2
					CMP #$02
					BEQ MODE3_4
					CMP #$03
					BEQ MODE3_5_0
					CMP #$04
					BEQ MODE3_6_0
					LDA #$C0
					STA $AA,x
					STZ $B6,x
					LDA $14D4,x
					CMP #$FF
					BNE MODE3_R
					LDA $D8,x
					CMP #$C0
					BCS MODE3_R
					LDA #$08
					STA $E4,x
					STZ $14E0,x
					STZ $AA,x
					LDA #$00
					STA $36
					LDA #$01
					STA $37
					INC $1570,x
MODE3_R				RTS
MODE3_2				LDA $14D4,x
					BNE MODE3_R
					LDA $D8,x
					CMP #$30
					BCS MODE3_3
					LDA #$10
					STA $AA,x
					STZ $B6,x
					RTS
MODE3_3				STZ $AA,x
					STZ $B6,x
					LDA #$02
					STA $1570,x
					LDA #$10
					STA $15AC,x
					RTS
MODE3_5_0			JMP MODE3_5
MODE3_6_0			JMP MODE3_7
MODE3_4				LDA #$10
					STA $B6,x
					STZ $AA,x
					LDA $15AC,x
					BNE MODE3_R
					LDA #$20
					STA $15AC,x
					JSR GEN_ENE
					LDA #$11
					STA $167A,y
					LDA #$1B
					STA $166E,y 
					LDA #$40
					STA $151C,y
					LDA #$00
					STA $1504,y
					LDA #$81
					STA $00C2,y
					LDA #$05
					STA $1602,y
					LDA $E4,x
					CMP #$F0
					BCC MODE3_R
					LDA #$03
					STA $1570,x
					STZ $B6,x
					RTS
MODE3_5				STZ $AA,x
					STZ $B6,x
					LDA $36
					ORA $37
					BEQ MODE3_6
					PHP
					REP #$20
					LDA $36
					CLC
					ADC.W #$0004
                    AND.W #$01FF
					STA $36
                    PLP
MODE3_R2			RTS
MODE3_6				LDA #$20
					STA $AA,x
					STZ $B6,x
					LDA $D8,x
					CMP #$B0
					BCC MODE3_R2
					LDA #$04
					STA $1570,x
					LDA #$20
					STA $15AC,x
					RTS
MODE3_7				STZ $AA,x
					LDA #$F0
					STA $B6,x
					LDA $E4,x
					CMP #$10
					BCS MODE3_7_2
					LDA #$01
					STA $C2,x
					RTS
MODE3_7_2			LDA $15AC,x
					BNE MODE3_R2
					LDA #$20
					STA $15AC,x
					JSR GEN_ENE
					LDA #$11
					STA $167A,y
					LDA #$1B
					STA $166E,y 
					LDA #$C0
					STA $151C,y
					LDA #$00
					STA $1504,y
					LDA #$81
					STA $00C2,y
					LDA #$05
					STA $1602,y
					RTS
					
MODE4				STZ $AA,x
					STZ $B6,x
					LDA $15AC,x
					BNE MODE4_R
					LDA $1570,x
					BNE THEEND
					PHP
					REP #$20
					LDA $36
					CLC
					ADC.W #$0004
                    AND.W #$01FF
					STA $36
                    PLP
					INC $38
					;INC $39
					LDA $38
					CMP #$80
					BEQ MODE4_2
					CMP #$10
					BNE MODE4_R
					LDA #$2B
					STA $1DFC
MODE4_R				RTS
MODE4_2				LDA #$01
					STA $1570,x
					LDA #$40
					STA $15AC,x
					LDA #$12
					STA $00212C
					LDA #$05
					STA $00212D
					RTS
THEEND				LDA #$FF
					STA $13C6
                    STA $1493
					LDA #$0B
					STA $1DFB
					STZ $14C8,x
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Mist Routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ENE2_X				dcb $30,$40,$60,$7F,$60,$40,$30,$00,$D0,$C0,$A0,$81,$A0,$C0,$D0,$00
ENE2_Y				dcb $A0,$C0,$D0,$00,$30,$40,$60,$7F,$60,$40,$30,$00,$D0,$C0,$A0,$81
;ENE2_X				dcb $18,$20,$30,$40,$30,$20,$18,$00,$E8,$E0,$D0,$C0,$D0,$E0,$E8,$00
;ENE2_Y				dcb $D0,$E0,$E8,$00,$18,$20,$30,$40,$30,$20,$18,$00,$E8,$E0,$D0,$C0

POS_SET				LDA $E4,x
					CLC
					ADC #$08
                    STA $E4                 ;  | 
					LDA $14E0,x
                    STZ $14E0               ; /
					LDA $D8,x
					CLC
					ADC #$48
                    STA $D8                 ;  |
					LDA $14D4,x
					ADC #$00
                    STZ $14D4               ; /
                    LDA #$2C                ; \ ??affects reznor sign size?? 0 puts artifacts
                    STA $1BA2               ; /
					PHX
					LDX #$00
                    JSL $03DEDF             ; applies position changes to reznor sign
					PLX
					RTS
					
SPEED_DEC			LDA #$C0
					STA $00AA,y
					LDA $94
					CMP $E4,x
					BCS SPEED_RIGHT
					LDA $E4,x
					SEC
					SBC $94
					LSR A
					LSR A
					STA $0F
					LDA #$00
					SEC
					SBC $0F
					STA $00B6,y
SPEED_R				RTS
SPEED_RIGHT			LDA $94
					SEC
					SBC $E4,x
					LSR A
					LSR A
					STA $00B6,y
					RTS

					
SPEED_DEC2			LDA $1570,x
					AND #$0F
					PHX
					TAX
					LDA ENE2_X,x
					STA $1504,y
					LDA ENE2_Y,x
					STA $151C,y
					PLX
					RTS
					
SPEED_DEC3			LDA #$40
					STA $1504,y
					LDA #$00
					STA $151C,y
					LDA $E4,x
					SEC
					SBC $94
					LDA $14E0,x
					SBC $95
					BCC RETURN33
					LDA #$C0
					STA $1504,y
RETURN33			RTS
SPEED_DEC4			LDA #$40
					STA $1504,x
					LDA #$00
					STA $151C,x
					LDA $E4,x
					SEC
					SBC $94
					LDA $14E0,x
					SBC $95
					BCC RETURN33
					LDA #$C0
					STA $1504,x
					RTS


					
DAMAGE_CHECK        LDA $E4,x
                    STA $7FFE01
                    LDA $14E0,x
                    STA $7FFE02
                    LDA $D8,x
                    STA $7FFE03
                    LDA $14D4,x
                    STA $7FFE04
                    PHX
                    LDX #$09
LOOP1               LDA $C2,x
                    CMP #$77
                    BNE LOOP3
					LDA $14C8,x
					CMP #$08
					BNE LOOP3
					JSR NEAR_CHECK
                    TYA
                    BEQ LOOP3
					STZ $14C8,x
                    LDA #$28
					STA $1DFC
					PLX
					INC $1528,x
					PHX
LOOP3               DEX
                    BPL LOOP1
                    PLX
					JSR LARGE
					RTS
					
LARGE				LDA $1528,x
					CMP #$03
					BCS SULK
                    RTS
SULK				STZ $1528,x
					DEC $38
					DEC $39
					LDA $38
					CMP #$0C
					BEQ SUKL2
					CMP #$08
					BEQ SUKL3
					CMP #$02
					BEQ SUKL4
					RTS
SUKL2				JSR DEL_ALL_ENE
					LDA #$02
					STA $C2,x
					LDA #$30
					STA $15AC,x
					STZ $1570,x
LARGE_R				RTS
SUKL3				JSR DEL_ALL_ENE
					LDA #$03
					STA $C2,x
					STZ $1570,x
					RTS
SUKL4				JSR DEL_ALL_ENE
					LDA #$04
					STA $C2,x
					STZ $1570,x
					LDA #$80
					STA $15AC,x
					STZ $1570,x
					LDA #$1E
					STA $1DFB
LARGE_2				RTS
NEAR_CHECK          LDY #$00
                    LDA $E4,x
                    SEC
                    SBC $7FFE01
                    STA $0F
                    LDA $14E0,x
                    SBC $7FFE02
                    CMP #$00
                    BEQ RIGHT_CHECK
                    CMP #$FF
                    BNE CHECK_E
                    LDA $0F
                    CMP #$E8
                    BCC CHECK_E
                    BRA VER_CHECK
RIGHT_CHECK         LDA $0F
                    CMP #$18
                    BCS CHECK_E
VER_CHECK           LDA $D8,x
                    SEC
                    SBC $7FFE03
                    STA $0F
                    LDA $14D4,x
                    SBC $7FFE04
                    CMP #$00
                    BEQ UNDER_CHECK
                    CMP #$FF
                    BNE CHECK_E
                    LDA $0F
                    CMP #$E8
                    BCC CHECK_E
                    BRA NEAR
UNDER_CHECK         LDA $0F
                    CMP #$18
                    BCS CHECK_E
NEAR                LDY #$01
CHECK_E             RTS

DEL_ALL_ENE			PHX
					LDX #$00
DEL_ALL_LOOP		LDA $C2,x
					CMP #$80
					BCC DEL_ALL_2
					STZ $14C8,x
DEL_ALL_2			INX
					CPX #$0A
					BCC DEL_ALL_LOOP
					PLX
					RTS


BAG_CHECK			PHX
					LDX #$00
BAG_CHECK_LOOP		LDA $14C8,x
					CMP #$02
					BEQ BAG_CHECK_1
					LDA $C2,x
					CMP #$77
					BNE BAG_CHECK_2
					LDA $B6,x
					CMP #$30
					BCS BAG_CHECK_2
					CMP #$D0
					BCC BAG_CHECK_2
BAG_CHECK_1			STZ $14C8,x
BAG_CHECK_2			INX
					CPX #$0A
					BCC BAG_CHECK_LOOP
					PLX
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN67            RTS
GEN_ENE             JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
					TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
                    LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

                    LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
E_SUB_GFX           JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                    LDA $00                 ; \ tile x position = sprite x location ($00)
                    STA $0300,y             ; /   set x position of the tile
                    LDA $01
                    STA $0301,y             ; /   set y position of the tile
                    LDA #$26
                    STA $0302,y             ; / 
					LDA $1602,x            ;  | get palette info
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$00
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS

STAR_SUB_GFX        JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                    LDA $00                 ; \ tile x position = sprite x location ($00)
                    STA $0300,y             ; /   set x position of the tile
                    LDA $01
                    STA $0301,y             ; /   set y position of the tile
                    LDA #$2A
                    STA $0302,y             ; / 
					LDA $14
					LSR A
					LSR A
					AND #$01
					ASL A
					ASL A
					CLC
					ADC #$05
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$00
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS            					
					
					
                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /



RETURN_H			RTS
HDMA1				;wi
					LDA $7FFB28
					BNE RETURN_H

					LDA #$17
					STA $00212C
					LDA #$00
					STA $00212D

					LDA #$20
					STA $7FFB28
					LDA #$40
					STA $7FFB30
					
					LDA #$00
					STA $7FFB29
					LDA #$02
					STA $7FFB31
					
					LDA #$21
					STA $7FFB2A
					LDA #$22
					STA $7FFB32
					
					LDA #$00
					STA $7FFB2B
					STA $7FFB33
					LDA #$E1
					STA $7FFB2C
					LDA #$E2
					STA $7FFB34
					LDA #$7F
					STA $7FFB2D
					STA $7FFB35

HDMA1_1				LDA #$08 ;1
					STA $7FE100
					STA $7FE200
					LDA #$00
					STA $7FE101
					LDA #$08
					STA $7FE201
					LDA #$40
					STA $7FE202
					
					LDA #$08  ;2
					STA $7FE102
					STA $7FE203
					LDA #$00
					STA $7FE103
					LDA #$08
					STA $7FE204
					LDA #$3C
					STA $7FE205
					
					LDA #$08 ;3
					STA $7FE104
					STA $7FE206
					LDA #$00
					STA $7FE105
					LDA #$07
					STA $7FE207
					LDA #$38
					STA $7FE208
					
					LDA #$08  ;4
					STA $7FE106
					STA $7FE209
					LDA #$00
					STA $7FE107
					LDA #$07
					STA $7FE20A
					LDA #$34
					STA $7FE20B
					
					LDA #$08 ;5
					STA $7FE108
					STA $7FE20C
					LDA #$00
					STA $7FE109
					LDA #$06
					STA $7FE20D
					LDA #$30
					STA $7FE20E
					
					LDA #$08  ;6
					STA $7FE10A
					STA $7FE20F
					LDA #$00
					STA $7FE10B
					LDA #$06
					STA $7FE210
					LDA #$2C
					STA $7FE211
					
					LDA #$08 ;7
					STA $7FE10C
					STA $7FE212
					LDA #$00
					STA $7FE10D
					LDA #$05
					STA $7FE213
					LDA #$28
					STA $7FE214
					
					LDA #$08  ;8
					STA $7FE10E
					STA $7FE215
					LDA #$00
					STA $7FE10F
					LDA #$05
					STA $7FE216
					LDA #$24
					STA $7FE217
					
					LDA #$08 ;9
					STA $7FE110
					STA $7FE218
					LDA #$00
					STA $7FE111
					LDA #$04
					STA $7FE219
					LDA #$20
					STA $7FE21A
					
					LDA #$08  ;10
					STA $7FE112
					STA $7FE21B
					LDA #$00
					STA $7FE113
					LDA #$04
					STA $7FE21C
					LDA #$1C
					STA $7FE21D
					
					LDA #$08 ;11
					STA $7FE114
					STA $7FE21E
					LDA #$00
					STA $7FE115
					LDA #$03
					STA $7FE21F
					LDA #$18
					STA $7FE220
					
					LDA #$08  ;12
					STA $7FE116
					STA $7FE221
					LDA #$00
					STA $7FE117
					LDA #$03
					STA $7FE222
					LDA #$14
					STA $7FE223
					
					LDA #$08 ;13
					STA $7FE118
					STA $7FE224
					LDA #$00
					STA $7FE119
					LDA #$02
					STA $7FE225
					LDA #$10
					STA $7FE226
					
					LDA #$08  ;14
					STA $7FE11A
					STA $7FE227
					LDA #$00
					STA $7FE11B
					LDA #$02
					STA $7FE228
					LDA #$0C
					STA $7FE229
					
					LDA #$08 ;15
					STA $7FE11C
					STA $7FE22A
					LDA #$00
					STA $7FE11D
					LDA #$01
					STA $7FE22B
					LDA #$08
					STA $7FE22C
					
					LDA #$08  ;16
					STA $7FE11E
					STA $7FE22D
					LDA #$00
					STA $7FE11F
					LDA #$02
					STA $7FE22E
					LDA #$0C
					STA $7FE22F
					
					LDA #$08 ;17
					STA $7FE120
					STA $7FE230
					LDA #$00
					STA $7FE121
					LDA #$02
					STA $7FE231
					LDA #$10
					STA $7FE232
					
					LDA #$08  ;18
					STA $7FE122
					STA $7FE233
					LDA #$00
					STA $7FE123
					LDA #$03
					STA $7FE234
					LDA #$14
					STA $7FE235
					
					LDA #$08 ;19
					STA $7FE124
					STA $7FE236
					LDA #$00
					STA $7FE125
					LDA #$03
					STA $7FE237
					LDA #$18
					STA $7FE238
					
					LDA #$08  ;20
					STA $7FE126
					STA $7FE239
					LDA #$00
					STA $7FE127
					LDA #$04
					STA $7FE23A
					LDA #$1C
					STA $7FE23B
					
					LDA #$08 ;21
					STA $7FE128
					STA $7FE23C
					LDA #$00
					STA $7FE129
					LDA #$04
					STA $7FE23D
					LDA #$20
					STA $7FE23E
					
					LDA #$08  ;22
					STA $7FE12A
					STA $7FE23F
					LDA #$00
					STA $7FE12B
					LDA #$05
					STA $7FE240
					LDA #$24
					STA $7FE241
					
					LDA #$08 ;23
					STA $7FE12C
					STA $7FE242
					LDA #$00
					STA $7FE12D
					LDA #$05
					STA $7FE243
					LDA #$28
					STA $7FE244
					
					LDA #$08  ;24
					STA $7FE12E
					STA $7FE245
					LDA #$00
					STA $7FE12F
					LDA #$06
					STA $7FE246
					LDA #$2C
					STA $7FE247
					
					LDA #$08 ;25
					STA $7FE130
					STA $7FE248
					LDA #$00
					STA $7FE131
					LDA #$06
					STA $7FE249
					LDA #$30
					STA $7FE24A
					
					LDA #$08  ;26
					STA $7FE132
					STA $7FE24B
					LDA #$00
					STA $7FE133
					LDA #$07
					STA $7FE24C
					LDA #$34
					STA $7FE24D
					
					LDA #$08 ;27
					STA $7FE134
					STA $7FE24E
					LDA #$00
					STA $7FE135
					LDA #$07
					STA $7FE24F
					LDA #$38
					STA $7FE250
					
					LDA #$08  ;28
					STA $7FE136
					STA $7FE251
					LDA #$00
					STA $7FE137
					LDA #$08
					STA $7FE252
					LDA #$3C
					STA $7FE253
					
					LDA #$00
					STA $7FE138
					STA $7FE254
					RTS
