;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 7 heros
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
                    EXTRA_BITS = $7FAB10
					CIRCLE = $27EFD0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA $010B
					CMP #$FE
					BEQ PEACH_INIT
					LDA #$C0
					STA $94
					STZ $76
					LDA #$FF
					STA $15AC,x
					LDA #$02
					STA $00212E
					JSR HDMA_LAYER2
					JSR HDMA_LAYER1_VER
					STZ $40
					LDA #$14
					STA $212C
					LDA #$03
					STA $212D
					RTL
PEACH_INIT			LDA #$20
					STA $1504,x
					LDA #$FF
					STA $15AC,x
					LDA #$40
					STA $7FF570
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                    
START_HB_CODE       LDA $1504,x
					BNE MAIN0
					JSR MAIN
					RTS
MAIN0				CMP #$20
					BNE MAIN1
					JSR WENDY
					RTS
MAIN1				CMP #$20
					BCC MAIN2
					JSR KOPPA
					RTS
MAIN2				CMP #$01
					BNE MAIN3
					JSR METEO
					RTS
MAIN3				CMP #$02
					BNE MAIN4
					JSR MOON
					RTS
MAIN4				CMP #$03
					BNE MAIN5
					JSR FLOWER
					RTS
MAIN5				CMP #$04
					BNE MAIN6
					JSR BALL
					RTS
MAIN6				RTS

MAIN				LDA $9D
					BNE MAIN_R
					LDA #$08
					STA $0F31
					LDA $C2,x
					BNE MAIN_1
					JSR MODE0
MAIN_R				RTS
MAIN_1				CMP #$01
					BNE MAIN_2
					JSR MODE1
					RTS
MAIN_2				CMP #$02
					BNE MAIN_3
					JSR METEO_MODE
					RTS
MAIN_3				CMP #$03
					BNE MAIN_4
					JSR SETUGEKKA
					RTS
MAIN_4				CMP #$04
					BNE MAIN_5
					JSR BALL_MODE
					RTS
MAIN_5				RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MODE0				JSR MOVE
					STZ $13E0
					STZ $13DF
					LDA #$01
					STA $212E
					LDA #$20
					STA $18BD
					LDA $14
					AND #$1F
					BNE MODE0_1
					LDA #$1B
					STA $1DFC
MODE0_1				LDA $15AC,x
					CMP #$FE
					BEQ MODE0_WINDOW
					CMP #$01
					BEQ MODE0_E
					LDA #$15
					STA $212C
					LDA #$02
					STA $212D
					LDA $14
					AND #$03
					BNE MODE0_R
					JSR LAYER22
					LDA $7FDF03
					BNE MODE0_2
					LDA $15AC,x
					BNE MODE0_R
					LDA #$80
					STA $15AC,x
					LDA #$00
					STA $7FFB20
					STA $7FFB28
					STA $7FFB30
MODE0_R				RTS
MODE0_2				JSR WINDOW2
					RTS
MODE0_WINDOW		JSR HDMA_WINDOW
					LDA #$14
					STA $212C
					LDA #$03
					STA $212D
					STZ $15AC,x
					JSR LAYER3_DELETE
					RTS
MODE0_E				LDA #$00
					STA $7FE301
					STA $7FE303
					LDA #$01
					STA $C2,x
					LDA #$01
					STA $1DFC
					LDA #$00
					STA $7FCB00
					LDA #$FF
					STA $7FCB01
					LDA #$7F
					STA $7FCB02
					JSR HDMA_COLOR
					STZ $18BD
					LDA #$24
					STA $40
					LDA #$04
					STA $212C
					LDA #$13
					STA $212D
					RTS
					
MODE1				JSR MOVE
					JSR HDMA_COLOR
					LDA $7FCB01
					BEQ MODE1_1
					REP #$30
					LDA $7FCB01
					SEC
					SBC.W #$0421
					STA $7FCB01
					SEP #$30
					LDA #$00
					STA $7FFB18
					RTS
MODE1_1				LDA #$FF
					STA $15AC,x
					LDA #$03
					STA $C2,x
					RTS
					
BALL_MODE			JSR MOVE
					LDA $15AC,x
					CMP #$F0
					BEQ BALL_GEN
					CMP #$D0
					BEQ BALL_GEN
					CMP #$B0
					BEQ BALL_GEN
					CMP #$90
					BEQ BALL_GEN
					CMP #$70
					BEQ BALL_GEN
					RTS
BALL_GEN			JSR GEN_SPRITE
					LDA #$04
					STA $1504,y
					LDA #$18
					STA $00B6,y
					JSL $01ACF9
					AND #$03
					STA $1528,y
					LDA #$19
					STA $1686,y
					LDA #$02
					STA $167A,y
					LDA #$30
					STA $1656,y
					LDA #$80
					STA $1662,y
					RTS

METEO_MODE			JSR MOVE
					LDA $15AC,x
					CMP #$FE
					BEQ METEO_MODE_0
					CMP #$FD
					BEQ METEO_MODE_1
					CMP #$C1
					BCS METEO_MODE_2
					CMP #$C0
					BEQ METEO_MODE_G1
					CMP #$A8
					BEQ METEO_MODE_G2
					CMP #$90
					BEQ METEO_MODE_G3
					CMP #$78
					BEQ METEO_MODE_G4
					CMP #$50
					BNE METEO_MODE_R
					LDA #$00
					STA $7FDF01
					LDA #$FF
					STA $7FE101
					LDA #$00
					STA $7FDF02
					STA $7FE102
					JSR LAYER3_DELETE
METEO_MODE_R		RTS
METEO_MODE_0		JSR HDMA_CIRCLE
					JSR LAYER3_SCAL
					RTS
METEO_MODE_1		LDA #$30
					STA $7FDEFD;#SxW
					LDA #$70
					STA $7FDEFE;#SyW
					LDA #$04
					STA $7FDEFF;#~̔a
					JSR CIRCLE_GEN
					JSR SAGA3
					RTS
METEO_MODE_2		JSR CIRCLE_GEN
					LDA $7FDEFF
					CMP #$40
					BCS METEO_MODE_2_2
					INC A
					INC A
					STA $7FDEFF
METEO_MODE_2_2		LDA $15AC,x
					CMP #$E8
					BCS METEO_MODE_2_R
					LDA $7FDEFE
					CMP #$20
					BCC METEO_MODE_2_R
					DEC A
					DEC A
					STA $7FDEFE
METEO_MODE_2_R		RTS
METEO_MODE_G1		LDA #$48
					PHA
					BRA METEO_MODE_G
METEO_MODE_G2		LDA #$18
					PHA
					BRA METEO_MODE_G
METEO_MODE_G3		LDA #$38
					PHA
					BRA METEO_MODE_G
METEO_MODE_G4		LDA #$28
					PHA
METEO_MODE_G		JSR GEN_SPRITE
					LDA #$00
					STA $14E0,y
					STA $14D4,y
					LDA #$30
					STA $00E4,y
					LDA #$E0
					STA $00D8,y
					LDA #$01
					STA $1504,y
					PLA
					STA $00B6,y
					LDA #$19
					STA $1686,y
					LDA #$2B
					STA $1DFC
					RTS

SETUGEKKA			JSR MOVE
					LDA $15AC,x
					CMP #$FE
					BEQ SETUGEKKA_0
					CMP #$AE
					BCS SETUGEKKA_1
					CMP #$AD
					BEQ SETUGEKKA_2
					CMP #$AC
					BEQ SETUGEKKA_3
					CMP #$A8
					BEQ SETUGEKKA_4
					RTS
SETUGEKKA_0			JSR LAYER3_SCAL
					JSR SNOW
					JSR SNOW_HDMA
					RTS
SETUGEKKA_1			DEC $24
					LDA $7FD401
					DEC A
					STA $7FD401
					RTS
SETUGEKKA_2			JSR LAYER3_DELETE
					STZ $24
					LDA #$00
					STA $7FD401
					LDA #$25
					STA $7FD100
					LDA #$01
					STA $7FD103
					LDA #$00
					STA $7FD101
					STA $7FD104
					STA $7FD106
					RTS
SETUGEKKA_3			LDA #$00
					STA	$7FFB20
					STA	$7FFB28
					RTS
SETUGEKKA_4			JSR GEN_SPRITE
					LDA #$02
					STA $1504,y
					LDA #$40
					STA $15AC,y
					LDA $96
					CLC
					ADC #$10
					STA $00D8,y
					LDA $97
					ADC #$00
					STA $14D4,y
					LDA $94
					STA $00E4,y
					LDA $95
					STA $14E0,y
					RTS


SUB_TIME			LDA $15AC,x ;#NCbN^C
					BEQ TIME_3
					CMP #$01
					BNE TIME_R
					JSR QUICKTIME
TIME_R				RTS
TIME_3				JSR LAYER3_WAVE
					RTS


SUB_MEAL			LDA $15AC,x ;#CVg[
					BEQ SUB_MEAL_3
					CMP #$20
					BEQ SUB_MEAL_2
					CMP #$01
					BNE SUB_MEAL_R
					JSR MAELSTROM
SUB_MEAL_R			RTS
SUB_MEAL_2			REP #$20
					LDA.W #$2800
					STA $7FD201
					SEP #$20
					RTS
SUB_MEAL_3				REP #$20
					LDA $7FD101
					SEC
					SBC.W #$0006
					STA $7FD101
					LDA $22
					SEC
					SBC.W #$0006
					STA $22
					SEP #$20
					RTS
					
METEO				JSR SUB_GFX_M
					LDA $9D
					BNE METEO_R
					LDA $1540,x
					BNE METEO_2
					LDA #$30
					STA $AA,x
					JSL $01802A
					LDA $1588,x
					AND #$04
					BNE METEO_1
					JSR DAMAGE_RT
METEO_R				RTS
METEO_1				LDA #$10
					STA $1DFC
					LDA #$18
					STA $1540,x
					RTS
METEO_2				CMP #$01
					BNE METEO_DELETE_N
					STZ $14C8,x
					RTS
METEO_DELETE_N		JSR DAMAGE_4
					RTS

MOON				LDA $15AC,x
					CMP #$14
					BCC MOON_0
					JSR SUB_GFX_MN
					RTS
MOON_0				JSR SUB_GFX_MN2
					LDA $9D
					BNE MOON_R
					LDA $15AC,x
					CMP #$02
					BEQ MOON_2
					CMP #$13
					BEQ MOON_1
					LDA $7FCB01
					BEQ MOON_R
					REP #$30
					LDA $7FCB01
					SEC
					SBC.W #$0421
					STA $7FCB01
					SEP #$30
					JSR HDMA_COLOR
					RTS
MOON_2				STZ $14C8,x
					JSR DAMAGE_4
					JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					LDA #$01
					STA $1602,y
					JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					LDA #$02
					STA $1602,y
					JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					STA $1602,y
MOON_R				RTS
MOON_1				LDA #$30
					STA $1DFC
					LDA #$CE
					STA $7FCB01
					LDA #$39
					STA $7FCB02
					JSR HDMA_COLOR
					RTS

BALL_TABLE			dcb $D8,$A8,$B0,$C0
BALL				JSR GET_DRAW_INFO
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA #$0A
					STA $0302,y
					LDA #$0B
					ORA $64
					STA $0303,y
					LDY #$02            
                    LDA #$00
                    JSL $01B7B3
					LDA $14C8,x
					CMP #$08
					BNE BALL_R2
					LDA $9D
					BNE BALL_R
					LDA $14E0,x
					BNE BALL_DEL
					JSL $01802A
					JSL $01A7DC
					LDA $1588,x
					AND #$04
					BEQ BALL_R
					LDA $1528,x
					TAY
					LDA BALL_TABLE,y
					STA $AA,x
BALL_R				RTS
BALL_R2				LDA #$99
					STA $1686,x
					RTS
BALL_DEL			STZ $14C8,x
					RTS

FLOWER				LDA $1602,x
					CMP #$01
					BEQ FLOWER_1
					CMP #$02
					BEQ FLOWER_2
					CMP #$03
					BEQ FLOWER_3
					LDA #$85
					STA $1528,x
					JSR SUB_GFX_FL1
					LDA $9D
					BNE FLOWER_R
					LDA #$F8
					STA $AA,x
					LDA #$FD
					STA $B6,x
					LDA $1570,x
					LSR A
					LSR A
					STA $151C,x
					JSL $01802A
					BRA FLOWER_DEL
FLOWER_1			LDA #$05
					STA $1528,x
					JSR SUB_GFX_FL1
					LDA $9D
					BNE FLOWER_R
					LDA #$10
					STA $AA,x
					LDA #$FC
					STA $B6,x
					LDA $1570,x
					LSR A
					STA $151C,x
					JSL $01802A
FLOWER_DEL			INC $1570,x
					LDA $1570,x
					CMP #$40
					BCC FLOWER_R
					STZ $14C8,x
FLOWER_R			RTS
FLOWER_2			LDA #$05
					STA $1528,x
					JSR SUB_GFX_FL2
					LDA $9D
					BNE FLOWER_R
					LDA #$FD
					STA $AA,x
					LDA #$0A
					STA $B6,x
					LDA $1570,x
					LSR A
					STA $151C,x
					JSL $01802A
					BRA FLOWER_DEL
FLOWER_3			LDA #$45
					STA $1528,x
					JSR SUB_GFX_FL2
					LDA $9D
					BNE FLOWER_R
					LDA #$F8
					STA $AA,x
					LDA #$F6
					STA $B6,x
					LDA $1570,x
					LSR A
					STA $03
					LSR A
					CLC
					ADC $03
					STA $151C,x
					JSL $01802A
					BRA FLOWER_DEL



DAMAGE_RT			LDA $1497
					BNE DAMAGE_R
					JSL $01A7DC
					BCC DAMAGE_R
					JSL $00F5B7
DAMAGE_R			RTS

DAMAGE_4			LDA $E4,x
					PHA
					SEC
					SBC #$08
					STA $E4,x
					LDA $14E0,x
					PHA
					SBC #$00
					STA $14E0,x
					LDA $D8,x
					PHA
					SEC
					SBC #$08
					STA $D8,x
					LDA $14D4,x
					PHA
					SBC #$00
					STA $14D4,x
					JSR DAMAGE_RT
					LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					JSR DAMAGE_RT
					LDA $D8,x
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					JSR DAMAGE_RT
					LDA $E4,x
					SEC
					SBC #$10
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
					JSR DAMAGE_RT
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HDMA_LAYER1_VER		LDA #$40
					STA $7FFB30
					LDA #$02
					STA $7FFB31
					LDA #$0E
					STA $7FFB32
					LDA #$00
					STA $7FFB33
					LDA #$CA
					STA $7FFB34
					LDA #$7F
					STA $7FFB35
					LDA #$01
					STA $7FCA00
					LDA #$C0
					STA $7FCA01
					LDA #$00
					STA $7FCA02
					STA $7FCA03
					RTS

MOVE				LDA $14
					AND #$07
					BNE MOVE_R
					INC $1570,x
					LDA $1570,x
					AND #$10
					BNE MOVE_2
					LDA $7FCA01
					DEC A
					STA $7FCA01
MOVE_R				RTS
MOVE_2				LDA $7FCA01
					INC A
					STA $7FCA01
					RTS

MUSIC_RESET			LDA #$1E
					STA $1DFB
					RTS
WENDY				JSR SUB_GFX_WE
					LDA $9D
					BNE RETURN_W
					LDA $15AC,x
					CMP #$FE
					BEQ MUSIC_RESET
					CMP #$C0
					BCS WENDY2
					CMP #$75
					BCS WENDY3
					CMP #$74
					BEQ WENDY3_2
					CMP #$73
					BEQ WENDY4
					BRA WENDY1
RETURN_W			RTS
WENDY2				LDA #$FF
					STA $18BD
					LDA #$01
					STA $76
					STZ $13E0
					STZ $13DF
					RTS
WENDY3				LDA #$80
					STA $14AD
					LDA #$01
					STA $76
					STZ $13DF
					DEC $E4,x
					INC $94
					LDA #$01
					STA $1602,x
					STZ $13E0
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					BEQ RETURN_W
					LDA #$02
					STA $1602,x
					LDA #$01
					STA $13E0
					LDA #$07
					STA $13BF
					RTS
WENDY3_2			STZ $13E0
					STZ $13DF
					LDA #$01
					STA $1602,x
					RTS
WENDY4				STZ $13E0
					STZ $13DF
					LDA #$01
					STA $1602,x
					LDA #$01
					STA $1426
					RTS
WENDY1				LDA $15AC,x
					CMP #$72
					BEQ WENDY5
					CMP #$71
					BEQ WENDY6
					CMP #$70
					BEQ WENDY7
					RTS
WENDY5				STZ $13E0
					STZ $13DF
					LDA #$02
					STA $1426
					RTS
WENDY6				LDA #$06
					STA $13BF
					STZ $13E0
					STZ $13DF
					LDA #$01
					STA $1426
					LDA #$23
					STA $1DFB
					RTS
WENDY7				LDA #$12
					STA $00212C
					LDA #$05
					STA $00212D
					LDA #$2C
					STA $13BF
					STZ $14AD
					LDA #$16
					STA $13E0
					LDA #$78
					STA $E4,x
					LDA #$78
					STA $94
					LDA #$01
					STA $14D4,x
					LDA #$30
					STA $D8,x
					JSR GEN_SPRITE
					LDA #$21
					STA $1504,y
					JSR GEN_SPRITE
					LDA #$22
					STA $1504,y
					LDA #$49
					STA $1602,y
					JSR GEN_SPRITE
					LDA #$23
					STA $1504,y
					LDA #$92
					STA $1602,y
					JSR GEN_SPRITE
					LDA #$24
					STA $1504,y
					LDA #$DB
					STA $1602,y
					JSR GEN_SPRITE
					LDA #$25
					STA $1504,y
					LDA #$24
					STA $1602,y
					LDA #$01
					STA $151C,y
					JSR GEN_SPRITE
					LDA #$26
					STA $1504,y
					LDA #$6D
					STA $1602,y
					LDA #$01
					STA $151C,y
					JSR GEN_SPRITE
					LDA #$27
					STA $1504,y
					LDA #$B6
					STA $1602,y
					LDA #$01
					STA $151C,y
					STZ $14C8,x
					RTS
					
KOPPA				LDA #$25
					STA $13E0
					LDA #$FF
					STA $18BD
					LDA $9D
                    ;BNE LABEL92
					LDA $7FF570
					CMP #$10
					BCS KOPPA2
					JSR HDMA_DARK
					LDA #$06
					STA $71
					STZ $89
					STZ $88
					STZ $14C8,x
					RTS
KOPPA2              LDA $14
					AND #$3F
					BNE KOPPA0
					LDA $7FF570
					DEC A
					STA $7FF570
					LDA #$80
					STA $14AD
					LDA #$18
					STA $1DFC
KOPPA0				CMP #$02
					BNE KOPPA0_22
					STZ $14AD
KOPPA0_22			LDA $7FF570
					CMP #$30
					BCS KOPPA0_1
					LDA $14
					AND #$1F
					BNE KOPPA0_2
					LDA $1602,x
					CLC
					ADC #$08
                    STA $1602,x
					LDA $151C,x
					ADC #$00
                    AND #$01
                    STA $151C,x
KOPPA0_2			LDA $7FF570
					CMP #$20
					BCS KOPPA0_1
					LDA $14
					AND #$1F
					CMP #$0F
					BNE KOPPA0_1
					LDA $1602,x
					CLC
					ADC #$08
                    STA $1602,x
					LDA $151C,x
					ADC #$00
                    AND #$01
                    STA $151C,x
					LDA $7FF570
KOPPA0_1			LDA $1602,x
					CLC
					ADC #$04
                    STA $1602,x
                    LDA $151C,x ;#݂̉]l Highbyte AND #$01 $01
					ADC #$00
                    AND #$01
                    STA $151C,x
LABEL92             LDA $151C,x
                    STA $01
                    LDA $1602,x
                    STA $00
                    REP #$30 ;#16bit[h
                    LDA $00
                    CLC
                    ADC.W #$0080 ;#]l80𑫂$02-$03
                    AND.W #$01FF
                    STA $02
                    LDA $00
                    AND.W #$00FF
                    ASL A
                    TAX
                    LDA $07F7DB,x ;#]pɑ΂W̊i[lH
                    STA $04
                    LDA $02
                    AND.W #$00FF
                    ASL A
                    TAX
                    LDA $07F7DB,x
                    STA $06       ;#90xY̍WH
                    SEP #$30
                    LDX $15E9
					
								;#8bitx8bit
					            ;#$4202ɔ搔Zbg
								;#$4203ɏ搔Zbg
								;#8TCNA$4216-$4217ɏZ(16bit)܂B
								
                    LDA $04
                    STA $4202   ;#]pɑ΂WW
                    LDA $7FF570
                    LDY $05    ;#ΑȂ
                    BNE LABEL93
                    STA $4203   ;#a
                    ASL $4216   ;#ɔ{ɂH
                    LDA $4217
                    ADC #$00
LABEL93             LSR $01
                    BCC LABEL94
                    EOR #$FF                ; \ reverse direction of rotation
                    INC A                   ; /#180xȏȂl𔽓]
LABEL94             STA $04
                    LDA $06
                    STA $4202
                    LDA $7FF570
                    LDY $07
                    BNE LABEL95
                    STA $4203
                    ASL $4216
                    LDA $4217
                    ADC #$00
LABEL95             LSR $03
                    BCC LABEL96
                    EOR #$FF
                    INC A
LABEL96             STA $06
                    LDA $E4,x ;#W
                    PHA
                    LDA $14E0,x
                    PHA
                    LDA $D8,x
                    PHA
                    LDA $14D4,x
                    PHA
                    LDY $0F86,x
                    STZ $00
                    LDA $04
                    BPL LABEL97
                    DEC $00
LABEL97             ASL A
					CLC
                    ADC $E4,x
                    STA $E4,x
                    PHP
                    PHA
                    SEC
                    SBC $1534,x
                    STA $1528,x
                    PLA
                    STA $1534,x
                    PLP
                    LDA $14E0,x
                    ADC $00
                    STA $14E0,x
                    STZ $01
                    LDA $06
                    BPL LABEL98
                    DEC $01
LABEL98             CLC
                    ADC $D8,x
                    STA $D8,x
                    LDA $14D4,x
                    ADC $01
                    STA $14D4,x
            
                    JSR SUB_GFX_K
                    
                    PLA     
                    STA $14D4,x
                    PLA        
                    STA $D8,x  
                    PLA        
                    STA $14E0,x
                    PLA        
                    STA $E4,x                   
                    RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GEN_OFFSET			dcb $E0,$20
GEN_OFFSET2			dcb $FF,$00

RETURN67            RTS
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
					LDA $E4,x
                    STA $00E4,y
                    LDA $14E0,x
                    STA $14E0,y             ; /

					LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  
TILEMAP_FL1			dcb $60,$62,$64,$62
SUB_GFX_FL1			JSR GET_DRAW_INFO
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					STA $03
					LDA $14
					CLC
					ADC $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					STA $04
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					PHX
					LDX $03
					LDA TILEMAP_FL1,x
					PLX
					STA $0302,y
					LDA $1528,x
					ORA #$40
					ORA $64
					STA $0303,y
					INY
					INY
					INY
					INY
					LDA $00
					CLC
					ADC $151C,x
					STA $0300,y
					LDA $01
					STA $0301,y
					PHX
					LDX $04
					LDA TILEMAP_FL1,x
					PLX
					STA $0302,y
					LDA $1528,x
					ORA $64
					STA $0303,y
					LDY #$02            
                    LDA #$01
                    JSL $01B7B3    
                    RTS

TILEMAP_FL2			dcb $04,$60,$04,$62
SUB_GFX_FL2			JSR GET_DRAW_INFO
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					STA $03
					LDA $14
					CLC
					ADC $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					STA $04
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					PHX
					LDX $03
					LDA TILEMAP_FL2,x
					PLX
					STA $0302,y
					LDA $1528,x
					ORA $64
					STA $0303,y
					INY
					INY
					INY
					INY
					LDA $00
					STA $0300,y
					LDA $01
					CLC
					ADC $151C,x
					STA $0301,y
					PHX
					LDX $04
					LDA TILEMAP_FL1,x
					PLX
					STA $0302,y
					LDA $1528,x
					ORA $64
					STA $0303,y
					LDY #$02            
                    LDA #$01
                    JSL $01B7B3    
                    RTS


TILEMAP_MN			dcb $00,$02,$20,$22,$24,$40,$42,$44
HORIZ_DISP_MN       dcb $F0,$00,$F0,$00,$10,$F0,$00,$10
VERT_DISP_MN        dcb $E0,$E0,$F0,$F0,$F0,$00,$00,$00

SUB_GFX_MN			JSR GET_DRAW_INFO
					PHX
					LDX #$07
LOOP_START_MN		LDA $00
					CLC
					ADC HORIZ_DISP_MN,x
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_DISP_MN,x
					STA $0301,y
					LDA TILEMAP_MN,x
					STA $0302,y
					LDA #$0B
					ORA $64
					STA $0303,y
					INY                 
                    INY                    
                    INY              
                    INY                 
                    DEX                   
                    BPL LOOP_START_MN
                    PLX
                    LDY #$02            
                    LDA #$07
                    JSL $01B7B3    
                    RTS

TILEMAP_MN2			 dcb $6E,$6E,$48,$66
					 dcb $6E,$6E,$68,$66
					 dcb $26,$28,$46,$66
					 dcb $26,$28,$08,$6E
					 dcb $06,$28,$6E,$6E
					 
HORIZ_DISP_MN2       dcb $00,$10,$00,$00
VERT_DISP_MN2        dcb $E8,$E8,$F8,$08

SUB_GFX_MN2			JSR GET_DRAW_INFO
					LDA $15AC,x
					LSR A
					LSR A
					ASL A
					ASL A
					STA $02
					PHX
					LDX #$03
LOOP_START_MN2		LDA $00
					CLC
					ADC HORIZ_DISP_MN2,x
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_DISP_MN2,x
					STA $0301,y
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA TILEMAP_MN2,x
					STA $0302,y
					PLX
					LDA #$0D
					ORA $64
					STA $0303,y
					INY                 
                    INY                    
                    INY              
                    INY                 
                    DEX                   
                    BPL LOOP_START_MN2
                    PLX
                    LDY #$02            
                    LDA #$03
                    JSL $01B7B3    
                    RTS



TILEMAP_M             dcb $E0,$E2,$E2,$E0
					  dcb $A0,$A2,$A2,$A0
					  dcb $C0,$C2,$C2,$C0
HORIZ_DISP_M          dcb $F8,$08,$F8,$08
VERT_DISP_M           dcb $F8,$F8,$08,$08
PROPERTIES_M          dcb $0A,$0A,$CA,$CA

SUB_GFX_M			JSR GET_DRAW_INFO
					LDA $1540,x
					BNE SUB_GFX_M2
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					TXA
					ASL A
					ASL A
					CLC
					ADC $14
					LSR A
					LSR A
					AND #$01
					BNE SUB_GFX_M_0
					LDA #$80
					BRA SUB_GFX_M_1
SUB_GFX_M_0			LDA #$82
SUB_GFX_M_1			STA $0302,y
					LDA #$4A
					ORA $64
					STA $0303,y
					LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$00
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
SUB_GFX_M2			STZ $03
					LDA $1540,x
					CMP #$10
					BCS SUB_GFX_M3
					LDA #$04
					STA $03
					CMP #$08
					BCS SUB_GFX_M3
					LDA #$08
					STA $03
SUB_GFX_M3			PHX
                    LDX #$03
LOOP_START_M        PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILEMAP_M,x           ; \ store tile
                    STA $0302,y             ; /
					PLX

					LDA $01
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP_M,x         ; |
                    STA $0301,y             ; /
					
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP_M,x        ; |
                    STA $0300,y             ; /

                    LDA PROPERTIES_M,x
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties

                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START_M
                    PLX
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS


TILEMAP             dcb $C4,$C6,$E4,$E6,$CE,$EE
					dcb $80,$82,$A0,$A2,$E8,$E8
					dcb $E2,$E0,$C0,$E8,$E8,$E8
					dcb $AC,$8C,$8E,$E8,$E8,$E8
					dcb $84,$86,$A4,$A6,$E8,$E8
					dcb $E2,$EC,$CC,$E8,$E8,$E8
					dcb $C2,$82,$A0,$A2,$E8,$E8
HORIZ_DISP          dcb $F8,$08,$F8,$08,$00,$00
					dcb $F8,$08,$F8,$08,$00,$00
					dcb $00,$06,$06,$00,$00,$00
					dcb $00,$F8,$F8,$00,$00,$00
					dcb $F8,$08,$F8,$08,$00,$00
					dcb $00,$06,$06,$00,$00,$00
					dcb $08,$F8,$08,$F8,$00,$00
VERT_DISP           dcb $F0,$F0,$00,$00,$E0,$F0
					dcb $F0,$F0,$00,$00,$E0,$F0
					dcb $00,$F6,$E6,$00,$00,$00
					dcb $00,$F4,$E4,$00,$00,$00
					dcb $F0,$F0,$00,$00,$E0,$F0
					dcb $00,$F6,$E6,$00,$00,$00
					dcb $F0,$F0,$00,$00,$E0,$F0
PROPERTIES          dcb $09,$09,$09,$09,$09,$09
					dcb $09,$09,$09,$09,$09,$09
					dcb $4B,$4B,$4B,$4B,$4B,$4B
					dcb $0F,$0F,$0F,$0F,$0F,$0F
					dcb $0B,$0B,$0B,$0B,$0B,$0B
					dcb $47,$07,$07,$09,$09,$09
					dcb $4D,$4D,$4D,$4D,$4D,$4D

RETURN32			RTS
SUB_GFX_K           JSR GET_DRAW_INFO
					LDA $1504,x
					DEC A
					AND #$0F
					STA $02
					ASL A
					ASL A
					CLC
					ADC $02
					ADC $02
					STA $02
					BNE GFX_K_1
					PHX
                    LDX #$05
					BRA LOOP_START
GFX_K_1				PHX
					LDX #$03
LOOP_START          PHX
					TXA
					CLC
					ADC $02
					TAX

					LDA $01
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP,x         ; |
                    STA $0301,y             ; /
					
					LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /

                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP,x        ; |
                    STA $0300,y             ; /

                    LDA PROPERTIES,x
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties

					PLX
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START
                    PLX                     ; pull, X = sprite index
					LDA $02
					BEQ GFX_K_2
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
GFX_K_2				LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$05
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS

					
TILEMAP2             dcb $8A,$A8,$88
					 dcb $8A,$A8,$88
					 dcb $8A,$E2,$88
HORIZ_DISP2          dcb $F8,$00,$08
					 dcb $08,$00,$F8
					 dcb $08,$00,$F8
VERT_DISP2           dcb $F5,$00,$F5
					 dcb $F5,$00,$F5
					 dcb $F5,$00,$F5
PROPERTIES2          dcb $49,$49,$49
					 dcb $09,$09,$09
					 dcb $09,$09,$09

RETURN33			RTS
SUB_GFX_WE          JSR GET_DRAW_INFO
					LDA $1602,x
					ASL A
					CLC
					ADC $1602,x
					STA $02
					PHX
                    LDX #$02
LOOP_START2         PHX
					TXA
					CLC
					ADC $02
					TAX

					LDA $01
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP2,x         ; |
                    STA $0301,y             ; /
					
					LDA TILEMAP2,x           ; \ store tile
                    STA $0302,y             ; /

                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP2,x        ; |
                    STA $0300,y             ; /

                    LDA PROPERTIES2,x
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties

					PLX
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START2

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$02
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    HDMA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HDMA_LAYER2			LDA #$08
					STA $7FFB18
					LDA #$02
					STA $7FFB19
					LDA #$0D
					STA $7FFB1A
					LDA #$00
					STA $7FFB1B
					LDA #$E3
					STA $7FFB1C
					LDA #$7F
					STA $7FFB1D
LAYER22_R			RTS
					
LAYER22				LDA $7FE601
					INC A
					INC A
					INC A
					INC A
					AND #$7F
					STA $7FE601
					LDA $15AC,x
					STA $02
					PHX
					PHY
					LDX #$00
					LDY #$00
LAYER2_LOOP			LDA #$01
					STA $7FE300,x
					STA $7FE3A8,x
					STA $7FE450,x
					STA $7FE4F8,x
					LDA #$00
					STA $7FE302,x
					STA $7FE3AA,x
					STA $7FE452,x
					STA $7FE4FA,x
					JSR LAYER2_SUB
					INX
					INX
					INX
					INY
					CPX #$A8
					BCC LAYER2_LOOP
					LDA #$00
					STA $7FE4F8,x
					PLY
					PLX
					RTS
					
LAYER2_SUB			TXA
					ASL A
					ASL A
					CLC
					ADC $7FE601
					AND #$7F
					STA $0F
					LDA $0F
					CMP #$40
					BCC LAYER2_SUB_2
					LDA #$80
					SEC
					SBC $0F
LAYER2_SUB_2		STA $7FE301,x
					LDA $02
					BEQ LAYER2_SUB_3
					JSR LAYER2_SUB2
LAYER2_SUB_3		LDA $7FE301,x
					STA $7FE3A9,x
					STA $7FE451,x
					STA $7FE4F9,x
					RTS
					
LAYER2_SUB2			LDA $7FE301,x
					STA $004202
					LDA $02
					STA $004203
					REP #$30
					LDA.W $004216
					STA.W $004204
					SEP #$30
					LDA #$80
					STA $004206
					LDA $4214
					STA $7FE301,x
					RTS


HDMA_WINDOW			LDA #$03
					STA $41
					LDA #$10
					STA $7FFB20
					LDA #$20
					STA $7FFB28
					LDA #$00
					STA $7FFB21
					STA $7FFB29
					LDA #$26
					STA $7FFB22
					LDA #$27
					STA $7FFB2A
					LDA #$00
					STA $7FFB23
					STA $7FFB2B
					LDA #$DF
					STA $7FFB24
					LDA #$E1
					STA $7FFB2C
					LDA #$7F
					STA $7FFB25
					STA $7FFB2D
					
					LDA #$10
					STA $7FDF00
					STA $7FE100
					LDA #$00
					STA $7FDF01
					LDA #$A0
					STA $7FE101
					
					PHY
					PHX
					LDY #$00
					LDX #$00
WINDOW_LOOP			LDA #$02
					STA $7FDF02,x
					STA $7FE102,x
					LDA WINDOW_TABLE2,y ;#CjV[`ł͎gȂ
					STA $0F
					STA $7FE103,x
					LDA #$98
					SEC
					SBC $0F
					STA $7FDF03,x
					INY
					INX
					INX
					CPY #$5C
					BCC WINDOW_LOOP
					LDA #$00
					STA $7FDF02,x
					STA $7FE102,x
					PLX
					PLY
					RTS
					
WINDOW_TABLE2		dcb $00,$04,$08,$0C,$10,$14,$18,$1C,$20,$22,$24,$26,$28,$2A,$2C,$2E
					dcb $30,$32,$34,$36,$38,$3A,$3C,$3D,$3E,$3F,$40,$41,$42,$43,$44,$44
					dcb $44,$45,$46,$46,$46,$47,$48,$48,$48,$49,$4A,$4A,$4A,$4A,$4A,$4A
					dcb $4A,$49,$48,$48,$48,$47,$46,$46,$46,$45,$44,$44
					dcb $44,$43,$42,$41,$40,$3F,$3E,$3D,$3C,$3A,$38,$36,$34,$32,$30,$2E
					dcb $2C,$2A,$28,$26,$24,$22,$20,$1C,$18,$14,$10,$0C,$08,$04,$00,$00

TABLE1				dcb $00,$00,$00,$00,$00,$00


WINDOW2				PHX
					LDX #$00
WINDOW2_LOOP		LDA $7FE103,x
					CMP #$C0
					BCS WINDOW2_2
					INC A
					STA $7FE103,x
WINDOW2_2			LDA $7FDF03,x
					BEQ WINDOW2_3
					DEC A
					STA $7FDF03,x
WINDOW2_3			INX
					INX
					CPX #$B8
					BCC WINDOW2_LOOP
					PLX
					RTS
					
HDMA_COLOR			LDA $7FCB00
					STA $2121
					LDA $7FCB01
					STA $2122
					LDA $7FCB02
					STA $2122
					RTS
					
LAYER3_SCL			LDA #$10
					STA $7FFB20
					LDA #$00
					STA $7FFB28
					LDA #$02
					STA $7FFB21
					LDA #$11
					STA $7FFB22
					LDA #$00
					STA $7FFB23
					LDA #$D1
					STA $7FFB24
					LDA #$7F
					STA $7FFB25
					
					LDA #$25
					STA $7FD100
					LDA #$00
					STA $7FD101
					STA $7FD102
					STA $7FD103
					RTS
					
LAYER3_WAVE_R		RTS
LAYER3_WAVE			LDA $14
					AND #$01
					BNE LAYER3_WAVE_R
					PHX
					LDX #$00
LAYER3_WAVE_0		LDA $7FFFC0,x
					INC A
					STA $7FFFC0,x
					AND #$0F
					STA $02
					CMP #$09
					BCC LAYER3_WAVE_1
					LDA #$10
					SEC
					SBC $02
LAYER3_WAVE_1		STA $7FFFB0,x
					INX
					CPX #$10
					BCC LAYER3_WAVE_0
					
					LDX #$00
LAYER3_WAVE_20		LDA $7FFFB0,x
					STA $03
					PHX
					TXA
					STA $02
					ASL A
					CLC
					ADC $02
					TAX
					LDA #$01
					STA $7FD100,x
					STA $7FD130,x
					STA $7FD160,x
					STA $7FD190,x
					STA $7FD1C0,x
					STA $7FD1F0,x
					STA $7FD220,x
					STA $7FD250,x
					STA $7FD280,x
					STA $7FD2B0,x
					STA $7FD2E0,x
					STA $7FD310,x
					STA $7FD340,x
					STA $7FD370,x

					BRA LAYER3_WAVE_4
LAYER3_WAVE_21		BRA LAYER3_WAVE_20
LAYER3_WAVE_4		LDA #$00
					STA $7FD102,x
					STA $7FD132,x
					STA $7FD162,x
					STA $7FD192,x
					STA $7FD1C2,x
					STA $7FD1F2,x
					STA $7FD222,x
					STA $7FD252,x
					STA $7FD282,x
					STA $7FD2B2,x
					STA $7FD2E2,x
					STA $7FD312,x
					STA $7FD342,x
					STA $7FD372,x

					BRA LAYER3_WAVE_3
LAYER3_WAVE_2		BRA LAYER3_WAVE_21
LAYER3_WAVE_3		LDA $03
					STA $7FD101,x
					STA $7FD131,x
					STA $7FD161,x
					STA $7FD191,x
					STA $7FD1C1,x
					STA $7FD1F1,x
					STA $7FD221,x
					STA $7FD251,x
					STA $7FD281,x
					STA $7FD2B1,x
					STA $7FD2E1,x
					STA $7FD311,x
					STA $7FD341,x
					STA $7FD371,x
					PLX
					INX
					CPX #$10
					BCC LAYER3_WAVE_2
					PLX
					LDA #$00
					STA $7FD3A0
					RTS


HDMA_DARK			LDA #$08
					STA $7FFB18
					LDA #$00
					STA $7FFB19
					LDA #$00
					STA $7FFB1A
					LDA #$00
					STA $7FFB1B
					LDA #$E0
					STA $7FFB1C
					LDA #$7F
					STA $7FFB1D
					LDA #$01
					STA $7FE000
					LDA #$00
					STA $7FE001
					STA $7FE002
					RTS
					
LAYER3_DELETE		LDA #$80
					STA $2115
					REP #$20
					LDA.W #$5000
					STA $03
LAYER3_D_LOOP		LDA $03
					STA $2116
					LDA.W #$2CFC
					STA $2118
					LDA $03
					INC A
					STA $03
					CMP.W #$6000
					BCC LAYER3_D_LOOP
					SEP #$20
					PHX
					LDX #$00
LAYER3_D_LOOP2		LDA #$FC
					STA $7FFFD0,x
					INX
					CPX #$20
					BCC LAYER3_D_LOOP2
					PLX
					STZ $22
					STZ $23
					STZ $24
					STZ $25
					RTS
					
					
MAELSTROM			JSR LAYER3_SCL
					LDA #$80
					STA $2115
					PHX
					LDX #$00
					LDY #$00
					REP #$20
					LDA.W #$2CFC
					STA $7FFFA0
					STA $7FFFA2
					LDA.W #$2DE1
					STA $7FFFA4
					LDA.W #$2DE2
					STA $7FFFA6
					LDA.W #$2DE3
					STA $7FFFA8
					LDA.W #$2DE4
					STA $7FFFAA
					LDA.W #$2DE5
					STA $7FFFAC
					LDA.W #$2DE6
					STA $7FFFAE
					LDA.W #$2CFC
					STA $7FFFB0
					STA $7FFFB2
					LDA.W #$2DF1
					STA $7FFFB4
					LDA.W #$2DF2
					STA $7FFFB6
					LDA.W #$2DF3
					STA $7FFFB8
					LDA.W #$2DF4
					STA $7FFFBA
					LDA.W #$2DF5
					STA $7FFFBC
					LDA.W #$2DF6
					STA $7FFFBE
					
					LDA.W #$5000
					STA $03
					
					SEP #$20
					
					
MAELSTROM_LOOP		LDA $03
					AND #$20
					BNE MAELSTROM_2ND
					TXA
					AND #$0F
					TAX
					REP #$20
					LDA $03
					STA $2116
					LDA $7FFFA0,x
					STA $2118
					LDA $03
					CLC
					ADC.W #$0400
					STA $2116
					LDA $7FFFA0,x
					STA $2118
					INC $03
					SEP #$20
					LDA $03
					AND #$1F
					BEQ MAELSTROM_LOOP
					INX
					INX
					BRA MAELSTROM_LOOP
					
MAELSTROM_2ND		TYA
					AND #$0F
					TAY
					REP #$20
					LDA $03
					STA $2116
					PHX
					TYX
					LDA $7FFFB0,x
					STA $2118
					LDA $03
					CLC
					ADC.W #$0400
					STA $2116
					LDA $7FFFB0,x
					STA $2118
					PLX
					LDA $03
					CMP.W #$537F
					BEQ MAELSTROM_3
					INC $03
					SEP #$20
					LDA $03
					AND #$1F
					BEQ MAELSTROM_LOOP
					INY
					INY
					BRA MAELSTROM_LOOP
					
MAELSTROM_3			SEP #$20
					LDX #$0E
					LDY #$00
MAELSTROM_LOOP2		TXA
					AND #$0F
					TAX
					LDA $7FFFA0,x
					PHX
					TYX
					STA $7FFFD0,x
					PLX
					INX
					INX
					INY
					CPY #$20
					BCC MAELSTROM_LOOP2
					PLX
					RTS
					

SNOW_HDMA			LDA #$10
					STA $7FFB20
					LDA #$20
					STA $7FFB28
					LDA #$02
					STA $7FFB21
					LDA #$02
					STA $7FFB29
					LDA #$11
					STA $7FFB22
					LDA #$12
					STA $7FFB2A
					LDA #$00
					STA $7FFB23
					STA $7FFB2B
					LDA #$D1
					STA $7FFB24
					LDA #$D4
					STA $7FFB2C
					LDA #$7F
					STA $7FFB25
					STA $7FFB2D
					
					LDA #$25
					STA $7FD400
					LDA #$00
					STA $7FD401
					STA $7FD402
					STA $7FD403
					
					PHX
					LDX #$00
					LDY #$00
SNOW_HDMA_1			LDA #$01
					STA $7FD100,x
					STA $7FD1A8,x
					STA $7FD250,x
					STA $7FD2F8,x
					TYA
					LSR A
					LSR A
					AND #$0F
					CMP #$08
					BCC SNOW_HDMA_2
					AND #$07
					EOR #$07
SNOW_HDMA_2			STA $7FD101,x
					STA $7FD1A9,x
					STA $7FD251,x
					STA $7FD2F9,x
					LDA #$00
					STA $7FD102,x
					STA $7FD1AA,x
					STA $7FD252,x
					STA $7FD2FA,x
					INX
					INX
					INX
					INY
					CPY #$38
					BNE SNOW_HDMA_1
					LDA #$00
					STA $7FD2F8,x
					PLX
					RTS



SNOW_TABLE1			dcb $FF,$FF,$FF,$CA,$FF,$FF,$FF,$CA
					dcb $FF,$C9,$FF,$FF,$FF,$FF,$C9,$CB
					dcb $FF,$FF,$FF,$FF,$FF,$FF,$CA,$FF
					dcb $FF,$FF,$FF,$C9,$C9,$CB,$FF,$FF
					dcb $FF,$CA,$FF,$FF,$CA,$FF,$FF,$FF
					dcb $C9,$CB,$FF,$FF,$FF,$FF,$FF,$FF
					dcb $CA,$FF,$FF,$FF,$FF,$CA,$FF,$FF
					dcb $FF,$FF,$FF,$FF,$FF,$C9,$FF,$FF
SNOW				LDA #$80
					STA $2115
					LDA #$50
					STA $04
					STZ $03
					LDA #$21
					STA $02
SNOW_LOOP			LDA $03
					AND #$07
					STA $01
					LDA $03
					AND #$E0
					LSR A
					LSR A
					ORA $01
					TAY
SNOW_LOOP1			LDA SNOW_TABLE1,y
					STA $01
					CMP #$FF
					BNE SNOW_LOOP2
					REP #$20
					LDA $03
					STA $2116
					LDA.W #$20FF
					STA $2118
					BRA SNOW_LOOP3
SNOW_LOOP2			REP #$20
					LDA $03
					STA $2116
					LDA $01
					STA $2118
SNOW_LOOP3			INC $03
					LDA $03
					CMP.W #$6000
					SEP #$20
					BCC SNOW_LOOP
					PHX
					LDX #$00
					LDY #$10
SNOW_LOOP0			TYA
					AND #$07
					ORA #$10
					TAY
					LDA SNOW_TABLE1,y
					STA $7FFFD0,x
					INX
					INY
					CPX #$20
					BNE SNOW_LOOP0
					PLX
					RTS
					
SAGA3_TABLE1		dcb $E7,$E8,$E9,$EA
					dcb $F7,$F8,$F9,$FA
					dcb $EB,$EC,$ED,$EE
					dcb $FB,$FC,$FD,$FE
SAGA3				LDA #$80
					STA $2115
					LDA #$50
					STA $04
					STZ $03
					LDA #$35
					STA $02
SAGA3_LOOP			LDA $03
					AND #$03
					STA $01
					LDA $03
					AND #$60
					LSR A
					LSR A
					LSR A
					ORA $01
					TAY
SAGA3_LOOP1			LDA SAGA3_TABLE1,y
					STA $01
					REP #$20
					LDA $03
					STA $2116
					LDA $01
					STA $2118
SAGA3_LOOP3			INC $03
					LDA $03
					CMP.W #$5380
					SEP #$20
					BCC SAGA3_LOOP
					PHX
					LDX #$00
					LDY #$08
SAGA3_LOOP0			TYA
					AND #$03
					ORA #$08
					TAY
					LDA SAGA3_TABLE1,y
					STA $7FFFD0,x
					INX
					INY
					CPX #$20
					BNE SAGA3_LOOP0
					PLX
					RTS

QUICK_TABLE1		dcb $89,$8A,$8B,$8C,$FC,$FC,$FC,$FC
					dcb $99,$9A,$9B,$9C,$FC,$FC,$FC,$FC
					dcb $AA,$AB,$AC,$AD,$FC,$FC,$FC,$FC
					dcb $BA,$BB,$BC,$BD,$FC,$FC,$FC,$FC
					dcb $FC,$FC,$FC,$FC,$89,$8A,$8B,$8C
					dcb $FC,$FC,$FC,$FC,$99,$9A,$9B,$9C
					dcb $FC,$FC,$FC,$FC,$AA,$AB,$AC,$AD
					dcb $FC,$FC,$FC,$FC,$BA,$BB,$BC,$BD
QUICKTIME			LDA #$80
					STA $2115
					LDA #$50
					STA $04
					STZ $03
					LDA #$29
					STA $02
QUICK_LOOP			LDA $03
					AND #$07
					STA $01
					LDA $03
					AND #$E0
					LSR A
					LSR A
					ORA $01
					TAY
QUICK_LOOP1			LDA QUICK_TABLE1,y
					STA $01
					CMP #$FC
					BNE QUICK_LOOP2
					REP #$20
					LDA $03
					STA $2116
					LDA.W #$2CFC
					STA $2118
					BRA QUICK_LOOP3
QUICK_LOOP2			REP #$20
					LDA $03
					STA $2116
					LDA $01
					STA $2118
QUICK_LOOP3			INC $03
					LDA $03
					CMP.W #$5380
					SEP #$20
					BCC QUICK_LOOP
					PHX
					LDX #$00
					LDY #$10
QUICK_LOOP0			TYA
					AND #$07
					ORA #$10
					TAY
					LDA QUICK_TABLE1,y
					STA $7FFFD0,x
					INX
					INY
					CPX #$20
					BNE QUICK_LOOP0
					PLX
					RTS
					

					
LAYER3_SCAL			LDA #$08
					STA $7FFB18
					LDA #$00
					STA $7FFB19
					LDA #$31
					STA $7FFB1A
					LDA #$C0
					STA $7FFB1B
					LDA #$DE
					STA $7FFB1C
					LDA #$7F
					STA $7FFB1D
					LDA #$01
					STA $7FDEC0
					LDA #$24
					STA $7FDEC1
					LDA #$00
					STA $7FDEC2
					RTS

HDMA_CIRCLE			LDA #$03
					STA $42
					LDA #$04
					STA $212E
					LDA #$10
					STA $7FFB20
					LDA #$20
					STA $7FFB28
					LDA #$00
					STA $7FFB21
					STA $7FFB29
					LDA #$26
					STA $7FFB22
					LDA #$27
					STA $7FFB2A
					LDA #$00
					STA $7FFB23
					STA $7FFB2B
					LDA #$DF
					STA $7FFB24
					LDA #$E1
					STA $7FFB2C
					LDA #$7F
					STA $7FFB25
					STA $7FFB2D
					LDA #$01
					STA $7FDF00
					STA $7FE100
					LDA #$00
					STA $7FDF01
					STA $7FE101
					STA $7FDF02
					STA $7FE102
					RTS
					
CIRCLE_GEN			LDA $7FDEFD;#SxW
					STA $02
					LDA $7FDEFE;#SyW
					STA $03
					STZ $04
					LDA $7FDEFF;#~̔a
					STA $0F
					PHX
					REP #$30
					LDA $03
					ASL A
					STA $00
					LDY.W #$0000
CIRCLE_LOOP0		SEP #$30
					STY $4202
					LDA #$70
					STA $4203
					LDA $4216
					STA $4204
					LDA $4217
					STA $4205
					LDA $0F
					STA $4206
					LDX $4214
					LDA CIRCLE,x
					STA $4202
					LDA $0F
					STA $4203
					LDA $4216
					STA $4204
					LDA $4217
					STA $4205
					LDA #$70
					STA $4206
					LDA $4214
					CLC
					ADC $02
					BCC NOT_RIGHT_OVER
					LDA #$FF
NOT_RIGHT_OVER		STA $04
					REP #$10
					LDX $00
					LDA $02
					SEC
					SBC $4214
					BCS NOT_LEFT_OVER
					LDA #$00
					BRA NOT_LEFT_OVER
CIRCLE_LOOP			BRA CIRCLE_LOOP0
NOT_LEFT_OVER		STA $05
					CPX.W #$1000
					BCS UP_OVER
					LDA $05
					STA $7FDF01,x
					LDA $04
					STA $7FE101,x
					LDA #$01
					STA $7FDF00,x
					STA $7FE100,x
UP_OVER
					REP #$30
					STY $00
					PHX
					TXA
					CLC
					ADC $00
					CLC
					ADC $00
					CLC
					ADC $00
					CLC
					ADC $00
					CLC
					ADC.W #$0002
					TAX
					SEP #$20
					CPX.W #$01C0
					BCS DOWN_OVER
					LDA $04
					STA $7FE101,x
					LDA $05
					STA $7FDF01,x
					LDA #$01
					STA $7FDF00,x
					STA $7FE100,x
					;LDA #$01 ;#\߉~ǂł
					;STA $7FDF02,x
					;STA $7FE102,x
					;LDA #$00
					;STA $7FDF03,x
					;STA $7FE103,x
					;STA $7FDF04,x
					;STA $7FE104,x
DOWN_OVER			PLX
					DEX
					DEX
					STX $00
					INY
					INC $14AF
					SEP #$30
					CPY $0F
					BCC CIRCLE_LOOP
					  ;#~㕔ǂ
					LDA $7FDEFE;#SyW
					INC A
					SEC
					SBC $7FDEFF;#~̔a
					BEQ CIRCLE_GEN4
					BCC CIRCLE_GEN4
					DEC A
					STA $03
					STZ $04
					REP #$30
					LDA $03
					ASL A
					TAX
					SEP #$20
CIRCLE_LOOP2		LDA #$01
					STA $7FDF00,x
					STA $7FE100,x
					LDA #$00
					STA $7FDF01,x
					STA $7FE101,x
					CPX.W #$0000
					BEQ CIRCLE_GEN4
					DEX
					DEX
					BRA CIRCLE_LOOP2
CIRCLE_GEN4			SEP #$30
					;#~ǂ
					LDA $7FDEFE;#SyW
					INC A
					CLC
					ADC $7FDEFF;#~̔a
					CMP #$E0
					BCC CIRCLE_GEN5
					REP #$10
					LDX.W #$01C0
					BRA CIRCLE_GEN6
					
CIRCLE_GEN5			STA $03
					STZ $04
					REP #$30
					LDA $03
					ASL A
					TAX
					SEP #$20
CIRCLE_GEN6			LDA #$01
					STA $7FDF00,x
					STA $7FE100,x
					LDA #$00
					STA $7FDF01,x
					STA $7FE101,x
					STA $7FDF02,x
					STA $7FE102,x
					SEP #$30
					PLX
					RTS
					
					

					

