;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Ark Deamon
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"
					LDA $E4,x
					ORA #$08
					STA $E4,x
					LDA #$88
					STA $D8,x
					LDA #$00
					STA $7FFE00
					JSR GAGE_RESET
					JSR LAYER3_DEL
					JSR HDMA_COLOR
					LDA #$60
					STA $15AC,x
                    RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                     ; return           
CODE_START          LDA $C2,x
					CMP #$10
					BNE MAIN1
					JSR FIRE1
					RTS
MAIN1				CMP #$11
					BNE MAIN2
					JSR STONE1
					RTS
MAIN2				CMP #$12
					BNE MAIN3
					JSR CONFU
					RTS
MAIN3				CMP #$13
					BNE MAIN4
					JSR BUBLE
					RTS
MAIN4				CMP #$14
					BNE MAIN5
					JSR BOMB
					RTS
MAIN5				CMP #$20
					BNE MAIN6
					JSR L_SUB
					RTS
MAIN6				CMP #$21
					BNE MAIN7
					JSR L_HAND
					RTS
MAIN7				CMP #$22
					BNE MAIN8
					JSR R_SUB
					RTS
MAIN8				CMP #$23
					BNE MAIN9
					JSR R_HAND
					RTS
MAIN9				CMP #$15
					BNE MAINA
					JSR FIRE2
					RTS
MAINA				CMP #$16
					BNE MAINB
					JSR SWORD
					RTS
MAINB				CMP #$17
					BNE MAINC
					JSR STONE2
					RTS
MAINC				CMP #$18
					BNE MAIND
					JSR BLACK2
					RTS
MAIND				JSR SUB_GFX             ; graphics routine
                    LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
                    ;JSR CHECK_DAMAGE
					LDA $7FFE00
					TAY
					LDA COLOR_MODE,y
					STA $7FC004
					LDA #$06
					STA $00212C
					LDA #$11
					STA $00212D
					LDA #$03
					STA $0F31
					STZ $149F
					
					LDA $16
					ORA $18
					BEQ CODE2
					INC $1594,x
CODE2				LDA $13
					AND #$07
					CMP #$04
					BCS CODE3
					INC $1570,x
CODE3				JSR DAMAGE_CHECK1
					JSR GAGE_CHECK
					LDA $C2,x
					BNE NOT_MODE0
					JSR MODE0
					RTS
NOT_MODE0			CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$02
					BNE NOT_MODE2
					JSR MODE2
					RTS
NOT_MODE2			CMP #$03
					BNE NOT_MODE3
					JSR MODE3
					RTS
NOT_MODE3			CMP #$04
					BNE NOT_MODE4
					JSR MODE4
					RTS
NOT_MODE4			CMP #$05
					BNE NOT_MODE5
					JSR MODE5
					RTS
NOT_MODE5			CMP #$06
					BNE NOT_MODE6
					JSR MODE6
					RTS
NOT_MODE6			CMP #$07
					BNE NOT_MODE7
					JSR MODE7
					RTS
NOT_MODE7			RTS


FIRE1				LDA #$EC
					STA $7FEEEC
					LDA #$02
					STA $7FEEED
					JSR SUB_GFX2             ; graphics routine
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN2
					JSL $27FAF4 ;SUB_OFF_SCREEN_HB
					LDA $AA,x
					PHA
					JSL $01802A             ; update position based on speed values
					PLA
					STA $AA,x
					LDA $1588,x
					AND #$04
					BEQ RETURN2
					LDA #$2B
					STA $7FEEEE
					JSR GEN_NORMAL
					STZ $14C8,x
RETURN2				RTS
FIRE_SPEED			dcb $60,$A0
FIRE2				LDA #$EC
					STA $7FEEEC
					LDA #$02
					STA $7FEEED
					JSR SUB_GFX2             ; graphics routine
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN2
					JSL $01A7DC
					LDA $14E0,x
					CMP #$01
					BNE FIRE2_D
					LDA $1504,x
					BNE FIRE2_2
					LDA #$60
					STA $AA,x
					STZ $B6,x
					JSL $01802A             ; update position based on speed values
					LDA $1588,x
					AND #$04
					BEQ FIRE2_R
					LDA #$01
					STA $1504,x
					LDA #$32
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$19
					STA $1686,y
					LDA #$13
					STA $167A,y
					LDA #$15
					STA $00C2,y
					LDA #$01
					STA $1504,y
					STA $157C,y
					RTS
FIRE2_D				STZ $14C8,x
FIRE2_R				RTS
FIRE2_2				LDY $157C,x
					LDA FIRE_SPEED,y
					STA $B6,x
					JSL $01802A
					RTS

STONE1				JSR SUB_GFX3            ; graphics routine
                    LDA $9D                 ; \ if sprites locked, return
                    BNE STONE1_R
					LDA #$19
					STA $1686,x
					LDA #$13
					STA $167A,x
					JSL $01A7DC
					STZ $B6,x
					JSL $01802A             ; update position based on speed values
					LDA $14
					AND #$01
					CLC
					ADC $1570,x
					STA $1570,x
					CMP #$FF
					BNE STONE1_R
					JSR SUB_SMOKE
					STZ $14C8,x
					LDA $1504,x
					CMP #$77
					BNE STONE1_R
					LDA #$53
					STA $7FEEEE
					JSR GEN_NORMAL
					LDA #$80
					STA $1540,y
					LDA #$09
					STA $14C8,y
STONE1_R			RTS

X_STONE				dcb $00,$D0,$A0,$90,$A0,$D0,$00,$30,$60,$70,$60,$30
Y_STONE				dcb $70,$60,$30,$00,$D0,$A0,$90,$A0,$D0,$00,$30,$60
STONE2				JSR SUB_GFX3            ; graphics routine
                    LDA $9D                 ; \ if sprites locked, return
                    BNE STONE1_R
					JSL $01A7DC
					LDY $1570,x
					LDA X_STONE,y
					STA $B6,x
					LDA Y_STONE,y
					STA $AA,x
					JSL $01802A             ; update position based on speed values
					LDA $15AC,x
					BNE STONE2_R
					STZ $14C8,x
STONE2_R			RTS

					
SUB_SMOKE           LDY #$03                ; \ find a free slot to display effect
FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
                    RTS                     ; / return if no slots open
FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    ;LDA $178B,x
					LDA $D8,x 
                    STA $17C4,y             ; /
                    LDA #$1B                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $E4,x             ; \ load generator x position
                    STA $17C8,y             ; /
RETURN3             RTS 
					
CONFU_PRO			dcb $0B,$CB
CONFU				LDA #$46
					STA $7FEEEC
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$01
					TAY
					LDA CONFU_PRO,y
					STA $7FEEED
					JSR SUB_GFX2
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN3
					JSR MIRROR
					INC $1570,x
					LDA $14
					AND #$01
					CLC
					ADC $1602,x
					STA $1602,x
					CMP #$FF
					BEQ CONFU_R
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					SEC
					SBC #$10
					STA $D8,x
					LDA $97
					SBC #$00
					STA $14D4,x
					RTS
CONFU_R				STZ $14C8,x
					RTS
					
					
MIRROR				LDA $15
					AND #$03
					BEQ SPEED
					CMP #$01
					BNE LEFT
					STZ $76
					BRA SPEED
LEFT				LDA #$01
					STA $76
SPEED				LDA $7B
					CMP #$80
					BCS S_LEFT
					LDA $94
					CMP #$09
					BCS SPEED2
					LDA #$09
					STA $94
					RTS
SPEED2				LDA $7B
					LSR A
					LSR A
					LSR A
					STA $151C,x
					LDA $94
					SEC
					SBC $151C,x
					STA $94
					LDA $95
					SBC #$00
					STA $95
					RTS
S_LEFT				LDA $94
					CMP #$E8
					BCC S_LEFT2
					LDA #$E7
					STA $94
					RTS
S_LEFT2				LDA $7B
					STA $151C,x
					LDA #$00
					SEC
					SBC $151C,x
					LSR A
					LSR A
					LSR A
					STA $151C,x
					LDA $94
					CLC
					ADC $151C,x
					STA $94
					LDA $95
					ADC #$00
					STA $95
BUBLE_R2 			RTS
					
BUBLE				JSR SUB_GFX4            ; graphics routine
                    LDA $9D                 ; \ if sprites locked, return
                    BNE BUBLE_R2
					LDA #$13
					STA $167A,x
					LDA #$19
					STA $1686,x
					JSL $01A7DC
					LDA $AA,x
					PHA
					JSL $01802A
					PLA
					STA $AA,x
					LDA $1588,x
					AND #$04
					BEQ BUBLE_2
					LDA $AA,x
					EOR #$FF
					STA $AA,x
					BRA BUBLE_C
BUBLE_2				LDA $E4,x
					CMP #$08
					BCS BUBLE_3
					LDA $B6,x
					CMP #$80
					BCC BUBLE_3
					LDA $B6,x
					EOR #$FF
					STA $B6,x
					BRA BUBLE_C
BUBLE_3				LDA $E4,x
					CMP #$F8
					BCC BUBLE_4
					LDA $B6,x
					CMP #$80
					BCS BUBLE_4
					LDA $B6,x
					EOR #$FF
					STA $B6,x
					BRA BUBLE_C
BUBLE_4				LDA $14D4,x
					BNE BUBLE_C
					LDA $D8,x
					CMP #$68
					BCS BUBLE_C
					LDA $AA,x
					CMP #$80
					BCC BUBLE_C
					LDA $AA,x
					EOR #$FF
					STA $AA,x
BUBLE_C				LDA $15AC,x
					BNE BUBLE_R
					STZ $14C8,x
					LDA $1504,x
					CMP #$77
					BNE BUBLE_R
					LDA #$53
					STA $7FEEEE
					JSR GEN_NORMAL
					LDA #$09
					STA $14C8,y
					LDA #$80
					STA $1540,y
BUBLE_R				RTS

BOMB				LDA $15AC,x
					CMP #$10
					BCC BOMB_2
					JSR SUB_GFX4
					BRA BOMB_M
BOMB_2				CMP #$08
					BCC BOMB_3
					LDA #$66
					STA $7FEEEC
					LDA #$03
					STA $7FEEED
					JSR SUB_GFX2
					BRA BOMB_M
BOMB_3				LDA #$60
					STA $7FEEEC
					LDA #$03
					STA $7FEEED
					JSR SUB_GFX2
BOMB_M				LDA $9D                 ; \ if sprites locked, return
                    BNE BUBLE_R
					LDA $7FD010
					CMP #$01
					BNE BOMB_M2
					STZ $B6,x
					LDA #$D0
					STA $AA,x
					JSL $01802A 
BOMB_M2				LDA $15AC,x
					BNE BUBLE_R
					STZ $14C8,x
					RTS
SWORD				JSR GET_DRAW_INFO
					LDA $9D
					BNE SWORD_R
					JSL $01A7DC
					LDA #$00
					SEC
					SBC $E4,x
					CLC
					ADC #$08
					STA $1466
					LDA #$00
					ADC #$00
					STA $1467
					LDA $15AC,x
					CMP #$F0
					BCS SWORD_R
					CMP #$D4
					BCS SWORD_2
					CMP #$9C
					BCS SWORD_R
					CMP #$80
					BCS SWORD_3
					LDA #$60
					STA $1468
					STZ $1466
					STZ $1467
					STZ $14C8,x
					RTS
SWORD_2				LDA $D8,x
					SEC
					SBC #$04
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					LDA $1468
					CLC
					ADC #$04
					STA $1468
SWORD_R				RTS
SWORD_3				LDA $D8,x
					CLC
					ADC #$04
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					LDA $1468
					SEC
					SBC #$04
					STA $1468
					RTS
					
BLACK2				LDA #$E8
					STA $7FEEEC
					LDA #$0A
					STA $7FEEED
					JSR SUB_GFX2
					LDA $9D
					BNE BLACK2_R
					LDA $15AC,x
					CMP #$D8
					BCS BLACK2_D
					CMP #$81
					BCS BLACK2_C
					CMP #$80
					BEQ BLACK2_2
					CMP #$72
					BCS BLACK2_3
					CMP #$71
					BEQ BLACK2_4
BLACK2_R			RTS
BLACK2_D			LDA #$40
					STA $AA,x
					STZ $B6,x
					JSL $01802A
					RTS
BLACK2_C			JSR DAMAGE_CHECK_B
					RTS
BLACK2_2			LDA #$10
					STA $1DF9
					LDA $E4,x
					CLC
					ADC #$08
					STA $002126
					STA $1504,x
					STA $002127
					STA $151C,x
					LDA #$00
					SEC
					SBC $E4,x
					CLC
					ADC #$38
					STA $1466
					LDA #$00
					ADC #$00
					STA $1467
					RTS
BLACK2_3			DEC $1504,x
					DEC $1504,x
					LDA $1504,x
					STA $002126
					INC $151C,x
					INC $151C,x
					LDA $151C,x
					STA $002127
					RTS
BLACK2_4			JSR CHECK_DAMAGE_C
					STZ $14C8,x
					STZ $1466
					STZ $1467
					RTS

					
L_SUB				LDA $7FD010
					CMP #$01
					BNE L_SUB_1
					JSR FINAL
					RTS
L_SUB_1				JSR SUB_GFX4 ;#$7FD000
					LDA $9D
					BNE L_SUB_R
					LDA $1528,x
					CMP #$08
					BNE L_SUB_2
					LDA $1540,x
					CMP #$C0
					BCS L_SUB_2
					JSR FINAL
					RTS
L_SUB_2				JSR POS_LEFT
					JSR FACE_CHANGE
					LDA $E4,x
					PHA
					LDA $14E0,x
					PHA
					LDA $D8,x
					PHA
					LDA $14D4,x
					PHA
					LDA #$78
					STA $E4,x
					LDA #$01
					STA $14E0,x
					LDA #$98
					STA $D8,x
					STZ $14D4,x
					JSR MARIO_CHECK
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					LDA $77
					AND #$04
					BEQ L_SUB_R
					STZ $151C,x
L_SUB_R				RTS

R_SUB				JSR SUB_GFX4 ;#$7FD002
					LDA $9D
					BNE R_SUB_R
					JSR POS_RIGHT
					JSR FREEZE_CHECK
					JSR ALTER_CHECK
R_SUB_R				RTS
					
					
					
L_HAND				JSR SUB_GFX5 ;#$7FD001
					LDA $9D
					BNE L_HAND_R
					LDA $7FFE00
					TAY
					LDA COLOR_MODE,y
					STA $7FC004
					LDA #$06
					STA $00212C
					LDA #$11
					STA $00212D
					LDA #$02
					STA $00212E
					LDA #$03
					STA $0F31
					STZ $149F
					LDA $16
					ORA $18
					BEQ L_HAND2
					INC $1594,x
					LDA $1594,x
					STA $7FD004
					
L_HAND2				LDA $7FD005
					CMP #$01
					BEQ L_HAND3
					CMP #$04
					BEQ L_HAND4
					CMP #$02
					BEQ L_HAND_R
					CMP #$05
					BEQ L_HAND_R
					LDA $7FD003
					TAY
					LDA $00D8,y
					STA $D8,x
					LDA $14D4,y
					STA $14D4,x
					LDA #$F0
					SEC
					SBC $00E4,y
					STA $E4,x
					LDA $1602,y
					STA $1602,x
L_HAND_R			RTS
L_HAND3				JSR ATK1
					RTS
L_HAND4				JSR ATK3
					RTS
					
					
R_HAND				JSR SUB_GFX5 ;#$7FD003
					LDA $9D
					BNE R_HAND_R
					LDA $7FD005
					CMP #$01
					BEQ R_HAND_R
					CMP #$04
					BEQ R_HAND_R
					CMP #$02
					BEQ R_HAND_2
					CMP #$05
					BEQ R_HAND_3
					CMP #$06
					BEQ R_HAND_4
					CMP #$07
					BEQ R_HAND_ATK_M
					LDA $1570,x
					CMP #$80
					BEQ R_HAND_ATK1
					JSR MOVE_RHAND
R_HAND_R			RTS
R_HAND_ATK1			LDA $7FD005
					CMP #$03
					BEQ R_HAND_ATK2
					LDA #$01
					STA $7FD005
					LDA $7FD001
					TAY
					LDA #$00
					STA $1570,y
					RTS
R_HAND_2			JSR ATK2
					RTS
R_HAND_ATK2			LDA #$04
					STA $7FD005
					LDA $7FD001
					TAY
					LDA #$00
					STA $1570,y
					RTS
R_HAND_3			JSR ATK4
					RTS
R_HAND_4			LDA #$07
					STA $7FD005
					LDA $7FD004
					CLC
					ADC $94
					AND #$03
					INC A
					STA $7FFE00
					LDA #$FF
					STA $15AC,x
					RTS
R_HAND_ATK_M		LDA $7FFE00
					CMP #$01
					BNE R_HAND_ATK_M_2
					JSR ATK_GREEN
					RTS
R_HAND_ATK_M_2		CMP #$02
					BNE R_HAND_ATK_M_3
					JSR ATK_BLUE
					RTS
R_HAND_ATK_M_3		CMP #$03
					BNE R_HAND_ATK_M_4
					JSR ATK_BLOWN
					RTS
R_HAND_ATK_M_4		JSR ATK_BLACK
					RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ATK
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ATK1				LDA #$02
					STA $1602,x
					LDA $1570,x
					CMP #$20
					BEQ ATK1_3
					BCC ATK1_2
					RTS
ATK1_2				LDA #$D0
					STA $AA,x
					STZ $B6,x
					JSL $01802A
					INC $1570,x
					LDA #$80
					STA $15AC,x
					RTS
ATK1_3				LDA $15AC,x
					BEQ ATK1_4
					CMP #$60
					BEQ ATK1_G
ATK1_R				RTS
ATK1_4				LDA #$01
					STA $1602,x
					LDA #$30
					STA $AA,x
					STZ $B6,x
					JSL $01802A
					LDA $D8,x
					CMP #$F0
					BCC ATK1_R
					LDA #$02
					STA $7FD005
					STZ $1570,x
					RTS
ATK1_G				LDA #$32
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$19
					STA $1686,y
					LDA #$13
					STA $167A,y
					LDA #$15
					STA $00C2,y
					LDA #$00
					STA $157C,y
					STA $1504,y
					RTS
					
ATK2				LDA #$02
					STA $1602,x
					LDA $1570,x
					CMP #$A0
					BEQ ATK2_3
					BCC ATK2_2
					RTS
ATK2_2				LDA #$D0
					STA $AA,x
					STZ $B6,x
					JSL $01802A
					INC $1570,x
					LDA #$80
					STA $15AC,x
					RTS
ATK2_3				LDA $15AC,x
					BEQ ATK2_4
					CMP #$60
					BEQ ATK2_G
ATK2_R				RTS
ATK2_4				LDA #$01
					STA $1602,x
					LDA #$30
					STA $AA,x
					STZ $B6,x
					JSL $01802A
					LDA $D8,x
					CMP #$F0
					BCC ATK2_R
					LDA #$03
					STA $7FD005
					STZ $1570,x
					LDA #$F0
					STA $D8,x
					STZ $AA,x
					RTS
ATK2_G				LDA #$69
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$05
					STA $1602,y
					LDA #$60
					STA $15AC,y
					LDA #$00
					STA $157C,y
					LDA #$40
					STA $00E4,y
					LDA #$01
					STA $14E0,y
					LDA #$80
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA #$69
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$05
					STA $1602,y
					LDA #$60
					STA $15AC,y
					LDA #$01
					STA $157C,y
					LDA #$C0
					STA $00E4,y
					LDA #$01
					STA $14E0,y
					LDA #$80
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					RTS
					
ATK3				STZ $1602,x
					LDA $1540,x
					BNE ATK3_5
					INC $1570,x
					LDA $1570,x
					CMP #$10
					BCC ATK3_2
					LDA $14D4,x
					BEQ ATK3_1
					LDA $D8,x
					CMP #$10
					BCS ATK3_4
ATK3_1				LDA #$50
					STA $AA,x
					JSL $01802A
					STZ $15AC,x
					RTS
ATK3_2				LDA #$B0
					STA $AA,x
					STZ $B6,x
					JSL $01802A
ATK3_R				RTS
ATK3_4				LDA #$FF
					STA $1540,x
					LDA #$09
					STA $1DFC
					LDA #$40
					STA $1887
					JSR DELETE_UNICON
					LDA $77
					AND #$04
					BEQ ATK3_R
					LDA #$FF
					STA $18BD
					RTS
ATK3_5				LDA $1540,x
					CMP #$D0
					BCS ATK3_R
					LDA #$D0
					STA $AA,x
					JSL $01802A
					LDA $14D4,x
					BNE ATK3_R
					LDA $D8,x
					CMP #$F0
					BCS ATK3_R
					STZ $AA,x
					LDA #$01
					STA $1602,x
					LDA #$05
					STA $7FD005
					STZ $1570,x
					STZ $1540,x
					RTS
					
ATK4				LDA #$01
					STA $1602,x
					LDA $1570,x
					CMP #$A0
					BEQ ATK4_3
					BCC ATK4_2
					RTS
ATK4_2				LDA #$D0
					STA $AA,x
					STZ $B6,x
					JSL $01802A
					INC $1570,x
					LDA #$C0
					STA $15AC,x
					RTS
ATK4_3				LDA $15AC,x
					BEQ ATK4_4
					CMP #$A0
					BEQ ATK4_G
ATK4_R				RTS
ATK4_4				LDA #$01
					STA $1602,x
					LDA #$30
					STA $AA,x
					STZ $B6,x
					JSL $01802A
					LDA $D8,x
					CMP #$F0
					BCC ATK4_R
					LDA #$06
					STA $7FD005
					STZ $1570,x
					LDA #$F0
					STA $D8,x
					STZ $AA,x
					RTS
ATK4_G				LDA #$32
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$19
					STA $1686,y
					LDA #$13
					STA $167A,y
					LDA #$16
					STA $00C2,y
					LDA #$FF
					STA $15AC,y
					LDA $94
					STA $00E4,y
					LDA $95
					STA $14E0,y
					LDA #$50
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					LDA $94
					SEC
					SBC #$08
					STA $002126
					CLC
					ADC #$1F
					STA $002127
					RTS
					
ATK_GREEN			LDA $15AC,x
					CMP #$E0
					BCS ATK_GREEN_R
					CMP #$C0
					BCS ATK_GREEN_2
					CMP #$8F
					BCS ATK_GREEN_R
					CMP #$70
					BCS ATK_GREEN_4
					CMP #$51
					BCS ATK_GREEN_3
					CMP #$50
					BEQ ATK_GREEN_5
					CMP #$30
					BCS ATK_GREEN_6
					CMP #$2F
					BCS ATK_GREEN_7
					RTS
ATK_GREEN_2			LDA #$20
					STA $B6,x
					LDA #$E0
					STA $AA,x
					JSL $01802A
					RTS
ATK_GREEN_6			LDA #$E0
					STA $B6,x
					LDA #$20
					STA $AA,x
					JSL $01802A
					RTS
ATK_GREEN_5			JSR HDMA_COLOR
					RTS
ATK_GREEN_3			PHP
					REP #$30
					LDA $7FE301
					SEC
					SBC.W #$0020
					STA $7FE301
					PLP
ATK_GREEN_R			RTS
ATK_GREEN_7			LDA #$00
					STA $7FFE00
					STA $7FD005
					LDA #$F0
					STA $D8,x
					STZ $1570,x
					RTS
ATK_GREEN_4			PHP
					REP #$30
					LDA $7FE301
					CLC
					ADC.W #$0020
					STA $7FE301
					PLP
					LDA $15AC,x
					CMP #$70
					BNE ATK_GREEN_R
					LDA #$01
					STA $1DFC
					LDA $7FD002
					TAY
					LDA #$00
					STA $1570,y
					LDA #$01
					STA $151C,y
					LDA #$90
					STA $94
					RTS

ATK_BLUE			LDA $15AC,x
					CMP #$E0
					BCS ATK_BLUE_R
					CMP #$C0
					BCS ATK_BLUE_2
					CMP #$80
					BCS ATK_BLUE_R
					CMP #$7F
					BEQ ATK_BLUE_3
					CMP #$60
					BCS ATK_BLUE_R
					CMP #$5F
					BEQ ATK_BLUE_4
					CMP #$3F
					BCS ATK_BLUE_5
					CMP #$3E
					BCS ATK_BLUE_6
					RTS
ATK_BLUE_2			LDA #$F0
					STA $B6,x
					LDA #$F8
					STA $AA,x
					JSL $01802A
ATK_BLUE_R			RTS
ATK_BLUE_5			LDA #$10
					STA $B6,x
					LDA #$08
					STA $AA,x
					JSL $01802A
					RTS
ATK_BLUE_4			STZ $1466
					STZ $1467
					RTS
ATK_BLUE_6			LDA #$00
					STA $7FFE00
					STA $7FD005
					LDA #$F0
					STA $D8,x
					LDA #$40
					STA $1570,x
					RTS
ATK_BLUE_3			LDA #$1C
                    STA $1DFC
					LDA #$01
					STA $7FD006
					LDA #$FF
					STA $18BD
					LDA $94
					CMP #$28
					BCC ATK_BLUE_3_2
					CMP #$C8
					BCS ATK_BLUE_3_3
					LDA $94
					SEC
					SBC #$28
					STA $002126
					CLC
					ADC #$60
					STA $002127
					LDA #$C8
					SEC
					SBC $94
					CLC
					ADC #$C0
					STA $1466
					LDA #$00
					ADC #$00
					STA $1467
					RTS
ATK_BLUE_3_2		LDA #$00
					STA $002126
					LDA #$60
					STA $002127
					LDA #$60
					STA $1466
					LDA #$01
					STA $1467
					RTS
ATK_BLUE_3_3		LDA #$A0
					STA $002126
					LDA #$FF
					STA $002127
					LDA #$C0
					STA $1466
					STZ $1467
					RTS


					
ATK_BLOWN			LDA $15AC,x
					CMP #$E0
					BCS ATK_BLOWN_R
					CMP #$C2
					BCS ATK_BLOWN_2
					CMP #$B0
					BEQ ATK_BLOWN_G
					CMP #$A8
					BEQ ATK_BLOWN_G
					CMP #$A0
					BEQ ATK_BLOWN_G
					CMP #$98
					BEQ ATK_BLOWN_G
					CMP #$90
					BEQ ATK_BLOWN_G
					CMP #$88
					BEQ ATK_BLOWN_G
					CMP #$80
					BEQ ATK_BLOWN_G
					CMP #$78
					BEQ ATK_BLOWN_G
					CMP #$70
					BEQ ATK_BLOWN_G
					CMP #$68
					BEQ ATK_BLOWN_G
					CMP #$60
					BEQ ATK_BLOWN_G
					CMP #$58
					BEQ ATK_BLOWN_G
					CMP #$30
					BCS ATK_BLOWN_R
					CMP #$12
					BCS ATK_BLOWN_3
					CMP #$11
					BEQ ATK_BLOWN_4
					RTS
ATK_BLOWN_2			LDA #$F0
					STA $B6,x
					LDA #$F8
					STA $AA,x
					JSL $01802A
					LDA #$02
					STA $1602,x
					STZ $1570,x
ATK_BLOWN_R			RTS
ATK_BLOWN_3			LDA #$10
					STA $B6,x
					LDA #$08
					STA $AA,x
					JSL $01802A
					LDA #$01
					STA $1602,x
					STZ $1570,x
					RTS
ATK_BLOWN_G			LDA #$32
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$13
					STA $167A,y
					LDA #$17
					STA $00C2,y
					LDA #$D0
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA #$78
					STA $00E4,y
					LDA #$01
					STA $14E0,y
					LDA $1570,x
					STA $1570,y
					LDA #$20
					STA $15AC,y
					INC $1570,x
					RTS
ATK_BLOWN_4			LDA #$00
					STA $7FFE00
					STA $7FD005
					LDA #$F0
					STA $D8,x
					STZ $1570,x
					RTS

X_BLACK				dcb $18,$58,$98,$D8
ATK_BLACK			LDA $1540,x
					BEQ ATK_BLACK_1
					CMP #$22
					BCS ATK_BLACK_R
					CMP #$02
					BCS ATK_BLACK_3
					CMP #$01
					BCS ATK_BLACK_4
					RTS
ATK_BLACK_1			LDA $15AC,x
					CMP #$E0
					BCS ATK_BLACK_R
					CMP #$C0
					BCS ATK_BLACK_2
					CMP #$B0
					BEQ ATK_BLACK_G
					CMP #$A0
					BEQ ATK_BLACK_G
					CMP #$90
					BEQ ATK_BLACK_G
					CMP #$80
					BEQ ATK_BLACK_G
					CMP #$50
					BEQ ATK_BLACK_5
					RTS
ATK_BLACK_2			STZ $1602,x
					LDA #$E0
					STA $B6,x
					LDA #$F0
					STA $AA,x
					JSL $01802A
					STZ $1570,x
ATK_BLACK_R			RTS
ATK_BLACK_3			STZ $1602,x
					LDA #$20
					STA $B6,x
					LDA #$10
					STA $AA,x
					JSL $01802A
					RTS
ATK_BLACK_4			LDA #$00
					STA $7FFE00
					STA $7FD005
					LDA #$F0
					STA $D8,x
					STZ $1570,x
					LDA #$01
					STA $1602,x
					RTS
ATK_BLACK_G			LDA #$32
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$18
					STA $00C2,y
					LDA #$50
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA #$01
					STA $14E0,y
					LDA #$FF
					STA $15AC,y
					PHX
					LDA $1570,x
					TAX
					LDA X_BLACK,x
					STA $00E4,y
					PLX
					INC $1570,x
					RTS
ATK_BLACK_5			LDA #$FF
					STA $1540,x
					RTS

DELETE_UNICON		PHX
					LDX #$00
DELETE_U_L			LDA NEW_SPRITE_NUM,x
					CMP #$69
					BNE DELETE_U2
					LDA $14C8,x
					CMP #$08
					BNE DELETE_U2
					JSR SUB_SMOKE
					STZ $14C8,x
DELETE_U2			INX
					CPX #$0A
					BNE DELETE_U_L
					PLX
					RTS
					
FREEZE_CHECK		LDA $7FD006
					CMP #$01
					BEQ FREEZE_CHECK_2
					LDA $1497
					BEQ FREEZE_CHECK_R
					STZ $18BD
FREEZE_CHECK_R		RTS
FREEZE_CHECK_2		LDA $18BD
					BEQ FREEZE_CHECK_R
					LDA $1497
					BNE FREEZE_CHECK_R2
					LDA $18BD
					CMP #$01
					BEQ FREEZE_CHECK_R2
					LDA #$89
                    STA $0D82
					RTS
FREEZE_CHECK_R2		STZ $18BD
					LDA #$00
					STA $7FD006
					RTS

ALTER_CHECK			LDA $151C,x
					BEQ ALTER_CHECK_R
					CMP #$07
					BEQ ALTER_CHECK_E
					LDA $1570,x
					CLC
					ADC #$01
					STA $1570,x
					LDA $151C,x
					ADC #$00
					STA $151C,x
					LDA $1570,x
					AND #$01
					BEQ ALTER_CHECK_R
					LDA $1570,x
					AND #$02
					BEQ ALTER_CHECK_2
					LDA $94
					CMP #$B8
					BCC ALTER_CHECK_1
					LDA #$B7
					STA $94
ALTER_CHECK_1		LDA $94
					CLC
					ADC #$30
					STA $94
ALTER_CHECK_R		RTS
ALTER_CHECK_2		LDA $94
					CMP #$38
					BCS ALTER_CHECK_3
					LDA #$38
					STA $94
ALTER_CHECK_3		LDA $94
					SEC
					SBC #$30
					STA $94
					RTS
ALTER_CHECK_E		STZ $1570,x
					STZ $151C,x
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MOVE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X_SPEED_H1			dcb $0C,$F4

MOVE_RHAND			LDA $1504,x
					BNE MOVE_RHAND_2
					LDA $15AC,x
					CMP #$40
					BEQ MOVE_RHAND_1
					LDA $15AC,x
					BNE MOVE_RHAND_R
					LDA #$20
					STA $AA,x
					LDA #$40
					STA $B6,x
					JSL $01802A
					LDA $D8,x
					CMP #$F0
					BCC MOVE_RHAND_R
					LDA #$01
					STA $1504,x
					LDA #$01
					STA $1602,x
					LDA $7FD001
					TAY
					LDA #$01
					STA $1602,y
					RTS
MOVE_RHAND_1		LDA #$19
					STA $1DFB
MOVE_RHAND_R		RTS
MOVE_RHAND_2		INC $1570,x
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$01
					TAY
					LDA X_SPEED_H1,y
					STA $B6,x
					STZ $AA,x
					JSL $01802A
					RTS

POS_LEFT			LDA $7FD001
					TAY
					LDA $00E4,y
					SEC
					SBC #$10
					STA $E4,x
					LDA $14E0,y
					SBC #$00
					STA $14E0,x
					LDA $14D4,y
					BNE POS_LEFT2
					LDA $00D8,y
					CMP #$E0
					BCS POS_LEFT2
					LDA $00D8,y
					CLC
					ADC #$08
					STA $D8,x
					LDA $14D4,y
					ADC #$00
					STA $14D4,x
					RTS
POS_LEFT2			LDA $00D8,y
					SEC
					SBC #$04
					STA $D8,x
					LDA $14D4,y
					SBC #$00
					STA $14D4,x
					RTS
					
POS_RIGHT			LDA $7FD003
					TAY
					LDA $00E4,y
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,y
					ADC #$00
					STA $14E0,x
					LDA $14D4,y
					BNE POS_RIGHT2
					LDA $00D8,y
					CMP #$E0
					BCS POS_RIGHT2
					LDA $00D8,y
					CLC
					ADC #$08
					STA $D8,x
					LDA $14D4,y
					ADC #$00
					STA $14D4,x
					RTS
POS_RIGHT2			LDA $00D8,y
					SEC
					SBC #$04
					STA $D8,x
					LDA $14D4,y
					SBC #$00
					STA $14D4,x
					RTS
					
FACE_CHANGE			LDA $15AC,x
					BNE FACE_CHANGE_R
					LDA #$80
					STA $15AC,x
					LDA $7FD004
					AND #$03
					BNE FACE_CHANG_2
					JSR FACE_CHANGE1
					RTS
FACE_CHANG_2		CMP #$01
					BNE FACE_CHANG_3
					JSR FACE_CHANGE2
					RTS
FACE_CHANG_3		CMP #$02
					BNE FACE_CHANG_4
					JSR FACE_CHANGE3
					RTS
FACE_CHANG_4		CMP #$03
					BNE FACE_CHANGE_R
					LDA $94
					CMP #$78
					BCS FACE_CHANG_5
					JSR FACE_CHANGE4
					RTS
FACE_CHANG_5		JSR FACE_CHANGE5
FACE_CHANGE_R		RTS
FACE_CHANGE1		LDA #$70
					STA $9A
					LDA #$01
					STA $9B
					LDA #$A0
					STA $98
					STZ $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A37
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					LDA #$01
					STA $9B
					LDA #$A0
					STA $98
					STZ $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A38
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$70
					STA $9A
					LDA #$01
					STA $9B
					LDA #$B0
					STA $98
					STZ $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A47
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					LDA #$01
					STA $9B
					LDA #$B0
					STA $98
					STZ $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A48
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
FACE_CHANGE2		LDA #$70
					STA $9A
					LDA #$01
					STA $9B
					LDA #$A0
					STA $98
					STZ $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A37
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					LDA #$01
					STA $9B
					LDA #$A0
					STA $98
					STZ $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A38
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$70
					STA $9A
					LDA #$01
					STA $9B
					LDA #$B0
					STA $98
					STZ $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A70
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					LDA #$01
					STA $9B
					LDA #$B0
					STA $98
					STZ $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A7F
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
FACE_CHANGE3		LDA #$70
					STA $9A
					LDA #$01
					STA $9B
					LDA #$A0
					STA $98
					STZ $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A37
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					LDA #$01
					STA $9B
					LDA #$A0
					STA $98
					STZ $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A38
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$70
					STA $9A
					LDA #$01
					STA $9B
					LDA #$B0
					STA $98
					STZ $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A94
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					LDA #$01
					STA $9B
					LDA #$B0
					STA $98
					STZ $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A9B
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
FACE_CHANGE4		LDA #$70
					STA $9A
					LDA #$01
					STA $9B
					LDA #$A0
					STA $98
					STZ $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A90
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					LDA #$01
					STA $9B
					LDA #$A0
					STA $98
					STZ $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A91
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$70
					STA $9A
					LDA #$01
					STA $9B
					LDA #$B0
					STA $98
					STZ $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A92
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					LDA #$01
					STA $9B
					LDA #$B0
					STA $98
					STZ $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A93
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
FACE_CHANGE5		LDA #$70
					STA $9A
					LDA #$01
					STA $9B
					LDA #$A0
					STA $98
					STZ $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A9E
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					LDA #$01
					STA $9B
					LDA #$A0
					STA $98
					STZ $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A9F
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$70
					STA $9A
					LDA #$01
					STA $9B
					LDA #$B0
					STA $98
					STZ $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A9C
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					LDA #$01
					STA $9B
					LDA #$B0
					STA $98
					STZ $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A9D
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
COLOR_MODE			dcb $0F,$01,$03,$05,$07,$09,$0B,$0D

MODE0				LDA $1570,x
					LSR A
					LSR A
					AND #$03
					STA $1602,x
					ASL A
					CLC
					ADC $1602,x
					ASL A
					STA $1602,x
					LDA $15AC,x
					BEQ MODE0_1
					RTS
MODE0_1				LDA $7FFE00
					INC A
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					LDA #$18
					STA $1602,x
					RTS

MODE1				LDA $15AC,x ;#1
					BEQ MODE1_2
					CMP #$F0
					BEQ MODE1_G
					CMP #$70
					BEQ MODE1_G
					RTS
MODE1_G				LDA #$32
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$19
					STA $1686,y
					LDA #$10
					STA $00C2,y
					STA $1DF9
					JSR SPEED_DEC1
					RTS
MODE1_2				LDA #$FF
					STA $15AC,x
					LDA #$06
					STA $C2,x
					RTS

MODE2				LDA $15AC,x ;#1
					CMP #$80
					BEQ MODE2_4
					CMP #$A0
					BCC MODE2_1
					CMP #$BF
					BCC MODE2_2
					RTS
MODE2_1				PHP
					REP #$30
					LDA $7FE301
					SEC
					SBC.W #$0020
					STA $7FE301
					PLP
					RTS
MODE2_2				PHP
					REP #$30
					LDA $7FE301
					CLC
					ADC.W #$0020
					STA $7FE301
					PLP
					LDA $15AC,x
					CMP #$A1
					BNE MODE2_R
					LDA #$32
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$01
					STA $1DFC
					LDA #$12
					STA $00C2,y
					LDA #$00
					STA $1570,y
					STA $1602,y
MODE2_R				RTS
MODE2_4				LDA #$FF
					STA $15AC,x
					LDA #$06
					STA $C2,x
					JSR HDMA_COLOR
					RTS
					
MODE3				LDA $15AC,x ;#1
					BEQ MODE3_2
					CMP #$E0
					BEQ MODE3_G
					RTS
MODE3_2				LDA #$FF
					STA $15AC,x
					LDA #$06
					STA $C2,x
					RTS
MODE3_G				LDA #$32
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$13
					STA $00C2,y
					LDA #$FF
					STA $15AC,y
					LDA #$18
					STA $00AA,y
					LDA #$30
					STA $00B6,y
					LDA $7FFC00
					CMP #$00
					BNE MODE3_G_2
					LDA #$77
					STA $1504,y
MODE3_G_2			LDA #$32
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$13
					STA $00C2,y
					LDA #$FF
					STA $15AC,y
					LDA #$D0
					STA $00AA,y
					LDA #$18
					STA $00B6,y
					LDA $7FFC00
					CMP #$01
					BNE MODE3_G_3
					LDA #$77
					STA $1504,y
MODE3_G_3			LDA #$32
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$13
					STA $00C2,y
					LDA #$FF
					STA $15AC,y
					LDA #$E8
					STA $00AA,y
					LDA #$D0
					STA $00B6,y
					LDA $7FFC00
					CMP #$02
					BNE MODE3_G_4
					LDA #$77
					STA $1504,y
MODE3_G_4			LDA #$32
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$13
					STA $00C2,y
					LDA #$FF
					STA $15AC,y
					LDA #$30
					STA $00AA,y
					LDA #$E8
					STA $00B6,y
					LDA #$77
					STA $157C,y
					LDA $7FFC00
					CMP #$03
					BNE MODE3_G_5
					LDA #$77
					STA $1504,y
MODE3_G_5			RTS
					
MODE4				LDA $15AC,x ;#1
					CMP #$F0
					BEQ MODE4_1
					CMP #$C0
					BEQ MODE4_2
					CMP #$90
					BEQ MODE4_3
					CMP #$60
					BEQ MODE4_4_0
					CMP #$50
					BEQ MODE4_5_0
					RTS
MODE4_1				LDA #$32
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$30
					STA $00E4,y
					LDA #$50
					STA $00D8,y
					LDA #$11
					STA $00C2,y
					LDA #$2B
					STA $1DFC
					LDA $7FFC01
					CMP $7FFC00
					BNE MODE4_1_2
					LDA #$77
					STA $1504,y
MODE4_1_2			LDA $7FFC01
					INC A
					STA $7FFC01
					RTS
MODE4_2				LDA #$32
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$60
					STA $00E4,y
					LDA #$50
					STA $00D8,y
					LDA #$11
					STA $00C2,y
					LDA #$2B
					STA $1DFC
					LDA $7FFC01
					CMP $7FFC00
					BNE MODE4_2_2
					LDA #$77
					STA $1504,y
MODE4_2_2			LDA $7FFC01
					INC A
					STA $7FFC01
					RTS
MODE4_4_0			BRA MODE4_4
MODE4_5_0			BRA MODE4_5
MODE4_3				LDA #$32
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$90
					STA $00E4,y
					LDA #$50
					STA $00D8,y
					LDA #$11
					STA $00C2,y
					LDA #$2B
					STA $1DFC
					LDA $7FFC01
					CMP $7FFC00
					BNE MODE4_3_2
					LDA #$77
					STA $1504,y
MODE4_3_2			LDA $7FFC01
					INC A
					STA $7FFC01
					RTS
MODE4_4				LDA #$32
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$C0
					STA $00E4,y
					LDA #$50
					STA $00D8,y
					LDA #$11
					STA $00C2,y
					LDA #$2B
					STA $1DFC
					LDA $7FFC01
					CMP $7FFC00
					BNE MODE4_4_2
					LDA #$77
					STA $1504,y
MODE4_4_2			RTS
MODE4_5				LDA #$FF
					STA $15AC,x
					LDA #$06
					STA $C2,x
					RTS
					
MODE5				LDA $15AC,x ;#1
					CMP #$E0
					BEQ MODE5_2
					CMP #$80
					BEQ MODE5_3
					RTS
MODE5_3				LDA #$FF
					STA $15AC,x
					LDA #$06
					STA $C2,x
					RTS
MODE5_2				LDA #$6A
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$00
					STA $157C,y
					LDA #$40
					STA $00E4,y
					LDA #$C0
					STA $00D8,y
					LDA #$10
					STA $00C2,y
					LDA #$FF
					STA $15AC,y
					LDA #$6A
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$01
					STA $157C,y
					LDA #$40
					STA $00E4,y
					LDA #$C0
					STA $00D8,y
					LDA #$40
					STA $1504,y
					LDA #$10
					STA $00C2,y
					LDA #$FF
					STA $15AC,y
					LDA #$6A
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$00
					STA $157C,y
					LDA #$C0
					STA $00E4,y
					LDA #$C0
					STA $00D8,y
					LDA #$10
					STA $00C2,y
					LDA #$FF
					STA $15AC,y
					LDA #$6A
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$01
					STA $157C,y
					LDA #$C0
					STA $00E4,y
					LDA #$C0
					STA $00D8,y
					LDA #$40
					STA $1504,y
					LDA #$10
					STA $00C2,y
					LDA #$FF
					STA $15AC,y
					RTS
					
MODE6				LDA $1570,x
					LSR A
					LSR A
					AND #$03
					STA $1602,x
					ASL A
					CLC
					ADC $1602,x
					ASL A
					STA $1602,x
					LDA $15AC,x
					CMP #$80
					BEQ MODE6_4
					CMP #$A0
					BCC MODE6_1
					CMP #$BF
					BCC MODE6_2
					RTS
MODE6_1				PHP
					REP #$30
					LDA $7FE301
					SEC
					SBC.W #$421
					STA $7FE301
					PLP
					RTS
MODE6_2				PHP
					REP #$30
					LDA $7FE301
					CLC
					ADC.W #$421
					STA $7FE301
					PLP
					LDA $15AC,x
					CMP #$A1
					BNE MODE6_R
					LDA $94
					CLC
					ADC $1594,x
					AND #$03
					SEC
					ADC $7FFE00
					CMP #$05
					BCC MODE6_3
					SEC
					SBC #$05
MODE6_3				STA $7FFE00
MODE6_R				RTS
MODE6_4				LDA #$60
					STA $15AC,x
					STZ $C2,x
					JSR HDMA_COLOR
					LDA #$00
					STA $7FFC01
					LDA $1594,x
					AND #$03
					STA $7FFC00
					RTS

MODE7				LDA $1463
					BNE MODE7_C1
					LDA $1540,x
					BNE MODE7_B
					LDA $15AC,x
					CMP #$D0
					BEQ MODE7_1
					CMP #$C1
					BCS MODE7_R
					CMP #$C0
					BEQ MODE7_2
					CMP #$B1
					BCS MODE7_3
					CMP #$B0
					BEQ MODE7_2
					CMP #$A1
					BCS MODE7_3
					CMP #$A0
					BEQ MODE7_2
					CMP #$20
					BEQ MODE7_5
MODE7_R				RTS
MODE7_1				LDA #$1E
					STA $1DFB
					JSR SPRITE_DEL1
					LDA #$07
					STA $7FFE00
					RTS
MODE7_2				PHP
					REP #$30
					LDA #$7FFF
					STA $0701
					PLP
					LDA #$18
					STA $1DFC
					RTS
MODE7_3				PHP
					REP #$30
					SEC
					LDA $0701
					SBC.W #$0842
					STA $0701
					PLP
					LDA #$00
					STA $7FFE01
					RTS
MODE7_5				LDA #$FF
					STA $1540,x
					STA $1887
					RTS
MODE7_C1			BRA MODE7_C
MODE7_B				CMP #$40
					BEQ MODE7_6
					CMP #$40
					BCC MODE7_7
					AND #$0F
					BEQ MODE7_4
					RTS
MODE7_4				LDA #$32
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$14
					STA $00C2,y
					LDA #$18
					STA $15AC,y
					LDA #$18
					STA $1DFC
					PHX
					LDA $7FFE01
					TAX
					LDA X_POS1,x
					STA $00E4,y
					LDA Y_POS1,x
					STA $00D8,y
					PLX
					LDA $7FFE01
					INC A
					STA $7FFE01
					RTS
MODE7_6				LDA #$17
					STA $1DFC
					RTS
MODE7_7				LDA $7FE301
					CMP #$FF
					BEQ MODE7_8
					PHP
					REP #$30
					LDA $7FE301
					CLC
					ADC.W #$0421
					STA $7FE301
					PLP
					RTS
MODE7_8				PHP
					REP #$30
					LDA $94
					CLC
					ADC.W #$0010
					STA $94
					LDA $1462
					CLC
					ADC.W #$0010
					STA $1462
					PLP
					RTS
MODE7_C				LDA $7FE301
					BEQ MODE7_D
					PHP
					REP #$30
					LDA $7FE301
					SEC
					SBC.W #$0421
					STA $7FE301
					PLP
					LDA #$FF
					STA $15AC,x
					RTS
MODE7_D				LDA $15AC,x
					CMP #$80
					BEQ MODE7_D2
					RTS
MODE7_D2			LDA #$00
					STA $7FFE00
					PHP
					REP #$30
					LDA #$2485
					STA $0701
					PLP
					JSR GAGE_RESET2
					
					LDA #$32
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$20
					STA $00C2,y
					LDA #$80
					STA $00E4,y
					LDA #$01
					STA $14E0,y
					LDA #$D8
					STA $00D8,y
					LDA #$80
					STA $15AC,y
					TYA
					STA $7FD000
					LDA #$32
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$21
					STA $00C2,y
					LDA #$00
					STA $157C,y
					LDA #$90
					STA $00E4,y
					LDA #$01
					STA $14E0,y
					LDA #$D0
					STA $00D8,y
					TYA
					STA $7FD001
					LDA #$32
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$22
					STA $00C2,y
					LDA #$70
					STA $00E4,y
					LDA #$01
					STA $14E0,y
					LDA #$D8
					STA $00D8,y
					TYA
					STA $7FD002
					LDA #$32
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$23
					STA $00C2,y
					LDA #$01
					STA $157C,y
					LDA #$60
					STA $00E4,y
					LDA #$01
					STA $14E0,y
					LDA #$D0
					STA $00D8,y
					TYA
					STA $7FD003
					LDA #$60
					STA $15AC,y
					JSR LAYER2_DEL
					STZ $14C8,x
					RTS
					
Y_POS1				dcb $D0,$C0,$E0,$C0,$F0,$E0,$C0,$F0,$E0,$F0,$B0,$D0
X_POS1				dcb $70,$60,$90,$80,$90,$60,$78,$68,$88,$90,$78,$60

Y_MAGIC             dcb $6C,$6C,$3C,$3C,$E8,$E8,$F4,$F4
X_MAGIC             dcb $20,$E0,$30,$D0
SPEED_DEC1			LDA $1602,x 
					PHA
					LDA $1504,x
					PHA
					PHY
					JSR SUB_GET_X_DIFF
					JSR SUB_GET_Y_DIFF
					PLY
					PHX                     ; \ set y speed of fire ball
                    LDA $1602,x             ;  |
                    ASL A                   ;  |
                    ASL A                   ;  |
                    ORA $1504,x             ;  |
                    TAX                     ;  |
                    LDA Y_MAGIC,x            ;  |
                    STA $00AA,y
                    PLX                     ; /     
                    PHX                     ; \  set x speed of fire ball
                    LDA $1504,x             ;  |
                    TAX                     ;  |
                    LDA X_MAGIC,x            ;  |
                    STA $00B6,y
                    PLX
					PLA
					STA $1504,x
					PLA
					STA $1602,x
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; difference in y position
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_GET_Y_DIFF      LDY #$00                
                    LDA $D3                 
                    PHA
                    CLC                     
                    ADC #$10                
                    STA $D3                 
                    LDA $D4                 
                    PHA
                    ADC #$00                
                    STA $D4                 

                    LDA $D3                 
                    SEC                     
                    SBC $D8,x               
                    STA $0E                 
                    LDA $D4                 
                    SBC $14D4,x             
                    BPL LABEL14            
                    INY                     
LABEL14             TYA                     ;  | 
                    STA $1602,x 
                    
                    PLA
                    STA $D4
                    PLA
                    STA $D3
                    RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; difference in x position
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   

SUB_GET_X_DIFF      LDY #$00                
                    LDA $D1                 
                    SEC                    
                    SBC $E4,x              
                    STA $0F                 
                    LDA $D2                 
                    SBC $14E0,x            
                    BPL TO_RIGHT            
TO_LEFT             INY                     
                    LDA $0F
                    CMP #$B0
                    BCS SET_VAL
                    INY
                    INY                 
                    BRA SET_VAL
TO_RIGHT            LDA $0F
                    CMP #$50
                    BCC SET_VAL
                    INY
                    INY 
SET_VAL             TYA
                    STA $1504,x
                    RTS         
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP             dcb $8E,$8E,$AE,$AE,$CE,$CE
					dcb $8A,$8A,$AA,$AA,$CA,$CA
					dcb $8C,$8C,$AC,$AC,$CC,$CC
					dcb $8A,$8A,$AA,$AA,$CA,$CA
					dcb $88,$88,$A8,$A8,$C8,$C8
X_OFFSET            dcb $F8,$08,$F8,$08,$F8,$08,
Y_OFFSET            dcb $00,$00,$10,$10,$20,$20
PROPETIES           dcb $00,$40,$00,$40,$00,$40

SUB_GFX_R			RTS
SUB_GFX 			JSR GET_DRAW_INFO
					LDA $7FFE00
					CMP #$07
					BEQ SUB_GFX_R
					LDA $1602,x
					STA $03
					
	                PHX                     ; push sprite index

                    LDX #$05                ; loop counter = (number of tiles per frame) - 1
LOOP_START          LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
					CLC
					ADC X_OFFSET,x
                    STA $0300,y             ; /
					
					
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
					CLC
					ADC Y_OFFSET,x
                    STA $0301,y             ; /
                    
                    PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILEMAP,x
                    STA $0302,y             ; /
        			PLX
					
					PHX
                    LDA PROPETIES,x
                    ORA #$06
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    
                    LDY #$02                ; \ 02, because we didn't write to 460 yet
                    LDA #$05                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen

                    RTS                    
					
TILEMAP3            dcb $80,$82,$A0,$A2
X_OFFSET3           dcb $F8,$08,$F8,$08
Y_OFFSET3           dcb $00,$00,$10,$10

SUB_GFX3 			JSR GET_DRAW_INFO
	                PHX                     ; push sprite index
                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START3         LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
					CLC
					ADC X_OFFSET3,x
                    STA $0300,y             ; /
					
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
					CLC
					ADC Y_OFFSET3,x
                    STA $0301,y             ; /
                    
					LDA TILEMAP3,x
                    STA $0302,y             ; /
					
					LDA #$0C
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties
                    
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START3          ; / 

                    PLX                     ; pull, X = sprite index
                    
                    LDY #$02                ; \ 02, because we didn't write to 460 yet
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen

                    RTS 
					
TILEMAP4            dcb $84,$86,$A4,$A6
TILEMAP4_2			dcb $42,$44,$62,$64
TILEMAP4_3			dcb $48,$4A,$68,$6A
X_OFFSET4           dcb $F8,$08,$F8,$08
Y_OFFSET4           dcb $F8,$F8,$08,$08

SUB_GFX4 			JSR GET_DRAW_INFO
	                LDA $C2,x
					STA $02
					PHX                     ; push sprite index
                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START4         LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
					CLC
					ADC X_OFFSET4,x
                    STA $0300,y             ; /
					
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
					CLC
					ADC Y_OFFSET4,x
                    STA $0301,y             ; /
                    
					LDA $02
					AND #$20
					BEQ SUB_GFX4_1
					LDA TILEMAP4_3,x
                    STA $0302,y             ; /
					
					LDA #$0F
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y
					BRA SUB_GFX4_3
					
SUB_GFX4_1			LDA $02
					CMP #$14
					BNE SUB_GFX4_2
					LDA TILEMAP4_2,x
                    STA $0302,y             ; /
					
					LDA #$03
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y
					BRA SUB_GFX4_3
					
SUB_GFX4_2			LDA TILEMAP4,x
                    STA $0302,y             ; /
					
					LDA #$08
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties
SUB_GFX4_3		
                    
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START4          ; / 

                    PLX                     ; pull, X = sprite index
                    
                    LDY #$02                ; \ 02, because we didn't write to 460 yet
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen

                    RTS
					
					
SUB_GFX5			LDA $1602,x
					BNE SUB_GFX5_2
					JMP SUB_GFXH1

SUB_GFX5_2			CMP #$01
					BNE SUB_GFX5_3
					JMP SUB_GFXH2

SUB_GFX5_3			JMP SUB_GFXH3

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_GFX2            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder 
											
                    PHX                     ; push sprite index

                    LDA $00                 ; \ tile x position = sprite x location ($00)
                    STA $0300,y             ; /                    
                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y             ; /
                                 
					LDA $7FEEEC
                    STA $0302,y             ; / 

                    LDA $7FEEED
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties

                    PLX                     ; pull, X = sprite index
                    
                    LDY #$02
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
TILEMAP3            dcb $80,$82,$A0,$A2
X_OFFSET3           dcb $F8,$08,$F8,$08
Y_OFFSET3           dcb $00,$00,$10,$10

SUB_GFX3 			JSR GET_DRAW_INFO
	                PHX                     ; push sprite index
                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START3         LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
					CLC
					ADC X_OFFSET3,x
                    STA $0300,y             ; /
					
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
					CLC
					ADC Y_OFFSET3,x
                    STA $0301,y             ; /
                    
					LDA TILEMAP3,x
                    STA $0302,y             ; /
					
					LDA #$0C
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties
                    
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START3          ; / 

                    PLX                     ; pull, X = sprite index
                    
                    LDY #$02                ; \ 02, because we didn't write to 460 yet
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen

                    RTS
					
TILEMAPH1           dcb $06,$08,$26,$28
X_OFFSETH1          dcb $F8,$08,$F8,$08
					dcb $08,$F8,$08,$F8
Y_OFFSETH1          dcb $F8,$F8,$08,$08
PROPETIESH1			dcb $0F,$4F

SUB_GFXH1 			JSR GET_DRAW_INFO
					LDA $157C,x
					STA $02
	                PHX                     ; push sprite index
                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_STARTH1        LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
					CLC
					ADC Y_OFFSETH1,x
                    STA $0301,y             ; /
                    
					LDA TILEMAPH1,x
                    STA $0302,y             ; /
					
					PHX
					TXA
					CLC
					ADC $02
					ADC $02
					ADC $02
					ADC $02
					TAX
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
					CLC
					ADC X_OFFSETH1,x
                    STA $0300,y 
					LDX $02
					LDA PROPETIESH1,x
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties
                    PLX
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_STARTH1          ; / 

                    PLX                     ; pull, X = sprite index
                    
                    LDY #$02                ; \ 02, because we didn't write to 460 yet
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen

                    RTS
					

					
TILEMAPH2           dcb $00,$02,$20,$22,$24
X_OFFSETH2          dcb $F8,$08,$F8,$08,$18
					dcb $08,$F8,$08,$F8,$E8
Y_OFFSETH2          dcb $00,$F8,$10,$08,$08
PROPETIESH2			dcb $0F,$4F

SUB_GFXH2 			JSR GET_DRAW_INFO
					LDA $157C,x
					STA $02
	                PHX                     ; push sprite index
                    LDX #$04                ; loop counter = (number of tiles per frame) - 1
LOOP_STARTH2        LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
					CLC
					ADC Y_OFFSETH2,x
                    STA $0301,y             ; /
                    
					LDA TILEMAPH2,x
                    STA $0302,y             ; /
					
					PHX
					TXA
					CLC
					ADC $02
					ADC $02
					ADC $02
					ADC $02
					ADC $02
					TAX
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
					CLC
					ADC X_OFFSETH2,x
                    STA $0300,y 
					LDX $02
					LDA PROPETIESH2,x
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties
                    PLX
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_STARTH2          ; / 

                    PLX                     ; pull, X = sprite index
                    
                    LDY #$02                ; \ 02, because we didn't write to 460 yet
                    LDA #$04                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen

                    RTS
					
TILEMAPH3           dcb $0A,$0C,$2A,$2C,$04
X_OFFSETH3          dcb $F8,$08,$F8,$08,$08
					dcb $08,$F8,$08,$F8,$F8
Y_OFFSETH3          dcb $F8,$F8,$08,$08,$E8
PROPETIESH3			dcb $0F,$4F

SUB_GFXH3 			JSR GET_DRAW_INFO
					LDA $157C,x
					STA $02
	                PHX                     ; push sprite index
                    LDX #$04                ; loop counter = (number of tiles per frame) - 1
LOOP_STARTH3        LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
					CLC
					ADC Y_OFFSETH3,x
                    STA $0301,y             ; /
                    
					LDA TILEMAPH3,x
                    STA $0302,y             ; /
					
					PHX
					TXA
					CLC
					ADC $02
					ADC $02
					ADC $02
					ADC $02
					ADC $02
					TAX
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
					CLC
					ADC X_OFFSETH3,x
                    STA $0300,y 
					LDX $02
					LDA PROPETIESH3,x
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties
                    PLX
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_STARTH3          ; / 

                    PLX                     ; pull, X = sprite index
                    
                    LDY #$02                ; \ 02, because we didn't write to 460 yet
                    LDA #$04                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen

                    RTS
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; generate sprite
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURNK68           RTS     
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURNK68            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    PHX
					TYX
					LDA $7FEEEE
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
                    LDA $E4,x               ;\ set x position for new sprite
                    STA $00E4,y

                    LDA $14E0,x             ;  |
                    STA $14E0,y             ; /

                    LDA $D8,x               ;\ set y position for new sprite
					STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
					STA $14D4,y             ; /

                    PHX
                    TYX
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; generate sprite
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RETURNK67           RTS     
GEN_NORMAL          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURNK67            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    LDA $7FEEEE
                    STA $009E,y
                    
                    LDA $E4,x               ;\ set x position for new sprite
                    STA $00E4,y

                    LDA $14E0,x             ;  |
                    STA $14E0,y             ; /

                    LDA $D8,x               ;\ set y position for new sprite
					STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
					STA $14D4,y             ; /

                    PHX
                    TYX
                    JSL $07F7D2             ;  
                    PLX
                    RTS                     ; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
					
					
					
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; HTML
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
LAYER3_DEL			LDA #$40
					STA $7FFB30
					LDA #$02
					STA $7FFB31
					LDA #$11
					STA $7FFB32
					LDA #$00
					STA $7FFB33
					LDA #$E1
					STA $7FFB34
					LDA #$7F
					STA $7FFB35
					LDA #$0F
					STA $7FE100
					LDA #$00
					STA $7FE101
					LDA #$00
					STA $7FE102
					LDA #$80
					STA $7FE103
					LDA #$00
					STA $7FE104
					LDA #$01
					STA $7FE105
					LDA #$00
					STA $7FE106
HDMA_R2				RTS

LAYER2_DEL			LDA #$20
					STA $7FFB28
					LDA #$00
					STA $7FFB29
					LDA #$23
					STA $7FFB2A
					LDA #$00
					STA $7FFB2B
					LDA #$E4
					STA $7FFB2C
					LDA #$7F
					STA $7FFB2D
					LDA #$01
					STA $7FE400
					LDA #$30
					STA $7FE401
					LDA #$00
					STA $7FE402
					RTS
					
HDMA_LAYER1			LDA #$20
					STA $7FFB28
					LDA #$00
					STA $7FFB29
					LDA #$23
					STA $7FFB2A
					LDA #$00
					STA $7FFB2B
					LDA #$E4
					STA $7FFB2C
					LDA #$7F
					STA $7FFB2D
					LDA #$01
					STA $7FE400
					LDA #$03
					STA $7FE401
					LDA #$01
					STA $7FE402
					LDA #$03
					STA $7FE403
					LDA #$01
					STA $7FE404
					LDA #$00
					STA $7FE405
					STA $7FE406
					RTS
					
HDMA_BLK			LDA #$08
					STA $7FFB18
					LDA #$00
					STA $7FFB19
					LDA #$00
					STA $7FFB1A
					LDA #$00
					STA $7FFB1B
					LDA #$E2
					STA $7FFB1C
					LDA #$7F
					STA $7FFB1D
					LDA #$01
					STA $7FE200
					LDA #$00
					STA $7FE201
					STA $7FE202
					RTS
					
HDMA_COLOR			LDA #$08
					STA $7FFB18
					LDA #$10
					STA $7FFB20
					LDA #$00
					STA $7FFB19
					LDA #$02
					STA $7FFB21
					LDA #$21
					STA $7FFB1A
					LDA #$22
					STA $7FFB22
					LDA #$00
					STA $7FFB1B
					STA $7FFB23
					LDA #$E2
					STA $7FFB1C
					LDA #$E3
					STA $7FFB24
					LDA #$7F
					STA $7FFB1D
					STA $7FFB25
					
					LDA #$01
					STA $7FE200
					STA $7FE300
					LDA #$00
					STA $7FE201
					LDA #$00
					STA $7FE301
					LDA #$00
					STA $7FE302
					LDA #$00
					STA $7FE202
					STA $7FE303
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GAGE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CHECK_DAMAGE_C		LDA $E4,x
					CMP #$18
					BEQ DAMAGE_C_2
					CMP #$58
					BEQ DAMAGE_C_3
					CMP #$98
					BEQ DAMAGE_C_4
					CMP #$D8
					BEQ DAMAGE_C_5
					RTS
DAMAGE_C_2			LDA $94
					CMP #$48
					BCS DAMAGE_C_R
					LDA $1497
					BNE DAMAGE_C_R
					JSL $00F5B7
DAMAGE_C_R			RTS
DAMAGE_C_3			LDA $94
					CMP #$48
					BCC DAMAGE_C_R
					CMP #$88
					BCS DAMAGE_C_R
					LDA $1497
					BNE DAMAGE_C_R
					JSL $00F5B7
					RTS
DAMAGE_C_4			LDA $94
					CMP #$88
					BCC DAMAGE_C_R
					CMP #$C8
					BCS DAMAGE_C_R
					LDA $1497
					BNE DAMAGE_C_R
					JSL $00F5B7
					RTS
DAMAGE_C_5			LDA $94
					CMP #$C8
					BCC DAMAGE_C_R
					LDA $1497
					BNE DAMAGE_C_R
					JSL $00F5B7
					RTS



DAMAGE_CHECK_B		JSL $01A7DC
					BCC DAMAGE_CHECK_B_R
					LDA $7D
					CMP #$80
					BCS ENE_WIN_B
					CMP #$10
					BCC ENE_WIN_B
					LDA #$B0
					STA $7D
					JSL $01AB99             ; display contact graphic
					LDA #$08
                    STA $1DF9
					JSR SUB_SMOKE
					STZ $14C8,x
DAMAGE_CHECK_B_R	RTS
ENE_WIN_B			LDA $1497
					BNE DAMAGE_CHECK_B_R
					JSL $00F5B7
					RTS

MARIO_CHECK			LDA $151C,x
					BNE MARIO_CHECK_R
					JSL $01A7DC
					BCC MARIO_CHECK_R
					LDA $7D
					CMP #$80
					BCS MARIO_CHECK_R
					CMP #$10
					BCC MARIO_CHECK_R
					LDA $140D
					BEQ MARIO_CHECK_R
					LDA #$B0
					STA $7D
					JSL $01AB99             ; display contact graphic
					LDA #$20
                    STA $1DF9
					LDA #$01
					STA $151C,x
					INC $1528,x
					JSR GAGE2_CHECK
MARIO_CHECK_R		RTS


CHECK1_R			RTS
DAMAGE_CHECK1		LDA $C2,x
					CMP #$07
					BEQ CHECK1_R
					TXY
					PHX
					LDX #$00
CHECK1_L			LDA $9E,x
					CMP #$53
					BNE CHECK1_2
					LDA $14C8,x
					CMP #$09
					BCC CHECK1_2
					LDA $E4,x
					CMP #$68
					BCC CHECK1_2
					CMP #$89
					BCS CHECK1_2
					LDA $14D4,x
					BNE CHECK1_2
					LDA $D8,x
					CMP #$90
					BCC CHECK1_2
					CMP #$A1
					BCS CHECK1_2
					STZ $14C8,x
					LDA $E4,x
					STA $7FFCE4
					LDA #$28
					STA $1DFC
					LDA $1528,y
					INC A
					STA $1528,y
CHECK1_2			INX
					CPX #$0A
					BNE CHECK1_L
					PLX
					LDA $1528,x
					CMP #$04
					BCS CHECK1_3
					RTS
CHECK1_3			LDA #$FF
					STA $15AC,x
					LDA #$07
					STA $C2,x
					JSR HDMA_COLOR
					RTS



GAGE_RESET			LDA #$01
					STA $7FFFDF
					LDA #$0B
					STA $7FFFE0
					LDA #$18
					STA $7FFFE1
					LDA #$1C
					STA $7FFFE2
					LDA #$1C
					STA $7FFFE3
					LDA #$FC
					STA $7FFFE4
					LDA #$44
					STA $7FFFE5
					LDA #$44
					STA $7FFFE6
					LDA #$44
					STA $7FFFE7
					LDA #$44
					STA $7FFFE8
					LDA #$FC
					STA $7FFFE9
					LDA #$FC
					STA $7FFFEA
					LDA #$FC
					STA $7FFFEB
					LDA #$FC
					STA $7FFFEC
					LDA #$FC
					STA $7FFFED
					LDA #$FC
					STA $7FFFEE
					LDA #$FC
					STA $7FFFEF
					RTS
					
GAGE_RESET2			LDA #$01
					STA $7FFFDF
					LDA #$0B
					STA $7FFFE0
					LDA #$18
					STA $7FFFE1
					LDA #$1C
					STA $7FFFE2
					LDA #$1C
					STA $7FFFE3
					LDA #$FC
					STA $7FFFE4
					LDA #$44
					STA $7FFFE5
					LDA #$44
					STA $7FFFE6
					LDA #$44
					STA $7FFFE7
					LDA #$44
					STA $7FFFE8
					LDA #$44
					STA $7FFFE9
					LDA #$44
					STA $7FFFEA
					LDA #$44
					STA $7FFFEB
					LDA #$44
					STA $7FFFEC
					LDA #$FC
					STA $7FFFED
					LDA #$FC
					STA $7FFFEE
					LDA #$FC
					STA $7FFFEF
					RTS

GAGE_CHECK			LDA $1528,x
					CMP #$01
					BEQ GAGE_CHECK2
					CMP #$02
					BEQ GAGE_CHECK3
					CMP #$03
					BEQ GAGE_CHECK4
					CMP #$04
					BEQ GAGE_CHECK5
					RTS
GAGE_CHECK2			LDA #$FC
					STA $7FFFE8
					RTS
GAGE_CHECK3			LDA #$FC
					STA $7FFFE7
					RTS
GAGE_CHECK4			LDA #$FC
					STA $7FFFE6
					RTS
GAGE_CHECK5			LDA #$FC
					STA $7FFFE5
					RTS

GAGE2_CHECK			LDA $1528,x
					CMP #$01
					BEQ GAGE2_CHECK2
					CMP #$02
					BEQ GAGE2_CHECK3
					CMP #$03
					BEQ GAGE2_CHECK4
					CMP #$04
					BEQ GAGE2_CHECK5
					CMP #$05
					BEQ GAGE2_CHECK6
					CMP #$06
					BEQ GAGE2_CHECK7
					CMP #$07
					BEQ GAGE2_CHECK8
					CMP #$08
					BEQ GAGE2_CHECK9
					RTS
GAGE2_CHECK2		LDA #$FC
					STA $7FFFEC
					RTS
GAGE2_CHECK3		LDA #$FC
					STA $7FFFEB
					RTS
GAGE2_CHECK4		LDA #$FC
					STA $7FFFEA
					RTS
GAGE2_CHECK5		LDA #$FC
					STA $7FFFE9
					RTS
GAGE2_CHECK6		LDA #$FC
					STA $7FFFE8
					RTS
GAGE2_CHECK7		LDA #$FC
					STA $7FFFE7
					RTS
GAGE2_CHECK8		LDA #$FC
					STA $7FFFE6
					RTS
GAGE2_CHECK9		LDA #$FC
					STA $7FFFE5
					LDA #$1E
					STA $1DFB
					LDA #$FF
					STA $1540,x
					RTS

SPRITE_DEL1			STX $03
					PHX
					LDX #$00
DEL1_L				CPX $03
					BEQ DEL1_2
					STZ $14C8,x
DEL1_2				INX
					CPX #$0A
					BNE DEL1_L
					PLX
					RTS
					
Y_POSF				dcb $D0,$C0,$E0,$C0,$F0,$E0,$C0,$F0,$E0,$F0,$B0,$D0
X_POSF				dcb $70,$40,$B0,$50,$90,$30,$A8,$68,$C8,$30,$78,$60

FINAL				LDA #$09
					STA $7FC004
					LDA $1558,x
					BNE FINAL3_0
					LDA $1540,x
					CMP #$BF
					BEQ FINAL1
					CMP #$B0
					BEQ FINAL_G
					CMP #$90
					BEQ FINAL_G
					CMP #$70
					BEQ FINAL_G
					CMP #$58
					BEQ FINAL_G
					CMP #$40
					BEQ FINAL_G
					CMP #$30
					BEQ FINAL_G
					CMP #$20
					BEQ FINAL_G
					CMP #$10
					BEQ FINAL_G
					CMP #$01
					BEQ FINAL2
					RTS
FINAL2				LDA #$FF
					STA $1558,x
					RTS
FINAL1				STZ $1466
					STZ $1467
					LDA #$60
					STA $1468
					JSR SPRITE_DEL1
					PHP
					REP #$30
					LDA #$7FFF
					STA $0701
					PLP
					LDA #$01
					STA $7FD010
					STZ $1570,x
					RTS
FINAL3_0			BRA FINAL3
FINAL_G				LDA #$32
					STA $7FEEEE
					JSR GEN_SPRITE
					LDA #$14
					STA $00C2,y
					LDA #$18
					STA $15AC,y
					LDA #$18
					STA $1DFC
					PHX
					LDA $1570,x
					TAX
					LDA X_POSF,x
					STA $00E4,y
					LDA #$01
					STA $14E0,y
					LDA Y_POSF,x
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					PLX
					INC $1570,x
FINAL_R				RTS
FINAL3				LDA $1558,x
					CMP #$F0
					BCS FINAL_R
					CMP #$EF
					BEQ FINAL4
					CMP #$D0
					BCS FINAL5
					CMP #$CF
					;BEQ FINAL6
					BEQ FINAL_R
					LDA #$0B
					STA $7FC004
					LDA #$01
					STA $00212F
					LDA $1558,x
					CMP #$B0
					BCS FINAL7
					CMP #$90
					BCS FINAL_R
					CMP #$8F
					BEQ FINAL8
					CMP #$90
					BCS FINAL_R
					CMP #$12
					BCS FINAL9
					CMP #$01
					BEQ FINALA
					RTS
FINAL4				LDA #$17
					;STA $1DFC
					LDA #$01
					STA $002126
					STA $002127
					RTS
FINAL5				PHP
					REP #$30
					LDA $7FE301
					CLC
					ADC.W #$0421
					STA $7FE301
					PLP
					RTS
FINAL7				LDA #$0B
					STA $7FC004
					PHP
					REP #$30
					LDA $7FE301
					SEC
					SBC.W #$0421
					STA $7FE301
					PLP
					RTS
FINAL8				JSR HDMA_LAYER1
					LDA #$17
					STA $1DFC
					RTS
FINAL9				LDA $7FE400
					INC A
					STA $7FE400
					LDA $7FE402
					INC A
					STA $7FE402
					RTS
FINALA				JSR HDMA_BLK
					LDA #$10
                    STA $13C6
                    STA $1493
					STZ $14C8,x
					RTS

