;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; bigwanwan
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;      
                    dcb "INIT"
					STZ $1528,x
					LDA #$50
					STA $15AC,x
					STZ $151C,x
					LDA #$01
					STA $157C,x
					STZ $C2,x
					STZ $14F8,x
                    RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                     ; return           
CODE_START          LDA #$06
					STA $00212C
					LDA #$11
					STA $00212D
					LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
					JSR DAMAGE_CHECK
					JSR MARIO_CHECK
					JSL $01802A 
                    JSR LAYER2
					LDA $1528,x
					BNE NOT_MODE0
					JSR MODE0
					RTS
NOT_MODE0			CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$02
					BNE NOT_MODE2
					JSR MODE2
					RTS
NOT_MODE2			CMP #$03
					BNE NOT_MODE3
					JSR MODE3
					RTS
NOT_MODE3			CMP #$04
					BNE NOT_MODE4
					JSR MODE4
					RTS
NOT_MODE4			JSR MODE5
					RTS
       
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X_SPEED_M			dcb $30,$D0

MODE0				LDA $15AC,x
					CMP #$20
					BCS MODE0_2
					CMP #$1F
					BEQ MODE0_3
					LDA $1588,x
					AND #$04
					BEQ MODE0_E
					LDA #$20
					STA $1887
					LDA $C2,x
					BEQ MODE0_4
					LDA #$01
					STA $1528,x
					LDA #$FF
					STA $15AC,x
					STZ $C2,x
MODE0_E				RTS
MODE0_2				STZ $AA,x
					STZ $B6,x
					RTS
MODE0_3				LDA #$2B
					STA $1DFC
					RTS
MODE0_4				LDA #$01
					STA $C2,x
					LDA #$D0
					STA $AA,x
					LDA #$09
					STA $1DFC
					RTS


MODE1				JSR DAMAGE_CHECK
					TYA
					BNE MODE1_R
					LDA $15AC,x
					BEQ MODE1_2
					CMP #$D0
					BEQ MODE1_G
					CMP #$40
					BEQ MODE1_G2
					RTS
MODE1_G				LDA #$09
					STA $1DFC
					JSR NORMAL_GEN
					LDA $157C,x
					STA $157C,y
					RTS
MODE1_G2			JSR FIRE_GEN
					LDA #$01
					STA $1594,y
					LDA $157C,x
					STA $157C,y
					TYA
					STA $1504,x
					RTS
MODE1_2				PHX
					LDA $1504,x
					TAX
					LDA $14C8,x
					BNE MODE1_2_2
					PLX
					LDA #$50
					STA $15AC,x
					RTS
MODE1_2_2			PLX
					RTS
MODE1_R				LDA #$02
					STA $1528,x
					LDA #$40
					STA $15AC,x
					LDA #$01
					STA $14AF
					LDA #$28
					STA $1DFC
					INC $151C,x
					PHX
					LDA $1504,x
					TAX
					STZ $14C8,x
					PLX
					RTS
					
MODE2				LDA $15AC,x
					BEQ MODE2_2
					CMP #$01
					BEQ MODE2_1
MODE2_E				RTS
MODE2_1				LDA #$F8
					STA $B6,x
					LDA #$B0
					STA $AA,x
					STZ $C2,x
					RTS
MODE2_2				LDA $C2,x
					CMP #$05
					BEQ MODE2_3
					LDA $E4,x
					CMP #$70
					BNE MODE2_2_2
					STZ $B6,x
MODE2_2_2			LDA $1588,x
					AND #$04
					BEQ MODE2_E
					INC $C2,x
					LDA #$20
					STA $1887
					LDA #$09
					STA $1DFC
					LDA $C2,x
					CMP #$05
					BEQ MODE2_3
					LDA #$B0
					STA $AA,x
					RTS
MODE2_3				STZ $B6,x
					LDA #$B0
					STA $AA,x
					LDA $14D4,x
					BNE MODE2_E
					LDA $D8,x
					CMP #$B0
					BCC MODE2_4
					RTS
MODE2_4				STZ $C2,x
					STZ $14AF
					STZ $AA,x
					STZ $1528,x
					LDA #$F0
					STA $E4,x
					LDA #$80
					STA $15AC,x
					LDA $151C,x
					CMP #$02
					BEQ MODE2_5
					RTS
MODE2_5				LDA #$03
					STA $1528,x
					LDA #$70
					STA $E4,x
					INC $151C,x
					STZ $157C,x
					RTS
					
MODE3				LDA $15AC,x
					CMP #$20
					BCS MODE3_2
					CMP #$1F
					BEQ MODE3_3
					LDA $1588,x
					AND #$04
					BEQ MODE3_E
					LDA #$20
					STA $1887
					LDA $C2,x
					BEQ MODE3_4
					LDA #$04
					STA $1528,x
					LDA #$90
					STA $15AC,x
					STZ $C2,x
					LDA #$B0
					STA $AA,x
MODE3_E				RTS
MODE3_2				STZ $AA,x
					STZ $B6,x
					RTS
MODE3_3				LDA #$2B
					STA $1DFC
					RTS
MODE3_4				LDA #$01
					STA $C2,x
					LDA #$D0
					STA $AA,x
					LDA #$09
					STA $1DFC
					RTS

MODE4				LDA $1588,x
					AND #$04
					BEQ MODE4_0
					LDA #$20
					STA $1887
					LDA #$09
					STA $1DFC
					LDA #$A0
					STA $AA,x
MODE4_0				JSR DAMAGE_CHECK
					TYA
					BNE MODE4_R
					LDA $15AC,x
					BEQ MODE4_2
					CMP #$40
					BEQ MODE4_G2
					RTS
MODE4_G2			JSR FIRE_GEN
					LDA #$01
					STA $1594,y
					LDA $157C,x
					STA $157C,y
					TYA
					STA $1504,x
					RTS
MODE4_2				PHX
					LDA $1504,x
					TAX
					LDA $14C8,x
					BNE MODE4_2_2
					PLX
					LDA #$50
					STA $15AC,x
					RTS
MODE4_2_2			PLX
					RTS
MODE4_R				LDA #$05
					STA $1528,x
					LDA #$A0
					STA $15AC,x
					LDA #$28
					STA $1DFC
					LDA #$1E
					STA $1DFB
					PHX
					LDA $1504,x
					TAX
					STZ $14C8,x
					PLX
					RTS
					
MODE5				LDA $15AC,x
					BEQ MODE5_3
					CMP #$60
					BEQ MODE5_2
					RTS
MODE5_2				LDA #$FF
					STA $14AD
					RTS
MODE5_3				LDA #$0B
                    STA $1DFB
					LDA #$FF
                    STA $13C6
                    STA $1493
					STZ $14C8,x
					RTS


DAMAGE_E			PLX
DAMAGE_R			RTS
DAMAGE_CHECK        LDY #$00
					PHX
					LDA $1504,x
					TAX
					LDA $14C8,x
					CMP #$08
					BNE DAMAGE_E
					LDA $C2,x
					CMP #$02
					BNE DAMAGE_E
					LDA $14E0,x
					BNE DAMAGE_E
					LDA $D8,x
					STA $02
					LDA $14D4,x
					STA $03
					LDA $E4,x
					STA $0F
					PLX
					LDA $D8,x
					SEC
					SBC $02
					LDA $14D4,x
					SBC $03
					BCC DAMAGE_R
					LDA $E4,x
					SEC
					SBC #$50
					CMP $0F
					BCS DAMAGE_R
					LDA $E4,x
					SEC
					SBC #$10
					CMP $0F
					BCC DAMAGE_R
					LDY #$01
					RTS
					
MARIO_CHECK			LDA $1497
					BNE MARIO_E
					LDA $E4,x
					SEC
					SBC #$60
					CMP $94
					BCS MARIO_E
					LDA $E4,x
					SEC
					SBC #$10
					CMP $94
					BCC MARIO_E
					
					LDA $96
					CLC
					ADC #$10
					STA $02
					LDA $97
					ADC #$00
					STA $03
					LDA $D8,x
					SEC
					SBC $02
					STA $0F
					LDA $14D4,x
					SBC $03
					BCC MARIO_E
					LDA $0F
					CMP #$68
					BCS MARIO_E
					JSL $00F5B7
MARIO_E				RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ETC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
LAYER2				LDA #$F0
					SEC
					SBC $E4,x
					STA $1466
					LDA #$00
					STA $1467
					LDA #$70
					SEC
					SBC $D8,x
					STA $1468
					LDA #$00
					STA $1469
					LDA $151C,x
					CMP #$03
					BCS LAYER2_2
					RTS
LAYER2_2			LDA #$01
					STA $1467
					RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


RETURN67            RTS
FIRE_GEN            JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA #$7C
					TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
                    LDA $E4,x
					SEC
					SBC #$30
                    STA $00E4,y

                    LDA $14E0,x
					SBC #$00
                    STA $14E0,y             ; /

                    LDA $D8,x
					SEC
					SBC #$30
                    STA $00D8,y             ;  |
                    LDA $14D4,x
					SBC #$00
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN68            RTS
NORMAL_GEN          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated
					
					LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    
					LDA #$9F
                    STA $009E,y
                    
                    LDA $E4,x
					SEC
					SBC #$50
                    STA $00E4,y

                    LDA $14E0,x
					SBC #$00
                    STA $14E0,y             ; /

                    LDA $D8,x
					SEC
					SBC #$40
                    STA $00D8,y             ;  |
                    LDA $14D4,x
					SBC #$00
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    PLX
                    RTS                          ; return
