;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Boss Barrel
;;
;; Description: 
;;
;; Uses first extra bit: Yes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    EXTRA_BITS = $7FAB10
                    TIME_TO_LOCK = $40
					NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"
					LDA $13BF
					CMP #$09
					BEQ ROCKET_INI
                    LDA #$01
                    STA $157C,x         ; direction set
                    STZ $15AC,x         ;
					LDA EXTRA_BITS,x
                    AND #$04
					BNE ULTEMA0
                    LDA #$20
                    STA $1558,x
                    LDA #$02
                    STA $7FFF03
					STZ $1528,x
                    RTL
ULTEMA0				STZ $151C,x
					STZ $1570,x
					LDA #$40
					STA $15AC,x
					STZ $1466
					STZ $1467
					LDA #$C8
					STA $1468
					STZ $1469
					STZ $14F8,x
					LDA #$58
					STA $D8,x
					LDA #$99
					STA $1686,x
					LDA #$81
					STA $167A,x
					LDA #$06
					STA $1528,x
					LDA #$31
					STA $40
					RTL
ROCKET_INI			STZ $C2,x
					LDA #$01
					STA $7FFFDF
					LDA #$0F
					STA $7FFFE0
					LDA #$1E
					STA $7FFFE1
					LDA #$0E
					STA $7FFFE2
					LDA #$15
					STA $7FFFE3
					LDA #$0B
					STA $1594,x
					STZ $1570,x
					TXA
					STA $7FF001
					PHX
					LDX $13BF
					LDA $1EA2,x
					PLX
					AND #$40
					BNE MID_INIT
					RTL
MID_INIT			STZ $1594,x
					RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
					LDA $13BF
					CMP #$09
					BEQ ROCKET_CODE
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /
ROCKET_CODE			LDA $C2,x
					BEQ CODE1
					JSR FNISH_CODE
					BRA CODE2
CODE1               JSR SPRITE_CODE_START   ;  |
CODE2               PLB                     ;  |
                    RTL    


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CODE_START          LDA EXTRA_BITS,x
                    AND #$04
                    BEQ BOSSBARREL
					JSR ULTEMA
					RTS
					
BOSSBARREL			JSR SUB_GFX             ; graphics routine #t[OtBbNXV
                    LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
                    LDA $14AF
                    BNE RETURN
                    LDA $163E               ;#nk G̏ꍇ͓悤ɂ
                    BEQ ALIVE
                    LDA $1497
                    BNE ALIVE
                    STZ $7B
                    STZ $7D
                    STZ $13E0
                    BRA ALIVE
RETURN              RTS                     ; return                    
ALIVE               LDA $1558,x             ;#Ȃ
                    BEQ ALIVE2              ;
                    RTS                     ;
ALIVE2              LDA $1528,x
					BEQ ALIVE3
					STZ $AA,x
ALIVE3				JSL $01802A             ; update position based on speed values
					LDA $14D4,x
					BEQ IN_AIR
					LDA $D8,x
					AND #$F0
					CMP #$30
					BNE IN_AIR
					STZ $AA,x
					LDA $1528,x
                    BNE ON_GROUND           ;#nǂ
                    LDA #TIME_TO_LOCK
                    STA $1887
                    LDA #$09
                    STA $1DFC
					LDA #$01
					STA $1528,x
                    LDA $77
                    AND #$04
                    BEQ ON_GROUND
                    LDA #TIME_TO_LOCK
                    STA $163E,x             ;#nkJE^[
                    STZ $7B
                    STZ $7D
                    BRA ON_GROUND           ;
IN_AIR              
ON_GROUND           LDY $15AC,x             ; \
					LDA $14E0,x
					CMP #$03
					BEQ LBL0001
					CMP #$01
					BEQ LBL0002
					LDA $E4,x
					AND #$F0
					CMP #$00
					BNE NOT_LEFT
LBL0002				STZ $157C,x
					BRA DONT_UPDATE
NOT_LEFT			CMP #$C0
 					BCC DONT_UPDATE
LBL0001             LDA #$01
					STA $157C,x

DONT_UPDATE         JSL $01A7DC             ; check for mario/sprite contact
                    LDA $7FFF03             ;#[h`FbN
                    BNE NO_UP
                    JSR JUMP_UP             ;#㏸[h
					STZ $1528,x
                    RTS
NO_UP               CMP #$01                ;#XvCgˏo[h
                    BNE NO_GEN              ;
                    JSR SPRITE_GEN          ;
                    RTS
NO_GEN              CMP #$02                ;#[h
                    BNE NO_DOWN
                    JSR JUMP_DOWN
                    RTS
NO_DOWN             CMP #$03                ;#󒆑ҋ@[h
                    BNE NO_AIR
                    JSR HOBA
                    RTS
NO_AIR              CMP #$04                ;#ړ[h
                    BNE RETURN2
                    JSR VERTICAL
RETURN2             RTS                     ; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP             dcb $80,$82,$84,$86,$A0,$A2,$A4,$A6,$C0,$C2,$C4,$C6,$E0,$E2,$E4,$E6
                    dcb $80,$82,$84,$86,$A0,$A2,$A4,$A6,$C0,$C2,$C4,$C6,$E0,$E2,$E4,$E6
HORIZ_DISP          dcb $F0,$00,$10,$20,$F0,$00,$10,$20,$F0,$00,$10,$20,$F0,$00,$10,$20
                    dcb $30,$20,$10,$00,$30,$20,$10,$00,$30,$20,$10,$00,$30,$20,$10,$00
VERT_DISP           dcb $08,$08,$08,$08,$18,$18,$18,$18,$28,$28,$28,$28,$38,$38,$38,$38
                    dcb $08,$08,$08,$08,$18,$18,$18,$18,$28,$28,$28,$28,$38,$38,$38,$38
PROPERTIES          dcb $40,$00             ;xyppccct format

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300) #΍WɌŒ
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder                 
                   
                    LDA $157C,x             ; \ $02 = sprite direction
                    STA $02                 ; /
                    STZ $03
                    BNE NO_ADD
                    LDA #$10
                    STA $03                 ;
NO_ADD              PHX                     ; push sprite index

                    LDX #$F                ; loop counter = (number of tiles per frame) - 1
LOOP_START          PHX                     ; push current tile number
                    TXA                     ; \ X = index to horizontal displacement   #XvCg̕`X^CɂđウĂ
                    CLC
                    ADC $03
FACING_LEFT         TAX                     ; \ 
                    
                    LDA $00                 ; \ tile x position = sprite x location ($00)
                    CLC                     ;  |
                    ADC HORIZ_DISP,x         ;  |
                    STA $0300,y             ; /   set x position of the tile
                    
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP,x         ;  |
                    STA $0301,y             ; /   set y position of the tile
                    
                    LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; / 
        
                    LDX $02                 ; \
                    LDA PROPERTIES,x        ;  | get tile properties using sprite direction
                    ;LDX $15E9               ;  | ;Sprite index for sprite being processed
                    ;ORA $15F6,x             ;  | get palette info
                    TAX
                    LDA $7FFF04
                    BNE COLOR1
                    TXA
                    ORA #$0F
                    BRA COLOR2
COLOR1              TXA
                    ORA #$0D
COLOR2              ORA $64                 ;  | put in level properties  Unknown, level mode-related
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$F                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

X_OFFSET            dcb $10,$F0
SPRITE_NUM          dcb $04,$0C,$91,$75,$02,$75,$16
                    
SPRITE_GEN          LDA #$02                ; generate sprite number
                    STA $18D4
GENERATE_SPRITE     LDA $18D4
                    BEQ RETURN67
                    JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ sound effect
                    STA $1DFC 
                    
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA $7FFF08
                    TAX
                    LDA #$00
                    STA $7FFF0F
                    LDA SPRITE_NUM,x
                    STA $009E,y             ; /set sprite number
                    TXA
                    PLX
                    CMP #$04                ;#5Ԗڂ̃XvCgȂ
                    BNE NO_EXTRA
                    DEC $18D4
                    JSR EXTRA
NO_EXTRA            LDA $E4,x               ; \ set x position for new sprite
                    CLC
                    ADC #$10
                    STA $00E4,y

                    LDA $14E0,x             ;  |
                    ADC #$00
                    STA $14E0,y             ; /

                    LDA $D8,x               ; \ set y position for new sprite
                    STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    LDA $7FFF0F
                    BEQ NO_SPRITE2
                    JSR EXTRA2
NO_SPRITE2          PLX                     ; / 
                    DEC $18D4
                    LDA $18D4
                    PHX
                    TAX
                    LDA X_OFFSET,x
                    STA $00B6,y             ; x speed of new sprite
                    PLX
                    LDA #$D0
                    STA $00AA,y             ; y speed of new sprite
                    LDA $18D4
                    STA $00C2,y             ; Direction of New Sprite?
                    JSR GENERATE_SPRITE
RETURN67            LDA #$20
                    STA $1558,x
                    LDA #$00
                    STA $7FFF03
                    LDA $7FFF08
                    CMP #$05
                    BNE RETURN68
                    LDA #$04
                    STA $7FFF03
RETURN68            RTS                          ; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ETC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Y_SPEED1             dcb $D0,$C0,$B0,$90,$90,$D0,$B0  ;
Y_SPEED2             dcb $30,$40,$50,$70,$70,$30,$50   ;
X_SPEED1             dcb $F0,$E0,$C0,$A0
                     dcb $10,$20,$40,$60
DOWN_NUM             dcb $03,$05,$07,$09,$0A,$01;
TIME_TO_STOP         dcb $20,$20,$10,$10,$01,$20,$01

MARIO_POS           LDA $94
                    STA $7FFF07
                    CMP #$D0
                    BCC RETURN11
                    LDA #$D0
                    STA $7FFF07
RETURN11            RTS

JUMP_UP             PHX
                    LDA $7FFF08
                    TAX
                    LDA Y_SPEED1,x
                    PLX
                    STA $AA,x
                    LDA $14D4
                    BNE RETURN12
                    LDA $D8
                    CMP #$70
                    BCS RETURN12      ;#ȏ̍xɂȂXgbvă[h`FW
                    PHX
                    LDA $7FFF08
                    TAX
                    LDA TIME_TO_STOP,x
                    PLX
                    STA $1558,x
                    LDA #$02
                    STA $7FFF03
                    LDA $7FFF07
                    STA $E4,x               ;#яオƂ̃}Ïʒu#ړ
                    JSR SUB_GET_DIR         ; \ always face mario
                    TYA                     ;  | 
                    STA $157C,x
                    LDA $7FFF08
                    CMP #$06
                    BEQ LAST2
                    PHX
                    TAX
                    LDA $7FFF09
                    CLC
                    CMP DOWN_NUM,x
                    PLX
                    BCC RETURN12
                    LDA #$00
                    STA $7FFF09
                    LDA $7FFF08
                    INC A
                    STA $7FFF08
                    LDA #$03
                    STA $7FFF03
                    BRA RETURN12
LAST2               LDA #$03
                    STA $7FFF03
RETURN12            RTS

JUMP_DOWN           PHX
                    LDA $7FFF08
                    TAX
                    LDA Y_SPEED2,x
                    PLX
                    STA $AA,x
                    LDA $1528,x
                    BEQ RETURN13        ;#n
                    JSR MARIO_POS       ;#}ÏʒuL^
                    PHX
                    LDA $7FFF08
                    TAX
                    LDA TIME_TO_STOP,x
                    PLX
                    STA $1558,x
                    LDA #$00
                    STA $7FFF03
                    PHX
                    LDA $7FFF08
                    TAX
                    LDA $7FFF09
                    INC A
                    CLC
                    CMP DOWN_NUM,x
                    STA $7FFF09
                    PLX
                    BCC RETURN13
                    LDA #$01
                    STA $7FFF03
RETURN13            RTS

HOBA                STZ $AA,x
                    JSR MARIO_POS        ;#}ÏʒuL^
                    LDA $7FFF07
                    STA $E4,x            ;#}ÏʒuɈړ
                    JSR SUB_GET_DIR      ; \ always face mario
                    TYA                  ;  | 
                    STA $157C,x
                    JSR SPRITE_CHECK
                    TYA
                    BNE RETURN14
                    LDA $7FFF08
                    CMP #$06
                    BEQ LAST1
                    PHX
                    TAX
                    LDA TIME_TO_STOP,x
                    PLX
                    STA $1558,x
                    LDA #$02
                    STA $7FFF03
                    BRA RETURN14
LAST1               LDA #$02
                    STA $14C8,x
                    LDA #$2B
                    STA $1DFC
                    LDA #$40
                    STA $AA,x
                    LDA #$1E
                    STA $1DFB
RETURN14            RTS

SPRITE_CHECK        PHX
                    LDA #$00
                    TAX
                    TAY
                    JSR SPRITE_CHECK2
                    PLX
                    RTS

SPRITE_CHECK2       TXA
                    CMP #$09
                    BEQ RETURN15
                    LDA $9E,x
                    CMP #$28
                    BEQ NEXT
                    LDA $14C8,x
                    BEQ NEXT
                    LDA #$01
                    TAY
                    BRA NEXT
RETURN15            RTS
NEXT                INX
                    JSR SPRITE_CHECK2
                    RTS
VERTICAL            LDA $14AE
                    CLC
                    CMP #$20
                    BCS VERTICAL2
                    LDA #$F0
                    STA $14AE
VERTICAL2           STZ $03
					LDA $157C,x
                    BNE NO_ADD2
                    LDA #$04
                    STA $03
NO_ADD2             PHX
                    LDA $7FFF02
                    CLC
                    ADC $03
                    TAX
                    LDA X_SPEED1,x
                    PLX
                    STA $B6,x
                    LDA $14AE
                    CMP #$95
                    BNE COLOR
                    LDA $7FFF02
                    CMP #$02
                    BEQ COLOR
                    LDA #$01
                    STA $7FFF04
                    LDA #$94
                    STA $14AE
                    LDA #$0E
                    STA $1DFC
COLOR               LDA $14AE
                    CMP #$90
                    BNE RETURN16
                    LDA #$00
                    STA $7FFF04
                    LDA $7FFF02
                    INC A
                    STA $7FFF02
                    CMP #$03
                    BNE NO_ADD3
                    STZ $14AE
                    LDA #$01
                    STA $7FFF03
                    STZ $B6,x
                    LDA #$06
                    STA $7FFF08
                    BRA RETURN16
NO_ADD3             LDA #$8F
                    STA $14AE
RETURN16            RTS

EXTRA               LDA #$02    ;XvCgԍ
                    PHX
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    LDA #$01
                    STA $7FFF0F
                    RTS
EXTRA2              JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817                ; Y = 1 if contact

SUB_GET_DIR         LDY #$00                ;
                    LDA $94                 ;
                    SEC                     ;
                    SBC $E4,x               ;
                    STA $0F                 ;
                    LDA $95                 ;
                    SBC $14E0,x             ;
                    BPL LABEL16             ;
                    INY                     ;
LABEL16             RTS                     ;




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ultema
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURNU             RTS                     ; return      
ULTEMA              JSR ULTEMA_GFX
                    LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURNU              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURNU              ; /
					JSL $01802A             ;
					JSR LIFE_GAGE
					LDA $14F8,x
					BNE NOT_MODE0
					JSR MODE0
					RTS
NOT_MODE0			CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$02
					BNE NOT_MODE2
					JSR MODE2
					RTS
NOT_MODE2			CMP #$03
					BNE NOT_MODE3
					JSR MODE3
					RTS
NOT_MODE3			CMP #$04
					BNE NOT_MODE4
					JSR MODE4
					RTS
NOT_MODE4			CMP #$05
					BNE NOT_MODE5
					JSR MODE5
					RTS
NOT_MODE5			CMP #$06
					BNE NOT_MODE6
					JSR MODE6
					RTS
NOT_MODE6			CMP #$07
					BNE NOT_MODE7
					JSR MODE7
					RTS
NOT_MODE7			CMP #$08
					BNE NOT_MODE8
					JSR MODE8
					RTS
NOT_MODE8			CMP #$09
					BNE NOT_MODE9
					JSR MODE9
					RTS
NOT_MODE9			CMP #$0A
					BNE NOT_MODEA
					JSR MODEA
					RTS
NOT_MODEA			CMP #$0B
					BNE NOT_MODEB
					JSR MODEB
					RTS
NOT_MODEB			JSR MODEC
					RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; etc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GAGE_E				RTS
LIFE_GAGE			LDA #$FC
					STA $7FFFE7
					STA $7FFFE8
					STA $7FFFE9
					STA $7FFFEA
					STA $7FFFEB
					STA $7FFFEC
					LDA $1528,x
					CMP #$01
					BCS GAGE_2
					RTS
GAGE_2				LDA #$FD
					STA $7FFFE7
					LDA $1528,x
					CMP #$02
					BCS GAGE_3
					RTS
GAGE_3				LDA #$FD
					STA $7FFFE8
					LDA $1528,x
					CMP #$03
					BCS GAGE_4
					RTS
GAGE_4				LDA #$FD
					STA $7FFFE9
					LDA $1528,x
					CMP #$04
					BCS GAGE_5
					RTS
GAGE_5				LDA #$FD
					STA $7FFFEA
					LDA $1528,x
					CMP #$05
					BCS GAGE_6
					RTS
GAGE_6				LDA #$FD
					STA $7FFFEB
					LDA $1528,x
					CMP #$06
					BCS GAGE_7
					RTS
GAGE_7				LDA #$FD
					STA $7FFFEC
					RTS


ULTEMA_GFX			LDA $151C,x
					BEQ GFX_E
					CMP #$01
					BNE GFX1
					JSR SUB_GFX1
					RTS
GFX1				CMP #$02
					BNE GFX2
					JSR SUB_GFX2
GFX_E				RTS
GFX2				CMP #$03
					BNE GFX3
					JSR SUB_GFX3
					RTS
GFX3				CMP #$04
					BNE GFX4
					JSR SUB_GFX4
					RTS
GFX4				JSR SUB_GFX5
					RTS

MODE0_E				RTS
MODE0				STZ $13E0
					STZ $13DF
					STZ $7B
					STZ $7D
					LDA #$01
					STA $76
					LDA $1570,x
					BNE MODE0_3
					STZ $AA,x
					LDA $15AC,x
					BNE MODE0_E
					LDA #$E8
					STA $1466
					LDA $13
					AND #$1F
					BNE MODE0_0
					LDA #$10
					STA $1DF9
MODE0_0				DEC $1468
					LDA $1468
					BEQ MODE0_1
					CMP #$50
					BEQ MODE0_2
					RTS
MODE0_1				STZ $1466
					LDA #$C8
					STA $1468
					INC $1570,x
					LDA #$40
					STA $15AC,x
					RTS
MODE0_2				LDA #$02
					STA $151C,x
					RTS
MODE0_3				INC $1570,x
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$03
					STA $1602,x
					STZ $AA,x
					LDA $15AC,x
					BNE MODE0_E
					LDA #$E0
					STA $AA,x
					LDA $14D4,x
					BNE MODE0_E
					LDA $D8,x
					CMP #$E0
					BNE MODE0_E
					STZ $AA,x
					LDA #$01
					STA $14F8,x
					LDA #$01
					STA $7FFFDF
					LDA #$1E
					STA $7FFFE0
					LDA #$15
					STA $7FFFE1
					LDA #$1D
					STA $7FFFE2
					LDA #$12
					STA $7FFFE3
					LDA #$16
					STA $7FFFE4
					LDA #$0A
					STA $7FFFE5
					LDA #$FC
					STA $7FFFE6
					LDA #$80
					STA $15AC,x
					LDA #$05
					STA $1DFB
					LDA #$01
					STA $1426
					RTS
					
MODE1				LDA #$02
					STA $151C,x
					STZ $AA,x
					INC $1570,x
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$03
					STA $1602,x
					CMP #$02
					BCC MODE1_2
					LDA #$FC
					STA $AA,x
					BRA MODE1_3
MODE1_2				LDA #$04
					STA $AA,x
MODE1_3				LDA $16
					BEQ MODE1_0
					INC $13
MODE1_0				LDA $15AC,x
					BNE MODE1_E
					LDA $13
					CLC
					ADC $94
					AND #$03
					BNE MODE1_1
					LDA #$02
					STA $14F8,x
					LDA #$2B
					STA $1DFC
					LDA #$58
					STA $AA,x
					STA $1504,x
					LDA #$E0
					STA $D8,x
					RTS
MODE1_1				CMP #$03
					BEQ MODE1_4
					LDA #$04
					STA $14F8,x
					LDA #$FF
					STA $15AC,x
					RTS
MODE1_4				LDA #$05
					STA $14F8,x
					LDA #$FF
					STA $15AC,x
MODE1_E				RTS

MODE2				LDA #$02
					STA $151C,x
					INC $1570,x
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$03
					STA $1602,x
					LDA $1594,x
					BEQ MODE2_0
					LDA #$05
					STA $151C,x
					STZ $1602,x
					LDA #$01
					STA $13E0
					STZ $13DF
					LDA #$01
					STA $13F9
					LDA $D8,x
					STA $96
					LDA $14D4,x
					STA $97
					LDA $14E0,x
					STA $95
					LDA $157C,x
					STA $76
					BEQ MODE2_0_1
					LDA $E4,x
					SEC
					SBC #$04
					STA $94
					BRA MODE2_0
MODE2_0_1			LDA $E4,x
					CLC
					ADC #$34
					STA $94
MODE2_0				LDA $15AC,x
					CMP #$E0
					BCC MODE2_2
					LDA #$04
					STA $151C,x
					STZ $AA,x
					RTS
MODE2_2				CMP #$00
					BNE MODE2_2_2
					JSR CHECK_MARIO
MODE2_2_2			LDA $157C,x
					BEQ MODE2_1_2
					DEC $E4,x
					LDA $1570,x
					AND #$01
					BEQ MODE2_3
					DEC $E4,x
					BRA MODE2_3
MODE2_1_2			INC $E4,x
					LDA $1570,x
					AND #$01
					BEQ MODE2_3
					INC $E4,x
MODE2_3				DEC $1504,x
					DEC $1504,x
					LDA $1504,x
					STA $AA,x
					LDA $14D4,x
					BNE MODE2_E
					LDA $D8,x
					CMP #$E0
					BCS MODE2_E
					LDA #$E0
					STA $D8,x
					STZ $AA,x
					STZ $B6,x
					STZ $1504,x
					LDA $1594,x
					BEQ MODE2_3_1
					STZ $1594,x
					LDA #$FF
					STA $15AC,x
					LDA #$03
					STA $14F8,x
					RTS
					
MODE2_3_1			STZ $13F9
					LDA #$7F
					STA $15AC,x
					LDA #$01
					STA $14F8,x
					LDA $157C,x
					BEQ MODE2_3_2
					STZ $157C,x
					LDA $E4,x
					SEC
					SBC #$20
					STA $E4,x
					RTS
MODE2_3_2			LDA #$01
					STA $157C,x
					LDA $E4,x
					CLC
					ADC #$20
					STA $E4,x
MODE2_E				RTS
					
					
MODE3				STZ $AA,x
					LDA $15AC,x
					CMP #$B0
					BCC MODE3_1
					LDA #$01
					STA $13E0
					STZ $13DF
					LDA #$01
					STA $13F9
					LDA $D8,x
					STA $96
					LDA $14D4,x
					STA $97
					LDA $14E0,x
					STA $95
					LDA $157C,x
					STA $76
					BEQ MODE3_0
					LDA $E4,x
					SEC
					SBC #$04
					STA $94
					BRA MODE3_1
MODE3_0				LDA $E4,x
					CLC
					ADC #$34
					STA $94
MODE3_1				LDA $15AC,x
					CMP #$D8
					BNE MODE3_1_0
					STZ $1570,x
					JSR ULTEMA_GEN
					LDA #$00
					STA $1528,y
					LDA #$40
					STA $15AC,y
					RTS
MODE3_1_0			CMP #$E0
					BCS MODE3_E
					CMP #$B0
					BEQ MODE3_2
					CMP #$70
					BEQ MODE3_3
					CMP #$AF
					BNE MODE3_1_1
					LDA #$02
					STA $151C,x
MODE3_1_1			LDA #$01
					STA $1602,x
MODE3_E				RTS
MODE3_2				STZ $13F9
					JSL $00F5B7
					STZ $7B
					RTS
MODE3_3				LDA #$7F
					STA $15AC,x
					LDA #$01
					STA $14F8,x
					LDA $157C,x
					BEQ MODE3_3_2
					STZ $157C,x
					LDA $E4,x
					SEC
					SBC #$20
					STA $E4,x
					RTS
MODE3_3_2			LDA #$01
					STA $157C,x
					LDA $E4,x
					CLC
					ADC #$20
					STA $E4,x
					RTS
					
MODE4				LDA #$01
					STA $151C,x
					STZ $AA,x
					LDA $15AC,x
					CMP #$E0
					BEQ MODE4_2
					CMP #$A0
					BCS MODE4_E
					LDA #$01
					STA $14F8,x
					LDA #$E0
					STA $D8,x
					LDA #$40
					STA $15AC,x
MODE4_E				RTS
MODE4_2				LDA #$02
					STA $1570,x
					JSR ULTEMA_GEN
					LDA #$01
					STA $1528,y
					LDA #$FF
					STA $15AC,y
					RTS
					
MODE5				LDA #$05
					STA $151C,x
					STZ $1602,x
					STZ $AA,x
					LDA $15AC,x
					CMP #$F8
					BEQ MODE5_2
					CMP #$08
					BCS MODE5_3
					LDA #$01
					STA $14F8,x
					LDA #$E0
					STA $D8,x
					LDA #$40
					STA $15AC,x
MODE5_E				RTS
MODE5_3				CMP #$E0
					BCS MODE5_E
					LDA #$02
					STA $151C,x
					INC $1570,x
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$03
					STA $1602,x
					CMP #$02
					BCC MODE5_1
					LDA #$FC
					STA $AA,x
					RTS
MODE5_1				LDA #$04
					STA $AA,x
					RTS
MODE5_2				LDA #$00
					STA $1570,x
					JSR ULTEMA_GEN
					LDA #$02
					STA $1528,y
					LDA #$FF
					STA $15AC,y
					RTS
					
MODE6				STZ $AA,x
					STZ $B6,x
					LDA #$04
					STA $151C,x
					LDA $15AC,x
					CMP #$C0
					BNE MODE6_1
					LDA #$02
					STA $1426
MODE6_E				RTS
MODE6_1				CMP #$C0
					BCS MODE6_E
					LDA #$01
					STA $151C,x
					LDA $15AC,x
					CMP #$B8
					BCS MODE6_E
					CMP #$51
					BCS MODE6_2
					LDA #$01
					STA $18D4
					STZ $1466
					STZ $1467
					LDA #$C8
					STA $1468
					LDA $15AC,x
					CMP #$20
					BCS MODE6_E
					LDA #$19
					STA $1DFB
					BRA MODE6_3
					RTS
MODE6_2				JSR CURE1
					RTS
MODE6_3				LDA #$02
					STA $151C,x
					INC $1570,x
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$03
					STA $1602,x
					LDA $157C,x
					BEQ MODE6_3_2
					DEC $E4,x
					LDA $1570,x
					AND #$01
					BEQ MODE6_4
					DEC $E4,x
					BRA MODE6_4
MODE6_3_2			INC $E4,x
					LDA $1570,x
					AND #$01
					BEQ MODE6_4
					INC $E4,x
MODE6_4				DEC $1504,x
					DEC $1504,x
					LDA $1504,x
					STA $AA,x
					LDA $14D4,x
					BNE MODE6_E
					LDA $D8,x
					CMP #$E0
					BCS MODE6_E
					LDA #$E0
					STA $D8,x
					STZ $AA,x
					STZ $B6,x
					STZ $1504,x
					STZ $13F9
					LDA #$7F
					STA $15AC,x
					LDA #$07
					STA $14F8,x
					LDA $157C,x
					BEQ MODE6_4_2
					STZ $157C,x
					LDA $E4,x
					SEC
					SBC #$20
					STA $E4,x
					RTS
MODE6_4_2			LDA #$01
					STA $157C,x
					LDA $E4,x
					CLC
					ADC #$20
					STA $E4,x
					RTS

MODE7				STZ $14AF
					LDA #$02
					STA $151C,x
					STZ $AA,x
					INC $1570,x
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$03
					STA $1602,x
					CMP #$02
					BCC MODE7_2
					LDA #$FC
					STA $AA,x
					BRA MODE7_3
MODE7_2				LDA #$04
					STA $AA,x
MODE7_3				LDA $16
					BEQ MODE7_0
					INC $13
MODE7_0				LDA $15AC,x
					BNE MODE7_E
					LDA $13
					CLC
					ADC $94
					AND #$03
					BNE MODE7_1
					LDA #$08
					STA $14F8,x
					LDA #$E0
					STA $D8,x
					RTS
MODE7_1				CMP #$01
					BNE MODE7_4
					LDA #$09
					STA $14F8,x
					LDA #$FF
					STA $15AC,x
					RTS
MODE7_4				CMP #$02
					BNE MODE7_5
					LDA #$0A
					STA $14F8,x
					LDA #$FF
					STZ $15AC,x
					STZ $1504,x
MODE7_E				RTS
MODE7_5				LDA #$0B
					STA $14F8,x
					LDA #$FF
					STA $15AC,x
					LDA $94
					STA $1504,x
					RTS

MODE8				INC $1570,x
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$03
					STA $1602,x
					LDA $157C,x
					BNE MODE8_1
					STZ $AA,x
					LDA #$30
					STA $B6,x
					LDA $E4,x
					CMP #$90
					BCS MODE8_2
					RTS
MODE8_1				STZ $AA,x
					LDA #$D0
					STA $B6,x
					LDA $E4,x
					CMP #$29
					BCC MODE8_2
					RTS
MODE8_2				STZ $AA,x
					STZ $B6,x
					LDA #$3F
					STA $15AC,x
					LDA #$07
					STA $14F8,x
					LDA $157C,x
					BEQ MODE8_3
					STZ $157C,x
					LDA $E4,x
					SEC
					SBC #$20
					STA $E4,x
					RTS
MODE8_3				LDA #$01
					STA $157C,x
					LDA $E4,x
					CLC
					ADC #$20
					STA $E4,x
					RTS

MODE9				LDA #$01
					STA $151C,x
					STZ $AA,x
					LDA $15AC,x
					CMP #$E0
					BEQ MODE9_2
					CMP #$A0
					BCS MODE9_E
					LDA #$07
					STA $14F8,x
					LDA #$E0
					STA $D8,x
					LDA #$40
					STA $15AC,x
MODE9_E				RTS
MODE9_2				LDA #$02
					STA $1570,x
					JSR ULTEMA_GEN
					LDA #$03
					STA $1528,y
					LDA #$FF
					STA $15AC,y
					RTS

MODEA				LDA $1504,x
					BNE MODEA_1
					JSR CHECK_MARIO2
MODEA_1				INC $1570,x
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$03
					STA $1602,x
					LDA #$02
					STA $151C,x
					LDA $15AC,x
					BNE MODEA_2
					LDA #$20
					STA $AA,x
					LDA $14D4,x
					BEQ MODEA_E
					LDA $D8,x
					CMP #$58
					BCC MODEA_E
					LDA #$58
					STA $D8,x
					LDA #$F0
					STA $15AC,x
MODEA_E				RTS
MODEA_2				STZ $AA,x
					LDA $15AC,x
					CMP #$D0
					BCS MODEA_E
					CMP #$70
					BCC MODEA_3
					LDA $1504,x
					BNE MODEA_2_2
					JSR CURE2
					RTS
MODEA_2_2			LDA #$04
					STA $151C,x
					RTS
MODEA_3				STZ $1466
					STZ $1467
					LDA #$C8
					STA $1468
					LDA $15AC,x
					CMP #$70
					BCS MODEA_E
					LDA #$E0
					STA $AA,x
					LDA $14D4,x
					BNE MODEA_E
					LDA $D8,x
					CMP #$E0
					BNE MODEA_E
					STZ $AA,x
					LDA #$07
					STA $14F8,x
					LDA #$5F
					STA $15AC,x
					RTS

MODEB				STZ $AA,x
					LDA $15AC,x
					CMP #$80
					BCC MODEB_2
					LDA #$01
					STA $14AF
					LDA #$03
					STA $151C,x
					LDA $13
					AND #$04
					BNE MODEB_1
					LDA #$10
					STA $AA,x
					BRA MODEB_E
MODEB_1				LDA #$F0
					STA $AA,x
MODEB_E				RTS
MODEB_2				LDA $15AC,x
					BNE MODEB_3
					LDA $1497
                    BNE MODEB_2_1
					LDA $94
					SEC
					SBC $1504,x
					BCC MODEB_2_0
					CMP #$30
					BCS MODEB_2_1
					JSL $00F5B7
					BRA MODEB_2_1
MODEB_2_0			CMP #$D0
					BCC MODEB_2_1
					JSL $00F5B7
MODEB_2_1			INC $1468
					INC $1468
					LDA $1468
					AND #$3F
					BNE MODEB_2_2
					LDA #$17
					STA $1DFC
MODEB_2_2			LDA $1468
					CMP #$C8
					BEQ MODEB_4
					RTS
MODEB_4				STZ $1466
					STZ $1467
					LDA #$4F
					STA $15AC,x
					LDA #$07
					STA $14F8,x
					STZ $1504,x
					RTS
MODEB_3				LDA #$01
					STA $151C,x
					LDA #$E0
					STA $D8,x
					STZ $15AC,x
					LDA #$00
					SEC
					SBC $1504,x
					CLC
					ADC #$40
					STA $1466
					LDA #$00
					ADC #$00
					STA $1467
					STZ $1468
					RTS
					
MODEC				LDA #$04
					STA $151C,x
					STZ $AA,x
					LDA $15AC,x
					CMP #$C0
					BCS MODEC_E
					CMP #$50
					BEQ MODEC_2
					LDA #$02
					STA $18D4
MODEC_E				RTS
MODEC_2				LDA #$0B
                    STA $1DFB
                    LDA #$FF
                    STA $13C6
                    STA $1493
					RTS
					

CURE1				LDA $15AC,x
					AND #$0F
					BNE CURE1_2
					INC $1528,x
					LDA #$24
					STA $1DFC
CURE1_2				LDA $E4,x
					STA $0F
					LDA $157C,x
					BNE CURE1_3
					LDA $0F
					CLC
					ADC #$10
					STA $0F
CURE1_3				LDA #$00
					SEC
					SBC $0F
					CLC
					ADC #$98
					STA $1466
					LDA #$00
					ADC #$00
					STA $1467
					DEC $1468
					RTS

CURE2				LDA $15AC,x
					AND #$1F
					BNE CURE2_2
					LDA $1528,x
					CMP #$06
					BCS CURE2_1
					INC $1528,x
CURE2_1				LDA #$24
					STA $1DFC
CURE2_2				LDA $E4,x
					STA $0F
					LDA $157C,x
					BNE CURE2_3
					LDA $0F
					CLC
					ADC #$10
					STA $0F
CURE2_3				LDA #$00
					SEC
					SBC $0F
					CLC
					ADC #$98
					STA $1466
					LDA #$00
					ADC #$00
					STA $1467
					DEC $1468
					RTS

CHECK_MARIO			JSL $01A7DC             ; check for mario/sprite contact
                    BCC RETURN_24           ; (carry set = contact)
                    LDA $7D                 ; \  if mario's y speed < 10 ...
                    CMP #$10                ;  }   ... sprite will hurt mario
                    BMI ENE_WINS           ; / 
					LDA $D8,x
					SEC
					SBC $96
					LDA $14D4,x
					SBC $97
					BCC ENE_WINS
MARIO_WINS          JSL $01AA33             ; set mario speed
					JSL $01AB99             ; display contact graphic
					LDA #$20
                    STA $1DF9
					LDA #$FF
					STA $15AC,x
					DEC $1528,x
					LDA $1528,x
					BNE RETURN_24
					LDA #$06
					STA $14F8,x
					LDA #$1E
					STA $1DFB
					RTS
ENE_WINS            LDA #$01
					STA $1594,x
RETURN_24			RTS                     ; return

CHECK_MARIO2		JSL $01A7DC             ; check for mario/sprite contact
                    BCC RETURN_242           ; (carry set = contact)
                    LDA $7D                 ; \  if mario's y speed < 10 ...
                    CMP #$10                ;  }   ... sprite will hurt mario
                    BMI ENE_WINS2           ; / 
					LDA $D8,x
					SEC
					SBC $96
					LDA $14D4,x
					SBC $97
					BCC ENE_WINS2
MARIO_WINS2         JSL $01AA33             ; set mario speed
					JSL $01AB99             ; display contact graphic
					LDA #$20
                    STA $1DF9
					LDA #$A0
					STA $15AC,x
					LDA #$01
					STA $1504,x
					STZ $1466
					STZ $1467
					LDA #$C8
					STA $1468
					DEC $1528,x
					LDA $1528,x
					BNE RETURN_242
					LDA #$1E
					STA $1DFB
					LDA #$FF
					STA $15AC,x
					LDA #$0C
					STA $14F8,x
					RTS
ENE_WINS2           LDA $1497               ; \ if mario is invincible...
                    BNE RETURN_242             ; /   ... return
                    JSL $00F5B7
RETURN_242			RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP1            dcb $80,$82,$84,$86,$A0,$A2,$A4,$A6,$C0,$C2,$C4,$C6,$E4,$E6
HORIZ_DISP1         dcb $40,$30,$20,$10,$40,$30,$20,$10,$40,$30,$20,$10,$20,$10
                    dcb $F0,$00,$10,$20,$F0,$00,$10,$20,$F0,$00,$10,$20,$10,$20
VERT_DISP1          dcb $00,$00,$00,$00,$10,$10,$10,$10,$20,$20,$20,$20,$30,$30
PROPERTIES1         dcb $40,$00

SUB_GFX1            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder
					LDA #$0F
					STA $0F
					LDA $18D4
					BEQ GFX1_0
					LDA #$0D
					STA $0F
GFX1_0              PHX                     ; push sprite index
					LDA $157C,x
					STA $02

                    LDX #$0D                ; loop counter = (number of tiles per frame) - 1
LOOP_START1         PHX                     ; push current tile number
                    
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP1,x         ;  |
					STA $0301,y             ; /   set y position of the tile
                    
                    LDA TILEMAP1,x           ; \ store tile
                    STA $0302,y             ; / 
					
					PHX
					LDA $02
					BEQ LOOP1_2
					TXA
					CLC
					ADC #$0E
					TAX
LOOP1_2				LDA $00                 ; \ tile x position = sprite x location ($00)
                    CLC                     ;  |
                    ADC HORIZ_DISP1,x         ;  |
                    STA $0300,y             ; /   set x position of the tile

					LDX $02
					LDA PROPERTIES1,x
                    ORA $0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    PLX
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START1          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$0D                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP2            dcb $00,$02,$20,$22,$24,$40,$42,$44,$61
					dcb $04,$06,$26,$28,$2A,$46,$48,$4A,$61
					dcb $08,$0A,$2C,$2E,$0C,$4C,$4E,$0E,$61
					dcb $04,$06,$26,$28,$2A,$46,$48,$4A,$61
HORIZ_DISP2         dcb $28,$18,$30,$20,$10,$30,$20,$10,$27
                    dcb $08,$18,$00,$10,$20,$00,$10,$20,$09
VERT_DISP2          dcb $00,$00,$10,$10,$10,$20,$20,$20,$30
PROPERTIES2         dcb $40,$00

SUB_GFX2            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder                
                    LDA #$0F
					STA $0F
					LDA $18D4
					BEQ GFX2_0
					LDA #$0D
					STA $0F
GFX2_0              PHX                     ; push sprite index
					LDA $157C,x
					STA $02
					LDA $1602,x
					ASL A
					ASL A
					ASL A
					CLC
					ADC $1602,x
					STA $03

                    LDX #$08                ; loop counter = (number of tiles per frame) - 1
LOOP_START2         PHX                     ; push current tile number
                    
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP2,x         ;  |
					STA $0301,y             ; /   set y position of the tile
                    
					PHX
					TXA
					CLC
					ADC $03
					TAX
                    LDA TILEMAP2,x           ; \ store tile
                    STA $0302,y             ; / 
					PLX
					
					PHX
					LDA $02
					BEQ LOOP2_2
					TXA
					CLC
					ADC #$09
					TAX
LOOP2_2				LDA $00                 ; \ tile x position = sprite x location ($00)
                    CLC                     ;  |
                    ADC HORIZ_DISP2,x         ;  |
                    STA $0300,y             ; /   set x position of the tile

					LDX $02
					LDA PROPERTIES2,x
                    ORA $0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    PLX
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START2          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$08                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP3            dcb $89,$8C,$A9,$AB,$AD,$C8,$CA,$CC,$E8,$EA,$EC,$CE,$EE
HORIZ_DISP3         dcb $28,$10,$28,$18,$08,$30,$20,$10,$30,$20,$10,$30,$20
                    dcb $08,$20,$08,$18,$28,$00,$10,$20,$00,$10,$20,$00,$10
VERT_DISP3          dcb $F0,$F0,$00,$00,$00,$10,$10,$10,$20,$20,$20,$30,$30
PROPERTIES3         dcb $40,$00

SUB_GFX3            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder                
                    LDA #$0F
					STA $0F
					LDA $18D4
					BEQ GFX3_0
					LDA #$0D
					STA $0F
GFX3_0              PHX                     ; push sprite index
					LDA $157C,x
					STA $02

                    LDX #$0C                ; loop counter = (number of tiles per frame) - 1
LOOP_START3         PHX                     ; push current tile number
                    
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP3,x         ;  |
					STA $0301,y             ; /   set y position of the tile
                    
                    LDA TILEMAP3,x           ; \ store tile
                    STA $0302,y             ; / 
					
					PHX
					LDA $02
					BEQ LOOP3_2
					TXA
					CLC
					ADC #$0D
					TAX
LOOP3_2				LDA $00                 ; \ tile x position = sprite x location ($00)
                    CLC                     ;  |
                    ADC HORIZ_DISP3,x         ;  |
                    STA $0300,y             ; /   set x position of the tile

					LDX $02
					LDA PROPERTIES3,x
                    ORA $0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    PLX
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START3          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$0C                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP4            dcb $80,$82,$84,$A0,$A2,$A4,$C0,$C2,$C4,$E0,$E2,$E4
HORIZ_DISP4         dcb $38,$28,$18,$38,$28,$18,$38,$28,$18,$38,$28,$18
                    dcb $F8,$08,$18,$F8,$08,$18,$F8,$08,$18,$F8,$08,$18
VERT_DISP4          dcb $00,$00,$00,$10,$10,$10,$20,$20,$20,$30,$30,$30
PROPERTIES4         dcb $40,$00

SUB_GFX4            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder                
                    LDA #$0E
					STA $0F
					LDA $18D4
					BEQ GFX4_0
					CMP #$01
					BNE GFX4_1
					LDA #$0C
					STA $0F
					BRA GFX4_0
GFX4_1				LDA #$06
					STA $0F
GFX4_0              PHX                     ; push sprite index
					LDA $157C,x
					STA $02

                    LDX #$0B                ; loop counter = (number of tiles per frame) - 1
LOOP_START4         PHX                     ; push current tile number
                    
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP4,x         ;  |
					STA $0301,y             ; /   set y position of the tile
                    
                    LDA TILEMAP4,x           ; \ store tile
                    STA $0302,y             ; / 
					
					PHX
					LDA $02
					BEQ LOOP4_2
					TXA
					CLC
					ADC #$0C
					TAX
LOOP4_2				LDA $00                 ; \ tile x position = sprite x location ($00)
                    CLC                     ;  |
                    ADC HORIZ_DISP4,x         ;  |
                    STA $0300,y             ; /   set x position of the tile

					LDX $02
					LDA PROPERTIES4,x
                    ;LDX $15E9               ;  |
                    ;ORA $15F6,x             ;  | get palette info
					ORA $0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    PLX
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START4          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$0B                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP5            dcb $88,$AC,$AE,$CA,$CC,$CE,$EA,$EC,$EE,$AA
                    dcb $8A,$8C,$8E,$E6,$E8,$CE,$EA,$EC,$EE,$AA
HORIZ_DISP5         dcb $35,$25,$15,$35,$25,$15,$35,$25,$15,$27
                    dcb $FB,$0B,$1B,$FB,$0B,$1B,$FB,$0B,$1B,$09
VERT_DISP5          dcb $00,$00,$00,$10,$10,$10,$20,$20,$20,$30
PROPERTIES5         dcb $40,$00

SUB_GFX5            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder                
                    LDA #$0E
					STA $0F
					LDA $18D4
					BEQ GFX5_0
					LDA #$0C
					STA $0F
GFX5_0              PHX                     ; push sprite index
					LDA $157C,x
					STA $02
					LDA $1602,x
					ASL A
					ASL A
					CLC
					ADC $1602,x
					ASL A
					STA $03

                    LDX #$09                ; loop counter = (number of tiles per frame) - 1
LOOP_START5         PHX                     ; push current tile number
                    
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP5,x         ;  |
					STA $0301,y             ; /   set y position of the tile
                    
                    PHX
					TXA
					CLC
					ADC $03
					TAX
                    LDA TILEMAP5,x           ; \ store tile
                    STA $0302,y             ; / 
					PLX
					
					PHX
					LDA $02
					BEQ LOOP5_2
					TXA
					CLC
					ADC #$0A
					TAX
LOOP5_2				LDA $00                 ; \ tile x position = sprite x location ($00)
                    CLC                     ;  |
                    ADC HORIZ_DISP5,x         ;  |
                    STA $0300,y             ; /   set x position of the tile

					LDX $02
					LDA PROPERTIES5,x
                    ORA $0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    PLX
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START5          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$09                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
					
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X_OFFSETU			dcb $2C,$FC,$40,$F0
X_OFFSETU2			dcb $00,$FF,$00,$FF
Y_OFFSETU			dcb $00,$00,$20,$20

RETURNU67           RTS
ULTEMA_GEN          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURNU67            ; / after: Y has index of sprite being generated
					
					PHX
					LDA $1570,x
					CLC
					ADC $157C,x
					TAX
					LDA X_OFFSETU,x
					STA $02
					LDA X_OFFSETU2,x
					STA $03
					LDA Y_OFFSETU,x
					STA $0F
					PLX
					
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA #$31
					TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
                    LDA $E4,x               ;\ set x position for new sprite
					CLC
					ADC $02
                    STA $00E4,y

                    LDA $14E0,x             ;  |
					ADC $03
                    STA $14E0,y             ; /

                    LDA $D8,x               ;\ set y position for new sprite
					CLC
					ADC $0F
                    STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
					ADC #$00
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return
					
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Rocket Code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FNISH_CODE			JSR R_SUB_GFX2
					STZ $1594,x
					JSR R_LIFE_GAGE
					RTS

R_RETURN              RTS
SPRITE_CODE_START   JSR R_SUB_GFX
					JSR DELETE_MARIO
	                LDA $9D                 ; \ if sprites locked, return
                    BNE R_RETURN              ; /
					JSR FINISH_CHECK
					LDA #$F0
					STA $AA,x
					JSL $01802A             ; update position based on speed values
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					SEC
					SBC #$20
					STA $D8,x
					LDA $97
					SBC #$00
					STA $14D4,x
					JSR R_LIFE_GAGE
					LDA $1594,x
					BEQ R_MAIN2
					INC $1570,x
					LDA $1570,x
					BNE R_MAIN2
					DEC $1594,x
R_MAIN2				LDA $1594,x
					BEQ R_NOT_MODE1
					JSR R_MODE0
					RTS
R_NOT_MODE1			JSR R_MODE1
					RTS

R_MODE0				LDA $15AC,x
					STA $7D
					STZ $7B
					LDA $15
					AND #$03
					BEQ R_MODE0_2
					CMP #$01
					BNE R_MODE0_1
					LDA #$10
					STA $7B
					BRA R_MODE0_2
R_MODE0_1			LDA #$F0
					STA $7B
R_MODE0_2			LDA #$01
					STA $1471
					LDA $1588,x
					AND #$08
					BEQ R_MODE0_3
					LDA #$20
					STA $15AC,x
					LDA #$02
					STA $1DF9
R_MODE0_3			LDA $96
					SEC
					SBC #$01
					STA $96
					LDA $97
					SBC #$00
					STA $97
					RTS

R_MODE1				STZ $7B
					LDA #$30
					STA $7D
					LDA $77
					AND #$04
					BEQ R_MODE1_1
					LDA #$06
					STA $7D
R_MODE1_1			LDA $15
					AND #$03
					BEQ R_MODE1_3
					CMP #$01
					BNE R_MODE1_2
					LDA #$10
					STA $7B
					BRA R_MODE1_3
R_MODE1_2			LDA #$F0
					STA $7B
R_MODE1_3			RTS

DELETE_MARIO		LDA #$03
					STA $78
					LDA #$40
					STA $0D89
					STA $0D93
					LDA #$51
					STA $0D8A
					STA $0D94
					RTS
					
R_GAGE_E			RTS
R_LIFE_GAGE			LDA #$FC
					STA $7FFFE4
					STA $7FFFE5
					STA $7FFFE6
					STA $7FFFE7
					STA $7FFFE8
					STA $7FFFE9
					STA $7FFFEA
					STA $7FFFEB
					STA $7FFFEC
					STA $7FFFED
					STA $7FFFEE
					STA $7FFFEF
					LDA $1594,x
					CMP #$01
					BCS R_GAGE_2
					RTS
R_GAGE_2			LDA #$FD
					STA $7FFFE4
					LDA $1594,x
					CMP #$02
					BCS R_GAGE_3
					RTS
R_GAGE_3			LDA #$FD
					STA $7FFFE5
					LDA $1594,x
					CMP #$03
					BCS R_GAGE_4
					RTS
R_GAGE_4			LDA #$FD
					STA $7FFFE6
					LDA $1594,x
					CMP #$04
					BCS R_GAGE_5
					RTS
R_GAGE_5			LDA #$FD
					STA $7FFFE7
					LDA $1594,x
					CMP #$05
					BCS R_GAGE_6
					RTS
R_GAGE_6			LDA #$FD
					STA $7FFFE8
					LDA $1594,x
					CMP #$06
					BCS R_GAGE_7
					RTS
R_GAGE_7			LDA #$FD
					STA $7FFFE9
					LDA $1594,x
					CMP #$07
					BCS R_GAGE_8
					RTS
R_GAGE_8			LDA #$FD
					STA $7FFFEA
					LDA $1594,x
					CMP #$08
					BCS R_GAGE_9
					RTS
R_GAGE_9			LDA #$FD
					STA $7FFFEB
					LDA $1594,x
					CMP #$09
					BCS R_GAGE_A
					RTS
R_GAGE_A			LDA #$FD
					STA $7FFFEC
					LDA $1594,x
					CMP #$0A
					BCS R_GAGE_B
					RTS
R_GAGE_B			LDA #$FD
					STA $7FFFED
					LDA $1594,x
					CMP #$0B
					BCS R_GAGE_C
					RTS
R_GAGE_C			LDA #$FD
					STA $7FFFEE
					RTS
					
FINISH_CHECK		LDA $14D4,x
					CMP #$02
					BNE FINISH2
					LDA $D8,x
					CMP #$91
					BCC FINISH
FINISH_E			RTS
FINISH2				CMP #$04
					BNE FINISH_E
					LDA $14E0,x
					CMP #$01
					BNE FINISH_E
					LDA $D8,x
					CMP #$50
					BCS FINISH_E
FINISH				LDA #$01
					STA $C2,x
					RTS
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

R_TILEMAP             dcb $82,$84,$A0,$A2,$A4,$A6,$C8,$C2,$C4,$C6,$E0,$E2,$E4,$E6
R_HORZ_DISP           dcb $F8,$08,$E8,$F8,$08,$18,$E8,$F8,$08,$18,$E8,$F8,$08,$18
R_VERT_DISP           dcb $00,$00,$10,$10,$10,$10,$20,$20,$20,$20,$30,$30,$30,$30

R_SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
					PHX                     ; push sprite index

                    LDX #$0D                ; loop counter = (number of tiles per frame) - 1
R_LOOP_START          PHX                     ; push current tile number

					LDA $00
					CLC                     ;  |
                    ADC R_HORZ_DISP,x   
                    STA $0300,y             ; /      

                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC R_VERT_DISP,x         ;  |
                    STA $0301,y             ; /
                    
					
                    LDA R_TILEMAP,x           ; \ store tile
                    STA $0302,y             ; / 
        
                    LDA #$0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL R_LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
					LDA $1594,x
					BNE R_GFX2
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$0D                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
R_GFX2				LDA #$8E
					STA $02
					LDA #$AE
					STA $03
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					BEQ R_GFX2_2
					LDA #$8C
					STA $02
					LDA #$AC
					STA $03
R_GFX2_2
					INY
					INY
					INY
					INY
					LDA $00
					STA $0300,y
					LDA $01
					STA $01
					CLC
					ADC #$40
					STA $0301,y
					LDA $02
					STA $0302,y
					LDA #$0D
                    ORA $64 
                    STA $0303,y
					INY
					INY
					INY
					INY
					LDA $00
					STA $0300,y
					LDA $01
					STA $01
					CLC
					ADC #$50
					STA $0301,y
					LDA $03
					STA $0302,y
					LDA #$0D
                    ORA $64 
                    STA $0303,y
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$0F                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

R_TILEMAP2             dcb $82,$84,$A0,$AA,$CE,$A6,$C8,$CA,$CC,$C6,$E0,$E2,$E4,$E6
R_HORZ_DISP2           dcb $F8,$08,$E8,$F8,$08,$18,$E8,$F8,$08,$18,$E8,$F8,$08,$18
R_VERT_DISP2           dcb $00,$00,$10,$10,$10,$10,$20,$20,$20,$20,$30,$30,$30,$30

R_SUB_GFX2             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
					PHX                     ; push sprite index

                    LDX #$0D                ; loop counter = (number of tiles per frame) - 1
R_LOOP_START2          PHX                     ; push current tile number

					LDA $00
					CLC                     ;  |
                    ADC R_HORZ_DISP2,x   
                    STA $0300,y             ; /      

                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC R_VERT_DISP2,x         ;  |
                    STA $0301,y             ; /
                    
					
                    LDA R_TILEMAP2,x           ; \ store tile
                    STA $0302,y             ; / 
        
                    LDA #$0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL R_LOOP_START2          ; / 

                    PLX                     ; pull, X = sprite index
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$0D                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
