;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Iggy
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"
					LDA #$0F
					STA $1602,x
					LDA #$80
					STA $15AC,x
					STZ $1504,x
                    RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                     ; return           
CODE_START          JSR SUB_GFX
MAIN                LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
					LDA $16
					BNE MAIN0
					LDA $18
					BNE MAIN0
					BRA MAIN1
MAIN0				INC $151C,x
MAIN1				INC $1570,x
					LDA $1465
					CMP #$07
					BNE RETURN
					LDA $1504,x
					BNE MAIN2
					LDA #$05
					STA $1DFB
					LDA #$01
					STA $1504,x
MAIN2				LDA $1528,x
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			JSR MODE2
					RTS



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP             dcb $80,$82,$A0,$A2,$C0,$C2,$E0,$E2,$84,$86,$A4,$A6,$C0,$C2,$E0,$E2,$C4,$C6,$E4,$E6
HORZ_DISP           dcb $00,$10,$00,$10
VERT_DISP           dcb $F0,$F0,$00,$00

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder                 
					LDA $1602,x
					STA $02
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					ASL A
					ASL A
                    STA $03
					LDA $76
					BEQ GFX2
					LDA #$10
					STA $03
GFX2				PHX                     ; push sprite index

                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START          
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP,x         ;  |
                    STA $0301,y             ; /   set y position of the tile
                    
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP,x
                    STA $0300,y             ; /   set y position of the tile
					
                    PHX
                    TXA
                    CLC
                    ADC $03
                    TAX
                    LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; / 
					PLX
					
					LDA #$00            ;  |
                    ORA $02
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ETC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MODE1_SPR			dcb $39,$08,$39,$08,$39,$39,$39,$08
MODE2_SPR			dcb $B3,$B4

MODE1				LDA #$0F
					STA $1602,x
					LDA $76
					BNE MODE1_2
					JSR DAMAGE_CHECK
MODE1_2				LDA $15AC,x
					BNE MODE1_E
					PHX
					LDA $151C,x
					CLC
					ADC $94
					CLC
					ADC $13
					AND #$03
					TAX
					LDA MODE1_SPR,x
					PLX
					STA $157C,x
					JSR GEN_SPRITE
					LDA #$01
					STA $157C,y
					LDA #$F0
					STA $00B6,y
					LDA #$80
					STA $15AC,x
MODE1_E				RTS


MODE2				LDA #$09
					STA $1602,x
					LDA $76
					BNE MODE2_2
					JSR DAMAGE_CHECK
MODE2_2				LDA $15AC,x
					BEQ MODE2_R
					LDA $15AC,x
					AND #$3F
					BNE MODE2_E
					PHX
					LDA $151C,x
					CLC
					ADC $94
					AND #$01
					TAX
					LDA MODE2_SPR,x
					PLX
					STA $157C,x
					JSR GEN_SPRITE
					LDA #$01
					STA $157C,y
					LDA #$F0
					STA $00B6,y
MODE2_E				RTS
MODE2_R				LDA #$40
					STA $15AC,x
					STZ $1528,x
					RTS
					


DAMAGE_CHECK        PHX
                    LDX #$09
LOOP1               LDA $9E,x
                    CMP #$04
                    BNE LOOP3
					LDA $14C8,x
					CMP #$0A
					BNE LOOP3
                    JSR NEAR_CHECK
                    TYA
                    BEQ LOOP3
                    LDA #$28
                    STA $1DFC
					LDA #$00
					STA $14C8,x
					TXY
					PLX
					INC $1594,x
					LDA $1594,x
					CMP #$03
					BEQ ENDS
					LDA #$01
					STA $1528,x
					LDA #$FF
					STA $15AC,x
LOOP2				PHX
					TYX
LOOP3               DEX
                    BPL LOOP1
                    PLX
                    RTS
ENDS				LDA #$08
                    STA $1DF9
					STA $1DFB
					LDA #$01
					STA $7FFEE0
					LDA $1528,x
					BEQ END2
					LDA #$02
					STA $7FFEE0
END2				JSR SUB_SMOKE2
					STZ $14C8,x
					RTS

NEAR_CHECK          LDY #$00
                    LDA $E4,x
					CMP #$E0
					BCC NEAR_E
					LDA $14E0,x
					BNE NEAR_E
					LDY #$01
NEAR_E				RTS
                    

SUB_SMOKE2          LDY #$03                ; \ find a free slot to display effect
FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
                    RTS                     ; / return if no slots open
FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    LDA #$90
                    STA $17C4,y             ; /
                    LDA #$1B                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA #$E0
                    STA $17C8,y             ; /
                    RTS            
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; hammer routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


RETURN68            RTS     
GEN_SPRITE		    JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

					LDA $157C,x
                    STA $009E,y

                    LDA $E4,x
                    STA $00E4,y
					LDA $14E0,x
                    STA $14E0,y
					LDA $D8,x
                    STA $00D8,y
					LDA $14D4,x
                    STA $14D4,y

                    LDA #$01
                    STA $157C,y

                    PHX
                    TYX
                    JSL $07F7D2             ;  
                    PLX
                    RTS                     ; return


