;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Box
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    ;symbolic names for ram addresses
                    SPRITE_OAM      = $15EA
                    
                    ;data
                    SIZE            = $08
                    
					EXTRA_BITS = $7FAB10
                    
                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
                    RTL
      

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite code JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"                                    
                    PHB                     
                    PHK                     
                    PLB                     
                    JSR SPRITE_CODE_START   
                    PLB                     
                    RTL      


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
SPRITE_CODE_START   LDA EXTRA_BITS,x
					AND #$04
					BNE DARK
					JSR SUB_GFX
					LDA $9D
					BNE LOCK
                    JSR SUB_B852
                    JSR SUB_MOVEMENT
LOCK                RTS
DARK				LDA #$FF
					STA $40
					STZ $14C8,x
					RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_MOVEMENT
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_MOVEMENT        LDA $1594,x
					BEQ MOVEMENT_2
					JSR FLOAT
					RTS
MOVEMENT_2			JSR WAETER_IN
					JSR AIR_CHECK
					LDA $151C,x
					BNE RETURN121
					LDA $1504,x
					AND #$03
					BNE RETURN121
					JSR WATER_CHECK
					JSR TOUCH_CHECK
					STZ $C2,x
RETURN121			RTS

FLOAT				LDA $1594,x
					CMP #$02
					BEQ FLOAT_R
					STZ $AA,x
					LDA #$10
					STA $B6,x
					JSL $01802A
					LDA $1588,x
					AND #$01
					BEQ FLOAT_2
					LDA #$02
					STA $1594,x
FLOAT_R				RTS
FLOAT_2				LDA $77
					AND #$01
					BNE FLOAT_R
					LDA $94
					CLC
					ADC #$01
					STA $94
					LDA $95
					ADC #$00
					STA $95
					RTS

WAETER_IN			JSL $019138
					REP #$30
					LDA $03
					CMP #$0B49
					BEQ IN_WATER
					CMP #$0B79
					BEQ IN_WATER
					SEP #$30
					RTS
IN_WATER			SEP #$30
					LDA #$01
					STA $1594,x
					RTS

WATER_CHECK			LDA $C2,x
					STA $1602,x
					LDA $E4,x
					SEC
					SBC #$10
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
					JSL $019138
					LDA $C2,x
					ORA $1602,x
					STA $1602,x
					LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					LDA $1602,x
					CMP #$01
					BEQ WATER_RIGHT
					CMP #$02
					BEQ WATER_LEFT
RETURN243			RTS
WATER_RIGHT			LDA #$10
					STA $B6,x
					JSL $01802A
					LDA $157C,x
					BEQ RETURN243
					LDA $77
					AND #$01
					BNE RETURN243
					LDA $94
					CLC
					ADC #$01
					STA $94
					LDA $95
					ADC #$00
					STA $95
					RTS
WATER_LEFT			LDA #$F0
					STA $B6,x
					JSL $01802A
					LDA $157C,x
					BEQ RETURN243
					LDA $77
					AND #$02
					BNE RETURN243
					LDA $94
					SEC
					SBC #$01
					STA $94
					LDA $95
					SBC #$00
					STA $95
					RTS
					
AIR_CHECK			STZ $B6,x
					JSL $019138
					LDA $1588,x
					STA $151C,x
					LDA $E4,x
					SEC
					SBC #$10
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
					JSL $019138
					LDA $1588,x
					ORA $151C,x
					STA $151C,x
					LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					LDA $151C,x
					AND #$04
					BNE ON_GROUND
					LDA #$01
					STA $151C,x
					JSL $01802A
					STZ $1504,x
					RTS
ON_GROUND			STZ $151C,x
					RTS

TOUCH_CHECK			LDA $15
					AND #$40
					BEQ RETURN122
					LDA $77
					AND #$04
					BEQ RETURN122
					LDA $1570,x
					BEQ RETURN122
					CMP #$01
					BEQ MOVE_LEFT
					CMP #$02
					BEQ MOVE_RIGHT
RETURN122           RTS
MOVE_LEFT			LDA $15
					AND #$02
					BEQ RETURN122
					LDA $E4,x
					SEC
					SBC #$10
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
					
					LDA $1602,x
					CMP #$01
					BEQ MOVE_LEFT2
					
                    LDA #$D0
					STA $B6,x
					STZ $AA,x
					LDA $94
					SEC
					SBC #$03
					STA $94
					LDA $95
					SBC #$00
					STA $95
					BRA MOVE_LEFT3
					
MOVE_LEFT2			LDA #$C0
					STA $B6,x
					STZ $AA,x
					LDA $94
					SEC
					SBC #$08
					STA $94
					LDA $95
					SBC #$00
					STA $95
					JSL $01802A

MOVE_LEFT3			JSL $01802A
					LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					LDA $1588,x
					AND #$02
					BEQ RETURN123
					LDA #$02
					STA $1504,x
RETURN123			RTS
MOVE_RIGHT			LDA $15
					AND #$01
					BEQ RETURN123
					LDA $1602,x
					CMP #$01
					BEQ MOVE_RIGHT2
					
                    LDA $94
					CLC
					ADC #$03
					STA $94
					LDA $95
					ADC #$00
					STA $95
					LDA #$30
					STA $B6,x
					BRA MOVE_RIGHT3
MOVE_RIGHT2			LDA $94
					CLC
					ADC #$08
					STA $94
					LDA $95
					ADC #$00
					STA $95
					LDA #$40
					STA $B6,x
					JSL $01802A

MOVE_RIGHT3			JSL $01802A
					LDA $1588,x
					AND #$01
					BEQ RETURN123
					LDA #$01
					STA $1504,x
					RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; platform code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_B852            STZ $157C,x
					STZ $1570,x
                    LDA $15C4,x   ;#ʊOȂ1
                    BNE RETURN05
                          
                    LDA $71       ;#Action Triger
                    CMP #$01                
                    BCS RETURN05     
                    
                    JSR SUB_B8FF ;#XvCgɐGĂ邩`FbN
                    BCC RETURN05      
                    
                    LDA $D8,x    
                    SEC          
                    SBC $1C      ;#vert screen boundry
                    STA $02      
                    SEC          
                    SBC $0D      
					SEC
                    STA $09      
                    LDA $80      
                    CLC          
                    ADC #$18
                    CMP $09      
                    BCS LBL06      
                    LDA $7D    
                    BMI RETURN05     
                    STZ $7D  ;#ɏ
                        
                    LDA #$01     
                    STA $1471    ;#ntO
                    LDA $0D      ;#$00?
                    CLC          
                    ADC #$1F     

                    STA $00      
                    
                    LDA #$01
                    STA $157C,x
                   
                    LDA $D8,x    
                    SEC          
                    SBC $00      ;#size
                    STA $96      
                    LDA $14D4,x  
                    SBC #$00     
                    STA $97      
                    LDY #$00     ;#`FbN
                    LDA $1491               ;amount to move mario 
                    BPL LBL04      
                    DEY
LBL04
                    CLC                     
                    ADC $94       
                    STA $94       
                    TYA           
                    ADC $95       
                    STA $95       
RETURN05            RTS           

LBL06               LDA $02       
                    CLC           
                    ADC $0D       
                    STA $02       
                    LDA #$FF      
                    LDY $73       
                    BNE LBL07      
                    LDY $19       
                    BNE SMALL_MARIO
LBL07
                    LDA #$08   
SMALL_MARIO
                    CLC                     
                    ADC $80      
                    CMP $02      
                    BCC LBL10      
                    LDA $7D       
                    BPL LBL09    
                    LDA #$10                
                    STA $7D    ;#Ԃ
LBL09
                    RTS       
LBL10				LDA #$01
					STA $1570,x
                    LDA $0E       ;#Ԃ
                    CLC           
                    ADC #$10      
                    STA $00       
                    LDY #$00      
                    LDA $E4,x     
                    SEC           
                    SBC $1A
					SBC #$10
                    CMP $7E       
                    BCC LBL11     
                    LDA $00       ;#Ԃ
                    EOR #$FF      
                    INC A         
					CLC
					ADC #$10
                    STA $00       
                    DEY     
					LDA #$02
					STA $1570,x
LBL11				LDA $00
					SEC
					SBC #$10
					STA $00
					LDA $E4,x     
                    CLC           
                    ADC $00       
                    STA $94       
                    TYA           
                    ADC $14E0,x   
                    STA $95       
                    STZ $7B       
                    RTS                     


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; make standable
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_B8FF
                    LDA $00      ;#SIZE
                    STA $0E      
                    LDA $02      ;#$00
                    STA $0D      
                    LDA $E4,x    
                    SEC          
                    SBC $00      
                    STA $04      
                    LDA $14E0,x  
                    SBC #$00     
                    STA $0A      
                    LDA $00      
                    ASL A        
                    ;CLC          
                    ;ADC #$10     ;#TCY
                    STA $06      
                    LDA $D8,x    
                    SEC          
                    SBC $02      
                    STA $05      
                    LDA $14D4,x  
                    SBC #$00     
                    STA $0B      
                    LDA $02      
                    ASL A        
                    CLC          
                    ADC #$10     
                    STA $07      
                    JSL $03B664  ;#???
                    JSL $03B72B  ;#???
                    RTS 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

X_OFFSET            dcb $F0,$00,$F0,$00
Y_OFFSET			dcb $F2,$F2,$02,$02
TILE				dcb $00,$02,$20,$22

SUB_GFX 			JSR GET_DRAW_INFO
                    PHX                     ; push sprite index

                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START          PHX                     ; push current tile number
                    
					LDA $00                 ; \ tile x position = sprite x location ($00)
                    CLC
                    ADC X_OFFSET,x
                    STA $0300,y             ; /
                    
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
					CLC
					ADC Y_OFFSET,x
                    STA $0301,y             ; /
                    
                    LDA TILE,x
                    STA $0302,y             ; / 
        
                    LDA #$09
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                                              
                    STZ $00       
                    STZ $01       
                    STZ $02       
                    STZ $03       
                    LDY #$00                 
                    LDA #SIZE   
                    STA $0000,y   
                    LSR A         
                    STA $0001,y   
                                        
                    LDA $00       
                    PHA           
                    LDA $02       
                    PHA       
                    
                    LDY #$02                ; \ 02, because we didn't write to 460 yet
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen

                    PLA           
                    STA $02       
                    PLA           
                    STA $00       
                    RTS                         

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GET_DRAW_INFO
; This is a helper for the graphics routine.  It sets off screen flags, and sets up
; variables.  It will return with the following:
;
;		Y = index to sprite OAM ($300)
;		$00 = sprite x position relative to screen boarder
;		$01 = sprite y position relative to screen boarder  
;
; It is adapted from the subroutine at $03B760
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T1              dcb $0C,$1C
SPR_T2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC SPR_T1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA SPR_T2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY SPRITE_OAM,x        ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
                    
