;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Noko bros1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					EXTRA_BITS = $7FAB10
					NEW_SPRITE_NUM = $7FAB9E
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"
					LDA EXTRA_BITS,x
					AND #$04
					BNE INIT2
					LDA #$0D
					STA #$0D
					STA $151C,x
					STZ $C2,x
					STZ $1602,x
					LDA #$01
					STA $157C,x
					LDA #$04
					STA $1588,x
					LDA #$30
					STA $15AC,x
					RTL
INIT2				LDA #$80
					STA $7FF003
					LDA #$00
					STA $7FF001
					LDA #$01
					STA $157C,x
					LDA $E4,x
					CMP #$80
					BEQ GREEN_INIT
					CMP #$A0
					BEQ YELLOW_INIT
					CMP #$C0
					BEQ BLACK_INIT
					CMP #$E0
					BEQ RED_INIT
					RTL
GREEN_INIT			LDA #$07
					STA $151C,x
					LDA #$30
					STA $15AC,x
					LDA #$08
					STA $1602,x
					RTL
YELLOW_INIT			LDA #$0B
					STA $151C,x
					LDA #$60
					STA $15AC,x
					LDA #$08
					STA $1602,x
					RTL
BLACK_INIT			LDA #$0F
					STA $151C,x
					LDA #$90
					STA $15AC,x
					LDA #$08
					STA $1602,x
					RTL
RED_INIT			LDA #$0D
					STA $151C,x
					LDA #$C0
					STA $15AC,x
					LDA #$08
					STA $1602,x
					RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

X_SPEED2			dcb $20,$E0

RETURN              RTS
CODE_START          JSR SUB_GFX
					LDA $14C8,x 
                    CMP #$08
                    BNE RETURN           
                    LDA $9D  
                    BNE RETURN
					LDA EXTRA_BITS,x
					AND #$04
					BNE MODE2
					LDA $010B
					CMP #$AF
					BEQ MODE_GREEN0
					CMP #$B1
					BEQ MODE_YELLOW0
					CMP #$B3
					BEQ MODE_BLACK0
					CMP #$B5
					BEQ MODE_RED0
					RTS
MODE2				LDA $151C,x
					CMP #$07
					BEQ MODE2_GREEN0
					CMP #$0B
					BEQ MODE2_YELLOW0
					CMP #$0F
					BEQ MODE2_BLACK0
					CMP #$0D
					BEQ MODE2_RED0
					RTS
					
MODE_GREEN0			JSR MODE_GREEN
					RTS
MODE_YELLOW0		JSR MODE_YELLOW
					RTS
MODE_BLACK0			JSR MODE_BLACK
					RTS
MODE_RED0			JSR MODE_RED
					RTS
					
MODE2_GREEN0		JSR MODE2_GREEN
					RTS
MODE2_YELLOW0		JSR MODE2_YELLOW
					RTS
MODE2_BLACK0		JSR MODE2_BLACK
					RTS
MODE2_RED0			JSR MODE2_RED
					RTS

MODE_GREEN			LDA $C2,x
					CMP #$01
					BEQ GREEN_DOWN
					CMP #$02
					BEQ GREEN_SHELL
					JSR NEAR_CHECK
					CPY #$01
					BNE GREEN_R
					LDA #$02
					STA $C2,x
					LDA #$20
					STA $15AC,x
					RTS
GREEN_R				RTS
GREEN_DOWN			LDA #$FF
					STA $14AD
					STZ $B6,x
					LDA $13
					LSR A
					LSR A
					LSR A
					AND #$01
					CLC
					ADC #$06
					STA $1602,x
					JSL $01802A
					RTS
GREEN_SHELL			JSL $01802A
					JSR CHECK_DAMAGE
					LDA $13
					LSR A
					LSR A
					AND #$03
					CLC
					ADC #$02
					STA $1602,x
					LDA $157C,x
					BEQ FACE_RIGHT
					LDA $B6,x
					AND #$FE
					CMP #$D0
					BEQ GREEN_SHELL_2
					DEC $B6,x
					DEC $B6,x
					BRA GREEN_SHELL_2
FACE_RIGHT			LDA $B6,x
					AND #$FE
					CMP #$30
					BEQ GREEN_SHELL_2
					INC $B6,x
					INC $B6,x
GREEN_SHELL_2		LDA $15AC,x
					BNE GREEN_SHELL_3
					JSR SUB_GET_DIR
					TYA
					STA $157C,x
					LDA #$20
					STA $15AC,x
GREEN_SHELL_3		LDA $1588,x
					AND #$03
					BEQ GREEN_R2
					LDA #$01
					STA $1DF9
					LDA $157C,x
					INC A
					AND #$01
					STA $157C,x
					LDA #$00
					SEC
					SBC $B6,x
					STA $B6,x
GREEN_R2			RTS
					
MODE2_GREEN_L		LDA $C2,x
					CMP #$10
					BEQ MODE2_GREEN_L_2
					JSR MODE_GREEN
					RTS
MODE2_GREEN_L_2		JSL $01802A
					JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
					LDA $7FF009
					INC A
					STA $7FF009
					STZ $B6,x
					STZ $1602,x
					LDA $7FF009
					CMP #$30
					BCC MODE2_GREEN_L_R
					STZ $C2,x
					STZ $15AC,x
MODE2_GREEN_L_R		RTS

MODE2_GREEN			LDA $7FF001
					CMP #$03
					BEQ MODE2_GREEN_L
					LDA $C2,x
					CMP #$10
					BEQ MODE2_GREEN2
					LDA $7FF001
					CMP #$01
					BNE MODE2_GREEN_M
					LDA #$10
					STA $C2,x
					RTS
MODE2_GREEN_M		JSL $01802A
					LDA $15AC,x
					BNE MODE2_GREEN_W
					LDA $1588,x
					AND #$04
					BEQ MODE2_GREEN_R
					LDA #$0A
					STA $1602,x
MODE2_GREEN_R		RTS
MODE2_GREEN_W		CMP #$01
					BEQ MODE2_GREEN_W2
					STZ $AA,x
					RTS
MODE2_GREEN_W2		LDA #$2B
					STA $1DFC
					RTS
MODE2_GREEN2		LDA $7FF001
					CMP #$02
					BEQ MODE2_GREEN3
					LDA #$0B
					STA $1602,x
					RTS
MODE2_GREEN3		;JSL $01802A
					JSR CHECK_DAMAGE2
					;STZ $AA,x
					LDA $7FF002
					STA $1602,x
					LDA $7FF003
					STA $E4,x
					LDA $7FF004
					STA $157C,x
					RTS

NEAR_CHECK			LDY #$00
					LDA $E4,x
					SEC
					SBC $94
					STA $0F
					LDA $14E0,x
					SBC $95
					BNE NEAR_R
					LDA $0F
					CMP #$70
					BCS NEAR_R
					LDY #$01
NEAR_R				RTS

MODE_YELLOW			LDA $C2,x
					CMP #$01
					BEQ YELLOW_DOWN
					JSR CHECK_DAMAGE
					JSR SUB_GET_DIR
					TYA
					STA $157C,x
					LDA $1588,x
					AND #$04
					BNE YELLOW_GROUND
					LDA #$08
					STA $1602,x
					JSL $01802A
					LDA $1588,x
					AND #$04
					BEQ YELLOW_R
					LDA #$09
					STA $1DFC
					LDA #$40
					STA $15AC,x
					LDA #$20
					STA $1887
					LDA $77
					AND #$04
					BEQ YELLOW_R
					LDA #$20
					STA $18BD
					RTS
YELLOW_GROUND		JSL $01802A
					STZ $1602,x
					LDA $15AC,x
					BNE YELLOW_R
					LDA #$B0
					STA $AA,x
YELLOW_R			RTS
YELLOW_DOWN			LDA #$FF
					STA $14AD
					STZ $B6,x
					LDA $13
					LSR A
					LSR A
					LSR A
					AND #$01
					CLC
					ADC #$06
					STA $1602,x
					JSL $01802A
					LDA $7FF007
					CMP #$04
					BCC YELLOW_R
					INC $1528,x
					LDA $1528,x
					CMP #$80
					BNE YELLOW_R
					PHP
					SEP #$30
					LDA #$06
					STA $71
					STZ $89
					STZ $88
					PLP
					RTS
					
MODE2_YELLOW_L		LDA $C2,x
					CMP #$10
					BEQ MODE2_YELLOW_L_2
					JSR MODE_YELLOW
					RTS
MODE2_YELLOW_L_2	JSL $01802A
					LDA $1588,x
					AND #$04
					BEQ MODE2_YELLOW_L_AIR
					JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
					STZ $B6,x
					STZ $1602,x
					LDA $15AC,x
					CMP #$C0
					BCS MODE2_YELLOW_L_R
					STZ $C2,x
					STZ $15AC,x
					RTS
MODE2_YELLOW_L_AIR	LDA #$F0
					STA $15AC,x
					LDA #$01
					STA $157C,x
					LDA #$0A
					STA $1602,x
					STZ $B6,x
					LDA $E4,x
					CMP #$E0
					BCS MODE2_YELLOW_L_R
					LDA #$20
					STA $B6,x
MODE2_YELLOW_L_R	RTS

MODE2_YELLOW		LDA $7FF001
					CMP #$03
					BEQ MODE2_YELLOW_L
					LDA $C2,x
					CMP #$10
					BEQ MODE2_YELLOW2
					LDA $7FF001
					CMP #$01
					BNE MODE2_YELLOW_M
					LDA #$10
					STA $C2,x
					LDA #$10
					STA $15AC,x
					RTS
MODE2_YELLOW_M		JSL $01802A
					LDA $15AC,x
					BNE MODE2_YELLOW_W
					LDA $1588,x
					AND #$04
					BEQ MODE2_YELLOW_R
					LDA #$0A
					STA $1602,x
MODE2_YELLOW_R		RTS
MODE2_YELLOW_W		CMP #$01
					BEQ MODE2_YELLOW_W2
					STZ $AA,x
					RTS
MODE2_YELLOW_W2		LDA #$2B
					STA $1DFC
					RTS
MODE2_YELLOW2		LDA $7FF001
					CMP #$02
					BEQ MODE2_YELLOW3
					JSL $01802A
					LDA $15AC,x
					BNE MODE2_YELLOW2_2
					LDA #$08
					STA $1602,x
					LDA $E4,x
					CMP #$81
					BCS MODE2_YELLOW_R
					LDA #$80
					STA $E4,x
					STZ $B6,x
					LDA $D8,x
					CMP #$54
					BCC MODE2_YELLOW_R
					LDA #$54
					STA $D8,x
					STZ $AA,x
					LDA #$0B
					STA $1602,x
					RTS
MODE2_YELLOW2_2		CMP #$01
					BNE MODE2_YELLOW_R
					LDA #$B0
					STA $AA,x
					LDA #$F4
					STA $B6,x
					RTS
MODE2_YELLOW3		;JSL $01802A
					JSR CHECK_DAMAGE2
					;STZ $AA,x
					LDA $7FF005
					STA $1602,x
					LDA $7FF003
					STA $E4,x
					LDA $7FF004
					STA $157C,x
					RTS
					
MODE_BLACK			LDA $C2,x
					CMP #$01
					BEQ BLACK_DOWN
					CMP #$02
					BEQ BLACK_ATACK
					JSR SUB_GET_DIR
					TYA
					STA $157C,x
					STZ $1602,x
					JSL $01802A
					LDA $15AC,x
					BNE BLACK_R
					LDA #$02
					STA $C2,x
BLACK_R				RTS
BLACK_DOWN			LDA #$FF
					STA $14AD
					STZ $B6,x
					LDA $13
					LSR A
					LSR A
					LSR A
					AND #$01
					CLC
					ADC #$06
					STA $1602,x
					JSL $01802A
					RTS
BLACK_ATACK			JSL $01802A
					JSR CHECK_DAMAGE
					LDA $13
					LSR A
					LSR A
					AND #$03
					CLC
					ADC #$02
					STA $1602,x
					LDA $1588,x
					AND #$03
					CMP #$01
					BNE BLACK_2
					LDA #$01
					STA $157C,x
					BRA BLACK_3
BLACK_2				CMP #$02
					BNE BLACK_3
					STZ $157C,x
BLACK_3
					LDA $157C,x
					PHX
					TAX
					LDA X_SPEED2,x
					PLX
					STA $B6,x
					LDA $1588,x
					AND #$04
					BEQ BLACK_E
					JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
					LDA #$B0
					STA $AA,x
BLACK_E				RTS

MODE2_BLACK_L		LDA $C2,x
					CMP #$10
					BEQ MODE2_BLACK_L_2
					JSR MODE_BLACK
					RTS
MODE2_BLACK_L_2		JSL $01802A
					LDA $1588,x
					AND #$04
					BEQ MODE2_BLACK_L_AIR
					JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
					STZ $B6,x
					STZ $1602,x
					LDA $15AC,x
					CMP #$C0
					BCS MODE2_BLACK_L_R
					STZ $C2,x
					STZ $15AC,x
					RTS
MODE2_BLACK_L_AIR	LDA #$F0
					STA $15AC,x
					LDA #$01
					STA $157C,x
					LDA #$0A
					STA $1602,x
					STZ $B6,x
					LDA $E4,x
					CMP #$E0
					BCS MODE2_BLACK_L_R
					LDA #$30
					STA $B6,x
MODE2_BLACK_L_R		RTS

MODE2_BLACK			LDA $7FF001
					CMP #$03
					BEQ MODE2_BLACK_L
					LDA $C2,x
					CMP #$10
					BEQ MODE2_BLACK2
					LDA $7FF001
					CMP #$01
					BNE MODE2_BLACK_M
					LDA #$10
					STA $C2,x
					LDA #$30
					STA $15AC,x
					RTS
MODE2_BLACK_M		JSL $01802A
					LDA $15AC,x
					BNE MODE2_BLACK_W
					LDA $1588,x
					AND #$04
					BEQ MODE2_BLACK_R
					LDA #$0A
					STA $1602,x
MODE2_BLACK_R		RTS
MODE2_BLACK_W		CMP #$01
					BEQ MODE2_BLACK_W2
					STZ $AA,x
					RTS
MODE2_BLACK_W2		LDA #$2B
					STA $1DFC
					RTS
MODE2_BLACK2		LDA $7FF001
					CMP #$02
					BEQ MODE2_BLACK3
					JSL $01802A
					LDA $15AC,x
					BNE MODE2_BLACK2_2
					LDA #$08
					STA $1602,x
					LDA $E4,x
					CMP #$81
					BCS MODE2_BLACK_R
					LDA #$80
					STA $E4,x
					STZ $B6,x
					LDA $D8,x
					CMP #$48
					BCC MODE2_BLACK_R
					LDA #$48
					STA $D8,x
					STZ $AA,x
					LDA #$0B
					STA $1602,x
					RTS
MODE2_BLACK2_2		CMP #$01
					BNE MODE2_BLACK_R
					LDA #$B0
					STA $AA,x
					LDA #$EC
					STA $B6,x
					RTS

MODE2_BLACK3		;JSL $01802A
					JSR CHECK_DAMAGE2
					;STZ $AA,x
					LDA $7FF006
					STA $1602,x
					LDA $7FF003
					STA $E4,x
					LDA $7FF004
					STA $157C,x
					RTS
					
MODE_RED			LDA $C2,x
					CMP #$01
					BEQ RED_DOWN
					CMP #$02
					BEQ RED_ATACK
					JSR SUB_GET_DIR
					TYA
					STA $157C,x
					STZ $1602,x
					JSL $01802A
					LDA $15AC,x
					BNE RED_R
					LDA #$02
					STA $C2,x
RED_R				RTS
RED_ATACK			JSL $01802A
					JSR CHECK_DAMAGE
					LDA #$09
					STA $1602,x
					JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
					LDA $15AC,x
					BNE RED_R
					LDA #$40
					STA $15AC,x
					LDA #$06
					STA $1DFC
					JSR SUB_HAMMER_THROW
					RTS
RED_DOWN			STZ $B6,x
					LDA $13
					LSR A
					LSR A
					LSR A
					AND #$01
					CLC
					ADC #$06
					STA $1602,x
					JSL $01802A
					RTS
					
MODE2_RED_L			LDA $C2,x
					CMP #$10
					BEQ MODE2_RED_L_2
					JSR MODE_RED
					RTS
MODE2_RED_L_2		JSL $01802A
					LDA $1588,x
					AND #$04
					BEQ MODE2_RED_L_AIR
					JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
					STZ $B6,x
					STZ $1602,x
					LDA $15AC,x
					CMP #$C0
					BCS MODE2_RED_L_R
					STZ $C2,x
					STZ $15AC,x
					RTS
MODE2_RED_L_AIR		LDA #$F0
					STA $15AC,x
					LDA #$01
					STA $157C,x
					LDA #$0A
					STA $1602,x
					STZ $B6,x
					LDA $E4,x
					CMP #$E0
					BCS MODE2_RED_L_R
					LDA #$40
					STA $B6,x
MODE2_RED_L_R		RTS

MODE2_RED			LDA $7FF001
					CMP #$03
					BEQ MODE2_RED_L
					LDA $C2,x
					CMP #$10
					BEQ MODE2_RED2
					LDA $7FF001
					CMP #$01
					BNE MODE2_RED_M
					LDA #$10
					STA $C2,x
					LDA #$50
					STA $15AC,x
					RTS
MODE2_RED_M			JSL $01802A
					LDA #$01
					STA $76
					STZ $7B
					STZ $7D
					LDA $15AC,x
					BNE MODE2_RED_W
					LDA $1602,x
					CMP #$0A
					BEQ MESSAGE
					LDA $1588,x
					AND #$04
					BEQ MODE2_RED_R
					LDA #$0A
					STA $1602,x
					RTS
MESSAGE				LDA #$02
					STA $1426
					LDA #$01
					STA $7FF001
MODE2_RED_R			RTS
MODE2_RED_W			CMP #$01
					BEQ MODE2_RED_W2
					STZ $AA,x
					RTS
MODE2_RED_W2		LDA #$2B
					STA $1DFC
					RTS
MODE2_RED2			LDA $7FF001
					CMP #$02
					BEQ MODE2_RED3
					JSL $01802A
					LDA $15AC,x
					BNE MODE2_RED2_2
					LDA #$08
					STA $1602,x
					LDA $E4,x
					CMP #$81
					BCS MODE2_RED_R
					LDA #$80
					STA $E4,x
					STZ $B6,x
					LDA $D8,x
					CMP #$3C
					BCC MODE2_RED_R
					LDA #$3C
					STA $D8,x
					STZ $AA,x
					LDA #$0B
					STA $1602,x
					LDA #$02
					STA $7FF001
					LDA #$FF
					STA $15AC,x
					RTS
MODE2_RED2_2		CMP #$01
					BNE MODE2_RED_R
					LDA #$B0
					STA $AA,x
					LDA #$D8
					STA $B6,x
					RTS
MODE2_RED3			JSL $01802A
					JSR CHECK_DAMAGE3
					LDA $E4,x
					STA $7FF003
					STZ $AA,x
					LDA $1528,x
					BNE MODE2_RED4_0
					LDA $15AC,x
					CMP #$E0
					BCC MODE2_RED3_2
					LDA $13
					LSR A
					LSR A
					AND #$03
					CLC
					ADC #$02
					STA $1602,x
					STA $7FF002
					STA $7FF005
					STA $7FF006
					RTS
MODE2_RED3_2		LDA $13
					LSR A
					AND #$03
					CLC
					ADC #$02
					STA $1602,x
					STA $7FF002
					STA $7FF005
					STA $7FF006
					LDA $15AC,x
					CMP #$C0
					BCS MODE2_RED3_R
					CMP #$A0
					BCC MODE2_RED3_3
					LDA $157C,x
					BEQ MODE2_RED3_2_2
					DEC $B6,x
					DEC $B6,x
					RTS
MODE2_RED3_2_2		INC $B6,x
					INC $B6,x
MODE2_RED3_R		RTS
MODE2_RED4_0		BRA MODE2_RED4
MODE2_RED3_3		LDA $1588,x
					AND #$03
					BEQ MODE2_RED3_4
					LDA #$00
					SEC
					SBC $B6,x
					STA $B6,x
MODE2_RED3_4		LDA $15AC,x
					BEQ MODE2_RED3_6
					CMP #$20
					BCC MODE2_RED3_5
					RTS
MODE2_RED3_5		LDA $B6,x
					CMP #$80
					BCC MODE2_RED3_5_R
					INC $B6,x
					INC $B6,x
					RTS
MODE2_RED3_5_R		DEC $B6,x
					DEC $B6,x
					RTS
MODE2_RED3_6		STZ $B6,x
					LDA #$01
					STA $1528,x
					LDA #$FF
					STA $15AC,x
					RTS
MODE2_RED4			LDA $15AC,x
					CMP #$E8
					BCC MODE2_RED4_3
					LDA $13
					LSR A
					AND #$03
					CLC
					ADC #$02
					STA $1602,x
					STA $7FF002
					STA $7FF005
					STA $7FF006
					JSR SUB_GET_DIR
					TYA
					STA $157C,x
					STA $7FF004
					RTS
MODE2_RED4_3		CMP #$D0
					BCC MODE2_RED4_4
					LDA #$0B
					STA $7FF002
					LDA $13
					LSR A
					LSR A
					AND #$03
					CLC
					ADC #$02
					STA $1602,x
					STA $7FF005
					STA $7FF006
					RTS
MODE2_RED4_4		CMP #$B8
					BCC MODE2_RED4_5
					LDA #$0B
					STA $7FF005
					LDA $13
					LSR A
					LSR A
					AND #$03
					CLC
					ADC #$02
					STA $1602,x
					STA $7FF006
					RTS
MODE2_RED4_5		CMP #$A0
					BCC MODE2_RED4_6
					LDA #$0B
					STA $7FF006
					LDA $13
					LSR A
					LSR A
					AND #$03
					CLC
					ADC #$02
					STA $1602,x
					RTS
MODE2_RED4_6		CMP #$50
					BCC MODE2_RED4_7
					LDA #$09
					STA $1602,x
					LDA $15AC,x
					CMP #$91
					BCS MODE2_RED4_6_R
					JSR HDMA
					LDA $15AC,x
					CMP #$90
					BNE MODE2_RED4_6_R
					LDA #$01
					STA $1DFC
					JSR GEN_STAR
MODE2_RED4_6_R		RTS
MODE2_RED4_7		LDA #$00
					STA $7FE201
					STA $7FE202
					LDA #$02
					STA $7FF001
					LDA #$FF
					STA $15AC,x
					STZ $1528,x
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; hammer routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

X_OFFSET            dcb $0C,$F0
X_OFFSET2           dcb $00,$FF

RETURN68            RTS     
SUB_HAMMER_THROW    JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    PHX
                    LDA #$41
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX

                    PHY
                    LDA $157C,x
                    TAY
                    LDA $E4,x               ; \ set x position for new sprite
                    CLC
                    ADC X_OFFSET,y
                    PLY
                    STA $00E4,y

                    PHY
                    LDA $157C,x
                    TAY
                    LDA $14E0,x             ;  |
                    ADC X_OFFSET2,y
                    PLY
                    STA $14E0,y             ; /

                    LDA $D8,x               ; \ set y position for new sprite
                    SEC                     ;  | (y position of generator - 1)
                    SBC #$06                ;  |
                    STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
                    SBC #$00                ;  |
                    STA $14D4,y             ; /

                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX                     ; / 
                    
                    LDA $157C,x
                    STA $157C,y
                    
                    
RETURN67            RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Contact Mario
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CHECK_DAMAGE		JSL $01A7DC
					BCC NO_DAMAGE
					LDA $7D
					CMP #$10
					BMI ENE_WINS
					LDA #$B0
					STA $7D
					JSL $01AB99             ; display contact graphic
					LDA #$03
                    STA $1DF9
					LDA #$01
					STA $C2,x
					LDA $7FF007
					INC A
					STA $7FF007
NO_DAMAGE			RTS

ENE_WINS            LDA $1497               ; \ if mario is invincible...
                    BNE RETURN2             ; /   ... return
                    JSL $00F5B7             ; hurt mario
RETURN2             RTS

CHECK_DAMAGE2		JSL $01A7DC
					BCC RETURN2
		            LDA $1497               ; \ if mario is invincible...
                    BNE RETURN2             ; /   ... return
                    JSL $00F5B7             ; hurt mario
					RTS

CHECK_DAMAGE3		JSL $01A7DC
					BCC NO_DAMAGE3
					LDA $7D
					CMP #$10
					BMI ENE_WINS3
					LDA #$B0
					STA $7D
					JSL $01AB99             ; display contact graphic
					LDA $1602,x
					CMP #$09
					BEQ MARIO_WINS
					LDA #$03
                    STA $1DF9
NO_DAMAGE3			RTS

ENE_WINS3           LDA $1497               ; \ if mario is invincible...
                    BNE RETURN23             ; /   ... return
                    JSL $00F5B7             ; hurt mario
RETURN23            RTS
MARIO_WINS			LDA #$28
                    STA $1DFC
					LDA #$03
					STA $7FF001
					LDA #$00
					STA $7FE201
					STA $7FE202
					LDA #$11
					STA $7FE20F
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP             dcb $40,$42,$60,$62,$44,$46,$64,$66,$48,$4A,$68,$6A,$4C,$4E,$6C,$6E
					dcb $4C,$4E,$6C,$6E,$C0,$C2,$E0,$E2,$80,$82,$A0,$A2,$84,$86,$A4,$A6
					dcb $08,$0A,$28,$2A,$00,$02,$20,$22,$0C,$0E,$2C,$2E,$04,$06,$24,$26
HORIZ_DISP          dcb $08,$F8,$08,$F8,$F8,$08,$F8,$08
VERT_DISP           dcb $F0,$F0,$00,$00,$F0,$F0,$00,$00
PROPERTIES          dcb $40,$40,$40,$40,$00,$00,$00,$00


SUB_GFX             JSR GET_DRAW_INFO
                    PHX                   
					LDA $1602,x
					ASL A
					ASL A
					STA $02
					LDA $157C,x
					ASL A
					ASL A
					STA $03
					LDA $151C,x
					STA $0F
					
                    
                    LDX #$03                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START          PHX                     ; push, current tile
                    
					PHX
					TXA
					CLC
					ADC $03
					TAX
					
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP,x        ; |
                    STA $0300,y             ; /
                    
                    LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP,x         ; |
                    STA $0301,y             ; /
					
					LDA PROPERTIES,x
					ORA $0F
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
					PLX

					PHX
					TXA
					CLC
					ADC $02
					TAX
                    LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /
					PLX

                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817                ; Y = 1 if contact

SUB_GET_DIR         LDY #$00                
                    LDA $94                 
                    SEC                     
                    SBC $E4,x               
                    STA $0F                 
                    LDA $95                 
                    SBC $14E0,x             
                    BPL LABEL16             
                    INY                    
LABEL16             RTS                     

HDMA				LDA $7FE20F
					CMP #$11
					BEQ LABEL16
					LDA #$14
					STA $00212C
					LDA #$03
					STA $00212D
					LDA $7FFB28
					BNE HDMA1
					LDA #$20
					STA $7FFB28
					LDA #$40
					STA $7FFB30
					LDA #$00
					STA $7FFB29
					LDA #$02
					STA $7FFB31
					LDA #$21
					STA $7FFB2A
					LDA #$22
					STA $7FFB32
					LDA #$00
					STA $7FFB2B
					STA $7FFB33
					LDA #$E1
					STA $7FFB2C
					LDA #$E2
					STA $7FFB34
					LDA #$7F
					STA $7FFB2D
					STA $7FFB35
					LDA #$07
					STA $7FE100
					STA $7FE200
					LDA #$00
					STA $7FE101
					LDA #$00
					STA $7FE201
					LDA #$00
					STA $7FE202
					LDA #$00
					STA $7FE102
					STA $7FE203
HDMA1				LDA $15AC,x
					AND #$01
					BNE HDMA_R
					LDA $15AC,x
					CMP #$70
					BCC HDMA2
					LDA $7FE201
					CLC
					ADC #$21
					STA $7FE201
					LDA $7FE202
					ADC #$04
					STA $7FE202
					RTS
HDMA2				LDA $7FE201
					SEC
					SBC #$21
					STA $7FE201
					LDA $7FE202
					SBC #$04
					STA $7FE202
HDMA_R				RTS


X2_OFFSET            dcb $16,$EA
X2_OFFSET2           dcb $00,$FF

RETURN67            RTS
GEN_STAR            JSL $02A9DE             ; \ ge slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
					INC A
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
					PHX
					LDA $157C,x
					TAX
					LDA X2_OFFSET,x
					STA $02
					LDA X2_OFFSET2,x
					STA $03
					PLX
					
                    LDA $E4,x               ;\ set x position for new sprite
					CLC
					ADC $02
                    STA $00E4,y

                    LDA $14E0,x             ;  |
					ADC $03
                    STA $14E0,y             ; /

                    LDA $D8,x               ;\ set y position for new sprite
					SEC
					SBC #$06
                    STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
					SBC #$00
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
					LDA #$30
					STA $15AC,y
					LDA #$02
					STA $00C2,y
					LDA #$CE
					STA $1570,y
                    RTS                          ; return
