;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Carmilla
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"
					STZ $187B,x
                    PHY
                    JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
                    PLY
					LDA EXTRA_BITS,x
					AND #$04
					BNE INIT_2
					JSR HDMA_COLOR
					LDA #$0D
					STA $1602,x
					LDA #$08
					STA $1B9A
					LDA #$80
					STA $15AC,x
					RTL
INIT_2				LDA #$09
					STA $167A,x
					LDA #$0B
					STA $166E,x
					LDA #$40
					STA $15AC,x
					LDA #$0D
					STA $151C,x
					LDA $E4,x
					AND #$10
					BEQ INIT_E
					LDA #$0F
					STA $151C,x
INIT_E              RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X_SPEED             dcb $0C,$F4
X_SPEED2            dcb $20,$E0
X_SPEED3			dcb $30,$D0

RETURN              RTS
CODE_START          LDA $C2,x
					CMP #$10
					BNE MAIN1
					JSR HEART1
					RTS
MAIN1				CMP #$11
					BNE MAIN2
					JSR HEART2
					RTS
MAIN2				CMP #$12
					BNE MAIN3
					JSR HEART3
					RTS
MAIN3				CMP #$13
					BNE MAIN4
					JSR HEART4
					RTS
MAIN4				CMP #$14
					BNE MAIN5
					JSR HEART5
					RTS
MAIN5				JSR SUB_GFX
					LDA $14C8,x             ; \ 
					BEQ RETURN
                    CMP #$02                ;  | if status != 8, return
                    BEQ RETURN11
					LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
					LDA #$BB
					STA $1662,x
					LDA EXTRA_BITS,x
					AND #$04
					BEQ QUEEN
					JSL $01802A
					JSL $01A7DC				 ; check for mario/sprite contact
                    JSR SUB_OFF_SCREEN_X0   ; handle off screen situation
					LDA $C2,x
					BNE NORMAL2
					JSR MODE0
					RTS
NORMAL2				JSR MODE1
					RTS
RETURN11			LDA #$07
					STA $1602,x
					RTS
					
QUEEN				LDA $E4,x
					STA $7FFDF0
					LDA $14E0,x
					STA $7FFDF1
					LDA $D8,x
					SEC
					SBC #$08
					STA $7FFDF2
					LDA $14D4,x
					SBC #$00
					STA $7FFDF3
					LDA #$10
					STA $00212C
					LDA #$0F
					STA $00212D
					STZ $149F
					PHP
					REP #$30
					LDA $1466
					CLC
					ADC.W #$0001
					STA $1466
					PLP
					LDA $16
					BNE QUEEN0
					LDA $18
					BNE QUEEN0
					BRA QUEEN1
QUEEN0				INC $1594,x
QUEEN1
					JSR DIRECTION_CHECK
					LDA $1540,x
					BNE QUEEN_R
					JSL $01802A
					LDA $C2,x
					BNE NOT_Q_MODE0
					JSR Q_MODE0
QUEEN_R				RTS
NOT_Q_MODE0			CMP #$01
					BNE NOT_Q_MODE1
					JSR Q_MODE1
					RTS
NOT_Q_MODE1			CMP #$02
					BNE NOT_Q_MODE2
					JSR Q_MODE2
					RTS
NOT_Q_MODE2			CMP #$03
					BNE NOT_Q_MODE3
					JSR Q_MODE3
					RTS
NOT_Q_MODE3			CMP #$04
					BNE NOT_Q_MODE4
					JSR Q_MODE4
					RTS
NOT_Q_MODE4			CMP #$05
					BNE NOT_Q_MODE5
					JSR Q_MODE5
					RTS
NOT_Q_MODE5			CMP #$06
					BNE NOT_Q_MODE6
					JSR Q_MODE6
					RTS
NOT_Q_MODE6			JSR Q_MODE7
					RTS


X_SPEED1			dcb $10,$F0

MODE0				LDA #$0D
					STA $1602,x
					LDA $15AC,x
					BEQ MODE0_2
					LDY $157C,x
					LDA X_SPEED1,y
					STA $B6,x
					RTS
MODE0_2				JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
					LDA #$40
					STA $15AC,x
					LDA #$01
					STA $C2,x
					RTS
MODE1				LDA #$04
					STA $1602,x
					LDA $15AC,x
					BEQ MODE1_1
					CMP #$3F
					BEQ MODE1_2
					STZ $AA,x
					STZ $B6,x
					RTS
MODE1_1				LDA #$80
					STA $15AC,x
					STZ $C2,x
					RTS
MODE1_2				JSR GEN_HEART
					LDA #$10
					STA $00C2,y
					LDA #$FF
					STA $15AC,y
					RTS


Q_MODE0				JSR DAMAGE_CHECK2
					LDA $15AC,x
					BEQ Q_MODE0_2
					LDY $157C,x
					LDA X_SPEED1,y
					STA $B6,x
					LDA $14
					AND #$10
					BEQ Q_MODE0_1
					LDA #$08
					STA $AA,x
					RTS
Q_MODE0_1			LDA #$F8
					STA $AA,x
					RTS
Q_MODE0_2			STZ $B6,x
					STZ $AA,x
					JSR MODE_CHANGE
					RTS
					
Q_MODE1				JSR DAMAGE_CHECK2
					STZ $AA,x
					STZ $B6,x
					LDA $15AC,x
					BEQ Q_MODE1_3
					CMP #$20
					BCS Q_MODE1_1
					LDA #$01
					STA $1602,x
					LDA $15AC,x
					CMP #$1E
					BEQ Q_MODE1_2
					RTS
Q_MODE1_1			LDA #$03
					STA $1602,x
					RTS
Q_MODE1_2			JSR GEN_HEART
					LDA #$10
					STA $00C2,y
					LDA #$FF
					STA $15AC,y
					JSR GEN_HEART
					LDA #$40
					STA $1504,y
					LDA #$10
					STA $00C2,y
					LDA #$FF
					STA $15AC,y
					RTS
Q_MODE1_3			LDA #$80
					STA $15AC,x
					STZ $C2,x
					LDA #$01
					STA $14D4,x
					LDA #$10
					STA $D8,x
					LDA #$0D
					STA $1602,x
					RTS

Q_MODE2				JSR DAMAGE_CHECK2
					STZ $AA,x
					STZ $B6,x
					LDA $15AC,x
					BEQ Q_MODE2_3
					CMP #$20
					BCS Q_MODE2_1
					LDA #$01
					STA $1602,x
					LDA $15AC,x
					CMP #$1E
					BEQ Q_MODE2_2
					RTS
Q_MODE2_1			LDA #$02
					STA $1602,x
					RTS
Q_MODE2_2			JSR GEN_HEART
					LDA #$20
					STA $00B6,y
					LDA #$11
					STA $00C2,y
					JSR GEN_HEART
					LDA #$10
					STA $00B6,y
					LDA #$11
					STA $00C2,y
					JSR GEN_HEART
					LDA #$F0
					STA $00B6,y
					LDA #$11
					STA $00C2,y
					JSR GEN_HEART
					LDA #$E0
					STA $00B6,y
					LDA #$11
					STA $00C2,y
					RTS
Q_MODE2_3			LDA #$80
					STA $15AC,x
					STZ $C2,x
					LDA #$01
					STA $14D4,x
					LDA #$10
					STA $D8,x
					LDA #$0D
					STA $1602,x
					RTS
					
Q_MODE3				JSR DAMAGE_CHECK
					LDA $1588,x
					AND #$04
					BNE Q_MODE3_G
					LDA $151C,x
					BNE Q_MODE3_G
					LDA #$20
					STA $AA,x
					LDA #$05
					STA $1602,x
					LDA #$FF
					STA $1570,x
					RTS
Q_MODE3_G			DEC $1570,x
					LDA #$01
					STA $151C,x
					STZ $B6,x
					LDA $1570,x
					CMP #$E8
					BCC Q_MODE3_2
					LDA #$04
					STA $1602,x
					JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
					RTS
Q_MODE3_2			LDA #$09
					STA $1602,x
					LDA $1570,x
					CMP #$C8
					BCC Q_MODE3_3
					LDY $157C,x
					LDA X_SPEED2,y
					STA $B6,x
					LDA $1570,x
					CMP #$E7
					BNE Q_MODE3_R
					JSR GEN_HEART
					LDA #$12
					STA $00C2,y
					LDA $157C,x
					STA $157C,y
					RTS
Q_MODE3_3			CMP #$C0
					BCS Q_MODE3_R
					LDA #$0A
					STA $1602,x
					LDA $1570,x
					CMP #$A0
					BCC Q_MODE3_4
					LDY $157C,x
					LDA X_SPEED2,y
					STA $B6,x
					LDA $1570,x
					CMP #$BF
					BNE Q_MODE3_R
					JSR GEN_HEART
					LDA #$12
					STA $00C2,y
					LDA $157C,x
					STA $157C,y
					RTS
Q_MODE3_4			CMP #$90
					BCS Q_MODE3_R
					CMP #$68
					BEQ Q_MODE3_5
					LDA #$06
					STA $1602,x
					LDA #$E0
					STA $AA,x
					RTS
Q_MODE3_5			STZ $AA,x
					LDA #$0D
					STA $1602,x
					LDA #$80
					STA $15AC,x
					STZ $C2,x
					STZ $151C,x
					LDA #$01
					STA $14D4,x
					LDA #$10
					STA $D8,x
					STZ $1570,x
					STZ $187B,x
Q_MODE3_R			RTS

Q_MODE5				JSR DAMAGE_CHECK2
					STZ $AA,x
					STZ $B6,x
					LDA $15AC,x
					CMP #$E0
					BCC Q_MODE4_1
					LDA #$04
					STA $1602,x
					RTS
Q_MODE4_1			CMP #$D8
					BCC Q_MODE4_2
					LDA #$0E
					STA $1602,x
					RTS
Q_MODE4_2			CMP #$C8
					BCC Q_MODE4_3
					LDA #$08
					STA $1602,x
					LDA $15AC,x
					CMP #$D0
					BNE Q_MODE4_R
					LDA $157C,x
					EOR #$01
					STA $157C,x
					RTS
Q_MODE4_3			CMP #$C0
					BCC Q_MODE4_4
					LDA #$0E
					STA $1602,x
					LDA $15AC,x
					CMP #$C0
					BNE Q_MODE4_R
					LDA $157C,x
					EOR #$01
					STA $157C,x
					RTS
Q_MODE4_4			CMP #$B8
					BCS Q_MODE4_R
					CMP #$9A
					BCC Q_MODE4_5
					CMP #$B7
					BNE Q_MODE4_4_2
					LDA #$01
					STA $1DFC
Q_MODE4_4_2			LDA #$0C
					STA $1602,x
					JSR PINK
					LDA $15AC,x
					CMP #$9A
					BNE Q_MODE4_R
					JSR HDMA_COLOR
					JSR GEN_HEART
					LDA #$13
					STA $00C2,y
					RTS
Q_MODE4_5			CMP #$60
					BCS Q_MODE4_R
					LDA #$83
					STA $15AC,x
					STZ $C2,x
					LDA #$0D
					STA $1602,x
					LDA #$01
					STA $14D4,x
					LDA #$10
					STA $D8,x
Q_MODE4_R			RTS

Q_MODE4				JSR DAMAGE_CHECK
					STZ $B6,x
					LDA $1588,x
					AND #$04
					BNE Q_MODE5_G
					LDA $151C,x
					BNE Q_MODE5_G
					LDA #$20
					STA $AA,x
					LDA #$05
					STA $1602,x
					LDA #$FF
					STA $1570,x
					RTS
Q_MODE5_G			DEC $1570,x
					LDA #$01
					STA $151C,x
					LDA $1570,x
					CMP #$E8
					BCC Q_MODE5_2
					LDA #$04
					STA $1602,x
					RTS
Q_MODE5_2			CMP #$D0
					BCC Q_MODE5_3
					LDA #$03
					STA $1602,x
					RTS
Q_MODE5_3			CMP #$90
					BCC Q_MODE5_4
					LDA #$01
					STA $1602,x
					LDA $1570,x
					CMP #$CF
					BNE Q_MODE5_R
					JSR GEN_HEART
					LDA #$14
					STA $00C2,y
					LDA #$E0
					STA $00B6,y
					JSR GEN_HEART
					LDA #$14
					STA $00C2,y
					LDA #$E0
					STA $00B6,y
					LDA #$01
					STA $151C,y
					JSR GEN_HEART
					LDA #$14
					STA $00C2,y
					LDA #$20
					STA $00B6,y
					JSR GEN_HEART
					LDA #$14
					STA $00C2,y
					LDA #$20
					STA $00B6,y
					LDA #$01
					STA $151C,y
					RTS
Q_MODE5_4			CMP #$68
					BEQ Q_MODE5_5
					LDA #$06
					STA $1602,x
					LDA #$E0
					STA $AA,x
					RTS
Q_MODE5_5			STZ $AA,x
					LDA #$0D
					STA $1602,x
					LDA #$80
					STA $15AC,x
					STZ $C2,x
					STZ $151C,x
					LDA #$01
					STA $14D4,x
					LDA #$10
					STA $D8,x
					STZ $1570,x
					STZ $187B,x
Q_MODE5_R			RTS

Q_MODE6				JSR DAMAGE_CHECK2
					STZ $AA,x
					STZ $B6,x
					LDA $15AC,x
					CMP #$40
					BCC Q_MODE6_2
					LDA #$05
					STA $1602,x
					RTS
Q_MODE6_2			CMP #$20
					BCC Q_MODE6_3
					LDA #$01
					STA $1602,x
					LDA $15AC,x
					CMP #$3F
					BNE Q_MODE6_R
					JSR GEN_HEART
					LDA #$14
					STA $00C2,y
					LDA #$01
					STA $1594,y
					LDA $1528,x
					CMP #$06
					BCS Q_MODE6_2_2
					TYA
					STA $7FFDF4
Q_MODE6_R			RTS
Q_MODE6_2_2			PHX
					LDA $7FFDF4
					TAX
					LDA $1504,x
					STA $1504,y
					LDA $151C,x
					EOR #$01
					STA $151C,y
					PLX
					RTS
Q_MODE6_3			LDA #$0D
					STA $1602,x
					STZ $C2,x
					LDA #$80
					STA $15AC,x
					LDA #$01
					STA $14D4,x
					LDA #$10
					STA $D8,x
					RTS
					
Q_MODE7				LDA #$0F
					STA $1602,x
					LDA $15AC,x
					CMP #$B0
					BCC Q_MODE7_2
					LDY $157C,x
					LDA X_SPEED2,y
					STA $B6,x
					RTS
Q_MODE7_2			CMP #$40
					BEQ Q_MODE7_3
					STZ $B6,x
					RTS
Q_MODE7_3			LDA #$06
					STA $71
					STZ $89
					STZ $88
					RTS

MODE_CHANGE			LDA $1528,x
					CMP #$07
					BEQ CHANGE2
					CMP #$02
					BEQ CHANGE3
					CMP #$05
					BEQ CHANGE3
					LDA $1594,x
					CLC
					ADC $94
					AND #$03
					INC A
					STA $C2,x
					LDA #$60
					STA $15AC,x
CHANGE_R			RTS
CHANGE2				LDA #$FF
					STA $15AC,x
					LDA #$05
					STA $C2,x
					INC $1528,x
					RTS
CHANGE3				LDA #$60
					STA $15AC,x
					LDA #$06
					STA $C2,x
					INC $1528,x
					RTS


DAMAGE_CHECK2		JSL $01A7DC
					BCC RETURN22
					BRA ENE_WINS
DAMAGE_CHECK		LDA $187B,x
					BNE RETURN22
					JSL $01A7DC
					BCC RETURN22
					LDA $7D
					CMP #$80
					BCS ENE_WINS
					CMP #$10
					BCC ENE_WINS
					LDA #$B0
					STA $7D
					JSL $01AB99             ; display contact graphic
					LDA #$20
                    STA $1DF9
					INC $1528,x
					LDA $1528,x
					CMP #$09
					BCS WIN2
					LDA #$40
					STA $1540,x
					LDA #$01
					STA $187B,x
					RTS
WIN2				LDA #$1E
					STA $1DFB
					LDA #$FF
					STA $15AC,x
					LDA #$07
					STA $C2,x
					STX $0F
					LDY #$00
WIN2_L				CPY $0F
					BEQ WIN2_2
					LDA $00C2,y
					BEQ WIN2_2
					LDA #$00
					STA $14C8,y
WIN2_2				INY
					CPY #$0A
					BNE WIN2_L
					RTS
ENE_WINS            LDA $1497               ; \ if mario is invincible...
                    BNE RETURN22             ; /   ... return
                    JSL $00F5B7             ; hurt mario
RETURN22            RTS


DIRECTION_CHECK		LDA $14E0,x
					CMP #$FF
					BEQ TURN_RIGHT
					CMP #$01
					BEQ TURN_LEFT
					LDA $E4,x
					CMP #$F0
					BCS TURN_LEFT
					CMP #$10
					BCC TURN_RIGHT
					RTS
TURN_RIGHT			STZ $157C,x
					RTS
TURN_LEFT			LDA #$01
					STA $157C,x
					RTS
					
SUB_SMOKE           LDY #$03                ; \ find a free slot to display effect
FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
                    RTS                     ; / return if no slots open
FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    ;LDA $178B,x
					LDA $D8,x 
                    STA $17C4,y             ; /
                    LDA #$1B                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $E4,x             ; \ load generator x position
                    STA $17C8,y             ; /
                    RTS          
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HORIZ_DISP          dcb $F8,$08,$F8,$08,$08,$F8,$08,$F8
HORIZ_DISP2         dcb $00,$10,$F8,$F0,$00,$F0,$08,$10
VERT_DISP           dcb $F0,$F0,$00,$00
VERT_DISP2          dcb $00,$00,$10,$00
TILEMAP             dcb $80,$82,$A0,$A2,$84,$86,$A4,$A6,$88,$8A,$A8,$AA,$8C,$8E,$AC,$AE
					dcb $C0,$C2,$E0,$E2,$C4,$C6,$E4,$E6,$C8,$CA,$E8,$EA,$CC,$CE,$EC,$EE
					dcb $00,$02,$20,$22,$04,$06,$24,$26,$08,$0A,$28,$2A,$0C,$0E,$2C,$2E
					dcb $40,$42,$60,$62,$44,$46,$64,$66,$48,$4A,$68,$6A,$4C,$4E,$6C,$6E
PROPERTIES          dcb $0C,$4C
PROPERTIES2         dcb $0D,$4D
PROPERTIES3         dcb $0F,$4F


SUB_GFX             JSR GET_DRAW_INFO
					
					LDA $157C,x
					STA $02
					LDA $1540,x
					BNE GFX0
					LDA $1602,x
					CMP #$08
					BCS GFX3
GFX0				PHX
					LDX $02
					LDA PROPERTIES,x
					PLX
					STA $0F
					BRA GFX4
GFX3				PHX
					LDX $02
					LDA PROPERTIES2,x
					PLX
					STA $0F
GFX4				LDA $02
					ASL A
					ASL A
					STA $02
					LDA $1602,x
					ASL A
					ASL A
					STA $03
					LDA $1540,x
					BEQ GFX2
					LDA #$1C
					STA $03
GFX2				PHX
                    LDX #$03                ; run loop 4 times, cuz 4 tiles per frame
					
LOOP_START          PHX
					LDA $03
					CMP #$3C
					BEQ GFX5
					
					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP,x         ; |
                    STA $0301,y             ; /
					PHX
					TXA
					CLC
					ADC $02
					TAX
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP,x        ; |
                    STA $0300,y             ; /
                    PLX
					BRA GFX6
					
GFX5				LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP2,x         ; |
                    STA $0301,y             ; /
					PHX
					TXA
					CLC
					ADC $02
					TAX
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP2,x        ; |
                    STA $0300,y             ; /
                    PLX
                    
GFX6				PHX
					TXA
					CLC
					ADC $03
					TAX
                    LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /
					PLX

					LDA $0F
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties


                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
					
SUB_GFX2            JSR GET_DRAW_INFO
                    
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    STA $0300,y             ; /
                    
                    LDA $01               ; |
                    STA $0301,y             ; /
					
					LDA $1570,x
                    STA $0302,y             ; /
					
					LDA $157C,x
					TAX
					LDA PROPERTIES3,x
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
					LDX $15E9

                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$00                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
SUB_GFX3            JSR GET_DRAW_INFO
					LDA #$EE
					STA $02
					LDA #$0F
					STA $03
                    LDA $010B
					CMP #$8B
					BNE SUB_GFX3_2
					LDA #$0A
					STA $03
					LDA $157C,x
					BEQ SUB_GFX3_3
					LDA #$E8
					STA $02
					BRA SUB_GFX3_2
SUB_GFX3_3			LDA #$EA
					STA $02
SUB_GFX3_2          LDA $00                 ; \
					CLC
					ADC $7FFD04
                    STA $0300,y             ; /
                    
                    LDA $01               ; |
					CLC
					ADC $7FFD06
                    STA $0301,y             ; /
					
					LDA $02
                    STA $0302,y             ; /
					
					LDA $03
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
					INY
					INY
					INY
					INY

					LDA $00                 ; \
					CLC
					ADC $7FFD06
                    STA $0300,y             ; /
                    
                    LDA $01
					SEC               ; |
					SBC $7FFD04
                    STA $0301,y             ; /
					
					LDA $02
                    STA $0302,y             ; /
					
					LDA $03
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
					INY
					INY
					INY
					INY
					
					LDA $00                 ; \
					SEC
					SBC $7FFD06
                    STA $0300,y             ; /
                    
                    LDA $01               ; |
					CLC
					ADC $7FFD04
                    STA $0301,y             ; /
					
					LDA $02
                    STA $0302,y             ; /
					
					LDA $03
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
					INY
					INY
					INY
					INY
					
					LDA $00                 ; \
					SEC
					SBC $7FFD04
                    STA $0300,y             ; /
                    
                    LDA $01               ; |
					SEC
					SBC $7FFD06
                    STA $0301,y             ; /
					
					LDA $02
                    STA $0302,y             ; /
					
					LDA $03
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
					
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RETURN67            RTS
GEN_HEART           JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
					LDA $E4,x
                    STA $00E4,y
                    LDA $14E0,x
                    STA $14E0,y             ; /

					LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$8C
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817                ; Y = 1 if contact

SUB_GET_DIR         LDY #$00                
                    LDA $94                
                    SEC                     
                    SBC $E4,x               
                    STA $0F                 
                    LDA $95                 
                    SBC $14E0,x             
                    BPL LABEL16             
                    INY                     
LABEL16             RTS                     

PINK				LDA $15AC,x
					CMP #$A9
					BCC PINK2
					PHP
					REP #$30
					LDA $7FE301
					CLC
					ADC.W #$0822
					STA $7FE301
					PLP
					RTS
PINK2				PHP
					REP #$30
					LDA $7FE301
					SEC
					SBC.W #$0822
					STA $7FE301
					PLP
					RTS

HDMA_COLOR			LDA #$08
					STA $7FFB18
					LDA #$10
					STA $7FFB20
					LDA #$00
					STA $7FFB19
					LDA #$02
					STA $7FFB21
					LDA #$21
					STA $7FFB1A
					LDA #$22
					STA $7FFB22
					LDA #$00
					STA $7FFB1B
					STA $7FFB23
					LDA #$E2
					STA $7FFB1C
					LDA #$E3
					STA $7FFB24
					LDA #$7F
					STA $7FFB1D
					STA $7FFB25
					
					LDA #$01
					STA $7FE200
					STA $7FE300
					LDA #$00
					STA $7FE201
					LDA #$00
					STA $7FE301
					LDA #$00
					STA $7FE302
					LDA #$00
					STA $7FE202
					STA $7FE303
					RTS
					



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B85D - off screen processing code - shared
; sprites enter at different points
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B83B             

TABLE3              dcb $40,$B0
TABLE6              dcb $01,$FF 
TABLE4              dcb $30,$C0,$A0,$80,$A0,$40,$60,$B0 
TABLE5              dcb $01,$FF,$01,$FF,$01,$00,$01,$FF

SUB_OFF_SCREEN_X0   LDA #$06                ; \ entry point of routine determines value of $03
                    BRA STORE_03            ;  | 
SUB_OFF_SCREEN_X1   LDA #$04                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X2   LDA #$02                ;  |
STORE_03            STA $03                 ;  |
                    BRA START_SUB           ;  |
SUB_OFF_SCREEN_HB   STZ $03                 ; /

START_SUB           JSR SUB_IS_OFF_SCREEN   ; \ if sprite is not off screen, return
                    BEQ RETURN_2            ; /    
                    LDA $5B                 ; \  goto VERTICAL_LEVEL if vertical level
                    AND #$01                ;  |
                    BNE VERTICAL_LEVEL      ; /     
                    LDA $D8,x               ; \
                    CLC                     ;  | 
                    ADC #$50                ;  | if the sprite has gone off the bottom of the level...
                    LDA $14D4,x             ;  | (if adding 0x50 to the sprite y position would make the high byte >= 2)
                    ADC #$00                ;  | 
                    CMP #$02                ;  | 
                    BPL ERASE_SPRITE        ; /    ...erase the sprite
                    LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ;  |
                    BNE RETURN_2            ; /
                    LDA $13                 ; \ 
                    AND #$01                ;  | 
                    ORA $03                 ;  | 
                    STA $01                 ;  |
                    TAY                     ; /
                    LDA $1A                 ;x boundry ;A:0101 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0256 VC:090 00 FL:16953
                    CLC                     ;A:0100 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdiZcHC:0280 VC:090 00 FL:16953
                    ADC TABLE4,y            ;A:0100 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdiZcHC:0294 VC:090 00 FL:16953
                    ROL $00                 ;A:01C0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizcHC:0326 VC:090 00 FL:16953
                    CMP $E4,x               ;x pos ;A:01C0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizcHC:0364 VC:090 00 FL:16953
                    PHP                     ;A:01C0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:0394 VC:090 00 FL:16953
                    LDA $1B                 ;x boundry hi ;A:01C0 X:0006 Y:0001 D:0000 DB:03 S:01EC P:eNvMXdizCHC:0416 VC:090 00 FL:16953
                    LSR $00                 ;A:0100 X:0006 Y:0001 D:0000 DB:03 S:01EC P:envMXdiZCHC:0440 VC:090 00 FL:16953
                    ADC TABLE5,y            ;A:0100 X:0006 Y:0001 D:0000 DB:03 S:01EC P:envMXdizcHC:0478 VC:090 00 FL:16953
                    PLP                     ;A:01FF X:0006 Y:0001 D:0000 DB:03 S:01EC P:eNvMXdizcHC:0510 VC:090 00 FL:16953
                    SBC $14E0,x             ;x pos high ;A:01FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:0538 VC:090 00 FL:16953
                    STA $00                 ;A:01FE X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:0570 VC:090 00 FL:16953
                    LSR $01                 ;A:01FE X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:0594 VC:090 00 FL:16953
                    BCC LABEL20             ;A:01FE X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdiZCHC:0632 VC:090 00 FL:16953
                    EOR #$80                ;A:01FE X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdiZCHC:0648 VC:090 00 FL:16953
                    STA $00                 ;A:017E X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizCHC:0664 VC:090 00 FL:16953
LABEL20             LDA $00                 ;A:017E X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizCHC:0688 VC:090 00 FL:16953
                    BPL RETURN_2            ;A:017E X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizCHC:0712 VC:090 00 FL:16953
ERASE_SPRITE        LDA $14C8,x             ; \ if sprite status < 8, permanently erase sprite
                    CMP #$08                ;  |
                    BCC KILL_SPRITE         ; /
                    LDY $161A,x             ;A:FF08 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdiZCHC:0140 VC:071 00 FL:21152
                    CPY #$FF                ;A:FF08 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizCHC:0172 VC:071 00 FL:21152
                    BEQ KILL_SPRITE         ;A:FF08 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0188 VC:071 00 FL:21152
                    LDA #$00                ; \ mark sprite to come back    A:FF08 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0204 VC:071 00 FL:21152
                    STA $1938,y             ; /                             A:FF00 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdiZcHC:0220 VC:071 00 FL:21152
KILL_SPRITE         STZ $14C8,x             ; erase sprite
RETURN_2            RTS                     ; return

VERTICAL_LEVEL      LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ;  |
                    BNE RETURN_2            ; /
                    LDA $13                 ; \ only handle every other frame??
                    LSR A                   ;  | 
                    BCS RETURN_2            ; /
                    AND #$01                ;A:0227 X:0006 Y:00EC D:0000 DB:03 S:01ED P:envMXdizcHC:0228 VC:112 00 FL:1142
                    STA $01                 ;A:0201 X:0006 Y:00EC D:0000 DB:03 S:01ED P:envMXdizcHC:0244 VC:112 00 FL:1142
                    TAY                     ;A:0201 X:0006 Y:00EC D:0000 DB:03 S:01ED P:envMXdizcHC:0268 VC:112 00 FL:1142
                    LDA $1C                 ;A:0201 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0282 VC:112 00 FL:1142
                    CLC                     ;A:02BD X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizcHC:0306 VC:112 00 FL:1142
                    ADC TABLE3,y            ;A:02BD X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizcHC:0320 VC:112 00 FL:1142
                    ROL $00                 ;A:026D X:0006 Y:0001 D:0000 DB:03 S:01ED P:enVMXdizCHC:0352 VC:112 00 FL:1142
                    CMP $D8,x               ;A:026D X:0006 Y:0001 D:0000 DB:03 S:01ED P:enVMXdizCHC:0390 VC:112 00 FL:1142
                    PHP                     ;A:026D X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNVMXdizcHC:0420 VC:112 00 FL:1142
                    LDA.W $001D             ;A:026D X:0006 Y:0001 D:0000 DB:03 S:01EC P:eNVMXdizcHC:0442 VC:112 00 FL:1142
                    LSR $00                 ;A:0200 X:0006 Y:0001 D:0000 DB:03 S:01EC P:enVMXdiZcHC:0474 VC:112 00 FL:1142
                    ADC TABLE6,y            ;A:0200 X:0006 Y:0001 D:0000 DB:03 S:01EC P:enVMXdizCHC:0512 VC:112 00 FL:1142
                    PLP                     ;A:0200 X:0006 Y:0001 D:0000 DB:03 S:01EC P:envMXdiZCHC:0544 VC:112 00 FL:1142
                    SBC $14D4,x             ;A:0200 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNVMXdizcHC:0572 VC:112 00 FL:1142
                    STA $00                 ;A:02FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizcHC:0604 VC:112 00 FL:1142
                    LDY $01                 ;A:02FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizcHC:0628 VC:112 00 FL:1142
                    BEQ LABEL22             ;A:02FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0652 VC:112 00 FL:1142
                    EOR #$80                ;A:02FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0668 VC:112 00 FL:1142
                    STA $00                 ;A:027F X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0684 VC:112 00 FL:1142
LABEL22             LDA $00                 ;A:027F X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0708 VC:112 00 FL:1142
                    BPL RETURN_2            ;A:027F X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0732 VC:112 00 FL:1142
                    BMI ERASE_SPRITE        ;A:0280 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:0170 VC:064 00 FL:1195

SUB_IS_OFF_SCREEN   LDA $15A0,x             ; \ if sprite is on screen, accumulator = 0 
                    ORA $186C,x             ;  |  
                    RTS                     ; / return


HEART1				LDA $010B
					CMP #$8B
					BNE LBLA1
					LDA $15AC,x
					CMP #$80
					BCS LBLA1
					STZ $14C8,x
					RTS
LBLA1				LDA $15AC,x
					BNE HEART1_1
					STZ $14C8,x
					RTS
HEART1_1			LDA $9D
					BNE HEART1_2
					LDA $15AC,x
					CMP #$80
					BCC HEART1_3
					INC $1570,x
					BRA HEART1_0
HEART1_3			DEC $1570,x
HEART1_0			LDA $1528,x
					CLC
					ADC #$02
					STA $1528,x
					LDA $151C,x
					ADC #$00
					AND #$01
					STA $151C,x
HEART1_2			LDA $1528,x
					STA $00
					LDA $151C,x
					STA $01
					
					REP #$30 ;#16bit[h
                    LDA $00
                    CLC
                    ADC.W #$0080 ;#]l80𑫂$02-$03
                    AND.W #$01FF
                    STA $02
                    LDA $00
                    AND.W #$00FF
                    ASL A
                    TAX
                    LDA $07F7DB,x ;#]pɑ΂W̊i[lH
                    STA $04
                    LDA $02
                    AND.W #$00FF
                    ASL A
                    TAX
                    LDA $07F7DB,x
                    STA $06       ;#90xY̍WH
                    SEP #$30
					
					LDX $15E9
					LDA $04
                    STA $4202   ;#]pɑ΂WW
                    LDA $1570,x  ;#w肵a
                    LDY $05    ;#ΑȂ
                    BNE LABEL93
                    STA $4203   ;#a
                    ASL $4216   ;#ɔ{ɂH
                    LDA $4217
                    ADC #$00
LABEL93             LSR $01
                    BCC LABEL94
                    EOR #$FF                ; \ reverse direction of rotation
                    INC A                   ; /#180xȏȂl𔽓]
LABEL94             STA $04
                    LDA $06
                    STA $4202
                    LDA $1570,x  ;#w肵a
                    LDY $07
                    BNE LABEL95
                    STA $4203
                    ASL $4216
                    LDA $4217
                    ADC #$00
LABEL95             LSR $03
                    BCC LABEL96
                    EOR #$FF
                    INC A
LABEL96             STA $06
                    LDA $E4,x ;#W
                    STA $7FFDE4
                    LDA $14E0,x
                    STA $7FFDE0
                    LDA $D8,x
                    STA $7FFDD8
                    LDA $14D4,x
                    STA $7FFDD4
					
                    LDY $0F86,x
                    STZ $00
                    LDA $04
                    BPL LABEL97
                    DEC $00
LABEL97             CLC
                    ADC $7FFDE4
                    STA $E4,x
                    PHP
                    PHA
                    SEC
                    SBC $1534,x
                    STA $1528,x
                    PLA
                    STA $1534,x
                    PLP
                    LDA $7FFDE0
                    ADC $00
                    STA $14E0,x
                    STZ $01
                    LDA $06
                    BPL LABEL98
                    DEC $01
LABEL98             LDA $00
					STA $7FFD00
					LDA $04
					STA $7FFD04
					LDA $01
					STA $7FFD01
					LDA $06
					STA $7FFD06
					
					LDA $7FFDE4
					CLC
					ADC $7FFD04
					STA $E4,x
                    LDA $7FFDE0
					ADC $7FFD00
					STA $14E0,x
                    LDA $7FFDD8
					CLC
					ADC $7FFD06
					STA $D8,x
                    LDA $7FFDD4
					ADC $7FFD01
					STA $14D4,x
					JSR DAMAGE_CHECK2
					
					LDA $7FFDE4
					CLC
					ADC $7FFD06
					STA $E4,x
                    LDA $7FFDE0
					ADC $7FFD01
					STA $14E0,x
                    LDA $7FFDD8
					SEC
					SBC $7FFD04
					STA $D8,x
                    LDA $7FFDD4
					SBC $7FFD00
					STA $14D4,x
					JSR DAMAGE_CHECK2

					LDA $7FFDE4
					SEC
					SBC $7FFD04
					STA $E4,x
                    LDA $7FFDE0
					SBC $7FFD00
					STA $14E0,x
                    LDA $7FFDD8
					SEC
					SBC $7FFD06
					STA $D8,x
                    LDA $7FFDD4
					SBC $7FFD01
					STA $14D4,x
					JSR DAMAGE_CHECK2
					
					LDA $7FFDE4
					SEC
					SBC $7FFD06
					STA $E4,x
                    LDA $7FFDE0
					SBC $7FFD01
					STA $14E0,x
                    LDA $7FFDD8
					CLC
					ADC $7FFD04
					STA $D8,x
                    LDA $7FFDD4
					ADC $7FFD00
					STA $14D4,x
					JSR DAMAGE_CHECK2
					
					LDA $7FFDD4     
                    STA $14D4,x
                    LDA $7FFDD8       
                    STA $D8,x  
                    LDA $7FFDE0       
                    STA $14E0,x
                    LDA $7FFDE4       
                    STA $E4,x
					JSR SUB_GFX3
                    RTS

HEART2				LDA #$EE
					STA $1570,x
					JSR SUB_GFX2
					LDA $9D
					BNE HEART2_R
					JSL $01802A
					LDA $14E0,x
					BEQ HEART2_0
					STZ $14C8,x
					RTS
HEART2_0			JSR DAMAGE_CHECK2
					LDA $1588,x
					AND #$04
					BEQ HEART2_R
					LDA #$B0
					STA $AA,x
HEART2_R			RTS

HEART3				LDA #$CE
					STA $1570,x
					JSR SUB_GFX2
					LDA $9D
					BNE HEART3_R
					JSL $01802A
					JSR SUB_OFF_SCREEN_X0
					JSR DAMAGE_CHECK2
					LDY $157C,x
					LDA X_SPEED3,y
					STA $B6,x
					STZ $AA,x
HEART3_R			RTS

HEART4				LDA #$EE
					STA $1570,x
					JSR SUB_GFX2
					LDA $9D
					BNE HEART4_R
					LDA $14
					AND #$07
					BNE HEART4_2
					INC $151C,x
					LDA $151C,x
					CMP #$B0
					BNE HEART4_2
					STZ $14C8,x
					RTS
HEART4_2			LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					SEC
					SBC #$10
					STA $D8,x
					LDA $97
					SBC #$00
					STA $14D4,x
					LDA $7B
					CMP #$80
					BCS HEART4_L
					CMP #$10
					BCC HEART4_R
					LDA #$10
					STA $7B
					RTS
HEART4_L			CMP #$F0
					BCS HEART4_R
					LDA #$F0
					STA $7B
HEART4_R			RTS

HEART5				LDA $9D
					BNE HEART5_2
					LDA $1594,x
					BNE HEART5_A
					STZ $AA,x
					JSL $01802A
					LDA $14E0,x
					BEQ HEART5_1
					STZ $14C8,x
					RTS
HEART5_A			LDA $7FFDF0
					STA $E4,x
					LDA $7FFDF1
					STA $14E0,x
					LDA $7FFDF2
					STA $D8,x
					LDA $7FFDF3
					STA $14D4,x
HEART5_1			LDA $1594,x
					BNE HEART5_B
					LDA $1504,x
					CLC
					ADC #$06
					STA $1504,x
					LDA $151C,x
					ADC #$00
					AND #$01
					STA $151C,x
					BRA HEART5_2
HEART5_B			LDA $1504,x
					CLC
					ADC #$03
					STA $1504,x
					LDA $151C,x
					ADC #$00
					AND #$01
					STA $151C,x
HEART5_2			LDA $1504,x
					STA $00
					LDA $151C,x
					STA $01
					
					REP #$30 ;#16bit[h
                    LDA $00
                    CLC
                    ADC.W #$0080 ;#]l80𑫂$02-$03
                    AND.W #$01FF
                    STA $02
                    LDA $00
                    AND.W #$00FF
                    ASL A
                    TAX
                    LDA $07F7DB,x ;#]pɑ΂W̊i[lH
                    STA $04
                    LDA $02
                    AND.W #$00FF
                    ASL A
                    TAX
                    LDA $07F7DB,x
                    STA $06       ;#90xY̍WH
                    SEP #$30
					
					LDX $15E9
					LDA $04
                    STA $4202   ;#]pɑ΂WW
                    LDA #$18  ;#w肵a
                    LDY $05    ;#ΑȂ
                    BNE LABEL593
                    STA $4203   ;#a
                    ASL $4216   ;#ɔ{ɂH
                    LDA $4217
                    ADC #$00
LABEL593             LSR $01
                    BCC LABEL594
                    EOR #$FF                ; \ reverse direction of rotation
                    INC A                   ; /#180xȏȂl𔽓]
LABEL594             STA $04
                    LDA $06
                    STA $4202
                    LDA #$18  ;#w肵a
                    LDY $07
                    BNE LABEL595
                    STA $4203
                    ASL $4216
                    LDA $4217
                    ADC #$00
LABEL595             LSR $03
                    BCC LABEL596
                    EOR #$FF
                    INC A
LABEL596             STA $06
                    LDA $E4,x
                    PHA
                    LDA $14E0,x
                    PHA
                    LDA $D8,x
                    PHA
                    LDA $14D4,x
                    PHA
                    LDY $0F86,x
                    STZ $00
                    LDA $04
                    BPL LABEL597
                    DEC $00
LABEL597             CLC
                    ADC $E4,x
                    STA $E4,x
                    PHP
                    PHA
                    SEC
                    SBC $1534,x
                    STA $1528,x
                    PLA
                    STA $1534,x
                    PLP
                    LDA $14E0,x
                    ADC $00
                    STA $14E0,x
                    STZ $01
                    LDA $06
                    BPL LABEL598
                    DEC $01
LABEL598             CLC
                    ADC $D8,x
                    STA $D8,x
                    LDA $14D4,x
                    ADC $01
                    STA $14D4,x
            		JSR DAMAGE_CHECK2
					LDA #$EE
					STA $1570,x
					JSR SUB_GFX2
                    
                    PLA     
                    STA $14D4,x
                    PLA        
                    STA $D8,x  
                    PLA        
                    STA $14E0,x
                    PLA        
                    STA $E4,x                   
				    RTS
