;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 
;;   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    ;symbolic names for ram addresses
                    MARIO_STATUS    = $19 
                    MARIO_X_SPEED   = $7B
                    MARIO_Y_SPEED   = $7D
                    MARIO_X_POS     = $94
                    MARIO_X_POS_HI  = $95
                    MARIO_Y_POS     = $96 
                    MARIO_Y_POS_HI  = $97
                    SPRITE_Y_SPEED  = $AA
                    SPRITE_X_SPEED  = $B6
                    SPRITE_STATE    = $C2       
                    SPRITE_Y_POS    = $D8
                    SPRITE_X_POS    = $E4
                    SPRITE_Y_POS_HI = $14D4
                    SPRITE_X_POS_HI = $14E0
                    SPR_OBJ_STATUS  = $1588
                    SPRITE_OAM      = $15EA
                    EXTRA_BITS = $7FAB10

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA $010B
					CMP #$42
					BEQ INIT_3
					LDA #$80
					STA $1602,x
					LDA EXTRA_BITS,x
					AND #$04
					BNE INIT_2
					LDA $E4,x
					ORA #$08
					STA $E4,x
                    RTL
INIT_2				LDA $D8,x
					ORA #$06
					STA $D8,x
					RTL
INIT_3				JSL $01ACF9
					AND #$3F
					STA $15AC,x
					STA $1570,x
					LDA $E4,x
					CMP #$20
					BCC INIT_3_1
					CMP #$C0
					BCS INIT_3_2
					LDA $14D4,x
					BEQ INIT_3_3
					LDA #$03
					STA $1528,x
					BRA INIT_3_0
INIT_3_1			STZ $1528,x
					BRA INIT_3_0
INIT_3_2			LDA #$01
					STA $1528,x
					BRA INIT_3_0
INIT_3_3			LDA #$02
					STA $1528,x
INIT_3_0			LDA EXTRA_BITS,x
					AND #$04
					BNE INIT_4
					RTL
INIT_4				STZ $1462
					JSL $01ACF9
					CLC
					ADC $13
					AND #$0F
					STA $7FFDDD
					LDA #$02
					STA $1540,x
					RTL
					

		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite code JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"                                    
                    PHB                     
                    PHK                     
                    PLB                     
                    JSR SPRITE_CODE_START   
                    PLB                     
                    RTL      


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
SPRITE_CODE_START   LDA $010B
					CMP #$42
					BEQ CHO_MAIN
					LDA EXTRA_BITS,x
					AND #$04
					BNE TATE
					JSR SUB_GFX
					BRA LIFT
TATE				JSR SUB_GFX2
LIFT                LDA $9D
					BNE RETURN01
					JSR SUB_B852
RETURN01            RTS                     
CHO_MAIN			JSR SUB_GFX_C
					LDA $9D
					BNE RETURN01
					LDA EXTRA_BITS,x
					AND #$04
					BEQ CHO_1
					LDA $1540,x
					BEQ CHO_5
					JSR SUB_COLOR
					STZ $1540,x
CHO_5				JSR SUB_CHO
					JSR TELEPORT
CHO_1				INC $1570,x
					PHX
					LDA $1528,x
					TAX
					LDA $7FFCCC,x
					PLX
					STA $1602,x
					LDA $15AC,x
					BEQ CHO_2
					CMP #$10
					BCS CHO_R
					JSL $018022 ;x speed
					JSL $01801A ;y speed
CHO_R               RTS
CHO_2				LDA #$40
					STA $15AC,x
					JSL $01ACF9
					AND #$07
					ASL A
					ASL A
					SEC
					SBC #$0E
					STA $AA,x
					JSL $01ACF9
					AND #$07
					ASL A
					ASL A
					SEC
					SBC #$0E
					STA $B6,x
					RTS
					
SUB_CHO				LDA $7FFDDD
					STA $7FC004
					RTS
					
SUB_COLOR			JSL $01ACF9
					SEC
					SBC $13
					AND #$0F
					ASL A
					ASL A
					TAY
					LDA COLOR,y
					STA $7FFCCC
					INY
					LDA COLOR,y
					STA $7FFCCD
					INY
					LDA COLOR,y
					STA $7FFCCE
					INY
					LDA COLOR,y
					STA $7FFCCF
					LDA $7FFDDD
					LSR A
					LSR A
					TAY
					LDA COLOR2,y
					STA $7FFDDE
					RTS
COLOR				dcb $0F,$0D,$07,$03
					dcb $0F,$07,$0D,$03
					dcb $0F,$03,$0D,$07
					dcb $0F,$03,$07,$0D
					dcb $0D,$03,$07,$0F
					dcb $0D,$07,$03,$0F
					dcb $0D,$07,$0F,$03
					dcb $0D,$0F,$03,$07
					dcb $07,$03,$0F,$0D
					dcb $07,$0D,$0F,$03
					dcb $07,$0D,$03,$0F
					dcb $07,$0F,$0D,$03
					dcb $03,$07,$0D,$0F
					dcb $03,$0D,$0F,$07
					dcb $03,$0F,$0D,$07
					dcb $03,$0F,$07,$0D
					
COLOR2				dcb $0D,$0F,$07,$03
TELEPORT			LDA $94
					CMP #$10
					BCC TELE_1
					CMP #$E0
					BCS TELE_2
					LDA $97
					BNE TELE_0
					LDA $96
					CMP #$D0
					BCC TELE_3
					RTS
TELE_0				LDA $96
					CMP #$98
					BCS TELE_4
					RTS
TELE_1				LDA $7FFCCC
					CMP $7FFDDE
					BNE TELE1_2
					LDA #$29
					STA $1DFC
					INC $14AF
					BRA TELE1_3
TELE1_2				LDA #$2A
					STA $1DFC
					STZ $14AF
TELE1_3				LDA #$42
					STA $19B8
					LDA #$06
					STA $19D8
					BRA TELEPO
TELE_2				LDA $7FFCCD
					CMP $7FFDDE
					BNE TELE2_2
					LDA #$29
					STA $1DFC
					INC $14AF
					BRA TELE2_3
TELE2_2				LDA #$2A
					STA $1DFC
					STZ $14AF
TELE2_3				LDA #$42
					STA $19B8
					LDA #$04
					STA $19D8
					BRA TELEPO
TELE_3				LDA $7FFCCE
					CMP $7FFDDE
					BNE TELE3_2
					LDA #$29
					STA $1DFC
					INC $14AF
					BRA TELE3_3
TELE3_2				LDA #$2A
					STA $1DFC
					STZ $14AF
TELE3_3				LDA #$43
					STA $19B8
					LDA #$06
					STA $19D8
					BRA TELEPO
TELE_4				LDA $7FFCCF
					CMP $7FFDDE
					BNE TELE4_2
					LDA #$29
					STA $1DFC
					INC $14AF
					BRA TELE4_3
TELE4_2				LDA #$2A
					STA $1DFC
					STZ $14AF
TELE4_3				LDA #$40
					STA $19B8
					LDA #$06
					STA $19D8
TELEPO				LDA $14AF
					CMP #$08
					BNE TELEPO2
					LDA #$50
					STA $19B8
					LDA #$04
					STA $19D8
TELEPO2				LDA #$06
					STA $71
					STZ $89
					STZ $88
					STZ $14C8,x
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAPC			dcb $A8,$AA,$AC,$AA
SUB_GFX_C			JSR GET_DRAW_INFO
					PHX
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					TAX
					LDA TILEMAPC,x
					STA $0302,y
					PLX
					LDA $1602,x
					ORA $64
					STA $0303,y
					LDA $00                 
                    STA $0300,y             ; /
                    LDA $01 
                    STA $0301,y
					LDY #$02                ; \ 02, because we didn't write to 460 yet
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3
					RTS




TILEMAP             dcb $44,$46,$46,$46,$46,$44
X_OFFSET            dcb $D8,$E8,$F8,$08,$18,$28
PROPETIES			dcb $0F,$0F,$0F,$0F,$0F,$4F

SUB_GFX 			JSR GET_DRAW_INFO
                    PHX                     ; push sprite index

                    LDX #$05                ; loop counter = (number of tiles per frame) - 1
LOOP_START          PHX                     ; push current tile number
                    
                    LDA $00                 ; \ tile x position = sprite x location ($00)
                    CLC
                    ADC X_OFFSET,x
                    STA $0300,y             ; /
                    
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y             ; /
                    
                    LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; / 

                    LDA PROPETIES,x             ;  | get palette info
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index

                    STZ $00       
                    STZ $01       
                    STZ $02       
                    STZ $03       
                    LDY #$00                 
                    LDA #$28  
                    STA $0000,y   ;#???
                    LSR A         
                    STA $0001,y   ;#????
                                        
                    LDA $00       
                    PHA           
                    LDA $02       
                    PHA       
                    
                    LDY #$02                ; \ 02, because we didn't write to 460 yet
                    LDA #$05                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen

                    PLA           
                    STA $02       
                    PLA                    
                    STA $00
                    RTS                    

TILEMAP2            dcb $08,$0A,$0A,$0A,$0A,$08
X_OFFSET2           dcb $D8,$E8,$F8,$08,$18,$28
PROPETIES2			dcb $0F,$0F,$0F,$0F,$0F,$8F

SUB_GFX2 			JSR GET_DRAW_INFO
                    PHX                     ; push sprite index

                    LDX #$05                ; loop counter = (number of tiles per frame) - 1
LOOP_START2         PHX                     ; push current tile number
                    
                    LDA $00                 ; \ tile x position = sprite x location ($00)
                    STA $0300,y             ; /
                    
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
					CLC
                    ADC X_OFFSET2,x
                    STA $0301,y             ; /
                    
                    LDA TILEMAP2,x           ; \ store tile
                    STA $0302,y             ; / 

                    LDA PROPETIES2,x             ;  | get palette info
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START2          ; / 

                    PLX                     ; pull, X = sprite index

                    STZ $00       
                    STZ $01       
                    STZ $02       
                    STZ $03       
                    LDY #$00                 
                    LDA #$00  
                    STA $0000,y   ;#???
                    LSR A         
                    STA $0001,y   ;#????
                                        
                    LDA $00       
                    PHA           
                    LDA $02       
                    PHA       
                    
                    LDY #$02                ; \ 02, because we didn't write to 460 yet
                    LDA #$05                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen

                    PLA           
					LDA #$28
                    STA $02       
                    PLA                    
                    STA $00
                    RTS                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; platform code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_B852            JSR SUB_B8FF
                    BCC RETURN05      
                    LDA $15C4,x
					;ORA $154C,x
                    BNE RETURN05
					
                    LDA SPRITE_Y_POS,x    
                    SEC          
                    SBC $1C      
                    STA $02      
                    SEC          
                    SBC $0D      
                    STA $09      
                    LDA $80      
                    CLC          
                    ADC #$18     
                    CMP $09      
                    BCS LBL06      
                    LDA MARIO_Y_SPEED    
                    BMI RETURN05     
                    STZ MARIO_Y_SPEED  ;#ɏĂ
                    JSR UP_CHECK
                    LDA #$01     
                    STA $1471    
                    LDA $0D      ;#^e/2
                    CLC          
                    ADC #$1F     


                    STA $00      
                    
                    ;LDA #$01
                    ;STA SPRITE_STATE,x
                   
                    LDA SPRITE_Y_POS,x    
                    SEC          
                    SBC $00      
                    STA MARIO_Y_POS      
                    LDA SPRITE_Y_POS_HI,x  
                    SBC #$00     
                    STA MARIO_Y_POS_HI      
                    LDY #$00     
RETURN05            RTS           

LBL06               LDA $02       
                    CLC           
                    ADC $0D       ;#^e/2
                    STA $02       
                    LDA #$FF      
                    LDY $73       
                    BNE LBL07      
                    LDY MARIO_STATUS       
                    BNE SMALL_MARIO
LBL07
                    LDA #$08   
SMALL_MARIO
                    CLC                     
                    ADC $80      
                    CMP $02      
                    BCC LBL10      
                    LDA MARIO_Y_SPEED       ;#ɂԂĂ
					BPL LBL09
					JSR UNDER_CHECK
                    LDA #$10                
                    STA MARIO_Y_SPEED    
LBL09				RTS       
LBL10
                    LDA $0E       ;#/2
                    CLC           
                    ADC #$10      
                    STA $00       
                    LDY #$00      
                    LDA SPRITE_X_POS,x     
                    SEC           
                    SBC $1A       
                    CMP $7E       
                    BCC LBL11     
                    LDA $00       
                    EOR #$FF      
                    INC A         
                    STA $00       
                    DEY     
LBL11
                    JSR YOKO_CHECK
					LDA SPRITE_X_POS,x     ;#ɐGĂ
                    CLC           
                    ADC $00       
                    STA MARIO_X_POS       
                    TYA           
                    ADC SPRITE_X_POS_HI,x   
                    STA MARIO_X_POS_HI       
                    STZ MARIO_X_SPEED       
                    RTS                     

UP_CHECK			LDA EXTRA_BITS,x
					AND #$04
					BEQ UP_CHECK_R
					LDA $140D
					BEQ UP_CHECK_R
					LDA $1602,x
					CMP #$90
					BCS UP_CHECK_R
					STZ $140D
					INC $1602,x
					LDA $D8,x
					CLC
					ADC #$04
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
UP_CHECK_R			RTS
UNDER_CHECK			LDA EXTRA_BITS,x
					AND #$04
					BEQ UNDER_CHECK_R
					LDA $1602,x
					CMP #$73
					BCC UNDER_CHECK_R
					DEC $1602,x
					LDA $D8,x
					SEC
					SBC #$04
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
UNDER_CHECK_R		RTS
YOKO_CHECK			LDA EXTRA_BITS,x
					AND #$04
					BNE YOKO_CHECK_R
					LDA $15
					AND #$40
					BEQ YOKO_CHECK_R
					LDA $15
					AND #$01
					BEQ YOKO_CHECK_2
					LDA $1602,x
					CMP #$E0
					BCS YOKO_CHECK_R
					INC $1602,x
					LDA $E4,x
					CLC
					ADC #$01
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
YOKO_CHECK_R		RTS
YOKO_CHECK_2		LDA $15
					AND #$02
					BEQ YOKO_CHECK_R
					LDA $1602,x
					CMP #$21
					BCC YOKO_CHECK_R
					DEC $1602,x
					LDA $E4,x
					SEC
					SBC #$01
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; make standable
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_B8FF			;#$00XvCg̉ $01 0 $02 0
                    LDA $00      
                    STA $0E      ;#/2
                    LDA $02      
                    STA $0D      ;#^e/2
                    LDA SPRITE_X_POS,x    
                    SEC          
                    SBC $00      
                    STA $04      ;#XvCg̍Low
                    LDA SPRITE_X_POS_HI,x  
                    SBC #$00     
                    STA $0A      ;#XvCg̍Hi
                    LDA $00      
                    ASL A        
                    CLC          
                    ADC #$10     
                    STA $06      ;#XvCg̕{10
                    LDA SPRITE_Y_POS,x    
                    SEC          
                    SBC $02      ;#0
                    STA $05      ;#XvCg̏㑤Low
                    LDA SPRITE_Y_POS_HI,x  
                    SBC #$00     
                    STA $0B      ;#XvCg̏㑤Hi
                    LDA $02      
                    ASL A        
                    CLC          
                    ADC #$10     
                    STA $07      ;#XvCg̍+10
                    JSL $03B664  
                    JSL $03B72B  
                    RTS 

                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GET_DRAW_INFO
; This is a helper for the graphics routine.  It sets off screen flags, and sets up
; variables.  It will return with the following:
;
;		Y = index to sprite OAM ($300)
;		$00 = sprite x position relative to screen boarder
;		$01 = sprite y position relative to screen boarder  
;
; It is adapted from the subroutine at $03B760
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T1              dcb $0C,$1C
SPR_T2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA SPRITE_X_POS_HI,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA SPRITE_X_POS_HI,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC SPR_T1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA SPRITE_Y_POS_HI,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA SPR_T2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY SPRITE_OAM,x        ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
                    

