;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Clacco
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;      
                    dcb "INIT"
					STZ $1528,x
					STZ $157C,x
					STZ $1570,x
					STZ $C2,x
					STZ $14AF
					LDA #$0D
					STA $151C,x
					LDA #$BF
					STA $E4,x
					LDA #$01
					STA $7FFFDF
					LDA #$14
					STA $7FFFE0
					LDA #$1B
					STA $7FFFE1
					LDA #$0A
					STA $7FFFE2
					LDA #$0C
					STA $7FFFE3
					LDA #$14
					STA $7FFFE4
					LDA #$18
					STA $7FFFE5
					LDA #$FC
					STA $7FFFE6
                    RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                     ; return           
CODE_START          JSR GET_DRAW_INFO 
					LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
					LDA $16
					ORA $18
					BEQ MAIN1
					INC $151C,x
MAIN1				LDA $1528,x
					CMP #$05
					BNE MAIN2
					JSR MODE5
					RTS
MAIN2				LDA $14AF
					BEQ MAIN3
					JSR THUNDER
MAIN3				JSR DAMAGE_CHECK
					JSR LIFE_GAGE
					INC $1570,x
					JSL $01802A 
                    JSL $01A7DC
					JSR LAYER2
					LDA $1528,x
					BNE NOT_MODE0
					JSR MODE0
					RTS
NOT_MODE0			CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$02
					BNE NOT_MODE2
					JSR MODE2
					RTS
NOT_MODE2			CMP #$03
					BNE NOT_MODE3
					JSR MODE3
					RTS
NOT_MODE3			JSR MODE4
					RTS


MAIN31				LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE MAIN31_E             ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE MAIN31_E
					LDA $15AC,x
					BNE MAIN31_E
					PHP
					SEP #$30
					LDA #$06
					STA $71
					STZ $89
					STZ $88
					PLP
MAIN31_E			RTS

					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS              
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MODE0				LDA $E4,x
					CMP #$C0
					BEQ MODE0_0
					CMP #$30
					BEQ MODE0_0
					LDA $1570,x
					AND #$20
					BNE MODE0_1
					LDA #$08
					STA $AA,x
					BRA MODE0_2
MODE0_1				LDA #$F8
					STA $AA,x
					LDA $D8,x
					CMP #$11
					BNE MODE0_2
					STZ $AA,x
MODE0_2				LDA $157C,x
					BNE MODE0_3
					LDA #$F0
					STA $B6,x
					RTS
MODE0_3				LDA #$10
					STA $B6,x
RETURN00			RTS
MODE0_0				LDA $151C,x
					CLC
					ADC $94
					AND #$03
					INC A
					STA $1528,x
					LDA #$30
					STA $15AC,x
					LDA #$10
					STA $D8,x
					STZ $AA,x
					STZ $B6,x
					STZ $1570,x
					STZ $1504,x
					RTS


MODE1				STZ $B6,x
					LDA $15AC,x
					BEQ MODE1_G
					LDA $1570,x
					AND #$08
					BNE MODE1_1
					LDA #$08
					STA $AA,x
					RTS
MODE1_1				LDA #$F8
					STA $AA,x
					LDA $D8,x
					CMP #$11
					BNE MODE1_E
					STZ $AA,x
MODE1_E				RTS
MODE1_G				LDA #$10
					STA $D8,x
					LDA $E4,x
					CMP #$30
					BEQ MODE1_G1
					CMP #$C0
					BNE MODE1_G2
					LDA #$BF
					STA $E4,x
					STZ $157C,x
					BRA MODE1_G2
MODE1_G1			LDA #$31
					STA $E4,x
					LDA #$01
					STA $157C,x
MODE1_G2			JSR FIRE_GEN
					LDA #$37
					STA $1DFC
					LDA #$02
					STA $00C2,y
					LDA #$00
					STA $15AC,y
					STZ $1528,x
					STZ $1570,x
					RTS
					
MODE2				STZ $B6,x
					LDA $15AC,x
					BEQ MODE2_G
					LDA $1570,x
					AND #$08
					BNE MODE2_1
					LDA #$08
					STA $AA,x
					RTS
MODE2_1				LDA #$F8
					STA $AA,x
					LDA $D8,x
					CMP #$11
					BNE MODE2_E
					STZ $AA,x
MODE2_E				RTS
MODE2_G				LDA #$10
					STA $D8,x
					LDA $E4,x
					CMP #$30
					BEQ MODE2_G1
					CMP #$C0
					BNE MODE2_G2
					LDA #$BF
					STA $E4,x
					STZ $157C,x
					BRA MODE2_G2
MODE2_G1			LDA #$31
					STA $E4,x
					LDA #$01
					STA $157C,x
MODE2_G2			JSR NORMAL_GEN
					LDA #$37
					STA $1DFC
					STZ $1528,x
					STZ $1570,x
					LDA $E4,x
					CMP $94
					BCS MODE2_L
					LDA #$00
					STA $157C,y
					RTS
MODE2_L				LDA #$01
					STA $157C,y
					RTS
					
MODE3				LDA $15AC,x
					CMP #$B7
					BEQ MODE3_E
					CMP #$40
					BCS MODE3_3
					LDA #$00
					BEQ MODE3_1
					STZ $AA,x
					STZ $B6,x
					RTS
MODE3_1				LDA #$48
					STA $1504,x
					LDA #$FF
					STA $15AC,x
					LDA #$2B
					STA $1DFC
					LDA $E4,x
					CMP #$30
					BNE MODE3_2
					LDA #$20
					STA $B6,x
					RTS
MODE3_2				LDA #$E0
					STA $B6,x
					RTS
MODE3_3				LDA $1504,x
					STA $AA,x
					DEC $1504,x
					DEC $1504,x
					RTS
MODE3_E				STZ $B6,x
					STZ $15AC,x
					STZ $1570,x
					LDA #$10
					STA $D8,x
					STZ $1528,x
					LDA $E4,x
					CMP #$80
					BCS MODE3_E2
					LDA #$31
					STA $E4,x
					LDA #$01
					STA $157C,x
					RTS
MODE3_E2			LDA #$BF
					STA $E4,x
					STZ $157C,x
					RTS

MODE4				STZ $AA,x
					LDA $1504,x
					BNE MODE4_3
					LDA $157C,x
					BNE MODE4_2
					LDA #$20
					STA $B6,x
					LDA $E4,x
					CMP #$F0
					BCC MODE4_E
					LDA #$01
					STA $1504,x
					LDA #$01
					STA $14AF
					LDA #$F0
					STA $B6,x
MODE4_E				RTS
MODE4_2				LDA #$E0
					STA $B6,x
					LDA $E4,x
					CMP #$10
					BCS MODE4_E
					LDA #$01
					STA $1504,x
					LDA #$01
					STA $14AF
					LDA #$10
					STA $B6,x
					RTS
MODE4_3				LDA $157C,x
					BNE MODE4_4
					LDA $E4,x
					CMP #$30
					BCS MODE4_E
					STZ $14AF
					STZ $1570,x
					STZ $1504,x
					LDA #$01
					STA $157C,x
					STZ $1528,x
					LDA #$31
					STA $E4,x
					STZ $B6,x
					STZ $15AC,x
					RTS
MODE4_4				LDA $E4,x
					CMP #$C0
					BCC MODE4_E
					STZ $14AF
					STZ $1570,x
					STZ $1504,x
					STZ $157C,x
					STZ $1528,x
					LDA #$BF
					STA $E4,x
					STZ $B6,x
					STZ $15AC,x
					RTS
					
MODE5				LDA $15AC,x
					BNE MODE5_E
					PHP
					SEP #$30
					LDA #$06
					STA $71
					STZ $89
					STZ $88
					PLP
MODE5_E				RTS

GAGE_E				RTS
LIFE_GAGE			LDA #$FD
					STA $7FFFE7
					STA $7FFFE8
					STA $7FFFE9
					STA $7FFFEA
					LDA #$FC
					STA $7FFFEB
					STA $7FFFEC
					STA $7FFFED
					STA $7FFFEE
					STA $7FFFEF
					LDA $C2,x
					CMP #$01
					BCS GAGE_2
					RTS
GAGE_2				LDA #$FC
					STA $7FFFE7
					LDA $C2,x
					CMP #$02
					BCS GAGE_3
					RTS
GAGE_3				LDA #$FC
					STA $7FFFE8
					LDA $C2,x
					CMP #$03
					BCS GAGE_4
					RTS
GAGE_4				LDA #$FC
					STA $7FFFE9
					LDA $C2,x
					CMP #$04
					BCS GAGE_5
					RTS
GAGE_5				LDA #$FC
					STA $7FFFEA
					RTS
					

THUNDER				LDA $97
					BEQ RETURNT
					LDA $96
					CMP #$10
					BCC RETURNT
					LDA $94
					AND #$FC
					STA $0F
					LDA $E4,x
					AND #$FC
					CMP $0F
					BNE RETURNT
					LDA $1497               ; \ if mario is invincible...
                    BNE RETURNT             ; /   ... return
                    JSL $00F5B7
RETURNT				RTS




DAMAGE_CHECK        LDA $E4,x
                    STA $7FFE01
                    LDA $14E0,x
                    STA $7FFE02
                    LDA $D8,x
                    STA $7FFE03
                    LDA $14D4,x
                    STA $7FFE04
                    PHX
                    LDX #$09
LOOP1               LDA $9E,x
                    CMP #$0F
                    BNE LOOP3
					LDA $14C8,x
					CMP #$09
					BNE LOOP3
                    JSR NEAR_CHECK
                    TYA
                    BEQ LOOP3
					STZ $14C8,x
                    LDA #$28
					STA $1DFC
					PLX
					INC $C2,x
					PHX
LOOP3               DEX
                    BPL LOOP1
                    PLX
					LDA $C2,x
					CMP #$04
					BCS THEEND
                    RTS
THEEND				LDA #$80
					STA $15AC,x
					LDA #$05
					STA $1528,x
					STZ $14AF
					STZ $40
					LDA #$1E
					STA $1DFB
					RTS
					
NEAR_CHECK          LDY #$00
                    LDA $E4,x
                    SEC
                    SBC $7FFE01
                    STA $0F
                    LDA $14E0,x
                    SBC $7FFE02
                    CMP #$00
                    BEQ RIGHT_CHECK
                    CMP #$FF
                    BNE CHECK_E
                    LDA $0F
                    CMP #$E8
                    BCC CHECK_E
                    BRA VER_CHECK
RIGHT_CHECK         LDA $0F
                    CMP #$18
                    BCS CHECK_E
VER_CHECK           LDA $D8,x
                    SEC
                    SBC $7FFE03
                    STA $0F
                    LDA $14D4,x
                    SBC $7FFE04
                    CMP #$00
                    BEQ UNDER_CHECK
                    CMP #$FF
                    BNE CHECK_E
                    LDA $0F
                    CMP #$F8
                    BCC CHECK_E
                    BRA NEAR
UNDER_CHECK         LDA $0F
                    CMP #$08
                    BCS CHECK_E
NEAR                LDY #$01
CHECK_E             RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ETC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
LAYER2				LDA #$C0
					SEC
					SBC $E4,x
					STA $1466
					LDA #$00
					SBC $14E0,x
					STA $1467
					LDA #$D0
					SEC
					SBC $D8,x
					STA $1468
					LDA #$01
					SBC $14D4,x
					STA $1469
					RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


RETURN67            RTS
FIRE_GEN            JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
					DEC A
					TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
                    LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

                    LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN68            RTS
NORMAL_GEN          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    
					LDA #$0F
                    STA $009E,y
                    
                    LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

                    LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    PLX
                    RTS                          ; return
