;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Cloud
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					EXTRA_BITS = $7FAB10
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP             dcb $CC,$CE,$CC,$EC,$EE,$EC,$E0,$CE,$E0,$EC,$EE,$EC
HORZ_DISP           dcb $F0,$00,$10
VERT_DISP           dcb $00,$00,$00
PROPERTIES          dcb $00,$00,$40

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					STZ $1570,x
					STZ $C2,x
					LDA #$13
					STA $1504,x
                    RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


RETURN              RTS                    
START_HB_CODE       LDA $C2,x
					BNE MODE2
					JSR SUB_GFX             ; draw gfx
                    LDA $14C8,x             ; \ if hammer bro status != 8...
                    CMP #$08                ;  }   ... not (killed with spin jump [4] or star[2])
                    BNE RETURN              ; /    ... return
                    LDA $9D                 ; \ if sprites locked...
                    BNE RETURN              ; /    ... return
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					STZ $B6,x
					LDA #$04
					STA $AA,x
					INC $1570,x
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$01
					BEQ MAIN
					LDA #$FC
					STA $AA,x
MAIN				JSR DAMAGE_CHECK
					JSL $01802A 
RETURN2				RTS

MODE2				LDA $C2,x
					CMP #$02
					BEQ MODE3
					JSR SUB_GFX2             ; draw gfx
                    LDA $14C8,x             ; \ if hammer bro status != 8...
                    CMP #$08                ;  }   ... not (killed with spin jump [4] or star[2])
                    BNE RETURN2              ; /    ... return
                    ;LDA $9D                 ; \ if sprites locked...
                    ;BNE RETURN2              ; /    ... return
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA #$10
					STA $9D
					STZ $7D
					STZ $7B
					LDA $15AC,x
					BEQ MODE2_2
					STZ $AA,x
					RTS
MODE2_2				JSL $01802A
					LDA $14D4,x
					BEQ MODE2_2_2
					LDA $D8,x
					CMP #$A0
					BCC MODE2_2_2
					STZ $14C8,x
MODE2_2_2			LDA $1588,x
					AND #$04
					BEQ RETURN2
					LDA #$02
					STA $C2,x
					LDA #$20
					STA $15AC,x
					LDA EXTRA_BITS,x
					AND #$04
					BNE MODE2_3
					LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					LDA $D8,x
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
RETURN3				RTS
MODE2_3				LDA $E4,x
					AND #$F0
					STA $E4,x
					LDA $D8,x
					AND #$F0
					STA $D8,x
					RTS
MODE3				STZ $AA,x
					LDA $14C8,x             ; \ if hammer bro status != 8...
                    CMP #$08                ;  }   ... not (killed with spin jump [4] or star[2])
                    BNE RETURN3
					LDA #$10
					STA $9D
					STZ $7D
					STZ $7B
					LDA $15AC,x
					BEQ MODE3_2
					STZ $B6,x
					RTS
MODE3_2				INC $1570,x
					LDA $1570,x
					AND #$0F
					BNE MODE3_3
					LDA $1504,x
					CMP #$1A
					BEQ MODE3_3
					STA $1DF9
					INC $1504,x
MODE3_3				LDA EXTRA_BITS,x
					AND #$04
					BNE MODE3_UP
					LDA #$18
					STA $B6,x
					JSR CHANGE_TILE
					JSL $01802A
					LDA $1588,x
					AND #$03
					BEQ RETURN4
					STZ $14C8,x
RETURN4				RTS

MODE3_UP			LDA #$10
					STA $B6,x
					LDA #$F0
					STA $AA,x
					LDA $E4,x
					AND #$0F
					BNE MODE3_UP_2
					JSR CHANGE_TILE2
MODE3_UP_2			JSL $01802A
					LDA $1588,x
					AND #$03
					BEQ RETURN4
					JSR CHANGE_TILE3
					STZ $14C8,x
					RTS



CHANGE_TILE			LDA $E4,x
					STA $9A
					LDA $14E0,x
					STA $9B
					LDA $D8,x
					STA $98
					LDA $14D4,x
					STA $99
					PHP
                    REP #$30                ; \ change sprite to block 
                    LDA.W #$045F
                    STA $03                 ;  |
                    JSL $2E8DF0
                    PLP
					RTS
					
CHANGE_TILE2		LDA $E4,x
					STA $151C,x
					STA $9A
					LDA $14E0,x
					STA $1602,x
					STA $9B
					LDA $D8,x
					STA $1594,x
					STA $98
					LDA $14D4,x
					STA $157C,x
					STA $99
					PHP
                    REP #$30                ; \ change sprite to block 
                    LDA.W #$044F
                    STA $03                 ;  |
                    JSL $2E8DF0
                    PLP
					LDA $E4,x
					SEC
					SBC #$10
					STA $9A
					LDA $14E0,x
					SBC #$00
					STA $9B
					LDA $D8,x
					STA $98
					LDA $14D4,x
					STA $99
					PHP
                    REP #$30                ; \ change sprite to block 
                    LDA.W #$044E
                    STA $03                 ;  |
                    JSL $2E8DF0
                    PLP
					RTS
CHANGE_TILE3		LDA $151C,x
					STA $9A
					LDA $1602,x
					STA $9B
					LDA $1594,x
					STA $98
					LDA $157C,x
					STA $99
					PHP
                    REP #$30                ; \ change sprite to block 
                    LDA.W #$045E
                    STA $03                 ;  |
                    JSL $2E8DF0
                    PLP
					RTS
					
DAMAGE_CHECK        LDA $E4,x
                    STA $7FFE01
                    LDA $14E0,x
                    STA $7FFE02
                    LDA $D8,x
                    STA $7FFE03
                    LDA $14D4,x
                    STA $7FFE04
                    PHX
                    LDX #$09
LOOP1               LDA $14C8,x
					CMP #$09
					BEQ OUT
					CMP #$0A
					BEQ OUT
					BRA LOOP3
OUT                 JSR NEAR_CHECK
                    TYA
                    BEQ LOOP3
					STZ $14C8,x
                    LDA #$0A
					STA $1DFC
					PLX
					LDA #$01
					STA $C2,x
					LDA #$20
					STA $15AC,x
					PHX
LOOP3               DEX
                    BPL LOOP1
                    PLX
                    RTS
					
NEAR_CHECK          LDY #$00
                    LDA $E4,x
                    SEC
                    SBC $7FFE01
                    STA $0F
                    LDA $14E0,x
                    SBC $7FFE02
                    CMP #$00
                    BEQ RIGHT_CHECK
                    CMP #$FF
                    BNE CHECK_E
                    LDA $0F
                    CMP #$F8
                    BCC CHECK_E
                    BRA VER_CHECK
RIGHT_CHECK         LDA $0F
                    CMP #$08
                    BCS CHECK_E
VER_CHECK           LDA $D8,x
                    SEC
                    SBC $7FFE03
                    STA $0F
                    LDA $14D4,x
                    SBC $7FFE04
                    CMP #$00
                    BEQ UNDER_CHECK
                    CMP #$FF
                    BNE CHECK_E
                    LDA $0F
                    CMP #$F8
                    BCC CHECK_E
                    BRA NEAR
UNDER_CHECK         LDA $0F
                    CMP #$08
                    BCS CHECK_E
NEAR                LDY #$01
CHECK_E             RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
                    PHX                     ; push sprite index
					LDA $1570,x
					LSR A
					LSR A
					LSR A

					AND #$03
					STA $03
					ASL A
					CLC
					ADC $03
					STA $03
					LDX #$02
LOOP_START          
					LDA $01
					CLC
					ADC VERT_DISP,x
					STA $0301,y
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP,x         ;  |
                    STA $0300,y             ; /
					
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILEMAP,x           ; \ store tile
                    STA $0302,y
					PLX
					
					PHX
                    LDA PROPERTIES,x
                    ORA #$0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					PLX

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$02                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_GFX2           JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
					LDA $01
					STA $0301,y
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0300,y             ; /
					
					LDA #$CE
                    STA $0302,y
					
                    LDA #$0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /




