;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Dark Lich
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
                    EXTRA_BITS = $7FAB10

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA $E4,x
					ORA #$09
					STA $E4,x
					JSR HDMA_INIT1
					JSR GAGE_RESET
					JSR LAYER3_DEL
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                    
START_HB_CODE       LDA #$01
					STA $2121
					LDA #$82
					STA $2122
					LDA #$18
					STA $2122
					LDA $1504,x
					BNE MAIN0
					JSR MAIN
					RTS
MAIN0				CMP #$01
					BNE MAIN1
					JSR THUNDER_MAIN
					RTS 
MAIN1				CMP #$02
					BNE MAIN2
					JSR CENTER_MAIN
					RTS
MAIN2				CMP #$03
					BNE MAIN3
					JSR HAT
					RTS
MAIN3				CMP #$04
					BNE MAIN4
					JSR SUN
					RTS
MAIN4				CMP #$05
					BNE MAIN5
					JSR SUNBEAM
					RTS
MAIN5				CMP #$06
					BNE MAIN6
					JSR FIRE
					RTS
MAIN6				CMP #$07
					BNE MAIN7
					JSR STONE
					RTS
MAIN7				CMP #$08
					BNE MAIN8
					JSR BUBLE
					RTS
MAIN8				CMP #$09
					BNE MAIN9
					JSR ICE
					RTS
MAIN9				CMP #$0A
					BNE MAINA
					JSR BUTA
					RTS
MAINA				CMP #$0B
					BNE MAINB
					JSR SWORD
					RTS
MAINB				CMP #$0C
					BNE MAINC
					JSR BARRIER
					RTS
MAINC				CMP #$0D
					BNE MAIND
					JSR F_BUBLE
					RTS
MAIND				JSR DEATH
					RTS
					
					


RETURN_M			RTS
MAIN				LDA $7FF345
					CMP #$66
					BEQ MAIN_NO_G
					JSR SUB_GFX
MAIN_NO_G			LDA $9D
					BNE RETURN_M
					JSR MARIO_WARP
					JSL $AC82B7
					LDA #$03
					STA $0F31
					LDA $1FF2
					AND #$10
					BEQ MAIN_0
					JSR GHOST_MODE
					RTS
MAIN_0				LDA $16
					ORA $18
					BEQ MAIN_1
					INC $1570,x
MAIN_1				JSR GAGE2_CHECK
					LDA $C2,x
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$01
					BNE NOT_MODE2
					JSR MODE2
					RTS
NOT_MODE2			CMP #$02
					BNE NOT_MODE3
					JSR MODE3
					RTS
NOT_MODE3			CMP #$03
					BNE NOT_MODE4
					JSR MODE4
					RTS
NOT_MODE4			JSR MODE5
					RTS
					
CENTER_MAIN_D		STZ $14C8,x
CENTER_MAIN_R		RTS
CENTER_MAIN			JSR SUB_GFX_C
					LDA $9D
					BNE CENTER_MAIN_R
					LDA $1594,x
                    STA $AA,x
                    LDA $1570,x
                    STA $B6,x
					JSL $01802A
					JSR CHECK_DAMAGE
					LDA $14E0,x
					CMP #$00
					BNE CENTER_MAIN_D
					LDA $14D4,x
					BNE CENTER_MAIN_1
					LDA $D8,x
					CMP #$C0
					BCC CENTER_MAIN_D
					BRA CENTER_MAIN_2
CENTER_MAIN_1		LDA $D8,x
					CMP #$B0
					BCS CENTER_MAIN_D
CENTER_MAIN_2		LDA $15AC,x
					CMP #$FE
					BEQ CENTER_MAIN_4
					CMP #$60
					BEQ CENTER_MAIN_3
					RTS
CENTER_MAIN_4		JSR SUB_SMOKE
					RTS
CENTER_MAIN_3		LDA #$10
					STA $1DF9
					LDA #$80
					STA $1570,x
					LDA #$40
					STA $151C,x
					REP #$20
					LDA.W $96
					CLC
					ADC.W #$0010
					STA $96
					SEP #$20
					JSR SPEED_DEC
					LDA $1594,x
                    STA $AA,x
                    LDA $1570,x
                    STA $B6,x
					REP #$20
					LDA.W $96
					SEC
					SBC.W #$0010
					STA $96
					SEP #$20
					RTS
					
SUNBEAM				JSR SUB_GFX_B
					LDA $9D
					BNE RETURN_B
					LDA $14D4,x
					BEQ SUNBEAM_2
					LDA $D8,x
					CMP #$B0
					BCC SUNBEAM_2
					STZ $14C8,x
					RTS
SUNBEAM_2			STZ $B6,x
					LDA #$7F
					STA $AA,x
					JSL $01802A
					JSL $01A7DC
RETURN_B			RTS
					
HAT					JSR SUB_GFX_H
					LDA $9D
					BNE RETURN_H
					STZ $B6,x
					JSL $01802A
					LDA $7FFF01
					BNE HAT_4
					JSL $01A7DC
					BCC RETURN_H
					LDA #$01
					STA $7FFF01
					JSL $01ACF9
					CLC
					ADC $1570,x
					CLC
					ADC $94
					AND #$01
					BNE HAT_3
					LDA #$29
					STA $1DFC
					JSR GEN_NORMAL
					LDA #$C0
					STA $1540,y
					BRA HAT_2
HAT_3				LDA #$2A
					STA $1DFC
HAT_2				JSR SUB_SMOKE
					STZ $14C8,x
RETURN_H			RTS
HAT_4				LDA #$02
					STA $7FFF01
					BRA HAT_2
					
RETURN_S			RTS
SUN					JSR SUB_GFX_S
					LDA $9D
					BNE RETURN_S
					LDA $151C,x
					STA $AA,x
					JSL $01802A
					JSL $01A7DC
					LDA $1528,x
					CMP #$03
					BNE SUN_0
					JSR SUN3
					RTS
SUN_0				LDA $157C,x
					BEQ SUN2
					LDA $15AC,x
					CMP #$C1
					BCS RETURN_S
					CMP #$C0
					BEQ SUN_1
					CMP #$80
					BCS SUN_2
					CMP #$40
					BEQ SUN_3
					CMP #$20
					BEQ SUN_4
					RTS
SUN2				LDA $15AC,x
					CMP #$C1
					BCS RETURN_S
					CMP #$C0
					BEQ SUN2_1
					CMP #$80
					BCS SUN2_2
					CMP #$40
					BEQ SUN2_3
					CMP #$20
					BEQ SUN2_4_2
					RTS
SUN_1				LDA #$2B
					STA $1DFC
					LDA #$60
					STA $151C,x
					STA $AA,x
					LDA #$FE
					STA $B6,x
					RTS
					
SUN_2				LDA $151C,x
					BEQ RETURN_S
					DEC A
					DEC A
					STA $151C,x
					LDA $B6,x
					CMP #$B0
					BCC RETURN_S
					DEC $B6,x
					DEC $B6,x
					RTS
SUN_3				STZ $151C,x
					LDA #$40
					STA $B6,x
					LDA #$00
					STA $14D4,x
					LDA #$D8
					STA $D8,x
					LDA #$A0
					STA $E4,x
					LDA #$FF
					STA $14E0,x
					RTS
SUN2_4_2			BRA SUN2_4
SUN_4				STZ $157C,x
					STZ $B6,x
					LDA #$20
					STA $E4,x
					LDA #$FF
					STA $15AC,x
					INC $1528,x
					RTS
SUN2_1				LDA #$2B
					STA $1DFC
					LDA #$60
					STA $151C,x
					STA $AA,x
					LDA #$02
					STA $B6,x
					RTS
					
SUN2_2				LDA $151C,x
					BEQ RETURN_S2
					DEC A
					DEC A
					STA $151C,x
					LDA $B6,x
					CMP #$50
					BCS RETURN_S2
					INC $B6,x
					INC $B6,x
RETURN_S2			RTS
SUN2_3				STZ $151C,x
					LDA #$C0
					STA $B6,x
					LDA #$00
					STA $14D4,x
					LDA #$D8
					STA $D8,x
					LDA #$60
					STA $E4,x
					LDA #$01
					STA $14E0,x
					RTS
SUN2_4				INC $157C,x
					STZ $B6,x
					LDA #$D0
					STA $E4,x
					LDA #$FF
					STA $15AC,x
					INC $1528,x
					RTS
					
SUN3				LDA $15AC,x
					CMP #$D0
					BCS SUN3_1
					CMP #$C0
					BEQ SUN3_2
					CMP #$90
					BEQ SUN3_3
					CMP #$60
					BEQ SUN3_3
					CMP #$30
					BEQ SUN3_3
					CMP #$00
					BEQ SUN3_4
					RTS
SUN3_1				LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					ASL A
					ASL A
					CLC
					ADC #$05
					STA $1570,x
					RTS
SUN3_2				LDA #$09
					STA $1570,x
					LDA #$27
					STA $1DFC
					JSR GEN_NORMAL
					LDA #$70
					STA $1540,y
					LDA $D8,x
					CLC
					ADC #$10
					STA $00D8,y
					LDA $14D4,x
					ADC #$00
					STA $14D4,y
					RTS
SUN3_3				LDA #$27
					STA $1DFC
					JSR GEN_SPRITE
					LDA #$05
					STA $1504,y
					LDA #$22
					STA $167A,y
					LDA $D8,x
					CLC
					ADC #$10
					STA $00D8,y
					LDA $14D4,x
					ADC #$00
					STA $14D4,y
					RTS
SUN3_4				LDA #$05
					STA $1570,x
					STZ $1528,x
					LDA #$FF
					STA $15AC,x
					RTS
					
FIRE_SPEED			dcb $30,$D0
FIRE				JSR SUB_GFX_F
					LDA $9D
					BNE FIRE_R
					JSL $01A7DC
					LDA $AA,x
					PHA
					JSL $01802A
					PLA
					STA $AA,x
					LDY $157C,x
					LDA FIRE_SPEED,y
					STA $B6,x
					INC $1570,x
					LDA $1570,x
					CMP #$10
					BCC FIRE_3
					CMP #$30
					BCC FIRE_4
					CMP #$50
					BCC FIRE_3
					CMP #$70
					BCC FIRE_4
					CMP #$90
					BCC FIRE_3
					CMP #$A0
					BCC FIRE_4
					CMP #$C0
					BCC FIRE_3
					CMP #$E0
					BCC FIRE_4
FIRE_3				DEC $AA,x
					DEC $AA,x
					BRA FIRE_5
FIRE_4				INC $AA,x
					INC $AA,x
FIRE_5				LDA $157C,x
					BEQ FIRE_2
					LDA $14E0,x
					CMP #$FF
					BEQ FIRE_DELETE
FIRE_R				RTS
FIRE_2				LDA $14E0,x
					CMP #$01
					BNE FIRE_R
FIRE_DELETE			STZ $14C8,x
					RTS
					
THUNDER_MAIN		JSR SUB_GFX_T
					LDA $9D
					BNE RETURN_T
					LDA $14D4,x
					BEQ THUNDER_2
					LDA $D8,x
					CMP #$B0
					BCC THUNDER_2
					STZ $14C8,x
					RTS
THUNDER_2			STZ $B6,x
					LDA #$7F
					STA $AA,x
					JSL $01802A
THUNDER_DAMAGE		LDA $D8,x
					PHA
					LDA $14D4,x
					PHA
					JSR CHECK_DAMAGE
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSR CHECK_DAMAGE
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSR CHECK_DAMAGE
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSR CHECK_DAMAGE
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSR CHECK_DAMAGE
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
RETURN_T			RTS

ICE					JSR SUB_GFX_I
					LDA $9D
					BNE RETURN_I
					JSL $01A7DC
					LDA #$E8
					STA $AA,x
					JSL $01802A
					LDA $14D4,x
					BNE RETURN_I
					LDA $D8,x
					CMP #$B0
					BCS RETURN_I
					STZ $14C8,x
RETURN_I			RTS

BUBLE				JSR SUB_GFX_BU
					LDA $9D
					BNE RETURN_BU
					JSL $01A7DC
					BCC BUBLE_1
					STZ $14C8,x
					JSR BREAK
					LDA #$19
					STA $1DFC
					LDA $151C,x
					CMP #$01
					BEQ BUBLE_3
					CMP #$02
					BEQ BUBLE_4
					RTS
BUBLE_3				JSR GEN_FEATURE
					RTS
BUBLE_4				JSR GEN_NORMAL
					LDA #$80
					STA $1540,y
					RTS
BUBLE_1				INC $1570,x
					LDA #$08
					STA $B6,x
					LDA $1570,x
					AND #$20
					BNE BUBLE_2
					LDA #$F8
					STA $B6,x
BUBLE_2				LDA #$F0
					STA $AA,x
					JSL $01802A
					LDA $14D4,x
					BNE RETURN_BU
					LDA $D8,x
					CMP #$B0
					BCS RETURN_BU
					STZ $14C8,x
RETURN_BU			RTS

STONE				LDA $9D
                    BNE LABEL92
					INC $157C,x
					LDA $157C,x
					CMP #$48
					BCC STONE_2
					STZ $14C8,x
					RTS
STONE_2				LDY #$FF ;#vȂY=0 t]ȂY=FF
					LDA #$04  ;#]x
                    CLC
                    ADC $1602,x
                    STA $1602,x ;#݂̉]l Lowbyte $00
                    TYA
                    ADC $151C,x ;#݂̉]l Highbyte AND #$01 $01
                    AND #$01
                    STA $151C,x
LABEL92             LDA $151C,x
                    STA $01
                    LDA $1602,x
                    STA $00
                    REP #$30 ;#16bit[h
                    LDA $00
                    CLC
                    ADC.W #$0080 ;#]l80𑫂$02-$03
                    AND.W #$01FF
                    STA $02
                    LDA $00
                    AND.W #$00FF
                    ASL A
                    TAX
                    LDA $07F7DB,x ;#]pɑ΂W̊i[lH
                    STA $04
                    LDA $02
                    AND.W #$00FF
                    ASL A
                    TAX
                    LDA $07F7DB,x
                    STA $06       ;#90xY̍WH
                    SEP #$30
                    LDX $15E9
					
								;#8bitx8bit
					            ;#$4202ɔ搔Zbg
								;#$4203ɏ搔Zbg
								;#8TCNA$4216-$4217ɏZ(16bit)܂B
								
                    LDA $04
                    STA $4202   ;#]pɑ΂WW
                    LDA $157C,x  ;#w肵a
                    LDY $05    ;#ΑȂ
                    BNE LABEL93
                    STA $4203   ;#a
                    ASL $4216   ;#ɔ{ɂH
                    LDA $4217
                    ADC #$00
LABEL93             LSR $01
                    BCC LABEL94
                    EOR #$FF                ; \ reverse direction of rotation
                    INC A                   ; /#180xȏȂl𔽓]
LABEL94             STA $04
                    LDA $06
                    STA $4202
                    LDA $157C,x  ;#w肵a
                    LDY $07
                    BNE LABEL95
                    STA $4203
                    ASL $4216
                    LDA $4217
                    ADC #$00
LABEL95             LSR $03
                    BCC LABEL96
                    EOR #$FF
                    INC A
LABEL96             STA $06
                    LDA $E4,x ;#W
                    PHA
                    LDA $14E0,x
                    PHA
                    LDA $D8,x
                    PHA
                    LDA $14D4,x
                    PHA
					
                    LDY $0F86,x
                    STZ $00
                    LDA $04
                    BPL LABEL97
                    DEC $00
LABEL97             ASL A
					CLC
                    ADC $E4,x
                    STA $E4,x
                    PHP
                    PHA
                    SEC
                    SBC $1534,x
                    STA $1528,x
                    PLA
                    STA $1534,x
                    PLP
                    LDA $14E0,x
                    ADC $00
                    STA $14E0,x
                    STZ $01
                    LDA $06
                    BPL LABEL98
                    DEC $01
LABEL98             ASL A
					CLC
                    ADC $D8,x
                    STA $D8,x
                    LDA $14D4,x
                    ADC $01
                    STA $14D4,x
            
                    JSL $01A7DC             ; check for mario/sprite contact
                    JSR SUB_GFX_ST
                    
                    PLA     
                    STA $14D4,x
                    PLA        
                    STA $D8,x  
                    PLA        
                    STA $14E0,x
                    PLA        
                    STA $E4,x                   
                    
DONE                LDY #$02                ; \ 02 because we haven't written to $0460
                    LDA #$00                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
BUTA_SPEED			dcb $10,$F0
BUTA				JSR SUB_GFX_BUTA
					LDA $9D
					BNE BUTA_R
					LDA $15AC,x
					CMP #$F0
					BCS BUTA_2
					CMP #$40
					BEQ BUTA_DELETE
					RTS
BUTA_2				LDY $157C,x
					LDA BUTA_SPEED,y
					STA $B6,x
					STZ $AA,x
					JSL $01802A
BUTA_R				RTS
BUTA_DELETE			STZ $14C8,x
					RTS
					
SWORD				JSR SUB_GFX_SW
					LDA $9D
					BNE SWORD_R
					LDA #$40
					STA $AA,x
					JSL $01802A
					LDA $14D4,x
					BEQ SWORD_R
					LDA $D8,x
					CMP #$80
					BEQ SWORD_2
					CMP #$90
					BEQ SWORD_2
					CMP #$A0
					BEQ SWORD_2
					CMP #$B0
					BEQ SWORD_D
SWORD_R				RTS
SWORD_D				STZ $14C8,x
					RTS
SWORD_2				LDA $E4,x
					STA $9A
					LDA $14E0,x
					STA $9B
					LDA $D8,x
					STA $98
					LDA $14D4,x
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0025
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
					
BARRIER_TABLE		dcb $10,$F0
BARRIER				JSR SUB_GFX_T
					LDA $9D
					BNE BARRIER_R
					JSR THUNDER_DAMAGE
					LDA $1540,x
					BNE BARRIER_2
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$01
					TAY
					LDA BARRIER_TABLE,y
					STA $B6,x
					JSL $018022
					INC $1570,x
					RTS
BARRIER_2			LDY $157C,x
					LDA BARRIER_TABLE,y
					STA $B6,x
					JSL $018022
BARRIER_R			RTS

F_BUBLE				JSR SUB_GFX_FB
					LDA $9D
					BNE F_BUBLE_R
					JSL $01A7DC
					REP #$20
					LDA.w #$8600
					STA $0D8B
					LDA.w #$8800
					STA $0D95
					SEP #$20
					JSL $01802A
					LDA $14
					AND #$07
					BNE F_BUBLE_2
					JSL $0285DF ;#GtFNg
F_BUBLE_2			LDA $AA,x
					CMP #$80
					BCS F_BUBLE_R
					LDA $14D4,x
					BEQ F_BUBLE_R
					LDA $D8,x
					CMP #$B0
					BCC F_BUBLE_R
					STZ $14C8,x
F_BUBLE_R			RTS

DEATH				JSR SUB_GFX_D
					LDA $9D
					BNE DEATH_R
					LDA $94
					STA $00E4,x
					LDA $95
					STA $14E0,x
					LDA $1540,x
					BNE DEATH_R
					LDA $157C,x
					BNE DEATH_2
					LDA #$18
					STA $AA,x
					JSL $01802A
					JSL $01A7DC
					BCC DEATH_R
					LDA #$20
					STA $1540,x
					INC $157C,x
					LDA #$77
					STA $7FFF19
DEATH_R				RTS
DEATH_2				LDA #$E8
					STA $AA,x
					JSL $01802A
					LDA $14D4,x
					BNE DEATH_R
					LDA $D8,x
					CMP #$B0
					BCS DEATH_R
					STZ $14C8,x
					LDA #$77
					STA $7FFF08
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X_SPEED				dcb $04,$FC

MODE1				JSR POS_OFFSET
					JSR BLK_CHECK
					LDA $1602,x
					BEQ MODE1_MAIN
					CMP #$02
					BEQ MODE1_RIGHT
					CMP #$03
					BEQ MODE1_LEFT
					JSR CENTER
					RTS
MODE1_RIGHT			JSR RIGHT
					RTS
MODE1_LEFT			JSR LEFT
					RTS
MODE1_MAIN			LDA $1528,x
					CMP #$02
					BEQ MODE1_4
					LDY $157C,x
					LDA X_SPEED,y
					STA $B6,x
					JSL $018022
					LDA $E4,x
					CMP #$B0
					BEQ MODE1_1
					CMP #$40
					BEQ MODE1_2
					CMP #$78
					BEQ MODE1_3
					RTS
MODE1_4				LDA $E4,x
					CMP #$78
					BEQ MODE1_5
					LDY $157C,x
					LDA X_SPEED,y
					STA $B6,x
					JSL $018022
					RTS
MODE1_1				LDA #$01
					STA $157C,x
					LDA #$02
					STA $1602,x
					LDA #$FF
					STA $15AC,x
					RTS
MODE1_2				STZ $157C,x
					LDA #$03
					STA $1602,x
					LDA #$FF
					STA $15AC,x
					RTS
MODE1_3				LDA #$01
					STA $1602,x
					LDA #$FF
					STA $15AC,x
					RTS
MODE1_5				JSR HDMA_COLOR
					LDA #$FF
					STA $7FE301
					LDA #$7F
					STA $7FE302
					LDA #$01
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					STZ $157C,x
					STZ $B6,x
					STZ $1468
					JSR GEN_SPRITE
					LDA #$22
					STA $167A,y
					LDA #$FF
					STA $15AC,y
					LDA #$04
					STA $1504,y
					LDA #$05
					STA $1570,y
					LDA #$D0
					STA $00E4,y
					LDA #$D8
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA #$01
					STA $157C,y
					LDA #$18
					STA $1DFC
					RTS
					
MODE2				JSR POS_OFFSET3
					LDA $157C,x
					CMP #$01
					BNE MODE2_A
					JSR MODE2_3
					RTS
MODE2_A				CMP #$03
					BNE MODE2_B
					JSR MODE2_C
					RTS
MODE2_B				JSR BLK_CHECK
					LDA $C2,x
					CMP #$02
					BEQ MODE2_R
					LDA $7FE301
					BEQ MODE2_1
					REP #$30
					LDA $7FE301
					SEC
					SBC #$0421
					STA $7FE301
					SEP #$30
MODE2_1				STZ $1602,x
					LDA $14
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$01
					BNE MODE2_2
					LDA #$04
					STA $1602,x
MODE2_2				LDA $15AC,x
					BNE MODE2_R
					INC $157C,x
					LDA $157C,x
					CMP #$03
					BEQ MODE2_2_2
					LDA #$FF
					STA $15AC,x
					JSR HDMA_COLOR
					LDA #$1F
					STA $7FE301
					LDA #$00
					STA $7FE302
					LDA #$01
					STA $1602,x
MODE2_R				RTS
MODE2_2_2			STZ $40
					LDA #$04
					STA $1602,x
					STZ $15AC,x
					JSR HDMA_LAYER1
					JSR HDMA_MASK
					RTS
MODE2_3				JSR BLK_CHECK
					LDA $C2,x
					CMP #$02
					BEQ MODE2_R
					LDA $15AC,x
					BEQ MODE2_6
					CMP #$FF
					BEQ MODE2_4
					CMP #$CF
					BEQ MODE2_5
					CMP #$8F
					BEQ MODE2_4
					CMP #$4F
					BEQ MODE2_5
					RTS
MODE2_6				LDA #$FF
					STA $15AC,x
					INC $157C,x
					LDA #$00
					STA $7FE301
					STA $7FE302
					RTS
MODE2_4				JSR GEN_SPRITE
					LDA #$22
					STA $167A,y
					LDA #$06
					STA $1504,y
					JSL $01ACF9
					CLC
					ADC $94
					AND #$3F
					CLC
					ADC #$50
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					LDA #$01
					STA $157C,y
					LDA #$00
					STA $00E4,y
					LDA #$01
					STA $14E0,y
					RTS
MODE2_5				JSR GEN_SPRITE
					LDA #$22
					STA $167A,y
					LDA #$06
					STA $1504,y
					JSL $01ACF9
					CLC
					ADC $94
					AND #$3F
					CLC
					ADC #$50
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					LDA #$00
					STA $157C,y
					LDA #$F0
					STA $00E4,y
					LDA #$FF
					STA $14E0,y
					RTS
MODE2_C				LDA $15AC,x
					BNE MODE2_C_2
					REP #$30
					LDA $7FE901
					DEC A
					STA $7FE901
					LDA $7FE904
					INC A
					STA $7FE904
					SEP #$30
					LDA $7FE802
					DEC A
					STA $7FE802
					LDA $7FE804
					INC A
					STA $7FE804
					LDA $7FE804
					CMP #$61
					BNE MODE2_C_R
					LDA #$FF
					STA $15AC,x
MODE2_C_R			RTS
MODE2_C_2			LDA $15AC,x
					CMP #$E0
					BEQ MODE2_C_G1
					CMP #$80
					BEQ MODE2_C_G2_2
					CMP #$70
					BCC MODE2_C_3
					RTS
MODE2_C_3			REP #$30
					LDA $7FE901
					INC A
					STA $7FE901
					LDA $7FE904
					DEC A
					STA $7FE904
					SEP #$30
					LDA $7FE802
					INC A
					STA $7FE802
					LDA $7FE804
					DEC A
					STA $7FE804
					LDA $7FE804
					CMP #$01
					BEQ MODE2_C_4
					RTS
MODE2_C_4			LDA #$20
					STA $40
					JSR HDMA_COLOR
					LDA #$FF
					STA $15AC,x
					STZ $157C,x
					RTS
MODE2_C_G2_2		BRA MODE2_C_G2
MODE2_C_G1			JSR GEN_SPRITE
					LDA #$22
					STA $167A,y
					LDA #$07
					STA $1504,y
					JSR GEN_SPRITE
					LDA #$22
					STA $167A,y
					LDA #$07
					STA $1504,y
					LDA #$80
					STA $1602,y
					JSR GEN_SPRITE
					LDA #$22
					STA $167A,y
					LDA #$07
					STA $1504,y
					LDA #$01
					STA $151C,y
					JSR GEN_SPRITE
					LDA #$22
					STA $167A,y
					LDA #$07
					STA $1504,y
					LDA #$01
					STA $151C,y
					LDA #$80
					STA $1602,y
					RTS
MODE2_C_G2			JSR GEN_SPRITE
					LDA #$22
					STA $167A,y
					LDA #$07
					STA $1504,y
					LDA #$40
					STA $1602,y
					JSR GEN_SPRITE
					LDA #$22
					STA $167A,y
					LDA #$07
					STA $1504,y
					LDA #$C0
					STA $1602,y
					JSR GEN_SPRITE
					LDA #$22
					STA $167A,y
					LDA #$07
					STA $1504,y
					LDA #$01
					STA $151C,y
					LDA #$40
					STA $1602,y
					JSR GEN_SPRITE
					LDA #$22
					STA $167A,y
					LDA #$07
					STA $1504,y
					LDA #$01
					STA $151C,y
					LDA #$C0
					STA $1602,y
					RTS
					
MODE3_TABLE1		dcb $D8,$18,$58,$D8,$18,$58,$D8,$18,$58,$D8,$18,$58,$D8,$18,$58,$D8
MODE3_TABLE2		dcb $00,$01,$01,$00,$01,$01,$00,$01,$01,$00,$01,$01,$00,$01,$01,$00

MODE3_R				RTS
MODE3				JSR BLK_CHECK
					LDA $C2,x
					CMP #$03
					BEQ MODE3_R
					JSR POS_OFFSET3
					STZ $1602,x
					LDA $14
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$01
					BNE MODE3_0
					LDA #$04
					STA $1602,x
MODE3_0				LDA $7FE301
					BEQ MODE3_1
					REP #$30
					LDA $7FE301
					SEC
					SBC #$0421
					STA $7FE301
					SEP #$30
MODE3_1				INC $157C,x
					LDA $157C,x
					CMP #$60
					BNE MODE3_3
					STZ $157C,x
					JSL $01ACF9
					STA $03
					LDA $1570,x
					AND #$0F
					ASL A
					ASL A
					ASL A
					ASL A
					CLC
					ADC $94
					CLC
					ADC $03
					STA $7FFF03
					JSR GEN_SPRITE
					LDA #$08
					STA $1504,y
					LDA $7FFF03
					STA $00E4,y
					LDA #$00
					STA $14E0,y
					LDA #$B0
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					JSL $01ACF9
					STA $1570,y
					JSL $01ACF9
					SEC
					SBC $1570,x
					AND #$07
					STA $151C,y
					BEQ MODE3_2
					CMP #$07
					BEQ MODE3_2
					BRA MODE3_3
MODE3_2				LDA #$09
					STA $1504,y
					LDA #$22
					STA $167A,y
MODE3_3				LDA $1540,x
					BEQ MODE3_3_0
					JSR MODE3_A
					RTS
MODE3_3_0			LDA $15AC,x
					CMP #$80
					BEQ MODE3_4
					CMP #$01
					BEQ MODE3_5
					RTS
MODE3_4				JSL $01ACF9
					SEC
					SBC $94
					CLC
					ADC $1570,x
					AND #$0F
					TAY
					LDA MODE3_TABLE1,y
					STA $7FFF05
					LDA MODE3_TABLE2,y
					STA $7FFF06
					JSR GEN_SPRITE
					LDA #$0A
					STA $1504,y
					LDA #$F0
					STA $00E4,y
					LDA #$FF
					STA $14E0,y
					LDA $7FFF05
					STA $00D8,y
					LDA $7FFF06
					STA $14D4,y
					LDA #$00
					STA $157C,y
					LDA #$FF
					STA $15AC,y
					JSR GEN_SPRITE
					LDA #$0A
					STA $1504,y
					LDA #$00
					STA $00E4,y
					LDA #$01
					STA $14E0,y
					LDA $7FFF05
					STA $00D8,y
					LDA $7FFF06
					STA $14D4,y
					LDA #$01
					STA $157C,y
					LDA #$FF
					STA $15AC,y
					RTS
MODE3_5				LDA #$17
					STA $1DFC
					LDA #$40
					STA $1540,x
					JSR HDMA_WATER
					LDA $7FFF05
					CMP #$18
					BEQ MODE3_5_2
					CMP #$58
					BEQ MODE3_5_3
					RTS
MODE3_5_2			LDA #$60
					STA $7FE303
					STA $7FE202
					RTS
MODE3_5_3			LDA #$41
					STA $7FE300
					STA $7FE200
					LDA #$60
					STA $7FE303
					STA $7FE202
					RTS
MODE3_A				LDA $7FE30F
					CMP #$3F
					BEQ MODE3_A_3
					LDA $7FE303
					DEC A
					STA $7FE303
					STA $7FE202
					LDA $7FE30F
					INC A
					INC A
					STA $7FE30F
					STA $7FE20A
					RTS
MODE3_A_2			PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					LDA $1540,x
					CMP #$01
					BNE MODE3_A_R
					JSR HDMA_COLOR
					STZ $1540,x
					LDA #$FF
					STA $15AC,x
MODE3_A_R			RTS
MODE3_A_3			LDA $E4,x
					PHA
					LDA $14E0,x
					PHA
					LDA $D8,x
					PHA
					LDA $14D4,x
					PHA
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $7FFF05
					CMP #$18
					BEQ MODE3_A_4
					CMP #$58
					BEQ MODE3_A_5
					LDA #$C0
					STA $D8,x
					LDA #$00
					STA $14D4,x
					JSR CHECK_DAMAGE
					LDA #$D0
					STA $D8,x
					JSR CHECK_DAMAGE
					LDA #$E0
					STA $D8,x
					JSR CHECK_DAMAGE
					LDA #$F0
					STA $D8,x
					JSR CHECK_DAMAGE
MODE3_A_6			BRA MODE3_A_2
MODE3_A_4			LDA #$00
					STA $D8,x
					LDA #$01
					STA $14D4,x
					JSR CHECK_DAMAGE
					LDA #$10
					STA $D8,x
					JSR CHECK_DAMAGE
					LDA #$20
					STA $D8,x
					JSR CHECK_DAMAGE
					LDA #$30
					STA $D8,x
					JSR CHECK_DAMAGE
					BRA MODE3_A_6
MODE3_A_5			LDA #$40
					STA $D8,x
					LDA #$01
					STA $14D4,x
					JSR CHECK_DAMAGE
					LDA #$50
					STA $D8,x
					JSR CHECK_DAMAGE
					LDA #$60
					STA $D8,x
					JSR CHECK_DAMAGE
					LDA #$70
					STA $D8,x
					JSR CHECK_DAMAGE
					BRA MODE3_A_6
					
MODE4_TABLE1		dcb $00,$30,$60,$90,$C0,$F0,$FF,$FF
MODE4_R				RTS
MODE4				LDA $C2,x
					CMP #$04
					BEQ MODE4_R
					STZ $1602,x
					LDA $14
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$01
					BNE MODE4_1
					LDA #$04
					STA $1602,x
MODE4_1				STZ $149F
					JSR BLK_CHECK
					LDA $1540,x
					BEQ MODE4_2
					JSR MODE4_A
					RTS
MODE4_2				JSR POS_OFFSET
					JSR MODE4_B
					LDY $157C,x
					LDA X_SPEED,y
					STA $B6,x
					JSL $018022
					LDA $E4,x
					CMP #$B0
					BEQ MODE4_3
					CMP #$40
					BEQ MODE4_4
					RTS
MODE4_3				LDA #$01
					STA $157C,x
					RTS
MODE4_4				STZ $157C,x
					RTS

MODE4_A				LDA $7FE301
					BEQ MODE4_A_1
					REP #$30
					LDA $7FE301
					SEC
					SBC #$0421
					STA $7FE301
					SEP #$30
MODE4_A_1			LDA $1540,x
					CMP #$F0
					BEQ MODE4_A_G
					CMP #$C8
					BEQ MODE4_A_G
					CMP #$A0
					BEQ MODE4_A_G
					CMP #$78
					BEQ MODE4_A_G
					CMP #$50
					BEQ MODE4_A_G
					CMP #$28
					BEQ MODE4_A_G
					CMP #$08
					BEQ MODE4_A_G2
					RTS
MODE4_A_G			LDA $7FFF07
					TAY
					INC A
					STA $7FFF07
					LDA MODE4_TABLE1,y
					STA $7FFF08
					JSR GEN_SPRITE
					LDA #$0B
					STA $1504,y
					LDA #$00
					STA $14E0,y
					STA $14D4,y
					LDA $7FFF08
					STA $00E4,y
					LDA #$B0
					STA $00D8,y
					LDA #$2B
					STA $1DFC
					RTS
MODE4_A_G2			JSR GEN_SPRITE
					LDA #$0C
					STA $1504,y
					LDA #$00
					STA $00E4,y
					STA $14E0,y
					LDA #$01
					STA $14D4,y
					LDA #$00
					STA $157C,y
					LDA #$40
					STA $1540,y
					STA $1570,y
					LDA #$70
					STA $00D8,y
					JSR GEN_SPRITE
					LDA #$0C
					STA $1504,y
					LDA #$F0
					STA $00E4,y
					LDA #$00
					STA $14E0,y
					LDA #$01
					STA $14D4,y
					STA $157C,y
					LDA #$40
					STA $1540,y
					STA $1570,y
					LDA #$70
					STA $00D8,y
					JSR HDMA_INIT1
					RTS
MODE4_B				INC $1594,x
					LDA $1594,x
					BEQ MODE4_G
					CMP #$40
					BEQ MODE4_G
					CMP #$80
					BEQ MODE4_G
					CMP #$C0
					BEQ MODE4_G
MODE4_B_R			RTS
MODE4_G				JSL $01ACF9
					CLC
					ADC $94
					AND #$07
					TAY
					LDA MODE4_TABLE1,y
					CMP #$FF
					BEQ MODE4_B_R
					STA $7FFF06
					LDA #$17
					STA $1DFC
					JSL $01ACF9
					SEC
					SBC $1570,x
					AND #$0F
					CMP #$05
					BCC MODE4_G_2
					JSR GEN_SPRITE
					LDA #$22
					STA $167A,y
					LDA #$0D
					STA $1504,y
MODE4_G_1			LDA #$B0
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					LDA $7FFF06
					STA $00E4,y
					LDA #$00
					STA $14E0,y
					LDA #$80
					STA $00AA,y
					RTS
MODE4_G_2			JSR GEN_NORMAL
					LDA #$C0
					STA $1540,y
					BRA MODE4_G_1
					
MODE5_TABLE			dcb $10,$40,$70,$A0,$D0,$20,$50,$80,$B0,$E0,$00,$30,$60,$90,$C0,$F0
MODE5				LDA $1558,x
					BEQ MODE5_0
					JSR MODE5_A
					RTS
MODE5_0				LDA $15AC,x
					CMP #$B0
					BCS MODE5_R
					CMP #$AF
					BEQ MODE5_1
					LDA #$02
					STA $18BD
					LDA $7FFF05
					STA $13E0
					LDA $7FFF06
					STA $13DF
					LDA #$10
					STA $15AC,x
					LDA $7FFF08
					CMP #$77
					BNE MODE5_R
					LDA #$FF
					STA $1558,x
MODE5_R				RTS
MODE5_1				LDA #$01
					STA $1602,x
					LDA $13E0
					STA $7FFF05
					LDA $13DF
					STA $7FFF06
					JSR GEN_SPRITE
					LDA #$0E
					STA $1504,y
					LDA #$B0
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA $94
					STA $00E4,y
					LDA $95
					STA $14E0,y
					STA $7FFF07
					RTS
MODE5_A				LDA $1558,x
					CMP #$F0
					BEQ MODE5_A_G
					CMP #$D8
					BEQ MODE5_A_G
					CMP #$C0
					BEQ MODE5_A_G
					CMP #$A8
					BEQ MODE5_A_G
					CMP #$90
					BEQ MODE5_A_G
					CMP #$78
					BEQ MODE5_A_G
					CMP #$60
					BEQ MODE5_A_G
					CMP #$48
					BEQ MODE5_A_G
					CMP #$30
					BEQ MODE5_A_G
					CMP #$18
					BEQ MODE5_A_G
					CMP #$14
					BCS MODE5_A_R
					LDA #$10
					STA $1558,x
MODE5_A_R			RTS
MODE5_A_G			LDA $7FFF07
					TAY
					INC A
					STA $7FFF07
					LDA MODE5_TABLE,y
					STA $7FFF0A
					JSR GEN_SPRITE
					LDA #$0B
					STA $1504,y
					LDA #$00
					STA $14E0,y
					STA $14D4,y
					LDA $7FFF0A
					STA $00E4,y
					LDA #$B0
					STA $00D8,y
					LDA #$2B
					STA $1DFC
					RTS
					
GHOST_MODE			LDA $1FF2
					AND #$08
					BNE GHOST_MODE_R
					LDA $1570,x
					CMP #$10
					BCS GHOST_MODE_R
					LDA $14
					AND #$1F
					BEQ GHOST_MODE_G
GHOST_MODE_R		RTS
GHOST_MODE_G		LDA $1570,x
					BNE GHOST_MODE_G_2
					JSR VRAM_DARK
GHOST_MODE_G_2		JSR GEN_SPRITE
					LDA #$0B
					STA $1504,y
					PHX
					LDA $1570,x
					INC $1570,x
					AND #$0F
					TAX
					LDA MODE5_TABLE,x
					STA $00E4,y
					PLX
					LDA #$00
					STA $14E0,y
					STA $14D4,y
					LDA #$B0
					STA $00D8,y
					LDA #$2B
					STA $1DFC
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MARIO_WARP			LDA $1FF2
					AND #$08
					BNE WARP_R
					LDA $1FF2
					AND #$10
					BNE MARIO_WARP_1
					LDA $7FFF19
					CMP #$77
					BEQ MARIO_WARP_1
					RTS
MARIO_WARP_1		LDA $1497
					CMP #$20
					BCS MARIO_WARP_2
					LDA #$60
					STA $1497
MARIO_WARP_2		LDA $97
					BEQ WARP_R
					LDA $96
					CMP #$B0
					BCC WARP_R
					LDA #$06
					STA $71
					STZ $89
					STZ $88
					LDA $1FF2
					ORA #$10
					STA $1FF2
WARP_R				RTS



BREAK				LDA $94
					SEC
					SBC $E4,x
					LDA $95
					SBC $14E0,x
					BCC BREAK_2
					LDA #$30
					STA $7B
					BRA BREAK_3
BREAK_2				LDA #$D0
					STA $7B
BREAK_3				LDA $96
					SEC
					SBC $D8,x
					LDA $97
					SBC $14D4,x
					BCC BREAK_4
					LDA #$30
					STA $7D
					RTS
BREAK_4				LDA #$B0
					STA $7D
					RTS




CHECK_DAMAGE		JSL $01A7DC
					BCC DAMAGE_R
					LDA $1497
					BNE DAMAGE_R
					JSL $00F5B7
DAMAGE_R			RTS

BLK_CHECK			TXY
					PHX
					LDX #$00
BLK_LOOP			LDA $9E,x
					CMP #$53
					BNE BLK_CHECK_2
					LDA $14C8,x
					CMP #$09
					BCC BLK_CHECK_2
					LDA $14E0,x
					BNE BLK_CHECK_2
					LDA $14D4,x
					BEQ BLK_CHECK_2
					LDA $D8,x
					CMP #$20
					BCC BLK_CHECK_2
					CMP #$34
					BCS BLK_CHECK_2
					LDA $00E4,y
					SEC
					SBC #$10
					CMP $E4,x
					BCS BLK_CHECK_2
					CLC
					ADC #$20
					CMP $E4,x
					BCC BLK_CHECK_2
					LDA #$28
					STA $1DFC
					STZ $14C8,x
					LDA $1528,y
					INC A
					STA $1528,y
					LDA $1528,y
					CMP #$02
					BEQ BLK_CHECK_02
					CMP #$04
					BEQ BLK_CHECK_04
					CMP #$06
					BEQ BLK_CHECK_06
					CMP #$08
					BEQ BLK_CHECK_08_2
BLK_CHECK_2			INX
					CPX #$0A
					BCC BLK_LOOP
					PLX
					RTS
BLK_CHECK_02		JSR SPRITE_DEL
					LDA #$00
					STA $1602,y
					STA $157C,y
					LDA $00E4,y
					CMP #$78
					BCC BLK_CHECK_2
					LDA #$01
					STA $157C,y
					BRA BLK_CHECK_2
BLK_CHECK_04		JSR SPRITE_DEL
					LDA #$00
					STA $1602,y
					JSR HDMA_COLOR
					LDA #$FF
					STA $7FE301
					LDA #$7F
					STA $7FE302
					LDA #$02
					STA $00C2,y
					LDA #$FF
					STA $15AC,y
					LDA #$00
					STA $157C,y
					LDA #$18
					STA $1DFC
					LDA #$C0
					STA $1468
					LDA #$01
					STA $1467
					LDA #$31
					STA $40
					LDA #$01
					STA $85
					JSR VRAM_WATER
BLK_CHECK_3			BRA BLK_CHECK_2
BLK_CHECK_08_2		BRA BLK_CHECK_08
BLK_CHECK_06		JSR SPRITE_DEL
					LDA #$00
					STA $1602,y
					STA $7FFF07
					JSR HDMA_COLOR
					LDA #$FF
					STA $7FE301
					LDA #$7F
					STA $7FE302
					LDA #$03
					STA $00C2,y
					LDA #$FF
					STA $1540,y
					LDA #$00
					STA $157C,y
					LDA #$18
					STA $1DFC
					LDA #$C0
					STA $1468
					STZ $1467
					JSR VRAM_DARK
					LDA #$20
					STA $40
					STZ $85
					BRA BLK_CHECK_3
BLK_CHECK_08		JSR SPRITE_DEL
					STZ $40
					LDA #$1E
					STA $1DFB
					LDA #$00
					STA $1602,y
					STA $00B6,y
					LDA #$04
					STA $00C2,y
					LDA #$FF
					STA $15AC,y
					BRA BLK_CHECK_3

CENTER				LDA $15AC,x
					CMP #$F0
					BEQ CENTER_G1
					CMP #$D0
					BEQ CENTER_G2
					CMP #$B0
					BEQ CENTER_G3
					CMP #$90
					BEQ CENTER_G4
					CMP #$80
					BEQ CENTER_RING
					CMP #$70
					BEQ CENTER_RING
					CMP #$60
					BEQ CENTER_RING
					CMP #$30
					BEQ CENTER_2
					RTS
CENTER_RING			LDA #$01
					STA $1DFC
					RTS
CENTER_2			LDA $157C,x
					BEQ CENTER_3
					LDA $E4,x
					DEC A
					STA $E4,x
					BRA CENTER_4
CENTER_3			LDA $E4,x
					INC A
					STA $E4,x
CENTER_4			STZ $15AC,x
					STZ $1602,x
					RTS
CENTER_G1			LDA #$30
					STA $7FFDE4
					LDA #$00
					STA $7FFDD8
					BRA CENTER_G
CENTER_G2			LDA #$C0
					STA $7FFDE4
					LDA #$00
					STA $7FFDD8
					BRA CENTER_G
CENTER_G3			LDA #$30
					STA $7FFDE4
					LDA #$90
					STA $7FFDD8
					BRA CENTER_G
CENTER_G4			LDA #$C0
					STA $7FFDE4
					LDA #$90
					STA $7FFDD8
CENTER_G			LDA #$27
					STA $1DFC
					JSR GEN_SPRITE
					LDA #$02
					STA $1504,y
					LDA #$FF
					STA $15AC,y
					LDA $7FFDD8
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					LDA $7FFDE4
					STA $00E4,y
					LDA #$00
					STA $14E0,y
					RTS

LEFT				LDA $15AC,x
					CMP #$D0
					BEQ LEFT_1
					LDA $7FFF01
					CMP #$02
					BNE LEFT_R
					LDA #$00
					STA $7FFF01
					LDA $E4,x
					INC A
					STA $E4,x
					STZ $1602,x
LEFT_R				RTS
LEFT_1				JSR GEN_SPRITE
					LDA #$19
					STA $1686,y
					LDA #$03
					STA $1504,y
					LDA #$B0
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA #$40
					STA $00E4,y
					LDA #$00
					STA $14E0,y
					JSR GEN_SPRITE
					LDA #$19
					STA $1686,y
					LDA #$03
					STA $1504,y
					LDA #$B0
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA #$B0
					STA $00E4,y
					LDA #$00
					STA $14E0,y
					LDA #$2B
					STA $1DFC
					RTS

RIGHT				LDA $15AC,x
					CMP #$F0
					BEQ RIGHT_1
					CMP #$D0
					BEQ LIGHTNING_G
					CMP #$B0
					BEQ LIGHTNING_G
					CMP #$90
					BEQ LIGHTNING_G
					CMP #$70
					BEQ LIGHTNING_G
					CMP #$50
					BEQ LIGHTNING_G
					CMP #$30
					BEQ RIGHT_2
					RTS
RIGHT_1				STZ $40
					RTS
RIGHT_2				LDA #$20
					STA $40
					LDA $E4,x
					DEC A
					STA $E4,x
					STZ $15AC,x
					STZ $1602,x
					RTS
LIGHTNING_G			LDA #$18
					STA $1DFC
					JSR GEN_SPRITE
					LDA #$01
					STA $1504,y
					LDA #$B0
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA $94
					STA $00E4,y
					LDA $95
					STA $14E0,y
					RTS

SPRITE_DEL			TYA
					STA $7FFF02
					PHX
					LDX #$00
SPRITE_DEL_LOOP		TXA
					CMP $7FFF02
					BEQ SPRITE_DEL_2
					STZ $14C8,x
SPRITE_DEL_2		INX
					CPX #$0A
					BCC SPRITE_DEL_LOOP
					PLX
					RTS

POS_OFFSET			REP #$30
					LDA.W #$0078
					SEC
					SBC $E4,x
					STA $7FE801
					STA $7FE804
					SEP #$30
POS_OFFSET3			REP #$30
					LDA.W $96
					CMP.W #$00C0
					BCS POS_OFFSET2
					LDA.W #$00C0
					STA $96
POS_OFFSET2			SEP #$30
					RTS
GAGE_RESET			LDA #$01
					STA $7FFFDF
					LDA #$0B
					STA $7FFFE0
					LDA #$18
					STA $7FFFE1
					LDA #$1C
					STA $7FFFE2
					LDA #$1C
					STA $7FFFE3
					LDA #$FC
					STA $7FFFE4
					LDA #$44
					STA $7FFFE5
					LDA #$44
					STA $7FFFE6
					LDA #$44
					STA $7FFFE7
					LDA #$44
					STA $7FFFE8
					LDA #$44
					STA $7FFFE9
					LDA #$44
					STA $7FFFEA
					LDA #$44
					STA $7FFFEB
					LDA #$44
					STA $7FFFEC
					LDA #$FC
					STA $7FFFED
					LDA #$FC
					STA $7FFFEE
					LDA #$FC
					STA $7FFFEF
					RTS
					
GAGE2_CHECK			LDA $1528,x
					CMP #$01
					BEQ GAGE2_CHECK2
					CMP #$02
					BEQ GAGE2_CHECK3
					CMP #$03
					BEQ GAGE2_CHECK4
					CMP #$04
					BEQ GAGE2_CHECK5
					CMP #$05
					BEQ GAGE2_CHECK6
					CMP #$06
					BEQ GAGE2_CHECK7
					CMP #$07
					BEQ GAGE2_CHECK8
					CMP #$08
					BEQ GAGE2_CHECK9
					RTS
GAGE2_CHECK2		LDA #$FC
					STA $7FFFEC
					RTS
GAGE2_CHECK3		LDA #$FC
					STA $7FFFEB
					RTS
GAGE2_CHECK4		LDA #$FC
					STA $7FFFEA
					RTS
GAGE2_CHECK5		LDA #$FC
					STA $7FFFE9
					RTS
GAGE2_CHECK6		LDA #$FC
					STA $7FFFE8
					RTS
GAGE2_CHECK7		LDA #$FC
					STA $7FFFE7
					RTS
GAGE2_CHECK8		LDA #$FC
					STA $7FFFE6
					RTS
GAGE2_CHECK9		LDA #$FC
					STA $7FFFE5
					LDA #$1E
					STA $1DFB
					RTS
					
HDMA_INIT1			LDA #$10
					STA $7FFB20
					LDA #$02
					STA $7FFB21
					LDA #$0D
					STA $7FFB22
					LDA #$00
					STA $7FFB23
					LDA #$E8
					STA $7FFB24
					LDA #$7F
					STA $7FFB25
					LDA #$7F
					STA $7FE800
					LDA #$00
					STA $7FE801
					STA $7FE802
					LDA #$40
					STA $7FE803
					LDA #$00
					STA $7FE804
					STA $7FE805
					LDA #$01
					STA $7FE806
					LDA #$00
					STA $7FE807
					STA $7FE808
					STA $7FE809
					RTS
					
HDMA_LAYER1			LDA #$20
					STA $7FFB28
					LDA #$02
					STA $7FFB28
					LDA #$0E
					STA $7FFB2A
					LDA #$00
					STA $7FFB2B
					LDA #$E9
					STA $7FFB2C
					LDA #$7F
					STA $7FFB2D
					LDA #$60
					STA $7FE900
					LDA #$C0
					STA $7FE901
					LDA #$00
					STA $7FE902
					LDA #$60
					STA $7FE903
					LDA #$C0
					STA $7FE904
					LDA #$00
					STA $7FE905
					LDA #$01
					STA $7FE906
					LDA #$C0
					STA $7FE907
					LDA #$00
					STA $7FE908
					STA $7FE909
					RTS
					
HDMA_MASK			LDA #$10
					STA $7FFB20
					LDA #$00
					STA $7FFB21
					LDA #$23
					STA $7FFB22
					LDA #$00
					STA $7FFB23
					LDA #$E8
					STA $7FFB24
					LDA #$7F
					STA $7FFB25
					LDA #$5E
					STA $7FE800
					LDA #$00
					STA $7FE801
					LDA #$61
					STA $7FE802
					LDA #$00
					STA $7FE803
					LDA #$01
					STA $7FE804
					LDA #$02
					STA $7FE805
					LDA #$01
					STA $7FE806
					LDA #$00
					STA $7FE808
					LDA #$00
					STA $7FE809
					RTS

HDMA_COLOR			LDA #$10
					STA $7FFB20
					LDA #$20
					STA $7FFB28
					LDA #$00
					STA $7FFB21
					LDA #$02
					STA $7FFB29
					LDA #$21
					STA $7FFB22
					LDA #$22
					STA $7FFB2A
					LDA #$00
					STA $7FFB23
					STA $7FFB2B
					LDA #$E2
					STA $7FFB24
					LDA #$E3
					STA $7FFB2C
					LDA #$7F
					STA $7FFB25
					STA $7FFB2D
					
					LDA #$01
					STA $7FE200
					STA $7FE300
					LDA #$00
					STA $7FE201
					LDA #$00
					STA $7FE301
					LDA #$00
					STA $7FE302
					LDA #$00
					STA $7FE202
					STA $7FE303
					RTS
					
HDMA_WATER			LDA #$01
					STA $7FE300
					STA $7FE200
					LDA #$00
					STA $7FE301
					STA $7FE302
					STA $7FE201
					
					LDA #$20
					STA $7FE303
					STA $7FE202
					LDA #$00
					STA $7FE304
					STA $7FE305
					STA $7FE203
					
					LDA #$01
					STA $7FE306
					STA $7FE204
					LDA #$FF
					STA $7FE307
					LDA #$01
					STA $7FE308
					LDA #$00
					STA $7FE205
					
					LDA #$01
					STA $7FE309
					STA $7FE206
					LDA #$1F
					STA $7FE30A
					LDA #$03
					STA $7FE30B
					LDA #$00
					STA $7FE207
					
					LDA #$01
					STA $7FE30C
					STA $7FE208
					LDA #$FF
					STA $7FE30D
					LDA #$03
					STA $7FE30E
					LDA #$00
					STA $7FE209
					
					
					LDA #$01
					STA $7FE30F
					STA $7FE20A
					LDA #$FF
					STA $7FE310
					LDA #$7F
					STA $7FE311
					LDA #$00
					STA $7FE20B
					
					LDA #$01
					STA $7FE312
					STA $7FE20C
					LDA #$FF
					STA $7FE313
					LDA #$03
					STA $7FE314
					LDA #$00
					STA $7FE20D
					
					LDA #$01
					STA $7FE315
					STA $7FE20E
					LDA #$1F
					STA $7FE316
					LDA #$03
					STA $7FE317
					LDA #$00
					STA $7FE20F
					
					LDA #$01
					STA $7FE318
					STA $7FE210
					LDA #$FF
					STA $7FE319
					LDA #$01
					STA $7FE31A
					LDA #$00
					STA $7FE211
					
					LDA #$01
					STA $7FE31B
					STA $7FE212
					LDA #$00
					STA $7FE31C
					STA $7FE31D
					STA $7FE213
					
					LDA #$00
					STA $7FE31E
					STA $7FE214
					RTS

LAYER3_DEL			LDA #$40
					STA $7FFB30
					LDA #$02
					STA $7FFB31
					LDA #$11
					STA $7FFB32
					LDA #$00
					STA $7FFB33
					LDA #$E1
					STA $7FFB34
					LDA #$7F
					STA $7FFB35
					LDA #$0F
					STA $7FE100
					LDA #$00
					STA $7FE101
					LDA #$00
					STA $7FE102
					LDA #$80
					STA $7FE103
					LDA #$00
					STA $7FE104
					LDA #$01
					STA $7FE105
					LDA #$00
					STA $7FE106
HDMA_R2				RTS

SPEED_DEC           LDA $E4,x
                    SEC
                    SBC $94
                    STA $0F
                    LDA $14E0,x
                    SBC $95
                    BPL FACE_LEFT
                    JSR RIGHT_SPEED
                    BRA VERC
FACE_LEFT           CMP #$01
                    BEQ HLEFT2
                    JSR HLEFT_SPEED1
                    BRA VERC
HLEFT2               JSR HLEFT_SPEED2
VERC                LDA $D8,x
                    SEC
                    SBC $96
                    STA $0F
                    LDA $14D4,x
                    SBC $97
                    BPL FACE_UP
                    JSR DOWN_SPEED
                    LDA $1594,x
                    CMP #$10
                    BCS VER_E
                    LDA #$10
                    STA $1594,x
                    BRA VER_E
FACE_UP             JSR UP_SPEED
                    LDA $1594,x
                    CMP #$F0
                    BCC VER_E
                    LDA #$F0
                    STA $1594,x
VER_E               RTS

UP_SPEED            LDA $0F38
                    CMP #$00
                    BNE UP3
                    LDA $0F
                    CMP #$80
                    BCC UP2
                    LDA #$7F
UP2                 STA $0F
                    BRA UP5
UP3                 CMP #$02
                    BNE UP4
                    JSR UP1_1
                    BRA UP5
UP4                 JSR UP1_2
UP5                 LDA #$00
                    SEC
                    SBC $0F
                    STA $1594,x
                    RTS

DOWN_SPEED          LDA #$00
                    SEC
                    SBC $0F
                    STA $0F
                    LDA $0F38
                    CMP #$00
                    BNE DOWN3
                    LDA $0F
                    CMP #$80
                    BCC DOWN2
                    LDA #$7F
DOWN2               STA $1594,x
                    RTS
DOWN3               CMP #$02
                    BNE DOWN4
                    JSR UP1_1
                    BRA DOWN5
DOWN4               JSR UP1_2
DOWN5               LDA $0F
                    STA $1594,x
                    RTS
UP1_1
LOOPUP1             LDA $0F37
                    BEQ LOOPUP1E
                    LDA $0F
                    LSR A
                    STA $0F
                    DEC $0F37
                    LDA $0F37
                    BNE LOOPUP1
LOOPUP1E            LDA $0F
                    CMP #$80
                    BCC LOOPUP1EE
                    LDA #$7F
                    STA $0F
LOOPUP1EE           RTS

UP1_2               LDA $0F
                    CMP #$80
                    BCC LOOPUP3
                    LDA #$7F
                    STA $0F
                    STZ $0F37
                    RTS
LOOPUP3             LDA $0F37
                    BEQ LOOPUP2E
                    LDA $0F
                    ASL A
                    STA $0F
                    DEC $0F37
                    LDA $0F37
                    BNE UP1_2
LOOPUP2E            LDA $0F
                    CMP #$80
                    BCC LOOPUP2EE
                    LDA #$7F
                    STA $0F
LOOPUP2EE           RTS

HLEFT_SPEED1         STZ $0F38
                    LDA $0F
                    CMP $1570,x
                    BCC HLEFT1_2
                    LDA #$02
                    STA $0F38
                    STZ $0F37
                    JSR HLEFT1_40
                    BRA HLEFT1_3
HLEFT1_2             CMP $151C,x
                    BCS HLEFT1_3
                    LDA #$01
                    STA $0F38
                    STZ $0F37
                    JSR HLEFT1_20
                    BRA HLEFT1_3
HLEFT1_3             LDA #$00
                    SEC
                    SBC $0F
                    STA $1570,x
                    RTS

HLEFT1_40            
LOOP140             LDA $0F
                    CMP $1570,x
                    BCC LOOP140E
                    LSR A
                    STA $0F
                    INC $0F37
                    BRA LOOP140
LOOP140E            RTS
HLEFT1_20            
LOOP120             LDA $0F
                    CMP $151C,x
                    BCS LOOP120E
                    ASL A
                    STA $0F
                    INC $0F37
                    BRA LOOP140
LOOP120E            RTS

HLEFT_SPEED2         STZ $0F37
                    INC $0F37
                    LDA $0F
                    LSR A
                    CLC
                    ADC #$80
                    STA $0F
                    LDA #$02
                    STA $0F38
                    JSR HLEFT1_40
                    LDA #$00
                    SEC
                    SBC $0F
                    STA $1570,x
                    RTS

RIGHT_SPEED         STZ $0F38
                    LDA #$00
                    SEC
                    SBC $0F
                    STA $0F
                    CMP $1570,x
                    BCC HRIGHT_2
                    LDA #$02
                    STA $0F38
                    STZ $0F37
                    JSR HLEFT1_40
                    BRA HRIGHT_3
HRIGHT_2             CMP $151C,x
                    BCS HRIGHT_3
                    LDA #$01
                    STA $0F38
                    STZ $0F37
                    JSR HLEFT1_20
                    BRA HRIGHT_3
HRIGHT_3             LDA $0F
                    STA $1570,x
                    RTS
					
SUB_SMOKE           LDY #$03                ; \ find a free slot to display effect
FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
                    RTS                     ; / return if no slots open
FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    LDA $D8,x
                    STA $17C4,y             ; /
                    LDA #$1B                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $E4,x
                    STA $17C8,y             ; /
                    RTS 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; generate sprite
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GEN_FEATURE			JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURNK68 
					LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    LDA #$77
                    STA $009E,y
					BRA GEN_NORMAL_2
					
RETURNK68           RTS     
GEN_NORMAL          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURNK68            ; / after: Y has index of sprite being generated

                    LDA #$09                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    LDA #$53
                    STA $009E,y
GEN_NORMAL_2                    
                    LDA $E4,x               ;\ set x position for new sprite
                    STA $00E4,y

                    LDA $14E0,x             ;  |
                    STA $14E0,y             ; /

                    LDA $D8,x               ;\ set y position for new sprite
					STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
					STA $14D4,y             ; /

                    PHX
                    TYX
                    JSL $07F7D2             ;  
                    PLX
                    RTS                     ; return

RETURN67            RTS
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
GEN_SPIRITE_2       PLX
                    
					LDA $E4,x
                    STA $00E4,y
                    LDA $14E0,x
                    STA $14E0,y             ; /

					LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  
TILEMAP             dcb $82,$82,$A0,$A0,$C0,$C0,$E0,$E0,$A2,$A2
					dcb $80,$80,$A0,$A0,$C0,$C0,$E0,$E0,$C2,$C2
					dcb $84,$86,$88,$A4,$A6,$A8,$C4,$8E,$E4,$E6
					dcb $84,$86,$88,$A4,$A6,$A8,$C4,$8E,$E4,$E6
					dcb $82,$82,$A0,$A0,$C0,$C0,$E0,$E0,$C2,$C2
HORIZ_DISP          dcb $F8,$08,$F8,$08,$F8,$08,$F8,$08,$F8,$08
					dcb $F8,$08,$F8,$08,$F8,$08,$F8,$08,$F8,$08
					dcb $E4,$F4,$04,$E4,$F4,$04,$E4,$F4,$E4,$F4
					dcb $1C,$0C,$FC,$1C,$0C,$FC,$1C,$0C,$1C,$0C
					dcb $F8,$08,$F8,$08,$F8,$08,$F8,$08,$F8,$08
VERT_DISP           dcb $CC,$CC,$DC,$DC,$EC,$EC,$FC,$FC,$0C,$0C
					dcb $D0,$D0,$E0,$E0,$F0,$F0,$00,$00,$10,$10
					dcb $D0,$D0,$D0,$E0,$E0,$E0,$F0,$F0,$00,$00
					dcb $D0,$D0,$D0,$E0,$E0,$E0,$F0,$F0,$00,$00
					dcb $CC,$CC,$DC,$DC,$EC,$EC,$FC,$FC,$0C,$0C
PROPERTIES          dcb $0D,$4D,$0D,$4D,$0D,$4D,$0D,$4D,$0D,$4D
					dcb $0D,$4D,$0D,$4D,$0D,$4D,$0D,$4D,$0D,$4D
					dcb $0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D
					dcb $4D,$4D,$4D,$4D,$4D,$4D,$4D,$4D,$4D,$4D
					dcb $0D,$4D,$0D,$4D,$0D,$4D,$0D,$4D,$0D,$4D

SUB_GFX				JSR GET_DRAW_INFO
					LDA $1602,x
					ASL A
					STA $02
					ASL A
					ASL A
					CLC
					ADC $02
					STA $02
					PHX
					LDX #$09
LOOP_START          PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $01
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP,x         ; |
                    STA $0301,y             ; /
					
					LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /

                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP,x        ; |
                    STA $0300,y             ; /

                    LDA PROPERTIES,x
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
					PLX
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START
                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$09
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS

TILEMAP_T           dcb $E4,$84,$A4,$C4,$E4,$E6,$86,$A6,$C6,$E6
VERT_DISP_T         dcb $C0,$D0,$E0,$F0,$00
					
SUB_GFX_T			JSR GET_DRAW_INFO
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					STA $02
					ASL A
					ASL A
					CLC
					ADC $02
					STA $02
					PHX
					LDX #$04
LOOP_START_T        LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    STA $0300,y             ; /
					LDA $01
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP_T,x         ; |
                    STA $0301,y             ; /
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA TILEMAP_T,x           ; \ store tile
                    STA $0302,y             ; /
					PLX
                    LDA #$02
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START_T
                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$04
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS

SUB_GFX_F			JSR GET_DRAW_INFO
					LDA $00
                    STA $0300,y
					LDA $01
                    STA $0301,y
					LDA #$88
					STA $0302,y
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					BEQ SUB_GFX_F_2
					LDA #$8A
					STA $0302,y
SUB_GFX_F_2			LDA #$0E
					ORA $64
					STA $0303,y
					LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$00
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS

SUB_GFX_B			JSR GET_DRAW_INFO
					LDA $00
                    STA $0300,y
					LDA $01
                    STA $0301,y
					LDA #$40
					STA $0302,y
					LDA #$05
					ORA $64
					STA $0303,y
					LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$00
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS

SUB_GFX_C			JSR GET_DRAW_INFO
					LDA $00
                    STA $0300,y
					LDA $01
                    STA $0301,y
					LDA #$A8
					STA $0302,y
					LDA #$0E
					ORA $64
					STA $0303,y
					LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$00
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS

					
TILEMAP_H           dcb $CA,$CC,$EA,$EC
HORZ_DISP_H         dcb $F8,$08,$F8,$08
VERT_DISP_H         dcb $F8,$F8,$08,$08
					
SUB_GFX_H			JSR GET_DRAW_INFO
					PHX
					LDX #$03
LOOP_STARTH         LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
					CLC
					ADC HORZ_DISP_H,x
                    STA $0300,y             ; /
					LDA $01
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP_H,x         ; |
                    STA $0301,y             ; /
					LDA TILEMAP_H,x           ; \ store tile
                    STA $0302,y             ; /
                    LDA #$05
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_STARTH
                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS

TILEMAP_S              dcb $00,$00,$20,$20
HORZ_DISP_S           dcb $F8,$08,$F8,$08
VERT_DISP_S           dcb $00,$00,$10,$10
PROPERTIES_S          dcb $00,$40,$00,$40
SUB_GFX_S           JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					LDA $1570,x
					STA $03
                    PHX                     ; push sprite index
                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START_S        LDA TILEMAP_S,x           ; \ store tile
                    STA $0302,y             ; /
					
					LDA $01
					CLC
					ADC VERT_DISP_S,x
					STA $0301,y
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP_S,x         ;  |
                    STA $0300,y             ; /
					
                    LDA PROPERTIES_S,x
                    ORA $03
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START_S          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS        
					
TILEMAP_I           dcb $8C,$8E,$AC,$AE
HORZ_DISP_I         dcb $F8,$08,$F8,$08
VERT_DISP_I         dcb $F8,$F8,$08,$08
SUB_GFX_I           JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					PHX                     ; push sprite index
                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START_I        LDA TILEMAP_I,x           ; \ store tile
                    STA $0302,y             ; /
					
					LDA $01
					CLC
					ADC VERT_DISP_I,x
					STA $0301,y
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP_I,x         ;  |
                    STA $0300,y             ; /
					
                    LDA #$08
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START_I          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS        
					
TILEMAP_ST			dcb $80,$82,$A0,$A2
HORZ_DISP_ST		dcb $F8,$08,$F8,$08
VERT_DISP_ST		dcb $F8,$F8,$08,$08
SUB_GFX_ST			JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					LDA $1570,x
					STA $03
                    PHX                     ; push sprite index
                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START_ST        LDA TILEMAP_ST,x           ; \ store tile
                    STA $0302,y             ; /
					
					LDA $01
					CLC
					ADC VERT_DISP_ST,x
					STA $0301,y
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP_ST,x         ;  |
                    STA $0300,y             ; /
					
                    LDA #$06
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START_ST          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
TILEMAP_BU			dcb $AE,$CE,$EE,$EE,$EE
					dcb $0E,$CE,$EE,$EE,$EE
					dcb $40,$CE,$EE,$EE,$EE
HORZ_DISP_BU		dcb $00,$F8,$08,$F8,$08
VERT_DISP_BU		dcb $00,$F8,$F8,$08,$08
PROPETIES_BU		dcb $09,$09,$09,$C9,$89
BU_COLOR			dcb $00,$02,$04,$06,$08,$0A,$0C,$0E

SUB_GFX_BU			JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					STZ $02
					LDA $151C,x
					CMP #$01
					BNE SUB_GFX_BU_1
					LDA #$05
					STA $02
					BRA SUB_GFX_BU_2
SUB_GFX_BU_1		CMP #$02
					BNE SUB_GFX_BU_2
					LDA #$0A
					STA $02
SUB_GFX_BU_2		PHX                     ; push sprite index
                    LDX #$04                ; loop counter = (number of tiles per frame) - 1
LOOP_START_BU		PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA TILEMAP_BU,x           ; \ store tile
                    STA $0302,y             ; /
					PLX

					LDA $01
					CLC
					ADC VERT_DISP_BU,x
					STA $0301,y
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP_BU,x         ;  |
                    STA $0300,y             ; /
					
                    LDA PROPETIES_BU,x
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					CPX #$00
					BNE SUB_GFX_BU_3
					LDA $02
					CMP #$0A
					BEQ SUB_GFX_BU_4
					CMP #$05
					BEQ SUB_GFX_BU_5
					BRA SUB_GFX_BU_3
SUB_GFX_BU_4		PHX
					LDA $14
					LSR A
					LSR A
					AND #$07
					TAX
					LDA BU_COLOR,x
					PLX
					ORA $64                 ;  | put in level properties
                    STA $0303,y 
					BRA SUB_GFX_BU_3
SUB_GFX_BU_5		LDA #$04
					ORA $64                 ;  | put in level properties
                    STA $0303,y 
SUB_GFX_BU_3        INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START_BU          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$04                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
TILEMAP_BUTA		dcb $8A,$8C,$AA,$AC
HORZ_DISP_BUTA		dcb $08,$F8,$08,$F8,$F8,$08,$F8,$08
VERT_DISP_BUTA		dcb $F8,$F8,$08,$08
PROPETIES_BUTA		dcb $4F,$0F
SUB_GFX_BUTA		JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					LDA $157C,x
					STA $02
					ASL A
					ASL A
					STA $03
                    PHX                     ; push sprite index
                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START_BUTA     LDA TILEMAP_BUTA,x           ; \ store tile
                    STA $0302,y             ; /
					
					LDA $01
					CLC
					ADC VERT_DISP_BUTA,x
					STA $0301,y
					
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP_BUTA,x         ;  |
                    STA $0300,y             ; /
					PLX
					
					PHX
					LDX $02
					LDA PROPETIES_BUTA,x
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					PLX
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START_BUTA          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS

TILEMAP_SW			dcb $C8,$E8
VERT_DISP_SW		dcb $F8,$08

SUB_GFX_SW			JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                    PHX                     ; push sprite index
                    LDX #$01              ; loop counter = (number of tiles per frame) - 1
LOOP_START_SW		LDA TILEMAP_SW,x           ; \ store tile
                    STA $0302,y             ; /
					
					LDA $01
					CLC
					ADC VERT_DISP_SW,x
					STA $0301,y
					
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0300,y             ; /

					LDA #$09
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START_SW          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$01               ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
SUB_GFX_FB			LDA $14
					LSR A
					LSR A
					AND #$01
					ASL A
					ASL A
					STA $02

					LDA #$04
					ORA $64
					STA $03
					LDA $AA,x
					CMP #$80
					BCS SUB_GFX_FB_2
					LDA $03
					ORA #$80
					STA $03
					LDA $02
					ORA #$08
					STA $02
SUB_GFX_FB_2		JSR GET_DRAW_INFO
					
					PHX
					LDX #$03
GFX_LOOP			PHX

					LDA $00
					CLC
					ADC $019CD3,x
					STA $0300,y

					LDA $01
					CLC
					ADC $019CD7,x
					STA $0301,y

					LDA $019CDF,x
					ORA $03
					STA $0303,y

					TXA
					ORA $02
					TAX
					LDA $019C35,x
					STA $0302,y

					PLX
					INY
					INY
					INY
					INY
					DEX
					BPL GFX_LOOP
					PLX
					LDY #$00
					LDA #$03
					JSL $01B7B3
					RTS
					
TILEMAP_D           dcb $AE,$AE,$AE,$02
					dcb $AE,$AE,$AE,$22
					dcb $AE,$00,$02,$02
					dcb $AE,$00,$02,$22
VERT_DISP_D         dcb $E0,$00,$10,$F8
PROPETIES_D			dcb $01,$01,$01,$05
					dcb $01,$01,$01,$05
					dcb $01,$00,$00,$05
					dcb $01,$00,$00,$05
SUB_GFX_D           LDA $76
					ASL A
					ASL A
					ASL A
					ASL A
					ASL A
					ASL A
					STA $02
					LDA $14
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$01
					ASL A
					ASL A
					STA $03
					LDA $157C,x
					BEQ SUB_GFX_D_2
					LDA $03
					ORA #$08
					STA $03
SUB_GFX_D_2			JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					PHX                     ; push sprite index
                    LDX #$03               ; loop counter = (number of tiles per frame) - 1
LOOP_START_D        LDA $01
					CLC
					ADC VERT_DISP_D,x
					STA $0301,y
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0300,y             ; /
					
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILEMAP_D,x           ; \ store tile
                    STA $0302,y             ; /
                    LDA PROPETIES_D,x
					ORA $02
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					PLX
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START_D          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03               ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
VRAM_TBL1			dcb $00,$01,$20,$21,$40,$41,$60,$61,$80,$81,$A0,$A1,$C0,$C1,$E0,$E1
					dcb $00,$01,$20,$21,$40,$41,$60,$61,$80,$81,$A0,$A1,$C0,$C1,$E0,$E1
					dcb $00,$01,$20,$21,$40,$41,$60,$61,$80,$81,$A0,$A1,$C0,$C1,$E0,$E1
					dcb $00,$01,$20,$21,$40,$41,$60,$61,$80,$81,$A0,$A1
VRAM_TBL2			dcb $37,$37,$37,$37,$37,$37,$37,$37,$37,$37,$37,$37,$37,$37,$37,$37
					dcb $3C,$3C,$3C,$3C,$3C,$3C,$3C,$3C,$3C,$3C,$3C,$3C,$3C,$3C,$3C,$3C
					dcb $3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D
					dcb $3E,$3E,$3E,$3E,$3E,$3E,$3E,$3E,$3E,$3E,$3E,$3E
WATER_TBL			dcb $A0,$A1,$B0,$B1,$C0,$C1,$D0,$D1,$E0,$E1,$F0,$F1
					dcb $A4,$A5,$B4,$B5,$C4,$C5,$D4,$D5,$E4,$E5,$F4,$F5
					dcb $A0,$A1,$B0,$B1,$C0,$C1,$D0,$D1,$E0,$E1,$F0,$F1
					dcb $A4,$A5,$B4,$B5,$C4,$C5,$D4,$D5,$E4,$E5,$F4,$F5
DARK_TBL			dcb $00,$01,$10,$11,$20,$21,$30,$31,$08,$09,$18,$19,$28,$29,$38,$39
					dcb $18,$19,$08,$09,$30,$31,$20,$21,$10,$11,$00,$01
					dcb $00,$01,$10,$11,$20,$21,$30,$31,$08,$09,$18,$19,$28,$29,$38,$39
					dcb $18,$19,$08,$09,$30,$31,$20,$21,$10,$11,$00,$01
DARK_TBL2			dcb $1C,$1C,$1C,$1C,$1C,$1C,$1C,$1C,$1C,$1C,$1C,$1C,$1C,$1C,$1C,$1C
					dcb $9C,$9C,$9C,$9C,$9C,$9C,$9C,$9C,$9C,$9C,$9C,$9C
					dcb $1C,$1C,$1C,$1C,$1C,$1C,$1C,$1C,$1C,$1C,$1C,$1C,$1C,$1C,$1C,$1C
					dcb $9C,$9C,$9C,$9C,$9C,$9C,$9C,$9C,$9C,$9C,$9C,$9C

VRAM_WATER			LDA #$80
					STA $2115
					LDA #$10
					STA $0F
					LDY #$00
VRAM_WATER_LP		LDA VRAM_TBL1,y
					STA $02
					LDA VRAM_TBL2,y
					STA $03
					LDA WATER_TBL,y
					STA $0E
					REP #$20
					LDA $02
					STA $2116
					LDA $0E
					STA $2118
					SEP #$20
					INY
					CPY #$30
					BCC VRAM_WATER_LP
					RTS

VRAM_DARK			LDA #$80
					STA $2115
					LDY #$00
VRAM_DARK_LP		LDA VRAM_TBL1,y
					STA $02
					LDA VRAM_TBL2,y
					STA $03
					LDA DARK_TBL,y
					STA $0E
					LDA DARK_TBL2,y
					STA $0F
					REP #$20
					LDA $02
					STA $2116
					LDA $0E
					STA $2118
					SEP #$20
					INY
					CPY #$3C
					BCC VRAM_DARK_LP
					RTS
