;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Dark Castle Sprite
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"
					LDA $010B
					CMP #$55
					BEQ INIT_SWORD
                    PHY
                    JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
                    PLY
					LDA EXTRA_BITS,x
					AND #$04
					BNE INIT_MAGIC
					LDA $14D4,x
					BEQ INIT_UNICON
					LDA $D8,x
					CMP #$80
					BCC INIT_UNICON
INIT_SWORD			LDA #$09
					STA $1602,x
					LDA #$90
					STA $1686,x
					RTL
INIT_UNICON			LDA #$05
					STA $1602,x
					LDA #$60
					STA $15AC,x
					RTL
INIT_MAGIC			LDA #$19
					STA $1656,x
					LDA #$07
					STA $1602,x
					LDA #$40
					STA $15AC,x
					LDA $E4,x
					AND #$10
					BEQ INIT_E
					LDA #$60
					STA $15AC,x
INIT_E              RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS
CODE_START          LDA $1602,x
					CMP #$09
					BNE MAIN1
					JSR SUB_SOWRD
					RTS
MAIN1				CMP #$05
					BNE MAIN2
					JSR SUB_UNICON
					RTS
MAIN2				JSR SUB_MAGIC
RETURN				RTS
					
SUB_SOWRD			LDA $010B
					CMP #$55
					BEQ SUB_SOWRD_1
					JSR SUB_GFX
					BRA SUB_SOWRD_2
SUB_SOWRD_1			JSR SUB_GFX_ONI
SUB_SOWRD_2			LDA $14C8,x             ; \ 
					BEQ RETURN
                    CMP #$02                ;  | if status != 8, return
                    BEQ RETURN
					LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN 
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSL $01A7DC
					JSL $01802A
					LDA $C2,x
					BNE SOWRD2
					STZ $AA,x
					JSR NEAR_CHECK
					RTS
SOWRD2				LDA $AA,x
					CMP #$80
					BCS RETURN
					LDA $14D4,x
					BEQ RETURN
					LDA $D8,x
					CMP #$80
					BCC RETURN
					STZ $C2,x
					LDA #$80
					STA $D8,x
					STZ $AA,x
					RTS
					
X_SPEED1			dcb $10,$F0
X_SPEED2			dcb $30,$D0

RETURN20			STZ $B6,x
					RTS
SUB_UNICON			JSR SUB_GFX2
					LDA $14C8,x             ; \ 
					BEQ RETURN2
                    CMP #$02                ;  | if status != 8, return
                    BEQ RETURN20
					LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN2 
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSL $01A7DC
					JSL $01802A
					JSR DIR_CHANGE
					LDA $C2,x
					BNE UNICON2
					LDA #$09
					STA $1656,x
					LDY $157C,x
					LDA X_SPEED1,y
					STA $B6,x
					LDA $15AC,x
					BEQ UNICON1
					CMP #$20
					BCC UNICON0
					RTS
UNICON0				STZ $B6,x
					PHY
                    JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
                    PLY
					RTS
UNICON1				LDA #$40
					STA $15AC,x
					LDA #$01
					STA $C2,x
RETURN2				RTS
UNICON2				LDA #$19
					STA $1656,x
					LDY $157C,x
					LDA X_SPEED2,y
					STA $B6,x
					JSR DAMAGE
					LDA $15AC,x
					BNE RETURN2
					LDA #$60
					STA $15AC,x
					STZ $C2,x
					RTS


SUB_MAGIC			JSR SUB_GFX4
					LDA $14C8,x             ; \ 
					BEQ RETURN8
                    CMP #$02                ;  | if status != 8, return
                    BEQ RETURN8
					LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN8
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSL $01A7DC
					JSL $01802A
					JSR DIR_CHANGE
					LDY $157C,x
					LDA X_SPEED1,y
					STA $B6,x
					LDA $15AC,x
					BEQ MAGIC1
					CMP #$21
					BEQ MAGIC0
					CMP #$20
					BCC MAGIC2
					LDA $14
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$01
					ASL A
					ASL A
					STA $1570,x
					RTS
MAGIC0				PHY
                    JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
                    PLY
					JSR GEN_SPRITE
					RTS
MAGIC1				LDA #$80
					STA $15AC,x
RETURN8				RTS
MAGIC2				STZ $B6,x
					LDA #$08
					STA $1570,x
					RTS


NEAR_CHECK			LDA $E4,x
					SEC
					SBC $94
					STA $0F
					LDA $14E0,x
					SBC $95
					BCS LEFT
					LDA $0F
					CMP #$D0
					BCS NEAR2
					RTS
LEFT				LDA $0F
					CMP #$30
					BCC NEAR2
					RTS
NEAR2				LDA #$90
					STA $AA,x
					LDA #$01
					STA $C2,x
					RTS
					
DAMAGE				LDA $157C,x
					BEQ DAMAGE_R
					LDA $E4,x
					PHA
					SEC
					SBC #$10
					STA $E4,x
					LDA $14E0,x
					PHA
					SBC #$00
					STA $14E0,x
					JSL $01A7DC
					LDA $E4,x
					SEC
					SBC #$10
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
					JSL $01A7DC
DAMAGE2				PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS
DAMAGE_R			LDA $E4,x
					PHA
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					PHA
					ADC #$00
					STA $14E0,x
					JSL $01A7DC
					LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					JSL $01A7DC
					BRA DAMAGE2
					
DIR_CHANGE			LDA $1588,x             ; \ if sprite is in contact with an object...
                    AND #$03                ; |
                    BEQ AIR_CHECK
                    LDA $157C,x             ; | flip the direction status
                    EOR #$01                ; |
                    STA $157C,x             ; /
					RTS
AIR_CHECK			LDA $1588,x
					AND #$04
					BNE DIR_R
					LDA $157C,x             ; | flip the direction status
                    EOR #$01                ; |
                    STA $157C,x 
DIR_R				RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN68            RTS
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots ful
                    BMI RETURN68            ; / after: Y has index of sprite being generated
					LDA #$2B
					STA $009E,y
					LDA #$08
					STA $14C8,y
					LDA $94
                    STA $00E4,y
                    LDA $95
                    STA $14E0,y             ; /
                    LDA #$B0
                    STA $00D8,y             ;  |
                    LDA #$00
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    PLX
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HORZ_DISP_ONI       dcb $F8,$08,$F8,$08
VERT_DISP_ONI       dcb $F8,$F8,$08,$08
TILEMAP_ONI         dcb $CC,$CE,$EC,$EE

GFX_ONI_R			RTS
SUB_GFX_ONI         LDA $C2,x
					BEQ GFX_ONI_R
					JSR GET_DRAW_INFO
					PHX
                    LDX #$03                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START_ONI      
                    LDA $00
					CLC
					ADC HORZ_DISP_ONI,x
					STA $0300,y             ; /
                    LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP_ONI,x         ; |
                    STA $0301,y  
					
                    LDA TILEMAP_ONI,x           ; \ store tile
                    STA $0302,y             ; /

					LDA #$03
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties

                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START_ONI

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return



VERT_DISP           dcb $F0,$00
TILEMAP             dcb $8E,$AE

GFX_R				RTS
SUB_GFX             LDA $C2,x
					BEQ GFX_R
					JSR GET_DRAW_INFO
					LDA $1602,x
					STA $0F
					PHX
                    LDX #$01                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START          PHX                     ; push, current tile

					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP,x         ; |
                    STA $0301,y             ; /
					
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    STA $0300,y             ; /
                    
                    LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /

					LDA $0F
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties


                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$01                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

HORIZ_DISP2          dcb $F8,$08,$F8,$08,$08,$F8,$08,$F8
VERT_DISP2           dcb $F0,$F0,$00,$00
TILEMAP2             dcb $86,$88,$A6,$A8
PROPERTIES2          dcb $05,$45


SUB_GFX2            JSR GET_DRAW_INFO
					LDA $C2,x
					BNE SUB_GFX3
					LDA $157C,x
					STA $02
					PHX
					LDX $02
					LDA PROPERTIES2,x
					PLX
					STA $0F
					LDA $02
					ASL A
					ASL A
					STA $02
					
					PHX
                    LDX #$03                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START2          PHX                     ; push, current tile

					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP2,x         ; |
                    STA $0301,y             ; /
					
					LDA TILEMAP2,x           ; \ store tile
                    STA $0302,y             ; /
					

					TXA
					CLC
					ADC $02
					TAX
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP2,x        ; |
                    STA $0300,y             ; /

                    
					LDA $0F
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties


                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START2

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

HORIZ_DISP3          dcb $00,$10,$20,$00,$10,$00,$F0,$E0,$00,$F0
VERT_DISP3           dcb $F0,$F0,$F0,$00,$00
TILEMAP3             dcb $80,$82,$84,$A0,$A2
PROPERTIES3          dcb $05,$45


SUB_GFX3            LDA $157C,x
					STA $02
					PHX
					LDX $02
					LDA PROPERTIES3,x
					PLX
					STA $0F
					LDA $02
					ASL A
					ASL A
					CLC
					ADC $02
					STA $02
					
					PHX
                    LDX #$04                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START3          PHX                     ; push, current tile

					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP3,x         ; |
                    STA $0301,y             ; /
					
					LDA TILEMAP3,x           ; \ store tile
                    STA $0302,y             ; /
					

					TXA
					CLC
					ADC $02
					TAX
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP3,x        ; |
                    STA $0300,y             ; /

                    
					LDA $0F
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties


                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START3

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$04                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
HORIZ_DISP4          dcb $F8,$08,$F8,$08,$08,$F8,$08,$F8
VERT_DISP4           dcb $F0,$F0,$00,$00
TILEMAP4             dcb $8A,$8C,$AA,$AC,$C4,$CA,$E4,$EA,$C0,$C2,$E0,$A4
PROPERTIES4          dcb $07,$47


SUB_GFX4            JSR GET_DRAW_INFO
					LDA $157C,x
					STA $02
					PHX
					LDX $02
					LDA PROPERTIES4,x
					PLX
					STA $0F
					LDA $02
					ASL A
					ASL A
					STA $02
					LDA $1570,x
					STA $03
					
					PHX
                    LDX #$03                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START4          PHX                     ; push, current tile

					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP4,x         ; |
                    STA $0301,y             ; /
					
					PHX
					TXA
					CLC
					ADC $02
					TAX
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP4,x        ; |
                    STA $0300,y             ; /
					PLX

					TXA
					CLC
					ADC $03
					TAX
                    LDA TILEMAP4,x           ; \ store tile
                    STA $0302,y
					
					LDA $0F
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties


                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START4

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817                ; Y = 1 if contact

SUB_GET_DIR         LDY #$00                
                    LDA $94                
                    SEC                     
                    SBC $E4,x               
                    STA $0F                 
                    LDA $95                 
                    SBC $14E0,x             
                    BPL LABEL16             
                    INY                     
LABEL16             RTS                     






