;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Boomerang Brother, by mikeyk
;;
;; Description: Similar to his role in SMB3, this guy throws boomerangs at Mario. 
;;
;; BIG FAT NOTE: This sprite depends on the boomerang sprite.  Make sure you insert the
;; boomerang as the very next sprite.  (ex. If this is sprite 1B, make the boomerang 1C)
;;
;; Uses first extra bit: NO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                   



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
                    LDA #$01
					STA $157C,x
					LDA #$40
					STA $15AC,x
					STZ $C2,x
					STZ $1504,x
					STZ $1528,x
					STZ $1594,x
					LDA #$01
					STA $7FFFDF
					LDA #$0D
					STA $7FFFE0
					LDA #$0E
					STA $7FFFE1
					LDA #$0D
					STA $7FFFE2
					LDA #$0E
					STA $7FFFE3
					LDA #$0D
					STA $7FFFE4
					LDA #$0E
					STA $7FFFE5
					LDA #$FC
					STA $7FFFE6
                    RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


STAR                INC $1558,x
RETURN              RTS                    
START_HB_CODE       JSR SUB_GFX             ; draw hammer bro gfx
                    LDA $14C8,x             ; \ if hammer bro status != 8...
                    CMP #$02                ;  }   ... not (killed with spin jump [4] or star[2])
                    BEQ STAR
                    CMP #$08
                    BNE RETURN              ; /    ... return
                    LDA $9D                 ; \ if sprites locked...
                    BNE RETURN              ; /    ... return
                    
                    INC $1570,x             ; increment number of frames hammer bro has been on screen
					LDA $16
					ORA $18
					BEQ MAIN1
					INC $151C,x
MAIN1					
					JSR SUB_MODE
					JSR LIFE_GAGE
                    LDA $E4,x
					CMP #$E0
					BCS MAIN_R
					CMP #$10
					BCC MAIN_L
					BRA MAIN2
MAIN_R				LDA $B6,x
					CMP #$80
					BCS MAIN2
					STZ $B6,x
					BRA MAIN2
MAIN_L				LDA $B6,x
					CMP #$80
					BCC MAIN2
					STZ $B6,x
MAIN2		        JSL $01802A             ; update position based on speed values
                    
                    JSR DAMAGE_CHECK
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X_SPEED1			dcb $10,$F0
X_SPEED2			dcb $04,$FC

MODE0				LDA $C2,x
					BNE MODE0_3
					LDA $15AC,x
					BNE MODE0_E
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$01
					CLC
					ADC #$01
					STA $1602,x
					PHX
					LDA $157C,x
					TAX
					LDA X_SPEED1,x
					PLX
					STA $B6,x
					LDA $E4,x
					AND #$FC
					CMP $1504,x
					BNE MODE0_R3
					LDA #$01
					STA $C2,x
					LDA #$20
					STA $15AC,x
MODE0_R3			RTS
MODE0_E				STZ $1602,x
					STZ $B6,x
					JSR SUB_GET_DIR         ; \ always face mario
                    TYA                     ;  | 
                    STA $157C,x
					LDA $94
					AND #$FC
					STA $1504,x
					RTS
MODE0_3				LDA #$03
					STA $1602,x
					LDA $15AC,x
					BEQ MODE0_5
					PHX
					LDA $157C,x
					TAX
					LDA X_SPEED1,x
					PLX
					STA $B6,x
					RTS
MODE0_5				STZ $C2,x
					JSR MODE_CHANGE
					RTS

MODE_CHANGE			STZ $B6,x
					LDA #$30
					STA $15AC,x
					LDA $151C,x
					AND $94
					AND #$03
					STA $1528,x
					CMP #$03
					BNE CHENGE_E
					LDA $13
					AND #$03
					STA $1528,x
CHENGE_E			RTS

MODE1				LDA $C2,x
					BNE MODE1_6
					LDA $15AC,x
					BEQ MODE1_2
					CMP #$01
					BEQ MODE1_3
					LDA #$04
					STA $1602,x
					RTS
MODE1_3				LDA #$A0
					STA $AA,x
					LDA $E4,x
					CMP $94
					BCS MODE1_4
					LDA $94
					SEC
					SBC $E4,x
					LSR A
					LSR A
					STA $B6,x
					RTS
MODE1_4				LDA $E4,x
					SEC
					SBC $94
					LSR A
					LSR A
					STA $0F
					LDA #$00
					SEC
					SBC $0F
					STA $B6,x
					RTS
MODE1_2				LDA #$05
					STA $1602,x
					LDA $1588,x
					AND #$04
					BEQ MODE1_E
					LDA #$20
					STA $15AC,x
					LDA #$09
					STA $1DFC
					LDA #$20
					STA $1887
					LDA #$01
					STA $C2,x
MODE1_E				RTS
MODE1_6				STZ $B6,x
					LDA #$04
					STA $1602,x
					LDA $15AC,x
					BEQ MODE1_7
					RTS
MODE1_7				STZ $C2,x
					JSR MODE_CHANGE
					RTS

MODE2				LDA $C2,x
					CMP #$05
					BEQ MODE2_5
					LDA $15AC,x
					BEQ MODE2_2
					STZ $1602,x
					JSR SUB_GET_DIR         ; \ always face mario
                    TYA                     ;  | 
                    STA $157C,x
					RTS
MODE2_2				LDA #$06
					STA $1602,x
					LDA $157C,x
					PHX
					TAX
					LDA X_SPEED1,x
					PLX
					STA $B6,x
					LDA $E4,x
					CMP #$E0
					BCC MODE2_2_1
					LDA #$01
					STA $157C,x
					BRA MODE2_2_2
MODE2_2_1			CMP #$10
					BCS MODE2_2_2
					STZ $157C,x
MODE2_2_2			LDA $1588,x
					AND #$04
					BEQ MODE2_3
					LDA #$D0
					STA $1504,x
					STA $AA,x
					INC $C2,x
					LDA $C2,x
					CMP #$05
					BEQ MODE2_4
					RTS
MODE2_3				INC $1504,x
					LDA $1504,x
					STA $AA,x
					RTS
MODE2_4				LDA #$03
					STA $1602,x
					LDA #$50
					STA $15AC,x
MODE2_E				RTS
MODE2_5				LDA $15AC,x
					BNE MODE2_E
					STZ $C2,x
					STZ $1504,x
					JSR MODE_CHANGE
					RTS
MODE4				STZ $B6,x
					LDA $15AC,x
					CMP #$80
					BCC MODE4_2
					LDA #$07
					STA $1602,x
					RTS
MODE4_2				CMP #$40
					BCC MODE4_3
					LDA #$03
					STA $1602,x
					LDA $157C,x
					PHX
					TAX
					LDA X_SPEED2,x
					PLX
					STA $B6,x
MODE4_E				RTS
MODE4_3				LDA #$03
					STA $1602,x
					LDA $15AC,x
					BNE MODE4_E
					PHP
					SEP #$30
					LDA #$06
					STA $71
					STZ $89
					STZ $88
					PLP
					RTS


SUB_MODE			LDA $1528,x
					BNE NOT_MODE0
					JSR MODE0
					RTS
NOT_MODE0			CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$02
					BNE NOT_MODE2
					JSR MODE2
					RTS
NOT_MODE2			CMP #$03
					BNE NOT_MODE3
					JSR MODE0
					RTS
NOT_MODE3			JSR MODE4
					RTS

DAMAGE_CHECK		LDA $1528,x
					CMP #$04
					BEQ RETURN2
					LDA $1540,x
					BNE RETURN2
					JSL $01A7DC
					BCC RETURN2
					LDA $7D
					CMP #$80
					BCS ENE_WINS
					CMP #$08
					BCC ENE_WINS
					LDA $1602,x
					CMP #$03
					BEQ WIN2
					CMP #$04
					BEQ WIN2
					LDA #$B0
					STA $7D
					JSL $01AB99             ; display contact graphic
					LDA #$02
                    STA $1DF9
					RTS
WIN2				LDA #$B0
					STA $7D
					JSL $01AB99             ; display contact graphic
					LDA #$20
                    STA $1DF9
					INC $1594,x
					LDA #$20
					STA $1540,x
					LDA $1594,x
					CMP #$08
					BEQ DAMAGE_END
					RTS
ENE_WINS            LDA $1497               ; \ if mario is invincible...
                    BNE RETURN2             ; /   ... return
                    JSL $00F5B7             ; hurt mario
RETURN2             RTS
DAMAGE_END			LDA #$1E
					STA $1DFB
					LDA #$04
					STA $1528,x
					LDA #$FF
					STA $15AC,x
					RTS
					
GAGE_E				RTS
LIFE_GAGE			LDA #$FD
					STA $7FFFE7
					STA $7FFFE8
					STA $7FFFE9
					STA $7FFFEA
					STA $7FFFEB
					STA $7FFFEC
					STA $7FFFED
					STA $7FFFEE
					LDA #$FC
					STA $7FFFEF
					LDA $1594,x
					CMP #$01
					BCS GAGE_2
					RTS
GAGE_2				LDA #$FC
					STA $7FFFE7
					LDA $1594,x
					CMP #$02
					BCS GAGE_3
					RTS
GAGE_3				LDA #$FC
					STA $7FFFE8
					LDA $1594,x
					CMP #$03
					BCS GAGE_4
					RTS
GAGE_4				LDA #$FC
					STA $7FFFE9
					LDA $1594,x
					CMP #$04
					BCS GAGE_5
					RTS
GAGE_5				LDA #$FC
					STA $7FFFEA
					LDA $1594,x
					CMP #$05
					BCS GAGE_6
					RTS
GAGE_6				LDA #$FC
					STA $7FFFEB
					LDA $1594,x
					CMP #$06
					BCS GAGE_7
					RTS
GAGE_7				LDA #$FC
					STA $7FFFEC
					LDA $1594,x
					CMP #$07
					BCS GAGE_8
					RTS
GAGE_8				LDA #$FC
					STA $7FFFED
					LDA $1594,x
					CMP #$08
					BCS GAGE_9
					RTS
GAGE_9				LDA #$FC
					STA $7FFFEE
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP             dcb $CC,$CE,$EC,$EE,$80,$82,$A0,$A2,$C8,$CA,$E8,$EA,$C4,$C6,$E4,$E6
					dcb $8C,$8E,$AC,$AE,$C0,$C2,$E0,$E2,$88,$8A,$A8,$AA,$84,$86,$A4,$A6
HORZ_DISP			dcb $08,$F8,$08,$F8,$F8,$08,$F8,$08
VERT_DISP           dcb $00,$00,$10,$10
PROPERTIES          dcb $40,$00

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
               ; /
                    LDA $157C,x             ; \ $02 = sprite direction
                    STA $02                 ; /
					LDA $1602,x
					ASL A
					ASL A
					STA $03
					LDA $1540,x
					BEQ GFX2
					LDA #$1C
					STA $03
GFX2				PHX                     ; push sprite index

                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START          PHX                     ; push current tile number
                   
                    
NO_ADJ              PHX
					TXA
					CLC
					ADC $02
					ADC $02
					ADC $02
					ADC $02
					TAX
					LDA $00
					CLC                     ;  |
                    ADC HORZ_DISP,x         ;  |
                    STA $0300,y             ; /      
					PLX              

                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP,x         ;  |
                    STA $0301,y             ; /
                    
					PHX
					TXA
					CLC
					ADC $03
					TAX
                    LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; / 
					PLX
        
                    LDX $02                 ; \
                    LDA PROPERTIES,x        ;  | get tile properties using sprite direction
                    ORA #$0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817                ; Y = 1 if contact

SUB_GET_DIR         LDY #$00                ;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
                    LDA $94                 ;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
                    SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
                    SBC $E4,x               ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
                    STA $0F                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
                    LDA $95                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
                    SBC $14E0,x             ;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
                    BPL LABEL16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
                    INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
LABEL16             RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642

