;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Deamon's Wall
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"
					LDA #$10
					STA $15AC,x
					RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS
CODE_START          LDA $9D
					BNE RETURN
					JSR LAYER2
					STZ $149F
					STZ $1401
					JSL $01802A
					LDA $C2,x
					BNE NOT_MODE0
					JSR MODE0
					RTS
NOT_MODE0			CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			JSR MODE2
					RTS

MODE0				JSR POS_SET
					LDA #$16
					STA $00212C
					LDA #$01
					STA $00212D
					LDA #$30
					STA $AA,x
					STZ $B6,x
					LDA $14D4,x
					BNE MODE0_2
					LDA $15AC,x
					BEQ MODE0_R
					LDA #$2B
					STA $1DFC
					STZ $15AC,x
MODE0_R				RTS
MODE0_2				STZ $AA,x
					STZ $D8,x
					INC $C2,x
					LDA #$80
					STA $15AC,x
					LDA #$20
					STA $1887
					LDA #$09
					STA $1DFC
					LDA #$30
					STA $1540,x
					RTS
					
MODE1				JSR POS_SET
					STZ $AA,x
					LDA $1540,x
					BNE MODE1_R
					JSR DAMAGE_CHECK
					LDA $B6,x
					CMP #$80
					BCS MODE1_1
					CMP #$20
					BCS MODE1_2
MODE1_1				INC $B6,x
MODE1_2				LDA $1528,x
					CMP #$03
					BEQ MODE1_3
					LDA $15AC,x
					BNE MODE1_R
					LDA #$80
					STA $15AC,x
					JSR BUL_CHECK
					TYA
					CMP #$02
					BCS MODE1_R
					JSR GEN_BULLET
					LDA #$09
					STA $1DFC
MODE1_R				RTS
MODE1_3				LDA $B6,x
					BNE MODE1_R
					STZ $1411
					STZ $AA,x
					STZ $B6,x
					INC $C2,x
					LDA #$40
					STA $1540,x
					RTS

MODE2				LDA $1528,x
					CMP #$05
					BEQ MODE2_4
					JSR DAMAGE_CHECK
					LDA #$08
					STA $B6,x
					STZ $AA,x
					LDA $1540,x
					BNE MODE2_R
					LDA $15AC,x
					BNE MODE2_R
					LDA #$60
					STA $15AC,x
					INC $1570,x
					LDA $1570,x
					AND #$01
					;BNE MODE2_3
					JSR NORMAL_GEN
					LDA #$0A
					STA $14C8,y
					LDA #$00
					STA $157C,y
MODE2_R				RTS
MODE2_3				JSR GEN_BULLET
					LDA #$09
					STA $1DFC
					RTS
MODE2_4				STZ $AA,x
					LDA $1540,x
					BNE MODE2_5
					LDA #$60
					STA $1540,x
					LDA #$1E
					STA $1DFB
					STZ $5B
					LDA #$E0
					STA $B6,x
					RTS
MODE2_5				CMP #$01
					BEQ MODE2_8
					RTS
MODE2_8				PHX
					LDA $95
					TAX
					LDA #$49
					STA $19B8,x
					LDA #$05
					STA $19D8,x
					LDA #$00
					STA $1B93,x
					PLX
					PHP
					SEP #$30
					LDA #$06
					STA $71
					STZ $89
					STZ $88
					PLP
					STZ $14C8,x
					RTS

LAYER2				LDA #$A0
					SEC
					SBC $E4,x
					STA $1466
					LDA #$00
					SBC $14E0,x
					STA $1467
					LDA $1466
					CLC
					ADC $1462
					STA $1466
					LDA $1467
					ADC $1463
					STA $1467
					LDA #$00
					SEC
					SBC $D8,x
					STA $1468
					LDA #$01
					SBC $14D4,x
					STA $1469
					RTS

POS_SET				LDA $94
					SEC
					SBC $E4,x
					STA $0F
					LDA $95
					SBC $14E0,x
					BCS POS_RIGHT
					LDA $0F
					CMP #$80
					BCS POS_RETURN
					LDA $94
					CLC
					ADC #$80
					STA $E4,x
					LDA $95
					ADC #$00
					STA $14E0,x
POS_RETURN			RTS
POS_RIGHT			LDA $0F
					CMP #$80
					BCC POS_RETURN
					LDA $94
					SEC
					SBC #$80
					STA $E4,x
					LDA $95
					SBC #$00
					STA $14E0,x
					RTS
BUL_CHECK			LDY #$00
					PHX
					LDX #$00
BUL_CHECK_LOOP		LDA $14C8,x
					CMP #$08
					BNE BUL_CHECK2
					LDA NEW_SPRITE_NUM,x
					CMP #$52
					BNE BUL_CHECK2
					INY
BUL_CHECK2			INX
					CPX #$0A
					BNE BUL_CHECK_LOOP
					PLX
					RTS
					
DAMAGE_CHECK        LDA $E4,x
                    STA $7FFE01
                    LDA $14E0,x
                    STA $7FFE02
                    LDA $D8,x
                    STA $7FFE03
                    LDA $14D4,x
                    STA $7FFE04
                    PHX
                    LDX #$09
LOOP1               ;LDA $9E,x
                    ;CMP #$04
                    ;BNE LOOP3
					LDA $14C8,x
					;BEQ LOOP3
					CMP #$0A
					BNE LOOP3
					LDA $B6,x
					CMP #$80
					BCC LOOP3
					JSR NEAR_CHECK
                    TYA
                    BEQ LOOP3
					STZ $14C8,x
                    LDA #$28
					STA $1DFC
					PLX
					INC $1528,x
					LDA #$E0
					STA $B6,x
					PHX
LOOP3               DEX
                    BPL LOOP1
                    PLX
					RTS
NEAR_CHECK          LDY #$00
                    LDA $E4,x
                    SEC
                    SBC $7FFE01
                    STA $0F
                    LDA $14E0,x
                    SBC $7FFE02
                    CMP #$00
                    BEQ RIGHT_CHECK
                    CMP #$FF
                    BNE CHECK_E
                    LDA $0F
                    CMP #$E8
                    BCC CHECK_E
                    BRA VER_CHECK
RIGHT_CHECK         LDA $0F
                    CMP #$18
                    BCS CHECK_E
VER_CHECK           LDA $D8,x
                    SEC
                    SBC $7FFE03
                    STA $0F
                    LDA $14D4,x
                    SBC $7FFE04
                    CMP #$00
                    BEQ UNDER_CHECK
                    CMP #$FF
                    BNE CHECK_E
                    LDA $0F
                    CMP #$E8
                    BCC CHECK_E
                    BRA NEAR
UNDER_CHECK         LDA $0F
                    CMP #$18
                    BCS CHECK_E
NEAR                LDY #$01
CHECK_E             RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN67            RTS
GEN_BULLET          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA #$52
					TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
                    LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

                    LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
					LDA #$00
					STA $157C,y
                    RTS                          ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN68            RTS
NORMAL_GEN          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots ful
                    BMI RETURN68            ; / after: Y has index of sprite being generated
					LDA #$04
					STA $009E,y
					LDA #$0A
					STA $14C8,y
					LDA $E4,x
					CLC
					ADC #$08
                    STA $00E4,y
					ADC #$00
                    LDA $14E0,x
                    STA $14E0,y             ; /
                    LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    PLX
					LDA #$00
					STA $157C,y
					;LDA #$C0
					;STA $00AA,y
					;LDA #$E0
					;STA $00B6,y
					LDA #$20
					STA $00B6,y
					RTS
					
