;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Light gazer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;      
                    dcb "INIT"
					LDA $E4,x
					CMP #$F0
					BEQ R_INIT
					CMP #$E0
					BEQ L_INIT
					STZ $1528,x
					LDA #$FF
					STA $15AC,x
					STZ $151C,x
					STZ $C2,x
					STZ $1504,x
					LDA #$01
					STA $157C,x
					TXA
					STA $7FFD00
					LDA #$FF
					STA $15AC,x
                    RTL
R_INIT				LDA #$01
					STA $1504,x
					RTL
L_INIT				LDA #$02
					STA $1504,x
					RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                     ; return           
CODE_START          LDA $1504,x
					CMP #$01
					BNE MAIN0
					JSR RIGHT_WING
					RTS
MAIN0				CMP #$02
					BNE MAIN1
					JSR LEFT_WING
					RTS
MAIN1				CMP #$10
					BNE MAIN2
					JSR MARIO
					RTS
MAIN2				CMP #$11
					BNE MAIN3
					JSR YOSHI
					RTS
MAIN3				CMP #$12
					BNE MAIN4
					JSR TAN
					RTS
MAIN4				CMP #$13
					BNE MAIN5
					JSR FIRE
					RTS
MAIN5				CMP #$14
					BNE MAIN6
					JSR FIRE2
					RTS
MAIN6				CMP #$15
					BNE MAIN7
					JSR TSC0
					RTS
MAIN7				CMP #$16
					BNE MAIN8
					JSR BOMB
					RTS
MAIN8				JSR GET_DRAW_INFO
NO_GFX				LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
					JSR FREEZ_CHECK
					LDA $1528,x
					CMP #$03
					BCS NO_CHECK
					JSR SPRITE_CHECK
NO_CHECK			LDA #$16
					STA $00212C
					LDA #$01
					STA $00212D
					LDA #$02
					STA $00212E
					LDA #$00
					STA $002126
					LDA #$00
					STA $002127
					JSR LAYER2
					JSL $01A7DC
					LDA $C2,x
					STA $7FFD02
					BNE NOT_MODE0
					JSR MODE0
					RTS
NOT_MODE0			CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$02
					BNE NOT_MODE2
					JSR MODE2
					RTS
NOT_MODE2			CMP #$03
					BNE NOT_MODE3
					JSR MODE3
					RTS
NOT_MODE3			CMP #$04
					BNE NOT_MODE4
					JSR MODE4
					RTS
NOT_MODE4			JSR MODE5
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MARIO				JSR MARIO_GFX
					RTS
YOSHI				JSR YOSHI_GFX
					RTS
					

BOMB				LDA $15AC,x
					CMP #$10
					BCC BOMB_2
					JSR SUB_GFX4
					BRA BOMB_M
BOMB_2				CMP #$08
					BCC BOMB_3
					LDA #$C4
					STA $7FEEEC
					LDA #$0F
					STA $7FEEED
					JSR SUB_GFX2
					BRA BOMB_M
BOMB_3				LDA #$E4
					STA $7FEEEC
					LDA #$0F
					STA $7FEEED
					JSR SUB_GFX2
BOMB_M				LDA $9D                 ; \ if sprites locked, return
                    BNE BOMB_R
					LDA $15AC,x
					BNE BOMB_R
					STZ $14C8,x
BOMB_R				RTS
					

BOMB_SPEED			dcb $20,$E0
TSC0				LDA $15AC,x
					CMP #$50
					BEQ TSC0_D
					CMP #$A0
					BCC TSC0_1
					JSR TSC_GFX
					BRA TSC0_2
TSC0_1				JSR TSC_GFX2
TSC0_2				LDA $9D
					BNE TSC_R
					LDA $15AC,x
					CMP #$A0
					BEQ TSC0_3
TSC_R				RTS
TSC0_D				STZ $14C8,x
					RTS
TSC0_3				JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
					JSR NORMAL_GEN
					PHX
					LDA $157C,x
					TAX
					LDA BOMB_SPEED,x
					STA $00B6,y
					PLX
					LDA #$C0
					STA $1540,y
					LDA $157C,x
					STA $157C,y
					RTS

TAN					JSR TAN_GFX
					LDA $9D
					BNE TAN_R
					STZ $1662,x
					JSL $01A7DC
					STZ $AA,x
					JSL $01802A
					LDA $15AC,x
					CMP #$5F
					BEQ TAN_D
					CMP #$80
					BCS TAN2
					CMP #$60
					BCS TAN3
TAN_R				RTS
TAN2				LDA #$E0
					STA $B6,x
					RTS
TAN3				LDA #$20
					STA $B6,x
					RTS
TAN_D				STZ $14C8,x
					RTS
					
FIRE_SPEED			dcb $E0,$20

FIRE2				JSR GET_DRAW_INFO
					LDA $9D
					BNE FIRE2_R
					LDA $15AC,x
					BEQ FIRE2_D
					LDY $157C,x
					LDA FIRE_SPEED,y
					STA $B6,x
					JSL $01802A
					JSR FIRE_CHANGE
FIRE2_R				RTS
FIRE2_D				STZ $14C8,x
					RTS

FIRE				JSR FIRE_GFX
					LDA $9D
					BNE FIRE_R
					LDA $1588,x
					AND #$04
					BNE FIRE_G
					STZ $B6,x
					JSL $01802A
FIRE_R				RTS
FIRE_G				JSR FIRE_GEN
					LDA #$14
					STA $1504,y
					LDA #$19
					STA $1686,y
					LDA #$00
					STA $1662,y
					LDA #$00
					STA $157C,y
					LDA #$20
					STA $15AC,y
					JSR FIRE_GEN
					LDA #$14
					STA $1504,y
					LDA #$19
					STA $1686,y
					LDA #$00
					STA $1662,y
					LDA #$01
					STA $157C,y
					LDA #$20
					STA $15AC,y
					LDA #$17
					STA $1DFC
					STZ $14C8,x
					RTS

X_SPEED				dcb $08,$F8
COLOR_OFFSET2		dcb $06,$06,$06,$0A,$0A,$0A,$0A,$08,$08,$08,$08,$04,$04,$04,$04,$06

MODE0				STZ $7D
					STZ $7B
					STZ $13E0
					STZ $13DF
					LDA #$01
					STA $76
					LDA $15AC,x
					CMP #$80
					BCS MODE0_M
					CMP #$7F
					BEQ MODE0_M1
					CMP #$7E
					BEQ MODE0_M2
					CMP #$7D
					BEQ MODE0_M3
					CMP #$7C
					BEQ MODE0_M4
					CMP #$7B
					BEQ MODE0_M5
MODE0_R				RTS
MODE0_M				LDA #$F8
					STA $B6,x
					LDA #$10
					STA $AA,x
					JSL $01802A
					RTS
MODE0_M1			JSR FIRE_GEN
					TYA
					STA $7FFD01
					LDA #$10
					STA $00E4,y
					LDA #$E8
					STA $00D8,y
					LDA #$00
					STA $14E0,y
					STA $14D4,y
					LDA #$10
					STA $1504,y
					LDA #$01
					STA $1426
					RTS
MODE0_M2			LDA $7FFD01
					TAY
					LDA #$00
					STA $14C8,y
					JSR FIRE_GEN
					TYA
					STA $7FFD01
					LDA #$10
					STA $00E4,y
					LDA #$E8
					STA $00D8,y
					LDA #$00
					STA $14E0,y
					STA $14D4,y
					LDA #$11
					STA $1504,y
					LDA #$02
					STA $1426
					RTS
MODE0_M3			
					LDA #$01
					STA $13BF
					LDA #$01
					STA $1426
					RTS
MODE0_M4			LDA #$02
					STA $1426
					RTS
MODE0_M5			LDA $7FFD01
					TAY
					LDA #$00
					STA $14C8,y
					LDA #$19
					STA $13BF
					LDA #$05
					STA $1DFB
					LDA #$01
					STA $C2,x
					RTS

MODE0_1				LDA #$01
					STA $C2,x
					STZ $1570,x
					LDA #$00
					STA $7FF000
					RTS

X_SPEED				dcb $08,$F8
MODE1				LDY $157C,x
					LDA X_SPEED,y
					STA $B6,x
					LDA $AA,x
					PHA
					JSL $01802A
					PLA
					STA $AA,x
					LDA $14D4,x
					BEQ MODE1_1
					LDA $D8,x
					CMP #$30
					BCC MODE1_1
					LDA #$E0
					STA $AA,x
					JSR SHAKE
					LDA $1570,x
					CMP #$04
					BEQ MODE1_ATK
					INC $1570,x
MODE1_1				LDA $14
					AND #$01
					BNE MODE1_2
					LDA $AA,x
					INC A
					STA $AA,x
MODE1_2				LDA $E4,x
					CMP #$C0
					BCS MODE1_3
					CMP #$10
					BCC MODE1_4
					RTS
MODE1_3				LDA #$01
					STA $157C,x
					RTS
MODE1_4				STZ $157C,x
					RTS
MODE1_ATK			STZ $AA,x
					STZ $B6,x
					STZ $1570,x
					LDA $151C,x
					CLC
					ADC #$02
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					INC $151C,x
					LDA $151C,x
					CMP #$03
					BNE MODE1_R
					STZ $151C,x
MODE1_R				RTS

MODE2				LDA $15AC,x
					CMP #$E0
					BEQ MODE2_G
					CMP #$80
					BEQ MODE2_2
					RTS
MODE2_G				JSR FIRE_GEN
					LDA $E4,x
					SEC
					SBC #$10
					STA $00E4,y
					LDA $14E0,x
					SBC #$00
					STA $14E0,y
					LDA $D8,x
					CLC
					ADC #$1C
					STA $00D8,y
					LDA $14D4,x
					ADC #$00
					STA $14D4,y
					LDA #$12
					STA $1504,y
					LDA #$A0
					STA $15AC,y
					LDA #$08
					STA $1DFC
					RTS
MODE2_2				STZ $15AC,x
					LDA #$01
					STA $C2,x
					LDA #$E0
					STA $AA,x
					RTS
					
MODE3				LDA $15AC,x
					CMP #$E0
					BEQ MODE3_G
					CMP #$80
					BEQ MODE3_2
					RTS
MODE3_G				JSR FIRE_GEN
					LDA $E4,x
					CLC
					ADC #$38
					STA $00E4,y
					LDA $14E0,x
					ADC #$00
					STA $14E0,y
					LDA $D8,x
					CLC
					ADC #$1C
					STA $00D8,y
					LDA $14D4,x
					ADC #$00
					STA $14D4,y
					LDA #$13
					STA $1504,y
					LDA #$19
					STA $1686,y
					LDA #$00
					STA $1662,y
					RTS
MODE3_2				STZ $15AC,x
					LDA #$01
					STA $C2,x
					LDA #$E0
					STA $AA,x
					RTS

MODE4				LDA $15AC,x
					CMP #$FE
					BEQ MODE4_1
					CMP #$E0
					BCS MODE4_R
					CMP #$C0
					BCS MODE4_DOWN2
					CMP #$80
					BCS MODE4_R
					CMP #$60
					BCS MODE4_UP
					CMP #$5F
					BEQ MODE4_2
					CMP #$40
					BEQ MODE4_3
					RTS
MODE4_1				JSR HDMA1
					JSR HDMA2
					JSR FIRE_CHANGE2
					JSR FIRE_GEN
					LDA $E4,x
					CLC
					ADC #$18
					STA $00E4,y
					LDA $14E0,x
					ADC #$00
					STA $14E0,y
					LDA $D8,x
					CLC
					ADC #$12
					STA $00D8,y
					LDA $14D4,x
					ADC #$00
					STA $14D4,y
					LDA #$15
					STA $1504,y
					LDA #$FF
					STA $15AC,y
MODE4_R				RTS
MODE4_UP			PHP
					REP #$30
					LDA $7FE204
					SEC
					SBC.W #$0002
					STA $7FE204
					PLP
					LDA $D8,x
					CLC
					ADC #$02
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					LDA $7FEF02
					CLC
					ADC #$02
					STA $7FEF02
					LDA $7FEF04
					SEC
					SBC #$02
					STA $7FEF04
					RTS
MODE4_DOWN2			BRA MODE4_DOWN
MODE4_2				LDA #$28
					STA $7FFB1A
					LDA #$29
					STA $7FFB2A
					RTS
MODE4_3				LDA #$00
					STA $7FFB18
					STA $7FFB28
					STZ $15AC,x
					LDA #$01
					STA $C2,x
					LDA #$E0
					STA $AA,x
					STZ $151C,x
					RTS
MODE4_DOWN			LDA #$10
					STA $7FFB1A
					LDA #$23
					STA $7FFB2A
					PHP
					REP #$30
					LDA $7FE204
					CLC
					ADC.W #$0002
					STA $7FE204
					PLP
					LDA $D8,x
					SEC
					SBC #$02
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					LDA $7FEF02
					SEC
					SBC #$02
					STA $7FEF02
					LDA $7FEF04
					CLC
					ADC #$02
					STA $7FEF04
					RTS
					
BOMB_X				dcb $20,$30,$10,$28,$20
BOMB_Y				dcb $20,$10,$00,$18,$30

MODE5				LDA $9D
					BNE MODE5_R
					LDA $1540,x
					CMP #$E0
					BEQ MODE5_G
					CMP #$D0
					BEQ MODE5_G
					CMP #$C0
					BEQ MODE5_G
					CMP #$B0
					BEQ MODE5_G
					CMP #$A0
					BEQ MODE5_G
					CMP #$90
					BEQ MODE5_D
MODE5_R				RTS
MODE5_G				LDA #$18
					STA $1DFC
					LDY $151C,x
					LDA BOMB_X,y
					STA $7FFEE0
					LDA BOMB_Y,y
					STA $7FFEE1
					JSR FIRE_GEN
					LDA $7FFEE0
					CLC
					ADC $E4,x
					STA $00E4,y
					LDA $14E0,x
					ADC #$00
					STA $14E0,y
					LDA $7FFEE1
					CLC
					ADC $D8,x
					STA $00D8,y
					LDA $14D4,x
					ADC #$00
					STA $14D4,y
					LDA #$16
					STA $1504,y
					LDA #$18
					STA $15AC,y
					INC $151C,x
					RTS
MODE5_D				JSR SPRITE_DEL
					LDA #$80
					STA $1466
					LDA #$01
					STA $1467
					LDA #$60
                    STA $13C6
                    STA $1493
					LDA #$0B
					STA $1DFB
					STZ $14C8,x
					RTS
	
SPRITE_DEL			STX $03
					PHX
					LDX #$00
DEL1_L				CPX $03
					BEQ DEL1_2
					STZ $14C8,x
DEL1_2				INX
					CPX #$0A
					BNE DEL1_L
					PLX
					RTS

RIGHT_WING			JSR SUB_GFXW
					LDA $9D
					BNE RIGHT_WING_R
					LDA $7FFD00
					TAY
					LDA $00E4,y
					CLC
					ADC #$2C
					STA $E4,x
					LDA $14E0,y
					ADC #$00
					STA $14E0,x
					LDA $00D8,y
					STA $D8,x
					LDA $14D4,y
					STA $14D4,x
RIGHT_WING_R		RTS
					
LEFT_WING			JSR SUB_GFXW2
					LDA $9D
					BNE LEFT_WING_R
					LDA $7FFD00
					TAY
					LDA $00E4,y
					STA $E4,x
					LDA $14E0,y
					STA $14E0,x
					LDA $00D8,y
					STA $D8,x
					LDA $14D4,y
					STA $14D4,x
LEFT_WING_R			RTS

SHAKE				LDA #$09
					STA $1DFC
					LDA #$40
					STA $1887
					LDA $18BD
					BNE SHAKE_R
					LDA $77
					AND #$04
					BEQ SHAKE_R
					LDA #$A0
					STA $18BD
SHAKE_R				RTS
FREEZ_CHECK			LDA $1497
					BEQ SHAKE_R
					STZ $18BD
					RTS

					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ETC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
LAYER2				LDA #$D0
					SEC
					SBC $E4,x
					STA $1466
					LDA #$00
					STA $1467
					LDA $14D4,x
					BNE LAYER2_2
					LDA #$00
					SEC
					SBC $D8,x
					CLC
					ADC #$70
					STA $1468
					STZ $1469
					RTS
LAYER2_2			LDA #$70
					SEC
					SBC $D8,x
					STA $1468
					STZ $1469
					RTS

FIRE_CHANGE			LDA $E4,x
					STA $9A
					LDA $14E0,x
					STA $9B
					LDA $D8,x
					CLC
					ADC #$10
					STA $98
					LDA $14D4,x
					ADC #$00
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$05A0
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
					
FIRE_CHANGE2		LDA #$00
					STA $9A
					LDA #$00
					STA $9B
					LDA #$70
					STA $98
					LDA #$01
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$06BC
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$10
					STA $9A
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$06AC
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$20
					STA $9A
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$06BC
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$30
					STA $9A
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$06AC
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$40
					STA $9A
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$06BC
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$50
					STA $9A
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$06AC
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$60
					STA $9A
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$06BC
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$70
					STA $9A
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$06AC
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$06BC
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$90
					STA $9A
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$06AC
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$A0
					STA $9A
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$06BC
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$B0
					STA $9A
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$06AC
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$C0
					STA $9A
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$06BC
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$D0
					STA $9A
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$06AC
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$E0
					STA $9A
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$06BC
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$F0
					STA $9A
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$06AC
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


RETURN67            RTS
FIRE_GEN            JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
					TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
                    LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

                    LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN68            RTS
NORMAL_GEN          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots ful
                    BMI RETURN68            ; / after: Y has index of sprite being generated
					LDA #$0D
					STA $009E,y
					LDA #$08
					STA $14C8,y
					LDA $E4,x
                    STA $00E4,y
                    LDA $14E0,x
                    STA $14E0,y             ; /
                    LDA $D8,x
					SEC
					SBC #$20
                    STA $00D8,y             ;  |
                    LDA $14D4,x
					SBC #$00
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    PLX
GEN_RETURN          RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP             dcb $80,$80,$A0,$A0
HORZ_DISP			dcb $F8,$08,$F8,$08
VERT_DISP			dcb $F1,$F1,$01,$01
PROPETIES			dcb $40,$00,$40,$00

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
                    PHX                     ; push sprite index

					LDX #$03
LOOP_START          PHX
					LDA $01
					CLC
					ADC VERT_DISP,x
					STA $0301,y
					LDA $00                 ; 
					CLC
					ADC HORZ_DISP,x
                    STA $0300,y             ; /
					
					LDA TILEMAP,x           ; \ store tile
                    STA $0302,y

                    LDA #$0D
					ORA PROPETIES,x
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					PLX

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

FIRE_GFX	        JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)

                    LDA $00                 ; \ tile x position = sprite x location ($00)
                    STA $0300,y             ; /                    
                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y             ; /
                                 
					LDA #$80
                    STA $0302,y             ; / 

                    LDA #$05
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties

                    
                    LDY #$02
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
TILEMAPW            dcb $40,$42,$44,$60,$62
					dcb $46,$48,$66,$68,$64
					dcb $4A,$4C,$6A,$6C,$6E
					dcb $46,$48,$66,$68,$64
HORZ_DISPW			dcb $00,$10,$20,$00,$10
					dcb $00,$10,$00,$10,$20
					dcb $00,$10,$00,$10,$20
					dcb $00,$10,$00,$10,$20
VERT_DISPW			dcb $F2,$F2,$F2,$02,$02
					dcb $F6,$F6,$06,$06,$FE
					dcb $03,$03,$13,$13,$0B
					dcb $F6,$F6,$06,$06,$FE

SUB_GFXW            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$03
					STA $03
					ASL A
					ASL A
					CLC
					ADC $03
					STA $03
					LDA $7FFD02
					CMP #$02
					BCC SUB_GFXW1
					LDA #$05
					STA $03
SUB_GFXW1           PHX                     ; push sprite index

					LDX #$04
LOOP_STARTW         PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA $01
					CLC
					ADC VERT_DISPW,x
					STA $0301,y
					LDA $00                 ; 
					CLC
					ADC HORZ_DISPW,x
                    STA $0300,y             ; /
					
					LDA TILEMAPW,x           ; \ store tile
                    STA $0302,y

                    LDA #$0D
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					PLX

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_STARTW          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$04                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
TILEMAPW2           dcb $40,$42,$44,$60,$62
					dcb $46,$48,$66,$68,$64
					dcb $4A,$4C,$6A,$6C,$6E
					dcb $46,$48,$66,$68,$64
HORZ_DISPW2			dcb $00,$F0,$E0,$00,$F0
					dcb $00,$F0,$00,$F0,$E0
					dcb $00,$F0,$00,$F0,$E0
					dcb $00,$F0,$00,$F0,$E0
VERT_DISPW2			dcb $F2,$F2,$F2,$02,$02
					dcb $F6,$F6,$06,$06,$FE
					dcb $03,$03,$13,$13,$0B
					dcb $F6,$F6,$06,$06,$FE

SUB_GFXW2            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$03
					STA $03
					ASL A
					ASL A
					CLC
					ADC $03
					STA $03
					LDA $7FFD02
					CMP #$02
					BCC SUB_GFXW22
					LDA #$05
					STA $03
SUB_GFXW22          PHX                     ; push sprite index

					LDX #$04
LOOP_STARTW2         PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA $01
					CLC
					ADC VERT_DISPW2,x
					STA $0301,y
					LDA $00                 ; 
					CLC
					ADC HORZ_DISPW2,x
                    STA $0300,y             ; /
					
					LDA TILEMAPW2,x           ; \ store tile
                    STA $0302,y

                    LDA #$4D
                    STA $0303,y             ; / store tile properties
					PLX

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_STARTW2          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$04                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
TILEMAPM            dcb $04,$06,$24,$26
HORZ_DISPM			dcb $00,$10,$00,$10
VERT_DISPM			dcb $00,$00,$10,$10

MARIO_GFX           JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
					 PHX                     ; push sprite index

					LDX #$03
LOOP_STARTM         LDA $01
					CLC
					ADC VERT_DISPM,x
					STA $0301,y
					LDA $00                 ; 
					CLC
					ADC HORZ_DISPM,x
                    STA $0300,y             ; /
					
					LDA TILEMAPM,x           ; \ store tile
                    STA $0302,y

                    LDA #$03
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_STARTM          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
TILEMAPY            dcb $00,$02,$20,$22
HORZ_DISPY			dcb $00,$10,$00,$10
VERT_DISPY			dcb $00,$00,$10,$10

YOSHI_GFX           JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
					 PHX                     ; push sprite index

					LDX #$03
LOOP_STARTY         LDA $01
					CLC
					ADC VERT_DISPY,x
					STA $0301,y
					LDA $00                 ; 
					CLC
					ADC HORZ_DISPY,x
                    STA $0300,y             ; /
					
					LDA TILEMAPY,x           ; \ store tile
                    STA $0302,y

                    LDA #$0D
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_STARTY          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
TILEMAPT            dcb $82,$84,$84,$84,$84,$84
HORZ_DISPT			dcb $00,$10,$20,$30,$40,$50

TAN_GFX           JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
					 PHX                     ; push sprite index

					LDX #$04
LOOP_STARTT         LDA $01
					STA $0301,y
					LDA $00                 ; 
					CLC
					ADC HORZ_DISPT,x
                    STA $0300,y             ; /
					
					LDA TILEMAPT,x           ; \ store tile
                    STA $0302,y

                    LDA #$09
                    STA $0303,y             ; / store tile properties

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_STARTT          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$04               ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
TILEMAPA            dcb $CA,$08,$0A,$28,$2A
HORZ_DISPA			dcb $00,$F8,$08,$F8,$08
VERT_DISPA			dcb $E0,$F0,$F0,$00,$00

TSC_GFX           JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
					 PHX                     ; push sprite index

					LDX #$04
LOOP_STARTA         LDA $01
					CLC
					ADC VERT_DISPA,x
					STA $0301,y
					LDA $00                 ; 
					CLC
					ADC HORZ_DISPA,x
                    STA $0300,y             ; /
					
					LDA TILEMAPA,x           ; \ store tile
                    STA $0302,y

                    LDA #$07
                    STA $0303,y             ; / store tile properties

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_STARTA          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$04                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
TILEMAPB            dcb $0C,$0E,$2C,$2E
HORZ_DISPB			dcb $F8,$08,$F8,$08
					dcb $08,$F8,$08,$F8
VERT_DISPB			dcb $F0,$F0,$00,$00
PROPETIESB			dcb $07,$47

TSC_GFX2           JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
					PHX                     ; push sprite index
					LDA $157C,x
					STA $02
					ASL A
					ASL A
					STA $03
					
					LDX #$03
LOOP_STARTB         LDA $01
					CLC
					ADC VERT_DISPB,x
					STA $0301,y
					
					LDA TILEMAPB,x           ; \ store tile
                    STA $0302,y
					
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA $00                 ; 
					CLC
					ADC HORZ_DISPB,x
                    STA $0300,y
					LDX $02
					LDA PROPETIESB,x
                    STA $0303,y             ; / store tile properties
					PLX
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_STARTB          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
TILEMAP4            dcb $C0,$C2,$E0,$E2
X_OFFSET4           dcb $F8,$08,$F8,$08
Y_OFFSET4           dcb $F8,$F8,$08,$08

SUB_GFX4 			JSR GET_DRAW_INFO
					PHX                     ; push sprite index
                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START4         LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
					CLC
					ADC X_OFFSET4,x
                    STA $0300,y             ; /
					
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
					CLC
					ADC Y_OFFSET4,x
                    STA $0301,y             ; /
					
SUB_GFX4_2			LDA TILEMAP4,x
                    STA $0302,y             ; /
					
					LDA #$0F
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties
SUB_GFX4_3		
                    
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START4          ; / 

                    PLX                     ; pull, X = sprite index
                    
                    LDY #$02                ; \ 02, because we didn't write to 460 yet
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen

                    RTS
					
SUB_GFX2            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder 
											
                    PHX                     ; push sprite index

                    LDA $00                 ; \ tile x position = sprite x location ($00)
                    STA $0300,y             ; /                    
                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y             ; /
                                 
					LDA $7FEEEC
                    STA $0302,y             ; / 

                    LDA $7FEEED
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties

                    PLX                     ; pull, X = sprite index
                    
                    LDY #$02
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

HDMA1				LDA #$08
					STA $7FFB18
					LDA #$02
					STA $7FFB19
					LDA #$28
					STA $7FFB1A
					LDA #$00
					STA $7FFB1B
					LDA #$E2
					STA $7FFB1C
					LDA #$7F
					STA $7FFB1D
					
					LDA #$10
					STA $7FE200
					LDA #$40
					STA $7FE201
					LDA #$00
					STA $7FE202
					LDA #$80
					STA $7FE203
					LDA #$40
					STA $7FE204
					LDA #$00
					STA $7FE205
					LDA #$40
					STA $7FE206
					LDA #$40
					STA $7FE207
					LDA #$00
					STA $7FE208
					LDA #$00
					STA $7FE209
					RTS
					
HDMA2				LDA #$20
					STA $7FFB28
					LDA #$00
					STA $7FFB29
					LDA #$29
					STA $7FFB2A
					LDA #$00
					STA $7FFB2B
					LDA #$EF
					STA $7FFB2C
					LDA #$7F
					STA $7FFB2D
					
					LDA #$10
					STA $7FEF00
					LDA #$00
					STA $7FEF01
					LDA #$80
					STA $7FEF02
					LDA #$00
					STA $7FEF03
					LDA #$01
					STA $7FEF04
					LDA #$30
					STA $7FEF05
					LDA #$01
					STA $7FEF06
					LDA #$00
					STA $7FEF07
					LDA #$00
					STA $7FEF08
					RTS


SUB_GET_DIR         LDY #$00                
                    LDA $94                
                    SEC                     
                    SBC $E4,x               
                    STA $0F                 
                    LDA $95                 
                    SBC $14E0,x             
                    BPL LABEL16             
                    INY                     
LABEL16             RTS

SPRITE_CHECK        LDA $E4,x
                    STA $7FFE01
                    LDA $14E0,x
                    STA $7FFE02
                    LDA $D8,x
                    STA $7FFE03
                    LDA $14D4,x
                    STA $7FFE04
                    PHX
                    LDX #$09
LOOP1               LDA $9E,x
                    CMP #$0D
                    BNE LOOP3
					LDA $14C8,x
					CMP #$09
					BCC LOOP3
                    JSR NEAR_CHECK
                    TYA
                    BEQ LOOP3
					STZ $14C8,x
                    LDA #$28
					STA $1DFC
					PLX
					INC $1528,x
					PHX
LOOP3               DEX
                    BPL LOOP1
                    PLX
					LDA $1528,x
					CMP #$03
					BCS THEEND
                    RTS
THEEND				LDA #$1E
					STA $1DFB
					LDA #$05
					STA $C2,x
					LDA #$FF
					STA $1540,x
					RTS
					
NEAR_CHECK          LDY #$00
                    LDA $E4,x
                    SEC
                    SBC $7FFE01
                    STA $0F
                    LDA $14E0,x
                    SBC $7FFE02
                    CMP #$00
                    BNE CHECK_E
RIGHT_CHECK         LDA $0F
                    CMP #$30
                    BCS CHECK_E
VER_CHECK           LDA $D8,x
                    SEC
                    SBC $7FFE03
                    STA $0F
                    LDA $14D4,x
                    SBC $7FFE04
                    LDA $0F
                    CMP #$30
                    BCS CHECK_E
NEAR                LDY #$01
CHECK_E             RTS
