;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; hN{bg
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
NEW_SPRITE_NUM = $7FAB9E
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA EXTRA_BITS,x
					AND #$04
					BNE FIRE_INIT
					LDA #$00
					STA $7FFFA0
					LDA $010B
					CMP #$57
					BEQ INIT_1
					LDA $010B
					CMP #$5C
					BEQ INIT_W
INIT_R				RTL
INIT_1				LDA $14E0,x
					CMP #$06
					BEQ INIT_R
					LDA #$01
					STA $1504,x
					RTL
FIRE_INIT			LDA $14E0,x
					BNE BARR_INIT
					LDA #$09
					STA $1504,x
					RTL
BARR_INIT			CMP #$0D
					BCS BEAM_INIT
					LDA #$0A
					STA $1504,x
					RTL
BEAM_INIT			LDA #$0D
					STA $1504,x
					LDA $14D4,x
					STA $1528,x
					RTL
INIT_W				LDA #$02
					STA $1504,x
					LDA $14E0,x
					CMP #$05
					BEQ INIT_R
					LDA #$03
					STA $1504,x
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

START_HB_CODE       LDA $1504,x
					BNE MAIN1
					JSR COLD
					RTS
MAIN1				CMP #$01
					BNE MAIN2
					JSR FLAME
					RTS
MAIN2				CMP #$02
					BNE MAIN3
					JSR WOOD
					RTS
MAIN3				CMP #$03
					BNE MAIN4
					JSR FLASH
					RTS
MAIN4				CMP #$04
					BNE MAIN5
					JSR SHADOW
					RTS
MAIN5				CMP #$05
					BNE MAIN6
					JSR DAMAGE_EFE
					RTS
MAIN6				CMP #$06
					BNE MAIN7
					JSR WALL
					RTS
MAIN7				CMP #$07
					BNE MAIN8
					JSR FLAME_SHOT1
					RTS
MAIN8				CMP #$08
					BNE MAIN9
					JSR FLAME_SHOT2
					RTS
MAIN9				CMP #$09
					BNE MAINA
					JSR FIRE
					RTS
MAINA				CMP #$0A
					BNE MAINB
					JSR BARRIER
					RTS
MAINB				CMP #$0B
					BNE MAINC
					JSR LEAF1
					RTS
MAINC				CMP #$0C
					BNE MAIND
					JSR LEAF2
					RTS
MAIND				JSR BEAM
					RTS
					
					
BEAM				LDA $C2,x
					BNE BEAM_1
					LDA $9D
					BNE BEAM_R
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA $1558,x
					BNE BEAM_R
					LDA $E4,x
					STA $02
					LDA $14E0,x
					STA $03
					REP #$20
					LDA $02
					SEC
					SBC $94
					CMP.W #$0040
					BPL BEAM_0
					SEP #$20
					INC $C2,x
					LDA #$17
					STA $1DFC
BEAM_0				SEP #$20
BEAM_R				RTS
BEAM_1				JSR SUB_GFX_BM
					LDA $9D
					BNE BEAM_R
					LDA $1558,x
					BNE BEAM_R
					JSR GEN_TILE
					JSL $01802A
					LDA $1528,x
					BNE BEAM_2
					LDA #$20
					STA $AA,x
					LDA $1588,x
					AND #$04
					BNE BEAM_DEL
					RTS
BEAM_2				LDA #$E0
					STA $AA,x
					LDA $1588,x
					AND #$08
					BNE BEAM_DEL
					LDA $14D4,x
					BEQ BEAM_DEL
					RTS
BEAM_DEL			STZ $14C8,x
					JSR GEN_TILE
					RTS
GEN_TILE			LDA $D8,x
					AND #$0F
					BNE BEAM_R
					LDA $E4,x
					STA $9A
					LDA $14E0,x
					STA $9B
					LDA $D8,x
					STA $98
					LDA $14D4,x
					STA $99
                    REP #$30                ; 
                    LDA.W #$03C6
                    STA $03
                    JSL $2E8DF0
					SEP #$30
					RTS

FIRE				LDA $7FFF7F
					BEQ FIRE_1
					JSR SUB_GFX_FIRE
FIRE_1				LDA $9D
					BNE FIRE_R
					LDA $7FFF7F
					BNE FIRE_2
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSR FLAME_CHECK
					CPY #$00
					BEQ FIRE_R
					LDA #$01
					STA $7FFF7F
					LDA #$17
					STA $1DFC
FIRE_R				RTS
FIRE_2				JSR LIGHT
					LDA $7FFF96
					CMP #$1D
					BNE FIRE_R
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					RTS


FLAME_R				RTS
FLAME				LDA $C2,x
					CMP #$04
					BEQ FLAME_0
					JSR SUB_GFX
					LDA $9D
					BNE FLAME_R
					JSL $01802A
					JSR MARIO_CHECK
					JSR WALL_CHECK
					JSR FLAME_DIR
FLAME_0				LDA $E4,x
					STA $7FFAE4
					LDA $14E0,x
					STA $7FFAE0
					LDA $D8,x
					STA $7FFAD8
					LDA $14D4,x
					STA $7FFAD4
					LDA $C2,x
					STA $7FFAC2
					BNE FLAME_1
					JSR FLAME0
					RTS
FLAME_1				CMP #$01
					BNE FLAME_2
					JSR FLAME1
					RTS
FLAME_2				CMP #$02
					BNE FLAME_3
					JSR FLAME2
					RTS
FLAME_3				CMP #$03
					BNE FLAME_4
					JSR FLAME3
					RTS
FLAME_4				JSR FLAME4
					RTS

FLAME0				REP #$20
					LDA $1462
					CMP.W #$0DE0
					BCC FLAME0_0
					SEP #$20
					LDA $15AC,x
					CMP #$A0
					BCS FLAME0_1
					CMP #$9F
					BEQ FLAME0_2
					CMP #$1F
					BEQ FLAME0_3
					LDA $7FFD76
					STA $76
					LDA $7FFDE0
					STA $13E0
					LDA $7FFDDF
					STA $13DF
					LDA #$02
					STA $18BD
					RTS
FLAME0_0			SEP #$20
					LDA #$FF
					STA $15AC,x
					RTS
FLAME0_1			LDA $76
					STA $7FFD76
					LDA $13E0
					STA $7FFDE0
					LDA $13DF
					STA $7FFDDF
					RTS
FLAME0_2			JSR GEN_SPRITE
					LDA #$04
					STA $1504,y
					LDA #$00
					STA $1602,y
					LDA #$60
					STA $15AC,y
					LDA #$D0
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA #$1E
					STA $1DFB
					STA $7EC100
					;JSR DELETE_ZAKO
					JSR VRAM2
					RTS
FLAME0_3			LDA #$24
					STA $1DFB
					JSR FLAME_MODE
					RTS
					
FLAME1_TBL			dcb $E0,$20
FLAME1				LDA $1588,x
					AND #$04
					BNE FLAME1_2
					LDA $157C,x
					TAY
					LDA FLAME1_TBL,y
					STA $B6,x
					LDA #$20
					STA $15AC,x
					LDA #$04
					STA $1602,x
FLAME1_R			RTS
FLAME1_2			STZ $B6,x
					STZ $1602,x
					LDA $15AC,x
					BNE FLAME1_R
					JSR FLAME_MODE
					RTS
					
					
FLAME2_TBL1			dcb $E4,$1C
FLAME2_TBL2			dcb $FF,$00

FLAME2				JSR SUB_HORZ_POS
					LDA #$05
					STA $1602,x
					LDA $15AC,x
					CMP #$E0
					BEQ FLAME2_G
					CMP #$B0
					BEQ FLAME2_G
					CMP #$80
					BEQ FLAME2_G
					CMP #$50
					BEQ FLAME2_G
					CMP #$08
					BEQ FLAME2_2
					RTS
FLAME2_2			JSR FLAME_MODE
					RTS
FLAME2_G			JSR GEN_SPRITE
					PHY
					LDA $157C,x
					TAY
					LDA FLAME2_TBL1,y
					STA $00
					LDA FLAME2_TBL2,y
					STA $01
					PLY
					LDA #$07
					STA $1504,y
					LDA $157C,x
					STA $157C,y
					LDA $E4,x
					CLC
					ADC $00
					STA $00E4,y
					LDA $14E0,x
					ADC $01
					STA $14E0,y
					LDA $D8,x
					SEC
					SBC #$08
					STA $00D8,y
					LDA $14D4,x
					SBC #$00
					STA $14D4,y
					LDA #$03
					STA $167A,y
					LDA #$91
					STA $1686,y
					RTS
					
FLAME3				LDA #$05
					STA $1602,x
					LDA $15AC,x
					CMP #$E0
					BEQ FLAME3_G
					CMP #$B8
					BEQ FLAME3_G
					CMP #$90
					BEQ FLAME3_G
					CMP #$68
					BEQ FLAME3_G
					CMP #$28
					BEQ FLAME3_2
					RTS
FLAME3_2			JSR FLAME_MODE
					RTS
FLAME3_G			JSR GEN_SPRITE
					LDA #$00
					STA $1570,y
					LDA #$08
					STA $1504,y
					LDA #$17
					STA $1DFC
					LDA $157C,x
					BEQ FLAME3_G_2
					LDA $E4,x
					CLC
					ADC $1570,x
					STA $00E4,y
					LDA $14E0,x
					ADC #$00
					STA $14E0,y
					BRA FLAME3_G_3
FLAME3_G_2			LDA $E4,x
					SEC
					SBC $1570,x
					STA $00E4,y
					LDA $14E0,x
					SBC #$00
					STA $14E0,y
FLAME3_G_3			LDA #$03
					STA $167A,y
					LDA #$91
					STA $1686,y
					LDA $1570,x
					CLC
					ADC #$30
					STA $1570,x
					RTS
					
FLAME_SHOT1_TBL		dcb $D0,$30
FLAME_SHOT1			JSR SUB_GFX_FL1
					LDA $9D
					BNE FLAME_SHOT1_R
					STZ $AA,x
					LDA $157C,x
					TAY
					LDA FLAME_SHOT1_TBL,y
					STA $B6,x
					JSL $018022
					JSL $01A7DC
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA $010B
					CMP #$5D
					BNE FLAME_SHOT1_R
					LDA #$10
					STA $AA,x
					JSL $01801A ;y speed
FLAME_SHOT1_R		RTS

FLAME_SHOT2			JSR SUB_GFX_FL2
					LDA $9D
					BNE FLAME_SHOT2_R
					JSR FLAME_DAMAGE
					INC $1570,x
					LDA $1570,x
					CMP #$20
					BNE FLAME_SHOT2_R
					STZ $14C8,x
FLAME_SHOT2_R		RTS

FLAME_DAMAGE		LDA $1570,x
					STA $02
					CMP #$10
					BCC FLAME_DAMAGE_2
					LDA #$20
					SEC
					SBC $02
					STA $02
FLAME_DAMAGE_2		JSL $01A7DC
					LDA $D8,x
					PHA
					SEC
					SBC $02
					STA $D8,x
					LDA $14D4,x
					PHA
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					LDA $D8,x
					SEC
					SBC $02
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					LDA $D8,x
					SEC
					SBC $02
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					RTS

FLAME_MODE			JSL $01ACF9
					CMP #$55
					BCC FLAME_MODE_1
					CMP #$AA
					BCC FLAME_MODE_2
					LDA #$01
					STA $C2,x
					JSL $01ACF9
					AND #$01
					STA $157C,x
					LDA #$A0
					STA $AA,x
					RTS
FLAME_MODE_1		LDA #$02
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					RTS
FLAME_MODE_2		LDA #$03
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					JSR SUB_HORZ_POS
					LDA #$20
					STA $1570,x
					RTS
					
FLAME_DIR			LDA $E4,x
					STA $00
					LDA $14E0,x
					STA $01
					REP #$20
					LDA $00
					CMP.W #$0DF1
					BCC FLAME_DIR_LE
					CMP.W #$0EC0
					BCS FLAME_DIR_RI
					SEP #$20
FLAME_DIR_R			RTS
FLAME_DIR_LE		SEP #$20
					LDA #$01
					STA $157C,x
					RTS
FLAME_DIR_RI		SEP #$20
					STZ $157C,x
					RTS
					
WOOD_DIR			LDA $E4,x
					STA $00
					LDA $14E0,x
					STA $01
					REP #$20
					LDA $00
					CMP.W #$04F1
					BCC WOOD_DIR_LE
					CMP.W #$05C0
					BCS WOOD_DIR_RI
					SEP #$20
WOOD_DIR_R			RTS
WOOD_DIR_LE			SEP #$20
					LDA #$01
					STA $157C,x
					RTS
WOOD_DIR_RI			SEP #$20
					STZ $157C,x
					RTS

FLASH_DIR			LDA $E4,x
					STA $00
					LDA $14E0,x
					STA $01
					REP #$20
					LDA $00
					CMP.W #$09F1
					BCC WOOD_DIR_LE
					CMP.W #$0AC0
					BCS WOOD_DIR_RI
					SEP #$20
WOOD_DIR_R			RTS
WOOD_DIR_LE			SEP #$20
					LDA #$01
					STA $157C,x
					RTS
WOOD_DIR_RI			SEP #$20
					STZ $157C,x
					RTS

FLAME4				LDA $15AC,x
					CMP #$50
					BEQ FLAME4_2
					RTS
FLAME4_2			STZ $14C8,x
					JSR TELEPORT
					RTS
TELEPORT			JSR GEN_SPRITE
					PHX
					TYX
					LDA #$10
					STA NEW_SPRITE_NUM,x
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					CLC
					ADC #$10
					STA $D8,x
					LDA $97
					ADC #$00
					STA $14D4,x
					LDA #$04
					STA $1504,x
					LDA #$60
					STA $15AC,x
					LDA #$23
					STA $1DF9
					PLX
					RTS
					
WOOD_R				RTS
WOOD				LDA $C2,x
					CMP #$03
					BEQ WOOD_0
					JSR SUB_GFX
					LDA $9D
					BNE WOOD_R
					JSR MARIO_CHECK
					JSR FLAME_CHECK
					JSR WOOD_DIR
WOOD_0				JSL $01802A
					LDA $E4,x
					STA $7FFAE4
					LDA $14E0,x
					STA $7FFAE0
					LDA $D8,x
					STA $7FFAD8
					LDA $14D4,x
					STA $7FFAD4
					LDA $C2,x
					STA $7FFAC2
					BNE WOOD_1
					JSR WOOD0
					RTS
WOOD_1				CMP #$01
					BNE WOOD_2
					JSR WOOD1
					RTS
WOOD_2				CMP #$02
					BNE WOOD_3
					JSR WOOD2
					RTS
WOOD_3				JSR WOOD3
					RTS

					
WOOD0				REP #$20
					LDA $1462
					CMP.W #$04E0
					BCC WOOD0_0
					SEP #$20
					LDA $15AC,x
					CMP #$A0
					BCS WOOD0_1
					CMP #$9F
					BEQ WOOD0_2
					CMP #$1F
					BEQ WOOD0_3
					LDA $7FFD76
					STA $76
					LDA $7FFDE0
					STA $13E0
					LDA $7FFDDF
					STA $13DF
					LDA #$02
					STA $18BD
					RTS
WOOD0_0				SEP #$20
					LDA #$FF
					STA $15AC,x
					RTS
WOOD0_1				LDA $76
					STA $7FFD76
					LDA $13E0
					STA $7FFDE0
					LDA $13DF
					STA $7FFDDF
					RTS
WOOD0_2				JSR GEN_SPRITE
					LDA #$04
					STA $1504,y
					LDA #$00
					STA $1602,y
					LDA #$60
					STA $15AC,y
					LDA #$D0
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA #$1E
					STA $1DFB
					;JSR DELETE_ZAKO
					JSR VRAM3
					RTS
WOOD0_3				INC $C2,x
					LDA #$24
					STA $1DFB
					JSR GEN_SPRITE
					LDA #$0B
					STA $1504,y
					LDA #$87
					STA $1662,y
					LDA #$03
					STA $167A,y
					LDA #$91
					STA $1686,y
					LDA #$FF
					STA $15AC,x
					RTS
					
WOOD1				LDA $15AC,x
					BNE WOOD1_2
					INC $C2,x
					LDA #$FF
					STA $15AC,x
					RTS
WOOD1_2				CMP #$C0
					BEQ WOOD1_G
					CMP #$B0
					BEQ WOOD1_G
					CMP #$A0
					BEQ WOOD1_G
					CMP #$90
					BEQ WOOD1_G
					CMP #$50
					BEQ WOOD1_G2
					RTS
WOOD1_G				JSR GEN_SPRITE
					LDA #$0C
					STA $1504,y
					LDA #$03
					STA $167A,y
					LDA #$91
					STA $1686,y
					RTS
WOOD1_G2			JSR GEN_SPRITE
					LDA #$0C
					STA $1504,y
					LDA #$03
					STA $167A,y
					LDA #$01
					STA $00C2,y
					LDA #$C0
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA #$10
					STA $00E4,y
					LDA #$05
					STA $14E0,y
					LDA #$91
					STA $1686,y
					JSR GEN_SPRITE
					LDA #$0C
					STA $1504,y
					LDA #$03
					STA $167A,y
					LDA #$01
					STA $00C2,y
					LDA #$C0
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA #$50
					STA $00E4,y
					LDA #$05
					STA $14E0,y
					LDA #$91
					STA $1686,y
					JSR GEN_SPRITE
					LDA #$0C
					STA $1504,y
					LDA #$03
					STA $167A,y
					LDA #$01
					STA $00C2,y
					LDA #$C0
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA #$90
					STA $00E4,y
					LDA #$05
					STA $14E0,y
					LDA #$91
					STA $1686,y
					JSR GEN_SPRITE
					LDA #$0C
					STA $1504,y
					LDA #$03
					STA $167A,y
					LDA #$01
					STA $00C2,y
					LDA #$C0
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA #$D0
					STA $00E4,y
					LDA #$05
					STA $14E0,y
					LDA #$91
					STA $1686,y
					RTS
					
WOOD2_TBL			dcb $E8,$18
WOOD2				LDA $15AC,x
					CMP #$C0
					BEQ WOOD2_1
					CMP #$C0
					BCS WOOD2_R
					LDA $1588,x
					AND #$04
					BNE WOOD2_2
					LDA #$40
					STA $15AC,x
					LDA $157C,x
					TAY
					LDA WOOD2_TBL,y
					STA $B6,x
WOOD2_R				RTS
WOOD2_1				LDA #$A0
					STA $AA,x
					LDA #$04
					STA $1602,x
					RTS
WOOD2_2				STZ $1602,x
					STZ $B6,x
					LDA $15AC,x
					BNE WOOD2_R
					JSR SUB_HORZ_POS
					LDA #$01
					STA $C2,x
					STA $7FFAC2
					JSR GEN_SPRITE
					LDA #$0B
					STA $1504,y
					LDA #$87
					STA $1662,y
					LDA #$03
					STA $167A,y
					LDA #$91
					STA $1686,y
					LDA #$FF
					STA $15AC,x
					RTS
WOOD3				LDA $15AC,x
					CMP #$40
					BEQ WOOD3_2
					RTS
WOOD3_2				LDA #$21
					STA $1DFB
					STZ $14C8,x
					LDA #$01
					STA $7FFFA0
					LDA #$03
					STA $7FFFA1
					RTS
					
FLASH				LDA $C2,x
					CMP #$04
					BEQ FLASH_0
					JSR SUB_GFX
					LDA $9D
					BNE FLASH_R
					JSR MARIO_CHECK
					JSR WOOD_CHECK
					JSR FLASH_DIR
FLASH_0				JSR FLASH_COLOR
					JSL $01802A
					LDA $E4,x
					STA $7FFAE4
					LDA $14E0,x
					STA $7FFAE0
					LDA $D8,x
					STA $7FFAD8
					LDA $14D4,x
					STA $7FFAD4
					LDA $C2,x
					STA $7FFAC2
					BNE FLASH_1
					JSR FLASH0
FLASH_R				RTS
FLASH_1				CMP #$01
					BNE FLASH_2
					JSR FLASH1
					RTS
FLASH_2				CMP #$02
					BNE FLASH_3
					JSR FLASH2
					RTS
FLASH_3				CMP #$03
					BNE FLASH_4
					JSR FLASH3
					RTS
FLASH_4				JSR FLASH4
					RTS
					
FLASH_COLOR			REP #$20
					LDA $7FF500
					BEQ FLASH_COLOR_2
					SEC
					SBC #$421
					STA $7FF500
FLASH_COLOR_2		SEP #$20
					LDA #$00
					STA $2121
					LDA $7FF500
					STA $2122
					LDA $7FF501
					STA $2122
					LDA $18BD
					BEQ FLASH_COLOR_R
					REP #$20
					LDA $96
					CMP.W #$0160
					BCS FLASH_COLOR_R
					INC $96
					INC $96
					INC $96
					INC $96
FLASH_COLOR_R		SEP #$20
					RTS

FLASH0				REP #$20
					LDA $1462
					CMP.W #$09E0
					BCC FLASH0_0
					SEP #$20
					LDA $15AC,x
					CMP #$A0
					BCS FLASH0_1
					CMP #$9F
					BEQ FLASH0_2
					CMP #$1F
					BEQ FLASH0_3
					LDA $7FFD76
					STA $76
					LDA $7FFDE0
					STA $13E0
					LDA $7FFDDF
					STA $13DF
					LDA #$02
					STA $18BD
					RTS
FLASH0_0			SEP #$20
					LDA #$FF
					STA $15AC,x
					RTS
FLASH0_1			LDA $76
					STA $7FFD76
					LDA $13E0
					STA $7FFDE0
					LDA $13DF
					STA $7FFDDF
					RTS
FLASH0_2			JSR GEN_SPRITE
					LDA #$04
					STA $1504,y
					LDA #$00
					STA $1602,y
					LDA #$60
					STA $15AC,y
					LDA #$D0
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA #$1E
					STA $1DFB
					JSR DELETE_ZAKO
					JSR VRAM4
					RTS
FLASH0_3			INC $C2,x
					LDA #$24
					STA $1DFB
					LDA #$FF
					STA $15AC,x
					RTS
					
FLAME2_TBL1			dcb $E4,$1C
FLAME2_TBL2			dcb $FF,$00
FLAME2_TBL3			dcb $D0,$30
FLAME2_TBL4			dcb $00,$00,$00,$00,$00,$00,$08,$F8
FLASH1				STZ $B6,x
					LDA #$05
					STA $1602,x
					JSR SUB_HORZ_POS
					LDA $15AC,x
					BEQ FLASH1_2
					CMP #$FE
					BEQ FLASH1_G
					CMP #$E0
					BEQ FLASH1_G
					CMP #$C0
					BEQ FLASH1_G
					CMP #$A0
					BEQ FLASH1_G
					CMP #$80
					BEQ FLASH1_G
					CMP #$60
					BEQ FLASH1_G
					CMP #$40
					BEQ FLASH1_G
					CMP #$20
					BEQ FLASH1_G
					RTS
FLASH1_2			LDA #$FF
					STA $15AC,x
					INC $C2,x
					RTS
FLASH1_G			JSR SPIT
					PHX
					LDA $157C,x
					TAX
					LDA FLAME2_TBL1,x
					CLC
					ADC $171F,y 
					STA $171F,y 
					LDA FLAME2_TBL2,x
					ADC $1733,y
					STA $1733,y
					LDA FLAME2_TBL3,x
					STA $1747,y
					JSL $01ACF9
					AND #$07
					TAX
					LDA FLAME2_TBL4,x
					STA $173D,y
					PLX
					RTS
					
FLASH2				JSR SUB_HORZ_POS
					LDA $15AC,x
					CMP #$D0
					BCS FLASH2_2
					CMP #$CF
					BEQ FLASH2_3
					CMP #$B0
					BEQ FLASH2_4
					RTS
FLASH2_2			LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					STA $1602,x
					RTS
FLASH2_3			LDA #$01
					STA $1DFC
					REP #$20
					LDA.W #$7FFF
					STA $7FF500
					SEP #$20
					LDA $157C,x
					CMP $76
					BEQ FLASH2_R
					LDA #$80
					STA $18BD
FLASH2_R			RTS
FLASH2_4			LDA #$80
					STA $15AC,x
					INC $C2,x
					RTS
FLASH_SPEED			dcb $E0,$20
FLASH3				LDA $15AC,x
					BEQ FLASH3_2
					LDA $157C,x
					TAY
					LDA FLASH_SPEED,y
					STA $B6,x
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					CLC
					ADC #$02
					STA $1602,x
					RTS
FLASH3_2			LDA #$01
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					RTS
FLASH4				LDA $15AC,x
					CMP #$40
					BEQ FLASH4_2
					RTS
FLASH4_2			LDA #$21
					STA $1DFB
					STZ $14C8,x
					LDA #$01
					STA $7FFFA0
					LDA #$04
					STA $7FFFA1
					RTS

LEAF2				JSR SUB_GFX_LE2
					LDA $9D
					BNE LEAF2_R
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSL $01A7DC
					LDA $C2,x
					BNE LEAF2_2
					LDA #$C0
					STA $AA,x
					JSL $01801A
					LDA $14D4,x
					BNE LEAF2_R
					LDA $D8,x
					CMP #$B0
					BCS LEAF2_R
					STZ $14C8,x
LEAF2_R				RTS
LEAF2_2				LDA #$0C
					STA $AA,x
					JSL $01802A
					INC $1570,x
					LDA $1570,x
					CMP #$18
					BCS LEAF2_3
					LDA #$01
					STA $157C,x
					LDA #$E8
					STA $B6,x
					RTS
LEAF2_3				CMP #$30
					BNE LEAF2_4
					STZ $1570,x
LEAF2_4				STZ $157C,x
					LDA #$18
					STA $B6,x
					RTS

LEAF1				JSR SUB_GFX_LE1
					LDA $9D
					BNE LEAF1_R
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSR SUB_LEAF1
					LDA $C2,x
					BEQ LEAF1_1
					JSL $018022 ;x speed
					JSL $01801A ;y speed
					RTS
LEAF1_1				LDA $7FFAE4
					STA $E4,x
					LDA $7FFAE0
					STA $14E0,x
					LDA $7FFAD8
					SEC
					SBC #$0C
					STA $D8,x
					LDA $7FFAD4
					SBC #$00
					STA $14D4,x
					LDA $7FFAC2
					CMP #$02
					BNE LEAF1_R
					INC $C2,x
					LDA $E4,x
					SEC
					SBC $94
					LDA $14E0,x
					SBC $95
					BCS LEAF1_GOL
					LDA $77
					AND #$04
					BEQ LEAF1_2
					LDA #$30
					STA $B6,x
					STZ $AA,x
LEAF1_R				RTS
LEAF1_2				LDA #$20
					STA $B6,x
					LDA #$E0
					STA $AA,x
					RTS
LEAF1_GOL			LDA $77
					AND #$04
					BEQ LEAF1_3
					LDA #$D0
					STA $B6,x
					STZ $AA,x
					RTS
LEAF1_3				LDA #$E0
					STA $B6,x
					LDA #$E0
					STA $AA,x
					RTS

SUB_LEAF1			LDA $E4,x
					PHA
					SEC
					SBC #$18
					STA $E4,x
					LDA $14E0,x
					PHA
					SBC #$00
					STA $14E0,x
					LDA $D8,x
					PHA
					SEC
					SBC #$18
					STA $D8,x
					LDA $14D4,x
					PHA
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS

COLD_R				RTS
COLD				LDA $C2,x
					CMP #$04
					BEQ COLD_0
					JSR SUB_GFX
					LDA $9D
					BNE COLD_R
					JSR MARIO_CHECK
					JSR WALL_3
					JSL $01802A
COLD_0				LDA $E4,x
					STA $7FFAE4
					LDA $14E0,x
					STA $7FFAE0
					LDA $D8,x
					STA $7FFAD8
					LDA $14D4,x
					STA $7FFAD4
					LDA $C2,x
					STA $7FFAC2
					BNE COLD_1
					JSR COLD0
					RTS
COLD_1				CMP #$01
					BNE COLD_2
					JSR COLD1
					RTS
COLD_2				CMP #$02
					BNE COLD_3
					JSR COLD2
					RTS
COLD_3				CMP #$03
					BNE COLD_4
					JSR COLD3
					RTS
COLD_4				JSR COLD4
					RTS

COLD0				REP #$20
					LDA $1462
					CMP.W #$05E0
					BCC COLD0_0
					SEP #$20
					LDA $15AC,x
					CMP #$A0
					BCS COLD0_1
					CMP #$9F
					BEQ COLD0_2
					CMP #$1F
					BEQ COLD0_3
					LDA $7FFD76
					STA $76
					LDA $7FFDE0
					STA $13E0
					LDA $7FFDDF
					STA $13DF
					LDA #$02
					STA $18BD
					RTS
COLD0_0				SEP #$20
					LDA #$FF
					STA $15AC,x
					RTS
COLD0_1				LDA $76
					STA $7FFD76
					LDA $13E0
					STA $7FFDE0
					LDA $13DF
					STA $7FFDDF
					RTS
COLD0_2				JSR GEN_SPRITE
					LDA #$04
					STA $1504,y
					LDA #$03
					STA $1602,y
					LDA #$60
					STA $15AC,y
					LDA #$D0
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA #$1E
					STA $1DFB
					JSR DELETE_ZAKO
					JSR VRAM1
					RTS
COLD0_3				INC $C2,x
					LDA #$24
					STA $1DFB
					LDA #$40
					STA $15AC,x
					RTS
					
					
COLD1_TBL1			dcb $DC,$24
COLD1_TBL2			dcb $FF,$00

COLD1				STZ $B6,x
					LDA $15AC,x
					BEQ COLD1_4
					CMP #$30
					BCS COLD1_1
					CMP #$2F
					BEQ COLD1_2
					CMP #$20
					BEQ COLD1_3
					RTS
COLD1_1				JSR SUB_HORZ_POS
					RTS
COLD1_2				LDA #$05
					STA $1602,x
					RTS
COLD1_4				LDA #$02
					STA $C2,x
					LDA #$60
					STA $15AC,x
					JSL $01ACF9
					CLC
					ADC $94
					AND #$01
					BNE COLD1_R
					INC $C2,x
COLD1_R				RTS
COLD1_3				JSR GEN_SPRITE
					PHY
					LDA $157C,x
					TAY
					LDA COLD1_TBL1,y
					STA $00
					LDA COLD1_TBL2,y
					STA $01
					PLY
					LDA #$06
					STA $1504,y
					LDA #$00
					STA $1570,y
					LDA $157C,x
					STA $157C,y
					LDA $E4,x
					CLC
					ADC $00
					STA $00E4,y
					LDA $14E0,x
					ADC $01
					STA $14E0,y
					LDA #$01
					STA $167A,y
					LDA #$4C
					STA $190F,y
					LDA #$28
					STA $166E,y
					LDA #$07
					STA $1DFC
					RTS
COLD2_TBL			dcb $E0,$20
COLD2				LDA $15AC,x
					CMP #$50
					BCS COLD2_2
					CMP #$4F
					BEQ COLD2_3
					LDA $157C,x
					TAY
					LDA COLD2_TBL,y
					STA $B6,x
					LDA $1588,x
					AND #$04
					BEQ COLD2_R
					LDA #$40
					STA $15AC,x
					LDA #$01
					STA $C2,x
					STZ $1602,x
COLD2_R				RTS
COLD2_2				LDA #$01
					STA $1602,x
					JSR SUB_HORZ_POS
					RTS
COLD2_3				LDA #$B0
					STA $AA,x
					LDA #$04
					STA $1602,x
					RTS
					
COLD3_TBL			dcb $E8,$18
COLD3				LDA $15AC,x
					BEQ COLD3_2
					LDA $157C,x
					TAY
					LDA COLD3_TBL,y
					STA $B6,x
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					INC A
					INC A
					STA $1602,x
					RTS
COLD3_2				LDA #$40
					STA $15AC,x
					LDA #$01
					STA $C2,x
					STZ $1602,x
					RTS
COLD4				LDA $15AC,x
					CMP #$50
					BEQ COLD4_1
					CMP #$38
					BEQ COLD4_2
					RTS
COLD4_1				LDA #$01
					STA $1426
					LDA #$01
					STA $7FFFA1
					RTS
COLD4_2				LDA #$21
					STA $1DFB
					STZ $14C8,x
					LDA #$01
					STA $7FFFA0
					RTS
					
WALL_TBL			dcb $D0,$30
WALL				JSR SUB_GFX_W
					LDA $9D
					BNE WALL_R
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA $14C8,x
					CMP #$08
					BCC WALL_R
					LDA $7FFAC2
					CMP #$04
					BEQ WALL_DEL
					LDA $1528,x
					BNE WALL_DEL
					LDA $14
					AND #$01
					BEQ WALL_1
					INC $1570,x
WALL_1				LDA $1570,x
					CMP #$10
					BCC WALL_R
					LDA $1570,x
					CMP #$80
					BNE WALL_2
WALL_DEL			JSR SUB_SMOKE
					STZ $14C8,x
					RTS
WALL_2				JSR WALL_DAMAGE
					LDA $157C,x
					TAY
					LDA WALL_TBL,y
					STA $B6,x
					JSL $01802A
WALL_3				LDA $E4,x
					STA $00
					LDA $14E0,x
					STA $01
					LDA $010B
					CMP #$5D
					BEQ WALL_4
					REP #$20
					LDA $00
					CMP.W #$05F1
					BCC WALL_LE
					CMP.W #$06C0
					BCS WALL_RI
					SEP #$20
WALL_R				RTS
WALL_4				REP #$20
					LDA $00
					CMP.W #$0208
					BCC WALL_LE
					CMP.W #$02E8
					BCS WALL_RI
					SEP #$20
					RTS
WALL_LE				SEP #$20
					LDA #$01
					STA $157C,x
					RTS
WALL_RI				SEP #$20
					STZ $157C,x
					RTS
					
WALL_DAMAGE			JSL $01A7DC
					LDA $D8,x
					PHA
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					PHA
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					RTS

WALL_CHECK			LDA $E4,x
					STA $00
					LDA $14E0,x
					STA $01
					LDA $D8,x
					STA $02
					LDA $14D4,x
					STA $03
					STX $04
					PHX
					LDX #$00
WALL_CHECK_L0		LDA $14C8,x
					BEQ WALL_CHECK_2
					LDA $9E,x
					CMP #$22
					BNE WALL_CHECK_2
					LDA NEW_SPRITE_NUM,x
					CMP #$13
					BNE WALL_CHECK_2
					LDA $1504,x
					CMP #$01
					BNE WALL_CHECK_2
					LDA $B6,x
					BEQ WALL_CHECK_2
					LDA $E4,x
					SEC
					SBC $00
					STA $0E
					LDA $14E0,x
					SBC $01
					STA $0F
					REP #$20
					LDA $0E
					CMP.W #$0008
					BCC WALL_CHECK_3
					CMP.W #$FFF8
					BCS WALL_CHECK_3
					SEP #$20
					BRA WALL_CHECK_2
WALL_CHECK_L		BRA WALL_CHECK_L0
WALL_CHECK_3		SEP #$20
					LDA $D8,x
					SEC
					SBC $02
					STA $0E
					LDA $14D4,x
					SBC $03
					STA $0F
					REP #$20
					LDA $0E
					CMP.W #$0018
					BCC WALL_CHECK_4
					CMP.W #$FFD0
					BCS WALL_CHECK_4
					SEP #$20
WALL_CHECK_2		BRA WALL_CHECK_20
WALL_CHECK_4		SEP #$20
					PHX
					LDX $04
					LDA $1540,x
					BNE WALL_CHECK_21
					INC $1528,x
					LDA $1528,x
					CMP #$08
					BCS WALL_CHECK_5
					LDA #$C0
					STA $1540,x
					LDA #$28
					STA $1DFC
					JSR GEN_SPRITE
					LDA #$05
					STA $1504,y
					LDA #$C0
					STA $15AC,y
WALL_CHECK_21		PLX
WALL_CHECK_20		INX
					CPX #$0A
					BCC WALL_CHECK_L
					PLX
					RTS
WALL_CHECK_5		PLX
					PLX
					JSR FLAME_DELETE
					LDA #$1E
					STA $1DFB
					JSR TIUN
					LDA #$04
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					RTS
					
FLAME_CHECK			LDY #$00
					LDA $E4,x
					STA $00
					LDA $14E0,x
					STA $01
					LDA $D8,x
					STA $02
					LDA $14D4,x
					STA $03
					STX $04
					PHX
					LDX #$00
FLAME_CHECK_L0		LDA $14C8,x
					BEQ FLAME_CHECK_2
					LDA $9E,x
					CMP #$22
					BNE FLAME_CHECK_2
					LDA NEW_SPRITE_NUM,x
					CMP #$13
					BNE FLAME_CHECK_2
					LDA $1504,x
					CMP #$02
					BNE FLAME_CHECK_2
					LDA $B6,x
					BEQ FLAME_CHECK_2
					LDA $E4,x
					SEC
					SBC $00
					STA $0E
					LDA $14E0,x
					SBC $01
					STA $0F
					REP #$20
					LDA $0E
					CMP.W #$0010
					BCC FLAME_CHECK_3
					CMP.W #$FFF0
					BCS FLAME_CHECK_3
					SEP #$20
					BRA FLAME_CHECK_2
FLAME_CHECK_L		BRA FLAME_CHECK_L0
FLAME_CHECK_3		SEP #$20
					LDA $D8,x
					SEC
					SBC $02
					STA $0E
					LDA $14D4,x
					SBC $03
					STA $0F
					REP #$20
					LDA $0E
					CMP.W #$0020
					BCC FLAME_CHECK_4
					CMP.W #$FFE0
					BCS FLAME_CHECK_4
					SEP #$20
FLAME_CHECK_2		BRA FLAME_CHECK_20
FLAME_CHECK_4		SEP #$20
					STZ $14C8,x
					INY
					PHX
					LDX $04
					LDA EXTRA_BITS,x
					AND #$04
					BNE FLAME_CHECK_21
					LDA $C2,x
					CMP #$02
					BNE FLAME_CHECK_21
					LDA $1540,x
					BNE FLAME_CHECK_21
					INC $1528,x
					LDA $1528,x
					CMP #$03
					BCS FLAME_CHECK_5
					LDA #$C0
					STA $1540,x
					LDA #$28
					STA $1DFC
					JSR GEN_SPRITE
					LDA #$05
					STA $1504,y
					LDA #$C0
					STA $15AC,y
FLAME_CHECK_21		PLX
FLAME_CHECK_20		INX
					CPX #$0A
					BCC FLAME_CHECK_L
					PLX
					RTS
FLAME_CHECK_5		PLX
					PLX
					JSR FLAME_DELETE
					LDA #$1E
					STA $1DFB
					JSR TIUN
					LDA #$03
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					RTS
					
FLAME_DELETE		PHX
					LDX #$00
FLAME_DELETE_L		LDA $9E,x
					CMP #$36
					BNE FLAME_DELETE_2
					LDA NEW_SPRITE_NUM,x
					CMP #$14
					BNE FLAME_DELETE_2
					LDA $1504,x
					CMP #$04
					BCC FLAME_DELETE_2
					STZ $14C8,x
FLAME_DELETE_2		INX
					CPX #$0A
					BCC FLAME_DELETE_L
					PLX
					RTS
					
WOOD_CHECK			LDY #$00
					LDA $E4,x
					STA $00
					LDA $14E0,x
					STA $01
					LDA $D8,x
					STA $02
					LDA $14D4,x
					STA $03
					STX $04
					PHX
					LDX #$00
WOOD_CHECK_L0		LDA $14C8,x
					BEQ WOOD_CHECK_2
					LDA $9E,x
					CMP #$22
					BNE WOOD_CHECK_2
					LDA NEW_SPRITE_NUM,x
					CMP #$13
					BNE WOOD_CHECK_2
					LDA $1504,x
					CMP #$03
					BNE WOOD_CHECK_2
					LDA $E4,x
					SEC
					SBC $00
					STA $0E
					LDA $14E0,x
					SBC $01
					STA $0F
					REP #$20
					LDA $0E
					CMP.W #$0024
					BCC WOOD_CHECK_3
					CMP.W #$FFDC
					BCS WOOD_CHECK_3
					SEP #$20
					BRA WOOD_CHECK_2
WOOD_CHECK_L		BRA WOOD_CHECK_L0
WOOD_CHECK_3		SEP #$20
					LDA $D8,x
					SEC
					SBC $02
					STA $0E
					LDA $14D4,x
					SBC $03
					STA $0F
					REP #$20
					LDA $0E
					CMP.W #$0024
					BCC WOOD_CHECK_4
					CMP.W #$FFCC
					BCS WOOD_CHECK_4
					SEP #$20
WOOD_CHECK_2		BRA WOOD_CHECK_20
WOOD_CHECK_4		SEP #$20
					STZ $14C8,x
					INY
					PHX
					LDX $04
					LDA $1540,x
					BNE WOOD_CHECK_21
					INC $1528,x
					LDA $1528,x
					CMP #$0C
					BCS WOOD_CHECK_5
					LDA #$C0
					STA $1540,x
					LDA #$28
					STA $1DFC
					JSR GEN_SPRITE
					LDA #$05
					STA $1504,y
					LDA #$C0
					STA $15AC,y
WOOD_CHECK_21		PLX
WOOD_CHECK_20		INX
					CPX #$0A
					BCC WOOD_CHECK_L
					PLX
					RTS
WOOD_CHECK_5		PLX
					PLX
					JSR FLAME_DELETE
					LDA #$1E
					STA $1DFB
					JSR TIUN
					LDA #$04
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					RTS

MARIO_CHECK			JSL $01A7DC
					BCS ENE_WINS
					LDA $D8,x
					PHA
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					PHA
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					BCS MARIO_CHECK_2
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
MARIO_CHECK_R		RTS
MARIO_CHECK_2		PLA
					STA $14D4,x
					PLA
					STA $D8,x
					LDA $D8,x
					SEC
					SBC $96
					STA $0F
					LDA $14D4,x
					SBC $97
					BCC ENE_WINS
					LDA $0F
					CMP #$18
					BCC ENE_WINS
					JSL $01AA33
					JSL $01AB99
					LDA $1540,x
					BNE MARIO_CHECK_R
					LDA $1504,x
					BNE MARIO_CHECK_R
					LDA #$C0
					STA $1540,x
					INC $1528,x
					LDA $1528,x
					CMP #$06
					BCS MARIO_CHECK_3
					LDA #$28
					STA $1DFC
					JSR GEN_SPRITE
					LDA #$05
					STA $1504,y
					LDA #$C0
					STA $15AC,y
					RTS
ENE_WINS			LDA $1497
                    BNE MARIO_CHECK_R
                    JSL $00F5B7
					RTS
MARIO_CHECK_3		LDA #$1E
					STA $1DFB
					JSR TIUN
					LDA #$04
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					RTS

DAMAGE_EFE			JSR SUB_GFX_F
					LDA $9D
					BNE DAMAGE_EFE_R
					LDA $7FFAC2
					CMP #$04
					BEQ DAMAGE_EFE_D
					LDA $15AC,x
					BEQ DAMAGE_EFE_D
					LDA $7FFAE4
					STA $E4,x
					LDA $7FFAE0
					STA $14E0,x
					LDA $7FFAD8
					STA $D8,x
					LDA $7FFAD4
					STA $14D4,x
DAMAGE_EFE_R		RTS
DAMAGE_EFE_D		STZ $14C8,x
					RTS

SUB_SMOKE           LDY #$03                ; \ find a free slot to display effect
FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
                    RTS                     ; / return if no slots open
FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    LDA $D8,x
                    STA $17C4,y             ; /
                    LDA #$1B                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $E4,x
                    STA $17C8,y             ; /
                    RTS



SPIT                LDY #$E8
                    LDA $157C,x
                    AND #$01
                    BNE LABEL9
                    LDY #$18
LABEL9              STY $00
                    LDY #$07
LABEL8              LDA $170B,y
                    BEQ LABEL7
                    DEY
                    BPL LABEL8
                    RTS                     
LABEL7              LDA #$02                ; \ projectile is a fireball
                    STA $170B,y             ; /

                    LDA $E4,x               ; \ set x position
                    STA $171F,y             ;  |
                    LDA $14E0,x             ;  |
                    STA $1733,y             ; /
                    
                    LDA $D8,x               ; \ set y position
                    STA $1715,y             ;  |
                    LDA $14D4,x             ;  |
                    STA $1729,y             ; /
LABEL6              RTS


LIGHT				REP #$20
					LDA $7FFF80
					CMP.W #$0004
					BEQ LIGHT_1
					INC A
					STA $7FFF80
LIGHT_1				LDA $7FFF82
					CMP.W #$0008
					BEQ LIGHT_2
					INC A
					STA $7FFF82
LIGHT_2				LDA $7FFF84
					CMP.W #$000C
					BEQ LIGHT_3
					INC A
					STA $7FFF84
LIGHT_3				LDA $7FFF86
					CMP.W #$088A
					BEQ LIGHT_4
					CLC
					ADC.W #$445
					STA $7FFF86
LIGHT_4				LDA $7FFF88
					CMP.W #$000E
					BEQ LIGHT_5
					INC A
					STA $7FFF88
LIGHT_5				LDA $7FFF8A
					CMP.W #$0010
					BEQ LIGHT_6
					INC A
					STA $7FFF8A
LIGHT_6				LDA $7FFF8C
					CMP.W #$0012
					BEQ LIGHT_7
					INC A
					STA $7FFF8C
LIGHT_7				LDA $7FFF8E
					CMP.W #$0014
					BEQ LIGHT_8
					INC A
					STA $7FFF8E
LIGHT_8				LDA $7FFF90
					CMP.W #$1CEE
					BEQ LIGHT_9
					CLC
					ADC.W #$422
					STA $7FFF90
LIGHT_9				LDA $7FFF92
					CMP.W #$0017
					BEQ LIGHT_A
					INC A
					STA $7FFF92
LIGHT_A				LDA $7FFF94
					CMP.W #$0019
					BEQ LIGHT_B
					INC A
					STA $7FFF94
LIGHT_B				LDA $7FFF96
					CMP.W #$001D
					BEQ LIGHT_C
					INC A
					STA $7FFF96
LIGHT_C				LDA $7FFF98
					CMP.W #$3194
					BEQ LIGHT_D
					CLC
					ADC.W #$0C65
					STA $7FFF98
LIGHT_D				LDA $7FFF9A
					CMP.W #$4218
					BEQ LIGHT_E
					CLC
					ADC.W #$0843
					STA $7FFF9A
LIGHT_E				LDA $7FFF9C
					CMP.W #$321C
					BEQ LIGHT_F
					CLC
					ADC.W #$C87
					STA $7FFF9C
LIGHT_F				SEP #$20
					JSR LIGHT2
					RTS

LIGHT2				PHX
					LDX #$00
					LDA #$21
					STA $0F
LIGHT2_L			LDA $0F
					STA $2121
					LDA $7FFF80,x
					STA $2122
					LDA $7FFF81,x
					STA $2122
					INC $0F
					INX
					INX
					LDA $0F
					CMP #$30
					BCC LIGHT2_L
					PLX
					LDA #$34
					STA $2121
					LDA $7FFF88
					STA $2122
					LDA $7FFF89
					STA $2122
					RTS


RETURN67            RTS
TIUN                PHX
					LDX #$00
TIUN_300			LDA #$00
					STA $7FFBB0,x
					INX
					CPX #$20
					BCC TIUN_300
					PLX
					JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA #$3B
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
					LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

					LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
					LDA #$99
					STA $00C2,y
					LDA #$00
					STA $1570,y
					LDA #$2C
					STA $1DFC
					LDA #$01
					STA $7FFEE0
					LDA $7FFE00
					TAY
					LDA #$F0
					STA $15AC,y
                    RTS
					
BARRIER				JSR SUB_GFX_BAR
					LDA $9D
					JSR SUB_BARRIER0
					JSR SUB_BARRIER0
					JSR SUB_BARRIER0
					LDA $D8,x
					CLC
					ADC #$30
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					RTS
					
SUB_BARRIER0		JSR SUB_BARRIER1
					JSR SUB_BARRIER2
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					RTS
					
SUB_BARRIER1		JSL $01A7DC
					BCC SUB_BARRIER1_R
					LDA $E4,x
					SEC
					SBC #$10
					STA $94
					LDA $14E0,x
					SBC #$00
					STA $95
SUB_BARRIER1_R		RTS
SUB_BARRIER2		JSR FLAME_CHECK
					CPY #$00
					BEQ SUB_BARRIER1_R
					STZ $14C8,x
					JSR SUB_SMOKE
					RTS
					
SHADOW				JSR SUB_GFX_S
SHADOW_M			LDA $9D
					BNE SHADOW_R
					LDA $15AC,x
					BEQ SHADOW_2
					LDA #$18
					STA $AA,x
					JSL $01801A
					RTS
SHADOW_2			STZ $14C8,x
SHADOW_R			RTS

DELETE_ZAKO			PHX
					LDX #$00
DELETE_ZAKO_L		LDA $14C8,x
					BEQ DELETE_ZAKO_2
					LDA $9E,x
					CMP #$36
					BNE DELETE_ZAKO_2
					LDA NEW_SPRITE_NUM,x
					CMP #$12
					BNE DELETE_ZAKO_2
					STZ $14C8,x
DELETE_ZAKO_2		INX
					CPX #$0A
					BCC DELETE_ZAKO_L
					PLX
					RTS
					
VRAM1				REP #$20
					LDA.W #$7800
					STA $00
					LDA.W #$AD00
					STA $02
					LDA.W #$00C0
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$7900
					STA $00
					LDA.W #$AF00
					STA $02
					LDA.W #$00C0
					STA $04
					SEP #$20
					JSR VRAM
					
					REP #$20
					LDA.W #$7A00
					STA $00
					LDA.W #$ADC0
					STA $02
					LDA.W #$00C0
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$7B00
					STA $00
					LDA.W #$AFC0
					STA $02
					LDA.W #$00C0
					STA $04
					SEP #$20
					JSR VRAM
					
					REP #$20
					LDA.W #$7C00
					STA $00
					LDA.W #$B600
					STA $02
					LDA.W #$00C0
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$7D00
					STA $00
					LDA.W #$B800
					STA $02
					LDA.W #$00C0
					STA $04
					SEP #$20
					JSR VRAM
					RTS


VRAM2				REP #$20
					LDA.W #$7800
					STA $00
					LDA.W #$B200
					STA $02
					LDA.W #$0040
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$7900
					STA $00
					LDA.W #$B200
					STA $02
					LDA.W #$0040
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$7A00
					STA $00
					LDA.W #$B100
					STA $02
					LDA.W #$0080
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$7B00
					STA $00
					LDA.W #$B300
					STA $02
					LDA.W #$0080
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$7C00
					STA $00
					LDA.W #$B500
					STA $02
					LDA.W #$0080
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$7D00
					STA $00
					LDA.W #$B700
					STA $02
					LDA.W #$0080
					STA $04
					SEP #$20
					JSR VRAM
					LDA #$B1
					STA $2121
					LDA #$FF
					STA $2122
					LDA #$7F
					STA $2122
					LDA #$B2
					STA $2121
					LDA #$00
					STA $2122
					LDA #$00
					STA $2122
					LDA #$B3
					STA $2121
					LDA #$BB
					STA $2122
					LDA #$00
					STA $2122
					LDA #$B4
					STA $2121
					LDA #$7F
					STA $2122
					LDA #$1E
					STA $2122
					LDA #$B5
					STA $2121
					LDA #$7F
					STA $2122
					LDA #$57
					STA $2122
					RTS
					
VRAM3				REP #$20
					LDA.W #$7800
					STA $00
					LDA.W #$B200
					STA $02
					LDA.W #$0040
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$7900
					STA $00
					LDA.W #$B200
					STA $02
					LDA.W #$0040
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$7A00
					STA $00
					LDA.W #$B180
					STA $02
					LDA.W #$0080
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$7B00
					STA $00
					LDA.W #$B380
					STA $02
					LDA.W #$0080
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$7C00
					STA $00
					LDA.W #$B580
					STA $02
					LDA.W #$0080
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$7D00
					STA $00
					LDA.W #$B780
					STA $02
					LDA.W #$0080
					STA $04
					SEP #$20
					JSR VRAM
					RTS
VRAM4				REP #$20
					LDA.W #$7800
					STA $00
					LDA.W #$B6C0
					STA $02
					LDA.W #$0040
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$7900
					STA $00
					LDA.W #$B8C0
					STA $02
					LDA.W #$0040
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$7A00
					STA $00
					LDA.W #$AE80
					STA $02
					LDA.W #$0080
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$7B00
					STA $00
					LDA.W #$B080
					STA $02
					LDA.W #$0080
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$7C00
					STA $00
					LDA.W #$B280
					STA $02
					LDA.W #$0080
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$7D00
					STA $00
					LDA.W #$B480
					STA $02
					LDA.W #$0080
					STA $04
					SEP #$20
					JSR VRAM
					RTS
VRAM				LDA #$80
					STA $2115
					REP #$20
					LDA $00
					STA $2116
					SEP #$20
					LDA #$01 
					STA $4310
					LDA #$18
					STA $4311
					LDA #$7E
					STA $4314
					REP #$20
					LDA $02
					STA $4312
					LDA $04
					STA $4315
					SEP #$20
					LDA #$02
					STA $420B
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP_FIRE		dcb $08,$28,$48
VERT_DISP_FIRE		dcb $F0,$00,$10

SUB_GFX_FIRE		JSR GET_DRAW_INFO
					PHX
					LDX #$02
LOOP_FIRE			LDA $00
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_DISP_FIRE,x
					STA $0301,y
					LDA TILEMAP_FIRE,x
					STA $0302,y
					LDA #$0F
					ORA $64
					STA $0303,y
					INY
                    INY
                    INY
                    INY
                    DEX
                    BPL LOOP_FIRE
					PLX
                    LDY #$02
                    LDA #$02
                    JSL $01B7B3
                    RTS


TILEMAP_F			dcb $EB,$EB,$ED,$ED
HORZ_DISP_F			dcb $F8,$08,$F8,$08
VERT_DISP_F			dcb $F0,$F0,$00,$00
PROPETIES_F			dcb $0A,$4A,$0A,$4A
					
SUB_GFX_F_R			RTS
SUB_GFX_F			LDA $14
					AND #$04
					BNE SUB_GFX_F_R
					JSR GET_DRAW_INFO
					LDA #$40
					TAY
					STA $15EA,x
					PHX
					LDX #$03
LOOP_F				LDA $00
					CLC
					ADC HORZ_DISP_F,x
					STA $0200,y
					LDA $01
					CLC
					ADC VERT_DISP_F,x
					STA $0201,y
					LDA TILEMAP_F,x
					STA $0202,y
					LDA PROPETIES_F,x
					ORA $64
					STA $0203,y
					INY
                    INY
                    INY
                    INY
                    DEX
                    BPL LOOP_F
					PLX
                    LDY #$02
                    LDA #$03
                    JSL $28FCC0 ;# $200p̃OtBbN[`
                    RTS


TILEMAP_W			dcb $20,$40,$60
VERT_DISP_W			dcb $E4,$F4,$04

SUB_GFX_W			JSR GET_DRAW_INFO
					PHX
					LDX #$02
LOOP_W				LDA $00
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_DISP_W,x
					STA $0301,y
					LDA TILEMAP_W,x
					STA $0302,y
					LDA #$0D
					ORA $64
					STA $0303,y
					INY
                    INY
                    INY
                    INY
                    DEX
                    BPL LOOP_W
					PLX
                    LDY #$02
                    LDA #$02
                    JSL $01B7B3
                    RTS
					
TILEMAP_FL1			dcb $62,$42,$62,$42
PROPETIES_FL1		dcb $0D,$0D,$CD,$CD
SUB_GFX_FL1			JSR GET_DRAW_INFO
					PHX
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$03
					TAX
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA TILEMAP_FL1,x
					STA $0302,y
					LDA PROPETIES_FL1,x
					ORA $64
					STA $0303,y
					PLX
					LDY #$02
                    LDA #$00
                    JSL $01B7B3
                    RTS
					
SUB_GFX_FL2			JSR GET_DRAW_INFO
					LDA $1570,x
					STA $02
					CMP #$10
					BCC SUB_GFX_FL2_2
					LDA #$20
					SEC
					SBC $1570,x
					STA $02
SUB_GFX_FL2_2
					PHX
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$03
					TAX
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA TILEMAP_FL1,x
					STA $0302,y
					LDA PROPETIES_FL1,x
					ORA $64
					STA $0303,y
					INY
					INY
					INY
					INY
					LDA $00
					STA $0300,y
					LDA $01
					SEC
					SBC $02
					STA $0301,y
					LDA TILEMAP_FL1,x
					STA $0302,y
					LDA PROPETIES_FL1,x
					ORA $64
					STA $0303,y
					INY
					INY
					INY
					INY
					LDA $00
					STA $0300,y
					LDA $01
					SEC
					SBC $02
					SBC $02
					STA $0301,y
					LDA TILEMAP_FL1,x
					STA $0302,y
					LDA PROPETIES_FL1,x
					ORA $64
					STA $0303,y
					INY
					INY
					INY
					INY
					LDA $00
					STA $0300,y
					LDA $01
					LDA $01
					SEC
					SBC $02
					SBC $02
					SBC $02
					STA $0301,y
					LDA TILEMAP_FL1,x
					STA $0302,y
					LDA PROPETIES_FL1,x
					ORA $64
					STA $0303,y
					INY
					INY
					INY
					INY
					PLX
					LDY #$02
                    LDA #$03
                    JSL $01B7B3
                    RTS
					
VERT_DISP_BAR		dcb $DF,$EF,$FF
SUB_GFX_BAR			JSR GET_DRAW_INFO
					PHX
					LDX #$02
LOOP_BAR			LDA $00
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_DISP_BAR,x
					STA $0301,y
					LDA #$40
					STA $0302,y
					LDA #$0D
					ORA $64
					STA $0303,y
					INY
                    INY
                    INY
                    INY
                    DEX
                    BPL LOOP_BAR
					PLX
                    LDY #$02
                    LDA #$02
                    JSL $01B7B3
                    RTS

TILEMAP_S			dcb $A0,$A2,$C0,$C2,$80,$E2,$E2,$E2,$E2
					dcb $80,$82,$84,$A0,$A2,$A4,$C0,$C2,$C4
HORZ_DISP_S			dcb $F8,$08,$F8,$08,$00,$00,$00,$00,$00
					dcb $F0,$00,$10,$F0,$00,$10,$F0,$00,$10
VERT_DISP_S			dcb $F0,$F0,$00,$00,$E0,$00,$00,$00,$00
					dcb $E0,$E0,$E0,$F0,$F0,$F0,$00,$00,$00

SUB_GFX_S			JSR GET_DRAW_INFO
					LDA #$78
					TAY
					STA $15EA,x
					STZ $03
					LDA $1602,x
					CMP #$03
					BNE SUB_GFX_S_2
					LDA #$09
					STA $03
SUB_GFX_S_2			PHX
					LDX #$08
LOOP_S				PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA $00
					CLC
					ADC HORZ_DISP_S,x
					STA $0200,y
					LDA $01
					CLC
					ADC VERT_DISP_S,x
					STA $0201,y
					LDA TILEMAP_S,x
					STA $0202,y
					LDA #$07
					ORA $64
					STA $0203,y
					PLX
					INY
                    INY
                    INY
                    INY
                    DEX
                    BPL LOOP_S
					PLX
                    LDY #$02
                    LDA #$08
                    JSL $28FCC0 ;# $200p̃OtBbN[`
                    RTS
					
HORZ_DISP_LE1       dcb $E0,$00,$20,$00,$E4,$0C,$1C,$F4
                    dcb $EB,$15,$15,$EB,$F4,$1C,$0C,$E4
VERT_DISP_LE1       dcb $00,$E0,$00,$20,$F4,$E4,$0C,$1C
                    dcb $EB,$EB,$15,$15,$E4,$F4,$1C,$0C

SUB_GFX_LE1			JSR GET_DRAW_INFO
					LDA $14
					LSR A
					LSR A
					AND #$03
					ASL A
					ASL A
					STA $03
					PHX
					LDX #$03
LOOP_LE1			PHX
                    TXA
                    CLC
                    ADC $03
                    TAX
                    LDA $00
                    CLC
                    ADC HORZ_DISP_LE1,x
                    STA $0300,y
                    LDA $01
                    CLC
                    ADC VERT_DISP_LE1,x
                    STA $0301,y
					PLX
                    LDA #$44
                    STA $0302,y
                    LDA #$0D
                    ORA $64
                    STA $0303,y
                    INY
                    INY
                    INY
                    INY
                    DEX
                    BPL LOOP_LE1
                    PLX
                    LDY #$02
                    LDA #$03
                    JSL $01B7B3
                    RTS

SUB_GFX_LE2			JSR GET_DRAW_INFO
					LDA $00
                    STA $0300,y
                    LDA $01
                    STA $0301,y
                    LDA #$44
                    STA $0302,y
                    LDA #$0D
                    ORA $64
                    STA $0303,y
					LDA $157C,x
					BEQ SUB_GFX_LE2_2
					LDA #$4D
					ORA $64
					STA $0303,y
SUB_GFX_LE2_2		LDY #$02
                    LDA #$00
                    JSL $01B7B3
                    RTS
					
SUB_GFX_BM			JSR GET_DRAW_INFO
					LDA $00
                    STA $0300,y
                    LDA $01
                    STA $0301,y
                    LDA #$04
                    STA $0302,y
                    LDA #$0F
                    ORA $64
                    STA $0303,y
					LDY #$02
                    LDA #$00
                    JSL $01B7B3
                    RTS


TILEMAP             dcb $80,$82,$A0,$A2,$C0,$C2;#
					dcb $80,$82,$A0,$A2,$E0,$E2;#Ⴊ
					dcb $80,$82,$A0,$A2,$E4,$E6;#1
					dcb $84,$86,$A4,$A6,$C4,$C6;#2
					dcb $88,$8A,$A8,$AA,$C8,$CA;#Wv
HORZ_DISP			dcb $F8,$08,$F8,$08,$F8,$08
					dcb $08,$F8,$08,$F8,$08,$F8
VERT_DISP			dcb $E7,$E7,$F7,$F7,$07,$07
					dcb $E9,$E9,$F9,$F9,$09,$09
					dcb $E8,$E8,$F8,$F8,$08,$08
					dcb $E8,$E8,$F8,$F8,$08,$08
					dcb $E8,$E8,$F8,$F8,$08,$08
PROPETIES			dcb $0A,$0A,$0A,$0A,$0A,$0A
					dcb $4A,$4A,$4A,$4A,$4A,$4A

TILEMAP2            dcb $AC,$AE,$CC,$CE,$8C,$8E;#
HORZ_DISP2			dcb $F0,$00,$F0,$00,$E0,$F8
					dcb $10,$00,$10,$00,$20,$08
VERT_DISP2			dcb $F0,$F0,$00,$00,$F8,$E0
PROPETIES2			dcb $0A,$0A,$0A,$0A,$0A,$0A
					dcb $4A,$4A,$4A,$4A,$4A,$4A

SUB_GFX             JSR GET_DRAW_INFO
					LDA #$58
					TAY
					STA $15EA,x
					LDA $157C,x
					ASL A
					STA $02
					ASL A
					CLC
					ADC $02
					STA $02
					LDA $1602,x
					CMP #$05
					BEQ SUB_GFX2
					LDA $1602,x
					ASL A
					STA $03
					ASL A
					CLC
					ADC $03
					STA $03
					PHX
					LDX #$05
LOOP_START          PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA $01
					CLC
					ADC VERT_DISP,x
					STA $0201,y
					LDA TILEMAP,x
					STA $0202,y
					PLX
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $00
					CLC
					ADC HORZ_DISP,x
					STA $0200,y
					LDA PROPETIES,x
					ORA $64
					STA $0203,y
					PLX
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$05
                    JSL $28FCC0 ;# $200p̃OtBbN[`
                    RTS                     ; return


SUB_GFX2            PHX
					LDX #$05
LOOP_START2         LDA $01
					CLC
					ADC VERT_DISP2,x
					STA $0201,y
					LDA TILEMAP2,x
					STA $0202,y
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $00
					CLC
					ADC HORZ_DISP2,x
					STA $0200,y
					LDA PROPETIES2,x
					ORA $64
					STA $0203,y
					PLX

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START2          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$05
                    JSL $28FCC0 ;# $200p̃OtBbN[`
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817        

SUB_HORZ_POS        STZ $157C,x                
                    LDA $94                
                    SEC                     
                    SBC $E4,x               
                    STA $0E                 
                    LDA $95                
                    SBC $14E0,x             
                    BCC LABEL16             
                    INC $157C,x
LABEL16             RTS                     


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generate routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN68            RTS     
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX

                    LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

                    LDA $D8,x
                    STA $00D8,y             ;  |
					LDA $14D4,x
                    STA $14D4,y             ; /

                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX                     ; / 
                    
RETURN67            RTS                     ; return


