;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Dragon
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"
                    PHY
                    JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
                    PLY
					LDA EXTRA_BITS,x
					AND #$04
					BNE INIT_2
					LDA $E4,x
					AND #$10
					BEQ INI_B
					LDA #$09 ;ԐF
					STA $1602,x
					LDA #$30
					STA $15AC,x
					RTL
INI_B				LDA #$07 ;F
					STA $1602,x
					LDA #$50
					STA $15AC,x
INIT_E              RTL
INIT_2				LDA $E4,x
					AND #$10
					BEQ INI_Y
					LDA #$0B ;ΐF
					STA $1602,x
					RTL
INI_Y				LDA #$05 ;F
					STA $1602,x
					LDA #$40
					STA $15AC,x
INIT_E              RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

X_SPEED             dcb $10,$F0


RETURN              RTS
CODE_START          JSR SUB_GFX
					LDA $14C8,x             ; \ 
					BEQ RETURN
                    CMP #$02                ;  | if status != 8, return
                    BEQ RETURN
					LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
                    JSL $27FAF4 ;SUB_OFF_SCREEN_X0
                    JSL $018032             ; interact with other sprites
					JSL $01A7DC				 ; check for mario/sprite contact
					
					LDA $18BD
					BEQ MAIN1
					LDA $1497
					BEQ MAIN0
					STZ $18BD
					BRA MAIN1
MAIN0				LDA $1602,x
					CMP #$07
					BNE MAIN1
					LDA #$89
                    STA $0D82
MAIN1				LDA $1602,x
					CMP #$0B
					BEQ MAIN2_G
					LDA $15AC,x
					CMP #$20
					BCC MAIN2
					
					LDY $157C,x             ; \ set x speed based on direction
                    LDA X_SPEED,y           ;  |
                    STA $B6,x               ; /
					JSL $01802A             ; update position based on speed values
					LDA $1588,x             ; \ if sprite is in contact with an object...
                    AND #$03                ; |
                    BEQ AIR_CHECK
                    LDA $157C,x             ; | flip the direction status
                    EOR #$01                ; |
                    STA $157C,x             ; /
					RTS
AIR_CHECK			LDA $1588,x
					AND #$04
					BNE RETURN2
					LDA $157C,x             ; | flip the direction status
                    EOR #$01                ; |
                    STA $157C,x 
RETURN2				RTS

MAIN2				LDA $1602,x
					CMP #$05
					BEQ MAIN2_Y
					CMP #$07
					BEQ MAIN2_B
					CMP #$09
					BEQ MAIN2_R
					RTS
MAIN2_Y				JSR SUB_Y
					RTS
MAIN2_B				JSR SUB_B
					RTS
MAIN2_R				JSR SUB_R
					RTS
MAIN2_G				LDA $1540,x
					BNE AIR_G
					LDA #$19
					STA $1656,x
					LDY $157C,x             ; \ set x speed based on direction
                    LDA X_SPEED,y           ;  |
                    STA $B6,x               ; /
					JSL $01802A             ; update position based on speed values
					JSR SUB_G
					LDA $1588,x             ; \ if sprite is in contact with an object...
                    AND #$03                ; |
                    BEQ AIR_CHECK_G
                    LDA $157C,x             ; | flip the direction status
                    EOR #$01                ; |
                    STA $157C,x             ; /
					RTS
AIR_CHECK_G			LDA $1588,x
					AND #$04
					BNE RETURN_G
					LDA $157C,x             ; | flip the direction status
                    EOR #$01                ; |
                    STA $157C,x 
RETURN_G			RTS
AIR_G				LDA #$10
					STA $1558,x
					LDA #$09
					STA $1656,x
					STZ $B6,x
					JSL $01802A
					LDA $1588,x
					AND #$04
					BEQ RETURN_G
					STZ $1540,x
					RTS
					

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; attack
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X_SPEED2            dcb $30,$D0
X_SPEED3			dcb $20,$E0

SUB_Y				PHY
                    JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
                    PLY
					STZ $B6,x
					LDA $1558,x
					BEQ SUB_Y2
					CMP #$01
					BEQ SUB_Y3
					LDA $1558,x             ; \ if time until throw < TIME_TO_SHOW
                    AND #$03
                    BNE RETURN38            ;  | 
                    JSR SUB_HAMMER_THROW    ; /
RETURN38            RTS
SUB_Y2				LDA #$30
					STA $1558,x
					RTS
SUB_Y3				STZ $1558,x
					LDA #$90
					STA $15AC,x
					RTS

SUB_B				PHY
                    JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
                    PLY
					STZ $B6,x
					LDA $15AC,x
					BEQ SUB_B_2
					CMP #$18
					BEQ SUB_B_GEN_MODE
					RTS
SUB_B_2				LDA #$A0
					STA $15AC,x
					RTS
SUB_B_GEN_MODE		LDA #$5A
					STA $1504,x
					JSR GEN_SPRITE
					PHX
					LDA $157C,x
					TAX
					LDA X_SPEED2,x
					STA $1504,y
					LDA #$00
					STA $151C,y
					LDA #$01
					STA $1528,y
					LDA #$07
					STA $1602,y
					PLX
					JSR GEN_SPRITE
					PHX
					LDA $157C,x
					TAX
					LDA X_SPEED3,x
					STA $1504,y
					LDA #$F0
					STA $151C,y
					LDA #$01
					STA $1528,y
					LDA #$07
					STA $1602,y
					PLX
					RTS
					
SUB_R				PHY
                    JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
                    PLY
					STZ $B6,x
					LDA $15AC,x
					BEQ SUB_R_2
					CMP #$18
					BEQ SUB_R_GEN_MODE
					RTS
SUB_R_2				LDA #$80
					STA $15AC,x
					RTS
SUB_R_GEN_MODE		LDA #$56
					STA $1504,x
					JSR GEN_SPRITE
					LDA #$03
					STA $00C2,y
					LDA #$CA
					STA $1570,y
					JSR SPEED_DEC
					LDA #$17
					STA $1DFC
					RTS
					
SUB_G				LDA $15AC,x
					BNE SUB_G2
					LDA #$40
					STA $15AC,x
					PHY
                    JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
                    PLY
SUB_G2				LDA $1558,x
					BNE SUB_G_R
					LDA $157C,x
					BEQ FACE_RIGHT_G
					LDA $E4,x
					SEC
					SBC $94
					STA $0F
					LDA $14E0,x
					SBC $95
					BNE SUB_G_R
					LDA $0F
					CMP #$20
					BCC JUMP_G
SUB_G_R				RTS
FACE_RIGHT_G		LDA $94
					SEC
					SBC $E4,x
					STA $0F
					LDA $95
					SBC $14E0,x
					BNE SUB_G_R
					LDA $0F
					CMP #$20
					BCC JUMP_G
					RTS
JUMP_G				LDA #$A0
					STA $AA,x
					LDA #$FF
					STA $1540,x
					STZ $B6,x
					RTS



SUB_G_GEN_MODE		LDA NEW_SPRITE_NUM,x
					STA $1504,x
					JSR GEN_SPRITE
					RTS
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; hammer routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

X_OFFSET            dcb $0A,$F6
X_OFFSET2           dcb $00,$FF

                    Y_SPEED = $C0

SUB_HAMMER_THROW    LDA $15A0,x           
                    ORA $186C,x             
                    ORA $15D0,x
                    BNE LABEL6

                    LDY #$E6                
                    LDA $157C,x             
                    BNE LABEL9              
                    LDY #$1A                
LABEL9              STY $00                

                    LDY #$07               
LABEL8              LDA $170B,y             
                    BEQ LABEL7              
                    DEY                    
                    BPL LABEL8              ;
                    RTS                     ;
LABEL7              LDA #$04                ;
                    STA $170B,y             
                    
                    PHY
                    LDA $157C,x
                    TAY
                    LDA $E4,x               
                    CLC
                    ADC X_OFFSET,y
                    PLY
                    STA $171F,y            
                    PHY
                    LDA $157C,x
                    TAY
                    LDA $14E0,x             ;  |
                    ADC X_OFFSET2,y
                    PLY
                    STA $1733,y             
                    
                    LDA $D8,x               
                    CLC
                    ADC #$10
                    STA $1715,y             
                    LDA $14D4,x            
                    ADC #$00
                    STA $1729,y             
                    LDA #Y_SPEED           
                    STA $173D,y             
                    LDA $00                 
                    STA $1747,y             
                    BRA LABEL10             
LABEL6              RTS                    
LABEL10             LDA $1715,y            
                    ADC #$F7               
                    STA $1715,y             
                    BCC LABEL11             
                    LDA $1729,y             
                    ADC #$FF                
                    STA $1729,y             
LABEL11             RTS                    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

HORIZ_DISP          dcb $F8,$08,$F8,$08,$08,$F8,$08,$F8
VERT_DISP           dcb $F0,$F0,$00,$00
TILEMAP             dcb $80,$82,$A0,$A2,$84,$86,$A4,$A6,$80,$82,$A0,$A2
					dcb $88,$8A,$A8,$AA,$8C,$8E,$AC,$AE,$A6,$A4,$86,$84,$AE,$AC,$8E,$8C
PROPERTIES          dcb $00,$40


SUB_GFX             JSR GET_DRAW_INFO
					
					LDA $1540,x
					BNE GFX2
					LDA $B6,x
					BNE GFX2
					JSR SUB_GFX2
					RTS 
GFX2				LDA $157C,x
					STA $02
					PHX
					LDX $02
					LDA PROPERTIES,x
					PLX
					ORA $1602,x
					STA $0F
					LDA $02
					ASL A
					ASL A
					STA $02
					
					LDA $14
					LSR A
					LSR A
					LSR A
					;LSR A
					AND #$03
					ASL A
					ASL A
					STA $03
					LDA $14C8,x
					CMP #$08
					BNE GFX_MAIN
					LDA $1540,x
					BEQ GFX_MAIN
					LDA $AA,x
					CMP #$80
					BCC GFX_DOWN
					CMP #$E8
					BCS GFX_DOWN_TOP
					LDA #$10
					STA $03
					BRA GFX_MAIN
GFX_DOWN_TOP		LDA #$14
					STA $03
					LDA $0F
					EOR #$C0
					STA $0F
					BRA GFX_MAIN
GFX_DOWN			LDA $AA,x
					CMP #$18
					BCC GFX_DOWN_TOP
					LDA #$18
					STA $03
					LDA $0F
					EOR #$C0
					STA $0F
GFX_MAIN            LDA $14C8,x
					CMP #$08
					BEQ GFX_MAIN2
					STZ $03
GFX_MAIN2			PHX
                    LDX #$03                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START          PHX                     ; push, current tile

					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP,x         ; |
                    STA $0301,y             ; /
					
					PHX
					TXA
					CLC
					ADC $02
					TAX
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP,x        ; |
                    STA $0300,y             ; /
                    PLX
                    
					PHX
					TXA
					CLC
					ADC $03
					TAX
                    LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /
					PLX

					LDA $0F
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties


                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

HORIZ_DISP2          dcb $F8,$08,$F8,$08,$18,$08,$F8,$08,$F8,$E8
VERT_DISP2           dcb $F0,$F0,$00,$00,$F8
TILEMAP2             dcb $C0,$C2,$E0,$E2,$E4
PROPERTIES2          dcb $00,$40


SUB_GFX2            JSR GET_DRAW_INFO
					LDA $157C,x
					STA $02
					LDA $1602,x
					STA $0F
                    PHX
                    LDX #$04                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START2          PHX                     ; push, current tile

					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP2,x         ; |
                    STA $0301,y             ; /
					
					LDA TILEMAP2,x           ; \ store tile
                    STA $0302,y             ; /

					
					PHX
					TXA
					CLC
					ADC $02
					ADC $02
					ADC $02
					ADC $02
					ADC $02
					TAX
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP2,x        ; |
                    STA $0300,y             ; /

					LDX $02
					LDA PROPERTIES2,x
					ORA $0F
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
					PLX

                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START2

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$04                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN67            RTS
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA $1504,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
					LDA $157C,x
					BNE GEN_LEFT
					LDA $E4,x
					CLC
					ADC #$10
                    STA $00E4,y
                    LDA $14E0,x
					ADC #$00
                    STA $14E0,y             ; /
					BRA GEN_2
GEN_LEFT			LDA $E4,x
					SEC
					SBC #$10
                    STA $00E4,y
                    LDA $14E0,x
					SBC #$00
                    STA $14E0,y 
GEN_2
					LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817                ; Y = 1 if contact

SUB_GET_DIR         LDY #$00                
                    LDA $94                
                    SEC                     
                    SBC $E4,x               
                    STA $0F                 
                    LDA $95                 
                    SBC $14E0,x             
                    BPL LABEL16             
                    INY                     
LABEL16             RTS                     





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; generate sprite
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Y_FIRE              dcb $18,$18,$00,$00,$E8,$E8,$F4,$F4
X_FIRE              dcb $18,$E8,$20,$E0


SPEED_DEC			PHY
					JSR SUB_GET_X_DIFF      ; face mario horizontally
                    JSR SUB_GET_Y_DIFF      ; face mario vertically
					PLY
					PHX                     ; \ set y speed of fire ball
                    LDA $151C,x             ;  |
                    ASL A                   ;  |
                    ASL A                   ;  |
                    ORA $1594,x
                    TAX                     ;  |
                    LDA Y_FIRE,x            ;  |
                    STA $00AA,y             ;  |
                    PLX                     ; /     
                    
                    PHX                     ; \  set x speed of fire ball
                    LDA $1594,x
                    TAX                     ;  |
                    LDA X_FIRE,x            ;  |
                    STA $00B6,y             ; /
                    PLX 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; difference in y position
; sets 151C if mario is above plant
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_GET_Y_DIFF      LDY #$00
                    LDA $D3 
                    PHA
                    CLC 
                    ADC #$10
                    STA $D3 
                    LDA $D4
                    PHA
                    ADC #$00 
                    STA $D4
                    LDA $D3
                    SEC
                    SBC $D8,x 
                    STA $0E 
                    LDA $D4
                    SBC $14D4,x 
                    BPL LABEL14
                    INY
LABEL14             TYA                     ;  | 
                    STA $151C,x 
                    PLA
                    STA $D4
                    PLA
                    STA $D3
                    RTS                    


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; difference in x position
; sets 157C to 00 through 03 depending on the relative position of mario to the plant
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   

SUB_GET_X_DIFF      LDY #$00
                    LDA $D1
                    SEC 
                    SBC $E4,x
                    STA $0F
                    LDA $D2 
                    SBC $14E0,x
                    BPL TO_RIGHT 
TO_LEFT             INY
                    LDA $0F
                    CMP #$B0
                    BCS SET_VAL
                    INY
                    INY                 
                    BRA SET_VAL
TO_RIGHT            LDA $0F
                    CMP #$50
                    BCC SET_VAL
                    INY
                    INY 
SET_VAL             TYA
                    STA $1594,x
                    RTS                    
