;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; #K`|R
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    EXTRA_BITS = $7FAB10
					NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA $010B
					CMP #$24
					BEQ BALL_INIT
					CMP #$29
					BEQ SWITCH_INIT
					CMP #$2A
					BEQ SPECIAL_INIT
					CMP #$75
					BEQ FRAME_GEN_INIT
					CMP #$60
					BEQ SPECIAL_INIT
                    RTL
BALL_INIT			LDA $14E0,x
					CMP #$05
					BCS FRAME_GEN_INIT
					LDA #$01
					STA $1504,x
					RTL
FRAME_GEN_INIT		LDA #$03
					STA $1504,x
					JSL $01ACF9
					AND #$3F
					CLC
					ADC #$80
					STA $15AC,x
					LDA $E4,x
					ORA #$08
					STA $E4,x
					RTL
SWITCH_INIT			LDA #$05
					STA $1504,x
					LDA #$BB
					STA $167A,x
					LDA #$00
					STA $15AC,x
					LDA #$02
					STA $1540,x
					RTL
SPECIAL_INIT
					LDA #$02
					STA $1504,x
					LDA #$09
					STA $14C8,x
					LDA #$00
					STA $15AC,x
					TXA
					STA $7FFDCB
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                    
START_HB_CODE       LDA $1504,x
					BNE MAIN1
					;JSR MAIN
					RTS
MAIN1				CMP #$01
					BNE MAIN2
					JSR BALL_GEN
					RTS
MAIN2				CMP #$02
					BNE MAIN3
					JSR BALL_MAIN
					RTS
MAIN3				CMP #$03
					BNE MAIN4
					JSR FRAME_GEN
					RTS
MAIN4				CMP #$04
					BNE MAIN5
					JSR FRAME_MAIN
					RTS
MAIN5				CMP #$05
					BNE MAIN6
					JSR SWITCH_MAIN
					RTS
MAIN6				CMP #$06
					BNE MAIN7
					JSR BALL2_MAIN
					RTS
MAIN7				CMP #$07
					BNE MAIN8
					JSR TILE1_MAIN
					RTS
MAIN8				CMP #$08
					BNE MAIN9
					JSR TILE2_MAIN
					RTS
MAIN9				RTS
					
BALL_GEN			LDA $9D
					BNE NOT_BALL_GEN
					JSL $27FAF4;SUB_OFF_SCREEN_X0
					LDY #$00
					PHX
					LDX #$00
BALLGEN_LOOP1		LDA $9E,x
					CMP #$80
					BNE BALLGEN_LOOP2
					LDA $14C8,x
					CMP #$08
					BCC BALLGEN_LOOP2
					LDA $1504,x
					CMP #$02
					BNE BALLGEN_LOOP2
					LDY #$01
BALLGEN_LOOP2		INX
					CPX #$0A
					BCC BALLGEN_LOOP1
					PLX
					CPY #$01
					BEQ NOT_BALL_GEN
					JSR GEN_SPRITE
					LDA #$02
					STA $1504,y
					LDA #$09
					STA $14C8,y
					LDA #$00
					STA $15AC,y
NOT_BALL_GEN		RTS


TILE1_MAIN			JSR SUB_GFX_TILE
					RTS
					
TILE2_MAIN			JSR SUB_GFX_TILE
					LDA $9D
					BNE TILE_MAIN_R
					LDA $14C8,x
					CMP #$0B
					BEQ TILE_MAIN_R
					JSL $01802A
					LDA #$09
					STA $14C8,x
					LDA #$0C
					STA $1662,x
TILE_MAIN_R			RTS

BALL_MAIN			JSR SUB_GFX_BL
					LDA $9D                 ; \ if sprites locked, return
                    BNE BALL_MAIN_R
					LDA $010B
					CMP #$2A
					BNE BALL_MAIN_2
					JSR SPECIAL_SUB
					BRA BALL_MAIN_1
BALL_MAIN_2			LDA $010B
					CMP #$60
					BNE BALL_MAIN_11
					JSR BOSS_SUB
					BRA BALL_MAIN_1
BALL_MAIN_11		JSL $27FAF4 ;SUB_OFF_SCREEN_X0
BALL_MAIN_1			LDA #$0C
					STA $1662,x
					JSR DELTE_CHECK
					LDA $14C8,x
					CMP #$0B
					BEQ BALL_HAND
					CMP #$08
					BCC BALL_MAIN_R
					JSR STAR_DUST
					;JSL $018032
					LDA $15AC,x
					BEQ BALL_MAIN_R
					CMP #$FE
					BEQ BALL_LEAVING
					JSR BALL_SPEED
BALL_MAIN_R         RTS
BALL_HAND			LDA #$FF
					STA $15AC,x
					JSR STAR_DUST
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSR DELTE_CHECK
					RTS
BALL_LEAVING		JSR CONT_CHECK
					RTS
					
BALL2_SPEED1		dcb $40,$C0,$00,$00
BALL2_SPEED2		dcb $00,$00,$40,$C0
BALL2_MAIN			JSR SUB_GFX_BL2
					LDA $9D                 ; \ if sprites locked, return
                    BNE BALL2_MAIN_R
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA $15AC,x
					BEQ BALL2_DEL
					LDA $14D4,x
					CMP #$01
					BEQ BALL2_2
					LDA $D8,x
					CMP #$B0
					BCC BALL2_DEL
BALL2_2				LDA #$09
					STA $14C8,x
					JSR STAR_DUST
					LDA $1602,x
					TAY
					LDA BALL2_SPEED1,y
					STA $B6,x
					LDA BALL2_SPEED2,y
					STA $AA,x
					JSL $018022 ;x speed
					JSL $01801A ;y speed
					JSR TILE_CHECK
BALL2_MAIN_R		RTS
BALL2_DEL			STZ $14C8,x
					RTS

SWITCH_MAIN			LDA $15AC,x
					BNE SWITCH_2
					JSR SUB_GFX_SW
					LDA $9D
					BNE SWITCH_R
					LDA $1540,x
					CMP #$01
					BEQ SWITCH_GEN
					JSL $01A7DC
					BCC SWITCH_R
					LDA #$40
					STA $15AC,x
					LDA #$10
					STA $1DFC
					JSR SUB_SMOKE
					LDY #$00
					PHX
					LDX #$00
SWITCH_LP			LDA $14C8,x
					CMP #$08
					BCC SWITCH_LP1
					LDA $1504,x
					CMP #$06
					BNE SWITCH_LP1
					LDY #$01
SWITCH_LP1			INX
					CPX #$0A
					BCC SWITCH_LP
					PLX
					CPY #$01
					BEQ SWITCH_R
					JSR GEN_SPRITE
					LDA #$06
					STA $1504,y
					LDA #$BB
					STA $167A,y
					LDA #$3D
					STA $1686,y
					LDA #$FF
					STA $15AC,y
					LDA #$80
					STA $00E4,y
					LDA #$50
					STA $00D8,y
					LDA #$00
					STA $1602,y
SWITCH_R			RTS
SWITCH_2			JSR GET_DRAW_INFO
					JSL $01A7DC
					BCC SWITCH_R
					LDA #$40
					STA $15AC,x
SWITCH_R			RTS
SWITCH_GEN			JSR GEN_SPRITE
					LDA #$07
					STA $1504,y
					LDA #$00
					STA $1602,y
					LDA #$BB
					STA $167A,y
					LDA #$B0
					STA $00E4,y
					LDA #$50
					STA $00D8,y
					JSR GEN_SPRITE
					LDA #$07
					STA $1504,y
					LDA #$01
					STA $1602,y
					LDA #$BB
					STA $167A,y
					LDA #$D0
					STA $00E4,y
					LDA #$80
					STA $00D8,y
					JSR GEN_SPRITE
					LDA #$07
					STA $1504,y
					LDA #$00
					STA $1602,y
					LDA #$D0
					STA $00E4,y
					LDA #$20
					STA $00D8,y
					LDA #$BB
					STA $167A,y
					JSR GEN_SPRITE
					LDA #$08
					STA $1504,y
					LDA #$01
					STA $1602,y
					LDA #$B0
					STA $00E4,y
					LDA #$80
					STA $00D8,y
					JSR GEN_SPRITE
					LDA #$08
					STA $1504,y
					LDA #$02
					STA $1602,y
					LDA #$20
					STA $00E4,y
					LDA #$50
					STA $00D8,y
					JSR GEN_SPRITE
					LDA #$07
					STA $1504,y
					LDA #$03
					STA $1602,y
					LDA #$20
					STA $00E4,y
					LDA #$20
					STA $00D8,y
					LDA #$BB
					STA $167A,y
					JSR GEN_SPRITE
					LDA #$07
					STA $1504,y
					LDA #$02
					STA $1602,y
					LDA #$80
					STA $00E4,y
					LDA #$80
					STA $00D8,y
					LDA #$BB
					STA $167A,y
					RTS
					
FRAME_GEN			LDA $9D
					BNE FRAME_GEN_R
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA $15AC,x
					BEQ FRAME_GEN_1
					CMP #$5B
					BEQ FRAME_GEN_3
					CMP #$5A
					BEQ FRAME_GEN_2
					CMP #$44
					BEQ FRAME_GEN_2
					CMP #$2E
					BEQ FRAME_GEN_2
					CMP #$18
					BEQ FRAME_GEN_2
					RTS
FRAME_GEN_2			JSR GEN_SPRITE
					LDA #$04
					STA $1504,y
					LDA #$40
					STA $15AC,y
					LDA #$00
					STA $1602,y
					LDA #$BB
					STA $167A,y
					LDA EXTRA_BITS,x
					AND #$04
					BEQ FRAME_GEN_R
					LDA #$01
					STA $157C,y
FRAME_GEN_R			RTS
FRAME_GEN_1			LDA #$D0
					STA $15AC,x
					RTS
FRAME_GEN_3			LDA #$17
					STA $1DFC
					RTS
					
FRAME_SPEED			dcb $40,$C0
FRAME_OFF			dcb $05,$04,$03,$02,$01,$00,$00
FRAME_DEL			STZ $14C8,x
					RTS
FRAME_MAIN			LDA $15AC,x
					BEQ FRAME_DEL
					CMP #$18
					BCC FRAME_DIS
					JSR SUB_GFX_FR
					LDA $9D
					BNE FRAME_R
					JSR FRAME_DAMAGE
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDY $157C,x
					LDA FRAME_SPEED,y
					STA $AA,x
					JSL $01801A
					LDA $15AC,x
					CMP #$28
					BCC FRAME_2
					SEC
					SBC #$28
					LSR A
					LSR A
					TAY
					LDA FRAME_OFF,y
					STA $1602,x
FRAME_R				RTS
FRAME_2				LDA #$05
					STA $1602,x
					RTS
FRAME_DIS			JSR SUB_GFX_FR2
					LDA $9D
					BNE FRAME_R
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSR FRAME_DAMAGE
					LDA #$18
					SEC
					SBC $15AC,x
					LSR A
					LSR A
					TAY
					LDA FRAME_OFF,y
					STA $1602,x
					RTS
					
BOSS_SUB			LDA $D8,x
					SEC
					SBC $7FFD9C
					LDA $14D4,x
					SBC $7FFD9D
					BCS BOSS_SUB_2
					LDA #$60
					STA $1602,x
BOSS_SUB_2			RTS

SPECIAL_SUB			LDA #$06
					STA $00212C
					LDA #$11
					STA $00212D
					LDA $7FFE01
					CMP #$20
					BCS SPECIAL_SUB_2
					LDA #$60
					STA $1602,x
					BRA SPECIAL_SUB_3
SPECIAL_SUB_2		CMP #$B0
					BCC SPECIAL_SUB_3
					LDA #$A0
					STA $1602,x
SPECIAL_SUB_3		LDA $7FFE00
					CMP #$20
					BCS SPECIAL_SUB_4
					LDA #$60
					STA $1570,x
					BRA SPECIAL_SUB_5
SPECIAL_SUB_4		CMP #$D0
					BCC SPECIAL_SUB_5
					LDA #$A0
					STA $1570,x
SPECIAL_SUB_5		LDA $14
					AND #$01
					BNE RETURN87
					LDA $1463
					CMP #$08
					BEQ RETURN87
					REP #$30
					LDA $1462
					INC A
					STA $1462
					SEP #$30
					LDA $1463
					CMP #$06
					BNE RETURN87
					LDA $1462
					CMP #$C0
					BCS RETURN87
					REP #$30
					LDA $1464
					INC A
					STA $1464
					SEP #$30
RETURN87			RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;					CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FRAME_DAMAGE		LDA $1602,x
					TAY
					LDA $D8,x
					PHA
					LDA $14D4,x
					PHA
FRAME_DAMAGE_LOOP	PHY
					JSR DAMAGE_CHECK
					PLY
					DEY
					BMI FRAME_DAMAGE_2
					LDA $157C,x
					BNE FRAME_DAMAGE_3
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					BRA FRAME_DAMAGE_LOOP
FRAME_DAMAGE_3		LDA $D8,x
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					BRA FRAME_DAMAGE_LOOP
FRAME_DAMAGE_2		PLA
					STA $14D4,x
					PLA
					STA $D8,x
					RTS
					
DAMAGE_CHECK		JSL $01A7DC
					BCC RETURN22
		            LDA $1497               ; \ if mario is invincible...
                    BNE RETURN22             ; /   ... return
                    JSL $00F5B7             ; hurt mario
RETURN22            RTS

STAR_DUST			LDA $14   ;#ʓɂƂ̂݌鏈ɂ
					AND #$07
					BNE STARDUST_R
					JSL $01ACF9
					AND #$0F
					CLC
					LDY #$00
					ADC #$FC
					BPL STARDUST_2
					DEY
STARDUST_2			CLC
					ADC $E4,x
					STA $02
					TYA
					ADC $14E0,x
					PHA
					LDA $02
					CMP $1A
					PLA
					SBC $1B
					BNE STARDUST_R
					LDA $148E
					AND #$0F
					CLC
					ADC #$FE
					ADC $D8,x
					STA $00
					LDA $14D4,x
					ADC #$00
					STA $01
					JSL $0285BA
STARDUST_R			RTS

SUB_SMOKE           LDY #$03                ; \ find a free slot to display effect
FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
                    RTS                     ; / return if no slots open
FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    LDA #$50
                    STA $17C4,y             ; /
                    LDA #$1B                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA #$80
                    STA $17C8,y             ; /
                    RTS 

DELTE_CHECK			LDA $14D4,x
					CMP #$02
					BEQ DELETE
					CMP #$FF
					BEQ DELETE
					LDA $14E0,x
					CMP #$FF
					BEQ DELETE
					RTS
DELETE				STZ $14C8,x
					RTS
					
CONT_CHECK			STZ $1570,x
					STZ $1602,x
					LDA $15
					AND #$0F
					BEQ NOT_PRESS
					LDA $15
					AND #$01
					BNE PRESS_RIGHT
					LDA $15
					AND #$02
					BNE PRESS_LEFT
					BRA CONT_CHECK_2
PRESS_RIGHT			LDA #$60
					STA $1570,x
					BRA CONT_CHECK_2
PRESS_LEFT			LDA #$A0
					STA $1570,x
CONT_CHECK_2		LDA $15
					AND #$04
					BNE PRESS_DOWN
					LDA $15
					AND #$08
					BNE PRESS_UP
					RTS
PRESS_DOWN			LDA #$60
					STA $1602,x
					RTS
PRESS_UP			LDA #$A0
					STA $1602,x
					RTS
NOT_PRESS			LDA $76
					BNE PRESS_RIGHT
					BRA PRESS_LEFT
					
BALL_SPEED			LDA $1570,x
					STA $B6,x
					LDA $1602,x
					STA $AA,x
					LDA $1588,x
					BEQ BALL_SPEED_R
					LDA #$01
					STA $1DF9
					LDA $1588,x
					AND #$01
					BNE BALL_SPEED2
					LDA $1588,x
					AND #$02
					BNE BALL_SPEED3
					LDA $1588,x
					AND #$04
					BNE BALL_SPEED4
					LDA $1588,x
					AND #$08
					BNE BALL_SPEED5
BALL_SPEED_R		RTS
BALL_SPEED2			LDA #$A0
					STA $1570,x
					RTS
BALL_SPEED3			LDA #$60
					STA $1570,x
					RTS
BALL_SPEED4			LDA #$A0
					STA $1602,x
					RTS
BALL_SPEED5			LDA #$60
					STA $1602,x
					RTS
					
TILE_CHECK			LDY #$00
					LDA $E4,x
					SEC
					SBC #$08
					STA $7FFDE4
					SBC #$00
					LDA $14E0,x
					STA $7FFDE0
					LDA $D8,x
					SEC
					SBC #$08
					STA $7FFDD8
					LDA $14D4,x
					SBC #$00
					STA $7FFDD4
					PHX
					LDX #00
TILE_CHECK_LOOP		LDA $14C8,x
					CMP #$08
					BCC TILE_CHECK_2
					LDA $1504,x
					CMP #$07
					BCC TILE_CHECK_2
					CMP #$09
					BCS TILE_CHECK_2
					LDA $E4,x
					SEC
					SBC $7FFDE4
					STA $0F
					LDA $14E0,x
					SBC $7FFDE0
					BNE TILE_CHECK_2
					LDA $0F
					CMP #$09
					BCS TILE_CHECK_2
					LDA $D8,x
					SEC
					SBC $7FFDD8
					STA $0F
					LDA $14D4,x
					SBC $7FFDD4
					BNE TILE_CHECK_2
					LDA $0F
					CMP #$09
					BCS TILE_CHECK_2
					LDA $1602,x
					STA $7FFDC2
					LDY #$01
TILE_CHECK_2		INX
					CPX #$0A
					BCC TILE_CHECK_LOOP
					PLX
					CPY #$01
					BEQ TILE_CHECK_3
					RTS
TILE_CHECK_3		LDA $7FFDC2
					BEQ TILE_CHECK_4
					CMP #$01
					BEQ TILE_CHECK_5
					CMP #$02
					BEQ TILE_CHECK_6
					LDA $1602,x
					CMP #$02
					BCS TILE_CHECK_R
					STZ $1602,x
TILE_CHECK_R		RTS
TILE_CHECK_4		LDA $1602,x
					BEQ TILE_CHECK_4_1
					CMP #$03
					BEQ TILE_CHECK_4_2
					RTS
TILE_CHECK_4_1		LDA #$02
					STA $1602,x
					RTS
TILE_CHECK_4_2		LDA #$01
					STA $1602,x
					RTS
TILE_CHECK_5		LDA $1602,x
					BEQ TILE_CHECK_5_1
					CMP #$02
					BEQ TILE_CHECK_5_2
					RTS
TILE_CHECK_5_1		LDA #$03
					STA $1602,x
					RTS
TILE_CHECK_5_2		LDA #$01
					STA $1602,x
					RTS
TILE_CHECK_6		LDA $1602,x
					CMP #$01
					BEQ TILE_CHECK_6_1
					CMP #$02
					BEQ TILE_CHECK_6_2
					RTS
TILE_CHECK_6_1		LDA #$03
					STA $1602,x
					RTS
TILE_CHECK_6_2		STZ $1602,x
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN67            RTS
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
					LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

					LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


SUB_GFX_BL          JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					LDA #$20
                    STA $0302,y             ; /
					LDA $01
					STA $7FFE01
					STA $0301,y
					LDA $00                 ; \ 
                    STA $0300,y             ; /
					STA $7FFE00

                    LDA #$07
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
SUB_GFX_BL2         JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					LDA #$20
                    STA $0302,y             ; /
					LDA $01
					STA $0301,y
					LDA $00                 ; \ 
                    STA $0300,y             ; /

                    LDA #$09
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
SUB_GFX_SW			JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					LDA #$40
                    STA $0302,y             ; /
					LDA $01
					STA $0301,y
					LDA $00                 ; \ 
                    STA $0300,y             ; /

                    LDA #$0D
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS     

TILE_MAP			dcb $06,$06,$06,$0A
TILE_PRO			dcb $80,$00,$40,$00
TILE_COL			dcb $07,$03

SUB_GFX_TILE		JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					PHX
					LDA $1504,x
					AND #$01
					TAX
					LDA TILE_COL,x
					STA $0303,y
					PLX
					PHX
					LDA $1602,x
					TAX
					LDA TILE_MAP,x
					STA $0302,y
					LDA TILE_PRO,x
					ORA $64
					ORA $0303,y
					STA $0303,y
					PLX

					LDA $01
					STA $0301,y
					LDA $00                 ; \ 
                    STA $0300,y             ; /

                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS     



TILEMAP_FR          dcb $22,$24,$24,$24,$26,$26
HORZ_DISP_FR		dcb $00,$00,$00,$00,$00,$FF
VERT_DISP_FR		dcb $00,$F0,$E0,$D0,$C0,$B0
PROPETIES_FR		dcb $09,$49,$09,$49,$09,$49

SUB_GFX_FR          JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)

                    PHX                     ; push sprite index
					STZ $0F
					LDA $157C,x
					BEQ SUB_GFX_FR_2
					LDA #$80
					STA $0F
SUB_GFX_FR_2		LDA $1602,x
					STA $03
					TAX
LOOP_START_FR       LDA $00
					CLC
					ADC HORZ_DISP_FR,x
					STA $0300,y
					LDA VERT_DISP_FR,x
					STA $0301,y
					LDA $0F
					BEQ SUB_GFX_FR_3
					LDA #$00
					SEC
					SBC $0301,y
					STA $0301,y
SUB_GFX_FR_3		LDA $0301,y
					CLC
					ADC $01
					STA $0301,y
					LDA TILEMAP_FR,x           ; \ store tile
                    STA $0302,y
					
					LDA PROPETIES_FR,x
					ORA $0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties


                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START_FR          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA $03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
TILEMAP_FR2         dcb $22,$26,$26,$24,$24,$24
HORZ_DISP_FR2		dcb $00,$FF,$00,$00,$00,$00
VERT_DISP_FR2		dcb $00,$B0,$C0,$D0,$E0,$F0
PROPETIES_FR2		dcb $09,$49,$09,$49,$09,$49

SUB_GFX_FR2         JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					STZ $0F
					LDA $157C,x
					BEQ SUB_GFX_FR2_2
					LDA #$80
					STA $0F
SUB_GFX_FR2_2		LDA #$18
					SEC
					SBC $15AC,x
					ASL A
					ASL A
					STA $02
                    PHX                     ; push sprite index
					LDA $1602,x
					STA $03
					TAX
LOOP_START_FR2      LDA $00
					CLC
					ADC HORZ_DISP_FR2,x
					STA $0300,y
					LDA VERT_DISP_FR2,x
					STA $0301,y
					CPX #$00
					BEQ LOOP_START_FR2_2
					CLC
					ADC $02
					STA $0301,y
LOOP_START_FR2_2	LDA $0F
					BEQ LOOP_START_FR2_3
					LDA #$00
					SEC
					SBC $0301,y
					STA $0301,y
LOOP_START_FR2_3	LDA $0301,y
					CLC
					ADC $01
					STA $0301,y
					LDA TILEMAP_FR2,x           ; \ store tile
                    STA $0302,y
					
					LDA PROPETIES_FR2,x
					ORA $0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties


                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START_FR2          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA $03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

