;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; X'mas
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;symbolic names for ram addresses
                    EXTRA_BITS = $7FAB10
					NEW_SPRITE_NUM = $7FAB9E
					
					RADIUS = $38

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA #$00
					STA $1602,x
					LDA #$00
					STA $151C,x
					LDA #$40
					STA $187B,x
					LDA $E4,x
					ORA #$08
					STA $E4,x
					LDA #$01
					STA $7FFDAD
					STA $7FFDAC
					LDA #$E0
					STA $7FFDAE
					JSR HDMA_INIT
					LDA #$D8
					STA $7FFD9C
					LDA #$00
					STA $7FFD9D
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                    
START_HB_CODE       LDA $1504,x
					BNE NOT_MAIN
					JSR LIFT
					RTS
NOT_MAIN			CMP #$01
					BNE LAST_MAIN
					JSR SLIME
					RTS
LAST_MAIN			JSR LAST_SUB
					RTS

SLIME				JSR SUB_GFX_S
					LDA $9D
					BNE SLIMR_R
					JSL $01A7DC
					JSL $01802A
					LDA $14D4,x
					BEQ SLIMR_R
					LDA $D8,x
					CMP #$A0
					BCC SLIMR_R
					STZ $14C8,x
SLIMR_R				RTS

LIFT				JSR CIRCLE
					JSR SUB_GFX_T
					LDA $9D
					BNE LIFT_2
					JSR HDMA_LAYER2
					JSR BALL_CHECK
					JSR MOVE_CHECK
					JSR MODE_CHECK
					LDA #$16
					STA $00212C
					LDA #$01
					STA $00212D
LIFT_2				LDA $7FFDD4
					STA $14D4,x
					LDA $7FFDD8
					STA $D8,x
					LDA $7FFDE0
					STA $14E0,x
					LDA $7FFDE4
					STA $E4,x
					LDA $9D
					BNE LIFT_R
					JSR SLIME_GEN
					JSR LAYER2_DOWN
					LDA $D8,x
					STA $7FFAD8
LIFT_R				RTS

LAST_SUB			LDA $1540,x
					BNE LAST_SUB_R
					LDA #$0B
                    STA $1DFB
					LDA #$FF
                    STA $13C6
                    STA $1493
					STZ $14C8,x
LAST_SUB_R			RTS

SUB_SMOKE           LDY #$03                ; \ find a free slot to display effect
FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
                    RTS                     ; / return if no slots open
FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    LDA $D8,x
                    STA $17C4,y             ; /
                    LDA #$1B                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $E4,x
                    STA $17C8,y             ; /
                    RTS 
					
LAYER2_DOWN			LDA $7FFADF
					CMP #$01
					BNE LAYER2_DOWN_R
					LDA $14
					AND #$03
					BNE LAYER2_DOWN_R
					LDA $7FFD9C
					CLC
					ADC #$01
					STA $7FFD9C
					LDA $7FFD9D
					ADC #$00
					STA $7FFD9D
					DEC $1468
					LDA $D8,x
					CLC
					ADC #$01
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					LDA $7FFDAD
					CMP #$70
					BCS LAYER2_DOWN_1
					INC A
					STA $7FFDAD
					BRA LAYER2_DOWN_2
LAYER2_DOWN_1		LDA $7FFDAC
					INC A
					STA $7FFDAC
LAYER2_DOWN_2		LDA $7FFDAE
					INC A
					STA $7FFDAE
LAYER2_DOWN_R		RTS


MODE_CHECK			LDA $1528,x
					CMP #$03
					BEQ MODE_LAST
					LDA $1558,x
					CMP #$01
					BNE MODE_CHECK_R
					LDA $1528,x
					CMP #$01
					BEQ MODE_1
					CMP #$02
					BEQ MODE_2
MODE_CHECK_R		RTS
MODE_1				JSR GEN_NORMAL
					RTS
MODE_2				LDA #$01
					STA $7FFADF
					RTS
MODE_LAST			JSR SUB_SMOKE
					LDA #$02
					STA $1504,x
					LDA #$40
					STA $1540,x
					LDA #$1E
					STA $1DFB
					RTS

MOVE_CHECK			LDA $E4,x
					CMP #$78
					BCC MOVE_LEFT
					LDA $1558,x
					BNE MOVE_RIGHT_1
					LDA $E4,x
					CMP #$C0
					BCS MOVE_RIGHT_D
MOVE_RIGHT_1		LDA $15AC,x
					CMP #$01
					BEQ MOVE_2
					CMP #$00
					BNE MOVE_R
					LDA $E4,x
					SEC
					SBC #$78
					CMP $7FFDAA
					BCC MOVE_R
					LDA $7FFD03
					BMI MOVE_R
					LDA #$FF
					STA $7FFD03
					JSR SUB_DEV
MOVE_R				RTS
MOVE_2				LDA #$FF
					STA $7FFD03
					LDA $E4,x
					SEC
					SBC #$78
					STA $7FFDAA
					JSR SUB_DEV
					RTS
MOVE_RIGHT_D		LDA #$FF
					STA $7FFD03
					LDA #$40
					STA $7FFDAA
					LDA #$FF
					STA $1558,x
					LDA #$28
					STA $1DFC
					INC $1528,x
					RTS
MOVE_LEFT			LDA $1558,x
					BNE MOVE_LEFT_1
					LDA $E4,x
					CMP #$30
					BCC MOVE_LEFT_D
MOVE_LEFT_1			LDA $15AC,x
					CMP #$01
					BEQ MOVE_3
					CMP #$00
					BNE MOVE_R
					LDA #$78
					SEC
					SBC $E4,x
					CMP $7FFDAA
					BCC MOVE_R2
					LDA $7FFD03
					BPL MOVE_R2
					LDA #$01
					STA $7FFD03
					JSR SUB_DEV
MOVE_R2				RTS
MOVE_3				LDA #$01
					STA $7FFD03
					LDA #$78
					SEC
					SBC $E4,x
					STA $7FFDAA
					JSR SUB_DEV
					RTS
MOVE_LEFT_D			LDA #$01
					STA $7FFD03
					LDA #$40
					STA $7FFDAA
					LDA #$FF
					STA $1558,x
					LDA #$28
					STA $1DFC
					INC $1528,x
					RTS

					
SUB_DEV				LDA $7FFDAA
					CMP #$08
					BCC SUB_DEV_2
					SEC
					SBC #$08
					STA $7FFDAA
					RTS
SUB_DEV_2			LDA #$00
					STA $7FFDAA
					STA $7FFD03
					RTS
					
			

BALL_CHECK			LDA $1540,x
					BNE CHECK_R
					LDA $1558,x
					BNE CHECK_R
					LDA $7FFDCB
					TAY
					LDA $D8,x
					SEC
					SBC $00D8,y
					STA $0F
					LDA $14D4,x
					SBC $14D4,y
					BEQ CHECK_2
					CMP #$FF
					BNE CHECK_R
					LDA $0F
					CMP #$F0
					BCC CHECK_R
					BRA CHECK_1
CHECK_2				LDA $0F
					CMP #$10
					BCS CHECK_R
CHECK_1				LDA $E4,x
					SEC
					SBC $00E4,y
					STA $0F
					LDA $14E0,x
					SBC $14E0,y
					BEQ CHECK_3
					CMP #$FF
					BNE CHECK_R
					LDA $0F
					CMP #$F0
					BCC CHECK_R
					BRA CHECK_4
CHECK_R				RTS
CHECK_3				LDA $0F
					CMP #$10
					BCS CHECK_R
CHECK_4				LDA $00B6,y
					BEQ CHECK_R
					LDA #$20
					STA $1540,x
					LDA #$20
					STA $15AC,x
					LDA #$15
					STA $1DF9
					LDA $00B6,y
					BMI CHECK_5
					LDA #$01
					STA $7FFD03
					RTS
CHECK_5				LDA #$FF
					STA $7FFD03
					RTS



SLIME_GEN			LDA $14
					AND #$7F
					BNE SLIME_GEN_R
					JSR SPRITE_GEN
					LDA #$01
					STA $1504,y
					LDA #$26
					STA $167A,y
					JSL $01ACF9
					CLC
					ADC $94
					STA $00E4,y
					LDA #$B0
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA #$00
					STA $14E0,y
					LDA #$2B
					STA $1DFC
SLIME_GEN_R			RTS

					
CIRCLE				LDA $9D
					BNE NOT_ROTATE
					LDA $7FFD03 ;#]x
					STA $03
                    CLC
                    ADC $1602,x
                    STA $1602,x ;#݂̉]l Lowbyte $00
					LDA #$FF
					LDY $03 ;#]x 
					BMI REVERCE
                    LDA #$00
REVERCE             ADC $151C,x ;#݂̉]l Highbyte AND #$01 $01
                    AND #$01
                    STA $151C,x
NOT_ROTATE
					LDA $151C,x
                    STA $01
                    LDA $1602,x
                    STA $00
                    REP #$30 ;#16bit[h
                    LDA $00
                    CLC
                    ADC.W #$0080 ;#]l80𑫂$02-$03
                    AND.W #$01FF
                    STA $02
                    LDA $00
                    AND.W #$00FF
                    ASL A
                    TAX
                    LDA $07F7DB,x ;#]pɑ΂W̊i[lH
                    STA $04				;#$04-$05xWW
                    LDA $02
                    AND.W #$00FF
                    ASL A
                    TAX
                    LDA $07F7DB,x
                    STA $06				;#$06-$07yWW
                    SEP #$30
                    LDX $15E9

                    LDA $04
                    STA $4202   ;#]pɑ΂WW
                    LDA $187B,x  ;#w肵a
                    LDY $05    ;#ΑȂ
                    BNE LABEL93
                    STA $4203   ;#a
                    ASL $4216   ;#ɔ{ɂH
                    LDA $4217
                    ADC #$00
LABEL93             LSR $01
                    BCC LABEL94
                    EOR #$FF                ; \ reverse direction of rotation
                    INC A                   ; /#180xȏȂl𔽓]
LABEL94             STA $04
                    LDA $06
                    STA $4202
                    LDA $187B,x  ;#w肵a
                    LDY $07
                    BNE LABEL95
                    STA $4203
                    ASL $4216
                    LDA $4217
                    ADC #$00
LABEL95             LSR $03
                    BCC LABEL96
                    EOR #$FF
                    INC A
LABEL96             STA $06
                    LDA $E4,x ;#W
                    STA $7FFDE4
                    LDA $14E0,x
                    STA $7FFDE0
                    LDA $D8,x
                    STA $7FFDD8
                    LDA $14D4,x
                    STA $7FFDD4
                    LDY $0F86,x
                    STZ $00
                    LDA $04
                    BPL LABEL97
                    DEC $00
					LDA #$00
					SEC
					SBC $04
					ASL A
					STA $04
					LDA #$00
					SEC
					SBC $04
					STA $04
					BRA LABEL972
LABEL97             ASL A
LABEL972			CLC
                    ADC $E4,x
                    STA $E4,x
                    ;PHP
                    ;PHA
                    ;SEC
                    ;SBC $1534,x
                    ;STA $1528,x
                    ;PLA
                    ;STA $1534,x
                    ;PLP
                    LDA $14E0,x
                    ADC $00
                    STA $14E0,x
                    STZ $01
                    LDA $06
                    BPL LABEL98
                    DEC $01
LABEL98             CLC
                    ADC $D8,x
                    STA $D8,x
                    LDA $14D4,x
                    ADC $01
                    STA $14D4,x
					JSR CIRCLE_MOVE
					RTS
					
CIRCLE_MOVE			LDA $1570,x
					BEQ CIRCLE_MOVE_2
					LDA $9D
					BNE CIRCLE_MOVE_2
					LDA $E4,x
					SEC
					SBC $7FFBE4,x
					STA $00
					LDA $14E0,x
					SBC $7FFCE0,x
					STA $01
					LDA $94
					CLC
					ADC $00
					STA $94
					LDA $95
					ADC $01
					STA $95
					LDA $D8,x
					SEC
					SBC $7FFBD8,x
					STA $00
					LDA $14D4,x
					SBC $7FFCD4,x
					STA $01
					LDA $96
					CLC
					ADC $00
					STA $96
					LDA $97
					ADC $01
					STA $97
CIRCLE_MOVE_2		LDA $E4,x
					STA $7FFBE4,x
					LDA $D8,x
					STA $7FFBD8,x
					LDA $14E0,x
					STA $7FFCE0,x
					LDA $14D4,x
					STA $7FFCD4,x
					RTS
					
SPEED_CHECK			LDA $14
					AND #$0F
					BNE SPEED_CHECK_R
					LDA $1504,x
					BEQ SPEED_NOT_STAND
					LDA $94
					SEC
					SBC $E4,x
					LDA $95
					SBC $14E0,x
					BCC SPEED_CHECK_L
					LDA $7FFD03
					CMP #$FD
					BEQ SPEED_CHECK_R
					DEC A
					STA $7FFD03
					RTS
SPEED_CHECK_L		LDA $7FFD03
					CMP #$03
					BEQ SPEED_CHECK_R
					INC A
					STA $7FFD03
SPEED_CHECK_R		RTS
SPEED_NOT_STAND		LDA $7FFD03
					BEQ SPEED_CHECK_R
					BMI NOT_STAND2
					DEC A
					STA $7FFD03
					RTS
NOT_STAND2			INC A
					STA $7FFD03
					RTS
					
					

					


               

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

					
TILEMAP0            dcb $E6,$E8,$AA,$AE
					dcb $CC,$CE,$EC,$EE
HORZ_DISP0			dcb $F8,$08,$F8,$08
					dcb $08,$F8,$08,$F8
VERT_DISP0			dcb $F8,$F8,$08,$08

RETURN332			RTS
SUB_GFX_T           LDA $1558,x
					AND #$01
					BNE RETURN332
					
					JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					
					LDA $14
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$01
					ASL A
					ASL A
					STA $02
					
					LDA #$0F
					STA $0F
					STZ $03
					LDA $E4,x
					SEC
					SBC $94
					LDA $14E0,x
					SBC $95
					BCS SUB_GFX_T_2
					LDA #$4F
					STA $0F
					LDA #$04
					STA $03

SUB_GFX_T_2         PHX                     ; push sprite index
					LDX #$03
LOOP_START0          
					LDA $01
					CLC
					ADC VERT_DISP0,x
					STA $0301,y
					
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA TILEMAP0,x
					STA $0302,y
					PLX
					
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA $00
					CLC
					ADC HORZ_DISP0,x
                    STA $0300,y 
					PLX
					
					LDA $0F
					ORA $64
					STA $0303,y

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START0          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
					
                    RTS                     ; return
					
TILEMAPS            dcb $CA,$EA
VERT_DISPS			dcb $F0,$00

SUB_GFX_S           JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)


					PHX                     ; push sprite index
					LDX #$01
LOOP_STARTS          
					LDA $01
					CLC
					ADC VERT_DISPS,x
					STA $0301,y
					
					LDA TILEMAPS,x
					STA $0302,y

					LDA $00
                    STA $0300,y 
					
					LDA #$03
					ORA $64
					STA $0303,y

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_STARTS          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$01                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
					
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

RETURN67            RTS
SPRITE_GEN          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    
					LDA NEW_SPRITE_NUM,x
					TYX
                    STA NEW_SPRITE_NUM,x
					PLX
					
					LDA $E4,x
					STA $00E4,y
					LDA #$00
					STA $14E0,y
					LDA $D8,x
					STA $00D8,y
					LDA $14D4,x
					STA $14D4,y
                    
                    PHX
					TYX
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS 
					
HDMA_INIT			LDA #$08
					STA $7FFB18
					LDA #$10
					STA $7FFB20
					LDA #$20
					STA $7FFB28
					LDA #$00
					STA $7FFB19
					STA $7FFB21
					STA $7FFB29
					LDA #$26
					STA $7FFB1A
					LDA #$27
					STA $7FFB22
					LDA #$23
					STA $7FFB2A
					LDA #$00
					STA $7FFB1B
					STA $7FFB23
					STA $7FFB2B
					LDA #$E2
					STA $7FFB1C
					LDA #$E3
					STA $7FFB24
					LDA #$E4
					STA $7FFB2C
					LDA #$7F
					STA $7FFB1D
					STA $7FFB25
					STA $7FFB2D
					
					LDA #$01
					STA $7FE200
					STA $7FE300
					STA $7FE400
					LDA #$70
					STA $7FE201
					LDA #$90
					STA $7FE301
					LDA #$30
					STA $7FE401
					LDA #$00
					STA $7FE302
					STA $7FE202
					STA $7FE402
					RTS
					
HDMA_LAYER2			LDA #$1D
					STA $7FE200
					STA $7FE300
					LDA #$00
					STA $7FE201
					LDA #$FF
					STA $7FE301
					LDA $7FFDAD
					STA $7FE202
					STA $7FE302
					LDA #$00
					STA $7FE203
					LDA #$FF
					STA $7FE303
					LDA $7FFDAC
					STA $7FE204
					STA $7FE304
					LDA #$00
					STA $7FE205
					LDA #$FF
					STA $7FE305
					
					LDA $D8,x
					SEC
					SBC $7FFDAE
					STA $03
					
					LDY #$00
					LDA $E4,x
					CMP #$78
					BCC LBL300
					JSR HDMA2_1
					BRA LBL800
LBL300				JSR HDMA2_2
LBL800				PHX
					TYA
					ASL A
					TAX
					LDA #$01
					STA $7FE206,x
					STA $7FE306,x
					LDA #$00
					STA $7FE207,x
					STA $7FE307,x
					STA $7FE208,x
					STA $7FE308,x
					PLX
					RTS
HDMA2_1
HDMA_LAYER_LOOP		LDA $E4,x
					SEC
					SBC #$78
					STA $4202
					TYA
					STA $4203
					LDA $4216
					STA $4204
					LDA $4217
					STA $4205
					LDA $D8,x
					SEC
					SBC $7FFDAE
					STA $4206
					
					PHX
					TYA
					ASL A
					TAX
					LDA #$01
					STA $7FE206,x
					STA $7FE306,x
					
					LDA $4214
					CLC
					ADC #$78
					CMP #$F0
					BCS LBL902
					CLC
					ADC #$04
					STA $7FE207,x
					ADC #$08
					STA $7FE307,x
					BRA LBL903
LBL902				CLC
					ADC #$04
					STA $7FE207,x
					LDA #$FF
					STA $7FE307,x
LBL903				PLX
					INY
					CPY $03
					BNE HDMA_LAYER_LOOP
					TYA
					STA $7FFDDD
					RTS
					
HDMA2_2
HDMA_LAYER_LOOP2	LDA #$78
					SEC
					SBC $E4,x
					STA $4202
					TYA
					STA $4203
					LDA $4216
					STA $4204
					LDA $4217
					STA $4205
					LDA $D8,x
					SEC
					SBC $7FFDAE
					STA $4206
					
					PHX
					TYA
					ASL A
					TAX
					LDA #$01
					STA $7FE206,x
					STA $7FE306,x
					
					LDA #$78
					SEC
					SBC $4214
					CLC
					ADC #$04
					STA $7FE207,x
					CLC
					ADC #$08
					STA $7FE307,x
					PLX
					INY
					CPY $03
					BNE HDMA_LAYER_LOOP2
					TYA
					STA $7FFDDD
					RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite erator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN67            RTS
SPRITE_GEN          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    LDA NEW_SPRITE_NUM,x
					TYX
                    STA NEW_SPRITE_NUM,x
					PLX
					
					LDA $E4,x
					STA $00E4,y
					LDA $14E0,x
					STA $14E0,y
					LDA $D8,x
					STA $00D8,y
					LDA $14D4,x
					STA $14D4,y
                    
                    PHX
					TYX
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; generate sprite
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RETURNK61           RTS     
GEN_NORMAL          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURNK61            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    LDA #$B6
                    STA $009E,y
                    
                    LDA $E4,x               ;\ set x position for new sprite
                    STA $00E4,y

                    LDA $14E0,x             ;  |
                    STA $14E0,y             ; /

                    LDA $D8,x
					STA $00D8,y             ;  |
                    LDA $14D4,x
					STA $14D4,y             ; /

                    PHX
                    TYX
                    JSL $07F7D2             ;  
                    PLX
					LDA #$20
					STA $00AA,y
					STA $00B6,y
					LDA #$01
					STA $157C,y
                    RTS                     ; return

