;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; X'mas
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;symbolic names for ram addresses
                    MARIO_STATUS    = $19 
                    MARIO_X_SPEED   = $7B
                    MARIO_Y_SPEED   = $7D
                    MARIO_X_POS     = $94
                    MARIO_X_POS_HI  = $95
                    MARIO_Y_POS     = $96 
                    MARIO_Y_POS_HI  = $97
                    SPRITE_Y_SPEED  = $AA
                    SPRITE_X_SPEED  = $B6
                    SPRITE_STATE    = $C2       
                    SPRITE_Y_POS    = $D8
                    SPRITE_X_POS    = $E4
                    SPRITE_Y_POS_HI = $14D4
                    SPRITE_X_POS_HI = $14E0
                    SPR_OBJ_STATUS  = $1588
                    SPRITE_OAM      = $15EA
                    EXTRA_BITS = $7FAB10
					NEW_SPRITE_NUM = $7FAB9E
					
					RADIUS = $38

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA #$80
					STA $15AC,x
					LDA $010B
					CMP #$88
					BEQ INIT_R
					LDA #$28
					STA $187B,x
					LDA EXTRA_BITS,x
					AND #$04
					BEQ INIT_R
					LDA $D8,x
					CMP #$10
					BEQ INIT_2
					CMP #$00
					BEQ INIT_3
					CMP #$F0
					BEQ INIT_4
INIT_R				RTL
INIT_2				CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					TXA
					STA $7FFE90
					LDA #$80
					STA $1602,x
					RTL
INIT_3				CLC
					ADC #$20
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					TXA
					STA $7FFE91
					LDA #$01
					STA $151C,x
					RTL
INIT_4				CLC
					ADC #$30
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					TXA
					STA $7FFE92
					LDA #$80
					STA $1602,x
					LDA #$01
					STA $151C,x
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                    
START_HB_CODE       LDA $010B
					CMP #$88
					BNE MAIN_2
					LDA $1504,x
					BEQ MAIN_1
					JSR TILE
					RTS
MAIN_1				JSR SLASH
					RTS
MAIN_2				JSR LIFT
					RTS

LIFT				JSR CIRCLE
					JSR SUB_GFX
					LDA $9D
					BNE LIFT_2
					JSR SUB_B852
LIFT_2					
					LDA $7FFDD4
					STA $14D4,x
					LDA $7FFDD8
					STA $D8,x
					LDA $7FFDE0
					STA $14E0,x
					LDA $7FFDE4
					STA $E4,x
					LDA EXTRA_BITS,x
					AND #$04
					BNE LIFT_R
					LDA $9D
					BNE LIFT_R
					JSR RIDE_CHECK
					JSR MOVEMENT
					JSR SPEED_CHECK
LIFT_R				RTS


RIDE_CHECK			STZ $1504,x
					PHX
					LDA $1570,x 
					BNE STAND_ON
					LDA $7FFE90
					TAX
					LDA $1570,x
					BNE STAND_ON
					LDA $7FFE91
					TAX
					LDA $1570,x
					BNE STAND_ON
					LDA $7FFE92
					TAX
					LDA $1570,x
					BNE STAND_ON
					PLX
					RTS
STAND_ON			PLX
					LDA #$01
					STA $1504,x
					RTS
					
CIRCLE				LDA $9D
					BNE NOT_ROTATE
					LDA $7FFD03 ;#]x
					STA $03
                    CLC
                    ADC $1602,x
                    STA $1602,x ;#݂̉]l Lowbyte $00
					LDA #$FF
					LDY $03 ;#]x 
					BMI REVERCE
                    LDA #$00
REVERCE             ADC $151C,x ;#݂̉]l Highbyte AND #$01 $01
                    AND #$01
                    STA $151C,x
NOT_ROTATE
					LDA $151C,x
                    STA $01
                    LDA $1602,x
                    STA $00
                    REP #$30 ;#16bit[h
                    LDA $00
                    CLC
                    ADC.W #$0080 ;#]l80𑫂$02-$03
                    AND.W #$01FF
                    STA $02
                    LDA $00
                    AND.W #$00FF
                    ASL A
                    TAX
                    LDA $07F7DB,x ;#]pɑ΂W̊i[lH
                    STA $04				;#$04-$05xWW
                    LDA $02
                    AND.W #$00FF
                    ASL A
                    TAX
                    LDA $07F7DB,x
                    STA $06				;#$06-$07yWW
                    SEP #$30
                    LDX $15E9

                    LDA $04
                    STA $4202   ;#]pɑ΂WW
                    LDA $187B,x  ;#w肵a
                    LDY $05    ;#ΑȂ
                    BNE LABEL93
                    STA $4203   ;#a
                    ASL $4216   ;#ɔ{ɂH
                    LDA $4217
                    ADC #$00
LABEL93             LSR $01
                    BCC LABEL94
                    EOR #$FF                ; \ reverse direction of rotation
                    INC A                   ; /#180xȏȂl𔽓]
LABEL94             STA $04
                    LDA $06
                    STA $4202
                    LDA $187B,x  ;#w肵a
                    LDY $07
                    BNE LABEL95
                    STA $4203
                    ASL $4216
                    LDA $4217
                    ADC #$00
LABEL95             LSR $03
                    BCC LABEL96
                    EOR #$FF
                    INC A
LABEL96             STA $06
                    LDA $E4,x ;#W
                    STA $7FFDE4
                    LDA $14E0,x
                    STA $7FFDE0
                    LDA $D8,x
                    STA $7FFDD8
                    LDA $14D4,x
                    STA $7FFDD4
                    LDY $0F86,x
                    STZ $00
                    LDA $04
                    BPL LABEL97
                    DEC $00
LABEL97             CLC
                    ADC $E4,x
                    STA $E4,x
                    ;PHP
                    ;PHA
                    ;SEC
                    ;SBC $1534,x
                    ;STA $1528,x
                    ;PLA
                    ;STA $1534,x
                    ;PLP
                    LDA $14E0,x
                    ADC $00
                    STA $14E0,x
                    STZ $01
                    LDA $06
                    BPL LABEL98
                    DEC $01
LABEL98             CLC
                    ADC $D8,x
                    STA $D8,x
                    LDA $14D4,x
                    ADC $01
                    STA $14D4,x
					JSR CIRCLE_MOVE
					RTS
					
CIRCLE_MOVE			LDA $1570,x
					BEQ CIRCLE_MOVE_2
					LDA $9D
					BNE CIRCLE_MOVE_2
					LDA $E4,x
					SEC
					SBC $7FFBE4,x
					STA $00
					LDA $14E0,x
					SBC $7FFCE0,x
					STA $01
					LDA $94
					CLC
					ADC $00
					STA $94
					LDA $95
					ADC $01
					STA $95
					LDA $D8,x
					SEC
					SBC $7FFBD8,x
					STA $00
					LDA $14D4,x
					SBC $7FFCD4,x
					STA $01
					LDA $96
					CLC
					ADC $00
					STA $96
					LDA $97
					ADC $01
					STA $97
CIRCLE_MOVE_2		LDA $E4,x
					STA $7FFBE4,x
					LDA $D8,x
					STA $7FFBD8,x
					LDA $14E0,x
					STA $7FFCE0,x
					LDA $14D4,x
					STA $7FFCD4,x
					RTS
					
SPEED_CHECK			LDA $14
					AND #$0F
					BNE SPEED_CHECK_R
					LDA $1504,x
					BEQ SPEED_NOT_STAND
					LDA $94
					SEC
					SBC $E4,x
					LDA $95
					SBC $14E0,x
					BCC SPEED_CHECK_L
					LDA $7FFD03
					CMP #$FD
					BEQ SPEED_CHECK_R
					DEC A
					STA $7FFD03
					RTS
SPEED_CHECK_L		LDA $7FFD03
					CMP #$03
					BEQ SPEED_CHECK_R
					INC A
					STA $7FFD03
SPEED_CHECK_R		RTS
SPEED_NOT_STAND		LDA $7FFD03
					BEQ SPEED_CHECK_R
					BMI NOT_STAND2
					DEC A
					STA $7FFD03
					RTS
NOT_STAND2			INC A
					STA $7FFD03
					RTS
					
					
SLASH				LDA $9D
					BNE SLASH_R
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					STA $D8,x
					LDA $97
					STA $14D4,x
					LDA $15AC,x
					BNE SLASH_R
					JSR SLASH_MAIN
SLASH_R				RTS

SLASH_MAIN			LDA #$80
					STA $15AC,x
					JSR SPRITE_GEN
					PHX
					LDA $1570,x
					TAX
					LDA POS_X,x
					STA $00E4,y
					LDA POS_Y,x
					STA $00D8,y
					LDA POS_Y2,x
					STA $14D4,y
					LDA TILE00,x
					STA $1602,y
					LDA DIRE,x
					STA $157C,y
					PLX
					LDA #$01
					STA $1504,y
					LDA #$29
					STA $1686,y
					INC $1570,x
					LDA $1570,x
					CMP #$11
					BEQ DELETE
					RTS
DELETE				STZ $14C8,x
					RTS
					
POS_X				dcb $80,$40,$80,$A0,$A0,$80,$A0,$C0,$60,$80,$A0,$C0,$C0,$E0,$C0,$E0,$E0,
POS_Y				dcb $60,$00,$40,$60,$40,$20,$20,$40,$00,$00,$00,$00,$20,$20,$E0,$00,$E0,
POS_Y2				dcb $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$00,$01,$00,
TILE00				dcb $00,$01,$01,$03,$00,$02,$01,$03,$00,$03,$02,$01,$00,$03,$02,$00,$01,
DIRE				dcb $00,$01,$00,$00,$01,$01,$00,$00,$01,$01,$00,$00,$00,$00,$01,$00,$01
;#00;΃n[g 01:_C 02:Fn[g 03:΃_C

X_SPEED				dcb $E0,$00
Y_SPEED				dcb $00,$20
TILE				JSR SUB_GFX_T
					LDA $9D
					BNE TILE_R
					LDA $E4,x
					PHA
					CLC
					ADC #$08
					STA $E4,x
					LDA $14E0,x
					PHA
					ADC #$00
					STA $14E0,x
					LDA $D8,x
					PHA
					SEC
					SBC #$08
					STA $D8,x
					LDA $14D4,x
					PHA
					SBC #$00
					STA $14D4,x
					JSR SUB_B852
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					LDA $1528,x
					CMP #$77
					BEQ TILE_2
					LDA #$77
					STA $1528,x
					JSR DELETE_TILE
TILE_2				LDY $157C,x
					LDA X_SPEED,y
					STA $B6,x
					LDA Y_SPEED,y
					STA $AA,x
					JSL $01802A
					LDA $157C,x
					BEQ TILE_3
					LDA $1588,x
					AND #$04
					BEQ TILE_R
TILE_1				JSR GEN_TILE
					STZ $14C8,x
					LDA #$10
					STA $1DFC
TILE_R				RTS
TILE_3				LDA $1588,x
					AND #$02
					BEQ TILE_R
					LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					BRA TILE_1

DELETE_TILE			LDA $E4,x
					STA $9A
					LDA $14E0,x
					STA $9B
					LDA $D8,x
					STA $98
					LDA $14D4,x
					STA $99
					REP #$30
                    LDA.W #$0025
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					LDA.W $9A
					CLC
					ADC.W #$0010
					STA.W $9A
					LDA.W #$0025
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					LDA.W $98
					SEC
					SBC.W #$0010
					STA.W $98
					LDA.W #$0025
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					LDA.W $9A
					SEC
					SBC.W #$0010
					STA.W $9A
					LDA.W #$0025
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					SEP #$30
					RTS
					
TILE_GEN			dcb $32,$0E,$33,$0E,$23,$0E,$22,$0E
					dcb $50,$0E,$51,$0E,$41,$0E,$40,$0E
					dcb $30,$0E,$31,$0E,$21,$0E,$20,$0E
					dcb $52,$0E,$53,$0E,$43,$0E,$42,$0E
;#00;΃n[g 01:_C 02:Fn[g 03:΃_C
GEN_TILE			LDA $1602,x
					ASL A
					ASL A
					ASL A
					STA $03
					PHX
					LDX #$00
GEN_TILE_LOOP		PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILE_GEN,x
					PLX
					STA $7FFD00,x
					INX
					CPX #$08
					BNE GEN_TILE_LOOP
					PLX
					
					LDA $E4,x
					STA $9A
					LDA $14E0,x
					STA $9B
					LDA $D8,x
					STA $98
					LDA $14D4,x
					STA $99
					REP #$30
                    LDA $7FFD00
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					LDA.W $9A
					CLC
					ADC.W #$0010
					STA.W $9A
					LDA $7FFD02
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					LDA.W $98
					SEC
					SBC.W #$0010
					STA.W $98
					LDA $7FFD04
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					LDA.W $9A
					SEC
					SBC.W #$0010
					STA.W $9A
					LDA $7FFD06
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					SEP #$30
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; platform code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					
SUB_B852            STZ $1570,x
					JSR SUB_B8FF
                    BCC RETURN05      
                    LDA $15C4,x
					ORA $154C,x
                    BNE RETURN05
					
                    LDA SPRITE_Y_POS,x    
                    SEC          
                    SBC $1C      
                    STA $02      
                    SEC          
                    SBC $0D      
                    STA $09      
                    LDA $80      
                    CLC          
                    ADC #$18     
                    CMP $09      
                    BCS LBL06     
                    LDA MARIO_Y_SPEED    
                    BMI RETURN05     
                    STZ MARIO_Y_SPEED  ;#ɏĂ
                    LDA #$01     
                    STA $1471       
					STA $1570,x
                    LDA $0D      
                    CLC          
                    ADC #$1F     ;#1F?
                    
					STA $00

                    LDA SPRITE_Y_POS,x    
                    SEC          
                    SBC $00      
                    STA MARIO_Y_POS      
                    LDA SPRITE_Y_POS_HI,x  
                    SBC #$00     
                    STA MARIO_Y_POS_HI      
                    LDY #$00     
RETURN05            RTS           

LBL06               LDA $010B
					CMP #$88
					BNE RETURN05
					LDA $02       
                    CLC           
                    ADC $0D       ;#^e/2
                    STA $02       
                    LDA #$FF      
                    LDY $73       
                    BNE LBL07      
                    LDY MARIO_STATUS       
                    BNE SMALL_MARIO
LBL07
                    LDA #$08   
SMALL_MARIO
                    CLC                     
                    ADC $80      
                    CMP $02      
                    BCC LBL10      
                    LDA MARIO_Y_SPEED       ;#ɂԂĂ
					BPL LBL09
					LDA #$10                
                    STA MARIO_Y_SPEED    
LBL09				RTS       
LBL10
                    LDA $0E       ;#/2
                    CLC           
                    ADC #$10      
                    STA $00       
                    LDY #$00      
                    LDA SPRITE_X_POS,x     
                    SEC           
                    SBC $1A       
                    CMP $7E       
                    BCC LBL11     
                    LDA $00       
                    EOR #$FF      
                    INC A         
                    STA $00       
                    DEY     
LBL11				LDA SPRITE_X_POS,x     ;#ɐGĂ
                    CLC           
                    ADC $00       
                    STA MARIO_X_POS       
                    TYA           
                    ADC SPRITE_X_POS_HI,x   
                    STA MARIO_X_POS_HI       
                    STZ MARIO_X_SPEED       
LBL12               RTS                    
       

               
RETURN131           RTS                    
MOVEMENT			LDA $7FFD03
					BEQ MOVEMENT_1
					BMI MOVEMENT_1
					LSR A
					STA $7FFD05
					BEQ MOVEMENT_3
					LDA #$00
					SEC
					SBC $7FFD05
					STA $7FFD05
					LDA #$FF
					STA $7FFD04
					BRA MOVEMENT_2
MOVEMENT_1			LDA #$00
					SEC
					SBC $7FFD03
					LSR A
					STA $7FFD05
MOVEMENT_3			LDA #$00
					STA $7FFD04
MOVEMENT_2			JSR TILE_CHECK
					LDA $1528,x
					CMP #$7D
					BEQ TO_START
					CMP #$7F
					BEQ TO_END
					CMP #$7E
					BEQ TO_RIGHT
					CMP #$81
					BEQ TO_LEFTUP
					CMP #$83
					BEQ TO_UPRIGHT
					CMP #$80
					BEQ TO_RIGHTDOWN
					CMP #$84
					BEQ TO_DOWN
					CMP #$82
					BEQ TO_DOWNRIGHT
					CMP #$85
					BEQ TO_UP
					CMP #$86
					BEQ NANAME1
					CMP #$87
					BEQ NANAME1
					CMP #$88
					BEQ NANAME2
					CMP #$89
					BEQ NANAME2
					RTS
NANAME1				JSR MOVE_UP
					JSR MOVE_RIGHT
					RTS
NANAME2				JSR MOVE_DOWN
					JSR MOVE_RIGHT
					RTS
TO_START			LDA $7FFD05
					BMI RETURN736
					JSR MOVE_RIGHT
RETURN736			RTS
TO_END				LDA $7FFD05
					BPL RETURN735
					JSR MOVE_RIGHT
RETURN735			RTS
TO_RIGHT			JSR MOVE_RIGHT
					RTS
TO_LEFTUP			LDA $7FFD05
					BMI TO_LEFTUP_2
					JSR MOVE_UP
					RTS
TO_LEFTUP_2			JSR MOVE_RIGHT
					RTS
TO_UP				JSR MOVE_UP
					RTS
TO_UPRIGHT			LDA $7FFD05
					BMI TO_UPRIGHT_2
					JSR MOVE_RIGHT
					RTS
TO_UPRIGHT_2		JSR MOVE_UP
					RTS
TO_RIGHTDOWN		LDA $7FFD05
					BMI TO_RIGHTDOWN_2
					JSR MOVE_DOWN
					RTS
TO_RIGHTDOWN_2		JSR MOVE_RIGHT
					RTS
TO_DOWN				JSR MOVE_DOWN
					RTS
TO_DOWNRIGHT		LDA $7FFD05
					BMI TO_DOWNRIGHT_2
					JSR MOVE_RIGHT
					RTS
TO_DOWNRIGHT_2		JSR MOVE_DOWN
					RTS

MOVE_DOWN			LDA $D8,x
					CLC
					ADC $7FFD05
					STA $D8,x
					LDA $14D4,x
					ADC $7FFD04
					STA $14D4,x
					JSR MOVE_OFFSET
MOVE_DOWN_R			RTS
MOVE_UP				LDA $D8,x
					SEC
					SBC $7FFD05
					STA $D8,x
					LDA $14D4,x
					SBC $7FFD04
					STA $14D4,x
					JSR MOVE_OFFSET
MOVE_UP_R			RTS
MOVE_RIGHT			LDA $E4,x
					CLC
					ADC $7FFD05
					STA $E4,x
					LDA $14E0,x
					ADC $7FFD04
					STA $14E0,x
					JSR MOVE_OFFSET
MOVE_RIGHT_R		RTS

MOVE_OFFSET			LDA $7FFE90
					TAY
					LDA $E4,x
					STA $00E4,y
					LDA $14E0,x
					STA $14E0,y
					LDA $D8,x
					STA $00D8,y
					LDA $14D4,x
					STA $14D4,y
					LDA $7FFE91
					TAY
					LDA $E4,x
					STA $00E4,y
					LDA $14E0,x
					STA $14E0,y
					LDA $D8,x
					STA $00D8,y
					LDA $14D4,x
					STA $14D4,y
					LDA $7FFE92
					TAY
					LDA $E4,x
					STA $00E4,y
					LDA $14E0,x
					STA $14E0,y
					LDA $D8,x
					STA $00D8,y
					LDA $14D4,x
					STA $14D4,y
					RTS

TILE_CHECK			LDA $E4,x
					AND #$0E
					BNE RETURN83
					LDA $D8,x
					AND #$0E
					BNE RETURN83
					LDA $D8,x
					PHA
					SEC
					SBC #$08
					STA $D8,x
					LDA $14D4,x
					PHA
					SBC #$00
					STA $14D4,x
					LDA $E4,x
					PHA
					SEC
					SBC #$08
					STA $E4,x
					LDA $14E0,x
					PHA
					SBC #$00
					STA $14E0,x
					JSL $019138
					LDA $03
					STA $1528,x
					STA $7FFDDD
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
RETURN83			RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; make standable
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_B8FF			;#$00XvCg̉ $01 0 $02 0
                    LDA $00      
                    STA $0E      ;#/2
                    LDA $02      
                    STA $0D      ;#^e/2
                    LDA SPRITE_X_POS,x    
                    SEC          
                    SBC $00      
                    STA $04      ;#XvCg̍Low
                    LDA SPRITE_X_POS_HI,x  
                    SBC #$00     
                    STA $0A      ;#XvCg̍Hi
                    LDA $00      
                    ASL A        
                    CLC          
                    ADC #$10     
                    STA $06      ;#XvCg̕{10
                    LDA SPRITE_Y_POS,x    
                    SEC          
                    SBC $02      ;#0
                    STA $05      ;#XvCg̏㑤Low
                    LDA SPRITE_Y_POS_HI,x  
                    SBC #$00     
                    STA $0B      ;#XvCg̏㑤Hi
                    LDA $02      
                    ASL A        
                    CLC          
                    ADC #$10     
                    STA $07      ;#XvCg̍+10
                    JSL $03B664  
                    JSL $03B72B  
                    RTS 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP				dcb $0E,$67,$69,$67

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					LDA $14
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$03
					PHX
					TAX
					LDA TILEMAP,x
					PLX
					STA $0302,y
					STA $0306,y

					LDA $01
					CLC
					ADC #$FE
					STA $0301,y
					STA $0305,y
					LDA $00
					CLC
					ADC #$F8
                    STA $0300,y
					CLC
					ADC #$10
					STA $0304,y 
					
					LDA #$0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					ORA #$40
					STA $0307,y

                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$01                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen

					STZ $01       
                    STZ $02       
                    STZ $03       
					LDA #$06
					STA $00
					
                    RTS                     
					
					
;#00;΃n[g 01:_C 02:Fn[g 03:΃_C
					
TILEMAP0            dcb $82,$82,$A2,$A2
					dcb $84,$84,$A4,$A4
HORZ_DISP0			dcb $00,$10,$00,$10
VERT_DISP0			dcb $EF,$EF,$FF,$FF
PROPETIES			dcb $00,$40,$00,$40
COLOR				dcb $0D,$0F,$0F,$0D

SUB_GFX_T           
					JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					
					LDA $1602,x
					STA $7FFF02
					AND #$01
					ASL A
					ASL A
					STA $02
					PHX
					LDA $1602,x
					TAX
					LDA COLOR,x
					STA $03
					PLX
					
                    PHX                     ; push sprite index
					LDX #$03
LOOP_START0          
					LDA $00
					CLC
					ADC HORZ_DISP0,x
                    STA $0300,y 
					LDA $01
					CLC
					ADC VERT_DISP0,x
					STA $0301,y
					LDA PROPETIES,x
					ORA $03
					ORA $64
					STA $0303,y
					
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA TILEMAP0,x
					STA $0302,y
					PLX

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START0          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
					
					LDA #$08
					STA $00
					STZ $01       
					LDA #$08
                    STA $02       
                    STZ $03       
					
					
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

RETURN67            RTS
SPRITE_GEN          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    
					LDA NEW_SPRITE_NUM,x
					TYX
                    STA NEW_SPRITE_NUM,x
					PLX
					
					LDA $E4,x
					STA $00E4,y
					LDA #$00
					STA $14E0,y
					LDA $D8,x
					STA $00D8,y
					LDA $14D4,x
					STA $14D4,y
                    
                    PHX
					TYX
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS 
