;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Giant Koopa
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"
                    PHY
                    JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
                    PLY
					STZ $C2,x
					STZ $1594,x
					LDA EXTRA_BITS,x
					AND #$04
					BEQ INIT_E
					LDA #$01
					STA $1594,x
INIT_E              RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

X_SPEED             dcb $08,$F8
X_SPEED2            dcb $38,$C8 
KILLED_X_SPEED      dcb $F0,$10

RETURN              RTS
CODE_START          LDA $14C8,x
					CMP #$08
					BNE GFX2
					LDA $C2,x
					BNE GFX2
					JSR SUB_GFX
					BRA MAIN
GFX2				JSR SUB_GFX2

MAIN                LDA $14C8,x             ; \ 
					BEQ RETURN
                    CMP #$02                ;  | if status != 8, return
                    BEQ RETURN
					LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
                    JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					
					LDA $C2,x
					BNE SHELL_MODE
                    LDY $157C,x             ; \ set x speed based on direction
                    LDA X_SPEED,y           ;  |
                    STA $B6,x               ; /
					JSL $01802A             ; update position based on speed values
                    JSL $018032             ; interact with other sprites
					LDA $1594,x
					BNE WING_MODE
					LDA $15AC,x
					BNE MODE0
					JSR CHECK1
MODE0				LDA $1588,x             ; \ if sprite is in contact with an object...
                    AND #$03                ; |
                    BEQ RETURN
                    LDA $157C,x             ; | flip the direction status
                    EOR #$01                ; |
                    STA $157C,x             ; /
					RTS
WING_MODE			JSR CHECK4
					LDA $1588,x
					AND #$04
					BEQ MODE0
					LDA #$B0
					STA $AA,x
					BRA MODE0


SHELL_MODE			CMP #$01
					BNE MODE2
					STZ $B6,x
					JSR CHECK2
					LDA $15AC,x
					BEQ SHELL_2
					CMP #$30
					BCS SHELL_E
					LDA $14
					LSR A
					LSR A
					AND #$01
					PHX
					TAX
					LDA X_SPEED,x
					PLX
					STA $B6,x
SHELL_E				JSL $01802A             ; update position based on speed values
                    JSL $018032             ; interact with other sprites
					RTS
SHELL_2				STZ $C2,x
					BRA SHELL_E
					
MODE2				LDY $157C,x             ; \ set x speed based on direction
                    LDA X_SPEED2,y           ;  |
                    STA $B6,x
					JSL $01802A             ; update position based on speed values
					JSR SPRITE_DEL
					LDA $15AC,x
					BNE MODE2_2
					JSR CHECK1
MODE2_2				LDA $1588,x             ; \ if sprite is in contact with an object...
                    AND #$03                ; |
                    BEQ MODE2_E
                    LDA $157C,x             ; | flip the direction status
                    EOR #$01                ; |
                    STA $157C,x             ; /
					LDA #$01
					STA $1DF9
MODE2_E				RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Contact Mario
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CHECK4              JSL $01A7DC             ; check for mario/sprite contact
                    BCC RETURN_25           ; (carry set = contact)
                    LDA $1490               ; \ if mario star timer > 0 ...
                    BNE HAS_STAR2            ; /    ... goto HAS_STAR
					LDA $D8,x
					SEC
					SBC $96
					STA $0F
                    LDA $14D4,x
					SBC $97
                    BCC GOOB_WINS2           ; /
					LDA $0F
					CMP #$18
					BCC GOOB_WINS2
MARIO_WINS3			JSR SUB_STOMP_PTS       ; give mario points
                    JSL $01AA33             ; set mario speed
                    JSL $01AB99             ; display contact graphic
                    LDA $140D               ; \  if mario is spin jumping...
                    ORA $187A               ;  }    ... or on yoshi ...
                    BNE SPIN_KILL2           ; /     ... goto SPIN_KILL
                    STZ $1594,x
					LDA #$06
					STA $AA,x
					LDA #$08
					STA $15AC,x
RETURN_25           RTS
GOOB_WINS2			LDA $7D                 ; \  if mario's y speed < 10 ...
                    CMP #$10                ;  }   ... sprite will hurt mario
                    BMI GOOB_WINS 
					BRA MARIO_WINS3
SPIN_KILL2			BRA SPIN_KILL
CHECK2              JSL $01A7DC             ; check for mario/sprite contact
                    BCC RETURN_24           ; (carry set = contact)
                    LDA $1490               ; \ if mario star timer > 0 ...
                    BNE HAS_STAR2            ; /    ... goto HAS_STAR
                    LDA $140D               ; \  if mario is spin jumping...
                    ORA $187A               ;  }    ... or on yoshi ...
                    BNE SPIN_KILL           ; /     ... goto SPIN_KILL
					LDA #$03
					STA $1DF9
					LDA #$02
					STA $C2,x
					LDA #$10
					STA $15AC,x
					JSR SUB_GET_DIR         ; \  set new sprite direction
                    TYA
					EOR #$01
                    STA $157C,x             ; /
					RTS
HAS_STAR2 			BRA HAS_STAR
CHECK1              JSL $01A7DC             ; check for mario/sprite contact
                    BCC RETURN_24           ; (carry set = contact)
                    LDA $1490               ; \ if mario star timer > 0 ...
                    BNE HAS_STAR            ; /    ... goto HAS_STAR
                    LDA $7D                 ; \  if mario's y speed < 10 ...
                    CMP #$10                ;  }   ... sprite will hurt mario
                    BMI GOOB_WINS           ; /                       
                    
MARIO_WINS          JSR SUB_STOMP_PTS       ; give mario points
                    JSL $01AA33             ; set mario speed
                    JSL $01AB99             ; display contact graphic
                    LDA $140D               ; \  if mario is spin jumping...
                    ORA $187A               ;  }    ... or on yoshi ...
                    BNE SPIN_KILL           ; /     ... goto SPIN_KILL
                    LDA #$01
					STA $C2,x
					LDA #$FF
					STA $15AC,x
RETURN_24           RTS                     ; return 

GOOB_WINS           LDA $1497               ; \ if mario is invincible...
                    ORA $187A               ;  }  ... or mario on yoshi...
                    ORA $15D0,x             ; |   ...or sprite being eaten...
                    BNE RETURN2             ; /   ... return
                    JSR SUB_GET_DIR         ; \  set new sprite direction
                    TYA                     ;  }  
                    STA $157C,x             ; /
                    JSL $00F5B7             ; hurt mario
RETURN2             RTS                     ; return

STAR_SOUNDS         dcb $00,$13,$14,$15,$16,$17,$18,$19

SPIN_KILL           LDA #$04                ; \ status = 4 (being killed by spin jump)
                    STA $14C8,x             ; /   
                    LDA #$1F                ; \ set spin jump animation timer
                    STA $1540,x             ; /
                    JSL $07FC3B             ; show star animation
                    LDA #$08                ; \ play sound effect
                    STA $1DF9               ; /
                    RTS                     ; return
HAS_STAR            LDA #$02                ; \ status = 2 (being killed by star)
                    STA $14C8,x             ; /
                    LDA #$D0                ; \ set y speed
                    STA $AA,x               ; /
                    JSR SUB_GET_DIR        ; get new direction
                    LDA KILLED_X_SPEED,y    ; \ set x speed based on direction
                    STA $B6,x               ; /
                    INC $18D2               ; increment number consecutive enemies killed
                    LDA $18D2               ; \
                    CMP #$08                ;  | if consecutive enemies stomped >= 8, reset to 8
                    BCC NO_RESET2           ;  |
                    LDA #$08                ;  |
                    STA $18D2               ; /   
NO_RESET2           JSL $02ACE5             ; give mario points
                    LDY $18D2               ; \ 
                    CPY #$08                ;  | if consecutive enemies stomped < 8 ...
                    BCS NO_SOUND2           ;  |
                    LDA STAR_SOUNDS,y       ;  |    ... play sound effect
                    STA $1DF9               ; /
NO_SOUND2           RTS                     ; final return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; points routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_STOMP_PTS       PHY                     ; 
                    LDA $1697               ; \
                    CLC                     ;  | 
                    ADC $1626,x             ; / some enemies give higher pts/1ups quicker??
                    INC $1697               ; increase consecutive enemies stomped
                    TAY                     ;
                    INY                     ;
                    CPY #$08                ; \ if consecutive enemies stomped >= 8 ...
                    BCS NO_SOUND            ; /    ... don't play sound 
                    LDA STAR_SOUNDS,y       ; \ play sound effect
                    STA $1DF9               ; /   
NO_SOUND            TYA                     ; \
                    CMP #$08                ;  | if consecutive enemies stomped >= 8, reset to 8
                    BCC NO_RESET            ;  |
                    LDA #$08                ; /
NO_RESET            JSL $02ACE5             ; give mario points
                    PLY                     ;
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; DEL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SPRITE_DEL          LDA $E4,x
                    STA $7FFD01
                    LDA $14E0,x
                    STA $7FFD02
                    LDA $D8,x
                    STA $7FFD03
                    LDA $14D4,x
                    STA $7FFD04
					TXA
					STA $02
                    PHX
                    LDX #$09
LOOP1               LDA $151C,x
                    CMP #$77
                    BEQ LOOP3
					CPX $02
					BEQ LOOP3
                    LDA $14C8,x
                    BEQ LOOP3
                    CMP #$02
                    BEQ LOOP3
                    JSR NEAR_CHECK
                    TYA
                    BEQ LOOP3
                    LDA $9E,x
                    STA $7FFD05
                    JSR TYPE_CHECK
                    TYA
                    BEQ LOOP3
                    LDA #$02
                    STA $14C8,x
					LDA #$D0
					STA $00AA,x
                    LDA #$37
                    STA $1DFC
LOOP3               DEX
                    BPL LOOP1
                    PLX
                    RTS

NEAR_CHECK          LDY #$00
                    LDA $E4,x
                    SEC
                    SBC $7FFD01
                    STA $0F
                    LDA $14E0,x
                    SBC $7FFD02
                    CMP #$00
                    BEQ RIGHT_CHECK
                    CMP #$FF
                    BNE CHECK_E
                    LDA $0F
                    CMP #$F0
                    BCC CHECK_E
                    BRA VER_CHECK
RIGHT_CHECK         LDA $0F
                    CMP #$10
                    BCS CHECK_E
VER_CHECK           LDA $D8,x
                    SEC
                    SBC $7FFD03
                    STA $0F
                    LDA $14D4,x
                    SBC $7FFD04
                    CMP #$00
                    BEQ UNDER_CHECK
                    CMP #$FF
                    BNE CHECK_E
                    LDA $0F
                    CMP #$F0
                    BCC CHECK_E
                    BRA NEAR
UNDER_CHECK         LDA $0F
                    CMP #$10
                    BCS CHECK_E
NEAR                LDY #$01
CHECK_E             RTS

SPRITE              dcb $0E,$21,$2D,$2F,$35,$3E,$45,$59,$5A,$6B,$6C,$6D,$74,$75,$76,$77
                    dcb $78,$79,$7B,$80,$81,$B1,$B9,$C1,$C7,$C8,$52,$54,$55,$56,$57,$58
                    dcb $5B,$5C,$5D,$5E,$5F,$61,$62,$63,$64,$6A,$7D,$87,$8E,$9C,$A3,$B7
                    dcb $B8,$BA,$BB,$C0,$C4,$C6,$E0,$19,$89,$8C,$D9,$E6,$E8,$E9,$ED,$EF
                    dcb $F2,$F3,$F4,$F5,$D2,$2C,$85
TYPE_CHECK          LDY #$01
                    PHX
                    LDX #$46
S_LOOP              LDA $7FFD05
                    CMP SPRITE,x
                    BNE S_LOOP2
                    LDY #$00
S_LOOP2             DEX
                    BPL S_LOOP
                    PLX
                    RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

HORIZ_DISP          dcb $08,$F8,$08,$F8,$08,$F8,$08,$F8,$F8,$08,$F8,$08,$F8,$08,$F8,$08
VERT_DISP           dcb $F0,$F0,$00,$00,$F0,$F0,$00,$00,$F0,$F0,$00,$00,$F0,$F0,$00,$00
TILEMAP             dcb $24,$26,$44,$46,$28,$26,$48,$4A,$24,$26,$44,$46,$28,$26,$48,$4A
PROPERTIES          dcb $40,$00

HORIZ_DISP3          dcb $F8,$F8,$08,$08
TILEMAP3             dcb $0A,$06,$0A,$06


SUB_GFX             JSR GET_DRAW_INFO
					TYA
					STA $1504,x
					LDA $1594,x
					BEQ SUB_GFX0
					INY
					INY
					INY
					INY
SUB_GFX0
					PHX
					LDA $157C,x
					TAX
					LDA PROPERTIES,x
					STA $0F
					PLX
					
                    LDA $157C,x             ; \ $02 = direction
					ASL A
					ASL A
					ASL A
                    STA $02                 ; / 
                    
                    LDA $14                 ;\ 
                    LSR A                   ; |
                    LSR A                   ; |
                    LSR A                   ; |
                    CLC                     ; |
                    ADC $15E9               ; |
                    AND #$01                ; |
                    ASL A                   ; |
                    ASL A                   ; |
                    STA $03                 ; | $03 = index to frame start (0 or 4)
					
					
                    PHX                     ; /
                    
                    LDX #$03                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START          PHX                     ; push, current tile

                    TXA                     ; \ X = index of frame start + current tile
                    CLC                     ;  |
                    ADC $03                 ;  |
					ADC $02
                    TAX                     ; /

                    
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP,x        ; |
                    STA $0300,y             ; /
                    
                    LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP,x         ; |
                    STA $0301,y             ; /

                    LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /

                    PHX                     ;
                    LDX $15E9               ;
                    LDA $15F6,x             ; get palette info
                    PLX                     ;
                    ORA $0F
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties

                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START

                    PLX                     ; pull, X = sprite index
					LDA $1594,x
					BNE GFX_WING
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
GFX_WING			LDA $1504,x
					TAY
					PHX
					LDA $157C,x             ; \ $02 = direction
					ASL A
                    STA $02                 ; / 
                    
                    LDA $14                 ;\ 
                    LSR A                   ; |
                    LSR A                   ; |
                    LSR A                   ; |
                    CLC                     ; |
                    ADC $15E9               ; |
                    AND #$01                ; |
					CLC
					ADC $02
                    TAX
					

					LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP3,x        ; |
                    STA $0300,y             ; /
                    
                    LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC #$F4
                    STA $0301,y             ; /

                    LDA TILEMAP3,x           ; \ store tile
                    STA $0302,y             ; /

                    LDA #$07                    ;
                    ORA $0F
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
					PLX
					LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$04                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

HORIZ_DISP2          dcb $F8,$08,$F8,$08
VERT_DISP2           dcb $F0,$F0,$00,$00
TILEMAP2             dcb $20,$22,$40,$42


SUB_GFX2            JSR GET_DRAW_INFO       ;A:87BF X:0007 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1102 VC:066 00 FL:665
					
                    PHX                     ; /
                    
                    LDX #$03                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START2         PHX                     ; push, current tile
                    
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP2,x        ; |
                    STA $0300,y             ; /
                    
                    LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP2,x         ; |
                    STA $0301,y             ; /

                    LDA TILEMAP2,x           ; \ store tile
                    STA $0302,y             ; /

                    PHX                     ;
                    LDX $15E9               ;
                    LDA $15F6,x             ; get palette info
                    PLX                     ;
                    ORA #$00
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties

                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START2

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817                ; Y = 1 if contact

SUB_GET_DIR         LDY #$00                ;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
                    LDA $94                 ;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
                    SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
                    SBC $E4,x               ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
                    STA $0F                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
                    LDA $95                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
                    SBC $14E0,x             ;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
                    BPL LABEL16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
                    INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
LABEL16             RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642




