;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Boomerang Brother, by mikeyk
;;
;; Description: Similar to his role in SMB3, this guy throws boomerangs at Mario. 
;;
;; BIG FAT NOTE: This sprite depends on the boomerang sprite.  Make sure you insert the
;; boomerang as the very next sprite.  (ex. If this is sprite 1B, make the boomerang 1C)
;;
;; Uses first extra bit: NO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10


                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                   



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					STZ $157C,x
					STZ $15AC,x
					STZ $C2,x
					STZ $1528,x
					LDA $E4,x
					STA $1602,x
					LSR A
					STA $1570,x
					LDA #$05
					STA $7FF002
                    RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


STAR                INC $1558,x
RETURN              RTS                    
START_HB_CODE       LDA EXTRA_BITS,x
					AND #$04
					BNE GFX2
					JSR SUB_GFX_0             ; draw hammer bro gfx
					BRA MAIN
GFX2				JSR SUB_GFX2_0
MAIN                LDA $14C8,x             ; \ if hammer bro status != 8...
                    CMP #$02                ;  }   ... not (killed with spin jump [4] or star[2])
                    BEQ STAR
                    CMP #$08
                    BNE RETURN              ; /    ... return
                    LDA $9D                 ; \ if sprites locked...
                    BNE RETURN              ; /    ... return
                    
                    INC $1570,x             ; increment number of frames hammer bro has been on screen
					JSL $01802A             ; update position based on speed values
					JSR SUB_MODE
                    RTS                     ; return
					
X_SPEED				dcb $10,$F0
Y_SPEED				dcb $10,$F0
X_SPEED2			dcb $20,$E0
Y_SPEED2			dcb $20,$E0
X_SPEED3			dcb $40,$C0
X_SPEED4			dcb $30,$D0
X_SPEED5			dcb $28,$D8
X_SPEED6			dcb $20,$E0
X_SPEED7			dcb $18,$E8
SUB_MODE			LDA $7FF001
					BNE NOT_MODE0
					JSR MODE0
					RTS
NOT_MODE0			CMP #$01
					BNE NOT_MODE1
					LDA EXTRA_BITS,x
					AND #$04
					BNE NOT_MODE0_2
NOT_MODE0_1			JSR MODE1
					RTS
NOT_MODE0_2			LDA $7FF005
					BNE NOT_MODE0_1
					JSR MODE0
					RTS
NOT_MODE1			CMP #$02
					BNE NOT_MODE_2
					JSR MODE2
					RTS
NOT_MODE_2			JSR MODE3
					RTS
					
MODE0				JSR CHECK4
					LDA EXTRA_BITS,x
					AND #$04
					BNE MODE0_0
					LDA $15AC,x
					BEQ MODE0_0
					STA $7FF003
					CMP #$01
					BNE MODE0_0
					LDA #$05
					STA $7FF002
					LDA #$01
					STA $7FF001
MODE0_0				STZ $B6,x
					LDA $7FF003
					CMP #$E0
					BCS MODE0_3
					LDA $7FF002
					CMP #$09
					BEQ MODE0_4
					LDA $157C,x
					PHX
					TAX
					LDA X_SPEED,x
					PLX
					STA $B6,x
					BRA MODE0_3
MODE0_4				LDA $157C,x
					PHX
					TAX
					LDA X_SPEED2,x
					PLX
					STA $B6,x
MODE0_3				LDA $E4,x
					CMP #$21
					BCC MODE0_1
					CMP #$D0
					BCS MODE0_2
MODE0_E				RTS
MODE0_1				STZ $157C,x
					RTS
MODE0_2				LDA #$01
					STA $157C,x
					RTS
					
					
MODE1				JSR CHECK4
					LDA EXTRA_BITS,x
					AND #$04
					BNE MODE1_0
					LDA $C2,x
					BEQ MODE1_A
					LDA #$01
					STA $7FF005
MODE1_A				LDA $15AC,x
					BEQ MODE1_0
					STA $7FF003
					CMP #$01
					BNE MODE1_0
					LDA #$05
					STA $7FF002
					LDA #$02
					STA $7FF001
					STZ $C2,x
MODE1_0				JSR SPEED_DEC
					RTS
					
					
MODE2				STZ $C2,x
					JSR CHECK4
					LDA $1588,x
					AND #$04
					BEQ MODE2_0
					JSR Y_SPEED_DEC
MODE2_0				JSR X_SPEED_DEC
					LDA $E4,x
					CMP #$21
					BCC MODE2_1
					CMP #$D0
					BCS MODE2_2
MODE2_E				RTS
MODE2_1				STZ $157C,x
					RTS
MODE2_2				LDA #$01
					STA $157C,x
					RTS
					
MODE3				LDA #$02
					STA $14C8,x
					RTS


X_SPEED_DEC			LDA $1602,x
					CMP #$D0
					BEQ X_SPEED_DEC1
					CMP #$C0
					BEQ X_SPEED_DEC2
					CMP #$B0
					BEQ X_SPEED_DEC3
					CMP #$A0
					BEQ X_SPEED_DEC4
					CMP #$90
					BEQ X_SPEED_DEC5
					RTS
					
X_SPEED_DEC1		LDA $157C,x
					PHX
					TAX
					LDA X_SPEED3,x
					PLX
					STA $B6,x
					RTS
X_SPEED_DEC2		LDA $157C,x
					PHX
					TAX
					LDA X_SPEED4,x
					PLX
					STA $B6,x
					RTS
X_SPEED_DEC3		LDA $157C,x
					PHX
					TAX
					LDA X_SPEED5,x
					PLX
					STA $B6,x
					RTS
X_SPEED_DEC4		LDA $157C,x
					PHX
					TAX
					LDA X_SPEED6,x
					PLX
					STA $B6,x
					RTS
X_SPEED_DEC5		LDA $157C,x
					PHX
					TAX
					LDA X_SPEED7,x
					PLX
					STA $B6,x
					RTS
					
Y_SPEED_DEC			LDA $1602,x
					CMP #$D0
					BEQ Y_SPEED_DEC1
					CMP #$C0
					BEQ Y_SPEED_DEC2
					CMP #$B0
					BEQ Y_SPEED_DEC3
					CMP #$A0
					BEQ Y_SPEED_DEC4
					CMP #$90
					BEQ Y_SPEED_DEC5
					RTS
Y_SPEED_DEC1		LDA #$B0
					STA $AA,x
					RTS
Y_SPEED_DEC2		LDA #$D0
					STA $AA,x
					RTS
Y_SPEED_DEC3		LDA #$C0
					STA $AA,x
					RTS
Y_SPEED_DEC4		LDA #$90
					STA $AA,x
					RTS
Y_SPEED_DEC5		LDA #$A0
					STA $AA,x
					RTS
					
SPEED_DEC
					STZ $B6,x
					STZ $AA,x
					LDA $7FF003
					CMP #$E0
					BCS MODE1_UNDER_E
					
					LDA $C2,x
					BEQ MODE1_UNDER
					CMP #$01
					BEQ MODE1_LEFT
					CMP #$02
					BEQ MODE1_RIGHT
					CMP #$03
					BEQ MODE1_UP
					RTS
					
MODE1_UNDER			LDA $157C,x
					PHX
					TAX
					LDA $7FF002
					CMP #$09
					BEQ MODE1_UNDER_0
					LDA X_SPEED,x
					BRA MODE1_UNDER_0_1
MODE1_UNDER_0		LDA X_SPEED2,x
MODE1_UNDER_0_1		PLX
					STA $B6,x
					LDA $E4,x
					CMP #$21
					BCC MODE1_UNDER_1
					CMP #$D0
					BCS MODE1_UNDER_2
MODE1_UNDER_E		RTS
MODE1_UNDER_1		LDA $157C,x
					BEQ MODE1_UNDER_E
					LDA #$01
					STA $C2,x
					RTS
MODE1_UNDER_2		LDA $157C,x
					BNE MODE1_UNDER_E
					LDA #$02
					STA $C2,x
					RTS
MODE1_LEFT			BRA MODE1_LEFT2

MODE1_RIGHT			LDA $157C,x
					INC A
					AND #$01
					PHX
					TAX
					LDA $7FF002
					CMP #$09
					BEQ MODE1_RIGHT_0_1
					LDA Y_SPEED,x
					BRA MODE1_RIGHT_0_2
MODE1_RIGHT_0_1		LDA Y_SPEED2,x
MODE1_RIGHT_0_2		PLX
					STA $AA,x
					STZ $B6,x
					LDA $14D4,x
					BNE MODE1_RIGHT_0
					LDA $D8,x
					CMP #$E0
					BCC MODE1_RIGHT_1
					BRA MODE1_RIGHT_3
MODE1_RIGHT_0		LDA $D8,x
					CMP #$70
					BCS MODE1_RIGHT_2
MODE1_RIGHT_3		RTS
MODE1_RIGHT_1		LDA $157C,x
					BNE MODE1_RIGHT_3
					LDA #$03
					STA $C2,x
					RTS
MODE1_RIGHT_2		LDA $157C,x
					BEQ MODE1_RIGHT_3
					STZ $C2,x
					RTS
					
MODE1_UP			BRA MODE1_UP2
MODE1_LEFT2			LDA $157C,x
					PHX
					TAX
					LDA $7FF002
					CMP #$09
					BEQ MODE1_LEFT_0_1
					LDA Y_SPEED,x
					BRA MODE1_LEFT_0_2
MODE1_LEFT_0_1		LDA Y_SPEED2,x
MODE1_LEFT_0_2
					PLX
					STA $AA,x
					STZ $B6,x
					LDA $14D4,x
					BNE MODE1_LEFT_0
					LDA $D8,x
					CMP #$E0
					BCC MODE1_LEFT_1
					BRA MODE1_LEFT_3
MODE1_LEFT_0		LDA $D8,x
					CMP #$70
					BCS MODE1_LEFT_2
MODE1_LEFT_3		RTS
MODE1_LEFT_1		LDA $157C,x
					BEQ MODE1_LEFT_3
					LDA #$03
					STA $C2,x
					RTS
MODE1_LEFT_2		LDA $157C,x
					BNE MODE1_LEFT_3
					STZ $C2,x
					RTS
					
					
MODE1_UP2			LDA $157C,x
					INC A
					AND #$01
					PHX
					TAX
					LDA $7FF002
					CMP #$09
					BEQ MODE1_UP_0
					LDA X_SPEED,x
					BRA MODE1_UP_0_2
MODE1_UP_0			LDA X_SPEED2,x
MODE1_UP_0_2
					PLX
					STA $B6,x
					STZ $AA,x
					LDA $E4,x
					CMP #$21
					BCC MODE1_UP_1
					CMP #$D0
					BCS MODE1_UP_2
MODE1_UP_E			RTS
MODE1_UP_1			LDA $157C,x
					BNE MODE1_UP_E
					LDA #$01
					STA $C2,x
					RTS
MODE1_UP_2			LDA $157C,x
					BEQ MODE1_UP_E
					LDA #$02
					STA $C2,x
					RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Contact Mario
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CHECK4              JSL $01A7DC             ; check for mario/sprite contact
                    BCC RETURN_25           ; (carry set = contact)
                    LDA $D8,x
					SEC
					SBC $96
					STA $0F
                    LDA $14D4,x
					SBC $97
                    BCC GOOB_WINS2           ; /
					LDA $0F
					CMP #$18
					BCC GOOB_WINS2
MARIO_WINS3			JSL $01AA33             ; set mario speed
                    JSL $01AB99             ; display contact graphic
					LDA $C2,x
					BNE MARIO_WINS5
					LDA EXTRA_BITS,x
					AND #$04
					BEQ MARIO_WINS
MARIO_WINS5			LDA #$03
					STA $1DF9
RETURN_25           RTS

GOOB_WINS2			LDA $7D                 ; \  if mario's y speed < 10 ...
                    CMP #$10                ;  }   ... sprite will hurt mario
                    BMI GOOB_WINS 
					BRA MARIO_WINS3

GOOB_WINS           LDA $1497               ; \ if mario is invincible...
                    BNE RETURN2             ; /   ... return
                    JSL $00F5B7             ; hurt mario
RETURN2             RTS                     ; return

MARIO_WINS			LDA $7FF002
					CMP #$09
					BEQ MARIO_WINS2
					LDA $7FF001
					CMP #$02
					BEQ THE_LAST
					LDA #$28
					STA $1DFC
					LDA #$FF
					STA $15AC,x
					LDA #$09
					STA $7FF002
					RTS
MARIO_WINS2			LDA #$03
					STA $1DF9
					RTS
THE_LAST			LDA #$1E
					STA $1DFB
					LDA #$28
					STA $1DFC
					LDA #$03
					STA $7FF001
					JSR KEY_GEN
					RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SUB_GFX_0			LDA $C2,x
					BNE SUB_GFX_0_1
					JSR SUB_GFX
					RTS
SUB_GFX_0_1			CMP #$01
					BNE SUB_GFX_0_2
					JSR SUB_GFX_1
					RTS
SUB_GFX_0_2			CMP #$02
					BNE SUB_GFX_0_3
					JSR SUB_GFX_2
					RTS
SUB_GFX_0_3			JSR SUB_GFX_3
					RTS
SUB_GFX2_0			LDA $C2,x
					BNE SUB_GFX2_0_1
					JSR SUB_GFX2
					RTS
SUB_GFX2_0_1		CMP #$01
					BNE SUB_GFX2_0_2
					JSR SUB_GFX2_1
					RTS
SUB_GFX2_0_2		CMP #$02
					BNE SUB_GFX2_0_3
					JSR SUB_GFX2_2
					RTS
SUB_GFX2_0_3		JSR SUB_GFX2_3
					RTS


TILEMAP             dcb $02,$04,$22,$24,$20,$02,$04,$22,$24,$20
HORZ_DISP			dcb $08,$F8,$08,$F8,$F8,$F8,$08,$F8,$08,$08
VERT_DISP           dcb $F2,$F2,$02,$02,$E4,$F2,$F2,$02,$02,$E4
PROPERTIES          dcb $40,$00

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
               ; /
                    LDA $1570,x
					LSR A
					AND #$0F
					STA $0F
					CMP #$08
					BCC SUB_GFX0
					LDA #$10
					SEC
					SBC $0F
					STA $0F
SUB_GFX0			LDA $157C,x             ; \ $02 = sprite direction
                    STA $02                 ; /
					PHX                     ; push sprite index

                    LDX #$04                ; loop counter = (number of tiles per frame) - 1
LOOP_START          PHX                     ; push current tile number
                    LDA $7FF002
					STA $03
					CPX #$04
					BNE ADJ2
					LDA #$0B
					STA $03
ADJ2
                    
NO_ADJ              PHX
					TXA
					CLC
					ADC $02
					ADC $02
					ADC $02
					ADC $02
					ADC $02
					TAX
					
					LDA $00
					CLC                     ;  |
                    ADC HORZ_DISP,x         ;  |
                    STA $0300,y             ; /                    

                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP,x         ;  |
					SBC $0F
                    STA $0301,y             ; /
                    

                    LDA TILEMAP,x           ; \ store tile
					CMP #$02
					BEQ FACE1
					CMP #$04
					BEQ FACE2
NO_FACE             LDA TILEMAP,x           ; \ store tile
					STA $0302,y             ; / 
					BRA FACE_E
					
FACE1				LDA $7FF002
					CMP #$09
					BNE NO_FACE
					LDA #$06
					STA $0302,y
					BRA FACE_E
FACE2				LDA $7FF002
					CMP #$09
					BNE NO_FACE
					LDA #$08
					STA $0302,y

FACE_E				PLX
					
					LDX $02                 ; \
					LDA PROPERTIES,x        ;  | get tile properties using sprite direction
                    ORA $03
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$04                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP_1            dcb $82,$84,$A2,$A4,$A0,$82,$84,$A2,$A4,$A0
HORZ_DISP_1			 dcb $FA,$0A,$FA,$0A,$18,$FA,$0A,$FA,$0A,$18
VERT_DISP_1          dcb $00,$00,$F0,$F0,$F0,$F0,$F0,$00,$00,$00
PROPERTIES_1         dcb $80,$00

SUB_GFX_1             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
               ; /
                    LDA $1570,x
					LSR A
					AND #$0F
					STA $0F
					CMP #$08
					BCC SUB_GFX0_1
					LDA #$10
					SEC
					SBC $0F
					STA $0F
SUB_GFX0_1			LDA $157C,x             ; \ $02 = sprite direction
                    STA $02                 ; /
					PHX                     ; push sprite index

                    LDX #$04                ; loop counter = (number of tiles per frame) - 1
LOOP_START_1        PHX                     ; push current tile number
                    LDA $7FF002
					STA $03
					CPX #$04
					BNE ADJ2_1
					LDA #$0B
					STA $03
ADJ2_1
                    
NO_ADJ              PHX
					TXA
					CLC
					ADC $02
					ADC $02
					ADC $02
					ADC $02
					ADC $02
					TAX
					
					LDA $00
					CLC                     ;  |
                    ADC HORZ_DISP_1,x         ;  |
					ADC $0F
                    STA $0300,y             ; /      
					              

                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP_1,x         ;  |
                    STA $0301,y             ; /
                    
                    LDA TILEMAP_1,x           ; \ store tile
					CMP #$84
					BEQ FACE1_1
					CMP #$A4
					BEQ FACE2_1
NO_FACE_1           LDA TILEMAP_1,x           ; \ store tile
					STA $0302,y             ; / 
					BRA FACE_E_1
					
FACE1_1				LDA $7FF002
					CMP #$09
					BNE NO_FACE_1
					LDA #$86
					STA $0302,y
					BRA FACE_E_1
FACE2_1				LDA $7FF002
					CMP #$09
					BNE NO_FACE_1
					LDA #$A6
					STA $0302,y

FACE_E_1				PLX
					
					LDX $02                 ; \
					LDA PROPERTIES_1,x        ;  | get tile properties using sprite direction
                    ORA $03
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START_1         ; / 

                    PLX                     ; pull, X = sprite index
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$04                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP_2            dcb $84,$82,$A4,$A2,$A0,$84,$82,$A4,$A2,$A0
HORZ_DISP_2			 dcb $F6,$06,$F6,$06,$E8,$F6,$06,$F6,$06,$E8,
VERT_DISP_2          dcb $F0,$F0,$00,$00,$00,$00,$00,$F0,$F0,$F0
PROPERTIES_2         dcb $40,$C0

SUB_GFX_2             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
               ; /
                    LDA $1570,x
					LSR A
					AND #$0F
					STA $0F
					CMP #$08
					BCC SUB_GFX0_2
					LDA #$10
					SEC
					SBC $0F
					STA $0F
SUB_GFX0_2			LDA $157C,x             ; \ $02 = sprite direction
                    STA $02                 ; /
					PHX                     ; push sprite index

                    LDX #$04                ; loop counter = (number of tiles per frame) - 1
LOOP_START_2        PHX                     ; push current tile number
                    LDA $7FF002
					STA $03
					CPX #$04
					BNE ADJ2_2
					LDA #$0B
					STA $03
ADJ2_2
                    
NO_ADJ              PHX
					TXA
					CLC
					ADC $02
					ADC $02
					ADC $02
					ADC $02
					ADC $02
					TAX
					
					LDA $00
					CLC                     ;  |
                    ADC HORZ_DISP_2,x         ;  |
					ADC $0F
                    STA $0300,y             ; /      
             

                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP_2,x         ;  |
                    STA $0301,y             ; /
                    

                    LDA TILEMAP_2,x           ; \ store tile
					CMP #$84
					BEQ FACE1_2
					CMP #$A4
					BEQ FACE2_2
NO_FACE_2           LDA TILEMAP_2,x           ; \ store tile
					STA $0302,y             ; / 
					BRA FACE_E_2
					
FACE1_2				LDA $7FF002
					CMP #$09
					BNE NO_FACE_2
					LDA #$86
					STA $0302,y
					BRA FACE_E_2
FACE2_2				LDA $7FF002
					CMP #$09
					BNE NO_FACE_2
					LDA #$A6
					STA $0302,y

FACE_E_2				PLX
					
					LDX $02                 ; \
					LDA PROPERTIES_2,x        ;  | get tile properties using sprite direction
                    ORA $03
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START_2         ; / 

                    PLX                     ; pull, X = sprite index
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$04                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP_3           dcb $02,$04,$22,$24,$20,$02,$04,$22,$24,$20
HORZ_DISP_3			dcb $F8,$08,$F8,$08,$08,$08,$F8,$08,$F8,$F8
VERT_DISP_3         dcb $02,$02,$F2,$F2,$10,$02,$02,$F2,$F2,$10
PROPERTIES_3        dcb $80,$C0

SUB_GFX_3             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
               ; /
                    LDA $1570,x
					LSR A
					AND #$0F
					STA $0F
					CMP #$08
					BCC SUB_GFX0_3
					LDA #$10
					SEC
					SBC $0F
					STA $0F
SUB_GFX0_3			LDA $157C,x             ; \ $02 = sprite direction
                    STA $02                 ; /
					PHX                     ; push sprite index

                    LDX #$04                ; loop counter = (number of tiles per frame) - 1
LOOP_START_3          PHX                     ; push current tile number
                   LDA $7FF002
					STA $03
					CPX #$04
					BNE ADJ2_3
					LDA #$0B
					STA $03
ADJ2_3
                    
NO_ADJ              PHX
					TXA
					CLC
					ADC $02
					ADC $02
					ADC $02
					ADC $02
					ADC $02
					TAX
					
					LDA $00
					CLC                     ;  |
                    ADC HORZ_DISP_3,x         ;  |
                    STA $0300,y             ; /      
             

                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP_3,x         ;  |
					SBC $0F
                    STA $0301,y             ; /
                    

                    LDA TILEMAP_3,x           ; \ store tile
					CMP #$02
					BEQ FACE1_3
					CMP #$04
					BEQ FACE2_3
NO_FACE_3             LDA TILEMAP_3,x           ; \ store tile
					STA $0302,y             ; / 
					BRA FACE_E_3
					
FACE1_3				LDA $7FF002
					CMP #$09
					BNE NO_FACE_3
					LDA #$06
					STA $0302,y
					BRA FACE_E_3
FACE2_3				LDA $7FF002
					CMP #$09
					BNE NO_FACE_3
					LDA #$08
					STA $0302,y

FACE_E_3				PLX
					
					LDX $02                 ; \
					LDA PROPERTIES_3,x        ;  | get tile properties using sprite direction
                    ORA $03
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START_3          ; / 

                    PLX                     ; pull, X = sprite index
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$04                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP2            dcb $40,$42,$60,$62,$40,$42,$60,$62
					dcb $44,$46,$64,$66,$44,$46,$64,$66
					dcb $48,$4A,$68,$6A,$48,$4A,$68,$6A
					dcb $44,$46,$64,$66,$44,$46,$64,$66
HORZ_DISP2			dcb $08,$F8,$08,$F8,$F8,$08,$F8,$08
VERT_DISP2          dcb $F0,$F0,$00,$00,$F0,$F0,$00,$00
PROPERTIES2         dcb $40,$00

SUB_GFX2             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
               ; /
                    LDA $157C,x             ; \ $02 = sprite direction
                    STA $02                 ; /
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					ASL A
					ASL A
					ASL A
					STA $03
					PHX                     ; push sprite index

                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START2          PHX                     ; push current tile number
                   
                    
	                PHX
					TXA
					CLC
					ADC $02
					ADC $02
					ADC $02
					ADC $02
					TAX
					
					LDA $00
					CLC                     ;  |
                    ADC HORZ_DISP2,x         ;  |
                    STA $0300,y             ; /                    

                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP2,x         ;  |
                    STA $0301,y             ; /
                    

					TXA
					CLC
					ADC $03
					TAX
                    LDA TILEMAP2,x           ; \ store tile
                    STA $0302,y             ; / 
					PLX
        
                    LDX $02                 ; \
                    LDA PROPERTIES2,x        ;  | get tile properties using sprite direction
                    ORA $7FF002
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START2          ; / 

                    PLX                     ; pull, X = sprite index
                    
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP2_1          dcb $C0,$C2,$E0,$E2,$C0,$C2,$E0,$E2
					dcb $C4,$C6,$E4,$E6,$C4,$C6,$E4,$E6
					dcb $C8,$CA,$E8,$EA,$C8,$CA,$E8,$EA
					dcb $C4,$C6,$E4,$E6,$C4,$C6,$E4,$E6
HORZ_DISP2_1		dcb $F8,$08,$F8,$08,$F8,$08,$F8,$08
VERT_DISP2_1        dcb $00,$00,$F0,$F0,$F0,$F0,$00,$00
PROPERTIES2_1       dcb $80,$00

SUB_GFX2_1          JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
               ; /
                    LDA $157C,x             ; \ $02 = sprite direction
                    STA $02                 ; /
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					ASL A
					ASL A
					ASL A
					STA $03
					PHX                     ; push sprite index

                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START2_1       PHX                     ; push current tile number
                   
                    
	                PHX
					TXA
					CLC
					ADC $02
					ADC $02
					ADC $02
					ADC $02
					TAX
					
					LDA $00
					CLC                     ;  |
                    ADC HORZ_DISP2_1,x         ;  |
                    STA $0300,y             ; /                    

                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP2_1,x         ;  |
                    STA $0301,y             ; /
                    

					TXA
					CLC
					ADC $03
					TAX
                    LDA TILEMAP2_1,x           ; \ store tile
                    STA $0302,y             ; / 
					PLX
        
                    LDX $02                 ; \
                    LDA PROPERTIES2_1,x        ;  | get tile properties using sprite direction
                    ORA $7FF002
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START2_1          ; / 

                    PLX                     ; pull, X = sprite index
                    
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP2_2          dcb $C0,$C2,$E0,$E2,$C0,$C2,$E0,$E2
					dcb $C4,$C6,$E4,$E6,$C4,$C6,$E4,$E6
					dcb $C8,$CA,$E8,$EA,$C8,$CA,$E8,$EA
					dcb $C4,$C6,$E4,$E6,$C4,$C6,$E4,$E6
HORZ_DISP2_2		dcb $08,$F8,$08,$F8,$08,$F8,$08,$F8
VERT_DISP2_2        dcb $F0,$F0,$00,$00,$00,$00,$F0,$F0
PROPERTIES2_2       dcb $40,$C0

SUB_GFX2_2          JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
               ; /
                    LDA $157C,x             ; \ $02 = sprite direction
                    STA $02                 ; /
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					ASL A
					ASL A
					ASL A
					STA $03
					PHX                     ; push sprite index

                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START2_2       PHX                     ; push current tile number
                   
                    
	                PHX
					TXA
					CLC
					ADC $02
					ADC $02
					ADC $02
					ADC $02
					TAX
					
					LDA $00
					CLC                     ;  |
                    ADC HORZ_DISP2_2,x         ;  |
                    STA $0300,y             ; /                    

                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP2_2,x         ;  |
                    STA $0301,y             ; /
                    

					TXA
					CLC
					ADC $03
					TAX
                    LDA TILEMAP2_2,x           ; \ store tile
                    STA $0302,y             ; / 
					PLX
        
                    LDX $02                 ; \
                    LDA PROPERTIES2_2,x        ;  | get tile properties using sprite direction
                    ORA $7FF002
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START2_2          ; / 

                    PLX                     ; pull, X = sprite index
                    
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP2_3          dcb $40,$42,$60,$62,$40,$42,$60,$62
					dcb $44,$46,$64,$66,$44,$46,$64,$66
					dcb $48,$4A,$68,$6A,$48,$4A,$68,$6A
					dcb $44,$46,$64,$66,$44,$46,$64,$66
HORZ_DISP2_3		dcb $F8,$08,$F8,$08,$08,$F8,$08,$F8
VERT_DISP2_3        dcb $00,$00,$F0,$F0,$00,$00,$F0,$F0
PROPERTIES2_3       dcb $80,$C0

SUB_GFX2_3          JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
               ; /
                    LDA $157C,x             ; \ $02 = sprite direction
                    STA $02                 ; /
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					ASL A
					ASL A
					ASL A
					STA $03
					PHX                     ; push sprite index

                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START2_3       PHX                     ; push current tile number
                   
                    
	                PHX
					TXA
					CLC
					ADC $02
					ADC $02
					ADC $02
					ADC $02
					TAX
					
					LDA $00
					CLC                     ;  |
                    ADC HORZ_DISP2_3,x         ;  |
                    STA $0300,y             ; /                    

                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP2_3,x         ;  |
                    STA $0301,y             ; /
                    

					TXA
					CLC
					ADC $03
					TAX
                    LDA TILEMAP2_3,x           ; \ store tile
                    STA $0302,y             ; / 
					PLX
        
                    LDX $02                 ; \
                    LDA PROPERTIES2_3,x        ;  | get tile properties using sprite direction
                    ORA $7FF002
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START2_3          ; / 

                    PLX                     ; pull, X = sprite index
                    
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN68            RTS
KEY_GEN             JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated
					
					LDA #$09                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    
					LDA #$80
                    STA $009E,y
                    
                    LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

                    LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    PLX
					;LDA #$C0
					;STA $00AA,y
                    RTS                          ; return
