;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 64hat
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


EXTRA_BITS = $7FAB10
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA EXTRA_BITS,x
					AND #$04
					BEQ INIT_RTL
					LDA #$03
					STA $1504,x
					STZ $0DBF
INIT_RTL            RTL
                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  |
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
START_HB_CODE		LDA $1504,x
					BNE MAIN1
					JSR INVI_HAT
					RTS
MAIN1				CMP #$01
					BNE MAIN2
					JSR METAL_HAT
					RTS
MAIN2				CMP #$02
					BNE MAIN3
					JSR WING_HAT
					RTS
MAIN3				CMP #$03
					BNE MAIN4
					JSR ASM
					RTS
MAIN4				JSR STAR
					RTS



RETURN				RTS
INVI_HAT	        JSR SUB_GFX_HAT
					LDA $9D
					BNE RETURN
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSL $01802A
					LDA $1570,x
					CMP #$10
					BCS INVI_HAT_1
					INC $1570,x
					RTS
INVI_HAT_1			LDA #$19
					STA $1686,x
					LDA #$01
					STA $C2,x
					JSL $01A7DC
					BCC RETURN
					STZ $14C8,x
					LDA #$FF
					STA $7FFFD0
					LDA #$22
					STA $1DFB
					LDA #$0A
					STA $1DF9
					RTS
					
RETURN2				RTS
METAL_HAT	        JSR SUB_GFX_HAT
					LDA $9D
					BNE RETURN2
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSR STAR_DUST
					JSL $01802A
					LDA $1570,x
					CMP #$10
					BCS METAL_HAT_1
					INC $1570,x
					RTS
METAL_HAT_1			LDA #$19
					STA $1686,x
					LDA #$01
					STA $C2,x
					JSL $01A7DC
					BCC RETURN2
					STZ $14C8,x
					LDA #$FF
					STA $7FFFD1
					LDA #$22
					STA $1DFB
					LDA #$0A
					STA $1DF9
					RTS
					
RETURN2				RTS
WING_HAT	        JSR SUB_GFX_HAT
					LDA $9D
					BNE RETURN2
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSL $01802A
					LDA $1570,x
					CMP #$10
					BCS WING_HAT_1
					INC $1570,x
					RTS
WING_HAT_1			LDA #$19
					STA $1686,x
					LDA #$01
					STA $C2,x
					JSL $01A7DC
					BCC RETURN2
					STZ $14C8,x
					LDA #$FF
					STA $7FFFD2
					LDA #$22
					STA $1DFB
					LDA #$0A
					STA $1DF9
					RTS
					
HORIZ_DISP          dcb $00,$0A
VERT_DISP           dcb $04,$FE
TILEMAP             dcb $88,$C6

SUB_GFX_HAT        JSR GET_DRAW_INFO
					LDA $C2,x
					STA $0F
					STZ $02
					LDA #$0F
					STA $03
					LDA $1504,x
					BEQ SUB_GFX_HAT_1
					LDA #$03
					STA $03
					LDA $1504,x
					CMP #$02
					BNE SUB_GFX_HAT_1
					LDA #$0D
					STA $03
					LDA #$01
					STA $02
SUB_GFX_HAT_1		PHX
                    LDX $02
LOOP_START          LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /
					
					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP,x         ; |
                    STA $0301,y             ; /
					
					LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP,x        ; |
                    STA $0300,y             ; /
                    LDA $03
                    STA $0303,y             ; store tile properties
					LDA $0F
					BEQ LBL200
					LDA $0303,y
					ORA $64
					STA $0303,y
LBL200
					CPX #$00
					BEQ SUB_GFX_HAT_2
					LDA #$0C
					STA $0303,y
					LDA $0F
					BEQ SUB_GFX_HAT_2
					LDA $0303,y
					ORA $64
					STA $0303,y
SUB_GFX_HAT_2
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA $02
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
SUB_GFX_STAR		JSR GET_DRAW_INFO
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA #$48
					STA $0302,y
					LDA #$04
					ORA $64
					STA $0303,y
					LDY #$02
                    LDA #$00
                    JSL $01B7B3
                    RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
					
STAR_DUST			LDA $14   ;#ʓɂƂ̂݌鏈ɂ
					AND #$07
					BNE STARDUST_R
					JSL $01ACF9
					AND #$0F
					CLC
					LDY #$00
					ADC #$FC
					BPL STARDUST_2
					DEY
STARDUST_2			CLC
					ADC $E4,x
					STA $02
					TYA
					ADC $14E0,x
					PHA
					LDA $02
					CMP $1A
					PLA
					SBC $1B
					BNE STARDUST_R
					LDA $148E
					AND #$0F
					CLC
					ADC #$FE
					ADC $D8,x
					STA $00
					LDA $14D4,x
					ADC #$00
					STA $01
					JSL $0285BA
STARDUST_R			RTS



ASM					JSR SPRITE_ROUTINE
					STZ $149F
					LDA $19
					BNE LBL300
					LDA #$01
					STA $19
LBL300				LDA $0DBF
					CMP #$63
					BNE LBL301
					LDA #$01
					STA $151C,x
LBL301				LDA $151C,x
					BEQ LBL302
					LDA $0DBF
					BNE LBL302
					LDA $76
					STA $7FFA76
					LDA $13E0
					STA $7FFAE0
					LDA $13DF
					STA $7FFADF
					LDA $96
					STA $7FFA96
					LDA $97
					STA $7FFA97
					LDA #$FF
					STA $18BD
					STA $15AC,x
					LDA #$1E
					STA $1DFB
					LDA #$04
					STA $1504,x
					RTS
LBL302				LDA #$01
					STA $1404
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					STA $D8,x
					LDA $97
					STA $14D4,x
					
					JSR WING_CHECK
					JSR WATER
					JSR INVISI_CHECK
					JSR METAL_CHECK
					RTS
					
STAR				LDA $15AC,x
					CMP #$80
					BCC STAR_1
					JSR SUB_GFX_STAR
STAR_1				LDA $9D
					BNE STAR_R
					JSR STAR_DUST
					LDA $7FFA76
					STA $76
					LDA $7FFAE0
					STA $13E0
					LDA $7FFADF
					STA $13DF
					LDA $7FFA96
					STA $96
					LDA $7FFA97
					STA $97
					LDA #$FF
					STA $18BD
					LDA $15AC,x
					CMP #$D0
					BCS STAR_2
					CMP #$A0
					BCS STAR_R
					CMP #$70
					BCS STAR_3
					CMP #$6F
					BEQ STAR_4
STAR_R				RTS
STAR_2				LDA #$E8
					STA $AA,x
					JSL $01801A
					RTS
STAR_3				LDA #$18
					STA $AA,x
					JSL $01801A
					RTS
STAR_4				LDA #$0C
					STA $1DFB
					LDA #$FF
                    STA $1493
					LDA #$01
					STA $141C ;#BS[tO
					STZ $14C8,x
RETURN001			RTS

					
WATER				LDA $75
					BEQ WATER_R
					LDA $9D
					BNE WATER_R
					LDA $7FFFD1
					BNE WATER_3
					LDA $7D
					CMP #$80
					BCC WATER_2
					CMP #$D0
					BCC WATER_R
WATER_2				DEC $7D
WATER_R				RTS
WATER_3				LDA $7D
					CMP #$80
					BCS WATER_5
					CMP #$30
					BCS WATER_R
					INC $7D
					RTS
WATER_5				STZ $7D
					RTS
					
					
INVISI_CHECK		LDA $9D
					BNE INVI_2
					LDA $7FFFD0
					BEQ RETURN1
					LDA $14
					AND #$03
					BNE INVI_2
					LDA $7FFFD0
					DEC A
					STA $7FFFD0
					CMP #$10
					BNE INVI_2
					LDA $7FFFD1
					CMP #$11
					BCS INVI_2
					LDA $7FFFD2
					CMP #$11
					BCS INVI_2
					LDA #$21
					STA $1DFB
INVI_2				LDA #$88
					STA $2121
					LDA #$00
					STA $2122
					LDA #$28
					STA $2122
					LDA #$89
					STA $2121
					LDA #$0C
					STA $2122
					LDA #$7D
					STA $2122
					LDA #$8D
					STA $2121
					LDA #$A5
					STA $2122
					LDA #$5C
					STA $2122
					LDA $14
					AND #$02
					BEQ RETURN1
					LDA #$13
					STA $78
RETURN1				RTS

NOT_METAL			JSR DEF_COLOR
					STZ $1490
					RTS
METAL_CHECK			LDA $7FFFD1
					BEQ NOT_METAL
					LDA $9D
					BNE METAL_2
					LDA #$FF
					STA $1490
					LDA $7FFFD2
					BNE METAL_1
					REP #$20
					INC $96
					INC $96
					SEP #$20
METAL_1				LDA $14
					AND #$03
					BNE METAL_2
					LDA $7FFFD1
					DEC A
					STA $7FFFD1
					CMP #$10
					BNE METAL_2
					LDA $7FFFD0
					CMP #$11
					BCS METAL_2
					LDA $7FFFD2
					CMP #$11
					BCS METAL_2
					LDA #$21
					STA $1DFB
METAL_2				LDA $14
					AND #$04
					BEQ METAL_3
					JSR METAL_COLOR1
					RTS
METAL_3				JSR METAL_COLOR2
RETURN2				RTS

WING_CHECK			LDA $9D
					BNE RETURN3
					LDA $7FFFD2
					BEQ RETURN3
					LDA $14
					AND #$03
					BNE WING_2
					LDA $7FFFD2
					DEC A
					STA $7FFFD2
					CMP #$10
					BNE WING_2
					LDA $7FFFD0
					CMP #$11
					BCS WING_2
					LDA $7FFFD1
					CMP #$11
					BCS WING_2
					LDA #$21
					STA $1DFB
WING_2				JSR FLY
RETURN3				RTS

FLY					LDA $C2,x
					BEQ ON_GROUND
					LDA $77
					AND #$04
					BNE BACK
					LDA $1528,x
					STA $7D
					JSR CONTROL
					RTS
BACK				STZ $C2,x
					RTS
ON_GROUND			LDA $77
					AND #$04
					BNE FLY_R
					LDA $7D
					BPL FLY_R
					STA $1528,x
					LDA #$01
					STA $C2,x
FLY_R				RTS

CONTROL				LDA #$0C
					STA $13E0
					JSR SPEED_CHECK
					LDA $77
					AND #$08
					BEQ CONTROL_2
					LDA $1528,x
					BPL CONTROL_2
					STZ $1528,x
CONTROL_2			LDA $15
					AND #$0C
					BEQ NO_PRESS
					CMP #$08
					BEQ UP
					BRA DOWN
CONTROL_R			RTS
NO_PRESS			LDA $14
					AND #$07
					BNE CONTROL_R
					LDA $1528,x
					BMI NO_PRESS_2
					CMP #$18
					BCS NO_PRESS_3
NO_PRESS_2			INC $1528,x
					RTS
NO_PRESS_3			LDA #$18
					STA $1528,x
					RTS
DOWN				LDA $14
					AND #$03
					BNE CONTROL_R
					LDA $1528,x
					BMI DOWN_2
					CMP #$28
					BCS CONTROL_R
DOWN_2				INC $1528,x
					RTS
UP					LDA $14
					AND #$03
					BNE CONTROL_R
					LDA $1528,x
					BPL UP_2
					CMP #$E8
					BCC CONTROL_R
UP_2				DEC $1528,x
					RTS
SPEED_CHECK			LDA $7D
					BMI SPEED_CHECK_2
					LDA $75
					BNE WATER_FLY
					LDA $7D
					CMP #$28
					BCC SPEED_CHECK_R
					LDA #$28
					STA $1528,x
SPEED_CHECK_R		RTS
SPEED_CHECK_2		CMP #$E8
					BCS SPEED_CHECK_R
					LDA #$E8
					STA $1528,x
					RTS
WATER_FLY			STZ $1528,x
					RTS

DEF_COLOR			LDA #$81
					STA $2121
					LDA #$FF
					STA $2122
					LDA #$7F
					STA $2122
					LDA #$82
					STA $2121
					LDA #$00
					STA $2122
					STA $2122
					LDA #$83
					STA $2121
					LDA #$71
					STA $2122
					LDA #$0D
					STA $2122
					LDA #$84
					STA $2121
					LDA #$9B
					STA $2122
					LDA #$1E
					STA $2122
					LDA #$85
					STA $2121
					LDA #$7F
					STA $2122
					LDA #$3B
					STA $2122
					RTS

METAL_COLOR_TBL1	dcb $29,$63,$4A,$08,$4A,$10,$1D,$63,$52,$4A,$CE,$07,$CE,$C6,$C6
METAL_COLOR_TBL2	dcb $25,$0C,$29,$1D,$29,$3E,$58,$0C,$4A,$29,$39,$21,$39,$18,$18

METAL_COLOR1		PHX
					LDY #$81
					LDX #$00
					
METAL_COLOR1_LOOP	STY $2121
					LDA METAL_COLOR_TBL1,x
					STA $2122
					LDA METAL_COLOR_TBL2,x
					STA $2122
					INY
					INX
					CPX #$0F
					BCC METAL_COLOR1_LOOP
					PLX
					RTS
					
METAL_COLOR_TBL3	dcb $31,$63,$C6,$29,$C6,$CE,$1D,$10,$29,$4A,$00,$C6,$31,$08,$31
METAL_COLOR_TBL4	dcb $46,$0C,$18,$21,$18,$39,$58,$42,$25,$29,$00,$18,$46,$21,$46

METAL_COLOR2		PHX
					LDY #$81
					LDX #$00
METAL_COLOR2_LOOP	STY $2121
					LDA METAL_COLOR_TBL3,x
					STA $2122
					LDA METAL_COLOR_TBL4,x
					STA $2122
					INY
					INX
					CPX #$0F
					BCC METAL_COLOR2_LOOP
					PLX
					RTS

SUB_GFX_WING        JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					STZ $02
					LDA #$08
					STA $03
					LDA $76
					BEQ SUB_GFX_WING_2
					LDA #$40
					STA $02
					LDA #$F8
					STA $03
SUB_GFX_WING_2		
					LDA #$C6
                    STA $0202,y             ; /
					LDA $01
					STA $0201,y
					LDA $00                 ; \
					CLC
					ADC $03
                    STA $0200,y             ; /
					LDA $02
                    ORA $64                 ;  | put in level properties
                    STA $0203,y             ; / store tile properties
					
                    LDY #$02                ; \ 02, because we didn't write to 460 yet
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $28FCC0             ;# / $200p̃OtBbN[`
                    RTS 


RETURN304	RTS
SPRITE_ROUTINE
			LDA $7FFFD2
			BEQ RETURN304
			JSR GET_DRAW_INFO
			LDA #$EE
			STA $0F
			LDA $C2,x
			BEQ SPRITE_ROUTINE_0
			LDA $14
			AND #$08
			BEQ SPRITE_ROUTINE_0
			LDA #$EC
			STA $0F
SPRITE_ROUTINE_0
			LDA #$09
			STA $02
			STZ $03
			LDA $76
			BEQ SPRITE_ROUTINE_1
			LDA #$F7
			STA $02
			
SPRITE_ROUTINE_1
			LDA $13E0
			CMP #$3C
			BNE SPRITE_ROUTINE_2
			LDA #$0C
			STA $03
SPRITE_ROUTINE_2
			LDY #$80
			PHX
			LDX $13F9
			LDA.l $00E2B2,x
			CLC
			ADC #$08
			STA $0C


			LDX $0C

			LDA $02F8,x
			CLC
			ADC $02
			STA $0200,y

			LDA $0F
			STA $0202,y

			LDA $02FB,x
			ORA $64
			ORA #$01
			STA $0203,y

			PHX
			PHY
			TYA
			LSR A
			LSR A
			TAY
			TXA
			LSR A
			LSR A
			TAX
			LDA $045E,x
			STA $0420,y
			
			PLY
			PLX

			LDA $02F9,x
			SEC
			SBC #$06
			CLC
			ADC $03
			STA $0201,y

			PLX
			RTS


