;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Snow
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    EXTRA_BITS = $7FAB10
					NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
                    RTL
                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RETURN              RTS                    
START_HB_CODE       JSR SUB_GFX             ; draw hammer bro gfx
					LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN2              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN2
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA $157C,x
					BEQ MODE2_LEFT
					LDA $E4,x
					CLC
					ADC #$04
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					BRA MODE2_2
MODE2_LEFT			LDA $E4,x
					SEC
					SBC #$04
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
MODE2_2				LDA $C2,x
					BEQ MODE2_3
					CMP #$02
					BEQ MODE2_DOWN
					LDA $D8,x
					SEC
					SBC #$02
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					BRA MODE2_3
MODE2_DOWN			LDA $D8,x
					CLC
					ADC #$02
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
MODE2_3				JSR BLK_CHECK
					JSR SPRITE_CHECK
RETURN2             RTS


SPRITE_CHECK		LDA $E4,x
					AND #$E0
					STA $7FFEE0
					LDA $14E0,x
					STA $7FFEE1
					LDA $D8,x
					AND #$E0
					STA $7FFEE2
					LDA $14D4,x
					STA $7FFEE3
					PHX
					LDX #$00
CHECK_LOOP			LDA $14C8,x
					BEQ CHECK2
					CMP #$02
					BEQ CHECK2
					LDA $9E,x
					CMP #$68
					BEQ CHECK3
					LDA $167A,x
					AND #$02
					BNE CHECK2
CHECK3				LDA $E4,x
					AND #$E0
					CMP $7FFEE0
					BNE CHECK2
					LDA $14E0,x
					CMP $7FFEE1
					BNE CHECK2
					LDA $D8,x
					AND #$E0
					CMP $7FFEE2
					BNE CHECK2
					LDA $14D4,x
					CMP $7FFEE3
					BNE CHECK2
					JSR GEN_BLK
					STZ $14C8,x
CHECK2				INX
					CPX #$0A
					BCC CHECK_LOOP
					PLX
					RTS

GEN_BLK				LDA #$1C
                    STA $1DFC
					LDA $E4,x
					AND #$F0
					STA $9A
					LDA $14E0,x
					STA $9B
					LDA $D8,x
					AND #$F0
					STA $98
					LDA $14D4,x
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0547
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
					
BLK_CHECK			LDA $D8,x
					PHA
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					PHA
					SBC #$00
					STA $14D4,x
					JSL $019138
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PHP
					REP #$30
					LDA $03
					CMP #$012F
					BEQ CHECK_2
					CMP #$0510
					BEQ CHECK_2
					CMP #$0511
					BEQ CHECK_2
					CMP #$0520
					BEQ CHECK_2
					CMP #$0521
					BEQ CHECK_2
					CMP #$0518
					BEQ CHECK_2
					CMP #$0519
					BEQ CHECK_2
					CMP #$051A
					BEQ CHECK_2
					CMP #$051B
					BEQ CHECK_2
					PLP
					RTS
CHECK_2				PLP
					LDA $E4,x
					PHA
					CLC
					ADC #$08
					STA $E4,x
					LDA $14E0,x
					PHA
					ADC #$00
					STA $14E0,x
					JSR GEN_BLK
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

PROPETIES			dcb $00,$40
SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
					LDA #$8A
                    STA $0302,y             ; /
					LDA $01
					STA $0301,y
					LDA $00                 ; \ 
                    STA $0300,y             ; /

					PHX
					LDA $157C,x
					TAX
					LDA PROPETIES,x
					PLX
                    ORA #$07             ;  | get palette info
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
					


