;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Koopa Boss
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
                    EXTRA_BITS = $7FAB10

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    dcb "INIT"
					LDA EXTRA_BITS,x
					AND #$04
					BEQ INIT_RTL
					LDA #$02
					STA $1504,x
					JSR HDMA
INIT_RTL			RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RETURN              RTS                    
START_HB_CODE       LDA $1504,x
					BNE MAIN1
					JSR BIG_HAKUN
					RTS
MAIN1				CMP #$01
					BNE MAIN2
					JSR BIG_HAKUN2
					RTS
MAIN2				CMP #$02
					BNE MAIN3
					JSR BIG_MECHA
					RTS
MAIN3				CMP #$03
					BNE MAIN4
					JSR FOOT
					RTS
MAIN4				CMP #$04
					BNE MAIN5
					JSR FLAME
					RTS
MAIN5
MAIN8

FLAME				JSR SUB_GFX_FL
					LDA $9D
					BNE FLAME_R
					JSL $01A7DC
					INC $1570,x
					LDA #$C0
					STA $B6,x
					JSL $018022 ;x speed
					JSL $01801A ;y speed
					LDA $14E0,x
					BEQ FLAME_R
					STZ $14C8,x
FLAME_R				RTS

FOOT_0				LDA $1558,x
					BNE RETURN89
					LDA #$10
					STA $AA,x
					JSL $01801A
RETURN89			RTS
FOOT				JSR SUB_GFX_F
					LDA $9D
					BNE FOOT_R
					LDA $7FFF09
					BNE FOOT_0
					JSL $01A7DC
					LDA $1540,x
					BNE FOOT_3
					LDA $7FE801
					CMP #$C1
					BEQ FOOT_R
					JSL $018022 ;x speed
					JSL $01801A ;y speed
					LDA $15AC,x
					CMP #$60
					BCS FOOT_1
					CMP #$30
					BCS FOOT_2
					LDA #$F0
					STA $B6,x
					LDA #$04
					STA $AA,x
					LDA $15AC,x
					BNE FOOT_R
					LDA #$C0
					STA $15AC,x
					LDA #$09
					STA $1DFC
					LDA #$20
					STA $1887
FOOT_R				RTS
FOOT_1				STZ $AA,x
					STZ $B6,x
					RTS
FOOT_2				LDA #$F0
					STA $B6,x
					LDA #$FC
					STA $AA,x
					RTS
FOOT_3				CMP #$41
					BCC FOOT_4
					LDA #$D8
					STA $B6,x
					JSL $018022
					RTS
FOOT_4				LDA #$28
					STA $B6,x
					JSL $018022
					RTS

BIG_HAKUN			JSR SUB_GFX
					LDA $9D
                    BNE BAIL
					LDA #$77
					STA $1528,x
					JSL $01802A
					JSR HAKUN_CHECK
					LDA $C2,x
					BNE BIG_HAKUN_2
					LDA $15AC,x
					BNE BAIL2
					LDA #$A0
					STA $AA,x
					INC $C2,x
					STZ $1602,x
					LDA #$10
					STA $15AC,x
					RTS
BAIL2				STZ $AA,x
					LDA #$01
					STA $1602,x
BAIL				RTS
BIG_HAKUN_2			LDA $15AC,x
					BNE BAIL
					LDA $14D4,x
					BEQ BAIL
					LDA $D8,x
					CMP #$3C
					BCC BAIL
					LDA #$40
					STA $15AC,x
					STZ $C2,x
					RTS
					
BIG_HAKUN2			JSR SUB_GFX2
					LDA $9D
                    BNE RETURN63
					JSL $01802A
					JSR HAKUN_CHECK
					LDA $1588,x
					AND #$04
					LSR A
					LSR A
					STA $1602,x
					LDA $15AC,x
					BNE RETURN63
					LDA #$60
					STA $15AC,x
					LDA #$B0
					STA $AA,x
RETURN63			RTS
					
HAKUN_CHECK			JSL $01A7DC
					BCC HAKUN_CHECK_R
					LDA $7D
					BMI ENE_WIN
					CMP #$10
					BCC ENE_WIN
					LDA $D8,x
					SEC
					SBC $96
					LDA $14D4,x
					SBC $97
					BCC ENE_WIN
					LDA #$D0
					STA $7D
					JSL $01AB99
					LDA #$03
					STA $1DF9
					LDA #$20
					STA $1497
					LDA $1504,x
					BNE HAKUN_CHECK_2
					JSR GEN_SPRITE
					LDA #$00
					STA $1662,y
					LDA #$01
					STA $1504,y
					LDA #$70
					STA $00E4,y
					LDA #$60
					STA $15AC,y
					LDA #$77
					STA $1528,y
					JSR GEN_SPRITE
					LDA #$00
					STA $1662,y
					LDA #$01
					STA $1504,y
					LDA #$A0
					STA $00E4,y
					LDA #$60
					STA $15AC,y
					LDA #$77
					STA $1528,y
					STZ $14C8,x
HAKUN_CHECK_R		RTS
ENE_WIN				LDA $1497
					BNE HAKUN_CHECK_R
					JSL $00F5B7 ;hurt mario
					RTS
HAKUN_CHECK_2		LDA #$51
					STA $7FFF9E
					JSR GEN_NORMAL
					LDA $E4,x
					SEC
					SBC #$30
					STA $00E4,y
					JSR GEN_NORMAL
					LDA $E4,x
					SEC
					SBC #$10
					STA $00E4,y
					JSR GEN_NORMAL
					LDA $E4,x
					CLC
					ADC #$30
					STA $00E4,y
					JSR GEN_NORMAL
					LDA $E4,x
					CLC
					ADC #$10
					STA $00E4,y
					LDA $E4,x
					STA $7FFFE4
					STZ $14C8,x
					RTS
					
BIG_MECHA			LDA $9D
					BNE BIG_MECHA_R
					JSR MECHA_SPEED
					LDA $7FFF09
					BEQ BIG_MECHA_1
					JSR MECHA_DOWN
					RTS
BIG_MECHA_1			JSR MARIO_DAMAGE
					JSR MECHA_CHECK
					LDA #$16
					STA $212C
					LDA #$01
					STA $212D
					LDA $C2,x
					BNE BIG_MECHA_2
					JSR HAKUN_COUNT
BIG_MECHA_R			RTS
BIG_MECHA_2			CMP #$01
					BNE BIG_MECHA_3
					JSR WALL_DELETE
					RTS
BIG_MECHA_3			CMP #$02
					BNE BIG_MECHA_4
					LDA $14
					AND #$01
					BEQ BIG_MECHA_R
					LDA $7FE801
					CMP #$C1
					BEQ BIG_MECHA_3_2
					REP #$20
					LDA $7FE801
					INC A
					STA $7FE801
					SEP #$20
					RTS
BIG_MECHA_3_2		LDA #$FF
					STA $15AC,x
					INC $C2,x
RETURN99			RTS
BIG_MECHA_4			CMP #$03
					BNE BIG_MECHA_5
					LDA $15AC,x
					BEQ BIG_MECHA_4_1
					CMP #$C0
					BCS RETURN99
					CMP #$40
					BCS BIG_MECHA_4_2
					RTS
BIG_MECHA_4_1
					LDA #$FF
					STA $15AC,x
					INC $C2,x
					LDA #$A2
					STA $7FFF9E
					RTS
BIG_MECHA_4_2		LDA $15AC,x
					AND #$07
					BNE RETURN99
					JSR GEN_SPRITE
					LDA #$04
					STA $1504,y
					LDA #$00
					STA $1662,y
					LDA #$03
					STA $167A,y
					JSL $01ACF9
					AND #$7F
					SEC
					SBC #$40
					STA $00AA,y
					LDA #$70
					STA $00E4,y
					LDA #$40
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					JSL $01ACF9
					STA $1570,y
					LDA #$17
					STA $1DFC
					RTS
BIG_MECHA_5			CMP #$04
					BNE BIG_MECHA_6
					LDA $15AC,x
					BEQ BIG_MECHA_5_2
					CMP #$D0
					BEQ BIG_MECHA_5_G
					CMP #$A0
					BEQ BIG_MECHA_5_G
					CMP #$70
					BEQ BIG_MECHA_5_G
					CMP #$50
					BEQ BIG_MECHA_5_1
					CMP #$40
					BEQ BIG_MECHA_5_G
					RTS
BIG_MECHA_5_1		LDA #$51
					STA $7FFF9E
					RTS
BIG_MECHA_5_G		JSR GEN_NORMAL
					LDA #$01
					STA $157C,y
					LDA #$E0
					STA $00B6,y
					LDA #$70
					STA $00E4,y
					LDA #$40
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					RTS
BIG_MECHA_5_2		INC $C2,x
					LDA #$FF
					STA $15AC,x
					RTS
BIG_MECHA_6			LDA $15AC,x
					CMP #$D0
					BEQ BIG_MECHA_6_2
					CMP #$90
					BEQ BIG_MECHA_6_3
					CMP #$40
					BEQ BIG_MECHA_6_4
					RTS
BIG_MECHA_6_2		LDA $7FFF00
					TAY
					LDA #$81
					STA $1540,y
					RTS
BIG_MECHA_6_3		LDA $7FFF01
					TAY
					LDA #$81
					STA $1540,y
					RTS
BIG_MECHA_6_4		LDA #$FF
					STA $15AC,x
					LDA #$03
					STA $C2,x
					RTS
					
MECHA_CHECK			STX $0F
					PHX
					LDX #$00
MECHA_CHECK_LOOP	LDA $14C8,x
					CMP #$09
					BCC MECHA_CHECK_2
					LDA $9E,x
					CMP #$A2
					BNE MECHA_CHECK_2
					LDA $14E0,x
					BNE MECHA_CHECK_2
					LDA $E4,x
					CMP #$50
					BCC MECHA_CHECK_2
					LDA $E4,x
					CMP #$A0
					BCS MECHA_CHECK_2
					LDA $14D4,x
					BEQ MECHA_CHECK_2
					LDA $D8,x
					CMP #$40
					BCS MECHA_CHECK_2
					STZ $14C8,x
					LDA #$28
					STA $1DFC
					PHX
					LDX $0F
					INC $1528,x
					PLX
MECHA_CHECK_2		INX
					CPX #$0A
					BCC MECHA_CHECK_LOOP
					PLX
					LDA $1528,x
					CMP #$03
					BCS MECHA_CHECK_3
MECHA_CHECK_R		RTS
MECHA_CHECK_3		LDA #$1E
					STA $1DFB
					LDA #$01
					STA $7FFF09
					LDA #$40
					STA $1558,x
					LDA $7FFF00
					TAY
					LDA #$40
					STA $1558,y
					LDA $7FFF01
					TAY
					LDA #$40
					STA $1558,y
					RTS
					
MECHA_SPEED			PHX
					LDX #$00
MECHA_SPEED_LOOP	LDA $14C8,x
					CMP #$08
					BNE MECHA_SPEED_2
					LDA $9E,x
					CMP #$A2
					BNE MECHA_SPEED_2
					LDA #$01
					STA $157C,x
					LDA #$E0
					STA $B6,x
MECHA_SPEED_2		INX
					CPX #$0A
					BCC MECHA_SPEED_LOOP
					PLX
					RTS

WALL_DELETE			LDA $15AC,x
					CMP #$D0
					BEQ WALL_DELETE_1
					CMP #$C8
					BEQ WALL_DELETE_2
					CMP #$C0
					BEQ WALL_DELETE_2
					CMP #$B8
					BEQ WALL_DELETE_2
					CMP #$B0
					BEQ WALL_DELETE_2
					CMP #$A8
					BEQ WALL_DELETE_2
					CMP #$A0
					BEQ WALL_DELETE_2
					CMP #$98
					BEQ WALL_DELETE_2
					CMP #$90
					BEQ WALL_DELETE_2
					CMP #$88
					BEQ WALL_DELETE_2
					CMP #$80
					BEQ WALL_DELETE_2
					CMP #$60
					BEQ WALL_DELETE_3
					RTS
WALL_DELETE_1		LDA #$F0
					STA $7FFF9A
					LDA #$00
					STA $7FFF9B
					STA $7FFF99
					LDA #$D0
					STA $7FFF98
WALL_DELETE_2		REP #$30
					LDA $7FFF98
					STA $98
					LDA $7FFF9A
					STA $9A
                    LDA.W #$0025
                    STA $03                 ;  |
                    JSL $2E8DF0
					LDA $7FFF98
					CLC
					ADC.W #$0010
					STA $7FFF98
                    SEP #$30
					JSR HAHEN
					RTS
WALL_DELETE_3		JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					LDA #$01
					STA $1602,y
					LDA #$40
					STA $1570,y
					LDA #$80
					STA $00E4,y
					LDA #$01
					STA $14E0,y
					LDA #$70
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					LDA #$60
					STA $15AC,y
					LDA #$00
					STA $1662,y
					LDA #$03
					STA $167A,y
					TYA
					STA $7FFF00
					JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					LDA #$60
					STA $1570,y
					LDA #$50
					STA $00E4,y
					LDA #$01
					STA $14E0,y
					LDA #$70
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					LDA #$C0
					STA $15AC,y
					LDA #$00
					STA $1662,y
					LDA #$03
					STA $167A,y
					TYA
					STA $7FFF01
					INC $C2,x
					RTS
					
HAHEN				;#j
					LDA #$0F
					TRB $9A ;#K?
					TRB $98 ;#K?
					PHB
					LDA #$02
					PHA
					PLB
					JSL $028663
					PHY
					LDY #$03
R3_LOOP				LDA $16CD,y ;Block Bounce Sprite Exists Flag Table #j
					BEQ ROUTINE3_2
					DEY
					BPL R3_LOOP
					INY
ROUTINE3_2			LDA $9A
					STA $16D1,y ;#jЂ̏oʒu̐ݒ
					LDA $9B
					STA $16D5,y
					LDA $98
					STA $16D9,y
					LDA $99
					STA $16DD,y
ROUTINE3_3			LDA #$01
					STA $16CD,y ;#^C}H
					LDA #$06
					STA $18F8,y
					PLY
					PLB
					RTS

HAKUN_COUNT			LDY #$00
					PHX
					LDX #$00
HAKUN_COUNT_LOOP	LDA $14C8,x
					BEQ HAKUN_COUNT_2
					LDA $9E,x
					CMP #$51
					BEQ HAKUN_COUNT_1
					LDA $1528,x
					CMP #$77
					BNE HAKUN_COUNT_2
HAKUN_COUNT_1		LDY #$01
HAKUN_COUNT_2		INX
					CPX #$0A
					BCC HAKUN_COUNT_LOOP
					PLX
					CPY #$00
					BNE HAKUN_COUNT_R
					JSR COIN_DELETE
					INC $C2,x
					LDA #$FF
					STA $15AC,x
HAKUN_COUNT_R		RTS
COIN_DELETE			PHX
					LDX #$00
COIN_LOOP			LDA $14C8,x
					BEQ COIN_2
					LDA $9E,x
					CMP #$21
					BNE COIN_2
					STZ $14C8,x
COIN_2				INX
					CPX #$0A
					BCC COIN_LOOP
					PLX
					RTS
					
MARIO_DAMAGE		REP #$20
					LDA.# #$0130
					SEC
					SBC $7FE801
					SEC
					SBC $94
					BCS MARIO_DAMAGE_R
					LDA $96
					CMP.W #$00E0
					BCC MARIO_DAMAGE_R
					SEP #$20
					LDA $1497
					BNE MARIO_DAMAGE_R
					JSL $00F5B7 ;hurt mario
MARIO_DAMAGE_R		SEP #$20
					RTS
					
MECHA_DOWN			LDA $94
					CMP #$E0
					BCS MECHA_DOWN_1
					LDA $1558,x
					BNE MECHA_DOWN_R
					LDA $1468
					BEQ MECHA_DOWN_R
					DEC $1468
MECHA_DOWN_R		RTS
MECHA_DOWN_1		LDA #$06
					STA $71
					STZ $89
					STZ $88
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP_NI			dcb $80,$82,$04,$06,$20,$22,$24,$26,$8C,$8E,$44,$46,$AC,$AE,$64,$66
					dcb $08,$84,$86,$88,$28,$2A,$2C,$2E,$48,$4A,$4C,$4E,$68,$6A,$6C,$6E
HORZ_NI				dcb $00,$10,$20,$30,$00,$10,$20,$30,$00,$10,$20,$30,$00,$10,$20,$30
VERT_NI				dcb $00,$00,$00,$00,$10,$10,$10,$10,$20,$20,$20,$20,$30,$30,$30,$30
TILEMAP_NI2			dcb $C8,$CA,$E8,$EA,$CC,$CE,$EC,$EE
HORZ_NI2			dcb $F8,$08,$F8,$08
VERT_NI2			dcb $F0,$F0,$00,$00

SUB_GFX				JSR GET_DRAW_INFO
					STZ $02
					LDA $1602,x
					BEQ SUB_GFX_0
					LDA #$10
					STA $02
SUB_GFX_0			LDA #$40
					TAY
					STA $15EA,x
					PHX
					LDX #$0F
LOOP_NI				LDA $00
					CLC
					ADC HORZ_NI,x
					STA $0200,y
					LDA $01
					CLC
					ADC VERT_NI,x
					STA $0201,y
					LDA #$09
					ORA $64
					STA $0203,y
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA TILEMAP_NI,x
					STA $0202,y
					PLX
					INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_NI          ; / 
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$0F
                    JSL $28FCC0 ;# $200p̃OtBbN[`
                    RTS        


					
					
SUB_GFX2			JSR GET_DRAW_INFO
					STZ $02
					LDA $1602,x
					BEQ SUB_GFX2_0
					LDA #$04
					STA $02
SUB_GFX2_0			PHX
					LDX #$03
LOOP_NI2			LDA $00
					CLC
					ADC HORZ_NI2,x
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_NI2,x
					STA $0301,y
					LDA #$09
					ORA $64
					STA $0303,y
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA TILEMAP_NI2,x
					STA $0302,y
					PLX
					INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_NI2          ; / 
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03
                    JSL $01B7B3
                    RTS
					
HORZ_FL				dcb $00,$10
TILEMAP_FL			dcb $A0,$A2,$C0,$C2

SUB_GFX_FL			JSR GET_DRAW_INFO
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$01
					ASL A
					STA $02
					PHX
					LDX #$01
LOOP_FL				LDA $00
					CLC
					ADC HORZ_FL,x
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA #$05
					ORA $64
					STA $0303,y
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA TILEMAP_FL,x
					STA $0302,y
					PLX
					INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_FL         ; / 
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$01
                    JSL $01B7B3
                    RTS

HORZ_F				dcb $00,$E8,$F8,$08
VERT_F				dcb $F0,$00,$00,$00
TILEMAP_F			dcb $E6,$E0,$E2,$E4

SUB_GFX_F			JSR GET_DRAW_INFO
					LDA $1570,x
					TAY
					STA $15EA,x
					LDA $1602,x
					STA $0F
					PHX
					LDX #$03
LOOP_F				LDA $00
					CLC
					ADC HORZ_F,x
					STA $0200,y
					LDA $01
					CLC
					ADC VERT_F,x
					STA $0201,y
					LDA TILEMAP_F,x
					STA $0202,y
					LDA #$0B
					STA $0203,y
					LDA $0F
					BEQ SUB_GFX_F_1
					LDA #$0B
					ORA $64
					STA $0203,y
SUB_GFX_F_1			INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_F         ; / 
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03
                    JSL $28FCC0 ;# $200p̃OtBbN[`
                    RTS


RETURN67            RTS
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
					LDA $E4,x
                    STA $00E4,y
                    LDA $14E0,x
                    STA $14E0,y             ; /

					LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS
					
RETURNK68           RTS     
GEN_NORMAL          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURNK68            ; / after: Y has index of sprite being generated

                    LDA $7FFF9E
                    STA $009E,y
					LDA #$08
					STA $14C8,y
GEN_NORMAL_2                    
                    LDA $E4,x               ;\ set x position for new sprite
                    STA $00E4,y

                    LDA $14E0,x             ;  |
                    STA $14E0,y             ; /

                    LDA $D8,x               ;\ set y position for new sprite
					STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
					STA $14D4,y             ; /

                    PHX
                    TYX
                    JSL $07F7D2             ;  
                    PLX
                    RTS                     ; return
					
HDMA				LDA #$08
					STA $7FFB18
					LDA #$02
					STA $7FFB19
					LDA #$0F
					STA $7FFB1A
					LDA #$00
					STA $7FFB1B
					LDA #$E8
					STA $7FFB1C
					LDA #$7F
					STA $7FFB1D
					LDA #$01
					STA $7FE800
					LDA #$00
					STA $7FE801
					STA $7FE802
					STA $7FE803
					RTS
