;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Koopa Castle
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
                    EXTRA_BITS = $7FAB10
					MARIO_STATUS    = $19 
                    SPRITE_STATE    = $C2
                    SPR_OBJ_STATUS  = $1588
                    IS_ON_YOSHI     = $187A 
                    SPRITE_OAM      = $15EA
                    ON_THIS         = $1528
                    
                    ;data
                    YOSHI_OFFSET    = $10
                    SIZE            = $08

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    dcb "INIT"
					LDA $010B
					CMP #$EA
					BEQ INI_QUICKMAN
					CMP #$08
					BEQ LIFT
					CMP #$EB
					BEQ INIT_TONBERI
					CMP #$EC
					BEQ INIT_TONBERI
					CMP #$EE
					BEQ INIT_MOON
					CMP #$ED
					BEQ INIT_BODORO
					CMP #$52
					BEQ INIT_152
					CMP #$53
					BEQ INIT_BODORO
					CMP #$69
					BEQ INIT_ICE1
					CMP #$67
					BEQ INIT_ICE4
                    RTL
INIT_ICE4			JMP INIT_ICE40
INI_QUICKMAN		LDA #$01
					STA $1504,x
					STZ $1570,x
					STZ $157C,x
					LDA $E4,x
					CMP #$80
					BCC INIT_R
					LDA #$01
					STA $157C,x
INIT_R				RTL
LIFT				LDA #$02
					STA $1504,x
					STZ ON_THIS,x
					STZ $1570,x
					RTL
INIT_TONBERI		LDA EXTRA_BITS,x
					AND #$04
					BNE YAJIRUSI_INIT
                    JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
					LDA #$03
					STA $1504,x
					RTL
YAJIRUSI_INIT		LDA #$04
					STA $1504,x
					RTL
INIT_MOON			JSR HDMA_COLOR
					LDA #$05
					STA $1504,x
					RTL
INIT_152			JSR HDMA_COLOR
					STZ $14C8,x
					RTL
INIT_BODORO			LDA EXTRA_BITS,x
					AND #$04
					BNE INIT_BIYON
					LDA #$06
					STA $1504,x
					RTL
INIT_BIYON			LDA #$08
					STA $1504,x
					JSL $01ACF9
					AND #$3F
					CLC
					ADC #$40
					STA $15AC,x
					JSR SUB_GET_DIR
                    TYA
					EOR #$01
                    STA $157C,x
					RTL
INIT_ICE1			LDA EXTRA_BITS,x
					AND #$04
					BNE INIT_ICE3
					LDA $14E0,x
					CMP #$04
					BEQ INIT_ICE2
					LDA #$09
					STA $1504,x
					LDA $D8,x
					STA $151C,x
					LDA $14D4,x
					STA $1528,x
					RTL
INIT_ICE2			LDA #$0A
					STA $1504,x
					LDA $E4,x
					ORA #$08
					STA $E4,x
					RTL
INIT_ICE3			LDA #$0B
					STA $1504,x
					STZ $157C,x
					STZ $15AC,x
					RTL
INIT_ICE40			LDA $E4,x
					CMP #$70
					BEQ INIT_ICE41
					CMP #$A0
					BEQ INIT_ICE42
					LDA #$0C
					STA $1504,x
					LDA #$D0
					STA $AA,x
					STA $B6,x
					LDA #$C0
					STA $1570,x
					RTL
INIT_ICE41			LDA #$0C
					STA $1504,x
					LDA #$30
					STA $AA,x
					STA $B6,x
					LDA #$80
					STA $1570,x
					RTL
INIT_ICE42			LDA #$0C
					STA $1504,x
					LDA #$30
					STA $AA,x
					LDA #$D0
					STA $B6,x
					LDA #$40
					STA $1570,x
					REP #$20
					LDA $1462
					STA $7FFF62
					LDA $1464
					STA $7FFF64
					SEP #$20
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RETURN              RTS                    
START_HB_CODE       LDA $1504,x
					CMP #$01
					BNE MAIN1
					JSR QUICKMAN
					RTS
MAIN1				CMP #$02
					BNE MAIN2
					JSR LIFT_BOWSER
					RTS
MAIN2				CMP #$03
					BNE MAIN3
					JSR TONBERI
					RTS
MAIN3				CMP #$04
					BNE MAIN4
					JSR YAJIRUSI
					RTS
MAIN4				CMP #$05
					BNE MAIN5
					JSR MOON
					RTS

MAIN5				CMP #$06
					BNE MAIN6
					JSR BODORO
					RTS
MAIN6				CMP #$07
					BNE MAIN7
					JSR ONE_UP
					RTS
MAIN7				CMP #$08
					BNE MAIN8
					JSR BIYON
					RTS
MAIN8				CMP #$09
					BNE MAIN9
					JSR DOSN1
					RTS
MAIN9				CMP #$0A
					BNE MAINA
					JSR DOSN2
					RTS
MAINA				CMP #$0B
					BNE MAINB
					JSR KTN
					RTS
MAINB				CMP #$0C
					BNE MAINC
					JSR HOLE
					RTS
MAINC				

HOLE20				STZ $1401
					REP #$20
					LDA $1462
					SEC
					SBC $7FFF62
					STA $7FFF66
					LDA $1462
					STA $7FFF62
					LDA $1464
					SEC
					SBC $7FFF64
					STA $7FFF68
					LDA $1464
					STA $7FFF64
					SEP #$20
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					STA $D8,x
					LDA $97
					STA $14D4,x
					RTS

HOLE				LDA EXTRA_BITS,x
					AND #$04
					BNE HOLE20
					JSR SUB_GFX_H
					LDA $9D
					BNE HOLE_R
					LDA $E4,x
					CLC
					ADC $7FFF66
					STA $E4,x
					LDA $14E0,x
					ADC $7FFF67
					STA $14E0,x
					LDA $D8,x
					CLC
					ADC $7FFF68
					STA $D8,x
					LDA $14D4,x
					ADC $7FFF69
					STA $14D4,x
					LDA #$16
					STA $212C
					LDA #$01
					STA $212D
					LDA #$31
					STA $40
					LDA $151C,x
					CMP #$10
					BCC HOLE_RI
					CMP #$F0
					BCS HOLE_LE
					BRA HOLE_1
HOLE_RI				LDA #$30
					STA $B6,x
					BRA HOLE_1
HOLE_LE				LDA #$D0
					STA $B6,x
HOLE_1				LDA $1528,x
					CMP #$10
					BCC HOLE_D
					CMP #$C0
					BCS HOLE_U
					BRA HOLE_2
HOLE_D				LDA #$30
					STA $AA,x
					BRA HOLE_2
HOLE_U				LDA #$D0
					STA $AA,x
HOLE_2				JSL $018022 ;x speed
					JSL $01801A ;y speed
HOLE_R				RTS

LIFT_BOWSER			JSR SUB_GFX
					LDA $9D
                    BNE BAIL
					LDA #$39
					STA $1686,x
					LDA #$FD
					STA $166E,x
					LDA #$A3
					STA $167A,x
					LDA #$45
					STA $190F,x
                    JSR SUB_B852
                    JSR SUB_MOVEMENT
BAIL				RTS

DOSN1				JSR SUB_GFX_DSN
					LDA $9D
					BNE DOSN1_R
					LDA #$07
					STA $1662,x
					LDA #$03
					STA $167A,x
					JSL $27FAF4;SUB_OFF_SCREEN_X0
					JSL $01A7DC
					JSL $01801A
					LDA $C2,x
					CMP #$01
					BEQ DSN1_FALL
					CMP #$02
					BEQ DSN1_RISE
					LDA $E4,x
					STA $02
					LDA $14E0,x
					STA $03
					REP #$20
					LDA $02
					SEC
					SBC $94
					CMP.W #$0031
					BCC DOSN1_3
					CMP.W #$FFA0
					BCS DOSN1_3
					SEP #$20
DOSN1_R				RTS
DOSN1_3				SEP #$20
					INC $C2,x
					RTS
DSN1_FALL			LDA $AA,x
					CMP #$3E
					BCS DSN1_FALL_2
					INC $AA,x
					CLC
					ADC #$04
					STA $AA,x
DSN1_FALL_2			LDA $D8,x
					PHA
					CLC
					ADC #$30
					STA $D8,x
					LDA $14D4,x
					PHA
					ADC #$00
					STA $14D4,x
					JSL $019138
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					LDA $1588,x
					AND #$04
					BEQ DOSN1_R2
					STZ $AA,x
					LDA #$20
					STA $1887
					LDA #$40
					STA $15AC,x
					LDA #$09
					STA $1DFC
					INC $C2,x
DOSN1_R2			RTS
DSN1_RISE			LDA $15AC,x
					BNE DOSN1_R
					LDA #$F0
					STA $AA,x
					LDA $D8,x
					CMP $151C,x
					BNE DOSN1_R2
					LDA $14D4,x
					CMP $1528,x
					BNE DOSN1_R2
					STZ $C2,x
					STZ $AA,x
					RTS

DOSN2				JSR SUB_GFX_DSN
					LDA $9D
					BNE DOSN2_R
					LDA #$07
					STA $1662,x
					LDA #$03
					STA $167A,x
					JSL $27FAF4;SUB_OFF_SCREEN_X0
					JSL $01A7DC
					JSL $018022
					LDA $C2,x
					CMP #$01
					BEQ DSN2_ATK
					CMP #$02
					BEQ DSN2_RTN
					JSR SUB_GET_DIR
					CPY #$01
					BNE DOSN2_R
					LDA $15AC,x
					BNE DOSN2_R
					INC $C2,x
DOSN2_R				RTS
DSN2_ATK			LDA $15AC,x
					BEQ DSN2_ATK_1
					CMP #$01
					BNE DOSN2_R
					INC $C2,x
					RTS
DSN2_ATK_1			LDA $B6,x
					CMP #$C9
					BMI DSN2_ATK_2
					DEC $B6,x
					DEC $B6,x
					DEC $B6,x
					DEC $B6,x
DSN2_ATK_2			LDA $14E0,x
					CMP #$03
					BNE DOSN2_R
					LDA $E4,x
					CMP #$A9
					BCS DOSN2_R
					STZ $B6,x
					LDA #$20
					STA $1887
					LDA #$40
					STA $15AC,x
					LDA #$09
					STA $1DFC
					RTS
DSN2_RTN			LDA #$10
					STA $B6,x
					LDA $14E0,x
					CMP #$04
					BNE DOSN2_R
					LDA $E4,x
					CMP #$28
					BCC DOSN2_R
					STZ $B6,x
					LDA #$30
					STA $15AC,x
					STZ $C2,x
					RTS
					
KTN_SPEED			dcb $18,$E8
KTN					JSR SUB_GFX_KTN
					LDA $9D
					BNE KTN_R
					LDA #$03
					STA $167A,x
					LDA #$06
					STA $1662,x
					LDA #$01
					STA $1656,x
					JSL $01803A
					JSL $01802A
					LDA $15AC,x
					BEQ KTN_1
					CMP #$01
					BEQ KTN_2
					RTS
KTN_1				LDA $1588,x
					AND #$04
					BEQ KTN_AIR
					STZ $B6,x
					LDA #$40
					STA $15AC,x
					LDA $157C,x
					EOR #$01
					STA $157C,x
KTN_R				RTS
KTN_AIR				LDA $1588,x
					AND #$08
					BEQ KTN_R
					LDA #$20
					STA $AA,x
					RTS
KTN_2				LDA $157C,x
					TAY
					LDA KTN_SPEED,y
					STA $B6,x
					LDA #$A0
					STA $AA,x
					RTS


ONE_UP				JSR SUB_GFX_ONE
					LDA $9D
					BNE ONE_R
					JSL $27FAF4;SUB_OFF_SCREEN_X0
					LDA #$F4
					STA $AA,x
					JSL $01801A
					LDA $14D4,x
					BNE ONE_1
					LDA $D8,x
					CMP #$80
					BCC ONE_DEL
ONE_1				LDA $15AC,x
					BNE ONE_R
					JSL $01A7DC
					BCC ONE_R
					LDA #$78
					STA $7FFF9E
					JSR GEN_NORMAL
ONE_DEL				STZ $14C8,x
ONE_R				RTS

BIYON_SPEED			dcb $F8,$08
BIYON				JSR SUB_GFX_BIYON
					LDA $9D
					BNE BIYON_R
					LDA #$03
					STA $167A,x
					JSL $27FAF4;SUB_OFF_SCREEN_X0
					INC $1570,x
					LDA $C2,x
					BNE BIYON_2
					JSL $01A7DC
					LDA $157C,x
					TAY
					LDA BIYON_SPEED,y
					STA $B6,x
					JSL $018022
					LDA $15AC,x
					BNE BIYON_R
					INC $C2,x
					LDA #$30
					STA $15AC,x
BIYON_R				RTS
BIYON_2				JSL $01A7DC
					LDA $D8,x
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					JSL $01A7DC
					LDA $D8,x
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					JSL $01A7DC
					LDA $D8,x
					SEC
					SBC #$20
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					LDA $15AC,x
					BNE BIYON_R
					LDA $157C,x
					EOR #$01
					STA $157C,x
					JSL $01ACF9
					AND #$3F
					CLC
					ADC #$40
					STA $15AC,x
					STZ $C2,x
					RTS

X_SPEEDT			dcb $08,$F8

TONBERI				JSR SUB_GFX_T
					LDA $9D
					BNE RETURNT
					LDA $14C8,x
					CMP #$08
					BNE RETURNT
					LDA #$0F
					STA $166E,x
					LDA #$01
					STA $167A,x
					LDA #$B7
					STA $1662,x
					LDA #$10
					STA $1656,x
					JSL $27FAF4;SUB_OFF_SCREEN_X0
					INC $1570,x
					LDY $157C,x
					LDA X_SPEEDT,y
					STA $B6,x
					JSL $01802A
					JSL $01A7DC
					LDA $1588,x
					AND #$04
					BEQ TURN_T
					LDA $1588,x
					AND #$03
					BNE TURN_T
					RTS
TURN_T				LDA $157C,x
					EOR #$01
					STA $157C,x
RETURNT				RTS


BODORO				JSR SUB_GFX_BO
					LDA $9D
					BNE BODORO_R
					LDA $14C8,x
					CMP #$08
					BNE BODORO_R
					LDA #$10
					STA $1656,x
					LDA #$80
					STA $1662,x
					LDA #$1F
					STA $166E,x
					LDA #$81
					STA $167A,x
					JSL $27FAF4;SUB_OFF_SCREEN_X0
					JSL $01802A
					JSR BODORO_CHECK
					INC $1570,x
					LDA $C2,x
					BNE BODORO_2
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$01
					STA $1602,x
					LDA $D8,x
					SEC
					SBC #$10
					STA $02
					LDA $14D4,x
					SBC #$00
					STA $03
					JSR BODORO_NEAR
BODORO_R			RTS
BODORO_2			JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
					LDA $1588,x
					AND #$01
					BNE BODORO_RIGHT
					LDA $1588,x
					AND #$02
					BNE BODORO_LEFT
					BRA BODORO_2_0
BODORO_RIGHT		LDA $E4,x
					SEC
					SBC #$03
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
					BRA BODORO_2_0
BODORO_LEFT			LDA $E4,x
					CLC
					ADC #$03
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
BODORO_2_0			LDA $1570,x
					LSR A
					LSR A
					AND #$01
					INC A
					INC A
					STA $1602,x
					LDA $157C,x
					BNE BODORO_3
					LDA $B6,x
					BMI BODORO_2_1
					CMP #$30
					BCC BODORO_2_1
					RTS
BODORO_2_1			INC $B6,x
					RTS
BODORO_3			LDA $B6,x
					BPL BODORO_3_1
					CMP #$D0
					BCS BODORO_3_1
					RTS
BODORO_3_1			DEC $B6,x
					RTS
					
BODORO_SPEED		dcb $E0,$20
BODORO_CHECK		JSL $01A7DC
					BCC BODORO_CHECK_R
					LDA $7D
					BMI BODORO_WIN
					CMP #$10
					BCC BODORO_WIN
					LDA #$02
					STA $14C8,x
					LDA #$03
					STA $1DF9
					LDA #$D0
					STA $7D
					JSL $01AB99
BODORO_CHECK_R		RTS
BODORO_WIN			LDA $1497
					BNE BODORO_CHECK_R
					LDA #$28
					STA $1DFC
					STA $1497
					LDA $157C,x
					TAY
					LDA BODORO_SPEED,y
					STA $B6,x
					EOR #$FF
					STA $7B
					LDA $0DBE
					BEQ BODORO_CHECK_R
					DEC $0DBE
					JSR GEN_SPRITE
					LDA #$99
					STA $1686,y
					LDA #$07
					STA $1504,y
					LDA #$20
					STA $15AC,y
					RTS

BODORO_NEAR			REP #$20
					LDA $02
					SEC
					SBC $96
					CMP.W #$FFE0
					BCS BODORO_NEAR_2
					CMP.W #$0021
					BCC BODORO_NEAR_2
					SEP #$20
					BRA BODORO_NEAR_R
BODORO_NEAR_2		SEP #$20
					LDA $E4,x
					STA $02
					LDA $14E0,x
					STA $03
					REP #$20
					LDA $02
					SEC
					SBC $94
					CMP.W #$FFC0
					BCS BODORO_NEAR_3
					CMP.W #$0041
					BCC BODORO_NEAR_3
					SEP #$20
					RTS
BODORO_NEAR_3		SEP #$20
					INC $C2,x
BODORO_NEAR_R		RTS
					

X_SPEED				dcb $30,$D0

QUICKMAN			LDA $1570,x
					BEQ QUICKMAN_2
					JSR SUB_GFX_Q
QUICKMAN_2			LDA $9D
					BNE RETURN3
					LDA $1570,x
					BEQ NEAR_CHECK
					LDY $157C,x
					LDA X_SPEED,y
					STA $B6,x
					STZ $AA,x
					JSL $01802A
					LDA $14E0,x
					BNE DELETE
					LDA $1588,x
					AND #$03
					BNE DELETE
					LDA $14
					AND #$01
					BNE RETURN3
					JSR GEN_BLK
RETURN3				RTS
DELETE				STZ $14C8,x
					JSR GEN_BLK
					RTS
NEAR_CHECK			LDA $D8,x
					SEC
					SBC $96
					STA $0F
					LDA $14D4,x
					SBC $97
					CMP #$00
					BNE RETURN3
					LDA $0F
					CMP #$40
					BCS RETURN3
					LDA #$17
					STA $1DFC
					LDA #$01
					STA $1570,x
					JSR GEN_BLK
					RTS

GEN_BLK				LDA $157C,x
					BNE GEN_BLK2
GEN_BLK1			LDA $E4,x
					AND #$F0
					STA $9A
					LDA $14E0,x
					STA $9B
					LDA $D8,x
					STA $98
					LDA $14D4,x
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0BCC
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
GEN_BLK2			LDA $E4,x
					CLC
					ADC #$10
					AND #$F0
					STA $9A
					LDA $14E0,x
					ADC #$00
					STA $9B
					LDA $D8,x
					STA $98
					LDA $14D4,x
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0BCC
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
					
YAJIRUSI			LDA $0701
					BEQ YAJIRUSI_R
					JSR SUB_GFX_YAJI
YAJIRUSI_R			RTS

MOON				LDA #$17
					STA $00212C
					LDA #$00
					STA $00212D
					LDA #$00
					STA $14D4,x
					LDA #$D8
					STA $D8,x
					LDA #$20
					CLC
					ADC $1462
					STA $E4,x
					LDA #$00
					ADC $1463
					STA $14E0,x
					JSR SUB_GFX_MN
					LDA $1463
					CMP #$06
					BNE MOON_R
					LDA #$06
					STA $71
					STZ $89
					STZ $88
MOON_R				RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_MOVEMENT
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_MOVEMENT        LDA $14D4,x
					BNE MOVEMENT
					LDA $D8,x
					CMP #$40
					BCC MOVE_END
MOVEMENT            STZ $B6,x
					STZ $AA,x
					LDA $1570,x
					BEQ DONT_MOVE_MARIO
					LDA #$E0
                    STA $AA,x
					LDA ON_THIS,x
                    BEQ DONT_MOVE_MARIO

MOVE_MARIO          LDA $96
					SEC
					SBC #$02
					STA $96
					LDA $97
					SBC #$00
					STA $97
DONT_MOVE_MARIO		JSL $018022             ;update x position, no gravity
                    JSL $01801A             ;update y position, no gravity ;#
MOVE_END            RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; platform code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_B852            STZ ON_THIS,x
					LDA $15C4,x 
                    ORA $154C,x   
                    BNE RETURN05
                          
                    LDA $71       ;Action (5/6=Trigger screen exit)
                    CMP #$01                
                    BCS RETURN05     
                    
                    JSR SUB_B8FF
                    BCC RETURN05      
                    
                    LDA $D8,x    
                    SEC          
                    SBC $1C      
                    STA $02      
                    SEC          
                    SBC $0D      
                    STA $09      
                    LDA $80      
                    CLC          
                    ADC #$18     
                    CMP $09      
                    BCS LBL06      
                    LDA $7D    
                    BMI RETURN05     
                    STZ $7D
                        
                    LDA #$01     
                    STA $1471    ;01 is for the floating rock
                    LDA $0D      
                    CLC          
                    ADC #$1C     
                    STA $00      
                    
                    LDA #$01
                    STA ON_THIS,x
					STA $1570,x
                    

                    LDA $D8,x    
                    SEC          
                    SBC $00      
                    STA $96
                    LDA $14D4,x  
                    SBC #$00     
                    STA $97
                    LDY #$00     
                    LDA $1491               ;amount to move mario 
                    BPL LBL04      
                    DEY
LBL04
                    CLC                     
                    ADC $94
                    STA $94
                    TYA           
                    ADC $96
                    STA $96
RETURN05            RTS           

LBL06               LDA $02       
                    CLC           
                    ADC $0D       
                    STA $02       
                    LDA #$FF      
                    LDY $73       
                    BNE LBL07      
                    LDY MARIO_STATUS       
                    BNE SMALL_MARIO
LBL07
                    LDA #$08   
SMALL_MARIO
                    CLC                     
                    ADC $80      
                    CMP $02      
                    BCC LBL10      
                    LDA $7D
                    BPL LBL09    
                    LDA #$10                
                    ;STA $7D
LBL09
                    RTS       
LBL10
                    LDA $0E       
                    CLC           
                    ADC #$10      
                    STA $00       
                    LDY #$00      
                    LDA $E4,x     
                    SEC           
                    SBC $1A       
                    CMP $7E       
                    BCC LBL11     
                    LDA $00       
                    EOR #$FF      
                    INC A         
                    STA $00       
                    DEY     
LBL11
                    LDA $E4,x     
                    CLC           
                    ADC $00       
                    ;STA $94
                    TYA           
                    ADC $14E0,x   
                    ;STA $95
                    ;STZ $7B
                    RTS                     


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; make standable
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_B8FF
                    LDA $00      
                    STA $0E      
                    LDA $02      
                    STA $0D      
                    LDA $E4,x    
                    CLC               
					ADC #$06     ;#Jnʒu
                    STA $04      
                    LDA $14E0,x  
                    ADC #$00     
                    STA $0A      
                    LDA $00      
                    ASL A        
                    CLC          
                    ADC #$08     ;#TCY
                    STA $06      

                    LDA $D8,x    
                    SEC          
                    SBC $02
                    STA $05      
                    LDA $14D4,x  
                    SBC #$00     
                    STA $0B      
                    LDA $02      
                    ASL A        
                    CLC          
                    ADC #$20    
                    STA $07      
                    JSL $03B664  
                    JSL $03B72B  
                    RTS 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            
                    LDA $1570,x             
					BEQ SUB_GFX_1
					LDA #$CC
                    STA $0302,y             ; /
					STA $0306,y
					LDA $01
					CLC
					ADC #$03
					STA $0301,y
					STA $0305,y
					LDA $00                 ; \ 
                    STA $0300,y             ; /
					CLC
					ADC #$10
					STA $0304,y

					LDA #$0B             ;  | get palette info
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					STA $0307,y

                                        
SUB_GFX_1			STZ $00       
                    STZ $01       
                    STZ $02       
                    STZ $03       
                    LDY #$00                 
                    LDA #SIZE   
                    STA $0000,y   
                    LSR A         
                    STA $0001,y   
                                        
                    LDA $00       
                    PHA           
                    LDA $02       
                    PHA  
					
                    LDY #$02                ; \ 02, because we didn't write to 460 yet
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen

                    PLA           
                    STA $02       
                    PLA           
                    STA $00       
                    RTS                
					
					
SUB_GFX_Q           JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					LDA #$CE
                    STA $0302,y             ; /
					LDA $01
					SEC
					SBC #$01
					STA $0301,y
					LDA $00                 ; \ 
                    STA $0300,y             ; /
					LDA #$0D             ;  | get palette info
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					
                    LDY #$02                ; \ 02, because we didn't write to 460 yet
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen   
                    RTS                
					
BIYON_HORZ			dcb $F8,$08,$08,$F8
BIYON_TILE			dcb $80,$82,$84,$86,$88,$8A,$84,$86
BIYON_PROP			dcb $09,$09,$49,$49

BIYON_HORZ2			dcb $F8,$08,$F8,$08,$01,$04
					dcb $08,$F8,$08,$F8,$FF,$FC
BIYON_VERT2			dcb $00,$00,$10,$10,$20,$20
BIYON_TILE2			dcb $8C,$8E,$AC,$AE,$A8,$A8
					dcb $A0,$A2,$AC,$AE,$C4,$C4
					dcb $A4,$A6,$AC,$AE,$AA,$AA
					dcb $A0,$A2,$AC,$AE,$C4,$C4
BIYON_PROP2			dcb $09,$09,$09,$09,$49,$09
					dcb $49,$49,$49,$49,$09,$49

SUB_GFX_BIYON		JSR GET_DRAW_INFO
					LDA $C2,x
					BNE SUB_GFX_BIYON2
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$03
					ASL A
					STA $03
					LDA $157C,x
					ASL A
					STA $02
					PHX
					LDX #$01
BIYON_LOOP			PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $00
					CLC
					ADC BIYON_HORZ,x
					STA $0300,y
					LDA BIYON_PROP,x
					ORA $64
					STA $0303,y
					PLX
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA $01
					STA $0301,y
					LDA BIYON_TILE,x
					STA $0302,y
					PLX
					INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL BIYON_LOOP
                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$01                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
SUB_GFX_BIYON2		LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					ASL A
					STA $03
					ASL A
					CLC
					ADC $03
					STA $03
					LDA $157C,x
					ASL A
					STA $02
					ASL A
					CLC
					ADC $02
					STA $02
					PHX
					LDX #$05
BIYON_LOOP2			LDA $01
					CLC
					ADC BIYON_VERT2,x
					STA $0301,y
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $00
					CLC
					ADC BIYON_HORZ2,x
					STA $0300,y
					LDA BIYON_PROP2,x
					ORA $64
					STA $0303,y
					PLX
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA BIYON_TILE2,x
					STA $0302,y
					PLX
					INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL BIYON_LOOP2
                    PLX                     ; pull, X = sprite index
                    LDY #$02             ; \ we've already set 460 so use FF
                    LDA #$05                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS

ONE_TILE			dcb $C6,$C6,$24
					dcb $5D,$5D,$24
ONE_HORZ			dcb $F5,$0B,$00
					dcb $FE,$0B,$00
ONE_VERT			dcb $F8,$F8,$00
					dcb $00,$00,$00
ONE_SIZE			dcb $02,$02,$02
					dcb $00,$00,$02
ONE_PROP			dcb $46,$06,$0A
SUB_GFX_ONE			JSR GET_DRAW_INFO
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					STA $03
					ASL A
					CLC
					ADC $03
					STA $03
					PHX
					LDX #$02
ONE_LOOP			LDA ONE_PROP,x
					ORA $64
					STA $0303,y
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA $00
					CLC
					ADC ONE_HORZ,x
					STA $0300,y
					LDA $01
					CLC
					ADC ONE_VERT,x
					STA $0301,y
					LDA ONE_TILE,x
					STA $0302,y
					PHY
					TYA                     ; \ get index to sprite property map ($460)...
					LSR A                   ; |    ...we use the sprite OAM index...
					LSR A                   ; |    ...and divide by 4 because a 16x16 tile is 4 8x8 tiles
					TAY                     ; | 
					LDA ONE_SIZE,x
					STA $0460,y            ; /
					PLY
					PLX
					INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL ONE_LOOP
                    PLX                     ; pull, X = sprite index
                    LDY #$FF               ; \ we've already set 460 so use FF
                    LDA #$02                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS

BO_HORZ				dcb $00,$00,$FD,$08,$00
					dcb $00,$00,$FD,$08,$00
					dcb $00,$00,$FD,$08,$00
					dcb $00,$00,$FB,$02,$0B
					dcb $00,$00,$0B,$00,$00
					dcb $00,$00,$0B,$00,$00
					dcb $00,$00,$0B,$00,$00
					dcb $00,$00,$0F,$06,$FD
					
BO_VERT				dcb $F6,$05,$08,$08,$00
					dcb $F6,$05,$08,$08,$00
					dcb $F6,$05,$08,$08,$00
					dcb $F6,$05,$06,$09,$06
					
BO_TILE				dcb $C0,$C2,$E2,$E2,$F0
					dcb $C0,$C2,$E2,$E2,$F0
					dcb $C0,$C2,$E0,$E0,$F0
					dcb $C0,$C2,$E1,$E2,$E1
					
BO_PROP				dcb $47,$47,$47,$47,$47
					dcb $07,$47,$47,$47,$47
					dcb $47,$47,$07,$47,$47
					dcb $47,$47,$07,$47,$47
					dcb $07,$07,$07,$07,$07
					dcb $47,$07,$07,$07,$07
					dcb $07,$07,$47,$07,$07
					dcb $07,$07,$47,$07,$07
					
BO_SIZE				dcb $02,$02,$00,$00,$00

SUB_GFX_BO			JSR GET_DRAW_INFO
					LDA $1602,x
					STA $03
					ASL A
					ASL A
					CLC
					ADC $03
					STA $03
					STZ $02
					LDA $157C,x
					BEQ SUB_GFX_BO_1
					LDA #$14
					STA $02
SUB_GFX_BO_1		PHX
					LDX #$04
BO_LOOP				PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA $01
					CLC
					ADC BO_VERT,x
					STA $0301,y
					LDA BO_TILE,x
					STA $0302,y
					TXA
					CLC
					ADC $02
					TAX
					LDA $00
					CLC
					ADC BO_HORZ,x
					STA $0300,y
					LDA BO_PROP,x
					ORA $64
					STA $0303,y
					
					PLX
					PHY
					TYA                     ; \ get index to sprite property map ($460)...
					LSR A                   ; |    ...we use the sprite OAM index...
					LSR A                   ; |    ...and divide by 4 because a 16x16 tile is 4 8x8 tiles
					TAY                     ; | 
					LDA BO_SIZE,x
					STA $0460,y            ; /  
					PLY
					INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL BO_LOOP
                    PLX                     ; pull, X = sprite index
                    LDY #$FF               ; \ we've already set 460 so use FF
                    LDA #$04                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS


HORIZ_DISP_YJ          dcb $00,$10,$00,$10
VERT_DISP_YJ           dcb $FF,$FF,$0F,$0F
TILEMAP_YJ             dcb $C0,$C0,$E0,$E0
PROPERTIES_YJ          dcb $0F,$4F,$0F,$4F

SUB_GFX_YAJI		JSR GET_DRAW_INFO
					PHX
					LDX #$03
YAJI_LOOP			LDA $00                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC HORIZ_DISP_YJ,x         ; |
                    STA $0300,y 
					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP_YJ,x         ; |
                    STA $0301,y             ; /
					
					LDA TILEMAP_YJ,x           ; \ store tile
                    STA $0302,y             ; /
                    
					LDA PROPERTIES_YJ,x
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties

                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL YAJI_LOOP

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
					
H_HORZ				dcb $E8,$F8,$08,$18,$E8,$F8,$08,$18,$E8,$F8,$08,$18,$E8,$F8,$08,$18
H_VERT				dcb $E8,$E8,$E8,$E8,$F8,$F8,$F8,$F8,$08,$08,$08,$08,$18,$18,$18,$18
H_TILE				dcb $80,$82,$82,$80,$A0,$A2,$A2,$A0,$A0,$A2,$A2,$A0,$80,$82,$82,$80
H_PROP				dcb $0F,$0F,$4F,$4F,$0F,$0F,$4F,$4F,$8F,$8F,$CF,$CF,$8F,$8F,$CF,$CF

SUB_GFX_H			JSR GET_DRAW_INFO
					LDA $00
					STA $151C,x
					LDA $01
					STA $1528,x
					LDA $1570,x
					TAY
					STA $15EA,x
					PHX
					LDX #$0F
LOOP_H              LDA H_TILE,x
					STA $0302,y
					LDA $00
					CLC
					ADC H_HORZ,x
					STA $0300,y
					LDA $01
					CLC
					ADC H_VERT,x
					STA $0301,y
					LDA H_PROP,x
					ORA $64
					STA $0303,y
					INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_H          ; / 
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$0F
                    ;JSL $28FCC0 ;# $200p̃OtBbN[`
					JSL $01B7B3
                    RTS                     ; return


DSN_TILE			dcb $84,$86,$86,$84,$A4,$A6,$A6,$A4,$88,$8A,$8A,$88,$A8,$AA,$AA,$A8
DSN_HORZ			dcb $00,$10,$20,$30,$00,$10,$20,$30,$00,$10,$20,$30,$00,$10,$20,$30
DSN_VERT			dcb $00,$00,$00,$00,$10,$10,$10,$10,$20,$20,$20,$20,$30,$30,$30,$30
DSN_PRP				dcb $03,$03,$43,$43,$03,$03,$43,$43,$03,$03,$43,$43,$03,$03,$43,$43
DSN_TBL				dcb $40,$80,$C0,$40,$80,$C0,$40,$80,$C0,$40
SUB_GFX_DSN			JSR GET_DRAW_INFO
					TXA
					AND #$03
					TAY
					LDA DSN_TBL,y
					TAY
					STA $15EA,x
					PHX
					LDX #$0F
LOOP_DSN            LDA DSN_TILE,x
					STA $0202,y
					LDA $00
					CLC
					ADC DSN_HORZ,x
					STA $0200,y
					LDA $01
					CLC
					ADC DSN_VERT,x
					STA $0201,y
					LDA DSN_PRP,x
					ORA $64
					STA $0203,y
					INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_DSN          ; / 
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$0F
                    JSL $28FCC0 ;# $200p̃OtBbN[`
                    RTS                     ; return


HORIZ_DISP_MN          dcb $F0,$00,$10,$F0,$00,$10,$F0,$00,$10
VERT_DISP_MN           dcb $F0,$F0,$F0,$00,$00,$00,$10,$10,$10
TILEMAP_MN             dcb $80,$82,$84,$A0,$A2,$A4,$C0,$C2,$C4

SUB_GFX_MN			JSR GET_DRAW_INFO
					PHX
					LDX #$08
MN_LOOP				LDA $00                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC HORIZ_DISP_MN,x         ; |
                    STA $0300,y 
					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP_MN,x         ; |
                    STA $0301,y             ; /
					
					LDA TILEMAP_MN,x           ; \ store tile
                    STA $0302,y             ; /
                    
					LDA #$0F
                    ;ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties

                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL MN_LOOP

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$08                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS      

KTN_HORZ			dcb $F8,$08,$F8,$08
KTN_VERT			dcb $00,$00,$10,$10
KTN_TILE			dcb $8E,$8E,$AE,$AE
KTN_PROP			dcb $03,$43,$03,$43
SUB_GFX_KTN			JSR GET_DRAW_INFO
					PHX
					LDX #$03
LOOP_KTN			LDA $00
					CLC
					ADC KTN_HORZ,x
					STA $0300,y
					LDA $01
					CLC
					ADC KTN_VERT,x
					STA $0301,y
					LDA KTN_TILE,x
					STA $0302,y
					LDA KTN_PROP,x
					ORA $64
					STA $0303,y
					INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_KTN

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS   
					
HORIZ_DISP          dcb $F8,$08,$F8,$08,$08,$F8,$08,$F8
VERT_DISP           dcb $F0,$F0,$00,$00,
TILEMAP             dcb $80,$82,$A0,$A2,$84,$86,$A4,$A6
PROPERTIES          dcb $0D,$4D


SUB_GFX_T           JSR GET_DRAW_INFO
					
					LDA $157C,x
					STA $02
					PHX
					LDX $02
					LDA PROPERTIES,x
					PLX
					STA $0F
					LDA $02
					ASL A
					ASL A
					STA $02
					
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$01
					ASL A
					ASL A
					STA $03
					
					PHX
                    LDX #$03                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START          PHX                     ; push, current tile

					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP,x         ; |
                    STA $0301,y             ; /
					
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /
					PLX
					

					TXA
					CLC
					ADC $02
					TAX
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP,x        ; |
                    STA $0300,y             ; /

                    
					LDA $0F
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties


                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS      


SUB_GET_DIR         LDY #$00                
                    LDA $94                
                    SEC                     
                    SBC $E4,x               
                    STA $0F                 
                    LDA $95                 
                    SBC $14E0,x             
                    BPL LABEL16             
                    INY                     
LABEL16             RTS     


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; HDMA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HDMA_COLOR			LDA #$10
					STA $7FFB20
					LDA #$20
					STA $7FFB28
					LDA #$00
					STA $7FFB21
					LDA #$02
					STA $7FFB29
					LDA #$21
					STA $7FFB22
					LDA #$22
					STA $7FFB2A
					LDA #$00
					STA $7FFB23
					STA $7FFB2B
					LDA #$E2
					STA $7FFB24
					LDA #$E3
					STA $7FFB2C
					LDA #$7F
					STA $7FFB25
					STA $7FFB2D
					
					LDA #$57
					STA $7FE200
					STA $7FE300
					LDA #$2E
					STA $7FE201
					LDA #$42
					STA $7FE301
					LDA #$04
					STA $7FE302
					
					LDA #$04
					STA $7FE202
					STA $7FE303
					LDA #$2E
					STA $7FE203
					LDA #$43
					STA $7FE304
					LDA #$0C
					STA $7FE305
					
					LDA #$04
					STA $7FE204
					STA $7FE306
					LDA #$2E
					STA $7FE205
					LDA #$64
					STA $7FE307
					LDA #$14
					STA $7FE308
					
					LDA #$04
					STA $7FE206
					STA $7FE309
					LDA #$2E
					STA $7FE207
					LDA #$86
					STA $7FE30A
					LDA #$1C
					STA $7FE30B
					
					LDA #$04
					STA $7FE208
					STA $7FE30C
					LDA #$2E
					STA $7FE209
					LDA #$A7
					STA $7FE30D
					LDA #$24
					STA $7FE30E
					
					LDA #$04
					STA $7FE20A
					STA $7FE30F
					LDA #$2E
					STA $7FE20B
					LDA #$C9
					STA $7FE310
					LDA #$2C
					STA $7FE311
					
					LDA #$04
					STA $7FE20C
					STA $7FE312
					LDA #$2E
					STA $7FE20D
					LDA #$0A
					STA $7FE313
					LDA #$35
					STA $7FE314
					
					LDA #$04
					STA $7FE20E
					STA $7FE315
					LDA #$2E
					STA $7FE20F
					LDA #$2D
					STA $7FE316
					LDA #$3D
					STA $7FE317
					
					LDA #$04
					STA $7FE210
					STA $7FE318
					LDA #$2E
					STA $7FE211
					LDA #$4F
					STA $7FE319
					LDA #$35
					STA $7FE31A
					
					LDA #$04
					STA $7FE212
					STA $7FE31B
					LDA #$2E
					STA $7FE213
					LDA #$92
					STA $7FE31C
					LDA #$2D
					STA $7FE31D
					
					LDA #$04
					STA $7FE214
					STA $7FE31E
					LDA #$2E
					STA $7FE215
					LDA #$B4
					STA $7FE31F
					LDA #$25
					STA $7FE320
					
					LDA #$04
					STA $7FE216
					STA $7FE321
					LDA #$2E
					STA $7FE217
					LDA #$37
					STA $7FE322
					LDA #$1E
					STA $7FE323
					
					LDA #$04
					STA $7FE218
					STA $7FE324
					LDA #$2E
					STA $7FE219
					LDA #$B9
					STA $7FE325
					LDA #$16
					STA $7FE326
					
					LDA #$04
					STA $7FE21A
					STA $7FE327
					LDA #$2E
					STA $7FE21B
					LDA #$5C
					STA $7FE328
					LDA #$17
					STA $7FE329
					
					LDA #$04
					STA $7FE21C
					STA $7FE32A
					LDA #$2E
					STA $7FE21D
					LDA #$FF
					STA $7FE32B
					LDA #$37
					STA $7FE32C
					
					LDA #$01
					STA $7FE21E
					STA $7FE32D
					LDA #$2E
					STA $7FE21F
					LDA #$00
					STA $7FE32E
					LDA #$00
					STA $7FE32F
					
					LDA #$00
					STA $7FE220
					STA $7FE330
					RTS
					
RETURN67            RTS
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
					LDA $E4,x
                    STA $00E4,y
                    LDA $14E0,x
                    STA $14E0,y             ; /

					LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS
					
RETURNK68           RTS     
GEN_NORMAL          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURNK68            ; / after: Y has index of sprite being generated

                    LDA $7FFF9E
                    STA $009E,y
					LDA #$08
					STA $14C8,y
GEN_NORMAL_2                    
                    LDA $E4,x               ;\ set x position for new sprite
                    STA $00E4,y

                    LDA $14E0,x             ;  |
                    STA $14E0,y             ; /

                    LDA $D8,x               ;\ set y position for new sprite
					STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
					STA $14D4,y             ; /

                    PHX
                    TYX
                    JSL $07F7D2             ;  
                    PLX
                    RTS                     ; return
