;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Coaster_koopa
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
TILEMAP             dcb $00,$02,$20,$22,$04,$06,$24,$26,$08,$0A,$28,$2A
HORZ_DISP           dcb $00,$10,$00,$10
VERT_DISP           dcb $F8,$F8,$08,$08,$F8,$F8,$08,$08,$EE,$EE,$FE,$FE

DEF_SPEED = $24
DOWN_SPEED = $34
UP_SPEED = $14
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA #$00
					STA $1570,x
					LDA $D8,x
					STA $1504,x
					LDA $14D4,x
					STA $1594,x
					LDA $1588,x
					AND #$04
					STA $14F8,x
					LDA $14E0,x
					CMP #$00
					BNE INIT1
					LDA #$00
					STA $151C,x
					LDA #$01
					STA $7FFA00
					JSR POS_SAVE
                    RTL
INIT1				CMP #$04
					BNE INIT2
					LDA $7FFC01
					CMP #$06
					BCC INIT1_2
					STZ $14C8,x
					RTL
INIT1_2				LDA #$01
					STA $151C,x
					LDA #$01
					STA $7FFA10
					JSR POS_SAVE
                    RTL
INIT2				CMP #$06
					BNE INIT3
					LDA $7FFC01
					CMP #$04
					BCC INIT2_2
					STZ $14C8,x
					RTL
INIT2_2				LDA #$02
					STA $151C,x
					LDA #$01
					STA $7FFA20
					JSR POS_SAVE
                    RTL
INIT3				CMP #$08
					BNE INIT4
					LDA $7FFC01
					CMP #$02
					BCC INIT3_2
					STZ $14C8,x
					RTL
INIT3_2				LDA #$03
					STA $151C,x
					LDA #$01
					STA $7FFA30
					JSR POS_SAVE
                    RTL
INIT4				LDA $7FFC01
					BEQ INIT4_2
					STZ $14C8,x
					RTL
INIT4_2				LDA #$04
					STA $151C,x
					LDA #$01
					STA $7FFA40
					JSR POS_SAVE
                    RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

FALL				LDA #$30
					STA $AA,x
					STZ $B6,x
RETURN              RTS                    
START_HB_CODE       JSR SUB_GFX
					LDA $9D
					BNE RETURN
					JSR POS_SAVE
					LDA $14C8,x
					CMP #$02
					BEQ FALL
					CMP #$08
					BNE RETURN
					JSR MODE_DEC
					JSR SPEED_DEC
					JSR DEFAULT
					JSR DAMAGE_CHECK
					JSL $01802A
					LDA $1420
					CMP #$04
					BNE RETURN
					LDA #$01
					STA $14AF
					RTS

DAMAGE_CHECK
					JSL $01A7DC
					BCC CHECK_E
					LDA $7D                 ; \  if mario's y speed < 10 ...
                    CMP #$10                ;  }   ... sprite will hurt mario
                    BMI ENE_WINS
					LDA $D8,x
					SEC
					SBC $96
					STA $0F
					LDA $14D4,x
					SBC $97
					BCC ENE_WINS
					LDA $0F
					CMP #$08
					BCC ENE_WINS
MARIO_WINS          JSL $01AA33             ; set mario speed
					JSL $01AB99             ; display contact graphic
					LDA #$02
					STA $14C8,x
					LDA #$03
                    STA $1DF9
CHECK_E				RTS
ENE_WINS			LDA $7FFC01
					INC A
					STA $7FFC01
					PHX
					LDA $7FFDD1
					TAX
					LDA #$E0
					STA $7B
					STA $1570,x
					PLX
					LDA #$20
                    STA $1DF9
					RTS

POS_SAVE			LDA $151C,x
					BNE POS1
					LDA $E4,x
					STA $7FFA01
					LDA $14E0,x
					STA $7FFA02
					RTS
POS1				CMP #$01
					BNE POS2
					LDA $E4,x
					STA $7FFA11
					LDA $14E0,x
					STA $7FFA12
					RTS
POS2				CMP #$02
					BNE POS3
					LDA $E4,x
					STA $7FFA21
					LDA $14E0,x
					STA $7FFA22
					RTS
POS3				CMP #$03
					BNE POS4
					LDA $E4,x
					STA $7FFA31
					LDA $14E0,x
					STA $7FFA32
					RTS
POS4				LDA $E4,x
					STA $7FFA41
					LDA $14E0,x
					STA $7FFA42
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; etc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
UTURN				INC $1570,x
					LDA $1570,x
					STA $B6,x
RETURN112			RTS
SPEED_DEC			LDA $1570,x
					CMP #$80
					BCS UTURN
					STA $B6,x
					LDA $1528,x
					BNE MODE2
					LDA $1570,x
					CMP #DEF_SPEED
					BEQ RETURN112
					BCC MODE1_2
					DEC A
					STA $B6,x
					STA $1570,x
					RTS
MODE1_2				INC A
					STA $B6,x
					STA $1570,x
					RTS
MODE2				CMP #$01
					BNE MODE3
					LDA $1570,x
					CMP #UP_SPEED
					BEQ RETURN112
					BCC MODE2_2
					DEC A
					STA $B6,x
					STA $1570,x
					RTS
MODE2_2				INC A
					STA $B6,x
					STA $1570,x
					RTS
MODE3				LDA $1570,x
					CMP #DOWN_SPEED
					BEQ RETURN112
					BCC MODE3_2
					DEC A
					STA $B6,x
					STA $1570,x
					RTS
MODE3_2				INC A
					STA $B6,x
					STA $1570,x
					RTS

DEFAULT				LDA $D8,x
					STA $1504,x
					LDA $14D4,x
					STA $1594,x
					LDA $1588,x
					AND #$04
					STA $14F8,x
					RTS

MODE_DEC			LDA $1588,x
					AND #$04
					BEQ MODE_DECE
					LDA $14F8,x
					BEQ MODE_DECE
					LDA $1504,x
					SEC
					SBC $D8,x
					BNE MODE_DEC2
					STZ $1528,x
					STZ $1602,x
MODE_DECE			RTS
MODE_DEC2			LDA $1594,x
					SBC $14D4,x
					BMI MODE_DEC3
					LDA #$01
					STA $1528,x
					LDA #$08
					STA $1602,x
					RTS
MODE_DEC3			LDA #$02
					STA $1528,x
					LDA #$04
					STA $1602,x
					RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
                    PHX                     ; push sprite index
					LDA $1602,x
					STA $03
                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START          LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP,x         ;  |
                    STA $0300,y             ; /
					
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILEMAP,x           ; \ store tile
                    STA $0302,y
					LDA $01
					CLC
					ADC VERT_DISP,x
					STA $0301,y

                    LDA #$00
                    LDX $15E9               ;  |
                    ORA $15F6,x             ;  | get palette info
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    PLX

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

