;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; KROOL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"
                    RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                     ; return           
CODE_START          LDA $1504,x
					BNE LBL001
					JSR KROOL
					RTS
LBL001				CMP #$01
					BNE LBL002
					JSR KBUL
					RTS
LBL002				CMP #$02
					BNE LBL003
					JSR SHELL
					RTS
LBL003				CMP #$03
					BNE LBL004
					JSR VACUME
					RTS
LBL004				JSR SMOKE
					RTS
					
					
					
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Smoke
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MRETURN             RTS                     ; return           
SMOKE               JSR SUB_GFXM
                    LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE MRETURN              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE MRETURN              ; /
					LDA #$18
					STA $1686,x
                    JSR MCHECK_DAMAGE
					JSL $01802A             ; update position based on speed values
					INC $1570,x
					LDA $14E0,x
					BEQ MMAIN2
					STZ $14C8,x
					RTS
MMAIN2				LDA $1528,x
					BNE MNOT_MODE1
					JSR MMODE1
					RTS
MNOT_MODE1			CMP #$01
					BNE MNOT_MODE2
					JSR MMODE2
					RTS
MNOT_MODE2			JSR MMODE3
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Vacume
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
VRETURN              RTS                     ; return           
VACUME              JSR SUB_GFXV
                    LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE VRETURN              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE VRETURN              ; /
					LDA #$
					LDA #$00
					STA $7FFA01
                    JSR VDAMAGE_CHECK
					DEC $151C,x
					LDA $151C,x
					BNE VMAIN2
					LDA #$02
					STA $7FFA01
					STZ $14C8,x
					RTS
VMAIN2				JSR VMODE1
					INC $1570,x
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Shell
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SRETURN              RTS                     ; return           
SHELL               JSR SUB_GFXS             ; graphics routine
                    LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE SRETURN              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE SRETURN              ; /
					LDA $14E0,x
					BEQ SMAIN1
					STZ $14C8,x
SMAIN1
                    JSR SCHECK_MARIO
					JSL $01802A             ; update position based on speed values
					LDA $14E0,x
					BEQ SMAIN2
					STZ $14C8,x
					RTS
SMAIN2				JSR SMODE1
					INC $1570,x
					RTS



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Kbul
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BRETURN              RTS                     ; return           
KBUL		        JSR SUB_GFXB             ; graphics routine
                    LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE BRETURN              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE BRETURN              ; /
					LDA #$18
					STA $1686,x
                    JSR BCHECK_DAMAGE
					JSL $01802A             ; update position based on speed values
					LDA $14E0,x
					BEQ BMAIN2
					STZ $14C8,x
					RTS
BMAIN2				LDA $1528,x
					BNE BNOT_MODE1
					JSR BMODE1
					RTS
BNOT_MODE1			CMP #$01
					BNE BNOT_MODE2
					JSR BMODE2
					RTS
BNOT_MODE2			CMP #$02
					BNE BNOT_MODE3
					JSR BMODE3
					RTS
BNOT_MODE3			
BMAIN_E				RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Krool
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
KROOL				JSR SUB_GFX             ; graphics routine
                    LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURNA              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURNA              ; /
					JSL $01802A             ; update position based on speed values

					LDA #$18
					STA $AA,x
					
					LDA $1570,x
					BNE MAIN2
					LDA $14D4,x
					BEQ RETURNA
					INC $1570,x
RETURNA 			RTS
MAIN2				INC $1570,x
					LDA $1570,x
					CMP #$20
					BEQ MAIN3
					LDA #$50
					STA $D8,x
					STZ $14D4,x
					RTS
MAIN3				LDA #$0B
                    STA $1DFB
                    LDA #$FF
                    STA $13C6
                    STA $1493
					STZ $14C8,x
					RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder 
					LDA $00                 ; \ tile x position = sprite x location ($00)
                    STA $0300,y             ; /                    
                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y             ; /

					LDA #$EA
                    STA $0302,y             ; / 

                    PHX
					LDA #$0F
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties

                    PLX                     ; pull, X = sprite index
                    
                    LDY #$02
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

SUB_GFXB             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder 
											
                    PHX                     ; push sprite index

                    LDA $00                 ; \ tile x position = sprite x location ($00)
                    STA $0300,y             ; /                    
                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y             ; /
                                 
					LDA #$AE
                    STA $0302,y             ; / 

                    LDA #$08
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties

                    PLX                     ; pull, X = sprite index
                    
                    LDY #$02
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
STILEMAP             dcb $8A,$8C,$8A,$8E
SPROPERTIES          dcb $0A,$0A,$4A,$0A    

VTILEMAP             dcb $0E,$2E,$2C,$2A
VPROPERTIES          dcb $49,$09
VX_OFFSET			dcb $08,$F0

SUB_GFXV             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder 
					LDA $1570,x
					LSR A
					LSR A
					AND #$03
					STA $03
					LDA $157C,x
					STA $02
                    PHX                     ; push sprite index

                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y             ; /

					LDX $03
					LDA VTILEMAP,x
                    STA $0302,y             ; / 

                    LDX $02
					LDA VX_OFFSET,x
					CLC
					ADC $00                 ; \ tile x position = sprite x location ($00)
                    STA $0300,y             ; /                    
					
					LDA VPROPERTIES,x
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties

                    PLX                     ; pull, X = sprite index
                    
                    LDY #$02
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

SUB_GFXS             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder 
					LDA $1570,x
					LSR A
					LSR A
					AND #$03
					STA $03
                    PHX                     ; push sprite index

                    LDA $00                 ; \ tile x position = sprite x location ($00)
                    STA $0300,y             ; /                    
                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y             ; /

					LDX $03
					LDA STILEMAP,x
                    STA $0302,y             ; / 

                    LDA SPROPERTIES,x
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties

                    PLX                     ; pull, X = sprite index
                    
                    LDY #$02
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
MTILEMAP			dcb $CC,$CE,$EC,$EE

SUB_GFXM             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					STA $03
                    PHX                     ; push sprite index

                    LDA $00                 ; \ tile x position = sprite x location ($00)
                    STA $0300,y             ; /                    
                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y             ; /
                                 
					LDX $03
					LDA MTILEMAP,x
                    STA $0302,y             ; / 

                    LDA #$0B
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties

                    PLX                     ; pull, X = sprite index
                    
                    LDY #$02
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SSPEED1				dcb $10,$F0

SCHECK_MARIO		JSL $01A7DC             ; check for mario/sprite contact
                    BCC SRETURN_24           ; (carry set = contact)
                    LDA $7D                 ; \  if mario's y speed < 10 ...
                    CMP #$10                ;  }   ... sprite will hurt mario
                    BMI SENE_WINS           ; /    
                    
SMARIO_WINS         JSL $01AA33             ; set mario speed
					JSL $01AB99             ; display contact graphic
					JSR SGEN_SHELL
					LDA #$03
					STA $1DF9
					STZ $14C8,x
SRETURN_24          RTS                     ; return 


SENE_WINS            LDA $1497               ; \ if mario is invincible...
                    BNE SRETURN2             ; /   ... return
                    JSL $00F5B7             ; hurt mario
SRETURN2             RTS                     ; return

SMODE1				LDA $157C,x
					PHX
					TAX
					LDA SSPEED1,x
					PLX
					STA $B6,x
					STZ $AA,x
					RTS
					
VMODE1				JSR SUB_GET_DIR
					CPY #$00
					BNE VFACE_LEFT
					DEC $94
					BRA VMODE1_2
VFACE_LEFT			INC $94
VMODE1_2			LDA $15AC,x
					BNE VMODE1_E
					LDA #$20
					STA $15AC,x
					LDA #$17
					STA $1DFC
VMODE1_E			RTS
					

					
VDAMAGE_CHECK        LDA $E4,x
                    STA $7FFE01
                    LDA $14E0,x
                    STA $7FFE02
                    LDA $D8,x
                    STA $7FFE03
                    LDA $14D4,x
                    STA $7FFE04
                    PHX
                    LDX #$09
VLOOP1               LDA $9E,x
                    CMP #$04
                    BNE VLOOP3
					LDA $14C8,x
					CMP #$0A
					BNE VLOOP3
                    JSR VNEAR_CHECK
                    TYA
                    BEQ VLOOP3
					
                    LDA #$03
                    STA $1DF9
					LDA #$01
					STA $7FFA01
					JSR DELETE_ALL
VLOOP3              DEX
                    BPL VLOOP1
                    PLX
                    RTS
					
VNEAR_CHECK          LDY #$00
                    LDA $E4,x
                    SEC
                    SBC $7FFE01
                    STA $0F
                    LDA $14E0,x
                    SBC $7FFE02
                    CMP #$00
                    BEQ VRIGHT_CHECK
                    CMP #$FF
                    BNE VCHECK_E
                    LDA $0F
                    CMP #$F8
                    BCC VCHECK_E
                    BRA VVER_CHECK
VRIGHT_CHECK         LDA $0F
                    CMP #$08
                    BCS VCHECK_E
VVER_CHECK           LDA $D8,x
                    SEC
                    SBC $7FFE03
                    STA $0F
                    LDA $14D4,x
                    SBC $7FFE04
                    CMP #$00
                    BEQ VUNDER_CHECK
                    CMP #$FF
                    BNE VCHECK_E
                    LDA $0F
                    CMP #$E8
                    BCC VCHECK_E
                    BRA VNEAR
VUNDER_CHECK         LDA $0F
                    CMP #$28
                    BCS VCHECK_E
VNEAR                LDY #$01
VCHECK_E             RTS


DELETE_ALL          PHX
                    LDX #$09
VLOOP21              LDA $9E,x
                    CMP #$28
                    BEQ VLOOP22
                    STZ $14C8,x
VLOOP22              DEX
                    BPL VLOOP21
                    PLX
                    RTS
					
SUB_GET_DIR         LDY #$00                
                    LDA $94                 
                    SEC                     
                    SBC $E4,x               
                    STA $0F                 
                    LDA $95               
                    SBC $14E0,x            
                    BPL LABEL16             
                    INY                     
LABEL16             RTS

MSPEED1				dcb $20,$E0

MCHECK_DAMAGE		JSL $01A7DC             ; check for mario/sprite contact
                    BCC MRETURN_24           ; (carry set = contact)
                    LDA $1497               ; \ if mario is invincible...
                    BNE MRETURN_24             ; /   ... return
                    LDA #$FF
					STA $14AD
					STZ $14C8,x
MRETURN_24           RTS                     ; return 

MMODE1				LDA $157C,x
					PHX
					TAX
					LDA MSPEED1,x
					PLX
					STA $B6,x
					STZ $AA,x
					RTS
					
MMODE2				LDA $B6,x
					BNE MMODE2_2
					LDA $13
					CLC
					ADC $94
					CLC
					ADC $96
					AND #$03
					BNE MMODE2_1
					LDA $13
					AND #$01
					CLC
					ADC #$02
MMODE2_1			ASL A
					ASL A
					ASL A
					ASL A
					CLC
					ADC #$40
					STA $D8,x
MMODE2_2			LDA $157C,x
					PHX
					TAX
					LDA MSPEED1,x
					PLX
					STA $B6,x
					STZ $AA,x
					RTS

MMODE3				LDA $B6,x
					BNE MMODE3_2
					LDA $13
					CLC
					ADC $94
					CLC
					ADC $96
					AND #$03
					ASL A
					ASL A
					ASL A
					ASL A
					ASL A
					CLC
					ADC #$10
					STA $1570,x
					LDA #$00
					SEC
					SBC $1570,x
					STA $1570,x
MMODE3_2			LDA $157C,x
					PHX
					TAX
					LDA MSPEED1,x
					PLX
					STA $B6,x
					LDA $1588,x
					AND #$04
					BEQ MMODE3_E
					LDA $1570,x
					STA $AA,x
MMODE3_E			RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; hammer routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SRETURNK68           RTS     
SGEN_SHELL           JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI SRETURNK68            ; / after: Y has index of sprite being generated

                    LDA #$09                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    LDA #$04
                    STA $009E,y
                    
                    LDA $E4,x               ;\ set x position for new sprite
                    STA $00E4,y

                    LDA $14E0,x             ;  |
                    STA $14E0,y             ; /

                    LDA $D8,x               ;\ set y position for new sprite
					CLC
					ADC #$08
                    STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
					ADC #$00
                    STA $14D4,y             ; /

                    PHX
                    TYX
                    JSL $07F7D2             ;  
                    PLX
                    RTS                     ; return
					
					

BSPEED1				dcb $20,$E0

BCHECK_DAMAGE		JSL $01A7DC             ; check for mario/sprite contact
                    BCC BRETURN_24           ; (carry set = contact)
                    LDA $1497               ; \ if mario is invincible...
                    BNE BRETURN_24             ; /   ... return
                    JSL $00F5B7
BRETURN_24          RTS                     ; return 

BMODE1				LDA $157C,x
					PHX
					TAX
					LDA BSPEED1,x
					PLX
					STA $B6,x
					STZ $AA,x
					RTS
					
BMODE2				LDA $B6,x
					BNE BMODE2_2
					LDA $13
					CLC
					ADC $94
					CLC
					ADC $96
					AND #$03
					BNE BMODE2_1
					LDA $13
					AND #$01
					CLC
					ADC #$02
BMODE2_1			ASL A
					ASL A
					ASL A
					ASL A
					CLC
					ADC #$40
					STA $D8,x
BMODE2_2			LDA $157C,x
					PHX
					TAX
					LDA BSPEED1,x
					PLX
					STA $B6,x
					STZ $AA,x
					RTS

BMODE3				LDA $B6,x
					BNE BMODE3_2
					LDA $13
					CLC
					ADC $94
					CLC
					ADC $96
					AND #$03
					ASL A
					ASL A
					ASL A
					ASL A
					ASL A
					CLC
					ADC #$10
					STA $1570,x
					LDA #$00
					SEC
					SBC $1570,x
					STA $1570,x
BMODE3_2			LDA $157C,x
					PHX
					TAX
					LDA BSPEED1,x
					PLX
					STA $B6,x
					LDA $1588,x
					AND #$04
					BEQ BMODE3_E
					LDA $1570,x
					STA $AA,x
BMODE3_E			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
