;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Big Kirby Egg
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					STZ $C2,x
					STZ $1528,x
                    RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


RETURN              RTS                    
START_HB_CODE       LDA $7FF002
					CMP #$01
					BNE RETURN
					LDA $C2,x
					BEQ MAIN0
					CMP #$01
					BNE MAIN1
					JSR SUB_GFX2
					BRA MAIN
MAIN1				JSR SUB_GFX3
					BRA MAIN
MAIN0				LDA $1528,x
					BEQ MAIN
					JSR SUB_GFX
MAIN                LDA $14C8,x             ; \ if hammer bro status != 8...
                    CMP #$08
                    BNE RETURN              ; /    ... return
                    LDA $9D                 ; \ if sprites locked...
                    BNE RETURN              ; /    ... return
					LDA $C2,x
					CMP #$01
					BEQ MAIN10
					CMP #$02
					BEQ MAIN20
					JSR COLOR_CHECK
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					STA $D8,x
					LDA $97
					STA $14D8,x
					JSR SUBMODE
					RTS

MAIN10				STZ $AA,x
					JSL $01802A
					JSL $01A7DC
					BCS MAIN102
					LDA $14E0,x
					BEQ MAIN10_E
					STZ $14C8,x
					RTS
MAIN102				STZ $14C8,x
					LDA #$22
					STA $1DFC
					LDA #$01
					STA $7FF001
MAIN10_E			RTS

MAIN20				JSL $01802A
					LDA $1570,x
					BNE MAIN21
					LDA $AA,x
					CMP #$80
					BCS MAIN20E
					LDA #$CA
					STA $1602,x
					LDA $D8,x
					CMP #$90
					BCC MAIN20E
					STZ $14C8,x
					LDA #$00
					STA $7FF001
MAIN20E				RTS
MAIN21				CMP #$01
					BEQ MAIN22
					LDA #$D0
					STA $AA,x
					LDA $D8,x
					CMP #$10
					BCS MAIN20E
					STZ $14C8,x
					LDA #$00
					STA $7FF001
					RTS
MAIN22				LDA $1602,x
					CMP #$CA
					BEQ MAIN22_2
					LDA #$D0
					STA $AA,x
					LDA $D8,x
					CMP #$04
					BCS MAIN20E
					LDA #$20
					STA $AA,x
					LDA #$CA
					STA $1602,x
					LDA #$78
					STA $E4,x
					STZ $B6,x
					RTS
MAIN22_2			LDA #$20
					STA $AA,x
					LDA $D8,x
					CMP #$70
					BCC MAIN20E
					STZ $14C8,x
					LDA #$20
					STA $1DF9
					LDA #$FF
					STA $14AD
					LDA $7FF003
					INC A
					STA $7FF003
					LDA #$00
					STA $7FF001
					RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

					

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RETURN67            RTS
STONE_GEN           JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
					TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
					LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

					LDA $D8,x
                    STA $00D8,y             ;  |
					LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
COLOR_CHECK			LDA $14AD
					CMP #$E0
					BNE COLOR_E
					STZ $14AD
COLOR_E				RTS
SUBMODE				LDA $1528,x
					BNE NOT_MODE0
					JSR MODE0
					RTS
NOT_MODE0			CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			JSR MODE1
					RTS

MODE0				LDA $7FF001
					BEQ MODE0_G
					LDA $17
					AND #$10
					BEQ MODE0_E
					STZ $1570,x
					LDA #$01
					STA $1528,x
MODE0_E				RTS
MODE0_G				LDA $15AC,x
					BNE MODE0_E
					LDA #$FF
					STA $15AC,x
					LDA $94
					AND #$01
					BNE MODE0_2
					JSR STONE_GEN
					LDA #$01
					STA $00C2,y
					LDA #$08
					STA $00E4,y
					LDA #$10
					STA $00B6,y
					LDA #$60
					STA $00D8,y
					RTS
MODE0_2				JSR STONE_GEN
					LDA #$01
					STA $00C2,y
					LDA #$F8
					STA $00E4,y
					LDA #$F0
					STA $00B6,y
					LDA #$60
					STA $00D8,y
					RTS

MODE1				LDA $17
					AND #$10
					BEQ MODE1_R
					INC $1570,x
					INC $1570,x
					INC $1570,x
					INC $1570,x
MODE1_E				RTS
MODE1_R				STZ $1528,x
					LDA $1570,x
					LSR A
					STA $151C,x
					CMP #$40
					BCC MODE1_2
					LDA #$80
					SEC
					SBC $151C,x
					STA $151C,x
MODE1_2				LDA $151C,x
					CMP #$18
					BCS MODE1_3
					LDA #$00
					STA $151C,x
					BRA MODE1_5
MODE1_3				CMP #$28
					BCC MODE1_4
					LDA #$02
					STA $151C,x
					BRA MODE1_5
MODE1_4				LDA #$01
					STA $151C,x
MODE1_5				LDA #$00
					STA $7FF001
					LDA #$2B
					STA $1DFC
					LDA #$80
					STA $15AC,x
					JSR STONE_GEN
					JSR SPEED_DEC
					LDA $151C,x
					STA $1570,y
					LDA #$02
					STA $00C2,y
					LDA #$C8
					STA $1602,y
					LDA #$40
					STA $15AC,y
					LDA #$D0
					STA $00AA,y
					RTS
					
SPEED_DEC			LDA $E4,x
					CMP #$80
					BCS SPEED2
					LDA #$80
					SEC
					SBC $E4,x
					LSR A
					LSR A
					LSR A
					STA $00B6,y
					RTS
SPEED2				LDA $E4,x
					SEC
					SBC #$80
					LSR A
					LSR A
					LSR A
					STA $00B6,y
					LDA #$00
					SEC
					SBC $00B6,y
					STA $00B6,y
					RTS
					



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)

					LDA $1570,x
					LSR A
					STA $0F
					CMP #$40
					BCC GFX_2
					LDA #$80
					SEC
					SBC $0F
					STA $0F
GFX_2				LDA $00
                    STA $0300,y             ; /                  

                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
					SEC
					SBC $0F
                    STA $0301,y
                    

                    LDA #$C6
                    STA $0302,y             ; / 

        
                    LDA #$0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP             dcb $88,$A8,$C8
VERT_DISP           dcb $E0,$F0,$00

SUB_GFX2             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder
					STZ $03
					LDA $B6,x
					CMP #$80
					BCS GFX2_2
					LDA #$40
					STA $03
GFX2_2				PHX                     ; push sprite index

                    LDX #$02               ; loop counter = (number of tiles per frame) - 1
LOOP_START          
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP,x         ;  |
                    STA $0301,y             ; /   set y position of the tile
                    
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0300,y             ; /   set y position of the tile
					
                    LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; / 
					
					LDA $03
					ORA #$0B
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$02                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_GFX3            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					
					LDA $00
                    STA $0300,y             ; /                  

                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y
                    

                    LDA $1602,x
                    STA $0302,y             ; / 

        
                    LDA #$0B
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
