;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; test
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					EXTRA_BITS = $7FAB10
					MARIO_STATUS    = $19 
                    MARIO_X_SPEED   = $7B
                    MARIO_Y_SPEED   = $7D
                    MARIO_X_POS     = $94
                    MARIO_X_POS_HI  = $95
                    MARIO_Y_POS     = $96 
                    MARIO_Y_POS_HI  = $97
                    SPRITE_Y_SPEED  = $AA
                    SPRITE_X_SPEED  = $B6
                    SPRITE_STATE    = $C2
                    SPRITE_Y_POS    = $D8
                    SPRITE_X_POS    = $E4
                    SPRITE_Y_POS_HI = $14D4
                    SPRITE_X_POS_HI = $14E0
                    SPR_OBJ_STATUS  = $1588
                    IS_ON_YOSHI     = $187A 
                    SPRITE_OAM      = $15EA
                    
                    EXTRA_BITS = $7FAB10
                    
                    ON_THIS         = $1528
                    
                    ;data
                    YOSHI_OFFSET    = $10
                    SIZE            = $08


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA $E4,x
					ADC #$08
					STA $E4,x
					LDA #$25
					STA $1602,x
					STZ ON_THIS,x
					STZ $1594,x
					STZ $1570,x
					LDA EXTRA_BITS,x
                    AND #$04
					BNE INIT_RED
					LDA #$05
					STA $151C,x
					RTL
INIT_RED			LDA #$09
					STA $151C,x
                    RTL
                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


					
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN		JSR TILE_CHECK
			RTS
					
START_HB_CODE
			LDA $E4,x
			PHA
			SEC
			SBC #$10
			STA $E4,x
			LDA $14E0,x
			PHA
			SBC #$00
			STA $14E0,x
			LDA $D8,x
			PHA
			CLC
			ADC #$10
			STA $D8,x
			LDA $14D4,x
			PHA
			ADC #$00
			STA $14D4,x
			JSR SUB_GFX 
			PLA
			STA $14D4,x
			PLA
			STA $D8,x
			PLA
			STA $14E0,x
			PLA
			STA $E4,x
			
			LDA $9D
			BNE RETURN
			
			LDA $E4,x
			PHA
			SEC
			SBC #$20
			STA $E4,x
			LDA $14E0,x
			PHA
			SBC #$00
			STA $14E0,x
			LDA $D8,x
			PHA
			CLC
			ADC #$10
			STA $D8,x
			LDA $14D4,x
			PHA
			ADC #$00
			STA $14D4,x
			JSR SUB_B852
			PLA
			STA $14D4,x
			PLA
			STA $D8,x
			PLA
			STA $14E0,x
			PLA
			STA $E4,x
			
			LDA $1570,x
			BEQ RETURN

			JSR TILE_CHECK
			LDA $15AC,x
			BNE MAIN2
			JSR SPEED_DEC
			JSR AIR_CHECK
			
MAIN2		LDA EXTRA_BITS,x
            AND #$04
			BEQ MAIN_MOVE2
			JSR SUB_MOVEMENT
MAIN_MOVE2	JSR SUB_MOVEMENT
			LDA $AA,x
			PHA
			
			LDA EXTRA_BITS,x
            AND #$04
			BEQ MAIN_UP2
			JSL $01802A
			PLA
			STA $AA,x
			PHA
MAIN_UP2	JSL $01802A
			;JSL $018022             ;update x position, no gravity
            ;JSL $01801A             ;update y position, no gravity
			PLA
			STA $AA,x
			
			
			RTS
			
CHECK_E		RTS
TILE_CHECK	LDA $185F
			CMP $1602,x
			BEQ CHECK_E
			LDA $185F
			STA $1602,x
			CMP #$93
			BEQ UNDER_CHECK
			CMP #$96
			BEQ RL_RETURN
			CMP #$97
			BEQ RL_RETURN
			CMP #$91
			;BEQ RIGHT_CHECK
			RTS
UNDER_CHECK	
			LDA $AA,x
			BEQ CHECK_E
			LDA $AA,x
			BMI CHECK_U
			LDA EXTRA_BITS,x
            AND #$04
			BEQ CHECK_D2
			LDA #$01
			STA $15AC,x
			RTS
CHECK_D2	LDA #$02
			STA $15AC,x
			RTS
CHECK_U		LDA EXTRA_BITS,x
            AND #$04
			BEQ CHECK_U2
			LDA #$04
			STA $15AC,x
			RTS
CHECK_U2	LDA #$08
			STA $15AC,x
CHECK_E		RTS
RIGHT_CHECK
			LDA EXTRA_BITS,x
            AND #$04
			BEQ R_CHECK_2
			LDA #$04
			STA $15AC,x
			RTS
R_CHECK_2	LDA #$08
			STA $15AC,x
			RTS
RL_RETURN	LDA #$00
			SEC
			SBC $B6,x
			STA $B6,x
			RTS
			
AIR_CHECK	LDA $185F
			CMP #$25
			BEQ AIR
			CMP #$2B
			BEQ AIR
			CMP #$2D
			BEQ AIR
			CMP #$2E
			BNE NOT_AIR
AIR			LDA $1594,x
			CMP #$10
			BEQ AIR2
			INC $1594,x
			RTS
AIR2		LDA $AA,x
			CLC
			ADC #$01
			STA $AA,x
			RTS
NOT_AIR		STZ $1594,x
			RTS
			
THIS_END		RTS
SUB_MOVEMENT	LDA ON_THIS,x
				BEQ THIS_END
				LDA $77
				AND #$03
				BNE THIS_END
				LDA $B6,x
				BEQ THIS_2
				BMI MOVE1
				LDA $94
				CLC
				ADC #$02
				STA $94
				LDA $95
				ADC #$00
				STA $95
				BRA THIS_2
MOVE1			LDA $94
				SEC
				SBC #$02
				STA $94
				LDA $95
				SBC #$00
				STA $95
THIS_2			LDA $AA,x
				BPL THIS_3
				CMP #$F0
				BCS THIS_END
				LDA $96
				SEC
				SBC #$02
				STA $96
				LDA $97
				SBC #$00
				STA $97
				RTS
THIS_3			CMP #$20
				BCC THIS_END
				LDA $96
				CLC
				ADC #$02
				STA $96
				LDA $97
				ADC #$00
				STA $97
				RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SPEED
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPEED_DEC	;LDA $1693
			LDA $185F
			CMP #$93
			BEQ UNDER_LINE
			CMP #$90
			BEQ RIGHT_LINE
			CMP #$86
			BEQ U_R_LINE
			CMP #$91
			BEQ LEFT_LINE
			CMP #$92
			BEQ UNDER_LINE
			CMP #$87
			BEQ D_R_LINE
RETURN12	RTS
			
UNDER_LINE	LDA $B6,x
			BMI UNDER2
			LDA #$20
			STA $B6,x
			STZ $AA,x
			RTS
UNDER2		LDA #$E0
			STA $B6,x
			STZ $AA,x
			RTS

			
RIGHT_LINE	LDA $AA,x
			BMI RIGHT2
			LDA #$20
			STA $AA,x
			STZ $B6,x
			RTS
RIGHT2		LDA #$E0
			STA $AA,x
			STZ $B6,x
			RTS

			
LEFT_LINE	LDA $AA,x
			BMI LEFT2
			LDA #$20
			STA $AA,x
			STZ $B6,x
			RTS
LEFT2		LDA #$E0
			STA $AA,x
			STZ $B6,x
			RTS

			
U_R_LINE	LDA $B6,x
			BEQ U_R0
			CMP #$80
			BCS U_R2
			BRA U_R1
U_R0		LDA $AA,x
			BPL U_R2
U_R1		LDA #$E0
			STA $AA,x
			LDA #$20
			STA $B6,x
			RTS
U_R2		LDA #$20
			STA $AA,x
			LDA #$E0
			STA $B6,x
			RTS
			
D_R_LINE	LDA $B6,x
			BEQ D_R0
			CMP #$80
			BCS D_R2
			BRA D_R1
D_R0		LDA $AA,x
			BMI D_R2
D_R1		LDA #$20
			STA $AA,x
			LDA #$20
			STA $B6,x
			RTS
D_R2		LDA #$E0
			STA $AA,x
			LDA #$E0
			STA $B6,x
			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; platform code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_B852            STZ ON_THIS,x
					LDA $15C4,x 
                    ORA $154C,x   
                    BNE RETURN05
                          
                    LDA $71       ;Action (5/6=Trigger screen exit)
                    CMP #$01                
                    BCS RETURN05     
                    
                    JSR SUB_B8FF
                    BCC RETURN05      
                    
                    LDA SPRITE_Y_POS,x    
                    SEC          
                    SBC $1C      
                    STA $02      
                    SEC          
                    SBC $0D      
                    STA $09      
                    LDA $80      
                    CLC          
                    ADC #$18     
                    CMP $09      
                    BCS LBL06      
                    LDA MARIO_Y_SPEED    
                    BMI RETURN05     
                    STZ MARIO_Y_SPEED  
                        
                    LDA #$01     
                    STA $1471    ;01 is for the floating rock
                    LDA $0D      
                    CLC          
                    ADC #$1C     
                    STA $00      
                    
                    LDA #$01
                    STA ON_THIS,x
					STA $1570,x
                    

                    LDA SPRITE_Y_POS,x    
                    SEC          
                    SBC $00      
                    STA MARIO_Y_POS      
                    LDA SPRITE_Y_POS_HI,x  
                    SBC #$00     
                    STA MARIO_Y_POS_HI      
                    LDY #$00     
                    LDA $1491               ;amount to move mario 
                    BPL LBL04      
                    DEY
LBL04
                    CLC                     
                    ADC MARIO_X_POS       
                    STA MARIO_X_POS       
                    TYA           
                    ADC MARIO_X_POS_HI       
                    STA MARIO_X_POS_HI       
RETURN05            RTS           

LBL06               LDA $02       
                    CLC           
                    ADC $0D       
                    STA $02       
                    LDA #$FF      
                    LDY $73       
                    BNE LBL07      
                    LDY MARIO_STATUS       
                    BNE SMALL_MARIO
LBL07
                    LDA #$08   
SMALL_MARIO
                    CLC                     
                    ADC $80      
                    CMP $02      
                    BCC LBL10      
                    LDA MARIO_Y_SPEED       
                    BPL LBL09    
                    LDA #$10                
                    ;STA MARIO_Y_SPEED    
LBL09
                    RTS       
LBL10
                    LDA $0E       
                    CLC           
                    ADC #$10      
                    STA $00       
                    LDY #$00      
                    LDA SPRITE_X_POS,x     
                    SEC           
                    SBC $1A       
                    CMP $7E       
                    BCC LBL11     
                    LDA $00       
                    EOR #$FF      
                    INC A         
                    STA $00       
                    DEY     
LBL11
                    LDA SPRITE_X_POS,x     
                    CLC           
                    ADC $00       
                    ;STA MARIO_X_POS       
                    TYA           
                    ADC SPRITE_X_POS_HI,x   
                    ;STA MARIO_X_POS_HI       
                    ;STZ MARIO_X_SPEED       
                    RTS                     


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; make standable
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_B8FF
                    LDA $00      
                    STA $0E      
                    LDA $02      
                    STA $0D      
                    LDA SPRITE_X_POS,x    
                    CLC               
					ADC #$06     ;#Jnʒu
                    STA $04      
                    LDA SPRITE_X_POS_HI,x  
                    ADC #$00     
                    STA $0A      
                    LDA $00      
                    ASL A        
                    CLC          
                    ADC #$24     ;#TCY
                    STA $06      

                    LDA SPRITE_Y_POS,x    
                    SEC          
                    SBC $02
                    STA $05      
                    LDA SPRITE_Y_POS_HI,x  
                    SBC #$00     
                    STA $0B      
                    LDA $02      
                    ASL A        
                    CLC          
                    ADC #$20    
                    STA $07      
                    JSL $03B664  
                    JSL $03B72B  
                    RTS 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP             dcb $E2,$E3,$E3,$E4
X_OFFSET            dcb $F0,$00,$10,$20

SUB_GFX 			JSR GET_DRAW_INFO
					LDA $151C,x
					STA $03

                    PHX                     ; push sprite index

                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START          LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
					STA $0301,y             ; /
                    
                    LDA TILEMAP,x
                    STA $0302,y             ; / 
					
					LDA $00                 ; \ tile x position = sprite x location ($00)
                    CLC
                    ADC X_OFFSET,x
                    STA $0300,y             ; /
        			
					PHX
                    LDA #$00
                    ORA $03
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                                              
                    
                    STZ $00       
                    STZ $01       
                    STZ $02       
                    STZ $03       
                    LDY #$00                 
                    LDA #SIZE   
                    STA $0000,y   
                    LSR A         
                    STA $0001,y   
                                        
                    LDA $00       
                    PHA           
                    LDA $02       
                    PHA       
                    
                    LDY #$02                ; \ 02, because we didn't write to 460 yet
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen

                    PLA           
                    STA $02       
                    PLA           
                    STA $00       
                    RTS                           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GET_DRAW_INFO
; This is a helper for the graphics routine.  It sets off screen flags, and sets up
; variables.  It will return with the following:
;
;		Y = index to sprite OAM ($300)
;		$00 = sprite x position relative to screen boarder
;		$01 = sprite y position relative to screen boarder  
;
; It is adapted from the subroutine at $03B760
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T1              dcb $0C,$1C
SPR_T2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA SPRITE_X_POS_HI,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA SPRITE_X_POS_HI,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC SPR_T1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA SPRITE_Y_POS_HI,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA SPR_T2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY SPRITE_OAM,x        ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
