;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Birdo, by mikeyk
;;
;; Description: Birdo walks back and forth spitting eggs at Mario
;;
;; Uses first extra bit: NO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP             dcb $80,$82,$A0,$A2,$84,$86,$A4,$A6,$88,$8A,$A8,$AA,$CC,$CE,$EC,$EE,$C0,$C2,$E0,$E2
                    dcb $80,$82,$A0,$A2,$84,$86,$A4,$A6,$88,$8A,$A8,$AA,$CC,$CE,$EC,$EE,$C0,$C2,$E0,$E2
VERT_DISP           dcb $F0,$F0,$00,$00,$F0,$F0,$00,$00,$F0,$F0,$00,$00,$F0,$F0,$00,$00,$F0,$F0,$00,$00
                    dcb $F0,$F0,$00,$00,$F0,$F0,$00,$00,$F0,$F0,$00,$00,$F0,$F0,$00,$00,$F0,$F0,$00,$00
HOR_DISP            dcb $00,$F0,$00,$F0,$00,$F0,$00,$F0,$00,$F0,$00,$F0,$00,$F0,$00,$F0,$00,$F0,$00,$F0
                    dcb $F0,$00,$F0,$00,$F0,$00,$F0,$00,$F0,$00,$F0,$00,$F0,$00,$F0,$00,$F0,$00,$F0,$00
PROPERTIES          dcb $00,$40             ;xyppccct format

;1558,x     time until spit
;15AC,x     time until jump

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
                    STZ $157C,x
                    TXA
                    RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

X_SPEED             dcb $00,$F8,$00,$08     ;rest at bottom, moving up, rest at top, moving down
TIME_IN_POS         dcb $50,$20,$50,$20     ;moving up, rest at top, moving down, rest at bottom

RETURN              RTS                    
START_HB_CODE       JSR SUB_GFX             ; draw gfx
                    LDA $14C8,x             ; \ if hammer bro status != 8...
					CMP #$02
					BNE MAIN2
					LDA #$01
					STA $14AF
					LDA #$01
					STA $1411
					STA $1412
					LDA #$08
					STA $1DFB
					LDA #$20
					STA $40
					LDA #$84
                    STA $0701
                    LDA #$10
                    STA $0702
					RTS
MAIN2               CMP #$08                ;  }   ... not (killed with spin jump [4] or star[2])
                    BNE RETURN              ; /    ... return
                    LDA $9D                 ; \ if sprites locked...
                    BNE RETURN              ; /    ... return

                    INC $1570,x             ; increment number of frames hammer bro has been on screen
                    
                    LDA $7FFF02
                    CMP #$02
                    BNE FRAME1
                    LDA $1570,x
                    LSR A
                    BRA FRAME2
FRAME1              LDA $1570,x             ; \ calculate which frame to show:
                    LSR A                   ;  | #8t[Ƃɉ摜̐؂ւ
                    LSR A                   ;  | 
                    LSR A                   ;  | 0 1 2 3 4 5 6 7
FRAME2              AND #$07                ;  | 0 1 2 3 4 3 2 1
                    CLC
                    CMP #$04
                    BCC LABEL3
                    STA $18D4
                    LDA #$08
                    SBC $18D4
LABEL3              STA $1602,x             ; / write frame to show
                    LDA $7FFF01
                    BNE MODE2
                    JSR MODE1
                    BRA NO_CONTACT
MODE2               STZ $140D
					JSL $01802A
                    LDA $7FFF02
                    CMP #$01
                    BNE MODE2_2
                    JSR MODE2B
                    BRA DONT_CHANGE_DIR
MODE2_2             CMP #$02
                    BNE MODE2_3
                    JSR MODE2A
                    BRA DONT_CHANGE_DIR
MODE2_3             JSR MODE2C
                    BRA DONT_CHANGE_DIR
DONT_CHANGE_DIR     JSL $01A7DC             ; check for mario/hammer bro contact
NO_CONTACT          
                    RTS                     ; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; hammer routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

NEW_SPEED           dcb $F0,$E0,$D0,$C0

RETURN68            RTS     
SUB_HAMMER_THROW    JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    LDA #$0F
                    STA $009E,y

                    LDA $E4,x               ; \ set x position for new sprite
                    CLC
                    ADC #$F0
                    STA $00E4,y

                    LDA $14E0,x             ;  |
                    ADC #$FF
                    STA $14E0,y             ; /

                    LDA $D8,x               ; \ set y position for new sprite
                    SEC                     ;  | (y position of generator - 1)
                    SBC #$05                ;  |
                    STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
                    SBC #$00                ;  |
                    STA $14D4,y             ; /

                    PHX
                    TYX
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables                   ; /
                    PLX
                    LDA #$30
                    STA $1656,y
                    LDA #$99
                    STA $1686,y
                    LDA #$21
                    STA $1DFC
                    LDA $1570,x
                    AND #$03
                    PHX
                    TAX
                    LDA NEW_SPEED,x
                    STA $00B6,y             ; x speed of new sprite
                    PLX                   
                    RTS                     ; return




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
                    LDA $1602,x             ; \Sprite Image Table #t[́H
                    ASL A                   ;  | $03 = index to frame start (frame to show * 4 tile per frame)
                    ASL A
GFX1                STA $03                 ; /
                    LDA $157C,x             ; \ $02 = sprite direction
                    STA $02                 ; /#1ō
                    BNE LEFT
                    LDA $03
                    CLC
                    ADC #$14
                    STA $03
LEFT                PHX                     ; push sprite index

                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START          PHX                     ; push current tile number
                    TXA                     ; \ X = index to horizontal displacement
                    ORA $03                 ; / get index of tile (index to first tile of frame + current tile number)
FACING_LEFT         TAX                     ; \ 
                    
                    LDA $00                 ; \ tile x position = sprite x location ($00)
                    CLC                     ;  |
                    ADC HOR_DISP,x         ;  |
                    STA $0300,y             ; /
                    
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP,x         ;  |
                    STA $0301,y             ; /
                    
                    LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; / 
        
                    LDX $02                 ; \
                    LDA PROPERTIES,x        ;  | get tile properties using sprite direction
                    LDX $15E9               ;  |
                    ORA $15F6,x             ;  | get palette info
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /




MODE1               STZ $157C,x
                    CLC
                    LDA $94
                    SBC #$23
                    STA $E4,x
                    LDA $95
                    SBC #$00
                    STA $14E0,x
                    CLC
                    LDA $96
                    SBC #$10
                    STA $D8,x
                    LDA $97
                    SBC #$00
                    STA $14D4,x
                    JSL $288760
                    LDA $1463
                    CMP #$0E
                    BNE MODE1_RTN
                    STZ $1411
                    STZ $1412
                    LDA #$05
                    STA $1DFB
                    LDA #$01
                    STA $1426
                    LDA #$01
                    STA $7FFF01  ;#[h2
                    STA $7FFF02
                    LDA #$F0
                    STA $1466
                    LDA #$5A
                    STA $0701
                    LDA #$6B
                    STA $0702
MODE1_RTN           RTS

MODE2A              LDA #$01
                    STA $157C,x
                    STZ $151C,x
                    LDA #$10
                    STA $1656,x
                    LDA #$00
                    TAY
                    SEC
                    LDA $E4,x
                    SBC $0F37  ;#xW̍
                    LSR A
                    LSR A
                    LSR A
                    LSR A
                    STA $B6,x
                    LDA $0F38
                    SEC
                    SBC $D8,x  ;#yW̍
                    LSR A
                    LSR A
                    LSR A
                    LSR A
                    STA $AA,x
                    CMP $B6,x
                    BNE LBLA2
                    LDA #$40
                    STA $AA,x
                    BRA LBLA3
LBLA2               BCS LBLA4
                    JSR LOOP1 ;#x̕
                    INC $151C,x
                    BRA LBLA8
LBLA4               JSR LOOP2 ;#y̕
LBLA8               LDA #$40
                    STA $AA,x
                    LDA $151C,x
                    BEQ LBLA9
                    JSR LOOP1S
                    BRA LBLA3
LBLA9               JSR LOOP2S
LBLA3               LDA #$C0
                    STA $B6,x
                    LDA $AA,x
                    CMP #$80
                    BCC LBLA5
                    LDA #$7E
                    STA $AA,x
LBLA5               LDA $E4,x
                    CMP $0F37
                    BCS LBLA6
                    STZ $B6,x
                    LDA $D8,x
                    CMP $0F38
                    BCS MODE2A_E
                    BRA LBLA7
LBLA6               LDA $D8,x
                    CMP $0F38
                    BCC LBLA7
                    STZ $AA,x
LBLA7               RTS
MODE2A_E            STZ $B6,x
                    STZ $AA,x
                    LDA #$01
                    STA $7FFF02
                    RTS



MODE2B              STZ $157C,x
                    STZ $151C,x
                    ;STZ $1656,x
                    LDA #$00
                    TAY
                    SEC
                    LDA #$F0
                    SBC $E4,x  ;#xW̍
                    LSR A
                    LSR A
                    LSR A
                    LSR A
                    STA $B6,x
                    LDA $D8,x
                    SEC
                    SBC #$10    ;#yW̍
                    LSR A
                    LSR A
                    LSR A
                    LSR A
                    STA $AA,x
                    CMP $B6,x
                    BNE LBL2
                    LDA #$10
                    STA $AA,x
                    BRA LBL3
LBL2                BCS LBL4
                    JSR LOOP1 ;#x̕
                    INC $151C,x
                    BRA LBL8
LBL4                JSR LOOP2 ;#y̕
LBL8                LDA #$10
                    STA $AA,x
                    LDA $151C,x
                    BEQ LBL9
                    JSR LOOP1S
                    BRA LBL3
LBL9                JSR LOOP2S
LBL3                LDA #$10
                    STA $B6,x
                    LDA $AA,x
                    CMP #$80
                    BCC LBL5
                    LDA #$7E
                    STA $AA,x
LBL5                LDA #$FF
                    SEC
                    SBC $AA,x
                    STA $AA,x
                    LDA $E4,x
                    CMP #$F0
                    BCC LBL6
                    STZ $B6,x
                    LDA $D8,x
                    CMP #$10
                    BCC MODE2_E
                    BRA LBL7
LBL6                LDA $D8,x
                    CMP #$10
                    BCS LBL7
                    STZ $AA,x
LBL7                RTS
MODE2_E             STZ $B6,x
                    STZ $AA,x
                    LDA #$03
                    STA $7FFF02
                    LDA #$FF
                    STA $15AC,x
                    LDA #$63
                    STA $1558,x
                    RTS

LOOP1               LDA $AA,x ;y  ;#x̕ꍇ
                    LSR A
                    STA $AA,x
                    LDA $B6,x ;x
                    LSR A
                    STA $B6,x
                    BEQ LOOP1E
                    LDA $AA,x
                    BNE LOOP1A
                    INY
LOOP1A              JSR LOOP1
LOOP1E              RTS

LOOP2               LDA $B6,x ;y ;#y̕ꍇ
                    LSR A
                    STA $B6,x
                    LDA $AA,x ;x
                    LSR A
                    STA $AA,x
                    BEQ LOOP2E
                    LDA $B6,x
                    BNE LOOP2A
                    INY
LOOP2A              JSR LOOP2
LOOP2E              RTS


LOOP1S              TYA          ;#x̕ꍇ
                    BEQ LOOP1SE
                    LDA $AA,x
                    LSR A
                    STA $AA,x
                    DEY
                    JSR LOOP1S
LOOP1SE             RTS

LOOP2S              TYA          ;#y̕ꍇ
                    BEQ LOOP2SE
                    LDA $AA,x
                    ASL A
                    STA $AA,x
                    DEY
                    JSR LOOP2S
LOOP2SE             RTS

MODE2C              STZ $AA,x
                    STZ $B6,x
                    STZ $1656,x
                    LDA #$01
                    STA $157C,x
                    LDA $15AC,x
                    BEQ MODE2C_E
                    LDA $1558,x
                    BNE MODE2CE
                    JSR SUB_HAMMER_THROW ;#𔭎
                    LDA #$63
                    STA $1558,x
MODE2CE             RTS
MODE2C_E            LDA #$02
                    STA $7FFF02
                    STZ $15AC,x
                    STZ $1558,x
                    LDA $94
                    CMP #$C0
                    BCC X_94
                    LDA #$C0
X_94                STA $0F37
                    LDA $96
                    STA $0F38
                    RTS
