;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Light gazer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;      
                    dcb "INIT"
					STZ $1528,x
					LDA #$FF
					STA $15AC,x
					STZ $151C,x
					STZ $C2,x
					STZ $1504,x
					STZ $40
					LDA $E4,x
					CLC
					ADC #$08
					STA $E4,x
					LDA #$01
					STA $157C,x
                    RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                     ; return           
CODE_START          LDA $C2,x
					CMP #$10
					BEQ MAIN_BUL
					;LDA #$06
					;STA $00212C
					;LDA #$11
					;STA $00212D
					LDA $C2,x
					CMP #$01
					BNE NO_GFX
					LDA $1570,x
					CMP #$D0
					BEQ NO_GFX
					JSR SUB_GFX
NO_GFX				LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
					JSR COLOR_CHECK
					LDA $16
					BEQ MAIN2
					LDA $7FE000
					INC A
					STA $7FE000
MAIN2
					LDA $1504,x
					STA $7FC004
                    JSR LAYER2
					LDA $C2,x
					BNE NOT_MODE0
					JSR MODE0
					RTS
NOT_MODE0			CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			JSR MODE2
					RTS
MAIN_BUL			JSR SUB_GFX
					LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN2
					LDA $14E0,x
					BNE BUL_DEL
					LDA $14D4,x
					BEQ BUL_1
					LDA $D8,x
					CMP #$A0
					BCS BUL_DEL
BUL_1				JSL $01A7DC
					LDA $AA,x
					PHA
					JSL $01802A
					PLA
					STA $AA,x
RETURN2				RTS
BUL_DEL				STZ $14C8,x
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X_SPEED				dcb $08,$F8
COLOR_OFFSET2		dcb $06,$06,$06,$0A,$0A,$0A,$0A,$08,$08,$08,$08,$04,$04,$04,$04,$06

MODE0				STZ $AA,x
					LDA #$FF
					STA $1570,x
					LDA $15AC,x
					BEQ MODE0_1
					CMP #$80
					BCS MODE0_R
					STA $03
					LDA #$24
					STA $40
					JSR HDMA1
MODE0_R				RTS
MODE0_1				LDA #$01
					STA $C2,x
					STZ $1570,x
					LDA #$00
					STA $7FF000
					RTS

MODE1				LDA $E4,x
					CMP #$C0
					BCC MODE1_0
					LDA #$01
					STA $157C,x
					BRA MODE1_3
MODE1_0				CMP #$40
					BCS MODE1_3
					STZ $157C,x
					
MODE1_3				LDA $1570,x
					CMP #$D0
					BEQ MODE1_4
					LDA $1504,x
					TAY
					LDA COLOR_OFFSET2,y
					STA $03
					LDA #$80
					STA $15AC,x
					JSR DAMAGE_CHECK
					JSR OFFENCE
					LDA $14
					AND #$03
					BNE MODE1_5
					INC $1570,x
MODE1_5				LDA $157C,x
					TAY
					LDA X_SPEED,y
					STA $B6,x
					LDA $14D4,x
					BEQ MODE1_1
					LDA $D8,x
					CMP #$65
					BCC MODE1_1
					LDA #$D0
					STA $AA,x
MODE1_1				LDA $14
					AND #$01
					BNE MODE1_2
					LDA $AA,x
					INC A
					STA $AA,x
MODE1_2				LDA $AA,x
					PHA
					JSL $01802A
					PLA
					STA $AA,x
					RTS
MODE1_4				STZ $B6,x
					STZ $AA,x
					LDA $15AC,x
					BEQ MODE1_6
					LDA #$80
					SEC
					SBC $15AC,x
					STA $03
					JSR HDMA1
					RTS
MODE1_6				STZ $40
					LDA #$00
					STA $7FF000
					LDA #$FF
					STA $15AC,x
					STZ $C2,x
					LDA $94
					AND #$0F
					ASL A
					ASL A
					ASL A
					CLC
					ADC #$40
					STA $E4,x
					STZ $14E0,x
					LDA $94
					CLC
					ADC $7FE000
					AND #$0F
					STA $1504,x
					RTS

MODE2				STZ $AA,x
					STZ $B6,x
					LDA #$16
					STA $00212C
					LDA #$01
					STA $00212D
					LDA $15AC,x
					BEQ MODE2_3
					CMP #$D0
					BEQ MODE2_1
					CMP #$C8
					BEQ MODE2_2
					CMP #$90
					BEQ MODE2_1
					CMP #$88
					BEQ MODE2_2
					CMP #$50
					BEQ MODE2_1
					CMP #$48
					BEQ MODE2_2
					CMP #$10
					BEQ MODE2_0
					RTS
MODE2_0				LDA #$7F
					STA $7FD000
					STA $7FD001
MODE2_1				LDA #$9C
					STA $7FD201
					LDA #$73
					STA $7FD202
					LDA #$18
					STA $1DFC
					RTS
MODE2_2				LDA #$00
					STA $7FD201
					STA $7FD202
					RTS
MODE2_3				JSR HDMA3
					LDA $7FD000
					CMP #$01
					BEQ MODE2_4
					DEC A
					STA $7FD000
					RTS
MODE2_4				LDA #$00
					STA $7FE203
					LDA $7FD001
					CMP #$01
					BEQ MODE2_5
					DEC A
					STA $7FD001
					RTS
MODE2_5				LDA #$00
					STA $7FE201
					PHP
					SEP #$30
					LDA #$06
					STA $71
					STZ $89
					STZ $88
					PLP
					STZ $14C8,x
					RTS

OFFENCE				LDA $1570,x
					CMP #$40
					BEQ OFFENCE2
					CMP #$80
					BEQ OFFENCE1
					CMP #$C0
					BEQ OFFENCE3
					RTS
OFFENCE1			LDA #$07
					STA $03
					JSR NORMAL_GEN
					LDA #$03
					STA $1DF9
					INC $1570,x
					RTS
OFFENCE2			LDA #$10
					STA $1DFC
					JSR FIRE_GEN
					LDA #$00
					STA $00B6,y
					LDA #$30
					STA $00AA,y
					JSR FIRE_GEN
					LDA #$30
					STA $00B6,y
					LDA #$20
					STA $00AA,y
					JSR FIRE_GEN
					LDA #$D0
					STA $00B6,y
					LDA #$20
					STA $00AA,y
					INC $1570,x
					RTS
OFFENCE3			LDA #$77
					STA $03
					JSR NORMAL_GEN
					INC $1570,x
					RTS

DAMAGE_CHECK        LDA $E4,x
                    STA $7FFE01
                    LDA $14E0,x
                    STA $7FFE02
                    LDA $D8,x
                    STA $7FFE03
                    LDA $14D4,x
                    STA $7FFE04
                    PHX
                    LDX #$09
LOOP1               LDA $9E,x
                    CMP #$07
                    BNE LOOP3
					LDA $14C8,x
					BEQ LOOP3
					CMP #$0A
					BEQ LOOP3
					CMP #$02
					BEQ LOOP3
					LDA $15F6,x
					CMP $03
					BNE LOOP3
                    JSR NEAR_CHECK
                    TYA
                    BEQ LOOP3
					STZ $14C8,x
                    LDA #$28
					STA $1DFC
					PLX
					INC $1528,x
					PHX
LOOP3               DEX
                    BPL LOOP1
                    PLX
					LDA $1528,x
					CMP #$03
					BCS THEEND
                    RTS
THEEND				LDA #$02
					STA $C2,x
					LDA #$1E
					STA $1DFB
					LDA #$FF
					STA $15AC,x
					JSR HDMA2
					RTS
					
NEAR_CHECK          LDY #$00
                    LDA $E4,x
                    SEC
                    SBC $7FFE01
                    STA $0F
                    LDA $14E0,x
                    SBC $7FFE02
                    CMP #$00
                    BEQ RIGHT_CHECK
                    CMP #$FF
                    BNE CHECK_E
                    LDA $0F
                    CMP #$E8
                    BCC CHECK_E
                    BRA VER_CHECK
RIGHT_CHECK         LDA $0F
                    CMP #$18
                    BCS CHECK_E
VER_CHECK           LDA $D8,x
                    SEC
                    SBC $7FFE03
                    STA $0F
                    LDA $14D4,x
                    SBC $7FFE04
                    CMP #$00
                    BEQ UNDER_CHECK
                    CMP #$FF
                    BNE CHECK_E
                    LDA $0F
                    CMP #$F0
                    BCC CHECK_E
                    BRA NEAR
UNDER_CHECK         LDA $0F
                    CMP #$10
                    BCS CHECK_E
NEAR                LDY #$01
CHECK_E             RTS
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ETC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
LAYER2				LDA #$D8
					SEC
					SBC $E4,x
					STA $1466
					LDA #$00
					STA $1467
					LDA #$85
					SEC
					SBC $D8,x
					STA $1468
					LDA #$00
					STA $1469
					LDA $151C,x
					CMP #$03
					BCS LAYER2_2
					RTS
LAYER2_2			LDA #$01
					STA $1467
					RTS

COLOR_OFFSET		dcb $04,$06,$04,$06,$08,$0A,$08,$0A

COLOR_CHECK			PHX
					LDX #$00
COLOR_LOOP			LDA $9E,x
					CMP #$07
					BNE COLOR2
					LDA $14C8,x
					BEQ COLOR2
					CMP #$0A
					BEQ COLOR2
					LDA $15F6,x
					AND #$0F
					LSR A
					TAY
					LDA COLOR_OFFSET,y
					STA $15F6,x
COLOR2				INX
					CPX #$0A
					BCC COLOR_LOOP
					PLX
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


RETURN67            RTS
FIRE_GEN            JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
					TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
                    LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

                    LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
					LDA #$10
					STA $00C2,y
                    RTS                          ; return
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN68            RTS
NORMAL_GEN          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots ful
                    BMI RETURN68            ; / after: Y has index of sprite being generated
					LDA $03
					STA $009E,y
					LDA #$08
					STA $14C8,y
					LDA $E4,x
                    STA $00E4,y
                    LDA $14E0,x
                    STA $14E0,y             ; /
                    LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    PLX
					LDA $009E,y
					CMP #$07
					BNE GEN_F
					LDA #$01
					STA $187B,y
					LDA #$14
					STA $166E,y
					LDA #$C0
					STA $00AA,y
					LDA #$0A
					STA $14C8,y
GEN_RETURN          RTS
GEN_F				LDA #$3B
					STA $1540,y
					STA $154C,y
					LDA #$D0
					STA $00AA,y
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP             dcb $80,$80,$A0,$A0
HORZ_DISP			dcb $F8,$08,$F8,$08
VERT_DISP			dcb $F1,$F1,$01,$01
PROPETIES			dcb $40,$00,$40,$00

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
                    PHX                     ; push sprite index

					LDX #$03
LOOP_START          PHX
					LDA $01
					CLC
					ADC VERT_DISP,x
					STA $0301,y
					LDA $00                 ; 
					CLC
					ADC HORZ_DISP,x
                    STA $0300,y             ; /
					
					LDA TILEMAP,x           ; \ store tile
                    STA $0302,y

                    LDA #$0D
					ORA PROPETIES,x
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					PLX

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
					
HDMA1	LDA $7FFB18
		BNE LBL1
		LDA #$08
		STA $7FFB18
		LDA #$02
		STA $7FFB19
		LDA #$0F
		STA $7FFB1A
		LDA #$00
		STA $7FFB1B
		LDA #$F0
		STA $7FFB1C
		LDA #$7F
		STA $7FFB1D
		RTS

LBL1	PHX
		LDA #$00
		STA $7FEFFF
		LDA $13
		AND #$03
		BNE LBL3
		LDA $7FEFFD
		INC A
		STA $7FEFFD
LBL3	LDA $7FEFFD
		STA $7FEFFE
		REP #$10 ;XY16bit
		LDX.w #$00

LOOP1	LDA #$08
		STA $7FF000,x
		INX
		LDA $7FEFFE
		INC A
		AND #$0F
		STA $7FEFFE
		CMP #$08
		BCC LBL2
		LDA #$10
		SEC
		SBC $7FEFFE
LBL2	STA $02
		LDA $03
		CMP #$20
		BCS LBL2_0
		LDA #$00
		BRA LBL2_3
LBL2_0	CMP #$40
		BCS LBL2_1
		LDA $02
		BRA LBL2_3
LBL2_1	CMP #$60
		BCS LBL2_2
		LDA $02
		ASL A
		BRA LBL2_3
LBL2_2	LDA $02
		ASL A
		CLC
		ADC $02
LBL2_3	STA $7FEFFC
		CLC
		ADC $1466
		STA $7FF000,x
		LDA $1467
		ADC #$00
		STA $7FF001,x
		INX
		INX
		LDA $7FEFFF
		INC A
		STA $7FEFFF
		CMP #$1E
		BNE LOOP1
		LDA #$00
		STA $7FF000,x
		SEP #$10
		PLX
		RTS

					
HDMA2				LDA #$10
					STA $7FFB20
					LDA #$40
					STA $7FFB30
					
					LDA #$00
					STA $7FFB21
					LDA #$02
					STA $7FFB31
					
					LDA #$21
					STA $7FFB22
					LDA #$22
					STA $7FFB32
					
					LDA #$00
					STA $7FFB23
					STA $7FFB33
					LDA #$D1
					STA $7FFB24
					LDA #$D2
					STA $7FFB34
					LDA #$7F
					STA $7FFB25
					STA $7FFB35
					
					LDA #$07
					STA $7FD100
					STA $7FD200
					LDA #$00
					STA $7FD101
					LDA #$00
					STA $7FD201
					LDA #$00
					STA $7FD202
					
					LDA #$00
					STA $7FD102
					STA $7FD203
					RTS



HDMA3				LDA #$02
					STA $00212E
					LDA #$00
					STA $002126
					STA $002127
					LDA #$20
					STA $7FFB28
					LDA #$00
					STA $7FFB29
					LDA #$23
					STA $7FFB2A
					LDA #$00
					STA $7FFB2B
					LDA #$E2
					STA $7FFB2C
					LDA #$7F
					STA $7FFB2D
					
					LDA $7FD000
					STA $7FE200
					LDA #$00
					STA $7FE201
					LDA $7FD001
					STA $7FE202
					LDA #$00
					STA $7FE203
					LDA #$01
					STA $7FE204
					LDA #$30
					STA $7FE205
					LDA #$00
					STA $7FE206
					RTS
