;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Ludwig
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
					EXTRA_BITS = $7FAB10
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"
					LDA #$01
					STA $157C,x
					STZ $1602,x
					LDA #$19
					STA $1686,x
                    RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CODE_START          STZ $149F
					LDA EXTRA_BITS,x
					AND #$04
					BEQ MAIN0
					JSR OPENING
					RTS
MAIN0				LDA $1504,x
					CMP #$01
					BNE MAIN1
					JSR FRAME1
					RTS
MAIN1				CMP #$02
					BNE MAIN2
					JSR FRAME2
					RTS
MAIN2				CMP #$03
					BNE MAIN3
					JSR FRAME3
					RTS
MAIN3				CMP #$04
					BNE MAIN4
					;JSR FRAME4
RETURN				RTS
MAIN4				LDA #$4C
					STA $151C,x
					JSR POS_OFFSET
					JSR BLOCK_MOVE
					JSR SUB_GFX             ; graphics routine
					LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
					JSL $01802A             ; update position based on speed values
					LDA $C2,x
					BNE NOT_MODE0
					JSR MODE0
					RTS
NOT_MODE0			CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$02
					BNE NOT_MODE2
					JSR MODE2
					RTS
NOT_MODE2			CMP #$03
					BNE NOT_MODE3
					JSR MODE3
					RTS
NOT_MODE3			CMP #$04
					BNE NOT_MODE4
					JSR MODE4
					RTS
NOT_MODE4			CMP #$05
					BNE NOT_MODE5
					JSR MODE5
					RTS
NOT_MODE5			JSR MODE6
RETURN22			RTS

MODE0				LDA $7FCD00
					BEQ MODE0_2
					LDA $1588,x
					AND #$04
					BEQ MODE0_R
					LDA #$80
					STA $15AC,x
					LDA #$01
					STA $C2,x
					JSR SUB_GET_DIR
MODE0_R				RTS
MODE0_2				STZ $AA,x
					RTS
					
X_OFFSET1			dcb $10,$F0
X_OFFSET2			dcb $00,$FF
X_SPEED1			dcb $18,$E8
X_SPEED2			dcb $30,$D0
MODE1				JSR DAMAGE_CHECK
					JSR BLOCK_CHECK
					STZ $AA,x
					LDA $15AC,x
					BEQ MODE1_2
					CMP #$60
					BEQ MODE1_G1
					CMP #$48
					BEQ MODE1_1
					CMP #$30
					BEQ MODE1_G2
					CMP #$18
					BEQ MODE1_1
					RTS
MODE1_1				STZ $1602,x
					RTS
MODE1_2				LDA #$02
					STA $C2,x
					LDA #$E0
					STA $15AC,x
					RTS
MODE1_G1			JSR GEN_SPRITE
					PHX
					LDA $157C,x
					TAX
					LDA X_SPEED1,x
					STA $00B6,y
					LDA $00E4,y
					CLC
					ADC X_OFFSET1,x
					STA $00E4,y
					LDA $14E0,y
					ADC X_OFFSET2,x
					STA $14E0,y
					LDA #$17
					STA $1DFC
					LDA #$01
					STA $1504,y
					PLX
					LDA #$01
					STA $1602,x
					RTS
MODE1_G2			JSR GEN_SPRITE
					PHX
					LDA $157C,x
					TAX
					LDA X_SPEED2,x
					STA $00B6,y
					LDA $00E4,y
					CLC
					ADC X_OFFSET1,x
					STA $00E4,y
					LDA $14E0,y
					ADC X_OFFSET2,x
					STA $14E0,y
					LDA #$17
					STA $1DFC
					LDA #$01
					STA $1504,y
					PLX
					LDA #$01
					STA $1602,x
					RTS
					
X_SPEED3			dcb $30,$D0
MODE2				JSR DAMAGE_CHECK2
					JSR BLOCK_CHECK2
					STZ $AA,x
					LDA $15AC,x
					BNE MODE2_0
					LDA #$80
					STA $15AC,x
					LDA #$01
					STA $C2,x
					JSR SUB_GET_DIR
					STZ $1602,x
					RTS
MODE2_3				STZ $B6,x
					RTS
MODE2_0				CMP #$10
					BCC MODE2_3
					INC $1570,x
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					CLC
					ADC #$03
					STA $1602,x
					LDY $157C,x
					LDA X_SPEED3,y
					STA $B6,x
					LDA $E4,x
					CMP #$30
					BCC MODE2_1
					CMP #$C0
					BCS MODE2_2
					RTS
MODE2_1				STZ $157C,x
					RTS
MODE2_2				LDA #$01
					STA $157C,x
					RTS
					
MODE3				JSR BLOCK_CHECK2
					LDA $1558,x
					BNE MODE3_2
					LDA $14D4,x
					BEQ MODE3_R
					LDA $D8,x
					CMP #$80
					BCS MODE3_1
					RTS
MODE3_1				LDA #$40
					STA $1540,x
					LDA #$F0
					STA $1558,x
					STZ $B6,x
					LDA #$28
					STA $1DFC
					INC $1528,x
					LDA $1528,x
					CMP #$04
					BNE MODE3_R
					LDA #$1E
					STA $1DFB
					LDA #$FF
					STA $15AC,x
					LDA #$06
					STA $C2,x
MODE3_R				RTS
MODE3_2				CMP #$B0
					BCS MODE3_R
					INC $1570,x
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					CLC
					ADC #$03
					STA $1602,x
					LDA $1528,x
					CMP #$02
					BEQ MODE3_3
					LDA #$F0
					STA $AA,x
					LDA $D8,x
					CMP #$70
					BCS MODE3_R
					LDA #$02
					STA $C2,x
					LDA #$D0
					STA $15AC,x
					STZ $1558,x
					LDA #$70
					STA $D8,x
					RTS
MODE3_3				LDA #$E0
					STA $AA,x
					LDA $14D4,x
					BNE MODE3_R
					LDA $D8,x
					CMP #$E0
					BCS MODE3_R
					LDA #$04
					STA $C2,x
					LDA #$80
					STA $15AC,x
					STZ $1558,x
					LDA #$E0
					STA $D8,x
					RTS

MODE4_8				LDY $157C,x
					LDA X_SPEED3,y
					STA $B6,x
					LDA $E4,x
					AND #$FC
					CMP #$78
					BNE MODE4_R
					LDA #$78
					STA $E4,x
					STZ $B6,x
					LDA #$F0
					STA $15AC,x
					STZ $1558,x
					STZ $1564,x
					LDA #$05
					STA $C2,x
					LDA #$02
					STA $1602,x
					RTS
MODE4				JSR DAMAGE_CHECK2
					JSR BLOCK_CHECK2
					STZ $AA,x
					INC $1570,x
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					CLC
					ADC #$03
					STA $1602,x
					LDA $1564,x
					BNE MODE4_8
					LDA $1558,x
					BNE MODE4_3
					LDY $157C,x
					LDA X_SPEED3,y
					STA $B6,x
					LDA $E4,x
					CMP #$08
					BCC MODE4_1
					CMP #$E8
					BCS MODE4_2
					RTS
MODE4_1				STZ $157C,x
					LDA $15AC,x
					BNE MODE4_R
					LDA #$F0
					STA $1558,x
					RTS
MODE4_2				LDA #$01
					STA $157C,x
					LDA $15AC,x
					BNE MODE4_R
					LDA #$F0
					STA $1558,x
MODE4_R				RTS
MODE4_3				LDA $157C,x
					BEQ MODE4_6
					LDA $1558,x
					CMP #$D0
					BCS MODE4_4
					CMP #$CF
					BEQ MODE4_5
					LDA $E4,x
					CMP #$10
					BCC MODE4_3_2
					LDA $7FFEAA
					STA $AA,x
					LDA $7FFEAA
					BEQ MODE4_R
					DEC A
					DEC A
					STA $7FFEAA
					LDA $B6,x
					CMP #$B0
					BCC MODE4_R
					DEC $B6,x
					DEC $B6,x
					RTS
MODE4_3_2			STZ $B6,x
					LDA #$D0
					STA $AA,x
					LDA $14D4,x
					BNE MODE4_R
					LDA $D8,x
					CMP #$E0
					BCS MODE4_R
					LDA #$E0
					STA $D8,x
					STZ $AA,x
					LDA #$F0
					STA $1564,x
					LDA $157C,x
					EOR #$01
					STA $157C,x
					RTS
MODE4_4				STZ $B6,x
					RTS
MODE4_5				LDA #$2B
					STA $1DFC
					LDA #$60
					STA $7FFEAA
					STA $AA,x
					LDA #$FE
					STA $B6,x
					RTS
MODE4_6				LDA $1558,x
					CMP #$D0
					BCS MODE4_4
					CMP #$CF
					BEQ MODE4_7
					LDA $E4,x
					CMP #$E0
					BCS MODE4_3_2
					LDA $7FFEAA
					STA $AA,x
					LDA $7FFEAA
					BEQ MODE4_R2
					DEC A
					DEC A
					STA $7FFEAA
					LDA $B6,x
					CMP #$50
					BCS MODE4_R2
					INC $B6,x
					INC $B6,x
MODE4_R2			RTS
MODE4_7				LDA #$2B
					STA $1DFC
					LDA #$60
					STA $7FFEAA
					STA $AA,x
					LDA #$02
					STA $B6,x
					RTS

MODE5_3				STZ $B6,x
					LDA $1588,x
					AND #$04
					BEQ MODE5_R4
					STZ $1558,x
					LDA #$80
					STA $15AC,x
					LDA #$01
					STA $C2,x
					JSR SUB_GET_DIR
MODE5_R4			RTS
MODE5				JSR DAMAGE_CHECK
					LDA $1528,x
					CMP #$03
					BEQ MODE5_3
					JSR BLOCK_CHECK4
					STZ $AA,x
					LDA $15AC,x
					CMP #$E0
					BEQ MODE5_G1
					CMP #$C0
					BEQ MODE5_G2
					CMP #$A0
					BEQ MODE5_G3
					CMP #$80
					BEQ MODE5_G4
					CMP #$60
					BEQ MODE5_G5
					LDA $1558,x
					CMP #$C0
					BEQ MODE5_G21
					CMP #$A0
					BEQ MODE5_G22
					CMP #$80
					BEQ MODE5_G23
					CMP #$60
					BEQ MODE5_G24
					CMP #$40
					BEQ MODE5_G25
					CMP #$01
					BEQ MODE5_2
					RTS
MODE5_G1			LDA #$30
					STA $7FFCE4
					BRA MODE5_G
MODE5_G2			LDA #$50
					STA $7FFCE4
					BRA MODE5_G
MODE5_G3			LDA #$78
					STA $7FFCE4
					BRA MODE5_G
MODE5_G4			LDA #$A0
					STA $7FFCE4
					BRA MODE5_G
MODE5_G5			LDA #$C0
					STA $7FFCE4
					LDA #$FF
					STA $1558,x
					BRA MODE5_G
MODE5_G21			LDA #$30
					STA $7FFCE4
					BRA MODE5_G20
MODE5_G22			LDA #$50
					STA $7FFCE4
					BRA MODE5_G20
MODE5_G23			LDA #$78
					STA $7FFCE4
					BRA MODE5_G20
MODE5_G24			LDA #$A0
					STA $7FFCE4
					BRA MODE5_G20
MODE5_G25			LDA #$C0
					STA $7FFCE4
					BRA MODE5_G20
MODE5_2				STZ $1558,x
					LDA #$D0
					STA $15AC,x
					LDA #$04
					STA $C2,x
					RTS
MODE5_G				JSR GEN_SPRITE
					LDA #$A0
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA $7FFCE4
					STA $00E4,y
					LDA #$02
					STA $1504,y
					JSR BLOCK_FF
					LDA #$2B
					STA $1DFC
					RTS
MODE5_G20			JSR GEN_SPRITE
					LDA #$A0
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					LDA $7FFCE4
					STA $00E4,y
					LDA #$03
					STA $1504,y
					LDA #$17
					STA $1DFC
					LDA #$00
					STA $1528,y
					RTS
					
MODE6				STZ $B6,x
					INC $1570,x
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					CLC
					ADC #$03
					STA $1602,x
					LDA $15AC,x
					CMP #$C0
					BCS MODE6_R
					CMP #$BF
					BEQ MODE6_2
					LDA #$D0
					STA $AA,x
					LDA $14D4,x
					BNE MODE6_R
					LDA $D8,x
					CMP #$A0
					BCS MODE6_R
					LDA #$0B
                    STA $1DFB
					LDA #$FF
                    STA $13C6
                    STA $1493
					LDA #$02
					STA $0F31
					STZ $14C8,x
MODE6_R				RTS
MODE6_2				LDA #$2B
					STA $1DFC
					RTS

BLOCK_FF			LDY #$00
BLOCK_FF_1			LDA $14C8,y
					BEQ BLOCK_FF_2
					LDA $009E,y
					CMP #$53
					BNE BLOCK_FF_2
					LDA #$FF
					STA $1540,y
BLOCK_FF_2			INY
					CPY #$0A
					BNE BLOCK_FF_1
					RTS

DAMAGE_CHECK3		JSL $01A7DC
					BCC DAMAGE_R3
					LDA $1497
					BNE DAMAGE_R3
					JSL $00F5B7
DAMAGE_R3			RTS

DAMAGE_CHECK		JSL $01A7DC
					BCC DAMAGE_R
					LDA $7D
					CMP #$80
					BCS ENE_WIN
					CMP #$10
					BCC ENE_WIN
					LDA #$B0
					STA $7D
					JSL $01AB99             ; display contact graphic
					LDA #$02
                    STA $1DF9
DAMAGE_R			RTS
ENE_WIN				LDA $1497
					BNE DAMAGE_R
					JSL $00F5B7
					RTS
					
MARIO_SPEED			dcb $40,$C0
DAMAGE_CHECK2		JSL $01A7DC
					BCC DAMAGE_R2
					LDA $7D
					CMP #$80
					BCS ENE_WIN2
					CMP #$10
					BCC ENE_WIN2
					LDA #$B0
					STA $7D
					JSL $01AB99             ; display contact graphic
					LDA #$02
                    STA $1DF9
DAMAGE_R2			RTS
ENE_WIN2			LDY $157C,x
					LDA MARIO_SPEED,y
					STA $7B
					LDA #$08
					STA $1DFC
					RTS

FRAME1				JSR SUB_GFXF
					LDA $9D
					BNE FRAME1_R
					JSR DAMAGE_CHECK3
					INC $1570,x
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$01
					STA $1602,x
					STZ $AA,x
					JSL $01802A
					LDA $14E0,x
					CMP #$03
					BEQ FRAME1_R
					STZ $14C8,x
FRAME1_R			RTS

FRAME2				JSR SUB_GFXF3
					LDA $9D
					BNE FRAME2_R
					JSR DAMAGE_CHECK3
					INC $1570,x
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					STA $1602,x
					STZ $B6,x
					JSL $01802A
					LDA $14D4,x
					BEQ FRAME2_R
					LDA $D8,x
					CMP #$A0
					BCC FRAME2_R
					STZ $14C8,x
FRAME2_R			RTS
					
FRAME3				JSR SUB_GFXF2
					LDA $9D
					BNE FRAME3_R
					JSR DAMAGE_CHECK3
					INC $1570,x
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$01
					STA $1602,x
					STZ $B6,x
					LDA #$C0
					STA $AA,x
					JSL $01802A
					LDA $14D4,x
					BNE FRAME3_2
					LDA $D8,x
					CMP #$A0
					BCS FRAME3_2
					STZ $14C8,x
					LDA $1528,x
					BNE FRAME3_4
FRAME3_R			RTS
FRAME3_2			LDA $1528,x
					BNE FRAME3_3
					JSR BLOCK_CHECK3
					RTS
FRAME3_3			LDY $151C,x
					LDA $009E,y
					CMP #$53
					BNE FRAME3_R
					LDA $14C8,y
					CMP #$08
					BCC FRAME3_R
					LDA #$00
					STA $00B6,y
					LDA $D8,x
					SEC
					SBC #$10
					STA $00D8,y
					LDA $14D4,x
					SBC #$00
					STA $14D4,y
					RTS
FRAME3_4			LDY $151C,x
					LDA $009E,y
					CMP #$53
					BNE FRAME3_R
					LDA $14C8,y
					CMP #$08
					BCC FRAME3_R
					LDA #$00
					STA $14C8,y
					RTS

					
POS_OFFSET			LDA $E4,x
					CMP #$E8
					BCS POS_OFFSET_1
					CMP #$08
					BCC POS_OFFSET_2
					RTS
POS_OFFSET_1		LDA #$E8
					STA $E4,x
					RTS
POS_OFFSET_2		LDA #$08
					STA $E4,x
					RTS

BLOCK_MOVE			LDY #$00
BLOCK_MOVE_1		LDA $14C8,y
					CMP #$08
					BCC BLOCK_MOVE_2
					LDA $009E,y
					CMP #$53
					BNE BLOCK_MOVE_2
					LDA $00AA,y
					CMP #$80
					BCC BLOCK_MOVE_2
					LDA #$00
					STA $00AA,y
BLOCK_MOVE_2		INY
					CPY #$0A
					BNE BLOCK_MOVE_1
					RTS

BLOCK_CHECK			
			        LDA $E4,x
                    STA $7FFE01
                    LDA $14E0,x
                    STA $7FFE02
                    LDA $D8,x
                    STA $7FFE03
                    LDA $14D4,x
                    STA $7FFE04
                    PHX
                    LDX #$09
BLOOP1               LDA $14C8,x
					CMP #$0A
					BCC BLOOP3
BLOOP2				LDA $9E,x
					CMP #$53
					BNE BLOOP3
BOUT                JSR NEAR_CHECK
                    TYA
                    BEQ BLOOP3
					STZ $14C8,x
					JSR CLASH
					LDA $E4,x
					SEC
					SBC $7FFE01
					LDA $14E0,x
					SBC $7FFE02
					BPL BOUT_2
					PLX
					LDA #$30
					STA $B6,x
					LDA #$03
					STA $C2,x
					PHX
					BRA BLOOP3
BOUT_2				PLX
					LDA #$D0
					STA $B6,x
					LDA #$03
					STA $C2,x
					PHX
BLOOP3              DEX
                    BPL BLOOP1
                    PLX
                    RTS
					
BLOCK_CHECK2        LDA $E4,x
                    STA $7FFE01
                    LDA $14E0,x
                    STA $7FFE02
                    LDA $D8,x
                    STA $7FFE03
                    LDA $14D4,x
                    STA $7FFE04
                    PHX
                    LDX #$09
BLOOP21             LDA $14C8,x
					CMP #$0A
					BCC BLOOP23
BLOOP22				LDA $9E,x
					CMP #$53
					BNE BLOOP23
BOUT2               JSR NEAR_CHECK
                    TYA
                    BEQ BLOOP23
					STZ $14C8,x
					JSR CLASH
BLOOP23             DEX
                    BPL BLOOP21
                    PLX
                    RTS
					
BLOCK_CHECK3        LDA $E4,x
                    STA $7FFE01
                    LDA $14E0,x
                    STA $7FFE02
                    LDA $D8,x
                    STA $7FFE03
                    LDA $14D4,x
                    STA $7FFE04
                    PHX
                    LDX #$09
BLOOP31             LDA $14C8,x
					CMP #$08
					BCC BLOOP33
BLOOP32				LDA $9E,x
					CMP #$53
					BNE BLOOP33
BOUT3               JSR NEAR_CHECK
                    TYA
                    BEQ BLOOP33
					TXY
					PLX
					LDA #$01
					STA $1528,x
					TYA
					STA $151C,x
					PHX
BLOOP33             DEX
                    BPL BLOOP31
                    PLX
                    RTS
					
BLOCK_CHECK4        LDA $E4,x
                    STA $7FFE01
                    LDA $14E0,x
                    STA $7FFE02
                    LDA $D8,x
                    STA $7FFE03
                    LDA $14D4,x
                    STA $7FFE04
                    PHX
                    LDX #$09
BLOOP41             LDA $14C8,x
					CMP #$08
					BCC BLOOP43
BLOOP42				LDA $9E,x
					CMP #$53
					BNE BLOOP43
BOUT4               JSR NEAR_CHECK
                    TYA
                    BEQ BLOOP43
					STZ $14C8,x
					JSR CLASH
					PLX
					INC $1528,x
					PHX
BLOOP43             DEX
                    BPL BLOOP41
                    PLX
                    RTS
					
CLASH				LDA $E4,x
					STA $9A
					LDA $14E0,x
					STA $9B
					LDA $D8,x
					STA $98
					LDA $14D4,x
					STA $99
					STZ $1933
					LDA #$0F
					TRB $9A
					TRB $98
					
					PHB
					LDA #$02
					PHA
					PLB
					JSL $028663
					PHY
					LDY #$03
R3_LOOP				LDA $16CD,y 
					BEQ ROUTINE3_2
					DEY
					BPL R3_LOOP
					INY
ROUTINE3_2			LDA $9A
					STA $16D1,y 
					LDA $9B
					STA $16D5,y
					LDA $98
					STA $16D9,y
					LDA $99
					STA $16DD,y
					
ROUTINE3_3			LDA #$01
					STA $16CD,y 
					LDA #$06
					STA $18F8,y
					PLY
					PLB
					RTS
					
NEAR_CHECK          LDY #$00
                    LDA $E4,x
                    SEC
                    SBC $7FFE01
                    STA $0F
                    LDA $14E0,x
                    SBC $7FFE02
                    CMP #$00
                    BEQ RIGHT_CHECK
                    CMP #$FF
                    BNE CHECK_E
                    LDA $0F
                    CMP #$F0
                    BCC CHECK_E
                    BRA VER_CHECK
RIGHT_CHECK         LDA $0F
                    CMP #$10
                    BCS CHECK_E
VER_CHECK           LDA $D8,x
                    SEC
                    SBC $7FFE03
                    STA $0F
                    LDA $14D4,x
                    SBC $7FFE04
                    CMP #$00
                    BEQ UNDER_CHECK
                    CMP #$FF
                    BNE CHECK_E
                    LDA $0F
                    CMP #$F8
                    BCC CHECK_E
                    BRA NEAR
UNDER_CHECK         LDA $0F
                    CMP #$08
                    BCS CHECK_E
NEAR                LDY #$01
CHECK_E             RTS



OPENING				LDA $1463
					CMP #$03
					BEQ ROCK
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					STA $D8,x
					LDA $97
					STA $14D4,x
					STZ $1401
					LDA $13DF
					STA $1504,x
					LDA $13E0
					STA $151C,x
					LDA $76
					STA $157C,x
					STZ $1570,x
OPENING_R			RTS
ROCK				STZ $1411
					LDA $157C,x
					STA $76
					LDA $1504,x
					STA $13DF
					LDA $151C,x
					STA $13E0
					LDA #$02
					STA $18BD
					STZ $7B
					INC $1570,x
					LDA $1570,x
					CMP #$10
					BEQ ROCK1
					CMP #$28
					BEQ ROCK2
					CMP #$40
					BEQ ROCK3
					CMP #$58
					BEQ ROCK4
					CMP #$70
					BEQ ROCK5
					CMP #$88
					BEQ ROCK6
					CMP #$90
					BEQ ROCK8
					RTS
ROCK8				LDA #$05
					STA $1DFB
					LDA #$01
					STA $7FCD00
					STZ $14C8,x
					RTS
ROCK1				REP #$30
					LDA #$0300
					STA $9A
					LDA #$0180
					STA $98
					BRA ROCK7
ROCK2				REP #$30
					LDA #$0310
					STA $9A
					LDA #$0180
					STA $98
					BRA ROCK7
ROCK3				REP #$30
					LDA #$0320
					STA $9A
					LDA #$0180
					STA $98
					BRA ROCK7
ROCK4				REP #$30
					LDA #$03D0
					STA $9A
					LDA #$0180
					STA $98
					BRA ROCK7
ROCK5				REP #$30
					LDA #$03E0
					STA $9A
					LDA #$0180
					STA $98
					BRA ROCK7
ROCK6				REP #$30
					LDA #$03F0
					STA $9A
					LDA #$0180
					STA $98
ROCK7				LDA.W #$0025
                    STA $03                 ;  |
                    JSL $2E8DF0
					SEP #$30
					LDA #$09
					STA $1DFC
					JSR SUB_SMOKE2
					RTS
SUB_SMOKE2          LDY #$03                ; \ find a free slot to display effect
FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
                    RTS                     ; / return if no slots open
FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    LDA $98
                    STA $17C4,y             ; /
                    LDA #$1B                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $9A                 ; \ load generator x position
                    STA $17C8,y             ; /
                    RTS           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP             dcb $C4,$C6,$E4,$E6,$C0,$C2,$E0,$E2
                    dcb $80,$82,$A0,$A2,$EA,$EA,$8C,$8E
                    dcb $EA,$EA,$AC,$AE,$EA,$EA,$CC,$CE
					dcb $EA,$EA,$EC,$EE
HORIZ_DISP          dcb $08,$F8,$08,$F8,$F8,$08,$F8,$08
VERT_DISP           dcb $F0,$F0,$00,$00
PROPERTIES          dcb $4B,$0B

SUB_GFX             JSR GET_DRAW_INFO
					LDA $1540,x
					AND #$01
					BEQ GFX2
					RTS
GFX2                PHX                   
					LDA $1602,x
					ASL A
					ASL A
					STA $02
					LDA $157C,x
					ASL A
					ASL A
					STA $03
					PHY
					LDY $157C,x
					LDA PROPERTIES,y
					STA $0F
					PLY
                    
                    LDX #$03                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START          
					PHX
					TXA
					CLC
					ADC $03
					TAX
					
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP,x        ; |
                    STA $0300,y             ; /
                    PLX
					
                    LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP,x         ; |
                    STA $0301,y             ; /
					
					LDA $0F
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties


					PHX
					TXA
					CLC
					ADC $02
					TAX
                    LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /
					PLX

                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
					
TILEMAPF             dcb $84,$86,$A4,$A6
HORIZ_DISPF          dcb $00,$F0,$00,$10
PROPERTIESF          dcb $45,$05

SUB_GFXF            JSR GET_DRAW_INFO
                    PHX                   
					LDA $1602,x
					ASL A
					STA $02
					LDA $157C,x
					ASL A
					STA $03
					PHY
					LDY $157C,x
					LDA PROPERTIESF,y
					STA $0F
					PLY
                    
                    LDX #$01
LOOP_STARTF          
					PHX
					TXA
					CLC
					ADC $03
					TAX
					
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISPF,x        ; |
                    STA $0300,y             ; /
                    PLX
					
                    LDA $01                 ; |
                    STA $0301,y             ; /
					
					LDA $0F
                    STA $0303,y             ; store tile properties


					PHX
					TXA
					CLC
					ADC $02
					TAX
                    LDA TILEMAPF,x           ; \ store tile
                    STA $0302,y             ; /
					PLX

                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_STARTF

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$01
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
					
TILEMAPF2            dcb $88,$A8,$8A,$AA
VERT_DISPF2          dcb $00,$10

SUB_GFXF2             JSR GET_DRAW_INFO
                    PHX                   
					LDA $1602,x
					ASL A
					STA $02
                    
                    LDX #$01
LOOP_STARTF2          
					LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    STA $0300,y             ; /
					
					LDA #$05
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
                    
					
                    LDA $01                 ; |
					CLC
					ADC VERT_DISPF2,x
                    STA $0301,y             ; /


					PHX
					TXA
					CLC
					ADC $02
					TAX
                    LDA TILEMAPF2,x           ; \ store tile
                    STA $0302,y             ; /
					PLX

                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_STARTF2

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$01
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
					
TILEMAPF3            dcb $C8,$CA,$C8,$CA
PROPETIESF3			dcb $05,$05,$C5,$C5

SUB_GFXF3           JSR GET_DRAW_INFO
					LDA $1602,x
					STA $03
                    
					PHX
					LDX $03
					
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    STA $0300,y             ; /
                    
                    LDA $01                 ; |
                    STA $0301,y             ; /
					
					LDA PROPETIESF3,x
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties


					LDA TILEMAPF3,x
                    STA $0302,y             ; /

					PLX
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$00                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN67            RTS
GEN_SPRITE          JSL $02A9DE             ; \ ge slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
                    LDA $E4,x               ;\ set x position for new sprite
                    STA $00E4,y

                    LDA $14E0,x             ;  |
                    STA $14E0,y             ; /

                    LDA $D8,x               ;\ set y position for new sprite
					SEC
					SBC #$08
                    STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
					SBC #$00
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
					LDA $157C,x
					STA $157C,y
                    RTS                          ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN68            RTS
GEN_KEY             JSL $02A9DE             ; \ g
                    BMI RETURN68            ; / after: Y has index of sprite being generated
                    LDA #$09                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    
					LDA #$80
                    STA $009E,y
                    
                    LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

                    LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    PLX
                    RTS           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817                ; Y = 1 if contact

SUB_GET_DIR         LDY #$00                ;
                    LDA $94                 ;
                    SEC                     ;
                    SBC $E4,x               ;
                    LDA $95                 ;
                    SBC $14E0,x             ;
                    BPL LABEL16             ;
                    INY                     ;
LABEL16             TYA
					STA $157C,x
					RTS                     ;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; generate sprite
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



                   
