;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Majinki
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA $E4,x
					EOR #$08
					STA $E4,x
					STZ $1602,x
					LDA #$80
					STA $15AC,x
					STZ $C2,x
					LDA #$01
					STA $7FFFDF
					LDA #$16
					STA $7FFFE0
					LDA #$0A
					STA $7FFFE1
					LDA #$13
					STA $7FFFE2
					LDA #$12
					STA $7FFFE3
					LDA #$17
					STA $7FFFE4
					LDA #$14
					STA $7FFFE5
					LDA #$12
					STA $7FFFE6
					LDA #$00
					STA $7FCCCC
                    RTL
                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                    
START_HB_CODE       LDA $1528,x
					CMP #$05
					BEQ GFX
					CMP #$06
					BEQ GFX
					CMP #$07
					BEQ MAIN0
					JSR DAMAGE_CHECK
					JSR LIFE_GAGE
					BRA MAIN0
GFX					JSR SUB_GFX
MAIN0				LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN 
					LDA $16
					ORA $18
					BEQ MAIN1
					INC $1570,x
MAIN1				LDA $1528,x
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$01
					BNE NOT_MODE2
					JSR MODE2
					RTS
NOT_MODE2			CMP #$02
					BNE NOT_MODE3
					JSR MODE3
					RTS
NOT_MODE3			CMP #$03
					BNE NOT_MODE4
					JSR MODE4
					RTS
NOT_MODE4			CMP #$04
					BNE NOT_MODE5
					JSR MODE5
					RTS
NOT_MODE5			CMP #$05
					BNE NOT_MODE6
					JSR MODE6
					RTS
NOT_MODE6			CMP #$06
					BNE NOT_MODE7
					JSR MODE7
					RTS
NOT_MODE7			JSR MODE8
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ETC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MODE1_E				RTS
MODE1				LDA $15AC,x
					BNE MODE1_E
					LDA $7FCCCC
					STA $151C,x
					INC A
					STA $7FCCCC
					CMP #$03
					BNE LBL1001
					LDA #$00
					STA $7FCCCC
LBL1001				LDA #$01
					STA $1528,x
					LDA #$80
					STA $15AC,x
					RTS
					
MODE2				LDA $15AC,x
					CMP #$03
					BCC MODE2_R
					LDA $151C,x
					BNE MODE2_1
					LDA #$00
					STA $1602,x
					LDA #$00
					STA $14F8,x
					JSR HDMA1
					RTS
MODE2_1				CMP #$01
					BNE MODE2_2
					LDA #$08
					STA $1602,x
					LDA #$00
					STA $14F8,x
					JSR HDMA1
					RTS
MODE2_2				LDA #$10
					STA $1602,x
					LDA #$00
					STA $14F8,x
					JSR HDMA1
					RTS
MODE2_R				CMP #$02
					BCC MODE2_R2
					JSR HDMA_RESET
					RTS
MODE2_R2			CMP #$00
					BEQ MODE2_R3
					JSR HDMA_RESET2
					RTS
MODE2_R3			JSR HDMA_RESET3
					LDA $151C,x
					BNE CHANGE2
					LDA #$02
					STA $1528,x
					LDA #$80
					STA $15AC,x
					RTS
CHANGE2				CMP #$01
					BNE CHANGE3
					LDA #$00
					STA $7FFD02
					STZ $1602,x
					LDA #$03
					STA $1528,x
					STZ $15AC,x
					RTS
CHANGE3				LDA #$04
					STA $1528,x
					LDA #$FF
					STA $15AC,x
					RTS
					
MODE3				LDA $15AC,x
					BEQ MODE3_E
					LDA #$D0
					STA $1468
					LDA $13
					AND #$3F
					BNE MODE3_2
					LDA #$17
					STA $1DFC
MODE3_2				STZ $7B
					LDA #$06
					STA $00212C
					LDA #$11
					STA $00212D
					LDA #$00
					SEC
					SBC $94
					CLC
					ADC #$08
					STA $1466
					LDA #$70
					STA $96
					LDA #$01
					STA $97
					RTS
MODE3_E				STZ $1466
					LDA #$C0
					STA $1468
					LDA #$00
					STA $1528,x
					LDA #$80
					STA $15AC,x
					LDA #$15
					STA $00212C
					LDA #$02
					STA $00212D
					RTS

MODE4				LDA $15AC,x
					BNE MODE4_R
					LDA $7FFD02
					CMP #$04
					BNE MODE4_0
					LDA #$04
					STA $15AC,x
					RTS
MODE4_0				LDA $1602,x
					CLC
					ADC #$02
					STA $1602,x
					LDA $7FFD02
					ADC #$00
					STA $7FFD02
					LDA $1602,x
					CMP #$80
					BCC MODE4_1
					LDA #$00
					SEC
					SBC $1602,x
MODE4_1				STA $7FFD01
					JSR HDMA_LASER
					LDA #$06
					STA $00212C
					LDA #$11
					STA $00212D
					LDA #$FF
					STA $1466
					LDA #$FF
					STA $14AE
					JSR CHECK_DAMAGE
					RTS
MODE4_R				CMP #$03
					BCC MODE4_R2
					STZ $1466
					JSR HDMA_RESETR
					RTS
MODE4_R2			CMP #$02
					BNE MODE4_R3
					JSR HDMA_RESETR2
					RTS
MODE4_R3			STA $15AC,x
					STZ $1528,x
					STZ $14AE
					LDA #$15
					STA $00212C
					LDA #$02
					STA $00212D
					RTS
					
MODE5				LDA $15AC,x
					BEQ MODE5_R
					CMP #$E0
					BNE MODE5_E
					LDA #$78
					STA $1602,x
					LDA #$F0
					STA $14F8,x
					JSR FIRE_GEN
					LDA #$10
					STA $1DF9
					LDA #$05
					STA $1528,y
					LDA #$00
					STA $151C,y
MODE5_E				RTS
MODE5_R				STZ $1602,x
					STZ $14F8,x
					LDA #$80
					STA $15AC,x
					STZ $1528,x
					RTS

POS					dcb $00,$30,$60,$90,$C0,$F0
MODE6				JSL $01A7DC
					JSL $01802A
					LDA $D8,x
					CMP #$90
					BCC MODE6_1
					LDA #$FF
					STA $15AC,x
					LDA #$E0
					STA $AA,x
					STZ $B6,x
MODE6_E				RTS
MODE6_1				STZ $AA,x
					LDA $15AC,x
					CMP #$90
					BEQ MODE6_L
					AND #$0F
					BNE MODE6_E
					PHX
					LDA $151C,x
					TAX
					LDA POS,x
					PLX
					STA $1602,x
					LDA #$90
					STA $14F8,x
					JSR FIRE_GEN
					LDA #$06
					STA $1528,y
					INC $151C,x
					RTS
MODE6_L				STZ $14C8,x
					RTS
					
MODE7				JSL $01A7DC
					JSL $01802A
					LDA #$30
					STA $AA,x
					STZ $B6,x
					LDA $14D4,x
					BEQ MODE7_E
					LDA $D8,x
					CMP #$50
					BCC MODE7_E
					STZ $14C8,x
MODE7_E				RTS

MODE8				LDA $15AC,x
					CMP #$FE
					BCC MODE8_1
					STZ $1466
					LDA #$C0
					STA $1468
					LDA #$15
					STA $00212C
					LDA #$02
					STA $00212D
					JSR HDMA_RESETR
					RTS
MODE8_1				CMP #$FD
					BNE MODE8_2
					JSR HDMA_RESETR
					RTS
MODE8_2				CMP #$FC
					BNE MODE8_3
					LDA #$1E
					STA $1DFB
					LDA #$2B
					STA $1DFC
					LDA #$18
					STA $1602,x
					LDA #$01
					STA $14F8,x
					JSR HDMA1
					RTS
MODE8_3				LDA #$FF
					STA $14AD
					RTS

DAMAGE_E			RTS
CHECK_DAMAGE		LDA $97
					BEQ DAMAGE_E
					LDA $1497               ; \ if mario is invincible...
                    BNE DAMAGE_E
					LDA $96
					CMP #$31
					BCS DAMAGE_E
					LDA $96
					CLC
					ADC #$0E
					ASL A
					PHX
					TAX
					LDA $7FE403,x
					STA $0F
					PLX
					LDA $94
					CMP $0F
					BCS CHECK2
					LDA $0F
					SEC
					SBC $94
					CMP #$08
					BCS DAMAGE_E
					JSL $00F5B7
					RTS
CHECK2				LDA $94
					SEC
					SBC $0F
					CMP #$08
					BCS DAMAGE_E
					JSL $00F5B7
					RTS
					
					
GAGE_E				RTS
LIFE_GAGE			LDA #$FD
					STA $7FFFE7
					STA $7FFFE8
					STA $7FFFE9
					STA $7FFFEA
					LDA #$FC
					STA $7FFFEB
					STA $7FFFEC
					STA $7FFFED
					STA $7FFFEE
					STA $7FFFEF
					LDA $C2,x
					CMP #$01
					BCS GAGE_2
					RTS
GAGE_2				LDA #$FC
					STA $7FFFE7
					LDA $C2,x
					CMP #$02
					BCS GAGE_3
					RTS
GAGE_3				LDA #$FC
					STA $7FFFE8
					LDA $C2,x
					CMP #$03
					BCS GAGE_4
					RTS
GAGE_4				LDA #$FC
					STA $7FFFE9
					LDA $C2,x
					CMP #$04
					BCS GAGE_5
					RTS
GAGE_5				LDA #$FC
					STA $7FFFEA
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; HDMA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BLUE				dcb $83,$8B,$8F,$95,$9F,$95,$8F,$8B,$23,$2B,$2F,$35,$3F,$35,$2F,$2B
					dcb $43,$4B,$4F,$55,$5F,$55,$4F,$4B,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0
CG_SUB				dcb $41,$81
HDMA1				LDA #$20
					STA $7FFB28
					LDA #$40
					STA $7FFB30
					
					LDA #$00
					STA $7FFB29
					LDA #$00
					STA $7FFB31
					
					LDA #$31
					STA $7FFB2A
					LDA #$32
					STA $7FFB32
					
					LDA #$00
					STA $7FFB2B
					STA $7FFB33
					LDA #$E1
					STA $7FFB2C
					LDA #$E2
					STA $7FFB34
					LDA #$7F
					STA $7FFB2D
					STA $7FFB35
					
					LDA #$26
					STA $7FE100
					STA $7FE200
					LDA #$00
					STA $7FE101
					LDA #$E0
					STA $7FE201
					LDA #$68
					STA $7FE102
					STA $7FE202
					PHX
					LDA $14F8,x
					TAX
					LDA CG_SUB,x
					PLX
					STA $7FE103
					PHX
					LDA $13
					LSR A
					LSR A
					;LSR A
					AND #$07
					CLC
					ADC $1602,x
					TAX
					LDA BLUE,x
					STA $7FE203
					TXA 
					AND #$07
					CMP #$02
					BNE HDMA1_2
					LDA #$01
					STA $1DFC
HDMA1_2				
					PLX
					LDA #$10
					STA $7FE104
					STA $7FE204
					LDA #$00
					STA $7FE105
					STA $7FE205
					STA $7FE106
					STA $7FE206
					RTS

					
HDMA_RESET			LDA #$00
					STA $7FE103
					LDA #$E0
					STA $7FE203
					RTS
HDMA_RESET2			LDA #$30
					STA $7FFB2A
					LDA #$02
					STA $7FE101
					STA $7FE103
					STA $7FE105
					RTS
HDMA_RESET3			LDA #$00
					STA $7FFB28
					STA $7FFB30
					RTS

HDMA_RESETR			LDA #$30
					STA $7FE100
					STA $7FE200
					STA $7FE400
					STA $7FE500
					LDA #$00
					STA $7FE101
					STA $7FE202
					STA $7FE401
					STA $7FE501
					STA $7FE102
					STA $7FE202
					STA $7FE402
					STA $7FE502
					RTS
HDMA_RESETR2		LDA #$00
					STA $7FFB18
					STA $7FFB20
					STA $7FFB28
					STA $7FFB30
					RTS

HDMA_LASER			LDA #$08
					STA $7FFB18
					LDA #$10
					STA $7FFB20
					LDA #$20
					STA $7FFB28
					LDA #$40
					STA $7FFB30
					LDA #$00
					STA $7FFB19
					STA $7FFB21
					STA $7FFB29
					STA $7FFB31
					
					LDA #$26
					STA $7FFB1A
					LDA #$27
					STA $7FFB22
					LDA #$23
					STA $7FFB2A
					LDA #$2E
					STA $7FFB32
					
					LDA #$00
					STA $7FFB1B
					STA $7FFB23
					STA $7FFB2B
					STA $7FFB33
					
					LDA #$E1
					STA $7FFB2C
					LDA #$E2
					STA $7FFB34
					LDA #$E4
					STA $7FFB1C
					LDA #$E5
					STA $7FFB24

					LDA #$7F
					STA $7FFB1D
					STA $7FFB25
					STA $7FFB2D
					STA $7FFB35
					
					LDA #$50
					STA $7FE400
					STA $7FE500
					LDA #$00
					STA $7FE401
					STA $7FE501
					
					PHX
					LDX #$00
					LDY #$00
LOOP_L				TXA
					LSR A
					LSR A
					LSR A
					STA $7FFF0F
					LDA $7FFD01
					STA $004202
					TYA
					STA $004203
					LDA $004216
					STA $004204
					LDA $004217
					STA $004205
					LDA #$40
					STA $004206
					LDA #$01
					STA $7FE402,x
					STA $7FE502,x
					LDA $7FFD02
					AND #$01
					BEQ LOOP_L2
					LDA #$80
					SEC
					SBC $004214
					STA $7FE403,x
					BRA LOOP_L3
LOOP_L2				LDA $004214
					CLC
					ADC #$80
					STA $7FE403,x
LOOP_L3				LDA $7FE403,x
					CLC
					ADC $7FFF0F
					STA $7FE503,x
					INX
					INX
					INY
					CPX #$80
					BCC LOOP_L
					LDA #$10
					STA $7FE402,x
					STA $7FE502,x
					LDA #$00
					STA $7FE403,x
					STA $7FE503,x
					STA $7FE404,x
					STA $7FE504,x
					PLX
					
					LDA #$70
					STA $7FE100
					STA $7FE200
					LDA #$30
					STA $7FE101
					LDA #$FF
					STA $7FE201
					LDA #$70
					STA $7FE102
					STA $7FE202
					LDA #$30
					STA $7FE103
					LDA #$FF
					STA $7FE203
					LDA #$00
					STA $7FE104
					STA $7FE204
					RTS
					
DAMAGE_CHECK        LDA $E4,x
                    STA $7FFE01
                    LDA $14E0,x
                    STA $7FFE02
                    LDA $D8,x
                    STA $7FFE03
                    LDA $14D4,x
                    STA $7FFE04
                    PHX
                    LDX #$09
LOOP1               LDA $9E,x
                    CMP #$53
                    BNE LOOP3
					LDA $14C8,x
					BEQ LOOP3
                    JSR NEAR_CHECK
                    TYA
                    BEQ LOOP3
					STZ $14C8,x
                    LDA #$28
					STA $1DFC
					PLX
					INC $C2,x
					LDA #$20
					STA $1887
					PHX
LOOP3               DEX
                    BPL LOOP1
                    PLX
					LDA $C2,x
					CMP #$04
					BCS THEEND
                    RTS
THEEND				LDA #$FF
					STA $15AC,x
					LDA #$07
					STA $1528,x
					RTS
					
NEAR_CHECK          LDY #$00
                    LDA $E4,x
                    SEC
                    SBC $7FFE01
                    STA $0F
                    LDA $14E0,x
                    SBC $7FFE02
                    CMP #$00
                    BEQ RIGHT_CHECK
                    CMP #$FF
                    BNE CHECK_E
                    LDA $0F
                    CMP #$F8
                    BCC CHECK_E
                    BRA VER_CHECK
RIGHT_CHECK         LDA $0F
                    CMP #$08
                    BCS CHECK_E
VER_CHECK           LDA $D8,x
                    SEC
                    SBC $7FFE03
                    STA $0F
                    LDA $14D4,x
                    SBC $7FFE04
                    CMP #$00
                    BEQ UNDER_CHECK
                    CMP #$FF
                    BNE CHECK_E
                    LDA $0F
                    CMP #$F8
                    BCC CHECK_E
                    BRA NEAR
UNDER_CHECK         LDA $0F
                    CMP #$08
                    BCS CHECK_E
NEAR                LDY #$01
CHECK_E             RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder 

                    PHX                     ; push sprite index

                    LDA $00                 ; \ tile x position = sprite x location ($00)
                    STA $0300,y             ; /                    
                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y             ; /
                                 
					LDA #$6C
                    STA $0302,y             ; / 

                    LDA #$00
                    LDX $15E9               ;  |
                    ORA $15F6,x             ;  | get palette info
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties

                    PLX                     ; pull, X = sprite index
                    
                    LDY #$02
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generate routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN68            RTS     
FIRE_GEN            JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX

                    LDA $1602,x
                    STA $00E4,y

                    LDA #$00
                    STA $14E0,y             ; /

                    LDA $14F8,x
                    STA $00D8,y             ;  |
                    LDA #$00
                    STA $14D4,y             ; /

                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX                     ; / 
                    
RETURN67            RTS                     ; return
					
					
