;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Halbard
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
                    EXTRA_BITS = $7FAB10
					

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA $010B
					CMP #$17
					BEQ LEVEL117_INIT_0
					CMP #$F4
					BEQ LAST_INIT
					LDA EXTRA_BITS,x
					AND #$04
					BNE INI_BEAM_0
					LDA $010B
					CMP #$16
					BEQ INI_STAR
					CMP #$F0
					BEQ INI_STAR2
					CMP #$F1
					BEQ INI_STAR3
					CMP #$F2
					BEQ INI_TON
                    RTL
LAST_INIT			LDA #$87
					STA $167A,x
					LDA EXTRA_BITS,x
					AND #$04
					BEQ INIT_R
					LDA #$99
					STA $1686,x
					LDA $0F33
					STA $7FFF33
					RTL
LEVEL117_INIT_0		BRA LEVEL117_INIT_1
INI_BEAM_0			BRA INI_BEAM
INI_STAR			LDA #$83
					STA $167A,x
					LDA #$99
					STA $1686,x
					LDA #$01
					STA $1504,x
					LDA #$0F
					STA $15F6,x
INIT_R				RTL
INI_STAR2			LDA #$FF
					STA $15AC,x
					LDA #$02
					STA $1504,x
					LDA #$84
					STA $1602,x
					LDA #$0F
					STA $151C,x
					RTL
INI_STAR3			LDA $14E0,x
					BNE INI_TON
					LDA #$03
					STA $1504,x
					LDA #$83
					STA $167A,x
					LDA #$0F
					STA $15F6,x
					RTL
INI_TON				PHY
                    JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
					STA $151C,x
                    PLY
					LDA #$04
					STA $1504,x
					LDA #$99
					STA $1686,x
					LDA #$01
					STA $167A,x
					RTL
INI_BEAM			PHY
                    JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
					PLY
					LDA #$05
					STA $1504,x
					LDA #$99
					STA $1686,x
					LDA #$01
					STA $167A,x
					RTL
LEVEL117_INIT_1		LDA #$83
					STA $167A,x
					LDA #$99
					STA $1686,x
					LDA #$07
					STA $1504,x
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
L_SPEED				dcb $40,$C0

RETURN              RTS                    
START_HB_CODE       LDA $010B
					CMP #$F4
					BNE MAIN0
					JSR LAST_MAIN
					RTS
MAIN0				LDA $1504,x
					CMP #$01
					BNE MAIN1
					JSR STAR1
					RTS
MAIN1				CMP #$02
					BNE MAIN2
					JSR STAR2
					RTS
MAIN2				CMP #$03
					BNE MAIN3
					JSR STAR3
					RTS
MAIN3				CMP #$04
					BNE MAIN4
					JSR TON
					RTS
MAIN4				CMP #$05
					BNE MAIN5
					JSR BEAM
					RTS
MAIN5				CMP #$06
					BNE MAIN6
					JSR LASER
					RTS
MAIN6				JSR WARP_STAR
RETURN2             RTS

X_SPEEDT			dcb $08,$F8

STAR1				LDA $C2,x
					BNE STAR1_2
					JSR SUB_GFX_S
					LDA $9D
					BNE RETURNS
					LDA $14C8,x
					CMP #$08
					BNE RETURNS
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					INC $1570,x
					JSL $01A7DC
					BCC RETURNS
					LDA #$01
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					LDA #$A0
					STA $96
					STZ $97
					STZ $7B
					STZ $7D
					STZ $13E0
RETURNS				RTS
STAR1_2				JSR SUB_GFX_S2
					LDA $9D
					BNE RETURNS
					LDA $14C8,x
					CMP #$08
					BNE RETURNS
					STZ $7B
					STZ $7D
					STZ $13E0
					LDA $15
					LDA $15AC,x
					CMP #$F0
					BCS RETURNS
					CMP #$E0
					BCS STAR1_3
					CMP #$80
					BCS STAR1_4
					CMP #$70
					BEQ STAR1_5
					RTS
STAR1_3				LDA $AA,x
					PHA
					JSL $01802A
					PLA
					STA $AA,x
					INC $AA,x
					INC $AA,x
					INC $B6,x
					RTS
STAR1_4				LDA $AA,x
					PHA
					JSL $01802A
					PLA
					STA $AA,x
					DEC $AA,x
					DEC $AA,x
					RTS
STAR1_5				LDA #$06
					STA $71
					STZ $89
					STZ $88
					RTS

X_SPEED				dcb $30,$D0

STAR2				JSR SUB_GFX_Q
					LDA $9D
					BNE RETURNS2
					LDA $14C8,x
					CMP #$08
					BNE RETURNS2
					LDA #$FF
					STA $18BD
					PHP
					REP #$30
					LDA $1466
					SEC
					SBC.W #$0004
					STA $1466
					PLP
					LDA $15AC,x
					CMP #$C0
					BCS RETURNS2
					CMP #$B0
					BCS STAR2_2
					CMP #$80
					BCS STAR2_1
					CMP #$7F
					BEQ STAR2_3
RETURNS2			RTS
STAR2_1				LDA $AA,x
					PHA
					JSL $01802A
					PLA
					STA $AA,x
					LDA $14
					AND #$03
					BNE RETURNS2
					INC $B6,x
					INC $B6,x
					INC $B6,x
					INC $B6,x
					INC $AA,x
					INC $AA,x
					RTS
STAR2_2				LDA #$D0
					STA $AA,x
					JSL $01802A
					RTS
STAR2_3				LDA #$06
					STA $71
					STZ $89
					STZ $88
					STZ $14C8,x
					RTS

STAR3				JSR SUB_GFX_S2
					LDA $9D
					BNE RETURNS3
					JSR SPRITE_DELETE
					LDA #$FF
					STA $18BD
					STZ $13E0
					LDA #$01
					STA $76
					LDA $E4,x
					STA $94
					LDA $14E0,x
					STA $95
					LDA $C2,x
					BNE STAR3_2
					BRA STAR3_1
RETURNS3			RTS
STAR3_1				LDA $14
					AND #$07
					BNE STAR3_1_2
					INC $AA,x
STAR3_1_2			LDA #$60
					STA $B6,x
					LDA $AA,x
					PHA
					JSL $01802A
					PLA
					STA $AA,x
					LDA $1588,x
					AND #$04
					BEQ RETURNS3
					LDA #$C0
					STA $AA,x
					LDA #$01
					STA $C2,x
					RTS
STAR3_2				LDA $14
					AND #$03
					BNE STAR3_2_3
					DEC $B6,x
STAR3_2_3			JSL $01802A
					LDA $B6,x
					CMP #$40
					BCC STAR3_2_4
					LDA $1588,x
					AND #$04
					BEQ RETURNS3
					LDA #$E0
					STA $AA,x
					RTS
STAR3_2_4			LDA $D8,x
					SEC
					SBC #$10
					STA $96
					LDA $14D4,x
					SBC #$00
					STA $97
					LDA $B6,x
					STA $7B
					STZ $14C8,x
					STZ $18BD
					JSR SUB_SMOKE
RETURN_B			RTS
					
LASER				JSR SUB_GFX_Q
					LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN_B              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN_B
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSL $01A7DC
					LDY $157C,x
					LDA L_SPEED,y
					STA $B6,x
					STZ $AA,x
					JSL $01802A
					RTS



BEAM				JSR SUB_GFX_BEAM
					LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN_B              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN_B
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSL $01802A
					JSL $01A7DC
					INC $1570,x
					PHY
                    JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
                    PLY
					LDA $1570,x
					AND #$10
					BNE BEAM_2
					LDA #$08
					STA $AA,x
					BRA BRAM_MAIN
BEAM_2				LDA #$F8
					STA $AA,x
BRAM_MAIN			LDA $15AC,x
					BNE BEAM_3
					LDA $1528,x
					CMP #$20
					BCC RETURN_B2
					CMP #$E0
					BCS RETURN_B2
					LDA #$FF
					STA $15AC,x
RETURN_B2			RTS
BEAM_3				LDA $15AC,x
					CMP #$E0
					BEQ BEAM_G
					CMP #$B0
					BEQ BEAM_G
					CMP #$80
					BCS RETURN_B2
					CMP #$40
					BEQ DELETE_B
					DEC $151C,x
					DEC $151C,x
					LDA $151C,x
					STA $AA,x
					RTS
DELETE_B			STZ $14C8,x
					RTS
BEAM_G				LDA #$05
					STA $1DF9
					JSR GEN_SPRITE
					LDA $157C,x
					STA $157C,y
					LDA #$00
					STA $1656,y
					LDA #$99
					STA $1686,y
					LDA #$06
					STA $1504,y
					LDA #$0B
					STA $151C,y
					LDA #$44
					STA $1602,y
					RTS
					
TON					JSR SUB_GFX_TON
					LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN_T              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN_T 
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSL $01802A
					JSL $01A7DC
					INC $1570,x
					LDA $C2,x
					BNE TON_4
					PHY
                    JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
                    PLY
					CMP $151C,x
					BNE TON_3
TON_5				LDA $1570,x
					AND #$10
					BNE TON_2
					LDA #$08
					STA $AA,x
					RTS
TON_2				LDA #$F8
					STA $AA,x
RETURN_T            RTS
TON_3				LDA #$01
					STA $C2,x
					LDA #$20
					STA $15AC,x
					RTS
TON_4				LDA $15AC,x
					BNE TON_5
					PHY
                    JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
                    PLY
					INC $1570,x
					LDA #$30
					STA $02
					LDA #$18
					STA $03
					LDA $96
					PHA
					CLC
					ADC #$10
					STA $96
					LDA $97
					PHA
					ADC #$00
					STA $97
					JSR SPEED_DEC
					PLA
					STA $97
					PLA
					STA $96
					LDA $1594,x
                    STA $AA,x
                    LDA $1602,x
                    STA $B6,x
					LDA $AA,x
					CMP #$80
					BCS TON_4_2
					CMP #$08
					BCC RETURN_T2
					LDA #$08
					STA $AA,x
RETURN_T2			RTS
TON_4_2				CMP #$F8
					BCS RETURN_T2
					LDA #$F8
					STA $AA,x
					RTS




SUB_SMOKE           LDY #$03                ; \ find a free slot to display effect
FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
                    RTS                     ; / return if no slots open
FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    ;LDA $178B,x
					LDA $D8,x 
                    STA $17C4,y             ; /
                    LDA #$1B                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $E4,x             ; \ load generator x position
                    STA $17C8,y             ; /
RETURN3             RTS 



LAST_MAIN			LDA EXTRA_BITS,x
					AND #$04
					BEQ LAST_MAIN0
					JSR LAST_META
					RTS
LAST_MAIN0			JSR SUB_GFX_WI
					JSR DELETE_MARIO
					LDA $9D
					BNE RETURN3
					TXA
					STA $7FFF22
					JSL $01802A
					JSR LAST_SPEED
					JSR TIMER
					RTS
					
TIMER				LDA $7FFF33
					CMP $0F33
					BEQ TIMER_R
					LDA $0F33
					STA $7FFF33
					LDA #$23
					STA $1DFC
TIMER_R				RTS
					
DELETE_MARIO		LDA $E4,x
					STA $94
					LDA $14E0,x
					STA $95
					LDA $D8,x
					SEC
					SBC #$10
					STA $96
					LDA $14D4,x
					STA $97
					LDA #$40
					STA $0D89
					STA $0D93
					LDA #$51
					STA $0D8A
					STA $0D94
					LDA #$40
					STA $13E0
					LDA $95
					CMP #$12
					BEQ LBL1011
					LDA #$04
					STA $18BD
					STZ $1401
					RTS
LBL1011				STZ $18BD
					RTS
LAST_SPEED			LDA $1588,x
					AND #$04
					BEQ LAST_SPEED0
					LDA $16
					AND #$80
					BEQ LAST_SPEED0
					LDA #$C0
					STA $AA,x
					LDA #$01
					STA $1DFA
LAST_SPEED0			LDA $1588,x
					AND #$01
					BNE LAST_SPEED2
					AND #$02
					BNE LAST_SPEED3
					LDA $B6,x
					CMP #$80
					BCS LAST_SPEED1
					CMP #$41
					BCC LAST_SPEED1
					RTS
LAST_SPEED1			INC $B6,x
					RTS
LAST_SPEED2			LDA #$C0
					STA $B6,x
					LDA #$C0
					STA $AA,x
					LDA #$28
					STA $1DFC
					RTS
LAST_SPEED3			STZ $B6,x
					RTS
					
					
RETURNLM			RTS
LAST_META			JSR SUB_GFX_LM
					LDA $9D
					BNE RETURNLM
					LDA $C2,x
					BNE LAST_META_2
					JSR MODE0
					RTS
LAST_META_2			CMP #$01
					BNE LAST_META_3
					JSR MODE1
					RTS
LAST_META_3			JSR MODE2
					RTS

MODE0				LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					STZ $1602,x
					LDA $14E0,x
					STZ $AA,x
					CMP #$02
					BCC MODE0_R
					LDA #$10
					STA $AA,x
					LDA $D8,x
					CMP #$F0
					BCC MODE0_R
					LDA #$01
					STA $C2,x
					LDA #$80
					STA $15AC,x
					STZ $1504,x
MODE0_R				JSL $01802A
					RTS


META_SPEED1			dcb $70,$00

MODE1				LDA $14
					LSR A
					LSR A
					LSR A
					AND #$03
					CMP #$03
					BNE MODE1_1
					LDA #$01
MODE1_1				CLC
					ADC #$01
					STA $1602,x
					
					LDA $15AC,x
					BEQ MODE1_5
					LDY $1504,x
					LDA META_SPEED1,y
					STA $B6,x
					STZ $AA,x
					JSL $01802A
					LDA $E4,x
					SEC
					SBC $94
					STA $0F
					LDA $14E0,x
					SBC $95
					BCS MODE1_2
					CMP #$FF
					BCC MODE1_4
					LDA $0F
					CMP #$C0
					BCC MODE1_4
					RTS
MODE1_2				CMP #$01
					BCS MODE1_3
					LDA $0F
					CMP #$60
					BCS MODE1_3
					RTS
MODE1_3				LDA #$01
					STA $1504,x
					RTS
MODE1_4				STZ $1504,x
					RTS
MODE1_5				LDA #$7F
					STA $B6,x
					STZ $AA,x
					JSL $01802A
					LDA $E4,x
					SEC
					SBC $94
					LDA $14E0,x
					SBC $95
					CMP #$01
					BNE MODE1_R
					LDA #$02
					STA $C2,x
					LDA $96
					CLC
					ADC #$10
					STA $D8,x
					LDA $97
					ADC #$00
					STA $14D4,x
					STZ $1504,x
MODE1_R				RTS

MODE2				LDA #$B0
					STA $B6,x
					STZ $AA,x
					JSL $01802A
					LDA #$04
					STA $1602,x
					LDA $1504,x
					BNE MODE2_2
					JSL $01A7DC
					BCC MODE2_2
					LDA #$01
					STA $1504,x
					LDA $7FFF22
					TAY
					LDA #$C0
					STA $00B6,y
					LDA #$C0
					STA $00AA,y
					LDA #$28
					STA $1DFC
MODE2_2				LDA $E4,x
					SEC
					SBC $94
					STA $0F
					LDA $14E0,x
					SBC $95
					BCC MODE2_3
					RTS
MODE2_3				CMP #$FF
					BCC MODE2_4
					LDA $0F
					CMP #$80
					BCC MODE2_4
					RTS
MODE2_4				LDA #$01
					STA $C2,x
					STZ $1504,x
					LDA #$A0
					STA $15AC,x
					LDA #$F0
					STA $D8,x
					STZ $14D4,x
					RTS
					
WARP_STAR_0			JSR STAR_DEC
					INC $C2,x
					RTS
WARP_STAR			LDA $C2,x
					BEQ WARP_STAR_0
					CMP #$02
					BEQ WARP_STAR_2
					JSR SUB_GFX_S
					LDA $9D
					BNE RETURN_W
					LDA $14C8,x
					CMP #$08
					BNE RETURN_W
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					INC $1570,x
					LDA $18BD
					BNE RETURN_W
					JSL $01A7DC
					BCC RETURN_W
					INC $C2,x
					LDA #$10
					STA $1540,x
					LDA #$FF
					STA $18BD
					;LDA #$01
					;STA $185C ;#IuWFNgɔȂȂ
					STZ $7B
					STZ $7D
RETURN_W			RTS
WARP_STAR_1			LDA $1528,x
					STA $15AC,x
					RTS
WARP_STAR_2			JSR SUB_GFX_S2
					LDA $9D
					BNE RETURN_W
					LDA #$13
					STA $78
					STZ $13E0
					LDA $1540,x
					BNE RETURN_W
					LDA $15AC,x
					BEQ WARP_STAR_1
					LDA $15AC,x
					CMP #$01
					BEQ WARP_STAR_4
					CMP #$10
					BCC RETURN_W
WARP_STAR_3			LDA $1602,x
					STA $B6,x
					LDA $151C,x
					STA $AA,x
					JSL $018022 ;x speed
					JSL $01801A ;y speed
					LDA $E4,x
					STA $94
					LDA $14E0,x
					STA $95
					LDA $D8,x
					SEC
					SBC #$10
					STA $96
					LDA $14D4,x
					SBC #$00
					STA $97
					RTS
WARP_STAR_4			STZ $18BD
					STZ $78
					;STZ $185C
					JSR SUB_SMOKE
					LDY $161A,x
                    LDA #$00
                    STA $1938,y 
					STZ $14C8,x
					RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GEN_OFFSET			dcb $10,$F0
GEN_OFFSET2			dcb $00,$FF

RETURN67            RTS
GEN_SPRITE          LDY $157C,x
					LDA GEN_OFFSET,y
					STA $02
					LDA GEN_OFFSET2,y
					STA $03
					JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
					LDA $E4,x
					CLC
					ADC $02
                    STA $00E4,y
                    LDA $14E0,x
					ADC $03
                    STA $14E0,y             ; /

					LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  
					
					
SUB_GFX_Q           JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					LDA $1602,x
                    STA $0302,y             ; /
					LDA $01
					STA $0301,y
					LDA $00                 ; \ 
                    STA $0300,y             ; /
					LDA $151C,x
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					
                    LDY #$02                ; \ 02, because we didn't write to 460 yet
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen   
                    RTS                
					

HORIZ_DISP          dcb $F8,$08,$F8,$08,$F8,$08,$F8,$08
					dcb $08,$F8,$08,$F8,$F8,$08,$F8,$08
VERT_DISP           dcb $F0,$F0,$00,$00,$F0,$F0,$00,$00
					dcb $F0,$F0,$00,$00,$00,$00,$F0,$F0
TILEMAP             dcb $A0,$A2,$C0,$C2,$A4,$A6,$C4,$C6
					dcb $A0,$A2,$C0,$C2,$A4,$A6,$C4,$C6
PROPERTIES          dcb $00,$00,$40,$80


SUB_GFX_S           JSR GET_DRAW_INFO
					LDA $15F6,x
					STA $0F
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					STA $02
					ASL A
					ASL A
					STA $03
					
					PHX
                    LDX #$03                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START          PHX                     ; push, current tile
					TXA
					CLC
					ADC $03
					TAX
					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP,x         ; |
                    STA $0301,y             ; /
					
					
					LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /

                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP,x        ; |
                    STA $0300,y             ; /

                    LDX $02
					LDA PROPERTIES,x
					ORA $0F
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties


                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
					
HORIZ_DISP2          dcb $F8,$08,$F8,$08,$00
VERT_DISP2           dcb $F0,$F0,$00,$00,$F0
TILEMAP2             dcb $A0,$A2,$C0,$C2,$00
PROPERTIES2          dcb $00,$00,$00,$00,$40


SUB_GFX_S2          JSR GET_DRAW_INFO
					LDA $15F6,x
					STA $0F
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					STA $02
					ASL A
					ASL A
					STA $03
					
					PHX
                    LDX #$04                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START2         LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP2,x         ; |
                    STA $0301,y             ; /
					
					LDA TILEMAP2,x           ; \ store tile
                    STA $0302,y             ; /

                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP2,x        ; |
                    STA $0300,y             ; /

                    LDA PROPERTIES2,x
                    ORA $64                 ; add in tile priority of level
					CPX #$04
					BEQ LOOP_START2_A
					ORA $0F
LOOP_START2_A       STA $0303,y             ; store tile properties
					

                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START2

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$04                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
					
GRA_OFFSET1			dcb $00,$0A,$14,$1B,$22
GRA_OFFSET2			dcb $09,$09,$06,$06,$08

GRA_OFFSET			PHY
					LDA $1602,x
					TAY
					LDA GRA_OFFSET1,y
					STA $03
					LDA GRA_OFFSET2,y
					STA $02
					PLY
					RTS

HORIZ_DISPLM		dcb $E8,$F8,$08,$18,$E8,$F8,$08,$18,$F8,$08
					dcb $EE,$FE,$0E,$1E,$EE,$FE,$0E,$1E,$F6,$06
					dcb $EB,$FB,$0B,$EB,$FB,$0B,$1B
					dcb $E8,$F8,$08,$F8,$08,$F8,$08
					dcb $08,$18,$F8,$08,$18,$E8,$F8,$08,$18
VERT_DISPLM			dcb $E0,$E0,$E0,$E0,$F0,$F0,$F0,$F0,$00,$00
					dcb $E3,$E3,$E3,$E3,$F3,$F3,$F3,$F3,$03,$03
					dcb $F2,$F2,$F2,$02,$02,$02,$02
					dcb $F0,$F0,$F0,$00,$00,$10,$10
					dcb $E8,$E8,$F8,$F8,$F8,$08,$08,$08,$08
TILEMAPLM			dcb $00,$02,$04,$06,$20,$22,$24,$26,$42,$44
					dcb $80,$82,$84,$86,$A0,$A2,$A4,$A6,$C1,$C3
					dcb $60,$62,$64,$E0,$E2,$E4,$E6
					dcb $0A,$0C,$0E,$2C,$2E,$4C,$4E
					dcb $8C,$8E,$AA,$AC,$AE,$C8,$CA,$CC,$CE


SUB_GFX_LM          JSR GET_DRAW_INFO
					JSR GRA_OFFSET
					
					PHX
                    LDX $02
LOOP_STARTLM        PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA $01
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISPLM,x         ; |
                    STA $0301,y             ; /
					
					LDA TILEMAPLM,x           ; \ store tile
                    STA $0302,y             ; /

                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISPLM,x        ; |
                    STA $0300,y             ; /
					PLX

                    LDA #$0D
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties

                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_STARTLM

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA $02
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
HORIZ_DISPW          dcb $F8,$08,$F8,$08,$F8,$08
VERT_DISPW           dcb $E0,$E0,$F0,$F0,$00,$00
TILEMAPW             dcb $28,$2A,$48,$4A,$68,$6A


SUB_GFX_WI          JSR GET_DRAW_INFO
					
					PHX
                    LDX #$05                ; run loop 4 times, cuz 4 tiles per frame
LOOP_STARTW         LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISPW,x         ; |
                    STA $0301,y             ; /
					
					LDA TILEMAPW,x           ; \ store tile
                    STA $0302,y             ; /

                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISPW,x        ; |
                    STA $0300,y             ; /

                    LDA #$0F
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties

                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_STARTW

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$05                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
HORIZ_DISPT          dcb $08,$F8,$08,$F8,$F8,$08,$F8,$08
VERT_DISPT           dcb $F8,$F8,$08,$08
TILEMAPT             dcb $00,$02,$20,$22,$04,$06,$24,$26
					 dcb $08,$0A,$28,$2A,$0C,$0E,$2C,$2E
PROPERTIEST          dcb $4D,$0D


SUB_GFX_TON         JSR GET_DRAW_INFO
					
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$01
					ASL A
					ASL A
					STA $03
					LDA $157C,x
					STA $02
					LDA $C2,x
					BEQ SUB_GFX_TON_2
					LDA $03
					CLC
					ADC #$08
					STA $03
SUB_GFX_TON_2
					PHX
                    LDX #$03                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START2         PHX
					TXA
					CLC
					ADC $02
					ADC $02
					ADC $02
					ADC $02
					TAX
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISPT,x        ; |
                    STA $0300,y             ; /
					PLX
					
					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISPT,x         ; |
                    STA $0301,y             ; /
					
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILEMAPT,x           ; \ store tile
                    STA $0302,y             ; /
					PLX
					
					PHX
					LDX $02
                    LDA PROPERTIEST,x
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
					PLX

                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START2

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
					
HORIZ_DISPB          dcb $08,$F8,$08,$F8,$F8,$08,$F8,$08
VERT_DISPB           dcb $F8,$F8,$08,$08
TILEMAPB             dcb $40,$42,$60,$62
PROPERTIESB          dcb $47,$07


SUB_GFX_BEAM        JSR GET_DRAW_INFO
					LDA $00
					STA $1528,x
					LDA $157C,x
					STA $02
					ASL A
					ASL A
					STA $03
					PHX
                    LDX #$03                ; run loop 4 times, cuz 4 tiles per frame
LOOP_STARTB         LDA TILEMAPB,x           ; \ store tile
                    STA $0302,y             ; /
					
					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISPB,x         ; |
                    STA $0301,y             ; /
					
					PHX
					TXA
					CLC
					ADC $03
					TAX
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISPB,x        ; |
                    STA $0300,y             ; /

					LDX $02
                    LDA PROPERTIESB,x
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
					PLX

                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_STARTB

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS


SUB_GET_DIR         LDY #$00                
                    LDA $94                
                    SEC                     
                    SBC $E4,x               
                    STA $0F                 
                    LDA $95                 
                    SBC $14E0,x             
                    BPL LABEL16             
                    INY                     
LABEL16             RTS     

SPEED_DEC           LDA $E4,x
                    SEC
                    SBC $94
                    STA $0F
                    LDA $14E0,x
                    SBC $95
                    BPL FACE_LEFT
                    JSR RIGHT_SPEED
                    BRA VERC
FACE_LEFT           CMP #$01
                    BEQ LEFT2
                    JSR LEFT_SPEED1
                    BRA VERC
LEFT2               JSR LEFT_SPEED2
VERC                LDA $D8,x
                    SEC
                    SBC $96
                    STA $0F
                    LDA $14D4,x
                    SBC $97
                    BPL FACE_UP
                    JSR DOWN_SPEED
                    LDA $1594,x
                    CMP #$10
                    BCS VER_E
                    LDA #$10
                    STA $1594,x
                    BRA VER_E
FACE_UP             JSR UP_SPEED
                    LDA $1594,x
                    CMP #$F0
                    BCC VER_E
                    LDA #$F0
                    STA $1594,x
VER_E               RTS

UP_SPEED            LDA $0F38
                    CMP #$00
                    BNE UP3
                    LDA $0F
                    CMP #$80
                    BCC UP2
                    LDA #$7F
UP2                 STA $0F
                    BRA UP5
UP3                 CMP #$02
                    BNE UP4
                    JSR UP1_1
                    BRA UP5
UP4                 JSR UP1_2
UP5                 LDA #$00
                    SEC
                    SBC $0F
                    STA $1594,x
                    RTS

DOWN_SPEED          LDA #$00
                    SEC
                    SBC $0F
                    STA $0F
                    LDA $0F38
                    CMP #$00
                    BNE DOWN3
                    LDA $0F
                    CMP #$80
                    BCC DOWN2
                    LDA #$7F
DOWN2               STA $1594,x
                    RTS
DOWN3               CMP #$02
                    BNE DOWN4
                    JSR UP1_1
                    BRA DOWN5
DOWN4               JSR UP1_2
DOWN5               LDA $0F
                    STA $1594,x
                    RTS
UP1_1
LOOPUP1             LDA $0F37
                    BEQ LOOPUP1E
                    LDA $0F
                    LSR A
                    STA $0F
                    DEC $0F37
                    LDA $0F37
                    BNE LOOPUP1
LOOPUP1E            LDA $0F
                    CMP #$80
                    BCC LOOPUP1EE
                    LDA #$7F
                    STA $0F
LOOPUP1EE           RTS

UP1_2               LDA $0F
                    CMP #$80
                    BCC LOOPUP3
                    LDA #$7F
                    STA $0F
                    STZ $0F37
                    RTS
LOOPUP3             LDA $0F37
                    BEQ LOOPUP2E
                    LDA $0F
                    ASL A
                    STA $0F
                    DEC $0F37
                    LDA $0F37
                    BNE UP1_2
LOOPUP2E            LDA $0F
                    CMP #$80
                    BCC LOOPUP2EE
                    LDA #$7F
                    STA $0F
LOOPUP2EE           RTS







LEFT_SPEED1         STZ $0F38
                    LDA $0F
                    CMP $02
                    BCC LEFT1_2
                    LDA #$02
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_40
                    BRA LEFT1_3
LEFT1_2             CMP $03
                    BCS LEFT1_3
                    LDA #$01
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_20
                    BRA LEFT1_3
LEFT1_3             LDA #$00
                    SEC
                    SBC $0F
                    STA $1602,x
                    RTS

LEFT1_40            
LOOP140             LDA $0F
                    CMP $02
                    BCC LOOP140E
                    LSR A
                    STA $0F
                    INC $0F37
                    BRA LOOP140
LOOP140E            RTS
LEFT1_20            
LOOP120             LDA $0F
                    CMP $03
                    BCS LOOP120E
                    ASL A
                    STA $0F
                    INC $0F37
                    BRA LOOP140
LOOP120E            RTS

LEFT_SPEED2         STZ $0F37
                    INC $0F37
                    LDA $0F
                    LSR A
                    CLC
                    ADC #$80
                    STA $0F
                    LDA #$02
                    STA $0F38
                    JSR LEFT1_40
                    LDA #$00
                    SEC
                    SBC $0F
                    STA $1602,x
                    RTS

RIGHT_SPEED         STZ $0F38
                    LDA #$00
                    SEC
                    SBC $0F
                    STA $0F
                    CMP $02
                    BCC RIGHT_2
                    LDA #$02
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_40
                    BRA RIGHT_3
RIGHT_2             CMP $03
                    BCS RIGHT_3
                    LDA #$01
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_20
                    BRA RIGHT_3
RIGHT_3             LDA $0F
                    STA $1602,x
                    RTS
					
SPRITE_DELETE		LDY #$00
SPRITE_DELETE_LOOP	LDA $14C8,y
					CMP #$08
					BCC SPRITE_DELETE_2
					LDA $167A,y
					AND #$02
					BNE SPRITE_DELETE_2
					STZ $0F
					JSR NEAR_CHECK
					LDA $0F
					BEQ SPRITE_DELETE_2
					LDA #$00
					STA $14C8,y
					PHY
					JSR SUB_SMOKE
					PLY
					LDA #$08
					STA $1DF9
SPRITE_DELETE_2		INY
					CPY #$0A
					BCC SPRITE_DELETE_LOOP
					RTS
NEAR_CHECK			LDA $14E0,y
					CMP $14E0,x
					BNE RETURN35
					LDA $E4,x
					AND #$F0
					STA $02
					LDA $00E4,y
					AND #$F0
					CMP $02
					BNE RETURN35
					LDA $14D4,y
					CMP $14D4,x
					BNE RETURN35
					LDA $D8,x
					AND #$F0
					STA $02
					LDA $00D8,y
					AND #$F0
					CMP $02
					BNE RETURN35
					LDA #$01
					STA $0F
RETURN35			RTS

STAR_DEC_TBL1		dcb $00,$44,$D0,$40,$50,$70,$90,$90,$70,$70,$90,$40,$40,$90,$90
STAR_DEC_TBL2		dcb $C0,$14,$30,$EE,$10,$02,$FA,$EA,$F8,$02,$14,$F0,$1C,$F4,$14
STAR_DEC_TBL3		dcb $38,$40,$30,$78,$70,$91,$83,$7E,$4E,$A0,$BD,$72,$6A,$72,$74
STAR_DEC_TBL4		dcb $0B,$0D,$0F,$09,$0F,$0F,$0B,$09,$0D,$0F,$09,$0B,$0D,$09,$0F

STAR_DEC			LDA $14E0,x
					BEQ STAR_DEC_1
					CMP #$02
					BEQ STAR_DEC_2
					CMP #$03
					BEQ STAR_DEC_4
					CMP #$05
					BEQ STAR_DEC_5
					CMP #$09
					BEQ STAR_DEC_6
					CMP #$0B
					BEQ STAR_DEC_A
					CMP #$0C
					BEQ STAR_DEC_7
					CMP #$0D
					BEQ STAR_DEC_8
					CMP #$0F
					BEQ STAR_DEC_B
					CMP #$11
					BEQ STAR_DEC_9
					RTS
STAR_DEC_1			LDY #$00
					BRA STAR_DEC_RT
STAR_DEC_2			LDA $E4,x
					CMP #$10
					BNE STAR_DEC_3
					LDY #$01
					BRA STAR_DEC_RT
STAR_DEC_3			LDY #$02
					BRA STAR_DEC_RT
STAR_DEC_4			LDY #$03
					BRA STAR_DEC_RT
STAR_DEC_5			LDY #$04
					BRA STAR_DEC_RT
STAR_DEC_6			LDY #$05
					BRA STAR_DEC_RT
STAR_DEC_7			LDY #$06
					LDA $E4,x
					CMP #$90
					BEQ STAR_DEC_RT
					LDY #$07
					BRA STAR_DEC_RT
STAR_DEC_8			LDY #$08
					LDA $E4,x
					CMP #$20
					BEQ STAR_DEC_RT
					LDY #$09
					BRA STAR_DEC_RT
STAR_DEC_9			LDY #$0A
					BRA STAR_DEC_RT
STAR_DEC_A			LDY #$0B
					LDA $E4,x
					CMP #$70
					BEQ STAR_DEC_RT
					LDY #$0C
					BRA STAR_DEC_RT
STAR_DEC_B			LDY #$0D
					LDA $E4,x
					CMP #$A0
					BEQ STAR_DEC_RT
					LDY #$0E
STAR_DEC_RT			LDA STAR_DEC_TBL1,y
					STA $1602,x
					LDA STAR_DEC_TBL2,y
					STA $151C,x
					LDA STAR_DEC_TBL3,y
					STA $1528,x
					LDA STAR_DEC_TBL4,y
					STA $15F6,x
					RTS

