;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MetaKnight
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
                    EXTRA_BITS = $7FAB10
					

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA #$01
					STA $157C,x
					LDA EXTRA_BITS,x
					AND #$04
					BNE INIT_SWORD
					LDA #$D0
					STA $E4,x
					TXA
					STA $7FD700
					RTL
INIT_SWORD			TXA
					STA $7FD701
					LDA #$01
					STA $1504,x
					LDA #$83
					STA $167A,x
					JSR GAGE_RESET
					JSR HDMA_COLOR_RESET
					LDA #$64
					STA $7FDE00 ;#}IHP
					LDA #$64
					STA $7FDE01 ;#^iCgHP
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                    
START_HB_CODE       LDA $1504,x
					BNE MAIN0
					JSR META
					RTS
MAIN0				CMP #$01
					BNE MAIN1
					JSR SWORD
					RTS
MAIN1				CMP #$02
					BNE MAIN2
					JSR ATTACK
					RTS
MAIN2				CMP #$03
					BNE MAIN3
					JSR MANTO
					RTS
MAIN3				CMP #$04
					BNE MAIN4
					JSR SWING2
					RTS
MAIN4				CMP #$05
					BNE MAIN5
					JSR SHOT
					RTS
MAIN5				CMP #$06
					BNE MAIN6
					JSR STORM
					RTS
MAIN6				JSR MASK
RETURN2             RTS

MASK				JSR SUB_GFX_Q
					LDA $9D
					BNE RETURN2
					JSL $01802A
					RTS

META				JSR SUB_GFX
					JSR GAGE_CHECK
					JSR HDMA_COLOR_CHECK
					LDA $9D
					BNE RETURNS
					LDA $14C8,x
					CMP #$08
					BNE RETURNS
					LDA $16
					ORA $18
					BEQ META_0
					LDA $7FD300
					INC A
					STA $7FD300
META_0				LDA #$14
					STA $00212C
					LDA #$03
					STA $00212D
					STZ $0DBC
					STZ $0DC1
					STZ $0DC2
					LDA #$01
					STA $19
					LDA $C2,x
					BNE META_2
					LDA $7FD207
					CMP #$77
					BNE RETURNS
					LDA $18BD
					BNE RETURNS
					LDA #$01
					STA $C2,x
					LDA #$05
					STA $1DFB
					JSR GEN_SPRITE
					LDA $E4,x
					STA $00E4,y
					LDA $14E0,x
					STA $14E0,y
					LDA $D8,x
					STA $00D8,y
					LDA $14D4,x
					STA $14D4,y
					LDA #$03
					STA $1504,y
					LDA #$40
					STA $15AC,y
					LDA #$FF
					STA $15AC,x
					LDA #$01
					STA $1602,x
RETURNS				RTS
META_2				JSR DAMAGE_CHECK
					LDA $C2,x
					CMP #$02
					BCS META_MAIN
					LDA $15AC,x
					CMP #$E0
					BCS RETURNS
					CMP #$B0
					BCS META_2_2
					CMP #$70
					BCS META_2_3
					LDA $1588,x
					AND #$04
					BNE META_2_1
					LDA #$28
					STA $AA,x
					JSL $01802A
					LDA #$0A
					STA $1602,x
					RTS
META_2_1			LDA #$01
					STA $1602,x
					LDA #$02
					STA $C2,x
					LDA #$20
					STA $1540,x
					LDA #$80
					STA $15AC,x
					RTS
META_2_2			LDA #$E0
					STA $B6,x
					LDA #$E0
					STA $AA,x
					LDA #$0A
					STA $1602,x
					JSL $01802A
					RTS
META_2_3			STZ $B6,x
					LDA #$28
					STA $AA,x
					JSL $01802A
					LDA $14
					LSR A
					AND #$07
					CLC
					ADC #$02
					STA $1602,x
RETURN30			RTS
META_MAIN			JSL $01802A
					LDA $C2,x
					CMP #$03
					BCS ATTACK_MODE
					LDA $1540,x
					BNE RETURN30
					LDA $15AC,x
					BEQ ATT_DEC
					JSR SUB_GET_DIR ;#
                    TYA
                    STA $157C,x
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$03
					TAY
					LDA WALK_G,y
					STA $1602,x
					LDA $14
					AND #$20
					BEQ META_MAIN_1
					LDA #$08
					STA $B6,x
					BRA META_MAIN_0
META_MAIN_1			LDA #$F8
					STA $B6,x
META_MAIN_0			LDA $14E0,x
					CMP #$01
					BEQ META_MAIN_11
					CMP #$FF
					BEQ META_MAIN_12
					LDA $E4,x
					CMP #$F0
					BCC META_MAIN_2
META_MAIN_11		LDA #$F0
					STA $E4,x
					STZ $14E0,x
META_MAIN_2			CMP #$08
					BCS RETURN301
META_MAIN_12		LDA #$08
					STA $E4,x
					STZ $14E0,x
RETURN301			RTS
ATT_DEC				STZ $B6,x
					LDA $7FD300
					CLC
					ADC $94
					AND #$07
					CLC
					ADC #$03
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					RTS
ATTACK_MODE			LDA $C2,x
					CMP #$03
					BNE MODE2
					JSR ATTACK1
					RTS
MODE2				CMP #$04
					BNE MODE3
					JSR ATTACK2
					RTS
MODE3				CMP #$05
					BNE MODE4
					JSR ATTACK3
					RTS
MODE4				CMP #$06
					BNE MODE5
					JSR ATTACK4
					RTS
MODE5				CMP #$07
					BNE MODE6
					JSR ATTACK5
					RTS
MODE6				CMP #$08
					BNE MODE7
					JSR ATTACK6
					RTS
MODE7				CMP #$09
					BNE MODE8
					JSR ATTACK1
					RTS
MODE8				CMP #$0A
					BNE MODE9
					JSR ATTACK2
					RTS
MODE9				JSR THE_END
					RTS

ATTACK1				;#
					LDA $15AC,x
					CMP #$E0
					BCS ATTACK1_2
					CMP #$B0
					BCS ATTACK1_3
					CMP #$AF
					BEQ ATTACK1_4
					RTS
ATTACK1_2			LDA #$0D
					STA $1602,x
					RTS
ATTACK1_3			LDA #$0E
					STA $1602,x
					LDA $15AC,x
					CMP #$DF
					BEQ ATTACK1_3_G
					RTS
ATTACK1_3_G			LDA $157C,x
					EOR #$01
					STA $157C,x
					JSR GEN_SPRITE
					LDA #$99
					STA $1686,y
					LDA #$04
					STA $1504,y
					LDA $157C,x
					STA $157C,y
					LDA #$0E
					STA $151C,y
					LDA #$10
					STA $15AC,y
					JSR GEN_SPRITE
					LDA #$99
					STA $1686,y
					LDA #$05
					STA $1504,y
					LDA $157C,x
					EOR #$01
					STA $157C,x
					STA $157C,y
					RTS
ATTACK1_4			LDA #$40
					STA $15AC,x
					LDA #$02
					STA $C2,x
					RTS
					
ATTACK2				;#]Wv
					LDA $15AC,x
					CMP #$FE
					BEQ ATTACK2_1
					CMP #$A0
					BEQ ATTACK2_4
					LDA $1588,x
					AND #$04
					BNE ATTACK2_2
					LDA $14
					LSR A
					AND #$07
					CLC
					ADC #$02
					STA $1602,x
					RTS
ATTACK2_2			STZ $B6,x
					LDA #$01
					STA $1602,x
					RTS
ATTACK2_4			LDA #$40
					STA $15AC,x
					LDA #$02
					STA $C2,x
					RTS
ATTACK2_1			LDA #$A0
					STA $AA,x
					JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
					BEQ ATAACK2_R
					LDA $E4,x
					SEC
					SBC $94
					LSR A
					LSR A
					STA $B6,x
					LDA #$00
					SEC
					SBC $B6,x
					STA $B6,x
					RTS
ATAACK2_R			LDA $94
					SEC
					SBC $E4,x
					LSR A
					LSR A
					STA $B6,x
					RTS
					
ATTACK3				;#˂
					LDA $15AC,x
					CMP #$FE
					BEQ ATTACK3_1
					CMP #$DF
					BCS ATTACK3_2
					CMP #$CF
					BCS ATTACK3_3
					CMP #$90
					BEQ ATTACK3_4
					LDA $1588,x
					AND #$04
					BNE RETURN32
					LDA #$60
					STA $AA,x
RETURN32			RTS
ATTACK3_2			LDA #$C0
					STA $AA,x
					LDA #$0A
					STA $1602,x
					RTS
ATTACK3_3			STZ $B6,x
					STZ $AA,x
					LDA #$11
					STA $1602,x
					RTS
ATTACK3_4			LDA #$40
					STA $15AC,x
					LDA #$02
					STA $C2,x
					RTS
ATTACK3_1			JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
					BEQ ATAACK3_R
					LDA $E4,x
					SEC
					SBC $94
					LSR A
					STA $B6,x
					LDA #$00
					SEC
					SBC $B6,x
					STA $B6,x
					RTS
ATAACK3_R			LDA $94
					SEC
					SBC $E4,x
					LSR A
					STA $B6,x
					RTS
					
					RTS
ATTACK4				;#˂
					LDA $1540,x
					BNE ATTACK4_3
					LDA #$0A
					STA $1602,x
					LDA $15AC,x
					CMP #$FE
					BNE ATTACK4_0
					LDA #$A0
					STA $AA,x
					RTS
ATTACK4_0			LDA $157C,x
					BEQ ATTACK4_R
					LDA #$30
					STA $B6,x
					LDA $14E0,x
					BEQ RETURN34
					LDA $E4,x
					CMP #$20
					BCC RETURN34
ATTACK4_1			LDA #$F0
					STA $1540,x
					LDA #$12
					STA $1602,x
					LDA #$20
					STA $D8,x
					LDA #$01
					STA $14D4,x
RETURN34			RTS
ATTACK4_R			LDA #$D0
					STA $B6,x
					LDA $14E0,x
					BEQ RETURN34
					LDA $E4,x
					CMP #$D0
					BCS RETURN34
					BRA ATTACK4_1
ATTACK4_3			CMP #$E0
					BCC ATTACK4_4
					STZ $AA,x
					STZ $B6,x
					RTS
ATTACK4_4			CMP #$90
					BEQ ATTACK4_5
					CMP #$90
					BCC ATTACK4_6
					LDA #$10
					STA $AA,x
					LDA $157C,x
					BEQ ATTACK4_3_R
					LDA #$A0
					STA $B6,x
					RTS
ATTACK4_3_R			LDA #$60
					STA $B6,x
					RTS
ATTACK4_5			LDA #$0A
					STA $1602,x
					LDA #$C0
					STA $D8,x
					STZ $14D4,x
					LDA $157C,x
					BEQ ATTACK4_5_R
					LDA #$E0
					STA $E4,x
					LDA #$FF
					STA $14E0,x
					LDA #$30
					STA $B6,x
					STZ $AA,x
					RTS
ATTACK4_5_R			LDA #$20
					STA $E4,x
					LDA #$01
					STA $14E0,x
					LDA #$D0
					STA $B6,x
					STZ $AA,x
RETURN42			RTS
ATTACK4_6			LDA $1588,x
					AND #$04
					BEQ RETURN42
					STZ $B6,x
					LDA #$01
					STA $1602,x
					LDA #$80
					STA $15AC,x
					LDA #$02
					STA $C2,x
					LDA #$20
					STA $1540,x
					RTS

ATTACK5				;#
					LDA #$01
					STA $14AF
					LDA $15AC,x
					CMP #$FE
					BEQ ATTACK5_1
					CMP #$D0
					BCS RETURN71
					CMP #$C0
					BCS ATTACK5_2
					LDA $1588,x
					AND #$04
					BNE ATTACK5_4
					LDA $E4,x
					CMP #$F0
					BCC ATTACK5_5
					LDA #$F0
					STA $E4,x
ATTACK5_5			LDA $E4,x
					CMP #$10
					BCS ATTACK5_6
					LDA #$10
					STA $E4,x
ATTACK5_6			LDA #$08
					STA $AA,x
					LDA #$77
					STA $151C,x
					JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
					LDA $157C,x
					BEQ ATTACK5_R
					LDA $B6,x
					CMP #$D0
					BEQ RETURN71
					DEC $B6,x
RETURN71			RTS
ATTACK5_R			LDA $B6,x
					CMP #$30
					BEQ RETURN71
					INC $B6,x
					RTS
ATTACK5_2			STZ $AA,x
					LDA $15AC,x
					AND #$01
					CLC
					ADC #$77
					STA $151C,x
					RTS
ATTACK5_1			LDA #$98
					STA $AA,x
					STZ $B6,x
					LDA #$0A
					STA $1602,x
					RTS
ATTACK5_4			STZ $B6,x
					LDA #$01
					STA $1602,x
					LDA #$80
					STA $15AC,x
					LDA #$02
					STA $C2,x
					STZ $14AF
					LDA #$20
					STA $1540,x
					STZ $151C,x
					RTS

ATTACK6				;#
					LDA $15AC,x
					CMP #$C0
					BCS ATTACK6_2
					CMP #$B0
					BCS ATTACK6_3
					LDA #$0E
					STA $1602,x
					LDA $7FD310
					BEQ ATTACK6_4
					RTS
ATTACK6_2			LDA $14
					LSR A
					LSR A
					AND #$01
					CLC
					ADC #$0F
					STA $1602,x
					STZ $B6,x
					RTS
ATTACK6_3			LDA #$0D
					STA $1602,x
					LDA #$77
					STA $7FD310
					LDA $15AC,x
					CMP #$B0
					BEQ ATTACK6_G
					RTS
ATTACK6_4			LDA #$01
					STA $1602,x
					LDA #$50
					STA $15AC,x
					LDA #$02
					STA $C2,x
					LDA #$10
					STA $1540,x
					RTS
ATTACK6_G			LDA #$17
					STA $1DFC
					LDA $157C,x
					EOR #$01
					STA $157C,x
					JSR GEN_SPRITE
					LDA #$00
					STA $1570,y
					LDA #$06
					STA $1504,y
					LDA #$50
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					LDA $157C,x
					STA $157C,y
					JSR GEN_SPRITE
					LDA #$0E
					STA $1570,y
					LDA #$06
					STA $1504,y
					LDA #$20
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					LDA $157C,x
					STA $157C,y
					JSR GEN_SPRITE
					LDA #$1C
					STA $1570,y
					LDA #$06
					STA $1504,y
					LDA #$F0
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA $157C,x
					STA $157C,y
					JSR GEN_SPRITE
					LDA #$2A
					STA $1570,y
					LDA #$06
					STA $1504,y
					LDA #$C0
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA $157C,x
					STA $157C,y
					LDA $157C,x
					EOR #$01
					STA $157C,x
					RTS
					
ATTACK7				;#_bVa
					RTS
ATTACK8				;#
					RTS

SWING2				JSR SUB_GFX_A
					LDA $9D
					BNE RETURN_S2
					LDA $15AC,x
					BEQ DELETE_S2
					JSL $01A7DC
					BCC RETURN_S2
					LDA $1497
					BNE RETURN_S2
					JSR SUB_DAMAGE_15
RETURN_S2			RTS
DELETE_S2			STZ $14C8,x
					RTS
					
SHOT				JSR SUB_GFX_SHOT
					LDA $9D
					BNE RETURN_S2
					LDA $14E0,x
					BNE DELETE_S2
					LDY $157C,x
					LDA SHOT_S,y
					STA $B6,x
					STZ $AA,x
					JSL $01802A
					JSL $01A7DC
					BCC SHOT_R
					LDA $1497
					BNE SHOT_R
					JSR SUB_DAMAGE_20
SHOT_R				RTS
SHOT_S				dcb $20,$D0
WALK_G				dcb $01,$0B,$01,$0C

SWORD				JSR SUB_GFX_S
					LDA $9D
					BNE RETURN_S
					LDA $1558,x
					BNE SWORD_START
					LDA $C2,x
					BNE SWORD_3
					JSL $01A7DC
					BCS SWORD_2
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					STA $1570,x
RETURN_S			RTS
SWORD_2				LDA #$00
					STA $40
					LDA #$0D
					STA $1DF9
					LDA #$01
					STA $19
					STA $1570,x
					LDA #$20
					STA $1558,x
					RTS
SWORD_START			LDA #$02
					STA $18BD

					LDA #$0B
					STA $13E0
					LDA #$01
					STA $1602,x
					JSR POS_CHECK
					LDA #$01
					STA $C2,x
					LDA #$77
					STA $7FD207
					RTS
SWORD_3				LDA $40
					CMP #$20
					BNE SWORD_3_2
					LDA $18BD
					BNE SWING
SWORD_3_2			LDA #$20
					STA $40
					LDA #$10
					STA $1602,x
					LDA $94
					STA $7FD200
					STA $E4,x
					LDA $95
					STA $7FD201
					STA $14E0,x
					LDA $96
					STA $7FD202
					STA $D8,x
					LDA $97
					STA $7FD203
					STA $14D4,x
					LDA $7B
					STA $7FD204
					LDA $7D
					STA $7FD205
					LDA $76
					STA $7FD206
					STA $157C,x
					LDA $16
					AND #$40
					BNE SWORD_4
					RTS
SWORD_4				LDA #$18
					STA $18BD
					RTS
SWING				LDA $7FD200
					STA $94
					LDA $7FD201
					STA $95
					LDA $7FD202
					STA $96
					LDA $7FD203
					STA $97
					LDA $7FD206
					STA $76
					LDA $18BD
					CMP #$14
					BCS SWING_2
					CMP #$10
					BCS SWING_3
					CMP #$0C
					BCS SWING_4
					CMP #$08
					BEQ SWING_1
					LDA #$01
					STA $13E0
					RTS
SWING_1				STZ $18BD
					LDA $7FD204
					STA $7B
					LDA $7FD205
					STA $7D
					RTS
SWING_2				LDA #$0B
					STA $13E0
					LDA #$02
					STA $1602,x
					RTS
SWING_3				LDA #$02
					STA $13E0
					LDA #$03
					STA $1602,x
					RTS
SWING_4				LDA #$01
					STA $13E0
					LDA #$04
					STA $1602,x
					LDA $18BD
					CMP #$0C
					BEQ SWORD_G
					RTS
SWORD_G				JSR GEN_SPRITE
					LDA #$08
					STA $151C,y
					LDA #$02
					STA $1504,y
					LDA $96
					CLC
					ADC #$10
					STA $00D8,y
					LDA $97
					ADC #$00
					STA $14D4,y
					LDA #$08
					STA $15AC,y
					RTS

ATTACK				JSR SUB_GFX_A
					LDA $9D
					BNE RETURN_A
					LDA $15AC,x
					BEQ DELETE_A
					JSR ATTACK_CHECK
RETURN_A			RTS
DELETE_A			STZ $14C8,x
					RTS

STORM				JSR SUB_GFX_W
					LDA $9D
					BNE RETURN_ST
					LDA $1497
					BNE STORM_0
					JSR TRNED_DAMAGE
STORM_0				STZ $AA,x
					INC $1570,x
					LDA $14E0,x
					BNE DELETE_S
					LDA $1570,x
					AND #$20
					BEQ STORM_1
					LDA #$08
					STA $B6,x
					BRA STORM_2
STORM_1				LDA #$F8
					STA $B6,x
STORM_2				JSL $01802A
					LDA $157C,x
					BNE MOVE_R
					LDA $E4,x
					SEC
					SBC #$01
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
					RTS
MOVE_R				LDA $E4,x
					CLC
					ADC #$01
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
RETURN_ST			RTS
DELETE_S			STZ $14C8,x
					LDA #$00
					STA $7FD310
					RTS

					
MANTO				JSR SUB_GFX_M
					LDA $9D
					BNE RETURN_M
					LDA $1558,x
					BNE MANT2
					CMP #$01
					BEQ DELETE_A
					STZ $AA,x
					LDA $15AC,x
					BEQ DELETE_A
					CMP #$20
					BCS MANT1
RETURN_M			RTS
MANT1				LDA #$08
					STA $B6,x
					JSL $01802A
					RTS
MANT2				STZ $AA,x
					LDA #$F0
					STA $B6,x
					JSL $01802A
					RTS


X_OFFSET			dcb $00,$04
Y_OFFSET			dcb $00,$F4
Y_OFFSET2			dcb $00,$FF

POS_CHECK			LDY $1602,x
					LDA $96
					CLC
					ADC Y_OFFSET,y
					STA $D8,x
					LDA $97
					ADC Y_OFFSET2,y
					STA $14D4,x
					LDA $76
					BEQ POS_LEFT
					LDA $94
					CLC
					ADC X_OFFSET,y
					STA $E4,x
					LDA $95
					ADC #$00
					STA $14E0,x
					RTS
POS_LEFT			LDA $94
					SEC
					SBC X_OFFSET,y
					STA $E4,x
					LDA $95
					SBC #$00
					STA $14E0,x
					RTS
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; DAMAGE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ATTACK_CHECK		LDA $1528,x
					CMP #$20
					BEQ RETURN648
					LDA $7FD700
					TAY
					LDA $00C2,y
					CMP #$07
					BEQ RETURN648
					LDA $00E4,y
					SEC
					SBC $E4,x
					STA $0F
					LDA $14E0,y
					SBC $14E0,x
					BEQ LBL648
					CMP #$FF
					BEQ LBL649
					RTS
LBL648				LDA $0F
					CMP #$10
					BCC LBL650
RETURN648			RTS
LBL649				LDA $0F
					CMP #$F0
					BCS LBL650
					RTS
LBL650				LDA $00D8,y
					SEC
					SBC $D8,x
					STA $0F
					LDA $14D4,y
					SBC $14D4,x
					BEQ LBL651
					CMP #$FF
					BEQ LBL652
					RTS
LBL651				LDA $0F
					CMP #$10
					BCC LBL653
					RTS
LBL652				LDA $0F
					CMP #$F0
					BCS LBL653
					RTS
LBL653				LDA $157C,x
					STA $0F
					LDA $157C,y
					CMP $0F
					BNE LBL655
					LDA #$03
					STA $1DF9
					LDA #$20
					STA $1528,x
					LDA $7FDE01
					CMP #$02
					BCC LBL654
					SEC
					SBC #$01
					STA $7FDE01
					RTS
LBL654				LDA #$00
					STA $7FDE01
					LDA #$1E
					STA $1DFB
					LDA $7FD700
					TAY
					LDA #$FF
					STA $15AC,y
					LDA #$80
					STA $00C2,y
					LDA #$FF
					STA $7FE301
					LDA #$7F
					STA $7FE302
					LDA #$18
					STA $1DFC
					JSR DELET_SPRITE
					RTS
LBL655				LDA #$39
					STA $7FE301
					LDA #$67
					STA $7FE302
					LDA #$10
					STA $1DFC
					LDA #$20
					STA $1528,x
					LDA $7FDE01
					CMP #$05
					BCC LBL654
					SEC
					SBC #$04
					STA $7FDE01
					RTS

DELET_SPRITE		LDA $7FD700
					STA $0F
					LDY #$00
DELETE_S_L			CPY $0F
					BEQ DELETE_S_2
					LDA #$00
					STA $14C8,y
DELETE_S_2			INY
					CPY #$0A
					BNE DELETE_S_L
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GEN_OFFSET			dcb $E0,$20
GEN_OFFSET2			dcb $FF,$00

RETURN67            RTS
GEN_SPRITE          LDY $157C,x
					LDA GEN_OFFSET,y
					STA $02
					LDA GEN_OFFSET2,y
					STA $03
					JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
					LDA $E4,x
					CLC
					ADC $02
                    STA $00E4,y
                    LDA $14E0,x
					ADC $03
                    STA $14E0,y             ; /

					LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
					LDA $157C,x
					STA $157C,y
                    RTS                          ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  
					
					
SUB_GFX_Q           JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					LDA $151C,x
                    STA $0302,y             ; /
					LDA $01
					STA $0301,y
					LDA $00                 ; \ 
                    STA $0300,y             ; /
					LDA #$0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					
                    LDY #$02                ; \ 02, because we didn't write to 460 yet
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen   
                    RTS                
					
TILEMAP             dcb $4C,$4E,$6C,$6E,$EE,$EE ;#p
					dcb $00,$02,$20,$22,$80,$A0 ;#1
					dcb $40,$42,$60,$62,$AC,$AC ;#
					dcb $40,$42,$60,$62,$8A,$EE ;#
					dcb $CC,$CE,$EC,$EE,$88,$88 ;#
					dcb $CC,$CE,$EC,$EE,$8A,$EE ;#E
					dcb $40,$42,$60,$62,$AC,$AC ;#E
					dcb $40,$42,$60,$62,$8A,$EE ;#E
					dcb $CC,$CE,$EC,$EE,$88,$88 ;#
					dcb $CC,$CE,$EC,$EE,$8A,$EE ;#
					dcb $80,$82,$A0,$A2,$A2,$82 ;#Wv
					dcb $04,$06,$24,$26,$80,$A0 ;#k1
					dcb $08,$0A,$28,$2A,$80,$A0 ;#k2
					dcb $44,$46,$64,$66,$80,$A0 ;#Uグ
					dcb $48,$4A,$68,$6A,$80,$A0 ;#U艺
					dcb $8C,$8E,$AC,$AE,$EE,$EE ;#^1
					dcb $CC,$CE,$AC,$AE,$EE,$EE ;#^2
					dcb $84,$86,$A4,$A6,$8E,$AE ;#˂
					dcb $88,$8A,$A8,$AA,$A8,$AA ;#˂
					dcb $C0,$C2,$E0,$E2,$EE,$EE ;#fP
					dcb $C4,$C6,$E4,$E6,$EE,$EE ;#f2
					dcb $CA,$EA,$EE,$EE,$EE,$EE ;#ړ
HORIZ_DISP          dcb $F8,$08,$F8,$08,$00,$00,$08,$F8,$08,$F8,$00,$00 ;#p
					dcb $F8,$08,$F8,$08,$EE,$EE,$08,$F8,$08,$F8,$12,$12 ;#1
					dcb $F8,$08,$F8,$08,$E8,$E8,$08,$F8,$08,$F8,$18,$18 ;#
					dcb $F8,$08,$F8,$08,$F2,$00,$08,$F8,$08,$F8,$0E,$00 ;#
					dcb $F8,$08,$F8,$08,$F8,$08,$08,$F8,$08,$F8,$08,$F8 ;#
					dcb $F8,$08,$F8,$08,$0E,$00,$08,$F8,$08,$F8,$F2,$00 ;#E
					dcb $08,$F8,$08,$F8,$18,$18,$F8,$08,$F8,$08,$E8,$E8 ;#E
					dcb $08,$F8,$08,$F8,$0E,$00,$F8,$08,$F8,$08,$F2,$00 ;#E
					dcb $08,$F8,$08,$F8,$F8,$08,$F8,$08,$F8,$08,$08,$F8 ;#
					dcb $08,$F8,$08,$F8,$F2,$00,$F8,$08,$F8,$08,$0E,$00 ;#
					dcb $F8,$08,$F8,$08,$F4,$04,$08,$F8,$08,$F8,$0C,$FC ;#Wv
					dcb $F8,$08,$F8,$08,$EF,$EF,$08,$F8,$08,$F8,$11,$11 ;#k1
					dcb $F8,$08,$F8,$08,$EE,$EE,$08,$F8,$08,$F8,$12,$12 ;#k2
					dcb $F8,$08,$F8,$08,$0E,$0E,$08,$F8,$08,$F8,$F2,$F2 ;#Uグ
					dcb $F8,$08,$F8,$08,$F9,$F9,$08,$F8,$08,$F8,$07,$07 ;#U艺
					dcb $F8,$08,$F8,$08,$F9,$F9,$08,$F8,$08,$F8,$07,$07 ;#^1
					dcb $F8,$08,$F8,$08,$F9,$F9,$08,$F8,$08,$F8,$07,$07 ;#^2
					dcb $F8,$08,$F8,$08,$FC,$FC,$08,$F8,$08,$F8,$04,$04 ;#˂
					dcb $F8,$08,$F8,$08,$E4,$F4,$08,$F8,$08,$F8,$1C,$0C ;#˂
					dcb $F8,$08,$F8,$08,$FC,$FC,$08,$F8,$08,$F8,$04,$04 ;#fP
					dcb $F8,$08,$F8,$08,$E4,$F4,$08,$F8,$08,$F8,$1C,$0C ;#f2
					dcb $00,$00,$F8,$08,$E4,$F4,$08,$F8,$08,$F8,$1C,$0C ;#ړ
VERT_DISP           dcb $F0,$F0,$00,$00,$E0,$E0 ;#p
					dcb $F0,$F0,$00,$00,$F4,$04 ;#1
					dcb $F0,$F0,$00,$00,$F0,$00 ;#
					dcb $F0,$F0,$00,$00,$06,$00 ;#
					dcb $F0,$F0,$00,$00,$10,$10 ;#
					dcb $F0,$F0,$00,$00,$06,$00 ;#E
					dcb $F0,$F0,$00,$00,$F0,$00 ;#E
					dcb $F0,$F0,$00,$00,$EA,$00 ;#E
					dcb $00,$00,$F0,$F0,$E0,$E0 ;#
					dcb $00,$00,$F0,$F0,$EA,$00 ;#
					dcb $F0,$F0,$00,$00,$E8,$E8 ;#Wv
					dcb $F0,$F0,$00,$00,$F1,$01 ;#k1
					dcb $F0,$F0,$00,$00,$F5,$05 ;#k2
					dcb $F0,$F0,$00,$00,$E9,$F9 ;#Uグ
					dcb $F4,$F4,$04,$04,$16,$06 ;#U艺
					dcb $F0,$F0,$00,$00,$12,$02 ;#^1
					dcb $F0,$F0,$00,$00,$12,$02 ;#^2
					dcb $F0,$F0,$00,$00,$0C,$1C ;#˂
					dcb $F0,$F0,$00,$00,$FD,$FD ;#˂
					dcb $F0,$F0,$00,$00,$0C,$1C ;#fP
					dcb $F0,$F0,$00,$00,$FD,$FD ;#fQ
					dcb $F0,$00,$00,$00,$0C,$1C ;#ړ
PROPERTIES          dcb $0F,$0F,$0F,$0F,$0F,$0F,$4F,$4F,$4F,$4F,$4F,$4F ;#p
					dcb $0F,$0F,$0F,$0F,$0E,$0E,$4F,$4F,$4F,$4F,$4E,$4E ;#1
					dcb $0F,$0F,$0F,$0F,$8E,$0E,$4F,$4F,$4F,$4F,$CE,$4E ;#
					dcb $0F,$0F,$0F,$0F,$CE,$CF,$4F,$4F,$4F,$4F,$8E,$8F ;#
					dcb $0E,$0E,$0E,$0E,$8E,$CE,$4E,$4E,$4E,$4E,$CE,$8E ;#
					dcb $0E,$0E,$0E,$0E,$8E,$8F,$4E,$4E,$4E,$4E,$CE,$CF ;#E
					dcb $4F,$4F,$4F,$4F,$CE,$4E,$0F,$0F,$0F,$0F,$8E,$0E ;#E
					dcb $4F,$4F,$4F,$4F,$0E,$4F,$0F,$0F,$0F,$0F,$4E,$0F ;#E
					dcb $CE,$CE,$CE,$CE,$0E,$4E,$8E,$8E,$8E,$8E,$4E,$0E ;#
					dcb $CE,$CE,$CE,$CE,$4E,$4F,$8E,$8E,$8E,$8E,$0E,$0F ;#
					dcb $0F,$0F,$0F,$0F,$0E,$0E,$4F,$4F,$4F,$4F,$4E,$4E ;#Wv
					dcb $0F,$0F,$0F,$0F,$0E,$0E,$4F,$4F,$4F,$4F,$4E,$4E ;#k1
					dcb $0F,$0F,$0F,$0F,$0E,$0E,$4F,$4F,$4F,$4F,$4E,$4E ;#k2
					dcb $0F,$0F,$0F,$0F,$4E,$4E,$4F,$4F,$4F,$4F,$0E,$0E ;#Uグ
					dcb $0F,$0F,$0F,$0F,$8E,$8E,$4F,$4F,$4F,$4F,$CE,$CE ;#U艺
					dcb $0F,$0F,$0F,$0F,$8F,$8F,$4F,$4F,$4F,$4F,$CF,$CF ;#^1
					dcb $0F,$0F,$0F,$0F,$8F,$8F,$4F,$4F,$4F,$4F,$CF,$CF ;#^2
					dcb $0F,$0F,$0F,$0F,$0E,$0E,$4F,$4F,$4F,$4F,$4E,$4E ;#˂
					dcb $0F,$0F,$0F,$0F,$0E,$0E,$4F,$4F,$4F,$4F,$4E,$4E ;#˂
					dcb $0F,$0F,$0F,$0F,$0F,$0F,$4F,$4F,$4F,$4F,$4F,$4F ;#fP
					dcb $0F,$0F,$0F,$0F,$0F,$0F,$4F,$4F,$4F,$4F,$4F,$4F ;#fQ
					dcb $0F,$0F,$0F,$0F,$0F,$0F,$4F,$4F,$4F,$4F,$4F,$4F ;#ړ


SUB_GFX             JSR GET_DRAW_INFO
					LDA $151C,x
					CMP #$77
					BNE SUB_GFX_2
					JSR SUB_GFX_T
					RTS
SUB_GFX_2			LDA $1602,x
					ASL A
					ASL A
					CLC
					ADC $1602,x
					ADC $1602,x
					STA $03
					LDA $157C,x
					EOR #$01
					STA $0F
					ASL A
					ASL A
					CLC
					ADC $0F
					ADC $0F
					STA $02
					
					PHX
                    LDX #$05                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START          PHX                     ; push, current tile
					TXA
					CLC
					ADC $03
					TAX
					
                    LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP,x         ; |
                    STA $0301,y             ; /
					
					LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /
					
					TXA
					CLC
					ADC $03
					ADC $02
					TAX
					
					LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP,x        ; |
                    STA $0300,y             ; /
					
					LDA PROPERTIES,x
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
					


                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$05                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
TILEMAP2             dcb $8E,$8C,$8E,$8C
					 dcb $8E,$AE,$8E,$AE
					 dcb $80,$A0,$80,$A0
					 dcb $A2,$82,$A2,$82
					 dcb $A2,$82,$A2,$82
HORIZ_DISP2          dcb $00,$00,$00,$00
					 dcb $00,$00,$00,$00
					 dcb $00,$00,$00,$00
					 dcb $02,$12,$FE,$EE
					 dcb $00,$10,$00,$F0
VERT_DISP2           dcb $00,$E0,$00,$E0
					 dcb $00,$F0,$00,$F0
					 dcb $F4,$04,$F4,$04
					 dcb $04,$04,$04,$04
					 dcb $12,$12,$12,$12
PROPERTIES2          dcb $08,$08,$08,$08
					 dcb $88,$88,$C8,$C8
					 dcb $08,$08,$48,$48
					 dcb $08,$08,$48,$48
					 dcb $88,$88,$C8,$C8

RETURN33			RTS
SUB_GFX_S           JSR GET_DRAW_INFO
					LDA $1602,x
					CMP #$10
					BEQ RETURN33
					ASL A
					ASL A
					STA $03
					LDA $157C,x
					EOR #$01
					ASL A
					STA $02
					LDA $1570,x
					STA $0F
					
					PHX
                    LDX $0F
LOOP_START2         PHX
					TXA
					CLC
					ADC $03
					ADC $02
					TAX

					LDA $01
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP2,x         ; |
                    STA $0301,y             ; /
					
					LDA TILEMAP2,x           ; \ store tile
                    STA $0302,y             ; /

                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP2,x        ; |
                    STA $0300,y             ; /

                    LDA PROPERTIES2,x
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties

					PLX
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START2

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA $0F
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
					
HORIZ_DISPT          dcb $00,$10,$00,$10,$00,$10
					 dcb $00,$F0,$00,$F0,$00,$F0
VERT_DISPT           dcb $F0,$F0,$00,$00,$10,$10
TILEMAPT             dcb $84,$86,$A4,$A6,$84,$86
PROPERTIEST          dcb $00,$00,$00,$00,$80,$80
					 dcb $40,$40,$40,$40,$C0,$C0


SUB_GFX_A           JSR GET_DRAW_INFO
					LDA $151C,x
					STA $02
					STZ $03
					LDA $157C,x
					BEQ SUB_GFX_A_2
					LDA #$06
					STA $03
SUB_GFX_A_2
					PHX
                    LDX #$05
LOOP_START2         LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISPT,x         ; |
                    STA $0301,y             ; /
					
					LDA TILEMAPT,x           ; \ store tile
                    STA $0302,y             ; /
					
					PHX
					TXA
					CLC
					ADC $03
					TAX
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISPT,x        ; |
                    STA $0300,y             ; /

                    LDA PROPERTIEST,x
					ORA $02
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
					PLX

                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START2

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$05                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
					
HORIZ_DISPB          dcb $F8,$F8,$08
VERT_DISPB           dcb $F0,$00,$00
TILEMAPB             dcb $0C,$2C,$2E

SUB_GFX_M           JSR GET_DRAW_INFO
					LDA $1558,x
					BNE SUB_GFX_M2
					LDA $15AC,x
					CMP #$20
					BCS SUB_GFX_M2
					LDA $15AC,x
					AND #$01
					BNE SUB_GFX_M2
					RTS
SUB_GFX_M2			PHX
                    LDX #$02                ; run loop 4 times, cuz 4 tiles per frame
LOOP_STARTB         LDA TILEMAPB,x           ; \ store tile
                    STA $0302,y             ; /
					
					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISPB,x         ; |
                    STA $0301,y             ; /
					
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISPB,x        ; |
                    STA $0300,y             ; /

                    LDA #$0F
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties

                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_STARTB

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$02                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
HORIZ_DISPT          dcb $F0,$00,$10,$F0,$00,$10,$F7,$07,$FF
VERT_DISPT           dcb $D8,$D8,$D8,$E8,$E8,$E8,$F8,$F8,$08
TILEMAPT             dcb $E0,$E2,$E4,$C6,$C8,$CA,$E6,$E8,$EA

SUB_GFX_T           PHX
                    LDX #$08
LOOP_STARTT         LDA TILEMAPT,x           ; \ store tile
                    STA $0302,y             ; /
					
					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISPT,x         ; |
                    STA $0301,y             ; /
					
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISPT,x        ; |
                    STA $0300,y             ; /

                    LDA #$06
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties

                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_STARTT

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$08
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					

HORIZ_DISPSHOT      dcb $10,$00,$F0,$F0,$00,$10
TILEMAPSHOT         dcb $C0,$C2,$C4
PROPETIESSHOT		dcb $4E,$0E

SUB_GFX_SHOT		JSR GET_DRAW_INFO
					STZ $03
					LDA $157C,x
					STA $02
					BEQ SUB_GFX_SHOT_2
					LDA #$03
					STA $03
SUB_GFX_SHOT_2		PHX
                    LDX #$02                ; run loop 4 times, cuz 4 tiles per frame
LOOP_STARTSHOT      LDA TILEMAPSHOT,x           ; \ store tile
                    STA $0302,y             ; /
					
					LDA $01                 ; |
                    STA $0301,y             ; /
					
					PHX
					TXA
					CLC
					ADC $03
					TAX
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISPSHOT,x        ; |
                    STA $0300,y             ; /

					LDX $02
					LDA PROPETIESSHOT,x
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties

					PLX
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_STARTSHOT

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$02                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS

HORIZ_DISPW          dcb $F8,$08,$F8,$08,$F8,$08
VERT_DISPW           dcb $E0,$E0,$F0,$F0,$00,$00
TILEMAPW             dcb $C6,$C8,$C6,$C8,$C6,$C8
					 dcb $E6,$E8,$E6,$E8,$E6,$E8

SUB_GFX_W           JSR GET_DRAW_INFO
					LDA $1570,x
					LSR A
					AND #$01
					ASL A
					STA $03
					ASL A
					CLC
					ADC $03
					STA $03
					PHX
                    LDX #$05                ; run loop 4 times, cuz 4 tiles per frame
LOOP_STARTW         LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISPW,x         ; |
                    STA $0301,y             ; /
					
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISPW,x        ; |
                    STA $0300,y             ; /
					
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILEMAPW,x           ; \ store tile
                    STA $0302,y 
					PLX

                    LDA #$06
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties

                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_STARTW

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$05                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					

SUB_GET_DIR         LDY #$00                
                    LDA $94                
                    SEC                     
                    SBC $E4,x               
                    STA $0F                 
                    LDA $95                 
                    SBC $14E0,x             
                    BPL LABEL16             
                    INY                     
LABEL16             RTS     


					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;GAGE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GAGE_CHECK			LDA $7FDE00 ;#}IHP
					CMP #$64
					BEQ GAGE_CHECK2
					LDA #$FC
					STA $7FFFE5
					LDA $7FDE00
					CMP #$0A
					BCC GAGE_CHECK_2
					LDA #$00
					STA $7FFFE6
					LDA $7FDE00
					STA $7FFFE7
GAGE_CHECK_LOOP		LDA $7FFFE7
					CMP #$0A
					BCC GAGE_CHECK2
					LDA $7FFFE6
					INC A
					STA $7FFFE6
					LDA $7FFFE7
					SEC
					SBC #$0A
					STA $7FFFE7
					BRA GAGE_CHECK_LOOP
GAGE_CHECK_2		STA $7FFFE7
					LDA #$FC
					STA $7FFFE6
					BRA GAGE_CHECK2
GAGE_CHECK2			LDA $7FDE01 ;#^iCgHP
					CMP #$64
					BEQ GAGE_CHECK_R
					LDA #$FC
					STA $7FFFED
					LDA $7FDE01
					CMP #$0A
					BCC GAGE_CHECK2_2
					LDA #$00
					STA $7FFFEE
					LDA $7FDE01
					STA $7FFFEF
GAGE_CHECK2_LOOP	LDA $7FFFEF
					CMP #$0A
					BCC GAGE_CHECK_R
					LDA $7FFFEE
					INC A
					STA $7FFFEE
					LDA $7FFFEF
					SEC
					SBC #$0A
					STA $7FFFEF
					BRA GAGE_CHECK2_LOOP
GAGE_CHECK2_2		STA $7FFFEF
					LDA #$FC
					STA $7FFFEE
GAGE_CHECK_R		RTS

GAGE_RESET			LDA #$01
					STA $7FFFDF
					LDA #$30
					STA $7FFFE0
					LDA #$31
					STA $7FFFE1
					LDA #$32
					STA $7FFFE2
					LDA #$33
					STA $7FFFE3
					LDA #$34
					STA $7FFFE4
					LDA #$01
					STA $7FFFE5
					LDA #$00
					STA $7FFFE6
					LDA #$00
					STA $7FFFE7
					LDA #$FC
					STA $7FFFE8
					LDA #$40
					STA $7FFFE9
					LDA #$41
					STA $7FFFEA
					LDA #$42
					STA $7FFFEB
					LDA #$42
					STA $7FFFEC
					LDA #$01
					STA $7FFFED
					LDA #$00
					STA $7FFFEE
					LDA #$00
					STA $7FFFEF
					RTS

HDMA_COLOR_RESET	LDA #$08
					STA $7FFB18
					LDA #$10
					STA $7FFB20
					LDA #$00
					STA $7FFB19
					LDA #$02
					STA $7FFB21
					LDA #$21
					STA $7FFB1A
					LDA #$22
					STA $7FFB22
					LDA #$00
					STA $7FFB1B
					STA $7FFB23
					LDA #$E2
					STA $7FFB1C
					LDA #$E3
					STA $7FFB24
					LDA #$7F
					STA $7FFB1D
					STA $7FFB25
					
					LDA #$01
					STA $7FE200
					STA $7FE300
					LDA #$00
					STA $7FE201
					LDA #$00
					STA $7FE301
					LDA #$00
					STA $7FE302
					LDA #$00
					STA $7FE202
					STA $7FE303
					RTS
					
THE_END				STZ $B6,x
					LDA $15AC,x
					CMP #$FE
					BEQ END_G
					CMP #$AF
					BEQ END_2
					CMP #$90
					BEQ END_G2
					CMP #$70
					BCS END_R
					LDA #$15
					STA $1602,x
					LDA #$C0
					STA $AA,x
					LDA $14D4,x
					BNE END_R
					LDA $D8,x
					CMP #$B0
					BCS END_R
					LDA #$06
					STA $71
					STZ $89
					STZ $88
					STZ $14C8,x
END_R				RTS
END_2				LDA #$14
					STA $1602,x
					LDA #$01
					STA $157C,x
					RTS
END_G2				JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					LDA #$20
					STA $1558,y
					RTS

END_G				LDA #$13
					STA $1602,x
					LDA #$C0
					STA $AA,x
					STZ $B6,x
					JSR GEN_SPRITE
					LDA $E4,x
					STA $00E4,y
					LDA $14E0,x
					STA $14E0,y
					LDA #$07
					STA $1504,y
					LDA #$99
					STA $1686,y
					LDA #$A0
					STA $00AA,y
					LDA #$F8
					STA $00B6,y
					LDA #$C8
					STA $151C,y
					JSR GEN_SPRITE
					LDA $E4,x
					STA $00E4,y
					LDA $14E0,x
					STA $14E0,y
					LDA #$07
					STA $1504,y
					LDA #$99
					STA $1686,y
					LDA #$B0
					STA $00AA,y
					LDA #$08
					STA $00B6,y
					LDA #$E8
					STA $151C,y
					RTS



HDMA_COLOR_CHECK	LDA $7FE302
					BNE COLOR_DEL
					RTS
COLOR_DEL			REP #$30
					LDA $7FE301
					SEC
					SBC.W #$0421
					STA $7FE301
					SEP #$30
					RTS
					
DAMAGE_CHECK		LDA $1497
					BNE RETURN278
					JSR SUB_DAMAGE_CHECK
					LDA $1497
					BNE RETURN278
					LDA $151C,x
					CMP #$77
					BEQ RETURN278
					JSL $01A7DC
					BCS LBL827
					RTS
LBL827				JSR SUB_DAMAGE_5
RETURN278			RTS
SUB_DAMAGE_CHECK	LDA $151C,x
					CMP #$77
					BNE LBL109
					JSR TRNED_DAMAGE
					RTS
LBL109				LDA $1602,x
					CMP #$11
					BNE LBL110
					JSR U_TUKI_DAMAGE
					RTS
LBL110				CMP #$12
					BNE LBL111
					JSR Y_TUKI_DAMAGE
					RTS
LBL111				CMP #$02
					BCC RETURN278
					CMP #$0A
					BCS RETURN278
					LDA $157C,x
					BEQ LBL120
					LDA $1602,x
					CMP #$02
					BNE LBL112
					JSR DAMAGE100
					RTS
LBL112				CMP #$03
					BNE LBL113
					JSR DAMAGE101
					RTS
LBL113				CMP #$04
					BNE LBL114
					JSR DAMAGE102
					RTS
LBL114				CMP #$05
					BNE LBL115
					JSR DAMAGE103
					RTS
LBL115				CMP #$06
					BNE LBL116
					JSR DAMAGE104
					RTS
LBL116				CMP #$07
					BNE LBL117
					JSR DAMAGE105
					RTS
LBL117				CMP #$08
					BNE LBL118
					JSR DAMAGE106
					RTS
LBL118				JSR DAMAGE107
					RTS
LBL120				LDA $1602,x
					CMP #$02
					BNE LBL121
					JSR DAMAGE104
					RTS
LBL121				CMP #$03
					BNE LBL122
					JSR DAMAGE103
					RTS
LBL122				CMP #$04
					BNE LBL123
					JSR DAMAGE102
					RTS
LBL123				CMP #$05
					BNE LBL124
					JSR DAMAGE101
					RTS
LBL124				CMP #$06
					BNE LBL125
					JSR DAMAGE100
					RTS
LBL125				CMP #$07
					BNE LBL126
					JSR DAMAGE107
					RTS
LBL126				CMP #$08
					BNE LBL127
					JSR DAMAGE106
					RTS
LBL127				JSR DAMAGE105
					RTS


Y_TUKI_DAMAGE		LDA $157C,x
					BNE Y_TUKI_1
					LDA $E4,x
					PHA
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					PHA
					ADC #$00
					STA $14E0,x
					BRA Y_TUKI_2
Y_TUKI_1			LDA $E4,x
					PHA
					SEC
					SBC #$10
					STA $E4,x
					LDA $14E0,x
					PHA
					SBC #$00
					STA $14E0,x
Y_TUKI_2			JSL $01A7DC
					BCC Y_TUKI_R
					JSR SUB_DAMAGE_20
Y_TUKI_R			PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS
					
U_TUKI_DAMAGE		LDA $D8,x
					PHA
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					PHA
					ADC #$00
					STA $14D4,x
					JSL $01A7DC
					BCC U_TUKI_R
					JSR SUB_DAMAGE_20
U_TUKI_R			PLA
					STA $14D4,x
					PLA
					STA $D8,x
					RTS


TRNED_DAMAGE		JSL $01A7DC
					BCC TRNED_D_2
					JSR SUB_DAMAGE_20
					RTS
TRNED_D_2			LDA $D8,x
					PHA
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					PHA
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					BCC TRNED_D_3
					JSR SUB_DAMAGE_20
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					RTS
TRNED_D_3			LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					BCC TRNED_D_4
					JSR SUB_DAMAGE_20
TRNED_D_4			PLA
					STA $14D4,x
					PLA
					STA $D8,x
					RTS
					
DAMAGE100			LDA $E4,x
					PHA
					SEC
					SBC #$08
					STA $E4,x
					LDA $14E0,x
					PHA
					SBC #$00
					STA $14E0,x
					JSL $01A7DC
					BCC DAMAGE100_R
					JSR SUB_DAMAGE_15
DAMAGE100_R			PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS
DAMAGE101			LDA $E4,x
					PHA
					SEC
					SBC #$08
					STA $E4,x
					LDA $14E0,x
					PHA
					SBC #$00
					STA $14E0,x
					LDA $D8,x
					PHA
					CLC
					ADC #$08
					STA $D8,x
					LDA $14D4,x
					PHA
					ADC #$00
					STA $14D4,x
					JSL $01A7DC
					BCC DAMAGE101_R
					JSR SUB_DAMAGE_15
DAMAGE101_R			PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS
DAMAGE102			LDA $D8,x
					PHA
					CLC
					ADC #$08
					STA $D8,x
					LDA $14D4,x
					PHA
					ADC #$00
					STA $14D4,x
					JSL $01A7DC
					BCC DAMAGE102_R
					JSR SUB_DAMAGE_15
DAMAGE102_R			PLA
					STA $14D4,x
					PLA
					STA $D8,x
					RTS
DAMAGE103			LDA $E4,x
					PHA
					CLC
					ADC #$08
					STA $E4,x
					LDA $14E0,x
					PHA
					ADC #$00
					STA $14E0,x
					LDA $D8,x
					PHA
					CLC
					ADC #$08
					STA $D8,x
					LDA $14D4,x
					PHA
					ADC #$00
					STA $14D4,x
					JSL $01A7DC
					BCC DAMAGE103_R
					JSR SUB_DAMAGE_15
DAMAGE103_R			PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS
DAMAGE104			LDA $E4,x
					PHA
					CLC
					ADC #$08
					STA $E4,x
					LDA $14E0,x
					PHA
					ADC #$00
					STA $14E0,x
					JSL $01A7DC
					BCC DAMAGE104_R
					JSR SUB_DAMAGE_15
DAMAGE104_R			PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS
DAMAGE105			LDA $E4,x
					PHA
					CLC
					ADC #$08
					STA $E4,x
					LDA $14E0,x
					PHA
					ADC #$00
					STA $14E0,x
					LDA $D8,x
					PHA
					SEC
					SBC #$08
					STA $D8,x
					LDA $14D4,x
					PHA
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					BCC DAMAGE105_R
					JSR SUB_DAMAGE_15
DAMAGE105_R			PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS
DAMAGE106			LDA $D8,x
					PHA
					SEC
					SBC #$08
					STA $D8,x
					LDA $14D4,x
					PHA
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					BCC DAMAGE106_R
					JSR SUB_DAMAGE_15
DAMAGE106_R			PLA
					STA $14D4,x
					PLA
					STA $D8,x
					RTS
DAMAGE107			LDA $E4,x
					PHA
					SEC
					SBC #$08
					STA $E4,x
					LDA $14E0,x
					PHA
					SBC #$00
					STA $14E0,x
					LDA $D8,x
					PHA
					SEC
					SBC #$08
					STA $D8,x
					LDA $14D4,x
					PHA
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					BCC DAMAGE107_R
					JSR SUB_DAMAGE_15
DAMAGE107_R			PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS

SUB_DAMAGE_5		LDA #$28
					STA $1DFC
					LDA #$40
					STA $1497
					LDA $7FDE00
					CMP #$06
					BCC CHECK_5_3
					LDA $7FDE00
					SEC
					SBC #$05
					STA $7FDE00
CHECK_5_R			RTS
CHECK_5_3			LDA #$00
					STA $7FDE00
					JSL $00F606 ;#
					LDA $7FD701
					TAY
					LDA #$00
					STA $14C8,y
					RTS
					
SUB_DAMAGE_15		LDA #$28
					STA $1DFC
					LDA #$40
					STA $1497
					LDA $7FDE00
					CMP #$10
					BCC CHECK_15_3
					LDA $7FDE00
					SEC
					SBC #$0F
					STA $7FDE00
CHECK_15_R			RTS
CHECK_15_3			LDA #$00
					STA $7FDE00
					JSL $00F606 ;#
					LDA $7FD701
					TAY
					LDA #$00
					STA $14C8,y
					RTS
					
SUB_DAMAGE_20		LDA #$28
					STA $1DFC
					LDA #$40
					STA $1497
					LDA $7FDE00
					CMP #$15
					BCC CHECK_20_3
					LDA $7FDE00
					SEC
					SBC #$14
					STA $7FDE00
CHECK_20_R			RTS
CHECK_20_3			LDA #$00
					STA $7FDE00
					JSL $00F606 ;#
					LDA $7FD701
					TAY
					LDA #$00
					STA $14C8,y
					RTS

