;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Orb
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
NEW_SPRITE_NUM = $7FAB9E
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					STZ $1602,x
					LDA $010B
					CMP #$FD
					BEQ INIT_2
                    RTL
INIT_2				LDA #$01
					STA $1504,x
					LDA #$FF
					STA $15AC,x
					JSR HDMA1
					RTL
                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HDMA1				LDA #$08
					STA $7FFB18
					LDA #$02
					STA $7FFB19
					LDA #$0F
					STA $7FFB1A
					LDA #$00
					STA $7FFB1B
					LDA #$E8
					STA $7FFB1C
					LDA #$7F
					STA $7FFB1D
					LDA #$01
					STA $7FE800
					LDA #$00
					STA $7FE801
					STA $7FE802
					STA $7FE803
					RTS

RETURN              RTS                    
START_HB_CODE       LDA $1504,x
					BEQ MAIN0
					LDA EXTRA_BITS,x
					AND #$04
					BNE MAIN1
					JSR KOOPA
					RTS
MAIN1				JSR SHENRONG
					RTS
MAIN0				JSR MAP_CHECK
					LDA $1602,x
					BEQ MAIN2
					STZ $14C8,x
					RTS
MAIN2				JSR SUB_GFX
					STZ $AA,x
					STZ $B6,x
					JSL $01A7DC
                    BCC RETURN
					JSR GET_ORB
                    RTS
					
MAP_CHECK			LDA $13BF
					CMP #$32
					BNE CHECK2
					LDA $0F49
					AND #$01
					BEQ CHECK_E
					LDA #$01
					STA $1602,x
					RTS
CHECK2				CMP #$40
					BNE CHECK3
					LDA $0F49
					AND #$02
					BEQ CHECK_E
					LDA #$01
					STA $1602,x
					RTS
CHECK3				CMP #$0B
					BNE CHECK4
					LDA $0F49
					AND #$04
					BEQ CHECK_E
					LDA #$01
					STA $1602,x
					RTS
CHECK4				CMP #$39
					BNE CHECK5
					LDA $0F49
					AND #$08
					BEQ CHECK_E
					LDA #$01
					STA $1602,x
					RTS
CHECK5				CMP #$2F
					BNE CHECK6
					LDA $0F49
					AND #$10
					BEQ CHECK_E
					LDA #$01
					STA $1602,x
					RTS
CHECK6				CMP #$1F
					BNE CHECK7
					LDA $0F49
					AND #$20
					BEQ CHECK_E
					LDA #$01
					STA $1602,x
					RTS
CHECK7				LDA $0F49
					AND #$40
					BEQ CHECK_E
					LDA #$01
					STA $1602,x
CHECK_E				RTS

GET_ORB				LDA #$15
					STA $1DFC
					LDA $13BF
					CMP #$32
					BNE GET2
					LDA $0F49
					ORA #$01
					STA $0F49
					RTS
GET2				CMP #$40
					BNE GET3
					LDA $0F49
					ORA #$02
					STA $0F49
					RTS
GET3				CMP #$0B
					BNE GET4
					LDA $0F49
					ORA #$04
					STA $0F49
					RTS
GET4				CMP #$39
					BNE GET5
					LDA $0F49
					ORA #$08
					STA $0F49
					RTS
GET5				CMP #$2F
					BNE GET6
					LDA $0F49
					ORA #$10
					STA $0F49
					RTS
GET6				CMP #$1F
					BNE GET7
					LDA $0F49
					ORA #$20
					STA $0F49
					RTS
GET7				LDA $0F49
					ORA #$40
					STA $0F49
					RTS
					
KOOPA				JSR SUB_GFX
					LDA $E4,x
					CMP #$50
					BEQ KOOPA1
					CMP #$90
					BEQ KOOPA2
					CMP #$30
					BEQ KOOPA3
					CMP #$B0
					BEQ KOOPA4
					CMP #$40
					BEQ KOOPA5
					CMP #$A0
					BEQ KOOPA6
					LDA #$40
					STA $0F
					BRA KOOPA7
KOOPA1				LDA #$01
					STA $0F
					BRA KOOPA7
KOOPA2				LDA #$02
					STA $0F
					BRA KOOPA7
KOOPA3				LDA #$04
					STA $0F
					BRA KOOPA7
KOOPA4				LDA #$08
					STA $0F
					BRA KOOPA7
KOOPA5				LDA #$10
					STA $0F
					BRA KOOPA7
KOOPA6				LDA #$20
					STA $0F
KOOPA7				LDA $0F49
					AND $0F
					BEQ KOOPA_DEL
					RTS
KOOPA_DEL			STZ $14C8,x
					RTS
					
SHENRONG			LDA $7EC102
					CMP #$77
					BNE SHENRONG_0
					LDA $7EC103
					CMP #$79
					BNE KOOPA_DEL
					JSR GEN_DOOR
					BRA KOOPA_DEL
SHENRONG_0			LDA #$06
					STA $212C
					LDA #$11
					STA $212D
					LDA $0F49
					AND #$7F
					CMP #$7F
					BNE SHENRONG_DEL
					LDA $1540,x
					BEQ SHENRONG_1
					JSR SUB_SHENRONG
					RTS
SHENRONG_1			LDA $15AC,x
					CMP #$C0
					BEQ SHENRONG2
					CMP #$BC
					BEQ SHENRONG3
					CMP #$90
					BEQ SHENRONG2
					CMP #$8C
					BEQ SHENRONG3
					CMP #$80
					BEQ SHENRONG2
					CMP #$7C
					BEQ SHENRONG3
					CMP #$7B
					BEQ SHENRONG4
					CMP #$70
					BEQ SHENRONG5
					BCS SHENRONG_R
					JSR SELECT
SHENRONG_R			RTS
SHENRONG_DEL		STZ $14C8,x
					RTS
					
SHENRONG2			LDA #$00
					STA $2121
					LDA #$FF
					STA $2122
					LDA #$7F
					STA $2122
					LDA #$18
					STA $1DFC
					RTS
SHENRONG3			LDA #$00
					STA $2121
					STA $2122
					STA $2122
					RTS
SHENRONG4			LDA #$F8
					STA $7FE801
					RTS
SHENRONG5			JSR MESSAGE
					LDA $13E0
					STA $7FE7E0
					LDA $13DF
					STA $7FE7DF
					LDA $76
					STA $7FE776
					RTS
					
SUB_SHENRONG		LDA $1540,x
					CMP #$F0
					BEQ SHENRONG2
					CMP #$EC
					BEQ SHENRONG3
					CMP #$C0
					BEQ SHENRONG2
					CMP #$BC
					BEQ SHENRONG3
					CMP #$B0
					BEQ SHENRONG2
					CMP #$AC
					BEQ SHENRONG3
					CMP #$A0
					BEQ SUB_SHENRONG2
					CMP #$80
					BEQ SUB_SHENRONG3
					RTS
SUB_SHENRONG2		LDA #$00
					STA $7FE801
					RTS
SUB_SHENRONG3		LDA #$77
					STA $7EC102
					LDA $1570,x
					BEQ SUB_SHENRONG4
					CMP #$01
					BEQ SUB_SHENRONG5
					CMP #$02
					BEQ SUB_SHENRONG6
					CMP #$03
					BEQ SUB_SHENRONG7
					RTS
SUB_SHENRONG4		LDA #$01
					STA $1426
					LDA #$77
					STA $7EC103
					RTS
SUB_SHENRONG5		LDA #$78
					STA $7EC103
					RTS
SUB_SHENRONG6		LDA #$79
					STA $7EC103
					RTS
SUB_SHENRONG7		LDA $19BA
					STA $19B8
					LDA $19DA
					STA $19D8
					LDA $1B95
					STA $1B93
					LDA #$06
					STA $71
					STZ $89
					STZ $88
					RTS
					
GEN_DOOR			LDA #$D0
					STA $9A
					LDA #$00
					STA $9B
					LDA #$60
					STA $98
					LDA #$01
					STA $99
					REP #$30 
                    LDA.W #$03DB
                    STA $03                 ;  |
                    JSL $2E8DF0
					SEP #$30
					LDA #$70
					STA $98
					REP #$30 
                    LDA.W #$03EB
                    STA $03                 ;  |
                    JSL $2E8DF0
					SEP #$30
					RTS
					
MESSAGE_TBL1		dcb $40,$07,$0E,$79,$54,$79,$5D,$4B,$79,$A6,$A6,$46,$A7,$88,$79,$42,$29,$11,$00,$11,$34,$0F,$3F
					dcb $17,$05,$79,$01,$09,$79,$13,$42,$23,$11,$05,$14,$03,$12,$3B,$3A,$02
					dcb $B1,$B3,$12,$79,$03,$36,$1B,$79,$05,$79,$01,$01
					dcb $01,$11,$12,$79,$35,$33,$12,$06,$15,$14,$39,$38
					dcb $63,$6B,$4C,$A7,$15,$11,$19,$79,$0A,$42
					dcb $49,$6B,$58,$7A,$18,$13,$09,$3A,$1E,$12,$79,$64,$A7,$88,$7A,$0B,$0F,$01
					dcb $48,$79,$69,$60,$15,$00,$01,$0F,$01
					
MESSAGE_TBL2		dcb $04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F,$10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A
					dcb $24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,$30,$31,$32,$33,$34
					dcb $44,$45,$46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F
					dcb $88,$89,$8A,$8B,$8C,$8D,$8E,$8F,$90,$91,$92,$93
					dcb $A8,$A9,$AA,$AB,$AC,$AD,$AE,$AF,$B0,$B1
					dcb $C8,$C9,$CA,$CB,$CC,$CD,$CE,$CF,$D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7,$D8,$D9
					dcb $E8,$E9,$EA,$EB,$EC,$ED,$EE,$EF,$F0,$FF
					
MESSAGE				LDA #$80
					STA $2115
					REP #$20
					LDA.W #$5900
					STA $00
MESSAGE_1			LDA $00
					STA $2116
					LDA.W #$211F
					STA $2118
					INC $00
					LDA $00
					CMP.W #$5A00
					BCC MESSAGE_1
					SEP #$20
					LDY #$00
MESSAGE_2			LDA MESSAGE_TBL1,y
					STA $00
					LDA #$21
					STA $01
					LDA MESSAGE_TBL2,y
					STA $02
					LDA #$59
					STA $03
					LDA #$80
					STA $2115
					REP #$20
					LDA $02
					STA $2116
					LDA $00
					STA $2118
					SEP #$20
					INY
					LDA MESSAGE_TBL2,y
					CMP #$FF
					BNE MESSAGE_2
					RTS
					
SELECT_TBL			dcb $87,$A7,$C7,$E7
SELECT				LDA $16
					ORA $18
					AND #$80
					BEQ SELECT_0
					LDA #$FF
					STA $1540,x
					LDA #$80
					STA $2115
					REP #$20
					LDA.W #$5900
					STA $00
SELECT_3			LDA $00
					STA $2116
					LDA.W #$20FC
					STA $2118
					INC $00
					LDA $00
					CMP.W #$5A00
					BCC SELECT_3
					SEP #$20
					RTS
SELECT_0			LDA $7FE7E0
					STA $13E0
					LDA $7FE7DF
					STA $13DF
					LDA $7FE776
					STA $76
					LDA #$02
					STA $18BD
					LDA #$80
					STA $2115
					REP #$20
					LDA.W #$5987
					STA $2116
					LDA.W #$211F
					STA $2118
					LDA.W #$59A7
					STA $2116
					LDA.W #$211F
					STA $2118
					LDA.W #$59C7
					STA $2116
					LDA.W #$211F
					STA $2118
					LDA.W #$59E7
					STA $2116
					LDA.W #$211F
					STA $2118
					SEP #$20
					LDA $16
					AND #$0C
					BEQ SELECT_2
					CMP #$04
					BEQ SELECT_1
					LDA $1570,x
					BEQ SELECT_2
					DEC $1570,x
					LDA #$23
					STA $1DFC
					BRA SELECT_2
SELECT_1			LDA $1570,x
					CMP #$03
					BCS SELECT_2
					INC $1570,x
					LDA #$23
					STA $1DFC
SELECT_2			LDA #$59
					STA $01
					LDA $1570,x
					TAY
					LDA SELECT_TBL,y
					STA $00
					REP #$20
					LDA $00
					STA $2116
					LDA.W #$212E
					STA $2118
					SEP #$20
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder 

                    PHX                     ; push sprite index

                    LDA $00                 ; \ tile x position = sprite x location ($00)
                    STA $0300,y             ; /                    
                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y             ; /
                                 
					LDA #$80
                    STA $0302,y             ; / 

                    LDA #$00
                    LDX $15E9               ;  |
                    ORA $15F6,x             ;  | get palette info
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties

                    PLX                     ; pull, X = sprite index
                    
                    LDY #$02
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /


