;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ottosei
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA $010B
					CMP #$45
					BEQ DARKMAN_INI
					LDA $E4,x
					ORA #$08
					STA $E4,x
					RTL
DARKMAN_INI			LDA #$91
					STA $1686,x
					PHP
					REP #$30
					LDA.W #$0200
					STA $7FDD00
					PLP
					LDA #$2C
					STA $1504,x
					STZ $1602,x
					RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                    
START_HB_CODE       LDA $010B
					CMP #$45
					BNE MAIN001
					JSR DARK_MAN
					RTS
MAIN001				LDA $1504,x
					BEQ MAIN
					JSR ICE
					RTS
MAIN				JSR SUB_GFX2
                    LDA $9D                 ; \ if sprites locked...
                    BNE RETURN              ; /    ... return
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA $C2,x
					BNE MODE2
					JSL $01802A
					LDA $14
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$01
					STA $1602,x
					JSR MARIO_CHECK
RETURN2				RTS
MODE2				LDA $15AC,x
					BEQ MODE2_4
					CMP #$1C
					BEQ MODE2_G1
					CMP #$14
					BEQ MODE2_G2
					CMP #$0C
					BEQ MODE2_G3
					CMP #$30
					BCS MODE2_1
					CMP #$28
					BCS MODE2_2
					CMP #$20
					BCS MODE2_3
					CMP #$18
					BCS MODE2_2
					STZ $1602,x
					RTS
MODE2_4				STZ $C2,x
					LDA #$01
					STA $7EC400
					LDA #$00
					STA $7EC401
					STA $7EC402
					RTS
MODE2_1				STZ $1602,x
					RTS
MODE2_2				LDA #$03
					STA $1602,x
					RTS
MODE2_3				LDA #$02
					STA $1602,x
					RTS
MODE2_G1			LDA #$C0
					STA $151C,x
					BRA MODE2_G
MODE2_G2			LDA #$C1
					STA $151C,x
					BRA MODE2_G
MODE2_G3			LDA #$D1
					STA $151C,x
MODE2_G				JSR GEN_SPRITE
					LDA #$30
					STA $15AC,y
					LDA $151C,x
					STA $151C,y
					LDA #$01
					STA $1504,y
					LDA #$95
					STA $1686,y
RETURN2				RTS

ICE					JSR SUB_GFX
                    LDA $9D                 ; \ if sprites locked...
                    BNE RETURN2              ; /    ... return
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA $15AC,x
					BEQ DELETE
					LDA #$30
					STA $B6,x
					STA $AA,x
					JSL $01802A
					RTS
DELETE				STZ $14C8,x
					RTS
					
MARIO_CHECK			JSL $01A7DC
					BCC CHECK_E
					LDA $7D
					CMP #$10
					BCC CHECK_E
					CMP #$80
					BCS CHECK_E
					LDA #$28
					STA $1DFC
					LDA #$B0
					STA $7D
					LDA #$F0
					STA $7B
					LDA #$40
					STA $15AC,x
					LDA #$01
					STA $C2,x
CHECK_E				RTS

POLE_OFFSET			dcb $FF,$FF,$01,$01,$01,$01,$01,$01,$01,$00,$01
					dcb $01,$01,$01,$01,$01,$01,$01,$01,$01,$02
					dcb $02,$01,$00,$02,$02,$02,$00,$01,$01,$01

DARK_MAN			LDA $1602,x
					BNE MOVE_MODE
STOP				STZ $144C
					LDA #$FF
					STA $144D
					REP #$30
					LDA $7FDD00
					STA $1468
					SEP #$30
					PHX
					LDA $1504,x
					TAX
					SEC
					SBC #$0E
					TAY
					LDA POLE_OFFSET,y
					STA $0F
					LDA $7FEE00,x
					CMP $0F
					BNE NO_MOVE
					PLX
					LDA #$20
					STA $1887
					LDA #$01
					STA $1602,x
DARK_MAN_R			RTS
NO_MOVE				PLX
					RTS
MOVE_MODE			LDA $1887
					BEQ MOVE_DWN
					CMP #$01
					BNE STOP2
					REP #$30
					LDA $7FDD00
					SEC
					SBC.W #$0010
					STA $7FDD00
					SEP #$30
					DEC $1504,x
					RTS
MOVE_DWN			LDA #$FC
					STA $144D
					REP #$30
					LDA $7FDD00
					CMP $1468
					BCC MOVE_CON
					SEP #$30
					PHX
					LDA $1504,x
					TAX
					SEC
					SBC #$0E
					TAY
					LDA POLE_OFFSET,y
					STA $0F
					LDA $7FEE00,x
					CMP $0F
					BNE MOVE_END
					PLX
					DEC $1504,x
					REP #$30
					LDA $7FDD00
					SEC
					SBC.W #$0010
					STA $7FDD00
					SEP #$30
					RTS
MOVE_CON			SEP #$30
					RTS
MOVE_END			PLX
					STZ $1602,x
					LDA #$09
					STA $1DFC
					RTS
STOP2				STZ $144C
					LDA #$FF
					STA $144D
					REP #$30
					LDA $7FDD00
					STA $1468
					SEP #$30
					RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generate routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN68            RTS     
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX

                    LDA $E4,x
					CLC
					ADC #$18
                    STA $00E4,y

                    LDA $14E0,x
					ADC #$00
                    STA $14E0,y             ; /

                    LDA $D8,x
					CLC
					ADC #$04
                    STA $00D8,y             ;  |
					LDA $14D4,x
					ADC #$00
                    STA $14D4,y             ; /

                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX                     ; / 
                    
RETURN67            RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP             dcb $80,$A0

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)

					LDA $151C,x
					STA $0302,y

					LDA $01
					STA $0301,y
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0300,y             ; /

					LDA #$08
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    LDY #$00                ; \ FF, because we wrote to 460
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
            
					
TILEMAP2            dcb $82,$84,$86,$A0,$A2,$A4,$A6
					dcb $8A,$8C,$8E,$A8,$AA,$AC,$AE
					dcb $C2,$C4,$C6,$E0,$E2,$E4,$E6
					dcb $CA,$CC,$CE,$80,$88,$EC,$C8
HORZ_DISP			dcb $F0,$00,$10,$E0,$F0,$00,$10
VERT_DISP			dcb $F4,$F4,$F4,$04,$04,$04,$04

SUB_GFX2            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
                    PHX                     ; push sprite index
					LDA $1602,x
					ASL A
					ASL A
					CLC
					ADC $1602,x
					ADC $1602,x
					ADC $1602,x
					STA $03

					LDX #$06
LOOP_START          LDA $00
					CLC
					ADC HORZ_DISP,x
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_DISP,x
					STA $0301,y
					
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILEMAP2,x           ; \ store tile
                    STA $0302,y
					PLX
					
					LDA #$0E
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties


                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$06                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /



