;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
NEW_SPRITE_NUM = $7FAB9E
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					STZ $15AC,x
					LDA $010B
					CMP #$4A
					BNE INIT_1
					STZ $1411
INIT_1				LDA EXTRA_BITS,x
					AND #$04
					BEQ INIT_RTL
					LDA #$02
					STA $1504,x
INIT_RTL			RTL
                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
START_HB_CODE		LDA $1504,x
					BNE MAIN1
					JSR CODE
					RTS
MAIN1				CMP #$01
					BNE MAIN2
					JSR GUS
					RTS
MAIN2				JSR IMO
					RTS
					
CODE				LDA $9D
					BNE CODE_R
					JSR SCROLL
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					STA $D8,x
					LDA $97
					STA $14D4,x
					LDA #$01
					STA $1404
					LDA $14AF
					BNE CODE_2
					REP #$20
					LDA $96
					CMP.W #$00C0
					BCS CODE_1
					LDA.W #$00C0
					STA $96
CODE_1				SEP #$20
					LDA $15AC,x
					BNE CODE_R
					LDA $16
					AND #$80
					BEQ CODE_R
					LDA #$06
					STA $1DF9
					JSR GEN_SPRITE
					LDA #$01
					STA $1504,y
					LDA #$40
					STA $15AC,y
					LDA #$C0
					STA $7D
					LDA #$10
					STA $15AC,x
CODE_R				RTS
CODE_2				JSR COLOUR
					LDA $15AC,x
					BNE CODE_R
					LDA #$06
					STA $1DF9
					JSR GEN_SPRITE
					LDA #$01
					STA $1504,y
					LDA #$18
					STA $15AC,y
					LDA #$C0
					STA $7D
					LDA #$08
					STA $15AC,x
					RTS
					
SCROLL				LDA $010B
					CMP #$4A
					BNE SCROLL_R
					REP #$20
					LDA $1464
					LSR A
					LSR A
					LSR A
					LSR A
					STA $1468
					SEP #$20
SCROLL_R			RTS

GUS					LDA #$A0
					STA $1602,x
					JSR SUB_GFX
					LDA $9D
					BNE GUS_R
					LDA $15AC,x
					BEQ GUS_DEL
					JSL $27FB02 ;SUB_OFF_SCREEN_HB
					LDA #$18
					STA $AA,x
					JSL $01801A
					JSR SPRITE_KILL
GUS_R				RTS
GUS_DEL				STZ $14C8,x
					RTS
					
IMO					LDA #$C0
					STA $1602,x
					JSR SUB_GFX
					LDA $9D
					BNE IMO_R
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					JSL $01A7DC
					BCC IMO_R
					LDA #$01
					STA $14AF
					LDA #$14
					STA $1DFC
					STZ $14C8,x
IMO_R				RTS

SPRITE_KILL			LDY #$00
					LDA $E4,x
					STA $00
					LDA $14E0,x
					STA $01
					LDA $D8,x
					STA $02
					LDA $14D4,x
					STA $03
SPRITE_KILL_L		LDA $14C8,y
					CMP #$08
					BCC SPRITE_KILL_3
					LDA $167A,y
					AND #$02
					BNE SPRITE_KILL_3
					LDA $00E4,y
					STA $0E
					LDA $14E0,y
					STA $0F
					REP #$20
					LDA $00
					SEC
					SBC $0E
					CMP.W #$0010
					BCC SPRITE_KILL_1
					CMP.W #$FFF0
					BCS SPRITE_KILL_1
					BRA SPRITE_KILL_3
SPRITE_KILL_1		SEP #$20
					LDA $00D8,y
					STA $0E
					LDA $14D4,y
					STA $0F
					REP #$20
					LDA $02
					SEC
					SBC $0E
					CMP.W #$0010
					BCC SPRITE_KILL_2
					CMP.W #$FFF0
					BCS SPRITE_KILL_2
					BRA SPRITE_KILL_3
SPRITE_KILL_2		SEP #$20
					LDA #$02
					STA $14C8,y
					LDA #$03
					STA $1DF9
SPRITE_KILL_3		SEP #$20
					INY
					CPY #$0A
					BCC SPRITE_KILL_L
					RTS
					
COLOUR				LDA $14
					AND #$0F
					BNE COLOUR_R
					REP #$20
					LDA $0701
					BEQ COLOUR_R2
					CMP.W #$0100
					BCC COLOUR_3
					CMP.W #$2020
					BCC COLOUR_2
					SEC
					SBC.W #$03FF
					STA $0701
COLOUR_R2			SEP #$20
COLOUR_R			RTS
COLOUR_2			SEC
					SBC.W #$0400
					STA $0701
					SEP #$20
					RTS
COLOUR_3			DEC $0701
					SEP #$20
					RTS


SUB_GFX             JSR GET_DRAW_INFO
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA $1602,x
					STA $0302,y
					LDA #$09
					ORA $64
					STA $0303,y
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
					
RETURN67            RTS
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
					LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

					LDA $D8,x
					CLC
					ADC #$18
                    STA $00D8,y             ;  |
                    LDA $14D4,x
					ADC #$00
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS

