;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Pumpkin
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"
					LDA #$0E
					STA $1570,x
					LDA #$02
					STA $1528,x
					LDA #$68
					STA $15AC,x
					STZ $14F8,x
					STZ $C2,x
                    RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                     ; return           
CODE_START          LDA $1528,x
					CMP #$01
					BEQ GFX2
					JSR SUB_GFX             ; graphics routine
					BRA MAIN
GFX2				JSR SUB_GFX2
MAIN				LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
					JSR SAVE_X
					JSL $01802A             ; update position based on speed values
					JSR CHECK_DAMAGE
					LDA $16
					BEQ MAIN1
					INC $151C,x
MAIN1				LDA $18
					BEQ MAIN2
					INC $1602,x
MAIN2				LDA $1528,x
					BNE NOT_MODE0
					JSR MODE0
					RTS
NOT_MODE0			CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$02
					;BNE NOT_MODE2
					JSR MODE2
					RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP             dcb $A0,$A2,$C0,$C2,$81

HORZ_DISP           dcb $F8,$08,$F8,$08,$00
VERT_DISP           dcb $00,$00,$10,$10,$F0

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder                
					PHX                     ; push sprite index
                    LDX #$04                ; loop counter = (number of tiles per frame) - 1
LOOP_START          PHX                     ; push current tile number
                    
                    
                    LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP,x         ;  |
                    STA $0300,y             ; /   set y position of the tile
					
					LDA $01                ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP,x         ;  |
                    STA $0301,y             ; /   set y position of the tile
                    
					LDA TILEMAP,x           ; \ store tile
                    STA $0302,y            ; / 
					
					LDA #$00
                    LDX $15E9               ;  |
                    ORA $1570,x             ;  | get palette info
					;ORA $64
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$04                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP2             dcb $C0,$C2,$A0,$A2,$81

HORZ_DISP2           dcb $F8,$08,$F8,$08,$00
VERT_DISP2           dcb $00,$00,$10,$10,$20

SUB_GFX2             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder                
					PHX                     ; push sprite index
                    LDX #$04                ; loop counter = (number of tiles per frame) - 1
LOOP_START2          PHX                     ; push current tile number
                    
                    
                    LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP2,x         ;  |
                    STA $0300,y             ; /   set y position of the tile
					
					LDA $01                ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP2,x         ;  |
                    STA $0301,y             ; /   set y position of the tile
                    
					LDA TILEMAP2,x           ; \ store tile
                    STA $0302,y            ; / 
					
					LDA #$80
                    LDX $15E9               ;  |
                    ORA $1570,x             ;  | get palette info
					;ORA $64
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START2          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$04                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ETC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X_POS				dcb $48,$88,$A8,$28,$C8,$78,$98,$68
X_POS2				dcb $D0,$30,$70,$50,$B0,$A0,$90,$80

MODE_DEC			STZ $C2,x
					LDA $1570,x
					CMP #$0E
					BNE DEC2
					LDA $7FFEE1
					PHX
					TAX
					LDA $14C8,x
					BNE DEC1_2
					PLX
					LDA #$70
					STA $E4,x
					LDA #$01
					STA $14D4,x
					LDA #$70
					STA $D8,x
					LDA #$02
					STA $1528,x
					LDA #$68
					STA $15AC,x
					RTS
DEC1_2				PLX
					BRA DEC_MAIN
DEC2				LDA $7FFEE0
					PHX
					TAX
					LDA $14C8,x
					BNE DEC2_2
					PLX
					LDA #$70
					STA $E4,x
					LDA #$01
					STA $14D4,x
					LDA #$70
					STA $D8,x
					LDA #$02
					STA $1528,x
					LDA #$68
					STA $15AC,x
					RTS
DEC2_2				PLX
DEC_MAIN			LDA $1570,x
					CMP #$0E
					BNE MODE_DEC_2
					LDA $151C,x
					CLC
					ADC $94
					CLC
					ADC $13
					AND #$0F
					LSR A
					PHX
					TAX
					LDA X_POS,x
					PLX
					STA $E4,x
					LDA $94
					SEC
					SBC $13
					AND #$01
					BEQ MODE_DEC2
					STZ $1528,x
					LDA #$01
					STA $14D4,x
					LDA #$70
					STA $D8,x
					RTS
MODE_DEC_2			LDA $94
					LSR A
					CLC
					ADC $1602,x
					SEC
					SBC $13
					AND #$0F
					LSR A
					PHX
					TAX
					LDA X_POS2,x
					PLX
					STA $E4,x
					LDA $94
					LSR A
					CLC
					ADC $13
					AND #$01
					BEQ MODE_DEC2
					STZ $1528,x
					LDA #$01
					STA $14D4,x
					LDA #$70
					STA $D8,x
					RTS
MODE_DEC2			LDA #$01
					STA $1528,x
					STZ $14D4,x
					LDA #$B0
					STA $D8,x
					RTS
					
SAVE_X				LDA $1570,x
					CMP #$0E
					BNE SAVE_X2
					TXA
					STA $7FFEE0
					RTS
SAVE_X2				TXA
					STA $7FFEE1
					RTS

MODE0				LDA $15AC,x
					BEQ MODE0_0
					STZ $AA,x
					RTS
MODE0_0				LDA $14D4,x
					BEQ MODE0_UP
					LDA $D8,x
					CMP #$40
					BCC MODE0_DOWN2
					LDA #$F8
					STA $AA,x
					RTS
MODE0_DOWN2			LDA #$E0
					STA $AA,x
					RTS
MODE0_UP			LDA $D8,x
					CMP #$F0
					BCC MODE0_UP2
					LDA #$E0
					STA $AA,x
					RTS
MODE0_UP2			CMP #$C0
					BCC MODE0_END
					LDA #$F8
					STA $AA,x
					RTS
MODE0_END			LDA #$43
					STA $15AC,x
					JSR MODE_DEC
					RTS
					
MODE1				LDA $15AC,x
					BEQ MODE1_0
					STZ $AA,x
					RTS
MODE1_0				LDA $14D4,x
					BEQ MODE1_UP
					LDA $D8,x
					CMP #$30
					BCC MODE1_DOWN2
					CMP #$60
					BCS MODE1_END
					LDA #$08
					STA $AA,x
					RTS
MODE1_DOWN2			LDA #$20
					STA $AA,x
					RTS
MODE1_UP			LDA $D8,x
					CMP #$E0
					BCC MODE1_UP2
					LDA #$20
					STA $AA,x
					RTS
MODE1_UP2			LDA #$08
					STA $AA,x
					RTS
MODE1_END			LDA #$4D
					STA $15AC,x
					JSR MODE_DEC
					RTS
					
MODE2				STZ $AA,x
					LDA $15AC,x
					BEQ MODE2_E
					CMP #$29
					BCS MODE2_UP
					CMP #$28
					BEQ MODE2_GEN
					LDA $1570,x
					CMP #$0E
					BNE MODE2_2
					LDA #$F0
					STA $B6,x
					RTS
MODE2_2				LDA #$10
					STA $B6,x
					RTS
MODE2_E				STZ $B6,x
					STZ $1528,x
					RTS
MODE2_UP			LDA #$F0
					STA $AA,x
					RTS
MODE2_GEN			JSR SAME_GEN
					LDA #$00
					STA $14F8,y
					STA $00C2,y
					LDA #$02
					STA $1528,y
					LDA #$28
					STA $15AC,y
					LDA #$10
					STA $1DF9
					LDA $1570,x
					CMP #$0E
					BEQ MODE2_GEN2
					LDA #$0E
					STA $1570,y
					RTS
MODE2_GEN2			LDA #$0C
					STA $1570,y
					RTS

CHECK_DAMAGE		LDA $C2,x
					BEQ CHECK2
					RTS
CHECK2				LDA $14D4,x
					PHA
					LDA $D8,x
					PHA
					LDA #$60
					SEC
					SBC $D8,x
					STA $D8,x
					STZ $14D4,x
					JSL $01A7DC
					BCC NO_DAMAGE
					LDA $1528,x
					CMP #$01
					BEQ ENE_WINS
					LDA $7D
					CMP #$10
					BMI ENE_WINS
					LDA #$01
					STA $C2,x
					JSL $01AA33             ; set mario speed
					INC $14F8,x
					LDA $14F8,x
					CMP #$03
					BEQ THEEND
					LDA #$20
                    STA $1DF9
NO_DAMAGE			PLA
					STA $D8,x
					PLA
					STA $14D4,x
					RTS

ENE_WINS            LDA $1497               ; \ if mario is invincible...
                    BNE RETURN2             ; /   ... return
					LDA $14D4,x
					BNE LBL002
					LDA $D8,x
					CMP #$90
					BCS RETURN2
LBL002              JSL $00F5B7             ; hurt mario
RETURN2             BRA NO_DAMAGE

THEEND				LDA $1570,x
					CMP #$0E
					BNE THEEND2
					LDA $7FFEE1
					PHX
					TAX
					LDA $14C8,x
					PLX
					CMP #$00
					BNE THEEND3
					LDA #$0B
                    STA $1DFB
					LDA #$01
					STA $141C
                    LDA #$FF
                    STA $1493
					BRA THEEND3
THEEND2				LDA $7FFEE0
					PHX
					TAX
					LDA $14C8,x
					PLX
					CMP #$00
					BNE THEEND3
					LDA #$0B
                    STA $1DFB
					LDA #$01
					STA $141C
                    LDA #$FF
                    STA $1493
THEEND3				PLA
					STA $D8,x
					PLA
					STA $14D4,x
					LDA #$08
                    STA $1DF9
					STZ $14C8,x
					JSR SUB_SMOKE2
					RTS

SUB_SMOKE2          LDY #$03                ; \ find a free slot to display effect
FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
                    RTS                     ; / return if no slots open
FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    LDA $178B,x
                    STA $17C4,y             ; /
                    LDA #$1B                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $E4,x             ; \ load generator x position
                    STA $17C8,y             ; /
                    RTS                    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


RETURN67            RTS
SAME_GEN            JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
					TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
                    LDA $E4,x               ;\ set x position for new sprite
                    STA $00E4,y

                    LDA $14E0,x             ;  |
                    STA $14E0,y             ; /

                    LDA $D8,x               ;\ set y position for new sprite
                    STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return

