;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Rabi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"
                    PHY
                    JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
                    PLY
					LDA EXTRA_BITS,x
					AND #$04
					BNE INIT_2
					LDA #$0D
					STA $151C,x
					LDA #$FF
					STA $15AC,x
					JSR HDMA_COLOR
					JSR HDMA_HOR
					RTL
INIT_2				LDA #$09
					STA $167A,x
					LDA #$0B
					STA $166E,x
					LDA #$60
					STA $15AC,x
					LDA #$0D
					STA $151C,x
					LDA $E4,x
					AND #$10
					BEQ INIT_E
					LDA #$0F
					STA $151C,x
INIT_E              RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X_SPEED             dcb $0C,$F4
X_SPEED2            dcb $30,$D0

RETURN              RTS
CODE_START          JSR SUB_GFX
					LDA $14C8,x             ; \ 
					BEQ RETURN
                    CMP #$02                ;  | if status != 8, return
                    BEQ RETURN
					LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
					LDA EXTRA_BITS,x
					AND #$04
					BEQ BLACK
					
                    JSL $27FAF4 ;SUB_OFF_SCREEN_X0
                    JSL $01802A
					JSL $01A7DC				 ; check for mario/sprite contact
					JSR N_MODE0
					RTS
					
BLACK				LDA #$00
					STA $00212C
					LDA #$1F
					STA $00212D
					LDA $16
					BNE BLACK0
					LDA $18
					BNE BLACK0
					BRA BLACK1
BLACK0				INC $1594,x
BLACK1
					JSR DIRECTION_CHECK
					JSL $01802A
					LDA $C2,x
					BNE NOT_B_MODE0
					JSR B_MODE0
					RTS
NOT_B_MODE0			CMP #$01
					BNE NOT_B_MODE1
					JSR B_MODE1
					RTS
NOT_B_MODE1			CMP #$02
					BNE NOT_B_MODE2
					JSR B_MODE2
					RTS
NOT_B_MODE2			CMP #$03
					BNE NOT_B_MODE3
					JSR B_MODE3
					RTS
NOT_B_MODE3			CMP #$04
					BNE NOT_B_MODE4
					JSR B_MODE4
					RTS
NOT_B_MODE4			CMP #$01
					;BNE NOT_B_MODE5
					JSR B_MODE5
					RTS

N_MODE0				LDA $1588,x
					AND #$03
					BEQ N_MODE0_0
					LDA $157C,x
					EOR #$01
					STA $157C,x
N_MODE0_0			JSR IMAGE_CHECK1
					LDA $15AC,x
					CMP #$30
					BCC N_MODE0_2
					LDA $1588,x
					AND #$04
					BNE N_MODE0_1
					LDA #$08
					STA $1558,x
					LDY $157C,x
					LDA X_SPEED1,y
					STA $B6,x
					RTS
N_MODE0_1			LDA $1558,x
					BNE MODE0_2
					LDA #$D0
					STA $AA,x
					RTS
N_MODE0_2			LDA $1588,x
					AND #$04
					BEQ N_MODE_R
					STZ $B6,x
					STZ $1602,x
					LDA $15AC,x
					BNE N_MODE_R
					LDA #$60
					STA $15AC,x
N_MODE_R			RTS



X_SPEED1			dcb $08,$F8

B_MODE0				JSR IMAGE_CHECK1
					JSR DAMAGE_CHECK
					LDA $1570,x
					BEQ MODE0_3
					LDA #$F0
					STA $15AC,x
MODE0_3				LDA $15AC,x
					CMP #$40
					BCS MODE0_0
					JSR MODE_CHANGE
					RTS
MODE0_0				LDA $1588,x
					AND #$04
					BNE MODE0_1
					LDA #$08
					STA $1558,x
					LDY $157C,x
					LDA X_SPEED1,y
					STA $B6,x
					RTS
MODE0_1				LDA $1558,x
					BNE MODE0_2
					LDA #$D0
					STA $AA,x
					RTS
MODE0_2				STZ $B6,x
					RTS
					
B_MODE1				LDA #$04
					STA $1602,x
					LDA $15AC,x
					CMP #$E0
					BEQ MODE1_G
					CMP #$C0
					BEQ MODE1_2
					RTS
MODE1_2				LDA #$FF
					STA $15AC,x
					STZ $C2,x
					RTS
MODE1_G				JSR DEAMON_NUM
					;CPY #$02
					;BCS MODE1_R
					;CPY #$01
					;BEQ MODE1_3
					CPY #$00
					BNE MODE1_R
					;JSR GEN_SPRITE
					;LDA #$01
					;STA $157C,y
					;LDA #$40
					;STA $151C,y
MODE1_3				JSR GEN_SPRITE
					;LDA #$00
					;STA $157C,y
					LDA $157C,x
					STA $157C,y
					LDA #$C0
					STA $151C,y
					LDA #$89
					STA $167A,y
MODE1_R				RTS

B_MODE2				JSR IMAGE_CHECK2
					LDA $1588,x
					AND #$04
					BNE B_MODE2_0
					JSR DAMAGE_CHECK2
B_MODE2_0			LDA $15AC,x
					CMP #$FE
					BNE MODE2_2
					LDA #$B0
					STA $AA,x
MODE2_R				RTS
MODE2_2				LDA $1588,x
					AND #$04
					BEQ MODE2_R
					LDA #$FF
					STA $15AC,x
					STZ $C2,x
					RTS
B_MODE3				LDA $15AC,x
					CMP #$30
					BEQ MODE3_0
					CMP #$FE
					BEQ MODE3_4
					CMP #$80
					BEQ MODE3_1
					CMP #$80
					BCS MODE3_2
					LDA $1588,x
					AND #$04
					BNE B_MODE3_7
					JSR DAMAGE_CHECK2
B_MODE3_7			LDA #$07
					STA $1602,x
					LDA $1588,x
					AND #$04
					BNE MODE3_6
					LDA #$40
					STA $AA,x
					RTS
MODE3_0				LDA #$FF
					STA $15AC,x
					STZ $C2,x
					RTS
MODE3_1				LDA #$2B
					STA $1DFC
					RTS
MODE3_4				LDA #$08
					STA $1DFC
					RTS
MODE3_6				LDA #$05
					STA $1602,x
					RTS
MODE3_2				LDA #$06
					STA $1602,x
					LDA $14D4,x
					BNE MODE3_3
					LDA $D8,x
					CMP #$A0
					BCS MODE3_3
					STZ $AA,x
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					RTS
MODE3_3				LDA #$C0
					STA $AA,x
					RTS
B_MODE4				LDA #$04
					STA $1602,x
					LDA $7FE301
					CMP #$FF
					BNE MODE4_1
					LDA $1558,x
					BNE MODE4_R
					PHP
					REP #$30
					LDA.W #$0000
					STA $7FE301
					STA $7FE001
					STA $7FE101
					STA $7FE004
					STA $7FE104
					STA $7FE007
					STA $7FE107
					PLP
					LDA #$01
					STA $1570,x
					LDA #$FF
					STA $15AC,x
					STZ $C2,x
MODE4_R				RTS
MODE4_1				LDA #$20
					STA $1558,x
					PHP
					REP #$30
					LDA $7FE001
					CLC
					ADC.W #$0002
					STA $7FE001
					STA $7FE101
					STA $7FE007
					STA $7FE107
					LDA $7FE004
					SEC
					SBC.W #$0002
					STA $7FE004
					STA $7FE104
					PLP
					LDA $14
					AND #$01
					BNE B_MODE4_R
					PHP
					REP #$30
					LDA $7FE301
					CLC
					ADC.W #$0421
					STA $7FE301
					PLP
B_MODE4_R			RTS
B_MODE5				STZ $B6,x
					LDA #$01
					STA $1570,x
					LDA $15AC,x
					CMP #$C0
					BEQ MODE5_2
					RTS
MODE5_2				PHP
					SEP #$30
					LDA #$06
					STA $71
					STZ $89
					STZ $88
					PLP
					STZ $14C8,x
					RTS


					
MODE_CHANGE			LDA $15AC,x
					BNE CHANGE_1
					LDA $94
					CLC
					ADC $1598,x
					AND #$03
					CLC
					ADC #$01
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					RTS
CHANGE_1			STZ $B6,x
					LDA $14
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$01
					CLC
					ADC #$05
					STA $1602,x
					RTS
					
DEL_DEAMON			PHX
					LDX #$00
DEL_NUM				LDA NEW_SPRITE_NUM,x
					CMP #$64
					BNE NUM_3
					STZ $14C8,x
NUM_3				INX
					CPX #$0A
					BNE DEL_NUM
					PLX
					RTS

DEAMON_NUM			LDY #$00
					PHX
					LDX #$00
LOOP_NUM			LDA NEW_SPRITE_NUM,x
					CMP #$64
					BNE NUM_2
					LDA $14C8,x
					CMP #$08
					BNE NUM_2
					INY
NUM_2				INX
					CPX #$0A
					BNE LOOP_NUM
					PLX
					RTS

IMAGE_CHECK1		LDA $1588,x
					AND #$04
					BNE ON_GROUND
					LDA $AA,x
					CMP #$80
					BCS AIR_UP
					LDA #$03
					STA $1602,x
					RTS
AIR_UP				LDA #$02
					STA $1602,x
					RTS
ON_GROUND			LDA #$01
					STA $1602,x
					RTS
					
IMAGE_CHECK2		LDA $14
					LSR A
					LSR A
					LSR A
					AND #$03
					CMP #$01
					BEQ IMAGE_CHECK2_1
					CMP #$02
					BEQ IMAGE_CHECK2_2
					CMP #$03
					BEQ IMAGE_CHECK2_3
					LDA #$08
					STA $1602,x
					LDA #$01
					STA $157C,x
					RTS
IMAGE_CHECK2_1		LDA #$0A
					STA $1602,x
					RTS
IMAGE_CHECK2_2		LDA #$08
					STA $1602,x
					STZ $157C,x
					RTS
IMAGE_CHECK2_3		LDA #$09
					STA $1602,x
					RTS

DAMAGE_CHECK2		JSL $01A7DC
					BCC RETURN22
					BRA ENE_WINS
DAMAGE_CHECK		LDA $1540,x
					BNE RETURN22
					JSL $01A7DC
					BCC RETURN22
					LDA $7D
					CMP #$80
					BCS ENE_WINS
					CMP #$10
					BCC ENE_WINS
					STZ $1570,x
					LDA #$B0
					STA $7D
					JSL $01AB99             ; display contact graphic
					LDA #$20
                    STA $1DF9
					INC $1528,x
					LDA $1528,x
					CMP #$10
					BCS WIN2
					LDA #$60
					STA $1540,x
					RTS
WIN2				LDA #$1E
					STA $1DFB
					LDA #$FF
					STA $15AC,x
					LDA #$05
					STA $C2,x
					JSR DEL_DEAMON
					JSR SUB_SMOKE
					RTS
ENE_WINS            LDA $1497               ; \ if mario is invincible...
                    BNE RETURN22             ; /   ... return
                    JSL $00F5B7             ; hurt mario
RETURN22            RTS


DIRECTION_CHECK		LDA $14E0,x
					CMP #$FF
					BEQ TURN_RIGHT
					CMP #$01
					BEQ TURN_LEFT
					LDA $E4,x
					CMP #$F0
					BCS TURN_LEFT
					CMP #$10
					BCC TURN_RIGHT
					RTS
TURN_RIGHT			STZ $157C,x
					RTS
TURN_LEFT			LDA #$01
					STA $157C,x
					RTS
					
SUB_SMOKE           LDY #$03                ; \ find a free slot to display effect
FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
                    RTS                     ; / return if no slots open
FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    ;LDA $178B,x
					LDA $D8,x 
                    STA $17C4,y             ; /
                    LDA #$1B                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $E4,x             ; \ load generator x position
                    STA $17C8,y             ; /
                    RTS          
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HORIZ_DISP          dcb $F8,$08,$F8,$08,$08,$F8,$08,$F8
HORIZ_DISP2         dcb $00,$00,$00,$00
VERT_DISP           dcb $F0,$F0,$00,$00
TILEMAP             dcb $8A,$8A,$80,$82,$8A,$8A,$A0,$A2,$84,$8A,$A4,$8A,$88,$8A,$A8,$AA
					dcb $8C,$8E,$AC,$AE,$8A,$8A,$C0,$C2,$8A,$8A,$E0,$E2,$C4,$C6,$E4,$E6
					dcb $C8,$CA,$E8,$EA,$CC,$CE,$EC,$EE,$CC,$CE,$86,$A6
PROPERTIES          dcb $00,$40


SUB_GFX             JSR GET_DRAW_INFO
					
					LDA $1570,x
					BNE GFX_R
					LDA $1540,x
					AND #$01
					BEQ GFX2
GFX_R				RTS 
GFX2				LDA $157C,x
					STA $02
					PHX
					LDX $02
					LDA PROPERTIES,x
					PLX
					ORA $151C,x
					STA $0F
					LDA $02
					ASL A
					ASL A
					STA $02
					
					LDA $1602,x
					ASL A
					ASL A
					STA $03
					PHX
                    LDX #$03                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START          PHX                     ; push, current tile

					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP,x         ; |
                    STA $0301,y             ; /

					LDA $03
					CMP #$08
					BEQ GFX3
					PHX
					TXA
					CLC
					ADC $02
					TAX
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP,x        ; |
                    STA $0300,y             ; /
                    PLX
					BRA GFX4
					
GFX3				LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP2,x        ; |
                    STA $0300,y             ; /
                    
GFX4				PHX
					TXA
					CLC
					ADC $03
					TAX
                    LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /
					PLX

					LDA $0F
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties


                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RETURN67            RTS
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA #$64
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
					LDA $E4,x
                    STA $00E4,y
                    LDA $14E0,x
                    STA $14E0,y             ; /

					LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$8C
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817                ; Y = 1 if contact

SUB_GET_DIR         LDY #$00                
                    LDA $94                
                    SEC                     
                    SBC $E4,x               
                    STA $0F                 
                    LDA $95                 
                    SBC $14E0,x             
                    BPL LABEL16             
                    INY                     
LABEL16             RTS                     


HDMA_COLOR			LDA #$08
					STA $7FFB18
					LDA #$10
					STA $7FFB20
					LDA #$00
					STA $7FFB19
					LDA #$02
					STA $7FFB21
					LDA #$21
					STA $7FFB1A
					LDA #$22
					STA $7FFB22
					LDA #$00
					STA $7FFB1B
					STA $7FFB23
					LDA #$E2
					STA $7FFB1C
					LDA #$E3
					STA $7FFB24
					LDA #$7F
					STA $7FFB1D
					STA $7FFB25
					
					LDA #$01
					STA $7FE200
					STA $7FE300
					LDA #$00
					STA $7FE201
					LDA #$00
					STA $7FE301
					LDA #$00
					STA $7FE302
					LDA #$00
					STA $7FE202
					STA $7FE303
					RTS
					
HDMA_HOR			LDA #$20
					STA $7FFB28
					LDA #$40
					STA $7FFB30
					LDA #$02
					STA $7FFB29
					STA $7FFB31
					LDA #$0D
					STA $7FFB2A
					LDA #$0F
					STA $7FFB32
					LDA #$00
					STA $7FFB2B
					STA $7FFB33
					LDA #$E0
					STA $7FFB2C
					LDA #$E1
					STA $7FFB34
					LDA #$7F
					STA $7FFB2D
					STA $7FFB35
					
					LDA #$50
					STA $7FE000
					STA $7FE100
					LDA #$00
					STA $7FE001
					STA $7FE002
					STA $7FE101
					STA $7FE102
					LDA #$50
					STA $7FE003
					STA $7FE103
					LDA #$00
					STA $7FE004
					STA $7FE005
					STA $7FE104
					STA $7FE105
					LDA #$50
					STA $7FE006
					STA $7FE106
					LDA #$00
					STA $7FE007
					STA $7FE008
					STA $7FE107
					STA $7FE108
					LDA #$00
					STA $7FE009
					STA $7FE109
					RTS






