;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ottosei
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA $010B
					CMP #$41
					BEQ FLOOR_INIT
					LDA EXTRA_BITS,x
					AND #$04
					BNE GAGE_INIT
					LDA #$01
					STA $157C,x
					RTL
FLOOR_INIT			LDA #$15
					STA $1686,x
					LDA #$38
					STA $166E,x
					LDA #$83
					STA $167A,x
					LDA #$40
					STA $190F,x
					LDA $D8,x
					SEC
					SBC #$08
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					RTL
GAGE_INIT			LDA #$83
					STA $167A,x
					LDA #$38
					STA $166E,x
					LDA #$40
					STA $190F,x
					LDA $D8,x
					SEC
					SBC #$01
					STA $D8,x
					LDA $E4,x
					AND #$10
					BEQ MYLIFE_INIT
					LDA #$8E
					STA $151C,x
					TXA
					STA $7FFD00
					RTL
MYLIFE_INIT			LDA #$8C
					STA $151C,x
					TXA
					STA $7FFD01
					RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GAGE_MAIN			JSR SUB_GFX
					LDA $9D
					BNE GAGE_R
GAGE_R				RTS

RETURN              RTS                    
START_HB_CODE       LDA $C2,x
					CMP #$99
					BEQ MAINWW
					LDA $7FFEE0
					CMP #$99
					BEQ TIUN_WILY
					LDA $010B
					CMP #$82
					BNE MAIN1001
TIUN_WILY			JSR TIUNW
					RTS
MAIN1001			CMP #$41
					BEQ MAIN9
					BRA MAIN10
MAIN9				JSR FLOOR
					RTS
MAIN10				CMP #$3F
					BEQ MAIN4
					JSR M_RING
					RTS
MAIN4				LDA EXTRA_BITS,x
					AND #$04
					BNE GAGE_MAIN
					LDA $1504,x
					CMP #$02
					BNE MAIN1
					JSR RING
					RTS
MAIN1				CMP #$03
					BNE MAIN3
MAINWW				JSR TIUN
					RTS
MAIN3				JSR SUB_GFX2
					LDA $9D
					BNE RETURN
					LDA $1504,x
					CMP #$01
					BNE MAIN0
					JSR DAMAGE_GRA
					RTS
MAIN0				LDA #$FC
					STA $1745
					STA $1746
					LDA #$03
					STA $19
					LDA #$01
					STA $14AF
					JSR DAMAGE_CHECK
					JSR MARIO_CHECK
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSR MARIO_CHECK
					LDA $D8,x
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					LDA $E4,x
					STA $7FEEE4
					LDA $14E0,x
					STA $7FEEE0
					LDA $D8,x
					STA $7FEED8
					LDA $14D4,x
					STA $7FEED4
					LDA $C2,x
					BNE NOT_MODE0
					JSR MODE0
					RTS
NOT_MODE0			CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$02
					BNE NOT_MODE2
					JSR MODE2
					RTS
NOT_MODE2			CMP #$03
					BNE NOT_MODE3
					JSR MODE3
					RTS
NOT_MODE3
RETURN12			RTS

DAMAGE_GRA			LDY $151C,x
					LDA $00D8,y
					STA $D8,x
					LDA $00E4,y
					STA $E4,x
					LDA $14D4,y
					STA $14D4,x
					LDA $14E0,y
					STA $14E0,x
					LDA $1558,x
					BNE DAMAGE_GRA2
					STZ $14C8,x
DAMAGE_GRA2			RTS

FLOOR				LDA $C2,x
					BEQ FLOOR1
					JSR FLOOR_SUB
					RTS
FLOOR1				JSR SUB_GFX_FLOOR2
					LDA $9D
					BNE FLOOR_R
					LDA $1540,x
					BNE FLOOR0
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
FLOOR0				LDA $1570,x
					BNE FLOOR2
					JSR LENGTH_CHECK
					RTS
FLOOR2				LDA $1602,x
					BNE FLOOR3
					JSR MARIO_FLOOR_CHECK
					LDA $7FEEEF
					BEQ FLOOR_R
					LDA #$01
					STA $1602,x
					LDA #$40
					STA $1540,x
FLOOR_R				RTS
FLOOR3				LDA $1540,x
					CMP #$3F
					BEQ FLOOR3_2
					CMP #$18
					BEQ FLOOR3_3
					RTS
FLOOR3_2			JSR FLOOR_G
					LDA #$01
					STA $00C2,y
					RTS
FLOOR3_3			JSR FLOOR_G
					LDA #$02
					STA $00C2,y
					RTS
					
FLOOR_G				JSR GEN_SPRITE
					LDA #$15
					STA $1686,y
					LDA #$38
					STA $166E,y
					LDA #$83
					STA $167A,y
					LDA #$40
					STA $190F,y
					LDA $1504,x
					STA $1504,y
					LDA $151C,x
					STA $151C,y
					LDA $E4,x
					CLC
					ADC #$02
					STA $00E4,y
					LDA $D8,x
					CLC
					ADC #$08
					STA $00D8,y
					LDA $14D4,x
					ADC #$00
					STA $14D4,y
					TXA
					STA $1602,y
					RTS
					
FLOOR_SUB			JSR SUB_GFX_FLOOR
					LDA $9D
					BNE FLOOR_SUB_R
					LDA $E4,x
					CMP $1504,x
					BNE FLOOR_SUB_2
					LDA $14E0,x
					CMP $151C,x
					BNE FLOOR_SUB_2
					STZ $14C8,x
					LDA $C2,x
					CMP #$01
					BEQ FLOOR_SUB_R
					LDY $1602,x
					LDA #$00
					STA $1602,y
FLOOR_SUB_R			RTS
FLOOR_SUB_2			LDA $E4,x
					AND #$0F
					BNE FLOOR_SUB_3
					JSR GEN_TILE
FLOOR_SUB_3			LDA #$20
					STA $B6,x
					STZ $AA,x
					JSL $01802A
					RTS
					
GEN_TILE			LDA $E4,x
					STA $9A
					LDA $14E0,x
					STA $9B
					LDA $D8,x
					STA $98
					LDA $14D4,x
					STA $99
					LDA $C2,x
					CMP #$02
					BEQ GEN_TILE2
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0025
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
GEN_TILE2			PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0B0B
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
					
LENGTH_CHECK		LDA $E4,x
					PHA
					LDA $14E0,x
					PHA
LENGTH_LOOP			JSL $019138
					REP #$30
					LDA $03
					CMP #$0ABD
					BNE LENGTH_2
					SEP #$30
					LDA #$01
					STA $1570,x
					LDA $E4,x
					STA $1504,x
					LDA $14E0,x
					STA $151C,x
					BRA LENGTH_CHECK_2
LENGTH_2			SEP #$30
					LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					BRA LENGTH_LOOP
					RTS
LENGTH_CHECK_2		SEP #$30
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS
					
MARIO_FLOOR_CHECK	LDA #$00
					STA $7FEEEF
					LDA $77
					AND #$04
					BNE M_FLOOR_CHECK
					RTS
M_FLOOR_CHECK		LDA $E4,x
					PHA
					LDA $14E0,x
					PHA
M_FLOOR_LOOP		JSL $01A7DC
					BCC M_FLOOR_2
					LDA #$01
					STA $7FEEEF
M_FLOOR_2			LDA $14E0,x
					CMP $151C,x
					BNE M_FLOOR_3
					LDA $E4,x
					CMP $1504,x
					BNE M_FLOOR_3
					BRA M_FLOOR_4
M_FLOOR_3			LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					BRA M_FLOOR_LOOP
M_FLOOR_4			PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS

RING				JSR SUB_GFXR
					LDA $9D
					BNE RING_R
					JSR MARIO_CHECK2
					LDA $15AC,x
					BEQ R_DELETE
					CMP #$60
					BCS RING_2
					JSR SPEED_DEC
					JSL $01802A
					LDA $14E0,x
					CMP $7FEEE0
					BNE RING_R
					LDA $7FEEE4
					AND #$F8
					STA $7FEEE5
					LDA $E4,x
					AND #$F8
					CMP $7FEEE5
					BEQ R_DELETE
RING_R				RTS
RING_2				LDY $157C,x
					LDA X_SPEED,y
					STA $B6,x
					STZ $AA,x
					JSL $01802A
					RTS
R_DELETE			STZ $14C8,x
					RTS
X_SPEED				dcb $60,$A0
X_SPEED2			dcb $30,$D0

M_RING				JSR SUB_GFXR
					LDA $9D
					BNE RING_R2
					LDA $010B
					CMP #$45
					BNE M_RINGA
					LDA #$15
					STA $1686,x
M_RINGA				LDA #$3B
					STA $C2,x
					LDA #$38
					STA $166E,x
					LDA #$83
					STA $167A,x
					JSR ITEM_CHECK
					LDA $1570,x
					BEQ M_RING1
					LDY $1528,x
					LDA $E4,x
					STA $00E4,y
					LDA $14E0,x
					STA $14E0,y
					LDA $D8,x
					STA $00D8,y
					LDA $14D4,x
					STA $14D4,y
M_RING1				LDA $15AC,x
					BEQ R_DELETE2
					CMP #$E8
					BCS M_RING_2
					JSR SPEED_DEC
					JSL $01802A
					LDA $14E0,x
					CMP $7FEEE0
					BNE RING_R
					LDA $7FEEE4
					AND #$F8
					STA $7FEEE5
					LDA $E4,x
					AND #$F8
					CMP $7FEEE5
					BEQ R_DELETE2
RING_R2				RTS
M_RING_2			LDY $157C,x
					LDA X_SPEED,y
					STA $B6,x
					STZ $AA,x
					JSL $01802A
					RTS
R_DELETE2			STZ $14C8,x
					RTS

TIUN				STZ $18BD
					JSR OFFSET
					JSR SUB_GFXT
					INC $1570,x
					LDA $010B
					LDA $C2,x
					CMP #$99
					BEQ TIUN3
					LDA $1570,x
					CMP #$7F
					BEQ TIUN2
					CMP #$80
					BEQ MAINEND
					RTS
MAINEND				STZ $14C8,x
					LDA #$06
					STA $71
					STZ $89
					STZ $88
					RTS
TIUN2				LDA #$01
					STA $1426
TIUN_RA				RTS
TIUN3				LDA $1570,x
					CMP #$70
					BNE TIUN_RA
					STZ $14C8,x
					RTS
					
TIUNW				LDA $7FFEE0
					CMP #$99
					BNE TIUNW_2
					LDA #$13
					STA $78
					STZ $1411
					STZ $1412
TIUNW_2				STZ $18BD
					JSR OFFSET
					JSR SUB_GFXT
					INC $1570,x
					LDA $1570,x
					CMP #$80
					BEQ MAINENDW
					RTS
MAINENDW			STZ $14C8,x
					RTS

OFFSET				LDA $C2,x
					BNE OFFSET_2
					JSR OFFSET2
					LDA #$01
					STA $C2,x
OFFSET_2			LDA $7FFBB0
					INC A
					STA $7FFBB0
					LSR A
					STA $7FFBB4
					LDA $7FFBB1
					DEC A
					STA $7FFBB1
					LDA $7FFBC2
					INC A
					STA $7FFBC2
					LSR A
					STA $7FFBC6
					LDA $7FFBC3
					DEC A
					STA $7FFBC3
					LDA #$00
					SEC
					SBC $7FFBB4
					STA $7FFBB5
					LDA #$00
					SEC
					SBC $7FFBC6
					STA $7FFBC7
					
					LDA $7FFBB4
					LSR A
					CLC
					ADC $7FFBB4
					STA $7FFBB8
					STA $7FFBB9
					LSR A
					STA $7FFBBC
					STA $7FFBBD
					LDA #$00
					SEC
					SBC $7FFBB8
					STA $7FFBBA
					STA $7FFBBB
					LDA #$00
					SEC
					SBC $7FFBBC
					STA $7FFBBE
					STA $7FFBBF
					
					LDA $7FFBC6
					LSR A
					CLC
					ADC $7FFBC6
					STA $7FFBC8
					STA $7FFBCA
					LSR A
					STA $7FFBCC
					STA $7FFBCE
					LDA #$00
					SEC
					SBC $7FFBC8
					STA $7FFBC9
					STA $7FFBCB
					LDA #$00
					SEC
					SBC $7FFBCC
					STA $7FFBCD
					STA $7FFBCF
					RTS
					
OFFSET2				PHX
					LDX #$00
OFFSET_LOOP			LDA #$00
					STA $7FFBB0,x
					STA $7FFBC0,x
					INX
					CPX #$10
					BCC OFFSET_LOOP
					PLX
					RTS
					
					
BLOCK_NUM			LDY #$00
					PHX
					LDX #$00
BLOCK_NUM_1			LDA $9E,x
					CMP #$53
					BNE BLOCK_NUM_2
					LDA $14C8,x
					CMP #$08
					BCC BLOCK_NUM_2
					LDY #$01
BLOCK_NUM_2			INX
					CPX #$0A
					BNE BLOCK_NUM_1
					PLX
					RTS

LUD_CHECK			JSR BLOCK_NUM
					CPY #$01
					BEQ LUD_CHECK_R
LUD_LOOP			LDA $151C,y
					CMP #$4C
					BNE LUD_2
					LDA $14C8,y
					CMP #$08
					BCC LUD_2
					JSR NEAR_CHECK
					LDA $03
					BEQ LUD_2
					LDA #$01
					STA $1570,x
					PHY
					JSR GEN_SPRITE2
					TYA
					STA $1528,x
					PLY
LUD_2				INY
					CPY #$0A
					BNE LUD_LOOP
LUD_CHECK_R			RTS



ITEM_CHECK			LDA $010B
					CMP #$42
					BNE ITEM_CHECK_2
					LDA $1570,x
					BNE ITEM_CHECK_R
					JSR LUD_CHECK
ITEM_CHECK_R		RTS
ITEM_CHECK_2		TXA
					STA $0F
					LDY #$00
ITEM_LOOP			CPY $0F
					BEQ ITEM_1
					LDA $167A,y
					AND #$02
					BEQ ITEM_ENEMY
					LDA $1570,x
					BNE ITEM_1
					LDA $14C8,y
					CMP #$08
					BCC ITEM_1
					CMP #$0A
					BCS ITEM_1
					JSR NEAR_CHECK
					LDA $03
					BEQ ITEM_1
					LDA #$01
					STA $1570,x
					TYA
					STA $1528,x
					BRA ITEM_1
ITEM_ENEMY			LDA $14C8,y
					CMP #$08
					BCC ITEM_1
					JSR NEAR_CHECK
					LDA $03
					BEQ ITEM_1
					LDA #$02
					STA $14C8,y
					LDA #$03
					STA $1DF9
ITEM_1				INY
					CPY #$0C
					BNE ITEM_LOOP
					RTS
					
NEAR_CHECK			LDA #$00
					STA $03
					LDA $E4,x
					SEC
					SBC $00E4,y
					STA $02
					LDA $14E0,x
					SBC $14E0,y
					CMP #$FF
					BEQ NEAR_2
					CMP #$00
					BNE NEAR_R
					LDA $02
					CMP #$09
					BCS NEAR_R
					BRA NEAR_3
NEAR_R				RTS
NEAR_2				LDA $0F
					CMP #$F8
					BCC NEAR_R
NEAR_3				LDA $D8,x
					SEC
					SBC $00D8,y
					STA $02
					LDA $14D4,x
					SBC $14D4,y
					CMP #$00
					BEQ NEAR_4
					CMP #$FF
					BNE NEAR_R
					LDA $02
					CMP #$F8
					BCC NEAR_R
					LDA #$01
					STA $03
					RTS
NEAR_4				LDA $02
					CMP #$09
					BCS NEAR_R
					LDA #$01
					STA $03
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MODE0				STZ $13E0
					LDA #$01
					STA $76
					LDA #$FF
					STA $18BD
					STZ $B6,x
					LDA #$20
					STA $AA,x
					JSL $01802A
					LDA $1588,x
					AND #$04
					BNE MODE0_3
					LDA $14D4,x
					BNE MODE0_2
					RTS
MODE0_2				LDA #$11
					STA $1686,x
					RTS
MODE0_3				LDA #$01
					STA $1602,x
					STA $C2,x
					LDA #$0E
					STA $1DFC
					LDA #$41
					STA $15AC,x
					RTS
MODE1				STZ $13E0
					LDA $15AC,x
					BNE MODE1_2
					STZ $18BD
					LDA #$05
					STA $1DFB
					LDA #$02
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					RTS
MODE1_2				LDA $7FFD00
					TAY
					LDA $00D8,y
					SEC
					SBC #$01
					STA $00D8,y
					LDA $14D4,y
					SBC #$00
					STA $14D4,y
					RTS
					
MODE2				JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
					JSL $01802A
					LDA $15AC,x
					CMP #$F0
					BEQ MODE2_1
					CMP #$E0
					BEQ MODE2_2
					CMP #$D0
					BEQ MODE2_3
					CMP #$B0
					BCS MODE2_R
					CMP #$98
					BCC MODE2_6
					STZ $AA,x
					STZ $B6,x
					LDA $15AC,x
					CMP #$AF
					BEQ MODE2_4
					CMP #$A0
					BEQ MODE2_2
MODE2_R				RTS
MODE2_1				LDA #$02
					STA $1602,x
					RTS
MODE2_2				JSR GEN_SPRITE
					LDA #$02
					STA $1504,y
					LDA #$80
					STA $15AC,y
					LDA $157C,x
					STA $157C,y
					LDA #$01
					STA $1602,x
					LDA #$83
					STA $167A,y
					LDA #$38
					STA $166E,y
					LDA #$40
					STA $190F.y
					RTS
MODE2_3				LDA #$A0
					STA $AA,x
					STZ $B6,x
					LDA #$04
					STA $1602,x
					RTS
MODE2_4				LDA #$03
					STA $1602,x
MODE2_R2			RTS
MODE2_6				LDA $1588,x
					AND #$04
					BEQ MODE2_R2
					LDA $94
					AND #$F8
					STA $7FEE94
					LDA #$03
					STA $C2,x
					JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
					RTS
MODE3				LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					INC A
					INC A
					STA $1602,x
					LDA $E4,x
					AND #$F8
					CMP $7FEE94
					BEQ MODE3_2
					LDY $157C,x
					LDA X_SPEED2,y
					STA $B6,x
					JSL $01802A
					RTS
MODE3_2				LDA #$FF
					STA $15AC,x
					LDA #$02
					STA $C2,x
					STZ $B6,x
					RTS

DAMAGE_CHECK		LDA $1528,x
					BEQ CHECK_R
					STZ $1528,x
					LDA $1540,x
					BNE CHECK_R
					LDA $7FFD00
					TAY
					LDA $00D8,y
					CLC
					ADC #$04
					STA $00D8,y
					LDA $14D4,y
					ADC #$00
					STA $14D4,y
					LDA $1528,y
					CLC
					ADC #$02
					STA $1528,y
					CMP #$20
					BEQ RING_DEATH
					JSR GEN_SPRITE
					LDA #$01
					STA $1504,y
					LDA #$60
					STA $1558,y
					STA $1540,x
					TXA
					STA $151C,y
					LDA #$06
					STA $1602,y
					LDA #$10
					STA $1DFC
CHECK_R				RTS
RING_DEATH			STZ $14C8,x
					LDA #$18
					STA $1DFC
					JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					LDA #$00
					STA $1570,y
					LDA #$1E
					STA $1DFB
					RTS

MARIO_CHECK			JSL $01A7DC
					BCC MARIO_CHECK_R
					LDA $1497
					BNE MARIO_CHECK_R
					LDA #$40
					STA $1497
					LDA $7FFD01
					TAY
					LDA $1528,y
					CMP #$16
					BCS MARIO_DEATH
					LDA $00D8,y
					CLC
					ADC #$14
					STA $00D8,y
					LDA $14D4,y
					ADC #$00
					STA $14D4,y
					LDA $1528,y
					CLC
					ADC #$0A
					STA $1528,y
					LDA #$04
					STA $1DF9
MARIO_CHECK_R		RTS
MARIO_DEATH			LDA #$2F
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					JSL $00F606
					RTS
					
MARIO_CHECK2		JSL $01A7DC
					BCC MARIO_CHECK_R
					LDA $1497
					BNE MARIO_CHECK_R
					LDA #$40
					STA $1497
					LDA $7FFD01
					TAY
					LDA $1528,y
					CMP #$1A
					BCS MARIO_DEATH
					LDA $00D8,y
					CLC
					ADC #$0C
					STA $00D8,y
					LDA $14D4,y
					ADC #$00
					STA $14D4,y
					LDA $1528,y
					CLC
					ADC #$06
					STA $1528,y
					LDA #$04
					STA $1DF9
					RTS
					




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generate routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN68            RTS     
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX

                    LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

                    LDA $D8,x
                    STA $00D8,y             ;  |
					LDA $14D4,x
                    STA $14D4,y             ; /

                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX                     ; / 
                    
RETURN67            RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAPT            dcb $2A,$2C,

SUB_GFXT            LDA $C2,x
					STA $03
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$01
					TAY
					LDA TILEMAPT,y
					STA $0F
					
					JSR GET_DRAW_INFO
					LDY #$40
					TYA
					STA $15EA,x
                    PHX                   
                    LDX #$0F               
LOOP_STARTT         PHX                    
                    LDA $00                 ; \ tile x position = sprite x location ($00)
                    CLC                     ;  |
                    ADC $7FFBB0,x         ;  |
                    STA $0200,y             ; /   set x position of the tile
                    
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC $7FFBC0,x         ;  |
                    STA $0201,y             ; /   set y position of the tile
                    
                    LDA $0F
                    STA $0202,y             ; / 
					
                    LDA #$0F
                    ORA $64                 ;  | put in level properties  Unknown, level mode-related
                    STA $0203,y             ; / store tile properties
					LDA $03
					CMP #$99
					BEQ SUB_GFXT_2
					LDA $7FFEE0
					CMP #$99
					BNE SUB_GFXT_2
                    LDA #$0B
                    ORA $64                 
                    STA $0203,y
SUB_GFXT_2          PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_STARTT          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$0F                ;  | A = number of tiles drawn - 1
                    JSL $28FCC0             ;# / $200p̃OtBbN[`
                    RTS                     ; return
					
SUB_GFX_FLOOR		JSR GET_DRAW_INFO
					LDA $00
					STA $0300,y
					LDA $01
					CLC
					ADC #$FF
					STA $0301,y
					LDA #$0A
					STA $0302,y
					LDA #$0D
					STA $0303,y
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
SUB_GFX_FLOOR2		JSR GET_DRAW_INFO
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA #$A4
					STA $0302,y
					LDA #$0F
					STA $0303,y
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS


VERT_DISP0			dcb $00,$10,$20,$30

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					LDA $151C,x
					STA $0F
					PHX
					LDX #$03
LOOP_START0         LDA $00
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_DISP0,x
					STA $0301,y
					LDA $0F
                    STA $0302,y
					LDA #$0F               ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START0          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS           
            
PROPETIESR			dcb $0E,$4E
SUB_GFXR            LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					TAY
					LDA PROPETIESR,y
					STA $0F
					JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA #$AA
                    STA $0302,y
					LDA $0F              ;  | put in level properties
					ORA $64
                    STA $0303,y             ; / store tile properties
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS      
					
TILEMAP2            dcb $84,$86,$A4,$A6,$0C
					dcb $80,$82,$A0,$A2,$0C
					dcb $C0,$C2,$E0,$E2,$0C
					dcb $CC,$CE,$EC,$EE,$AE
					dcb $C8,$CA,$E8,$EA,$AC
					dcb $C4,$C6,$E4,$E6,$AC
					dcb $88,$8A,$A8,$AA,$0C
HORZ_DISP			dcb $08,$F8,$08,$F8,$00,$F8,$08,$F8,$08,$00
VERT_DISP			dcb $F0,$F0,$00,$00,$E0
PROPETIES			dcb $4F,$0F

GFX_R				RTS
SUB_GFX2            LDA $1558,x
					AND #$04
					BNE GFX_R
					LDY $157C,x
					LDA PROPETIES,y
					STA $0F
					JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                    PHX                     ; push sprite index
					LDA $1602,x
					ASL A
					ASL A
					CLC
					ADC $1602,x
					STA $03
					STZ $02
					LDA $157C,x
					BEQ SUB_GFX2_0
					LDA #$05
					STA $02
SUB_GFX2_0			LDX #$04
LOOP_START          PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $00
					CLC
					ADC HORZ_DISP,x
					STA $0300,y
					PLX
					
					LDA $01
					CLC
					ADC VERT_DISP,x
					STA $0301,y
					
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILEMAP2,x           ; \ store tile
                    STA $0302,y
					PLX
					
					LDA $0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties


                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$04               ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

SUB_GET_DIR         LDY #$00                
                    LDA $94                
                    SEC                     
                    SBC $E4,x               
                    STA $0F
                    LDA $95                 
                    SBC $14E0,x             
                    BPL LABEL16             
                    INY                     
LABEL16             RTS

TURN_LEFT			LDA $14E0,x
					CMP #$FF
					BEQ TURN_RIGHT
					LDA #$A0
					STA $B6,x
					BRA SPEED_DEC_3
SPEED_DEC           LDA $E4,x
                    SEC
                    SBC $7FEEE4
                    STA $0F
					LDA $14E0,x
                    SBC $7FEEE0
                    BCS TURN_LEFT
TURN_RIGHT			LDA #$00
					SEC
					SBC $0F
					STA $0F
					LDA #$60
					STA $B6,x
SPEED_DEC_3			LDA $D8,x
					SEC
					SBC $7FEED8
					STA $02
					LDA $14D4,x
					SBC $7FEED4
					BCS TURN_L_UP
					LDA #$00
					SEC
					SBC $02
					STA $02
					STA $004202
					LDA #$60
					STA $004203
					REP #$30
					LDA.W $004216
					STA.W $004204
					SEP #$30
					LDA $0F
					STA $004206
					LDA $004214
					STA $AA,x
					LDA $004215
					BEQ SPEED_DEC_R
					LDA #$7F
					STA $AA,x
SPEED_DEC_R			RTS
TURN_L_UP			LDA $02
					STA $004202
					LDA #$40
					STA $004203
					REP #$30
					LDA.W $004216
					STA.W $004204
					SEP #$30
					LDA $0F
					STA $004206
					LDA #$00
					SEC
					SBC $004214
					STA $AA,x
					LDA $004215
					BEQ SPEED_DEC_R
					LDA #$81
					STA $AA,x
					RTS
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN69            RTS
GEN_SPRITE2         JSL $02A9DE             ; \ g
                    BMI RETURN69            ; / after: Y has index of sprite being generated
                    LDA #$09                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
					LDA #$53
                    STA $009E,y
                    
                    LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

                    LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    PLX
					LDA #$F0
					STA $1540,y
                    RTS           

