;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ROCKET
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                

  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					STZ $C2,x
					LDA #$01
					STA $7FFFDF
					LDA #$0F
					STA $7FFFE0
					LDA #$1E
					STA $7FFFE1
					LDA #$0E
					STA $7FFFE2
					LDA #$15
					STA $7FFFE3
					LDA #$0B
					STA $1594,x
					STZ $1570,x
					TXA
					STA $7FF001
					PHX
					LDX $13BF
					LDA $1EA2,x
					PLX
					AND #$40
					BNE MID_INIT
					RTL
MID_INIT			STZ $1594,x
					RTL
                    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite code JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"                                    
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
					LDA $C2,x
					BEQ CODE1
					JSR FNISH_CODE
					BRA CODE2
CODE1               JSR SPRITE_CODE_START   ;  |
CODE2               PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main code 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FNISH_CODE			JSR SUB_GFX2
					STZ $1594,x
					JSR LIFE_GAGE
					RTS



RETURN              RTS
SPRITE_CODE_START   JSR SUB_GFX
					JSR DELETE_MARIO
MAIN                LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
					JSR FINISH_CHECK
					LDA #$F0
					STA $AA,x
					JSL $01802A             ; update position based on speed values
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					SEC
					SBC #$20
					STA $D8,x
					LDA $97
					SBC #$00
					STA $14D4,x
					JSR LIFE_GAGE
					LDA $1594,x
					BEQ MAIN2
					INC $1570,x
					LDA $1570,x
					BNE MAIN2
					DEC $1594,x
MAIN2				LDA $1594,x
					BEQ NOT_MODE1
					JSR MODE0
					RTS
NOT_MODE1			JSR MODE1
					RTS
					
MODE0				LDA $15AC,x
					STA $7D
					STZ $7B
					LDA $15
					AND #$03
					BEQ MODE0_2
					CMP #$01
					BNE MODE0_1
					LDA #$10
					STA $7B
					BRA MODE0_2
MODE0_1				LDA #$F0
					STA $7B
MODE0_2				LDA #$01
					STA $1471
					LDA $1588,x
					AND #$08
					BEQ MODE0_3
					LDA #$20
					STA $15AC,x
					LDA #$02
					STA $1DF9
MODE0_3				LDA $96
					SEC
					SBC #$01
					STA $96
					LDA $97
					SBC #$00
					STA $97
					RTS

MODE1				STZ $7B
					LDA #$30
					STA $7D
					LDA $77
					AND #$04
					BEQ MODE1_1
					LDA #$06
					STA $7D
MODE1_1				LDA $15
					AND #$03
					BEQ MODE1_3
					CMP #$01
					BNE MODE1_2
					LDA #$10
					STA $7B
					BRA MODE1_3
MODE1_2				LDA #$F0
					STA $7B
MODE1_3				RTS

DELETE_MARIO		LDA #$03
					STA $78
					LDA #$40
					STA $0D89
					STA $0D93
					LDA #$51
					STA $0D8A
					STA $0D94
					RTS
					
GAGE_E				RTS
LIFE_GAGE			LDA #$FC
					STA $7FFFE4
					STA $7FFFE5
					STA $7FFFE6
					STA $7FFFE7
					STA $7FFFE8
					STA $7FFFE9
					STA $7FFFEA
					STA $7FFFEB
					STA $7FFFEC
					STA $7FFFED
					STA $7FFFEE
					STA $7FFFEF
					LDA $1594,x
					CMP #$01
					BCS GAGE_2
					RTS
GAGE_2				LDA #$FD
					STA $7FFFE4
					LDA $1594,x
					CMP #$02
					BCS GAGE_3
					RTS
GAGE_3				LDA #$FD
					STA $7FFFE5
					LDA $1594,x
					CMP #$03
					BCS GAGE_4
					RTS
GAGE_4				LDA #$FD
					STA $7FFFE6
					LDA $1594,x
					CMP #$04
					BCS GAGE_5
					RTS
GAGE_5				LDA #$FD
					STA $7FFFE7
					LDA $1594,x
					CMP #$05
					BCS GAGE_6
					RTS
GAGE_6				LDA #$FD
					STA $7FFFE8
					LDA $1594,x
					CMP #$06
					BCS GAGE_7
					RTS
GAGE_7				LDA #$FD
					STA $7FFFE9
					LDA $1594,x
					CMP #$07
					BCS GAGE_8
					RTS
GAGE_8				LDA #$FD
					STA $7FFFEA
					LDA $1594,x
					CMP #$08
					BCS GAGE_9
					RTS
GAGE_9				LDA #$FD
					STA $7FFFEB
					LDA $1594,x
					CMP #$09
					BCS GAGE_A
					RTS
GAGE_A				LDA #$FD
					STA $7FFFEC
					LDA $1594,x
					CMP #$0A
					BCS GAGE_B
					RTS
GAGE_B				LDA #$FD
					STA $7FFFED
					LDA $1594,x
					CMP #$0B
					BCS GAGE_C
					RTS
GAGE_C				LDA #$FD
					STA $7FFFEE
					RTS
					
FINISH_CHECK		LDA $14D4,x
					CMP #$02
					BNE FINISH2
					LDA $D8,x
					CMP #$91
					BCC FINISH
FINISH_E			RTS
FINISH2				CMP #$04
					BNE FINISH_E
					LDA $14E0,x
					CMP #$01
					BNE FINISH_E
					LDA $D8,x
					CMP #$50
					BCS FINISH_E
FINISH				LDA #$01
					STA $C2,x
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP             dcb $82,$84,$A0,$A2,$A4,$A6,$C8,$C2,$C4,$C6,$E0,$E2,$E4,$E6
HORZ_DISP           dcb $F8,$08,$E8,$F8,$08,$18,$E8,$F8,$08,$18,$E8,$F8,$08,$18
VERT_DISP           dcb $00,$00,$10,$10,$10,$10,$20,$20,$20,$20,$30,$30,$30,$30

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
					PHX                     ; push sprite index

                    LDX #$0D                ; loop counter = (number of tiles per frame) - 1
LOOP_START          PHX                     ; push current tile number

					LDA $00
					CLC                     ;  |
                    ADC HORZ_DISP,x   
                    STA $0300,y             ; /      

                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP,x         ;  |
                    STA $0301,y             ; /
                    
					
                    LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; / 
        
                    LDA #$0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
					LDA $1594,x
					BNE GFX2
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$0D                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
GFX2				LDA #$8E
					STA $02
					LDA #$AE
					STA $03
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					BEQ GFX2_2
					LDA #$8C
					STA $02
					LDA #$AC
					STA $03
GFX2_2
					INY
					INY
					INY
					INY
					LDA $00
					STA $0300,y
					LDA $01
					STA $01
					CLC
					ADC #$40
					STA $0301,y
					LDA $02
					STA $0302,y
					LDA #$0D
                    ORA $64 
                    STA $0303,y
					INY
					INY
					INY
					INY
					LDA $00
					STA $0300,y
					LDA $01
					STA $01
					CLC
					ADC #$50
					STA $0301,y
					LDA $03
					STA $0302,y
					LDA #$0D
                    ORA $64 
                    STA $0303,y
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$0F                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP2             dcb $82,$84,$A0,$AA,$CE,$A6,$C8,$CA,$CC,$C6,$E0,$E2,$E4,$E6
HORZ_DISP2           dcb $F8,$08,$E8,$F8,$08,$18,$E8,$F8,$08,$18,$E8,$F8,$08,$18
VERT_DISP2           dcb $00,$00,$10,$10,$10,$10,$20,$20,$20,$20,$30,$30,$30,$30

SUB_GFX2             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
					PHX                     ; push sprite index

                    LDX #$0D                ; loop counter = (number of tiles per frame) - 1
LOOP_START2          PHX                     ; push current tile number

					LDA $00
					CLC                     ;  |
                    ADC HORZ_DISP2,x   
                    STA $0300,y             ; /      

                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP2,x         ;  |
                    STA $0301,y             ; /
                    
					
                    LDA TILEMAP2,x           ; \ store tile
                    STA $0302,y             ; / 
        
                    LDA #$0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START2          ; / 

                    PLX                     ; pull, X = sprite index
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$0D                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /


