;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Roy
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
					EXTRA_BITS = $7FAB10
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"
					LDA #$01
					STA $157C,x
					STZ $1528,x
					LDA #$FF
					STA $15AC,x
                    RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X_SPEED				dcb $14,$EC
X_SPEED2			dcb $60,$A0
X_OFFSET			dcb $10,$F0
X_OFFSET2			dcb $00,$FF

RETURN              RTS                     ; return           
CODE_START          LDA $C2,x
					CMP #$01
					BNE MAIN2
					JSR HAIR
					RTS
MAIN2				CMP #$02
					BNE MAIN3
					JSR LIGHT
					RTS
MAIN3				CMP #$03
					BNE MAIN4
					JSR FIRE
					RTS
MAIN4				LDA $1528,x
					CMP #$04
					BEQ MAIN5
					JSR SUB_GFX             ; graphics routine
					LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
					JSL $01802A             ; update position based on speed values
					LDA $1528,x
					BNE NOT_MODE0
					JSR MODE0
					RTS
NOT_MODE0			CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$02
					BNE NOT_MODE2
					JSR MODE2
					RTS
NOT_MODE2			JSR MODE3
RETURN22			RTS
MAIN5				JSR SUB_GFX3
					LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN22              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN22
					JSL $01802A
					LDA $15AC,x
					CMP #$90
					BEQ MAIN5_4
					CMP #$C0
					BEQ MAIN5_2
					CMP #$C0
					BCC MAIN5_3
					STZ $B6,x
					STZ $AA,x
					RTS
MAIN5_2				LDA #$2B
					STA $1DFC
MAIN5_3				LDA #$E0
					STA $AA,x
					RTS
MAIN5_4				LDA #$0B
                    STA $1DFB
					LDA #$FF
                    STA $13C6
                    STA $1493
					LDA #$02
					STA $0F31
					STZ $14C8,x
					RTS

MODE0				STZ $AA,x
					LDA $15AC,x
					BEQ MODE0_4
					CMP #$A0
					BEQ MODE0_2
					CMP #$98
					BEQ MODE0_3
					RTS
MODE0_2				LDA $7FF008
					CMP #$02
					BEQ MODE0_2_2
					STZ $157C,x
					RTS
MODE0_2_2			LDA #$01
					STA $157C,x
					RTS
MODE0_3				LDA #$01
					STA $7FF001
					JSR GEN_HAIR
					LDA #$CC
					STA $1570,y
					LDA #$02
					STA $1602,x
					RTS
MODE0_4				LDA #$01
					STA $1528,x
					LDA #$60
					STA $15AC,x
					RTS
					
MODE1				JSR KEY_CHECK
					STZ $AA,x
					JSR SUB_GET_DIR
					TYA
					STA $157C,x
					LDA $15AC,x
					CMP #$20
					BCS MODE1_2
					LDA #$07
					STA $1602,x
					LDA $15AC,x
					BEQ MODE1_3
					CMP #$10
					BNE MODE1_R
					LDA $D8,x
					PHA
					CLC
					ADC #$08
					STA $D8,x
					LDA $14D4,x
					PHA
					ADC #$00
					STA $14D4,x
					LDA $157C,x
					TAY
					LDA $E4,x
					PHA
					CLC
					ADC X_OFFSET,y
					STA $E4,x
					LDA $14E0,x
					PHA
					ADC X_OFFSET2,y
					STA $14E0,x
					LDA #$03
					STA $7FF001
					JSR GEN_HAIR
					LDA #$CA
					STA $1570,y
					JSR SPEED_DEC
					LDA $1594,x
                    STA $00AA,y
                    LDA $1504,x
                    STA $00B6,y
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					LDA #$17
					STA $1DFC
MODE1_R				RTS
MODE1_2				LDA #$01
					STA $1602,x
					RTS
MODE1_3				LDA #$FF
					STA $15AC,x
					RTS
					
MODE2				STZ $AA,x
					STZ $B6,x
					JSR SUB_GET_DIR
					TYA
					STA $157C,x
					LDA #$00
					STA $7FE201
					STA $7FE202
					LDA $7FF008
					BNE MODE2_L2
					LDA #$10
					STA $9A
					LDA #$01
					STA $9B
					LDA #$10
					STA $98
					LDA #$01
					STA $99
					BRA MODE2_BLK
MODE2_L2			CMP #$02
					BEQ MODE2_L3
					LDA #$B0
					STA $9A
					LDA #$00
					STA $9B
					LDA #$40
					STA $98
					LDA #$01
					STA $99
					BRA MODE2_BLK
MODE2_L3			LDA #$30
					STA $9A
					LDA #$00
					STA $9B
					LDA #$40
					STA $98
					LDA #$01
					STA $99
MODE2_BLK			JSR GEN_BLOCK
					JSR BLOCK_CHECK
					LDA $15AC,x
					CMP #$20
					BCS MODE2_2
					LDA #$08
					STA $1602,x
					LDA $15AC,x
					BEQ MODE2_3
					CMP #$10
					BNE MODE2_R
					LDA $D8,x
					PHA
					CLC
					ADC #$08
					STA $D8,x
					LDA $14D4,x
					PHA
					ADC #$00
					STA $14D4,x
					LDA $157C,x
					TAY
					LDA $E4,x
					PHA
					CLC
					ADC X_OFFSET,y
					STA $E4,x
					LDA $14E0,x
					PHA
					ADC X_OFFSET2,y
					STA $14E0,x
					LDA #$03
					STA $7FF001
					JSR GEN_HAIR
					LDA #$CA
					STA $1570,y
					JSR SPEED_DEC
					LDA $1594,x
                    STA $00AA,y
                    LDA $1504,x
                    STA $00B6,y
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					LDA #$17
					STA $1DFC
MODE2_R				RTS
MODE2_2				LDA #$03
					STA $1602,x
					RTS
MODE2_3				LDA #$FF
					STA $15AC,x
					RTS
					
MODE3				LDA $7FF008
					CMP #$01
					BNE MODE3_L2
					LDA $15AC,x
					CMP #$D0
					BCC MODE3_2
					LDA #$10
					STA $9A
					LDA #$01
					STA $9B
					LDA #$10
					STA $98
					LDA #$01
					STA $99
					JSR RESET_BLOCK
MODE3_R				STZ $B6,x
					STZ $AA,x
					RTS
MODE3_2				CMP #$70
					BCC MODE3_3
					CMP #$90
					BCC MODE3_R
					LDA #$01
					STA $157C,x
					STZ $AA,x
					LDA #$F0
					STA $B6,x
					LDA $13
					LSR A
					LSR A
					LSR A
					AND #$03
					CLC
					ADC #$03
					STA $1602,x
					RTS
MODE3_3				
					STZ $1528,x
					LDA #$B0
					STA $15AC,x
					RTS
MODE3_L2			CMP #$03
					BEQ MODE3_L3
					STZ $157C,x
					LDA $15AC,x
					CMP #$D0
					BCC MODE3_L2_2
					LDA #$B0
					STA $9A
					LDA #$00
					STA $9B
					LDA #$40
					STA $98
					LDA #$01
					STA $99
					JSR RESET_BLOCK
MODE3_L2_R			STZ $B6,x
					STZ $AA,x
					RTS
MODE3_L2_2			CMP #$B8
					BCC MODE3_L2_3
					LDA #$E0
					STA $AA,x
					RTS
MODE3_L2_3			CMP #$18
					BCC MODE3_L2_4
					CMP #$38
					BCC MODE3_L2_R
					STZ $AA,x
					LDA #$20
					STA $B6,x
					LDA $13
					LSR A
					LSR A
					;LSR A
					AND #$03
					CLC
					ADC #$03
					STA $1602,x
					RTS
MODE3_L2_4				
					STZ $1528,x
					LDA #$B0
					STA $15AC,x
					RTS
MODE3_L3			LDA $15AC,x
					CMP #$D0
					BCC MODE3_L3_2
					LDA #$30
					STA $9A
					LDA #$00
					STA $9B
					LDA #$40
					STA $98
					LDA #$01
					STA $99
					JSR RESET_BLOCK
					STZ $AA,x
					STZ $B6,x
					RTS
MODE3_L3_2			LDA #$04
					STA $1528,x
					LDA #$FF
					STA $15AC,x
					LDA #$1E
					STA $1DFB
					RTS


HAIR				JSR SUB_GFX2
					LDA $9D 
                    BNE HAIR_R2
					LDA #$10
					;STA $9D
					;STZ $7D
					;STZ $7B
					LDA $15AC,x
					CMP #$F0
					BCC HAIR_2
					LDA $157C,x
					PHX
					TAX
					LDA X_SPEED,x
					PLX
					STA $B6,x
					LDA #$10
					STA $AA,x
					JSL $01802A
HAIR_R2				RTS
HAIR_2				CMP #$80
					BCC HAIR2_2
					CMP #$E0
					BNE HAIR2_1
					LDA #$02
					STA $7FF001
					LDA $D8,x
					PHA
					SEC
					SBC #$04
					STA $D8,x
					LDA $14D4,x
					PHA
					SBC #$00
					STA $14D4,x
					JSR GEN_HAIR
					LDA #$01
					STA $1DFC
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					LDA #$CE
					STA $1570,y
					LDA #$20
					STA $15AC,y
					LDA #$02
					STA $1602,x
					RTS
HAIR2_1				CMP #$C0
					BCS HAIR_R2
					JSR HDMA
					RTS
HAIR2_2
					LDA $157C,x
					PHX
					TAX
					LDA X_SPEED2,x
					PLX
					STA $B6,x
					LDA $AA,x
					PHA
					JSL $01802A
					PLA
					INC A
					STA $AA,x
					LDA $14E0,x
					BNE HAIR_3
					LDA $E4,x
					CMP #$20
					BCS HAIR_4
					LDA #$20
					STA $E4,x
					STZ $AA,x
					BRA HAIR_4
HAIR_3				LDA $E4,x
					CMP #$D0
					BCC HAIR_4
					LDA #$D0
					STA $E4,x
					STZ $AA,x
HAIR_4				LDA $14D4,x
					BEQ HAIR_R
					LDA $D8,x
					CMP #$70
					BCC HAIR_R
					LDA #$70
					STA $D8,x
					JSR GEN_KEY
					STZ $14C8,x
HAIR_R				RTS
LIGHT				JSR SUB_GFX2
					LDA $9D 
                    BNE LIGHT_R
					STZ $AA,x
					STZ $B6,x
					LDA $15AC,x
					CMP #$01
					BNE LIGHT_R
					STZ $14C8,x
LIGHT_R				RTS
FIRE				JSR SUB_GFX2
					LDA $9D 
                    BNE FIRE_R
					LDA #$01
					STA $167A,x
					LDA #$1F
					STA $166E,x
					LDA #$80
					STA $1656,x
					JSL $01A7DC
					LDA $AA,x
					PHA
					JSL $01802A
					PLA
					STA $AA,x
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
FIRE_R				RTS
					
KEY_CHECK			
			        LDA $E4,x
                    STA $7FFE01
                    LDA $14E0,x
                    STA $7FFE02
                    LDA $D8,x
                    STA $7FFE03
                    LDA $14D4,x
                    STA $7FFE04
                    PHX
                    LDX #$09
LOOP1               LDA $14C8,x
					BEQ LOOP3
LOOP2				LDA $9E,x
					CMP #$80
					BNE LOOP3
OUT                 JSR NEAR_CHECK
                    TYA
                    BEQ LOOP3
					STZ $14C8,x
                    LDA #$03
					STA $1DF9
					PLX
					LDA #$02
					STA $1528,x
					LDA #$FF
					STA $15AC,x
					PHX
LOOP3               DEX
                    BPL LOOP1
                    PLX
                    RTS
					
BLOCK_CHECK			
			        LDA $E4,x
                    STA $7FFE01
                    LDA $14E0,x
                    STA $7FFE02
                    LDA $D8,x
                    STA $7FFE03
                    LDA $14D4,x
                    STA $7FFE04
                    PHX
                    LDX #$09
BLOOP1               LDA $14C8,x
					BEQ BLOOP3
BLOOP2				LDA $9E,x
					CMP #$53
					BNE BLOOP3
BOUT                 JSR NEAR_CHECK
                    TYA
                    BEQ BLOOP3
					STZ $14C8,x
                    LDA #$28
					STA $1DFC
					PLX
					LDA $7FF008
					INC A
					STA $7FF008
					LDA #$03
					STA $1528,x
					LDA #$FF
					STA $15AC,x
					PHX
BLOOP3               DEX
                    BPL BLOOP1
                    PLX
                    RTS
					
NEAR_CHECK          LDY #$00
                    LDA $E4,x
                    SEC
                    SBC $7FFE01
                    STA $0F
                    LDA $14E0,x
                    SBC $7FFE02
                    CMP #$00
                    BEQ RIGHT_CHECK
                    CMP #$FF
                    BNE CHECK_E
                    LDA $0F
                    CMP #$F0
                    BCC CHECK_E
                    BRA VER_CHECK
RIGHT_CHECK         LDA $0F
                    CMP #$10
                    BCS CHECK_E
VER_CHECK           LDA $D8,x
                    SEC
                    SBC $7FFE03
                    STA $0F
                    LDA $14D4,x
                    SBC $7FFE04
                    CMP #$00
                    BEQ UNDER_CHECK
                    CMP #$FF
                    BNE CHECK_E
                    LDA $0F
                    CMP #$F8
                    BCC CHECK_E
                    BRA NEAR
UNDER_CHECK         LDA $0F
                    CMP #$08
                    BCS CHECK_E
NEAR                LDY #$01
CHECK_E             RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP             dcb $84,$86,$A4,$A6,$C4,$C6,$E8,$EA,$80,$82,$A0,$A2
					dcb $88,$8A,$E4,$E6,$88,$8A,$E8,$EA,$88,$8A,$EC,$EE,$88,$8A,$E8,$EA
					dcb $C0,$C2,$E0,$E2,$A8,$AA,$E0,$E2
HORIZ_DISP          dcb $08,$F8,$08,$F8,$F8,$08,$F8,$08
VERT_DISP           dcb $F0,$F0,$00,$00,$F0,$F0,$00,$00
PROPERTIES          dcb $40,$40,$40,$40,$00,$00,$00,$00

TILEMAP3             dcb $8C,$8E,$8C,$8E,$AC,$AE,$AC,$AE
HORIZ_DISP3          dcb $F8,$08,$08,$F8,$08,$F8,$F8,$08
;HORIZ_DISP3          dcb $00,$10,$10,$00,$10,$00,$00,$10
PROPERTIES3          dcb $00,$00,$40,$40,$40,$40,$00,$00



SUB_GFX             JSR GET_DRAW_INFO
                    PHX                   
					LDA $1602,x
					ASL A
					ASL A
					STA $02
					LDA $157C,x
					ASL A
					ASL A
					STA $03
					
                    
                    LDX #$03                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START          PHX                     ; push, current tile
                    
					PHX
					TXA
					CLC
					ADC $03
					TAX
					
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP,x        ; |
                    STA $0300,y             ; /
                    
                    LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP,x         ; |
                    STA $0301,y             ; /
					
					LDA PROPERTIES,x
					ORA #$09
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
					PLX

					PHX
					TXA
					CLC
					ADC $02
					TAX
                    LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /
					PLX

                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
SUB_GFX2            JSR GET_DRAW_INFO
                    
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    STA $0300,y             ; /
                    
                    LDA $01                 ; |
                    STA $0301,y             ; /
					
					LDA #$09
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties


					LDA $1570,x
                    STA $0302,y             ; /

                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$00                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return


SUB_GFX3            JSR GET_DRAW_INFO                   
					LDA $13
					LSR A
					LSR A
					AND #$03
					ASL A
					STA $03
					
                    PHX
                    LDX #$01                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START3         PHX                     ; push, current tile
                    
					TXA
					CLC
					ADC $03
					TAX
					
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP3,x        ; |
                    STA $0300,y             ; /
                    
                    LDA $01                 ; |
                    STA $0301,y             ; /
					
					LDA TILEMAP3,x           ; \ store tile
                    STA $0302,y 
					
					LDA PROPERTIES3,x
					ORA #$09
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties


                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START3

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$01                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

X_OFFSET            dcb $10,$F0
X_OFFSET2           dcb $00,$FF

RETURN67            RTS
GEN_HAIR            JSL $02A9DE             ; \ ge slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
                    LDA $E4,x               ;\ set x position for new sprite
                    STA $00E4,y

                    LDA $14E0,x             ;  |
                    STA $14E0,y             ; /

                    LDA $D8,x               ;\ set y position for new sprite
					SEC
					SBC #$10
                    STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
					SBC #$00
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
					LDA $157C,x
					STA $157C,y
					LDA #$FF
					STA $15AC,y
					LDA $7FF001
					STA $00C2,y
                    RTS                          ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN68            RTS
GEN_KEY             JSL $02A9DE             ; \ g
                    BMI RETURN68            ; / after: Y has index of sprite being generated
                    LDA #$09                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    
					LDA #$80
                    STA $009E,y
                    
                    LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

                    LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    PLX
                    RTS           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817                ; Y = 1 if contact

SUB_GET_DIR         LDY #$00                ;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
                    LDA $94                 ;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
                    SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
                    SBC $E4,x               ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
                    STA $0F                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
                    LDA $95                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
                    SBC $14E0,x             ;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
                    BPL LABEL16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
                    INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
LABEL16             RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31

HDMA				LDA #$14
					STA $00212C
					LDA #$03
					STA $00212D
					LDA $7FFB28
					BNE HDMA1
					LDA #$20
					STA $7FFB28
					LDA #$40
					STA $7FFB30
					LDA #$00
					STA $7FFB29
					LDA #$02
					STA $7FFB31
					LDA #$21
					STA $7FFB2A
					LDA #$22
					STA $7FFB32
					LDA #$00
					STA $7FFB2B
					STA $7FFB33
					LDA #$E1
					STA $7FFB2C
					LDA #$E2
					STA $7FFB34
					LDA #$7F
					STA $7FFB2D
					STA $7FFB35
					LDA #$07
					STA $7FE100
					STA $7FE200
					LDA #$00
					STA $7FE101
					LDA #$00
					STA $7FE201
					LDA #$00
					STA $7FE202
					LDA #$00
					STA $7FE102
					STA $7FE203
HDMA1				LDA $15AC,x
					AND #$01
					BNE HDMA_R
					LDA $7FE202
					CMP #$7F
					BNE HDMA1_2
					LDA $7FE201
					CMP #$FF
					BEQ HDMA_R
HDMA1_2				LDA $7FE201
					CLC
					ADC #$21
					STA $7FE201
					LDA $7FE202
					ADC #$04
					STA $7FE202
HDMA_R				RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; generate sprite
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPEED_DEC			LDA #$20
					STA $1570,x
					LDA #$10
					STA $151C,x
					LDA $94
					STA $7FFA00
					LDA $95
					STA $7FFA01
					LDA $96
					STA $7FFA02
					LDA $97
					STA $7FFA03
					JSR SPEED_DEC2
					STZ $15AC,x
MODE5A_0			LDA $1594,x
					CMP #$80
					BCS MODE5A_4
					CMP #$20
					BCC MODE5A_E
					LSR A
					STA $1594,x
MODE5A_3_1			LDA $1504,x
					CMP #$80
					BCS MODE5A_3_2
					LSR A
					STA $1504,x
					BRA MODE5A_0
MODE5A_3_2			LDA #$00
					SEC
					SBC $1504,x
					LSR A
					STA $1504,x
					LDA #$00
					SEC
					SBC $1504,x
					STA $1504,x
					BRA MODE5A_0
MODE5A_E			RTS
MODE5A_4			CMP #$E0
					BCS MODE5A_E
					LDA #$E0
					STA $1594,x
					BRA MODE5A_3_1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SPEED_DEC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   

SPEED_DEC2          LDA $E4,x
                    SEC
                    SBC $7FFA00
                    STA $0F
                    LDA $14E0,x
                    SBC $7FFA01
                    BPL FACE_LEFT
                    JSR RIGHT_SPEED
                    BRA VERC
FACE_LEFT           CMP #$01
                    BEQ LEFT2
                    JSR LEFT_SPEED1
                    BRA VERC
LEFT2               JSR LEFT_SPEED2
VERC                LDA $D8,x
                    SEC
                    SBC $7FFA02
                    STA $0F
                    LDA $14D4,x
                    SBC $7FFA03
                    BPL FACE_UP
                    JSR DOWN_SPEED
                    LDA $1594,x
                    CMP #$10
                    BCS VER_E
                    LDA #$10
                    STA $1594,x
                    BRA VER_E
FACE_UP             JSR UP_SPEED
                    LDA $1594,x
                    CMP #$F0
                    BCC VER_E
                    LDA #$F0
                    STA $1594,x
VER_E               RTS

UP_SPEED            LDA $0F38
                    CMP #$00
                    BNE UP3
                    LDA $0F
                    CMP #$80
                    BCC UP2
                    LDA #$7F
UP2                 STA $0F
                    BRA UP5
UP3                 CMP #$02
                    BNE UP4
                    JSR UP1_1
                    BRA UP5
UP4                 JSR UP1_2
UP5                 LDA #$00
                    SEC
                    SBC $0F
                    STA $1594,x
                    RTS

DOWN_SPEED          LDA #$00
                    SEC
                    SBC $0F
                    STA $0F
                    LDA $0F38
                    CMP #$00
                    BNE DOWN3
                    LDA $0F
                    CMP #$80
                    BCC DOWN2
                    LDA #$7F
DOWN2               STA $1594,x
                    RTS
DOWN3               CMP #$02
                    BNE DOWN4
                    JSR UP1_1
                    BRA DOWN5
DOWN4               JSR UP1_2
DOWN5               LDA $0F
                    STA $1594,x
                    RTS
UP1_1
LOOPUP1             LDA $0F37
                    BEQ LOOPUP1E
                    LDA $0F
                    LSR A
                    STA $0F
                    DEC $0F37
                    LDA $0F37
                    BNE LOOPUP1
LOOPUP1E            LDA $0F
                    CMP #$80
                    BCC LOOPUP1EE
                    LDA #$7F
                    STA $0F
LOOPUP1EE           RTS

UP1_2               LDA $0F
                    CMP #$80
                    BCC LOOPUP3
                    LDA #$7F
                    STA $0F
                    STZ $0F37
                    RTS
LOOPUP3             LDA $0F37
                    BEQ LOOPUP2E
                    LDA $0F
                    ASL A
                    STA $0F
                    DEC $0F37
                    LDA $0F37
                    BNE UP1_2
LOOPUP2E            LDA $0F
                    CMP #$80
                    BCC LOOPUP2EE
                    LDA #$7F
                    STA $0F
LOOPUP2EE           RTS







LEFT_SPEED1         STZ $0F38
                    LDA $0F
                    CMP $1570,x
                    BCC LEFT1_2
                    LDA #$02
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_40
                    BRA LEFT1_3
LEFT1_2             CMP $151C,x
                    BCS LEFT1_3
                    LDA #$01
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_20
                    BRA LEFT1_3
LEFT1_3             LDA #$00
                    SEC
                    SBC $0F
                    STA $1504,x
                    RTS

LEFT1_40            
LOOP140             LDA $0F
                    CMP $1570,x
                    BCC LOOP140E
                    LSR A
                    STA $0F
                    INC $0F37
                    BRA LOOP140
LOOP140E            RTS
LEFT1_20            
LOOP120             LDA $0F
                    CMP $151C,x
                    BCS LOOP120E
                    ASL A
                    STA $0F
                    INC $0F37
                    BRA LOOP140
LOOP120E            RTS

LEFT_SPEED2         STZ $0F37
                    INC $0F37
                    LDA $0F
                    LSR A
                    CLC
                    ADC #$80
                    STA $0F
                    LDA #$02
                    STA $0F38
                    JSR LEFT1_40
                    LDA #$00
                    SEC
                    SBC $0F
                    STA $1504,x
                    RTS

RIGHT_SPEED         STZ $0F38
                    LDA #$00
                    SEC
                    SBC $0F
                    STA $0F
                    CMP $1570,x
                    BCC RIGHT_2
                    LDA #$02
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_40
                    BRA RIGHT_3
RIGHT_2             CMP $151C,x
                    BCS RIGHT_3
                    LDA #$01
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_20
                    BRA RIGHT_3
RIGHT_3             LDA $0F
                    STA $1504,x
                    RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; difference in y position
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_GET_Y_DIFF      LDY #$00                
                    LDA $D3                 
                    PHA
                    CLC                     
                    ADC #$10                
                    STA $D3                 
                    LDA $D4                 
                    PHA
                    ADC #$00                
                    STA $D4                 

                    LDA $D3                 
                    SEC                     
                    SBC $D8,x               
                    STA $0E                 
                    LDA $D4                 
                    SBC $14D4,x             
                    BPL LABEL14            
                    INY                     
LABEL14             TYA                     ;  | 
                    STA $7FF010 
                    
                    PLA
                    STA $D4
                    PLA
                    STA $D3
                    
                    RTS                    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; difference in x position
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   

SUB_GET_X_DIFF      LDY #$00                
                    LDA $D1                 
                    SEC                    
                    SBC $E4,x              
                    STA $0F                 
                    LDA $D2                 
                    SBC $14E0,x            
                    BPL TO_RIGHT            
TO_LEFT             INY                     
                    LDA $0F
                    CMP #$B0
                    BCS SET_VAL
                    INY
                    INY                 
                    BRA SET_VAL
TO_RIGHT            LDA $0F
                    CMP #$50
                    BCC SET_VAL
                    INY
                    INY 
SET_VAL             TYA
                    STA $7FF011 
                    RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Map 16 Routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GEN_BLOCK			PHP
                    REP #$30                ; \ change sprite to block 
                    LDA.W #$012E
                    STA $03                 ;  |
                    JSR SUBL_SET_MAP16      ;  |
                    PLP
					RTS
					
RESET_BLOCK			PHP
                    REP #$30                ; \ change sprite to block 
                    LDA.W #$0846
                    STA $03                 ;  |
                    JSR SUBL_SET_MAP16      ;  |
                    PLP
					RTS


SUBL_SET_MAP16      PHP                     
                    REP #$30                
                    PHY                    
                    PHX                     
                    TAX                    
                    LDA $03                 
                    PHA                    
                    JSR SUB_8034           
                    PLA                  
                    STA $03                 
                    PLX                     
                    PLY                     
                    PLP                     
                    RTS                    

                    JMP $FEA301
RETURN18            PLX
                    PLB
                    PLP
                    RTS

SUB_8034            PHP                      
                    SEP #$20                
                    PHB                     
                    LDA #$00                 
                    PHA                  
                    PLB                   
                    REP #$30                 
                    PHX                     
                    LDA $9A                 ;A:0200 X:0266 Y:0001 0426 
                    STA $0C                 ;A:0070 X:0266 Y:0001 0458 
                    LDA $98                 ;A:0070 X:0266 Y:0001 0490 
                    STA $0E                 ;A:0130 X:0266 Y:0001 0522 
                    LDA.W #$0000            ;A:0130 X:0266 Y:0001 0554 
                    SEP #$20                ;A:0000 X:0266 Y:0001 0578 
                    LDA $5B                 ;A:0000 X:0266 Y:0001 0600 
                    STA $09                 ;A:0000 X:0266 Y:0001 0624 
                    LDA $1933               ;A:0000 X:0266 Y:0001 0648
                    BEQ NO_SHIFT            ;A:0000 X:0266 Y:0001 0680 
                    LSR $09
NO_SHIFT            LDY $0E                 ;A:0000 X:0266 Y:0001 0702 
                    LDA $09                 ;A:0000 X:0266 Y:0130 0734 
                    AND #$01                ;A:0000 X:0266 Y:0130 0758 
                    BEQ HORIZ               ;A:0000 X:0266 Y:0130 0774 
                    LDA $9B
                    STA $00
                    LDA $99
                    STA $9B
                    LDA $00  
                    STA $99
                    LDY $0C
HORIZ               CPY.W #$0200            ;A:0000 X:0266 Y:0130 0796 
                    BCS RETURN18            ;A:0000 X:0266 Y:0130 0820 
                    LDA $1933               ;A:0000 X:0266 Y:0130 0836 
                    ASL A                   ;A:0000 X:0266 Y:0130 0868 
                    TAX                     ;A:0000 X:0266 Y:0130 0882 
                    LDA $BEA8,x ;[$00:BEA8] ;A:0000 X:0000 Y:0130 0896 
                    STA $65                 ;A:00A8 X:0000 Y:0130 0928 
                    LDA $BEA9,x ;[$00:BEA9] ;A:00A8 X:0000 Y:0130 0952 
                    STA $66                 ;A:00BD X:0000 Y:0130 0984 
                    STZ $67                 ;A:00BD X:0000 Y:0130 1008 
                    LDA $1925               ;A:00BD X:0000 Y:0130 1032 
                    ASL A                   ;A:0000 X:0000 Y:0130 1064 
                    TAY                     ;A:0000 X:0000 Y:0130 1078 
                    LDA ($65),y ;[$00:BDA8] ;A:0000 X:0000 Y:0000 1092 
                    STA $04                 ;A:00D8 X:0000 Y:0000 1132 
                    INY                     ;A:00D8 X:0000 Y:0000 1156 
                    LDA ($65),y ;[$00:BDA9] ;A:00D8 1170 
                    STA $05                 ;A:00BA 1210 
                    STZ $06                 ;A:00BA 1234 
                    LDA $9B                 ;A:00BA 1258 
                    STA $07                 ;A:0000 1282 
                    ASL A                   ;A:0000 1306 
                    CLC                     ;A:0000 1320 
                    ADC $07                 ;A:0000 1334 
                    TAY                     ;A:0000 1358 
                    LDA ($04),y ;[$00:BAD8] ;A:0000 X:0000 Y:0000 0004  
                    STA $6B                 ;A:0000 X:0000 Y:0000 0044  
                    STA $6E                 ;A:0000 X:0000 Y:0000 0068  
                    INY                     ;A:0000 X:0000 Y:0000 0092  
                    LDA ($04),y ;[$00:BAD9] ;A:0000 0106  
                    STA $6C                 ;A:00C8 0146  
                    STA $6F                 ;A:00C8 0170  
                    LDA #$7E                ;A:00C8 0194  
                    STA $6D                 ;A:007E 0210  
                    INC A                   ;A:007E 0234  
                    STA $70                 ;A:007F 0248  
                    LDA $09                 ;A:007F 0272  
                    AND #$01                ;A:0000 0296  
                    BEQ NO_AND              ;A:0000 0312  
                    LDA $99
                    LSR A
                    LDA $9B 
                    AND #$01
                    BRA LABEL52
NO_AND              LDA $9B                 ;A:0000 0334  
                    LSR A                   ;A:0000 0358  
                    LDA $99                 ;A:0000 0372  
LABEL52             ROL A                   ;A:0001 0396  
                    ASL A                   ;A:0002 0410  
                    ASL A                   ;A:0004 0424  
                    ORA #$20                ;A:0008 0438  
                    STA $04                 ;A:0028 0454  
                    CPX.W #$0000            ;A:0028 0478  
                    BEQ NO_ADD              ;A:0028 0502  
                    CLC
                    ADC #$10 
                    STA $04
NO_ADD              LDA $98                 
                    AND #$F0                
                    CLC                     ;A:0030 0564  
                    ASL A                   ;A:0030 0578  
                    ROL A                   ;A:0060 0592  
                    STA $05                 ;A:00C0 0606  
                    ROL A                   ;A:00C0 0630  
                    AND #$03                ;A:0080 0644  
                    ORA $04                 ;A:0000 0660  
                    STA $06                 ;A:0028 0684  
                    LDA $9A                 ;A:0028 0708  
                    AND #$F0                ;A:0070 0732  
                    LSR A                   ;A:0070 0748  
                    LSR A                   ;A:0038 0762  
                    LSR A                   ;A:001C 0776  
                    STA $04                 ;A:000E 0790  
                    LDA $05                 ;A:000E 0814  
                    AND #$C0                ;A:00C0 0838  
                    ORA $04                 ;A:00C0 0854  
                    STA $07                 ;A:00CE 0878  
                    REP #$20                ;A:00CE 0902  
                    LDA $09                 ;A:00CE 0924  
                    AND.W #$0001            ;A:0100 0956  
                    BNE LABEL51             ;A:0000 0980  
                    LDA $1A                 ;A:0000 0996  
                    SEC                     ;A:0000 1028  
                    SBC.W #$0080            ;A:0000 1042  
                    TAX                     ;A:FF80 1066  
                    LDY $1C                 ;A:FF80 X:FF80 Y:0001 1080  
                    LDA $1933               ;A:FF80 X:FF80 Y:00C0 1112  
                    BEQ LABEL50             ;A:0000 X:FF80 Y:00C0 1152  
                    LDX $1E
                    LDA $20
                    SEC
                    SBC.W #$0080
                    TAY
                    BRA LABEL50
LABEL51             LDX $1A
                    LDA $1C
                    SEC
                    SBC.W #$0080
                    TAY
                    LDA $1933
                    BEQ LABEL50
                    LDA $1E
                    SEC
                    SBC.W #$0080
                    TAX  
                    LDY $20
LABEL50             STX $08                
                    STY $0A               
                    LDA $98               
                    AND.W #$01F0          
                    STA $04              
                    LDA $9A              
                    LSR A                
                    LSR A                
                    LSR A                
                    LSR A                
                    AND.W #$000F          
                    ORA $04              
                    TAY                    
                    PLA              
                    SEP #$20               
                    STA [$6B],y ;[$7E:C937] 
                    XBA                     
                    STA [$6E],y ;[$7F:C937] 
                    XBA                    
                    REP #$20                
                    ASL A              
                    TAY                     
                    PHK                   
                    PER.W #$0006           
                    PEA $804C
                    JMP.L $00C0FB
MAP16_RETURN        PLB
                    PLP
                    RTS

                    
                    NOP                    
