;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ShapeSister
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    EXTRA_BITS = $7FAB10
					NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA #$0E
					STA $1602,x
					LDA EXTRA_BITS,x
					AND #$04
					BEQ INIT_R
					LDA #$0C
					STA $1602,x
INIT_R              RTL
                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SHADOW				LDA $77
					AND #$04
					BEQ SHADOW2
					LDA $14
					AND #$01
					BNE SHADOW2
					JSR SUB_GFX3
SHADOW2				JSR DELETE_SAME
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					CLC
					ADC #$1F
					STA $D8,x
					LDA $97
					ADC #$00
					STA $14D4,x
					LDA $76
					EOR #$01
					STA $157C,x
					RTS


RETURN              RTS                    
START_HB_CODE       LDA $13BF
					CMP #$19
					BEQ SHADOW
					CMP #$10
					BEQ SHADOW
					LDA $C2,x
					BNE SHADOW_ZERO
					JSR SUB_GFX             ; draw hammer bro gfx
					LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSR NEAR_CHECK
					CPY #$00
					BEQ MAIN
					JSR CHANGE
					RTS
MAIN 				JSL $01802A
					LDA EXTRA_BITS,x
					AND #$04
					BNE RETURN
					LDA $1588,x
					AND #$04
					BEQ RETURN2
					LDA $15AC,x
					BNE RETURN
					LDA #$C0
					STA $AA,x
					RTS
RETURN2             LDA #$30
					STA $15AC,x
					RTS
SHADOW_ZERO			JSR SUB_GFX2            ; draw hammer bro gfx
					LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN2              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN2
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSL $01802A
					JSR POS_CHECK
					CPY #$01
					BEQ SHADOW_R
					JSL $01A7DC
					LDA $76
					STA $157C,x
					LDA #$00
					SEC
					SBC $7B
					STA $B6,x
					LDA $7D
					STA $AA,x
SHADOW_R			RTS

POS_CHECK			LDY #$00
					LDA $1504,x
					SEC
					SBC $D8,x
					LDA $1570,x
					SBC $14D4,x
					BCS POS_R
					LDY #$01
POS_R				RTS

NEAR_CHECK			LDY #$00
					LDA $E4,x
					SEC
					SBC $94
					STA $0F
					LDA $14E0,x
					SBC $95
					STA $02
					BCS NEAR_RIGHT
					LDA $02
					CMP #$FF
					BNE NEAR_R
					LDA $0F
					CMP #$B0
					BCC NEAR_R
					LDY #$01
					STZ $157C,x
NEAR_R				RTS
NEAR_RIGHT			LDA $02
					CMP #$00
					BNE NEAR_R
					LDA $0F
					CMP #$50
					BCS NEAR_R
					LDY #$01
					LDA #$01
					STA $157C,x
					RTS
					
CHANGE				LDA #$10
					STA $1DF9
					JSR SUB_SMOKE
					LDA EXTRA_BITS,x
					AND #$04
					BNE D_CHANGE
					JSR MAKE_SPRITE
					LDA $157C,x
					STA $157C,y
					LDA $15F6,y
					;AND #$F1
					ORA #$0E
					STA $15F6,y
					LDY $161A,x
                    LDA #$00
                    STA $1938,y
					STZ $14C8,x  
					RTS
D_CHANGE			LDA NEW_SPRITE_NUM,x
					STA $151C,x
					LDA #$01
					STA $C2,x
					LDA $D8,x
					STA $1504,x
					LDA $14D4,x
					STA $1570,x
					RTS
					
SPRITE				dcb $09,$13,$1D,$91,$15,$75,$01,$02

MAKE_SPRITE			LDA $13
					AND #$07
					TAY
					LDA SPRITE,y
					STA $151C,x
					CMP #$01
					BEQ MAKE_SPRITE2
					CMP #$02
					BEQ MAKE_SPRITE2
					JSR GEN_SPRITE
					RTS
MAKE_SPRITE2		JSR GEN_SPRITE2
					RTS

RETURN68            RTS
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots ful
                    BMI RETURN68            ; / after: Y has index of sprite being generated
					LDA $151C,x
					STA $009E,y
					LDA #$08
					STA $14C8,y
					LDA $E4,x
                    STA $00E4,y
                    LDA $14E0,x
                    STA $14E0,y             ; /
                    LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    PLX
					RTS

RETURN67            RTS
GEN_SPRITE2         JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
					LDA $151C,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
					LDA $E4,x
                    STA $00E4,y
                    LDA $14E0,x
                    STA $14E0,y             ; /
					LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return
					
SUB_SMOKE           LDY #$03                ; \ find a free slot to display effect
FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
                    RTS                     ; / return if no slots open
FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    ;LDA $178B,x
					LDA $D8,x 
                    STA $17C4,y             ; /
                    LDA #$1B                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $E4,x             ; \ load generator x position
                    STA $17C8,y             ; /
                    RTS           
					
					
DELETE_SAME			TXA
					STA $02
					PHX
					LDX #$00
DELETE_LOOP			CPX $02
					BEQ DELETE_2
					LDA $9E,x
					CMP #$22
					BNE DELETE_2
					STZ $14C8,x
DELETE_2			INX
					CPX #$0A
					BNE DELETE_LOOP
					PLX
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
					LDA #$A8
					STA $0302,y
					LDA $1588,x
					AND #$04
					BNE NOT_AIR
					LDA #$AA
					STA $0302,y
NOT_AIR				LDA $01
					STA $0301,y
					LDA $00                 ; \ 
                    STA $0300,y             ; /

					LDA $1602,x
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
TILEMAP             dcb $00,$02
VERT_DISP           dcb $F0,$00
PROPERTIES			dcb $40,$00
VERT_DISP2          dcb $10,$00
PROPERTIES2			dcb $C0,$80

SUB_GFX2            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					LDA $157C,x
					STA $02
                    PHX                     ; push sprite index
                    LDX #$01
LOOP_START          
					LDA $01
					CLC
					ADC VERT_DISP,x
					STA $0301,y
					
					LDA $00
                    STA $0300,y             ; /
					
					LDA TILEMAP,x           ; \ store tile
                    STA $0302,y

					PHX
					LDX $02
                    LDA PROPERTIES,x
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    PLX

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$01                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
SUB_GFX3            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					LDA $157C,x
					STA $02
                    PHX                     ; push sprite index
                    LDX #$01
LOOP_START3          
					LDA $01
					CLC
					ADC VERT_DISP2,x
					STA $0301,y
					
					LDA $00
                    STA $0300,y             ; /
					
					LDA TILEMAP,x           ; \ store tile
                    STA $0302,y

					PHX
					LDX $02
                    LDA PROPERTIES2,x
                    ;ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    PLX

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START3          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$01                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return


