;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Ski
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                    
START_HB_CODE       LDA EXTRA_BITS,x
					AND #$04
					BEQ MAIN
					JSR STONE
					RTS
MAIN				JSR SUB_GFX2
                    LDA $9D                 ; \ if sprites locked...
                    BNE RETURN              ; /    ... return
					JSR MARIO_STATUS
					JSR WARP
					JSL $01802A
					LDA $C2,x
					BNE MODE2
					JSR SPEED_CHECK
					JSR GRA_CHECK
					LDA $7FFE00
					BEQ RETURN2
					LDA #$01
					STA $C2,x
					LDA #$20
					STA $B6,x
					LDA #$C0
					STA $AA,x
					LDA #$03
					STA $1602,x
RETURN2				RTS

MODE2				JSR SPEED_CHECK2
					LDA $C2,x
					CMP #$02
					BEQ MODE3
					LDA $1588,x
					AND #$04
					BEQ MODE2_R
					LDA #$02
					STA $C2,x
					STZ $1570,x
					LDA #$04
					STA $7FFE01
					LDA #$00
					STA $7FFE02
					LDA #$C8
					STA $7FFE03
					LDA #$01
					STA $7FFE04
MODE2_R				RTS
MODE3				JSR GRA_CHECK2
					RTS
					
					
MARIO1				dcb $C8,$E8,$CA,$EA,$C8,$E8,$CA,$EA
MARIO2				dcb $01,$01,$01,$01,$C1,$C1,$C1,$C1
GRA_CHECK2			LDA $14
					LSR A
					LSR A
					LSR A
					AND #$07
					TAY
					LDA MARIO1,y
					STA $7FFE03
					LDA MARIO2,y
					STA $7FFE04
					LDA $1570,x
					CMP #$80
					BCS GRA_CHECK2_R
					LDA $1588,x
					AND #$04
					BEQ GRA_CHECK2_R
					INC $1570,x
					LDA $1570,x
					CMP #$20
					BEQ GRA_CHECK2_3
					CMP #$40
					BEQ GRA_CHECK2_4
GRA_CHECK2_R		RTS
GRA_CHECK2_3		LDA #$05
					STA $7FFE02
					RTS
GRA_CHECK2_4		LDA #$09
					STA $7FFE01
					LDA #$0A
					STA $7FFE02
					RTS

WARP				LDA $14E0,x
					CMP #$0A
					BNE WARP_2
					LDA $E4,x
					CMP #$E0
					BCC WARP_2
					LDA #$06
					STA $71
					STZ $89
					STZ $88
WARP_2				RTS

SPEED_CHECK2		LDA $1588,x
					AND #$01
					BEQ SPEED_R2
					STZ $B6,x
SPEED_R2			RTS

SPEED_CHECK			LDA $B6,x
					CMP #$30
					BCS SPEED_2
					INC $B6,x
SPEED_2				LDA $1588,x
					AND #$01
					BEQ SPEED_3
					STZ $B6,x
					LDA $1588,x
					AND #$04
					BEQ SPEED_3
					LDA $D8,x
					SEC
					SBC #$04
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
SPEED_3				LDA $1588,x
					AND #$04
					BEQ SPEED_R
					LDA $16
					AND #$80
					BEQ SPEED_R
					LDA #$C0
					STA $AA,x
SPEED_R				RTS

MARIO_STATUS		LDA $E4,x
					STA $94
					LDA $14E0,x
					STA $95
					LDA $D8,x
					STA $96
					LDA $14D4,x
					STA $97
					LDA #$40
					STA $0D89
					STA $0D93
					LDA #$51
					STA $0D8A
					STA $0D94
					LDA #$40
					STA $13E0
					STA $18BD
					LDA #$01     
                    STA $1471    ;#ntO
					LDA $14D4,x
					BEQ STATUS_R
					LDA $D8,x
					CMP #$90
					BCC STATUS_R
					STZ $14C8,x
					STZ $18BD
STATUS_R			RTS

GRA_CHECK			LDA $1588,x
					AND #$04
					BEQ GRA_R
					JSL $019138
					LDA $03
					CMP #$72
					BEQ GRA_1
					CMP #$73
					BEQ GRA_1
					CMP #$61
					BEQ GRA_1
					CMP #$62
					BEQ GRA_1
					CMP #$71
					BEQ GRA_1
					CMP #$74
					BEQ GRA_1
					CMP #$6B
					BEQ GRA_2
					CMP #$6C
					BEQ GRA_2
					CMP #$69
					BEQ GRA_3
					CMP #$68
					BEQ GRA_3
					CMP #$67
					BEQ GRA_3
					CMP #$6D
					BEQ GRA_2
					CMP #$93
					BEQ GRA_3
GRA_R				RTS
GRA_1				STZ $1602,x
					RTS
GRA_2				LDA #$01
					STA $1602,x
					RTS
GRA_3				LDA #$02
					STA $1602,x
					LDA $D8,x
					SEC
					SBC #$04
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					RTS


STONE				JSR SUB_GFX
                    LDA $9D                 ; \ if sprites locked...
                    BNE RETURNS2              ; /    ... return
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSR MARIO_CHECK
RETURNS2			RTS
					
MARIO_CHECK			LDA $7FFE00
					BEQ CHECK_1
					RTS
CHECK_1				LDA $E4,x
					PHA
					CLC
					ADC #$08
					STA $E4,x
					LDA $14E0,x
					PHA
					ADC #$00
					STA $14E0,x
					JSL $01A7DC
					BCS CHECK_2
					LDA $E4,x
					CLC
					ADC #$08
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					JSL $01A7DC
					BCS CHECK_2
					LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					JSL $01A7DC
					BCS CHECK_2
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS
CHECK_2				PLA
					STA $14E0,x
					PLA
					STA $E4,x
					LDA #$01
					STA $7FFE00
					LDA #$02
					STA $1DF9
					RTS



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP             dcb $88,$8A,$8C,$A8,$AA,$AC
HORZ_DISP			dcb $00,$10,$20,$00,$10,$20
VERT_DISP			dcb $F0,$F0,$F0,$00,$00,$00

SUB_GFX            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                    PHX                     ; push sprite index
					LDX #$05
LOOP_START          LDA $00
					CLC
					ADC HORZ_DISP,x
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_DISP,x
					STA $0301,y
					
					LDA TILEMAP,x           ; \ store tile
                    STA $0302,y
					
					LDA #$0F
                    STA $0303,y             ; / store tile properties


                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$05                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
            
					
TILEMAP2            dcb $C0,$C2,$E0,$E2
					dcb $C4,$C6,$E4,$E6
					dcb $84,$86,$A4,$A6
					dcb $A6,$A4,$86,$84
HORZ_DISP2			dcb $F8,$08,$F8,$08
VERT_DISP2			dcb $F0,$F0,$00,$00

SUB_GFX2            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                    LDA $C2,x
					CMP #$02
					BNE GFX00
					JSR SNOW_GFX
					RTS
GFX00               PHX                     ; push sprite index
					LDA #$0D
					STA $0F
					LDA $1602,x
					ASL A
					ASL A
					STA $03
					CMP #$0C
					BNE SUB_GFX2_1
					LDA #$CD
					STA $0F
SUB_GFX2_1			LDX #$03
LOOP_START2         LDA $00
					CLC
					ADC HORZ_DISP2,x
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_DISP2,x
					STA $0301,y
					
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILEMAP2,x           ; \ store tile
                    STA $0302,y
					PLX
					
					LDA $0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties


                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START2          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

TILEMAP3            dcb $00,$02,$20,$22,$77
					dcb $40,$42,$60,$62,$77
					dcb $04,$06,$08,$24,$26,$28,$44,$46,$48,$77
HORZ_DISP3			dcb $F8,$08,$F8,$08,$00
					dcb $F8,$08,$F8,$08,$00
					dcb $F0,$00,$10,$F0,$00,$10,$F0,$00,$10,$00
VERT_DISP3			dcb $F0,$F0,$00,$00,$F8
					dcb $F0,$F0,$00,$00,$F8
					dcb $E0,$E0,$E0,$F0,$F0,$F0,$00,$00,$00,$F4

SNOW_GFX            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                    PHX                     ; push sprite index
					LDA $7FFE01
					TAX
LOOP_START3         PHX
					TXA
					CLC
					ADC $7FFE02
					TAX
					
					LDA $00
					CLC
					ADC HORZ_DISP3,x
					STA $0300,y
					
					LDA $01
					CLC
					ADC VERT_DISP3,x
					STA $0301,y
					
					LDA TILEMAP3,x           ; \ store tile
					CMP #$77
					BEQ SNOW_GFX_2
                    STA $0302,y
					PLX
					
					LDA #$0F
					ORA $64
                    STA $0303,y             ; / store tile properties
					
					BRA SNOW_GFX_3
					
SNOW_GFX_2			PLX
					LDA $7FFE03
					STA $0302,y
					LDA $7FFE04
					ORA $64
					STA $0303,y


SNOW_GFX_3          INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START3          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA $7FFE01
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /



