;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Syuho
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;      
                    dcb "INIT"
					TXA
					STA $7FF001
					STZ $1570,x
					STZ $C2,x
					STZ $1504,x
					STZ $1602,x
					LDA #$C0
					STA $15AC,x
					LDA #$0D
					STA $151C,x
					LDA $D8,x
					CLC
					ADC #$08
					STA $D8,x
					LDA $E4,x
					SEC
					SBC #$03
					STA $E4,x
					LDA #$01
					STA $7FFFDF
					LDA #$1B
					STA $7FFFE0
					LDA #$0E
					STA $7FFFE1
					LDA #$0A
					STA $7FFFE2
					LDA #$0C
					STA $7FFFE3
					LDA #$1D
					STA $7FFFE4
					LDA #$18
					STA $7FFFE5
					LDA #$1B
					STA $7FFFE6
                    RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                     ; return           
CODE_START          LDA $C2,x
					BNE MAING
					JSR SUB_GFX
					LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
					JSR LIFE_GAGE
					LDA $94
					CMP #$70
					BCC MAIN0
					LDA #$70
					STA $94
MAIN0				INC $1570,x
					JSR MOVE
					JSL $01802A
					LDA $1528,x
					BNE NOT_MODE0
					JSR MODE0
					RTS
NOT_MODE0			CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$02
					BNE NOT_MODE2
					JSR MODE2
					RTS
NOT_MODE2			CMP #$03
					BNE NOT_MODE3
					JSR MODE3
					RTS
NOT_MODE3			JSR MODE4
					RTS
					
MAING				JSR SUB_GFX2
					LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN
					JSL $01A7DC             ; check for mario/sprite contact
                    BCC MAING1
					LDA $1497               ; \ if mario is invincible...
                    BNE MAING1
                    JSL $00F5B7
MAING1				LDA $C2,x
					CMP #$02
					BEQ MAING3
					CMP #$03
					BEQ MAING4
					JSR SPEED
					LDA #$02
					STA $C2,x				
MAING3				LDA $1504,x
					STA $B6,x
					LDA $1594,x
					STA $AA,x
					JSL $01802A
					JSR REFLECT
					LDA $14D4,x
					BNE MAING_E
					LDA $14E0,x
					BNE MAING_E
					RTS
MAING_E				STZ $14C8,x
					RTS
MAING4				JSR DAMAGE_CHECK
					BRA MAING3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP             dcb $80,$82,$A0,$A2
HORZ_DISP           dcb $F8,$08,$F8,$08
VERT_DISP           dcb $F8,$F8,$08,$08

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
					PHX                     ; push sprite index
					LDA $151C,x
					STA $03
                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START          PHX                     ; push current tile number

					LDA $00
					CLC                     ;  |
                    ADC HORZ_DISP,x         ;  |
                    STA $0300,y             ; /      

                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP,x         ;  |
                    STA $0301,y             ; /
                    
					
                    LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; / 
        
                    LDA $03
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
	                LDA $1504,x
					BNE GFX2
GFX1				LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
GFX2				LDA $1570,x
					LSR A
					AND #$01
					BEQ GFX1
					LDA #$76
                    STA $0300,y             ; /      
                    LDA #$88                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y             ; /
                    LDA #$84
                    STA $0302,y             ; / 
                    LDA #$0D
                    ORA $64                 ;  | put in level properties
                    STA $0303,y
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$04                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3
					RTS
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_GFX2            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
					LDA $00
                    STA $0300,y             ; /      

                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y             ; /
                    
					
                    LDA #$86
                    STA $0302,y             ; / 
        
                    LDA #$0D
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					
	                LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS              
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Y_SPEED				dcb $F8,$08
MOVE				STZ $B6,x
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$01
					TAY
					LDA Y_SPEED,y
					STA $AA,x
					LDA $1602,x
					CMP #$04
					BNE MOVE_E
					STZ $AA,x
MOVE_E				RTS
					
					

MODE0				LDA $15AC,x
					BEQ MODE0_3
					CMP #$21
					BEQ MODE0_1
					CMP #$21
					BCC MODE0_2
					RTS
					RTS
MODE0_1				LDA #$FF
					SEC
					SBC $94
					SBC #$08
					STA $1466
					RTS
MODE0_2				INC $1468
					RTS
MODE0_3				LDA #$01
					STA $1528,x
					LDA #$FF
					STA $15AC,x
					RTS

MODE1				LDA $15AC,x
					BEQ MODE1_7
					CMP #$9F
					BEQ MODE1_2
					CMP #$A0
					BCS MODE1_1
					CMP #$8C
					BCS MODE1_3
					CMP #$58
					BCS MODE1_4
					CMP #$57
					BEQ MODE1_5
					CMP #$57
					BCC MODE1_6
					RTS
MODE1_2				LDA #$17
					STA $1DFC
					STZ $1594,x
					STZ $1504,x
					RTS
MODE1_1				LDA #$01
					STA $1504,x
					RTS
MODE1_3				INC $1594,x
					JSR HDMA
					RTS
MODE1_4				JSR CHECK_DAMAGE
					RTS
MODE1_5				JSR RESET_HDMA
MODE1_R				RTS
MODE1_6				LDA $1468
					BEQ MODE1_R
					DEC $1468
					RTS
MODE1_7				LDA #$FF
					STA $15AC,x
					LDA #$02
					STA $1528,x
					RTS
					
MODE2				LDA $15AC,x
					BEQ MODE2_3
					CMP #$C1
					BCS MODE2_R
					CMP #$C0
					BEQ MODE2_1
					CMP #$60
					BCS MODE2_2
					JSR TARGET
MODE2_R				RTS
MODE2_1				LDA #$FF
					SEC
					SBC $94
					SBC #$08
					STA $1466
					RTS
MODE2_2				INC $1468
					RTS
MODE2_3				LDA #$03
					STA $1528,x
					LDY #$03
					LDA #$00
					STA $17CC,y
					LDA #$FF
					STA $15AC,x
					RTS
					
MODE3				LDA $15AC,x
					BEQ MODE3_3
					CMP #$FE
					BEQ MODE3_G
					CMP #$80
					BCC MODE3_2
					RTS
MODE3_G				LDA #$09
					STA $1DFC
					JSR GEN_SP
					LDA #$01
					STA $00C2,y
					LDA #$19
					STA $1686,y
					RTS
MODE3_2				LDA $1468
					BEQ MODE3_R
					DEC $1468
MODE3_R				RTS
MODE3_3				LDA #$60
					STA $15AC,x
					STZ $1528,x
					RTS

MODE4				LDA $15AC,x
					BNE MODE4_E
					PHP
					SEP #$30
					LDA #$06
					STA $71
					STZ $89
					STZ $88
					PLP
MODE4_E				RTS



REFLECT				LDA $1588,x
					AND #$03
					BNE REFLECT2
					LDA $1588,x
					AND #$0C
					BNE REFLECT3
					RTS
REFLECT2			LDA #$03
					STA $C2,x
					LDA #$99
					STA $1686,x
					LDA #$00
					SEC
					SBC $1504,x
					STA $1504,x
					RTS
REFLECT3			LDA #$03
					STA $C2,x
					LDA #$00
					SEC
					SBC $1594,x
					STA $1594,x
					RTS


TARGET				LDA $13
					AND #$0F
					BNE TARGET2
					LDA #$01
					STA $1DFC
TARGET2				LDY #$03
					LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    LDA $96
					CLC
					ADC #$10
                    STA $17C4,y             ; /
                    
                    LDA #$33                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $94
                    STA $17C8,y             ; /
                    RTS      

GAGE_E				RTS
LIFE_GAGE			LDA #$FD
					STA $7FFFE7
					STA $7FFFE8
					STA $7FFFE9
					STA $7FFFEA
					LDA #$FC
					STA $7FFFEB
					STA $7FFFEC
					STA $7FFFED
					STA $7FFFEE
					STA $7FFFEF
					LDA $1602,x
					CMP #$01
					BCS GAGE_2
					RTS
GAGE_2				LDA #$FC
					STA $7FFFE7
					LDA $1602,x
					CMP #$02
					BCS GAGE_3
					RTS
GAGE_3				LDA #$FC
					STA $7FFFE8
					LDA $1602,x
					CMP #$03
					BCS GAGE_4
					RTS
GAGE_4				LDA #$FC
					STA $7FFFE9
					LDA $1602,x
					CMP #$04
					BCS GAGE_5
					RTS
GAGE_5				LDA #$FC
					STA $7FFFEA
					RTS

CHECK_DAMAGE		LDA $96
					CMP #$91
					BCS CHECK_1
					CMP #$68
					BCC CHECK_1
					LDA $1497
                    BNE CHECK_1
                    JSL $00F5B7  
CHECK_1				RTS


DAMAGE_CHECK        LDA $14E0,x
					BNE CHECK_E
					LDA $14D4,x
					BNE CHECK_E

					LDA $E4,x
                    CMP #$B8
					BCC CHECK_E
					CMP #$C8
					BCS CHECK_E
                    LDA $D8,x
					CMP #$40
					BCC CHECK_E
					CMP #$71
					BCS CHECK_E
					STZ $14C8,x
                    LDA #$28
					STA $1DFC
					PHX
                    LDA $7FF001
					TAX
					INC $1602,x
					LDA $1602,x
					CMP #$04
					BCS THEEND
					PLX
CHECK_E             RTS
THEEND				LDA #$80
					STA $15AC,x
					LDA #$04
					STA $1528,x
					STZ $1468
					LDA #$1E
					STA $1DFB
					LDA #$0F
					STA $151C,x
					PLX
					RTS
					



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SPEED_DEC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   
SPEED				LDA #$30
					STA $1570,x
					LDA #$18
					STA $151C,x
					LDA $96
					PHA
					CLC
					ADC #$10
					STA $96
					LDA $97
					PHA
					ADC #$00
					STA $97
					JSR SPEED_DEC
					PLA
					STA $97
					PLA
					STA $96
					RTS
					
SPEED_DEC           LDA $E4,x
                    SEC
                    SBC $94
                    STA $0F
                    LDA $14E0,x
                    SBC $95
                    BPL FACE_LEFT
                    JSR RIGHT_SPEED
                    BRA VERC
FACE_LEFT           CMP #$01
                    BEQ LEFT2
                    JSR LEFT_SPEED1
                    BRA VERC
LEFT2               JSR LEFT_SPEED2
VERC                LDA $D8,x
                    SEC
                    SBC $96
                    STA $0F
                    LDA $14D4,x
                    SBC $97
                    BPL FACE_UP
                    JSR DOWN_SPEED
                    LDA $1594,x
                    CMP #$10
                    BCS VER_E
                    LDA #$10
                    STA $1594,x
                    BRA VER_E
FACE_UP             JSR UP_SPEED
                    LDA $1594,x
                    CMP #$F0
                    BCC VER_E
                    LDA #$F0
                    STA $1594,x
VER_E               RTS

UP_SPEED            LDA $0F38
                    CMP #$00
                    BNE UP3
                    LDA $0F
                    CMP #$80
                    BCC UP2
                    LDA #$7F
UP2                 STA $0F
                    BRA UP5
UP3                 CMP #$02
                    BNE UP4
                    JSR UP1_1
                    BRA UP5
UP4                 JSR UP1_2
UP5                 LDA #$00
                    SEC
                    SBC $0F
                    STA $1594,x
                    RTS

DOWN_SPEED          LDA #$00
                    SEC
                    SBC $0F
                    STA $0F
                    LDA $0F38
                    CMP #$00
                    BNE DOWN3
                    LDA $0F
                    CMP #$80
                    BCC DOWN2
                    LDA #$7F
DOWN2               STA $1594,x
                    RTS
DOWN3               CMP #$02
                    BNE DOWN4
                    JSR UP1_1
                    BRA DOWN5
DOWN4               JSR UP1_2
DOWN5               LDA $0F
                    STA $1594,x
                    RTS
UP1_1
LOOPUP1             LDA $0F37
                    BEQ LOOPUP1E
                    LDA $0F
                    LSR A
                    STA $0F
                    DEC $0F37
                    LDA $0F37
                    BNE LOOPUP1
LOOPUP1E            LDA $0F
                    CMP #$80
                    BCC LOOPUP1EE
                    LDA #$7F
                    STA $0F
LOOPUP1EE           RTS

UP1_2               LDA $0F
                    CMP #$80
                    BCC LOOPUP3
                    LDA #$7F
                    STA $0F
                    STZ $0F37
                    RTS
LOOPUP3             LDA $0F37
                    BEQ LOOPUP2E
                    LDA $0F
                    ASL A
                    STA $0F
                    DEC $0F37
                    LDA $0F37
                    BNE UP1_2
LOOPUP2E            LDA $0F
                    CMP #$80
                    BCC LOOPUP2EE
                    LDA #$7F
                    STA $0F
LOOPUP2EE           RTS







LEFT_SPEED1         STZ $0F38
                    LDA $0F
                    CMP $1570,x
                    BCC LEFT1_2
                    LDA #$02
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_40
                    BRA LEFT1_3
LEFT1_2             CMP $151C,x
                    BCS LEFT1_3
                    LDA #$01
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_20
                    BRA LEFT1_3
LEFT1_3             LDA #$00
                    SEC
                    SBC $0F
                    STA $1504,x
                    RTS

LEFT1_40            
LOOP140             LDA $0F
                    CMP $1570,x
                    BCC LOOP140E
                    LSR A
                    STA $0F
                    INC $0F37
                    BRA LOOP140
LOOP140E            RTS
LEFT1_20            
LOOP120             LDA $0F
                    CMP $151C,x
                    BCS LOOP120E
                    ASL A
                    STA $0F
                    INC $0F37
                    BRA LOOP140
LOOP120E            RTS

LEFT_SPEED2         STZ $0F37
                    INC $0F37
                    LDA $0F
                    LSR A
                    CLC
                    ADC #$80
                    STA $0F
                    LDA #$02
                    STA $0F38
                    JSR LEFT1_40
                    LDA #$00
                    SEC
                    SBC $0F
                    STA $1504,x
                    RTS

RIGHT_SPEED         STZ $0F38
                    LDA #$00
                    SEC
                    SBC $0F
                    STA $0F
                    CMP $1570,x
                    BCC RIGHT_2
                    LDA #$02
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_40
                    BRA RIGHT_3
RIGHT_2             CMP $151C,x
                    BCS RIGHT_3
                    LDA #$01
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_20
                    BRA RIGHT_3
RIGHT_3             LDA $0F
                    STA $1504,x
                    RTS
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generate routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN68            RTS     
GEN_SP              JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX

                    LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

                    LDA #$50
                    STA $00D8,y             ;  |
					LDA $14D4,x
					SBC #$00
                    STA $14D4,y             ; /

                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX                     ; / 
                    
RETURN67            RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; HDMA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HDMA				LDA $7FFB28
					BNE HDMA1_LBL1
					LDA #$20
					STA $7FFB28
					LDA #$40
					STA $7FFB30
					
					LDA #$00
					STA $7FFB29
					LDA #$02
					STA $7FFB31
					
					LDA #$21
					STA $7FFB2A
					LDA #$22
					STA $7FFB32
					
					LDA #$00
					STA $7FFB2B
					STA $7FFB33
					LDA #$E1
					STA $7FFB2C
					LDA #$E2
					STA $7FFB34
					LDA #$7F
					STA $7FFB2D
					STA $7FFB35
					
HDMA1_LBL1			LDA #$60
					STA $7FE100
					STA $7FE200
					LDA #$00
					STA $7FE101
					LDA #$00
					STA $7FE201
					LDA #$00
					STA $7FE202
					
					LDA #$2C
					SEC
					SBC $1594,x
					STA $7FE102
					STA $7FE203
					LDA #$00
					STA $7FE103
					LDA #$00
					STA $7FE204
					LDA #$00
					STA $7FE205
					
					LDA #$02
					STA $7FE104
					STA $7FE206
					LDA #$00
					STA $7FE105
					LDA #$E2
					STA $7FE207
					LDA #$6D
					STA $7FE208
					
					LDA #$02
					STA $7FE106
					STA $7FE209
					LDA #$00
					STA $7FE107
					LDA #$E5
					STA $7FE20A
					LDA #$7F
					STA $7FE20B
					
					LDA $1594,x
					ASL A
					STA $7FE108
					STA $7FE20C
					LDA #$00
					STA $7FE109
					LDA #$FF
					STA $7FE20D
					LDA #$7F
					STA $7FE20E
					
					LDA #$02
					STA $7FE10A
					STA $7FE20F
					LDA #$00
					STA $7FE10B
					LDA #$E5
					STA $7FE210
					LDA #$7F
					STA $7FE211
					
					LDA #$02
					STA $7FE10C
					STA $7FE212
					LDA #$00
					STA $7FE10D
					LDA #$E2
					STA $7FE213
					LDA #$6D
					STA $7FE214
					
					LDA #$01
					STA $7FE10E
					STA $7FE215
					LDA #$00
					STA $7FE10F
					LDA #$00
					STA $7FE216
					LDA #$00
					STA $7FE217
					
					LDA #$00
					STA $7FE110
					STA $7FE218
					RTS
					
RESET_HDMA			LDA #$01
					STA $7FE100
					STA $7FE200
					LDA #$00
					STA $7FE101
					LDA #$00
					STA $7FE201
					LDA #$00
					STA $7FE202
					LDA #$00
					STA $7FE102
					STA $7FE203
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


RETURN67            RTS
FIRE_GEN            JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
					DEC A
					TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
                    LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

                    LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN68            RTS
NORMAL_GEN          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    
					LDA #$0F
                    STA $009E,y
                    
                    LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

                    LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    PLX
                    RTS                          ; return
