;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Telesa
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					STZ $15AC,x
					STZ $1570,x
					LDA #$0F
					STZ $1528,x
					STZ $1504,x
                    RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
YOSHI_MODE2			JSR SUB_GFX_Y2
					LDA $14C8,x             ; \ if hammer bro status != 8...
                    CMP #$08                ;  }   ... not (killed with spin jump [4] or star[2])
                    BNE RETURN4
					LDA #$30
					STA $9D
					STZ $AA,x
					STZ $B6,x
					LDA $15AC,x
					CMP #$38
					BEQ YOSHI_MODE2_1
					CMP #$30
					BEQ YOSHI_MODE2_2
					CMP #$28
					BEQ YOSHI_MODE2_3
					CMP #$20
					BEQ YOSHI_MODE2_5
					CMP #$18
					BEQ YOSHI_MODE2_6
					CMP #$10
					BEQ YOSHI_MODE2_4
					CMP #$01
					BEQ YOSHI_MODE2_7
RETURN4				RTS
YOSHI_MODE2_1		LDA #$05
					STA $1602,x
					RTS
YOSHI_MODE2_2		LDA #$0A
					STA $1602,x
					RTS
YOSHI_MODE2_3		LDA #$0F
					STA $1602,x
					RTS
YOSHI_MODE2_4		STZ $1602,x
					PHX
					LDA $7FFDDD
					TAX
					STZ $14C8,x
					PLX
					RTS
YOSHI_MODE2_5		LDA #$0A
					STA $1602,x
					PHX
					LDA $7FFDDD
					TAX
					LDA #$98
					STA $E4,x
					PLX
					RTS
YOSHI_MODE2_0		BRA YOSHI_MODE2
YOSHI_MODE2_6		LDA #$05
					STA $1602,x
					STA $1602,x
					PHX
					LDA $7FFDDD
					TAX
					LDA #$88
					STA $E4,x
					PLX
					RTS
YOSHI_MODE2_7		LDA #$12
					STA $C2,x
					LDA #$2B
					STA $1DFC
					RTS
YOSHI_MODE3			JSR SUB_GFX_Y
					LDA $14C8,x             ; \ if hammer bro status != 8...
                    CMP #$08                ;  }   ... not (killed with spin jump [4] or star[2])
                    BNE RETURN3
					LDA $9D
					BNE RETURN3
					JSL $01802A
					RTS
YOSHI_MODE			LDA $C2,x
					CMP #$11
					BEQ YOSHI_MODE2_0
					CMP #$12
					BEQ YOSHI_MODE3
					JSR SUB_GFX_Y
					LDA $14C8,x             ; \ if hammer bro status != 8...
                    CMP #$08                ;  }   ... not (killed with spin jump [4] or star[2])
                    BNE RETURN3              ; /    ... return
					LDA #$30
					STA $AA,x
					STZ $B6,x
					LDA #$30
					STA $9D
					JSL $01802A
					PHX
					LDA $7FFDDD
					TAX
					LDA $D8,x
					AND #$FC
					STA $02
					LDA $14D4,x
					STA $03
					PLX
					LDA $03
					CMP $14D4,x
					BNE RETURN3
					LDA $D8,x
					AND #$FC
					CMP $02
					BNE RETURN3
					LDA #$11
					STA $C2,x
					LDA #$21
					STA $1DFC
					LDA #$40
					STA $15AC,x
					STZ $1602,x
RETURN3				RTS

					
RETURN              RTS                    
START_HB_CODE       LDA $C2,x
					CMP #$10
					BCS YOSHI_MODE
					JSR SUB_GFX
					LDA $C2,x
					BNE DEATH_MODE
					LDA $14C8,x             ; \ if hammer bro status != 8...
                    CMP #$08                ;  }   ... not (killed with spin jump [4] or star[2])
                    BNE RETURN              ; /    ... return
                    LDA $9D                 ; \ if sprites locked...
                    BNE RETURN              ; /    ... return
					LDA $94
					SEC
					SBC #$50
					STA $E4,x
					LDA $95
					SBC #$00
					STA $14E0,x
					LDA $96
					SEC
					SBC #$20
					STA $D8,x
					LDA $97
					SBC #$00
					STA $14D4,x
					JSL $01802A
					
					LDA $010B
					CMP #$F7
					BNE MAIN0
					LDA $95
					CMP #$05
					BNE MAIN0
					LDA $94
					CMP #$B0
					BCC MAIN0
					LDA #$03
					STA $C2,x
					LDA #$30
					STA $15AC,x
					STZ $1504,x
					LDA $76
					STA $151C,x
					RTS
	 MAIN0			LDA $1528,x
					STA $7FC004
					JSR EAT_CHECK
					INC $1570,x
					LDA $1570,x
					CMP #$40
					BCC RETURN
					LDA $1528,x
					CMP #$07
					BEQ DEATH
					STZ $1570,x
					INC $1528,x
					RTS
DEATH				LDA #$01
					STA $C2,x
					LDA $76
					STA $151C,x
					STZ $1504,x
					RTS
DEATH_MODE			CMP #$03
					BEQ LAST_MODE1
					CMP #$02
					BEQ DEATH_MODE3
					CMP #$04
					BEQ LAST_MODE3
					LDA $1504,x
					CMP #$40
					BEQ DEATH_MODE2
					LDA $151C,x
					STA $76
					LDA #$30
					STA $9D
					STA $15AC,x
					STZ $7B
					STZ $7D
					LDA #$14
					STA $B6,x
					LDA #$0C
					STA $AA,x
					JSL $01802A
					INC $1504,x
					RTS
DEATH_MODE2			LDA #$02
					STA $C2,x
					JSL $00F606
					LDA #$06
					STA $1DF9
					RTS
DEATH_MODE3			LDA #$03
					STA $78
					RTS
					
LAST_MODE1			LDA $1504,x
					CMP #$30
					BEQ LAST_MODE2
					LDA $151C,x
					STA $76
					LDA #$30
					STA $9D
					STA $15AC,x
					STZ $7B
					STZ $7D
					LDA #$14
					STA $B6,x
					LDA #$0C
					STA $AA,x
					JSL $01802A
					INC $1504,x
					RTS
LAST_MODE2			LDA #$01
					STA $1426
					JSR GEN_SPRITE
					LDA #$04
					STA $C2,x
					LDA #$30
					STA $9D
					TXA
					STA $7FFDDD
					RTS
LAST_MODE3			
					STZ $AA,x
					STZ $B6,x
					LDA #$30
					STA $15AC,x
					STZ $7B
					STZ $7D
					LDA $151C,x
					STA $76
RETURN2 			RTS
					

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					STZ $03
					LDA $15AC,x
					BEQ SUB_GFX0_1
					LDA #$02
					STA $03
SUB_GFX0_1
					LDA $01
					STA $0301,y
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0300,y             ; /
					LDA $03
                    STA $0302,y
					
					LDA #$0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties


                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN67            RTS
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
					TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
                    LDA #$60
                    STA $00E4,y

                    LDA #$05
                    STA $14E0,y             ; /

                    LDA #$20
                    STA $00D8,y             ;  |
                    LDA #$00
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
					LDA #$10
					STA $00C2,y
					LDA #$19
					STA $1686,y
                    RTS                          ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP2            dcb $06,$27
HORZ_DISP2			dcb $08,$00
VERT_DISP2			dcb $F0,$00

SUB_GFX_Y          JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
                    PHX                     ; push sprite index
					LDX #$01
LOOP_START          PHX
					LDA $01
					CLC
					ADC VERT_DISP2,x
					STA $0301,y
					LDA $00
					CLC
					ADC HORZ_DISP2,x
                    STA $0300,y             ; /
					
					LDA TILEMAP2,x           ; \ store tile
                    STA $0302,y

                    LDA #$4B
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					PLX

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$01                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

TILEMAP3            dcb $20,$20,$20,$0C,$1E
					dcb $3C,$20,$20,$0C,$1E
					dcb $3E,$3C,$20,$0C,$1E
					dcb $3E,$3E,$3C,$0C,$1E
HORZ_DISP3			dcb $18,$28,$38,$10,$00
VERT_DISP3			dcb $F8,$F8,$F8,$F8,$00

SUB_GFX_Y2          JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
					LDA $1602,x
					STA $03
                    PHX                     ; push sprite index
					LDX #$04
LOOP_START2          PHX
					LDA $01
					CLC
					ADC VERT_DISP3,x
					STA $0301,y
					LDA $00
					CLC
					ADC HORZ_DISP3,x
                    STA $0300,y             ; /
					
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILEMAP3,x           ; \ store tile
                    STA $0302,y
					PLX

                    LDA #$4B
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					PLX

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START2          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$04                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EAT_CHECK           LDA $E4,x
                    STA $7FFE01
                    LDA $14E0,x
                    STA $7FFE02
                    LDA $D8,x
                    STA $7FFE03
                    LDA $14D4,x
                    STA $7FFE04
                    PHX
                    LDX #$09
LOOP1               ;LDA $9E,x
                    ;CMP #$04
                    ;BNE LOOP3
					LDA $14C8,x
					BEQ LOOP3
					CMP #$02
					BEQ LOOP3
					LDA $167A,x
					AND #$02
					BNE LOOP3
					JSR NEAR_CHECK
                    TYA
                    BEQ LOOP3
					STZ $14C8,x
                    LDA #$06
					STA $1DF9
					PLX
					LDA #$18
					STA $15AC,x
					LDA $1528,x
					BEQ LOOP2
					DEC A
					STA $1528,x
					BEQ LOOP2
					DEC A
					STA $1528,x
					BEQ LOOP2
					DEC A
					STA $1528,x
LOOP2				PHX
LOOP3               DEX
                    BPL LOOP1
                    PLX
					RTS
NEAR_CHECK          LDY #$00
                    LDA $E4,x
                    SEC
                    SBC $7FFE01
                    STA $0F
                    LDA $14E0,x
                    SBC $7FFE02
                    CMP #$00
                    BEQ RIGHT_CHECK
                    CMP #$FF
                    BNE CHECK_E
                    LDA $0F
                    CMP #$E8
                    BCC CHECK_E
                    BRA VER_CHECK
RIGHT_CHECK         LDA $0F
                    CMP #$18
                    BCS CHECK_E
VER_CHECK           LDA $D8,x
                    SEC
                    SBC $7FFE03
                    STA $0F
                    LDA $14D4,x
                    SBC $7FFE04
                    CMP #$00
                    BEQ UNDER_CHECK
                    CMP #$FF
                    BNE CHECK_E
                    LDA $0F
                    CMP #$E8
                    BCC CHECK_E
                    BRA NEAR
UNDER_CHECK         LDA $0F
                    CMP #$18
                    BCS CHECK_E
NEAR                LDY #$01
CHECK_E             RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

