;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Tetolis
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"
					LDA #$40
					STA $15AC,x
					STZ $1570,x
                    RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                     ; return           
CODE_START          LDA EXTRA_BITS,x
					AND #$04
					BNE MAIN
					JSR SUB_GFX             ; graphics routine
MAIN				LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
					
					LDA EXTRA_BITS,x
					AND #$04
					BEQ BLOCK_MAIN
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					STA $D8,x
					LDA $97
					STA $14D4,x
					JSR BLK_GEN_CODE
					RTS

BLOCK_MAIN			LDA #$30
					STA $AA,x
					JSL $01802A             ; update position based on speed values
					LDA $1588,x
					AND #$04
					BEQ BLOCK_MAIN_E
					JSR BLOCK_MODE
					LDA #$09
					STA $1DFC
					STZ $14C8,x
BLOCK_MAIN_E		RTS


BLK_GEN_CODE		LDA $15AC,x
					CMP #$01
					BNE BLK_GEN_CODE_E
					JSR BLK_GEN
					LDA #$2B
					STA $1DFC
					LDA $7FF001
					INC A
					STA $7FF001
					CMP #$08
					BEQ LAST
					LDA #$60
					STA $15AC,x
BLK_GEN_CODE_E		RTS
LAST				STZ $14C8,x
					RTS

BLOCK_MODE			LDA $7FF001
					CMP #$01
					BEQ MODE1
					CMP #$02
					BEQ MODE2
					CMP #$03
					BEQ MODE1
					CMP #$04
					BEQ MODE3
					CMP #$05
					BEQ MODE4
					CMP #$06
					BEQ MODE5
					CMP #$07
					BEQ MODE1
					CMP #$08
					BEQ MODE6
					RTS
MODE1				JSR BLOCK1
					RTS
MODE2				JSR BLOCK2
					RTS
MODE3				JSR BLOCK3
					RTS
MODE4				JSR BLOCK4
					RTS
MODE5				JSR BLOCK5
					RTS
MODE6				JSR BLOCK6
					RTS
					
BLOCK1				LDA $E4,x               ;@
                    STA $9A                 ;@
                    LDA $14E0,x             ;
                    STA $9B                 ;
                    LDA $D8,x               ;
                    STA $98                 ;
                    LDA $14D4,x             ;
                    STA $99                 ;
					JSR CHANGE_TILE
					LDA $E4,x               ;
					CLC
					ADC #$10
                    STA $9A                 ;
                    LDA $14E0,x             ;
					ADC #$00
                    STA $9B                 ;
                    LDA $D8,x               ;
                    STA $98                 ;
                    LDA $14D4,x             ;
                    STA $99                 ;
					JSR CHANGE_TILE
					LDA $E4,x               ;
					CLC
					ADC #$10
                    STA $9A                 ;
                    LDA $14E0,x             ;
					ADC #$00
                    STA $9B                 ;
                    LDA $D8,x               ;
					SEC
					SBC #$10
                    STA $98                 ;
                    LDA $14D4,x             ;
					SBC #$00
                    STA $99                 ;
					JSR CHANGE_TILE
					LDA $E4,x               ;
					CLC
					ADC #$10
                    STA $9A                 ;
                    LDA $14E0,x             ;
					ADC #$00
                    STA $9B                 ;
                    LDA $D8,x               ;
					SEC
					SBC #$20
                    STA $98                 ;
                    LDA $14D4,x             ;
					SBC #$00
                    STA $99                 ;
					JSR CHANGE_TILE
					RTS
BLOCK2				LDA $E4,x               ;
                    STA $9A                 ;@
                    LDA $14E0,x             ;
                    STA $9B                 ;
                    LDA $D8,x               ;
                    STA $98                 ;
                    LDA $14D4,x             ;
                    STA $99                 ;
					JSR CHANGE_TILE
					LDA $E4,x               ;
					CLC
					ADC #$10
                    STA $9A                 ;
                    LDA $14E0,x             ;
					ADC #$00
                    STA $9B                 ;
                    LDA $D8,x               ;
                    STA $98                 ;
                    LDA $14D4,x             ;
                    STA $99                 ;
					JSR CHANGE_TILE
					LDA $E4,x               ;
					CLC
					ADC #$10
                    STA $9A                 ;
                    LDA $14E0,x             ;
					ADC #$00
                    STA $9B                 ;
                    LDA $D8,x               ;
					SEC
					SBC #$10
                    STA $98                 ;
                    LDA $14D4,x             ;
					SBC #$00
                    STA $99                 ;
					JSR CHANGE_TILE
					LDA $E4,x               ;
					CLC
					ADC #$20
                    STA $9A                 ;
                    LDA $14E0,x             ;
					ADC #$00
                    STA $9B                 ;
                    LDA $D8,x               ;
					SEC
					SBC #$10
                    STA $98                 ;
                    LDA $14D4,x             ;
					SBC #$00
                    STA $99                 ;
					JSR CHANGE_TILE
					RTS
					
BLOCK3				LDA $E4,x               ;
                    STA $9A                 ;
                    LDA $14E0,x             ;
                    STA $9B                 ;
                    LDA $D8,x               ;
                    STA $98                 ;
                    LDA $14D4,x             ;
                    STA $99                 ;
					JSR CHANGE_TILE
					LDA $E4,x               ;
                    STA $9A                 ;
                    LDA $14E0,x             ;
                    STA $9B                 ;
                    LDA $D8,x               ;
					SEC
					SBC #$10
                    STA $98                 ;
                    LDA $14D4,x             ;
                    STA $99                 ;
					JSR CHANGE_TILE
					LDA $E4,x               ;
                    STA $9A                 ;
                    LDA $14E0,x             ;
                    STA $9B                 ;
                    LDA $D8,x               ;
					SEC
					SBC #$20
                    STA $98                 ;
                    LDA $14D4,x             ;
                    STA $99                 ;
					JSR CHANGE_TILE
					LDA $E4,x               ;
                    STA $9A                 ;
                    LDA $14E0,x             ;
                    STA $9B                 ;
                    LDA $D8,x               ;
					SEC
					SBC #$30
                    STA $98                 ;
                    LDA $14D4,x             ;
                    STA $99                 ;
					JSR CHANGE_TILE
					RTS
					
BLOCK4				LDA $E4,x               ;
                    STA $9A                 ;
                    LDA $14E0,x             ;
                    STA $9B                 ;
                    LDA $D8,x               ;
                    STA $98                 ;
                    LDA $14D4,x             ;
                    STA $99                 ;
					JSR CHANGE_TILE
					LDA $E4,x               ;
                    STA $9A                 ;
                    LDA $14E0,x             ;
                    STA $9B                 ;
                    LDA $D8,x               ;
					SEC
					SBC #$10
                    STA $98                 ;
                    LDA $14D4,x             ;
					SBC #$00
                    STA $99                 ;
					JSR CHANGE_TILE
					LDA $E4,x               ;
					CLC
					ADC #$10
                    STA $9A                 ;
                    LDA $14E0,x             ;
					ADC #$00
                    STA $9B                 ;
                    LDA $D8,x               ;
					SEC
					SBC #$10
                    STA $98                 ;
                    LDA $14D4,x             ;
					SBC #$00
                    STA $99                 ;
					JSR CHANGE_TILE
					LDA $E4,x               ;
					CLC
					ADC #$20
                    STA $9A                 ;
                    LDA $14E0,x             ;
					ADC #$00
                    STA $9B                 ;
                    LDA $D8,x               ;
					SEC
					SBC #$10
                    STA $98                 ;
                    LDA $14D4,x             ;
					SBC #$00
                    STA $99                 ;
					JSR CHANGE_TILE
					RTS
					
BLOCK5				LDA $E4,x               ;
                    STA $9A                 ;
                    LDA $14E0,x             ;@
                    STA $9B                 ;@
                    LDA $D8,x               ;
                    STA $98                 ;
                    LDA $14D4,x             ;
                    STA $99                 ;
					JSR CHANGE_TILE
					LDA $E4,x               ;
                    STA $9A                 ;
                    LDA $14E0,x             ;
                    STA $9B                 ;
                    LDA $D8,x               ;
					SEC
					SBC #$10
                    STA $98                 ;
                    LDA $14D4,x             ;
                    STA $99                 ;
					JSR CHANGE_TILE
					LDA $E4,x               ;
                    STA $9A                 ;
                    LDA $14E0,x             ;
                    STA $9B                 ;
                    LDA $D8,x               ;
					SEC
					SBC #$20
                    STA $98                 ;
                    LDA $14D4,x             ;
                    STA $99                 ;
					JSR CHANGE_TILE
					LDA $E4,x               ;
					SEC
					SBC #$10
                    STA $9A                 ;
                    LDA $14E0,x             ;
					SBC #$00
                    STA $9B                 ;
                    LDA $D8,x               ;
					SEC
					SBC #$20
                    STA $98                 ;
                    LDA $14D4,x             ;
                    STA $99                 ;
					JSR CHANGE_TILE
					RTS
					
BLOCK6				LDA $E4,x               ;
                    STA $9A                 ;
                    LDA $14E0,x             ;
                    STA $9B                 ;
                    LDA $D8,x               ;
                    STA $98                 ;
                    LDA $14D4,x             ;
                    STA $99                 ;
					JSR CHANGE_TILE
					LDA $E4,x               ;
					CLC
					ADC #$10
                    STA $9A                 ;
                    LDA $14E0,x             ;
					ADC #$00
                    STA $9B                 ;
                    LDA $D8,x               ;
                    STA $98                 ;
                    LDA $14D4,x             ;
                    STA $99                 ;
					JSR CHANGE_TILE
					LDA $E4,x               ;
					CLC
					ADC #$10
                    STA $9A                 ;
                    LDA $14E0,x             ;
					ADC #$00
                    STA $9B                 ;
                    LDA $D8,x               ;
					SEC
					SBC #$10
                    STA $98                 ;
                    LDA $14D4,x             ;
					SBC #$00
                    STA $99                 ;
					JSR CHANGE_TILE
					LDA $E4,x               ;
                    STA $9A                 ;
                    LDA $14E0,x             ;
                    STA $9B                 ;
                    LDA $D8,x               ;
					SEC
					SBC #$10
                    STA $98                 ;
                    LDA $14D4,x             ;
					SBC #$00
                    STA $99                 ;
					JSR CHANGE_TILE
					RTS
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HORZ_DISP			dcb $00,$10,$10,$10,$00,$10,$10,$20,$00,$10,$10,$10,$00,$00,$00,$00
					dcb $00,$00,$10,$20,$00,$00,$00,$F0,$00,$10,$10,$10,$00,$10,$00,$10
VERT_DISP           dcb $00,$00,$F0,$E0,$00,$00,$F0,$F0,$00,$00,$F0,$E0,$00,$F0,$E0,$D0
					dcb $00,$F0,$F0,$F0,$00,$F0,$E0,$E0,$00,$00,$F0,$E0,$00,$00,$F0,$F0

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder                				
					LDA $7FF001
					DEC A
					ASL A
					ASL A
					STA $02
					PHX                     ; push sprite index
                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START          PHX                     ; push current tile number
                    
					PHX
					TXA
					CLC
					ADC $02
					TAX
					
                    LDA $00                 ; \ til
					CLC                     ;  |
                    ADC HORZ_DISP,x         ;  |
                    STA $0300,y             ; /   set y position of the tile
					
					LDA $01                ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP,x         ;  |
                    STA $0301,y             ; /   set y position of the tile
                    PLX
					
					LDA #$80
                    STA $0302,y            ; / 
					
					LDA #$00            ;  |
                    ORA #$0D
					ORA $64
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we di
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GEN_OFFSET			dcb $80,$60,$A0,$A0,$60,$B0,$80,$A0

RETURN67            RTS
BLK_GEN             JSL $02A9DE             ; \ get an index
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
					TYX
                    STA NEW_SPRITE_NUM,x
					LDA $7FF001
					TAX
					LDA GEN_OFFSET,x
                    STA $00E4,y

                    LDA #$00
                    STA $14E0,y             ; /

                    LDA #$C0
                    STA $00D8,y             ;  |
                    LDA #$00
                    STA $14D4,y             ; 
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS
					                          ; return
CHANGE_TILE			PHP
                    REP #$30                ; \ change sprite to block 
                    LDA.W #$04BA
                    STA $03                 ;  |
                    JSR SUBL_SET_MAP16      ;  |
                    PLP
					RTS
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Map 16 Routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SUBL_SET_MAP16      PHP                     
                    REP #$30                
                    PHY                    
                    PHX                     
                    TAX                    
                    LDA $03                 
                    PHA                    
                    JSR SUB_8034           
                    PLA                  
                    STA $03                 
                    PLX                     
                    PLY                     
                    PLP                     
                    RTS                    

                    JMP $FEA301
RETURN18            PLX
                    PLB
                    PLP
                    RTS

SUB_8034            PHP                      
                    SEP #$20                
                    PHB                     
                    LDA #$00                 
                    PHA                  
                    PLB                   
                    REP #$30                 
                    PHX                     
                    LDA $9A                 ;A:0200 X:0266 Y:0001 0426 
                    STA $0C                 ;A:0070 X:0266 Y:0001 0458 
                    LDA $98                 ;A:0070 X:0266 Y:0001 0490 
                    STA $0E                 ;A:0130 X:0266 Y:0001 0522 
                    LDA.W #$0000            ;A:0130 X:0266 Y:0001 0554 
                    SEP #$20                ;A:0000 X:0266 Y:0001 0578 
                    LDA $5B                 ;A:0000 X:0266 Y:0001 0600 
                    STA $09                 ;A:0000 X:0266 Y:0001 0624 
                    LDA $1933               ;A:0000 X:0266 Y:0001 0648
                    BEQ NO_SHIFT            ;A:0000 X:0266 Y:0001 0680 
                    LSR $09
NO_SHIFT            LDY $0E                 ;A:0000 X:0266 Y:0001 0702 
                    LDA $09                 ;A:0000 X:0266 Y:0130 0734 
                    AND #$01                ;A:0000 X:0266 Y:0130 0758 
                    BEQ HORIZ               ;A:0000 X:0266 Y:0130 0774 
                    LDA $9B
                    STA $00
                    LDA $99
                    STA $9B
                    LDA $00  
                    STA $99
                    LDY $0C
HORIZ               CPY.W #$0200            ;A:0000 X:0266 Y:0130 0796 
                    BCS RETURN18            ;A:0000 X:0266 Y:0130 0820 
                    LDA $1933               ;A:0000 X:0266 Y:0130 0836 
                    ASL A                   ;A:0000 X:0266 Y:0130 0868 
                    TAX                     ;A:0000 X:0266 Y:0130 0882 
                    LDA $BEA8,x ;[$00:BEA8] ;A:0000 X:0000 Y:0130 0896 
                    STA $65                 ;A:00A8 X:0000 Y:0130 0928 
                    LDA $BEA9,x ;[$00:BEA9] ;A:00A8 X:0000 Y:0130 0952 
                    STA $66                 ;A:00BD X:0000 Y:0130 0984 
                    STZ $67                 ;A:00BD X:0000 Y:0130 1008 
                    LDA $1925               ;A:00BD X:0000 Y:0130 1032 
                    ASL A                   ;A:0000 X:0000 Y:0130 1064 
                    TAY                     ;A:0000 X:0000 Y:0130 1078 
                    LDA ($65),y ;[$00:BDA8] ;A:0000 X:0000 Y:0000 1092 
                    STA $04                 ;A:00D8 X:0000 Y:0000 1132 
                    INY                     ;A:00D8 X:0000 Y:0000 1156 
                    LDA ($65),y ;[$00:BDA9] ;A:00D8 1170 
                    STA $05                 ;A:00BA 1210 
                    STZ $06                 ;A:00BA 1234 
                    LDA $9B                 ;A:00BA 1258 
                    STA $07                 ;A:0000 1282 
                    ASL A                   ;A:0000 1306 
                    CLC                     ;A:0000 1320 
                    ADC $07                 ;A:0000 1334 
                    TAY                     ;A:0000 1358 
                    LDA ($04),y ;[$00:BAD8] ;A:0000 X:0000 Y:0000 0004  
                    STA $6B                 ;A:0000 X:0000 Y:0000 0044  
                    STA $6E                 ;A:0000 X:0000 Y:0000 0068  
                    INY                     ;A:0000 X:0000 Y:0000 0092  
                    LDA ($04),y ;[$00:BAD9] ;A:0000 0106  
                    STA $6C                 ;A:00C8 0146  
                    STA $6F                 ;A:00C8 0170  
                    LDA #$7E                ;A:00C8 0194  
                    STA $6D                 ;A:007E 0210  
                    INC A                   ;A:007E 0234  
                    STA $70                 ;A:007F 0248  
                    LDA $09                 ;A:007F 0272  
                    AND #$01                ;A:0000 0296  
                    BEQ NO_AND              ;A:0000 0312  
                    LDA $99
                    LSR A
                    LDA $9B 
                    AND #$01
                    BRA LABEL52
NO_AND              LDA $9B                 ;A:0000 0334  
                    LSR A                   ;A:0000 0358  
                    LDA $99                 ;A:0000 0372  
LABEL52             ROL A                   ;A:0001 0396  
                    ASL A                   ;A:0002 0410  
                    ASL A                   ;A:0004 0424  
                    ORA #$20                ;A:0008 0438  
                    STA $04                 ;A:0028 0454  
                    CPX.W #$0000            ;A:0028 0478  
                    BEQ NO_ADD              ;A:0028 0502  
                    CLC
                    ADC #$10 
                    STA $04
NO_ADD              LDA $98                 
                    AND #$F0                
                    CLC                     ;A:0030 0564  
                    ASL A                   ;A:0030 0578  
                    ROL A                   ;A:0060 0592  
                    STA $05                 ;A:00C0 0606  
                    ROL A                   ;A:00C0 0630  
                    AND #$03                ;A:0080 0644  
                    ORA $04                 ;A:0000 0660  
                    STA $06                 ;A:0028 0684  
                    LDA $9A                 ;A:0028 0708  
                    AND #$F0                ;A:0070 0732  
                    LSR A                   ;A:0070 0748  
                    LSR A                   ;A:0038 0762  
                    LSR A                   ;A:001C 0776  
                    STA $04                 ;A:000E 0790  
                    LDA $05                 ;A:000E 0814  
                    AND #$C0                ;A:00C0 0838  
                    ORA $04                 ;A:00C0 0854  
                    STA $07                 ;A:00CE 0878  
                    REP #$20                ;A:00CE 0902  
                    LDA $09                 ;A:00CE 0924  
                    AND.W #$0001            ;A:0100 0956  
                    BNE LABEL51             ;A:0000 0980  
                    LDA $1A                 ;A:0000 0996  
                    SEC                     ;A:0000 1028  
                    SBC.W #$0080            ;A:0000 1042  
                    TAX                     ;A:FF80 1066  
                    LDY $1C                 ;A:FF80 X:FF80 Y:0001 1080  
                    LDA $1933               ;A:FF80 X:FF80 Y:00C0 1112  
                    BEQ LABEL50             ;A:0000 X:FF80 Y:00C0 1152  
                    LDX $1E
                    LDA $20
                    SEC
                    SBC.W #$0080
                    TAY
                    BRA LABEL50
LABEL51             LDX $1A
                    LDA $1C
                    SEC
                    SBC.W #$0080
                    TAY
                    LDA $1933
                    BEQ LABEL50
                    LDA $1E
                    SEC
                    SBC.W #$0080
                    TAX  
                    LDY $20
LABEL50             STX $08                
                    STY $0A               
                    LDA $98               
                    AND.W #$01F0          
                    STA $04              
                    LDA $9A              
                    LSR A                
                    LSR A                
                    LSR A                
                    LSR A                
                    AND.W #$000F          
                    ORA $04              
                    TAY                    
                    PLA              
                    SEP #$20               
                    STA [$6B],y ;[$7E:C937] 
                    XBA                     
                    STA [$6E],y ;[$7F:C937] 
                    XBA                    
                    REP #$20                
                    ASL A              
                    TAY                     
                    PHK                   
                    PER.W #$0006           
                    PEA $804C
                    JMP.L $00C0FB
MAP16_RETURN        PLB
                    PLP
                    RTS

                    
                    NOP                    
					
