;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Trap
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					EXTRA_BITS = $7FAB10
					NEW_SPRITE_NUM = $7FAB9E
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					STZ $C2,x
					STZ $15AC,x
					LDA EXTRA_BITS
					AND #$04
					BNE INIT_2
					LDA $E4,x
					CLC
					ADC #$08
					STA $E4,x
		            RTL
INIT_2				LDA #$20
					STA $15AC,x
					RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X_SPEED				dcb $10,$F0

RETURN              RTS                    
START_HB_CODE       LDA $151C,x
					CMP #$77
					BEQ MODE_BOWL
					LDA EXTRA_BITS,x
					AND #$04
					BNE MAIN2
					JSR SUB_GFX
	                LDA $14C8,x             ; \ if hammer bro status != 8...
                    CMP #$08                ;  }   ... not (killed with spin jump [4] or star[2])
                    BNE RETURN              ; /    ... return
                    LDA $9D                 ; \ if sprites locked...
                    BNE RETURN              ; /    ... return
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSL $01802A
					JSL $01A7DC
					LDA $C2,x
					BNE MOVE
					JSR NEAR_CHECK
RETURN2				RTS
MODE_BOWL			BRA MODE_BOWL2
MOVE				JSR SUB_MOVE
					RTS
MAIN2				LDA $14C8,x             ; \ if hammer bro status != 8...
                    CMP #$08                ;  }   ... not (killed with spin jump [4] or star[2])
                    BNE RETURN2              ; /    ... return
                    LDA $9D                 ; \ if sprites locked...
                    BNE RETURN2              ; /    ... return
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA #$99
					STA $1686,x
					STZ $1656,x
					LDA $15AC,x
					BNE RETURN2
					LDA #$60
					STA $15AC,x
					JSR BOWL_CHECK
					CPY #$01
					BEQ RETURN2
					LDA #$2B
					STA $1DFC
					JSR STONE_GEN
RETURN3				RTS
MODE_BOWL2			JSR SUB_GFX2
					LDA $14C8,x             ; \ if hammer bro status != 8...
                    CMP #$08                ;  }   ... not (killed with spin jump [4] or star[2])
                    BNE RETURN3              ; /    ... return
                    LDA $9D                 ; \ if sprites locked...
                    BNE RETURN3              ; /    ... return
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSL $01802A
					JSL $01A7DC
					LDA $1504,x
					BNE MODE_BOWL3
					LDA $1588,x
					AND #$04
					BEQ RETURN3
					LDA #$10
					STA $1887
					LDA #$09
					STA $1DFC
					LDA #$01
					STA $1504,x
					JSR NEAR_CHECK2
					RTS
MODE_BOWL3			LDA $1887
					BNE RETURN3
					LDA $157C,x
					BNE MODE_BOWL3_R
					LDA #$18
					STA $B6,x
					INC $1570,x
					RTS
MODE_BOWL3_R		LDA #$E8
					STA $B6,x
					DEC $1570,x
					RTS

BOWL_CHECK			LDY #$00
					PHX
					LDX #$00
CHECK_LOOP			LDA $151C,x
					CMP #$77
					BNE CHECK_2
					LDA $14C8,x
					CMP #$08
					BNE CHECK_2
					LDY #$01
CHECK_2				INX
					CPX #$0A
					BCC CHECK_LOOP
					PLX
					RTS

NEAR_CHECK2			STZ $157C,x
					LDA $E4,x
					SEC
					SBC $94
					LDA $14E0,x
					SBC $95
					BCC RETURN30
					LDA #$01
					STA $157C,x
RETURN30			RTS
					
NEAR_CHECK			LDA $E4,x
					SEC
					SBC $94
					STA $02
					LDA $14E0,x
					SBC $95
					STA $03
					BCS RIGHT
					STZ $157C,x
					LDA $03
					CMP #$FF
					BNE NEAR_R
					LDA $02
					CMP #$A0
					BCC NEAR_R
					LDA #$01
					STA $C2,x
					LDA #$B0
					STA $AA,x
NEAR_R				RTS
RIGHT				LDA #$01
					STA $157C,x
					LDA $03
					BNE NEAR_R
					LDA $02
					CMP #$60
					BCS NEAR_R
					LDA #$01
					STA $C2,x
					LDA #$B0
					STA $AA,x
					RTS

SUB_MOVE			LDA $15AC,x
					CMP #$01
					BEQ DIR_CHECK
					CMP #$00
					BNE MOVE_R
					LDA $157C,x
					PHX
					TAX
					LDA X_SPEED,x
					PLX
					STA $B6,x
					LDA $1588,x
					AND #$04
					BNE ON_GROUND
					LDA $1588,x
					AND #$03
					BEQ SUB_MOVE2
					CMP #$01
					BEQ RIGHT_EDGE
					STZ $157C,x
					BRA SUB_MOVE2
RIGHT_EDGE			LDA #$01
					STA $157C,x
SUB_MOVE2			LDA $1588,x
					AND #$80
					BEQ MOVE_R
					STZ $AA,x
MOVE_R				RTS
ON_GROUND			STZ $B6,x
					LDA #$20
					STA $15AC,x
					LDA #$09
					STA $1DFC
					LDA #$10
					STA $1887
					RTS
DIR_CHECK			LDA #$B0
					STA $AA,x
					STZ $157C,x
					LDA $E4,x
					SEC
					SBC $94
					LDA $14E0,x
					SBC $95
					BCC MOVE_R
					LDA #$01
					STA $157C,x
					RTS
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN67            RTS
STONE_GEN           JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
					TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
					LDA $E4,x
					CLC
					ADC #$08
                    STA $00E4,y

                    LDA $14E0,x
					ADC #$00
                    STA $14E0,y             ; /

					LDA $D8,x
                    STA $00D8,y             ;  |
					LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
					LDA #$77
					STA $151C,y
					LDA #$A3
					STA $1662,y
					LDA #$00
					STA $1656,y
					STA $1504,y
					LDA #$00
					STA $00AA,y
					STA $00B6,y
					STA $1504,y
                    RTS                          ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP				dcb $A8,$A6,$A6,$A8
HORZ_DISP           dcb $F8,$08,$F8,$08
VERT_DISP           dcb $EF,$EF,$FF,$FF

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
                    PHX                     ; push sprite index
					LDX #$03
LOOP_START          
					LDA $01
					CLC
					ADC VERT_DISP,x
					STA $0301,y
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP,x         ;  |
                    STA $0300,y             ; /
					
					LDA TILEMAP,x           ; \ store tile
                    STA $0302,y

					

                    LDA #$0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties


                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine - specific to sprite
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP2             dcb $45,$47,$45,$65,$66,$65,$45,$47,$45,$63
HORZ_DISP2           dcb $F0,$00,$10,$F0,$00,$10,$F0,$00,$10,$F8
VERT_DISP2           dcb $E0,$E0,$E0,$F0,$F0,$F0,$00,$00,$00,$E8
PROPERTIES2			 dcb $00,$00,$40,$00,$00,$40,$80,$80,$C0,$00

HORZ_DISP3           dcb $FC,$04,$0C,$10,$0C,$04,$FC,$F8
VERT_DISP3           dcb $EC,$E8,$EC,$F4,$FC,$00,$FC,$F4


HORZ_DISP4           dcb $FC,$F8,$FC,$04,$0C,$10,$0C,$04
VERT_DISP4           dcb $FC,$F4,$EC,$E8,$EC,$F4,$FC,$00


SUB_GFX2            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
					PHX
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$07
					TAX
					
					LDA $01
					CLC
					ADC VERT_DISP3,x
					STA $0301,y
					
					LDA $00
					CLC
					ADC HORZ_DISP3,x
					STA $0300,y             ; /

					LDA #$38
                    STA $0302,y
					
					LDA #$00
                    PHX
                    PHA
                    TYA                     ; \ get index to sprite property map ($460)...
                    LSR A                   ; |    ...we use the sprite OAM index...
                    LSR A                   ; |    ...and divide by 4 because a 16x16 tile is 4 8x8 tiles
                    TAX                     ; | 
                    PLA
                    STA $0460,x             ; /  
                    PLX

                    LDA #$0D
                    ;ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					
					INY
					INY
					INY
					INY
					
					
					LDA $01
					CLC
					ADC VERT_DISP4,x
					STA $0301,y
					
					LDA $00
					CLC
					ADC HORZ_DISP4,x
					STA $0300,y             ; /

					LDA #$39
                    STA $0302,y
					
					LDA #$00
                    PHX
                    PHA
                    TYA                     ; \ get index to sprite property map ($460)...
                    LSR A                   ; |    ...we use the sprite OAM index...
                    LSR A                   ; |    ...and divide by 4 because a 16x16 tile is 4 8x8 tiles
                    TAX                     ; | 
                    PLA
                    STA $0460,x             ; /  
                    PLX

                    LDA #$0D
                    ;ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					PLX
					
					INY
					INY
					INY
					INY
					
                    PHX                     ; push sprite index
                    LDX #$09
LOOP_START2          
					LDA $01
					CLC
					ADC VERT_DISP2,x
					STA $0301,y
					
					LDA $00
					CLC
					ADC HORZ_DISP2,x
					STA $0300,y             ; /

					LDA TILEMAP2,x           ; \ store tile
                    STA $0302,y
					
					LDA #$02
                    PHX
                    PHA
                    TYA                     ; \ get index to sprite property map ($460)...
                    LSR A                   ; |    ...we use the sprite OAM index...
                    LSR A                   ; |    ...and divide by 4 because a 16x16 tile is 4 8x8 tiles
                    TAX                     ; | 
                    PLA
                    STA $0460,x             ; /  
                    PLX                  
					
                    LDA PROPERTIES2,x
                    ORA #$0D
                    ;ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties


                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START2          ; / 

	
                    PLX                     ; pull, X = sprite index
                    LDY #$FF                ; \ FF, because we wrote to 460
                    LDA #$0B                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /



