;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Ultema
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"
					LDA $010B
					CMP #$55
					BEQ INIT_2
INIT_R              RTL
INIT_2				LDA #$10
					STA $1656,x
					LDA #$80
					STA $1662,x
					LDA #$01
					STA $167A,x
					LDA #$0A
					STA $166E,x
					RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ROCKMAN				JSR SUB_GFX_ROCK
					LDA $9D
					BNE RETURN
					LDA $14C8,x
					CMP #$08
					BNE RETURN
					INC $1602,x
					JSL $27FAF4 ;SUB_OFF_SCREEN_HB
					JSL $018022 ;x speed
					JSL $01801A ;y speed
					JSL $01A7DC
					JSR MODE3_2
RETURN              RTS                     ; return           
CODE_START          LDA $167A,x
					CMP #$01
					BEQ ROCKMAN
					LDA $157C,x
					BNE START2
					JSR SUB_GFX             ; graphics routine
					BRA MAIN2
START2				JSR SUB_GFX1
MAIN2               LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
					JSL $27FAF4 ;SUB_OFF_SCREEN_HB

					JSL $01802A             ; update position based on speed values
					LDA $1528,x
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$01
					BNE NOT_MODE2
					JSR MODE2
					RTS
NOT_MODE2			CMP #$02
					BNE NOT_MODE3
					JSR MODE3
					RTS
NOT_MODE3			JSR MODE4
					RTS



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder 
											
                    PHX                     ; push sprite index

                    LDA $00                 ; \ tile x position = sprite x location ($00)
                    STA $0300,y             ; /                    
                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y             ; /
                                 
					LDA $1602,x
                    STA $0302,y             ; / 

                    LDA #$00
                    LDX $15E9               ;  |
                    ORA $15F6,x             ;  | get palette info
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties

                    PLX                     ; pull, X = sprite index
                    
                    LDY #$02
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HORIZ_DISP1         dcb $F8,$08,$F8,$08
VERT_DISP1          dcb $F8,$F8,$08,$08
PROPERTIES1         dcb $00,$40,$80,$C0

SUB_GFX1            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					PHX                     ; push sprite index

                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START1         PHX                     ; push current tile number
                    
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP1,x         ;  |
					STA $0301,y             ; /   set y position of the tile
                    
                    LDA #$C6
                    STA $0302,y             ; / 
					
					PHX

					LDA $00                 ; \ tile x position = sprite x location ($00)
                    CLC                     ;  |
                    ADC HORIZ_DISP1,x         ;  |
                    STA $0300,y             ; /   set x position of the tile

					LDA PROPERTIES1,x
                    LDX $15E9               ;  |
                    ORA $15F6,x             ;  | get palette info
					ORA $64
                    STA $0303,y             ; / store tile properties
                    PLX
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START1          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
TILE_RO				dcb $8A,$AA,$8C,$E4,$8E,$AE,$CA,$EA,$CA,$EA,$8E,$AE,$8C,$E4,$8A,$AA
VERT_RO				dcb $F8,$08
PROP_RO				dcb $0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$4D,$4D,$4D,$4D,$4D,$4D,$4D,$4D

SUB_GFX_ROCK		JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					PHX                     ; push sprite index
					LDA $1602,x
					LSR A
					LSR A
					LSR A
					AND #$07
					ASL A
					STA $02
                    LDX #$01                ; loop counter = (number of tiles per frame) - 1
LOOP_STARTRO        LDA $00                 ; \ tile x position = sprite x location ($00)
                    STA $0300,y
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_RO,x         ;  |
					STA $0301,y             ; /   set y position of the tile
					
					PHX                     ; push current tile number
                    TXA
					CLC
					ADC $02
					TAX
					
                    LDA TILE_RO,x
                    STA $0302,y             ; / 
					LDA PROP_RO,x
					ORA $64
                    STA $0303,y
					
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_STARTRO          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$01
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SPEED1				dcb $20,$E0

CHECK_DAMAGE		JSL $01A7DC             ; check for mario/sprite contact
                    BCC RETURN_24           ; (carry set = contact)
                    LDA $1497               ; \ if mario is invincible...
                    BNE RETURN_24             ; /   ... return
                    JSL $00F5B7
RETURN_24           RTS                     ; return 

MODE1				LDA #$FC
					STA $AA,x
					STZ $B6,x
					LDA #$A8
					STA $1602,x
					LDA $15AC,x
					BNE MODE1_E
					STZ $14C8,x
MODE1_E				RTS

MODE2				JSR CHECK_DAMAGE
					LDA $15AC,x
					CMP #$E8
					BCC MODE2_2
					STZ $AA,x
					STZ $B6,x
					LDA #$86
					STA $1602,x
					RTS
MODE2_2				CMP #$D0
					BCC MODE2_3
					STZ $AA,x
					STZ $B6,x
					LDA #$A6
					STA $1602,x
					RTS
MODE2_3				CMP #$CF
					BNE MODE2_4
					LDA #$30
					STA $1570,x
					LDA #$18
					STA $151C,x
					JSR SPEED_DEC
					LDA $1594,x
                    STA $AA,x
                    LDA $1504,x
                    STA $B6,x
					LDA $1594,x
					CMP #$80
					BCS MODE2_E
					CMP #$50
					BCC MODE2_E
					LSR A
					STA $1594,x
					LDA $1504,x
					CMP #$80
					BCS MODE2_3_2
					LSR A
					STA $1504,x
					RTS
MODE2_3_2			LDA #$00
					SEC
					SBC $1504,x
					LSR A
					STA $1504,x
					LDA #$00
					SEC
					SBC $1504,x
					STA $1504,x
MODE2_E				RTS
MODE2_4				LDA $1594,x
                    STA $AA,x
                    LDA $1504,x
                    STA $B6,x
					RTS

MODE3				JSR CHECK_DAMAGE
					LDA #$A8
					STA $1602,x
					LDA $15AC,x
					BNE MODE3_2
					STZ $14C8,x
					RTS
MODE3_2				LDA #$18
					STA $1570,x
					LDA #$0C
					STA $151C,x
					JSR SPEED_DEC
					LDA $1594,x
                    STA $AA,x
                    LDA $1504,x
                    STA $B6,x
MODE3_0				LDA $1594,x
					CMP #$80
					BCS MODE3_4
					CMP #$18
					BCC MODE3_E
					LSR A
					STA $AA,x
MODE3_3_1			LDA $B6,x
					CMP #$80
					BCS MODE3_3_2
					LSR A
					STA $B6,x
					RTS
MODE3_3_2			LDA #$00
					SEC
					SBC $B6,x
					LSR A
					STA $B6,x
					LDA #$00
					SEC
					SBC $B6,x
					STA $B6,x
MODE3_E				RTS
MODE3_4				CMP #$F8
					BCS MODE3_E
					LDA #$F8
					STA $AA,x
					BRA MODE3_3_1
					RTS


MODE4				JSR CHECK_DAMAGE
					LDA $15AC,x
					CMP #$E8
					BCC MODE4_2
					STZ $AA,x
					STZ $B6,x
					LDA #$86
					STA $1602,x
					RTS
MODE4_2				CMP #$D0
					BCC MODE4_3
					STZ $AA,x
					STZ $B6,x
					LDA #$A6
					STA $1602,x
					RTS
MODE4_3				CMP #$B8
					BCC MODE4_5
					STZ $AA,x
					STZ $B6,x
					LDA #$01
					STA $157C,x
					RTS
MODE4_5				CMP #$B7
					BNE MODE4_4
					LDA #$80
					STA $1570,x
					LDA #$40
					STA $151C,x
					JSR SPEED_DEC
					LDA $1594,x
                    STA $AA,x
                    LDA $1504,x
                    STA $B6,x
MODE4_4				LDA $1594,x
                    STA $AA,x
                    LDA $1504,x
                    STA $B6,x
					RTS

SPEED_DEC			REP #$20
					LDA $96
					CLC
					ADC.W #$0010
					STA $96
					SEP #$20
					JSR SPEED_DEC0
					REP #$20
					LDA $96
					SEC
					SBC.W #$0010
					STA $96
					SEP #$20
					RTS

SPEED_DEC0          LDA $E4,x
                    SEC
                    SBC $94
                    STA $0F
                    LDA $14E0,x
                    SBC $95
                    BPL FACE_LEFT
                    JSR RIGHT_SPEED
                    BRA VERC
FACE_LEFT           CMP #$01
                    BEQ LEFT2
                    JSR LEFT_SPEED1
                    BRA VERC
LEFT2               JSR LEFT_SPEED2
VERC                LDA $D8,x
                    SEC
                    SBC $96
                    STA $0F
                    LDA $14D4,x
                    SBC $97
                    BPL FACE_UP
                    JSR DOWN_SPEED
                    LDA $1594,x
                    CMP #$10
                    BCS VER_E
                    LDA #$10
                    STA $1594,x
                    BRA VER_E
FACE_UP             JSR UP_SPEED
                    LDA $1594,x
                    CMP #$F0
                    BCC VER_E
                    LDA #$F0
                    STA $1594,x
VER_E               RTS

UP_SPEED            LDA $0F38
                    CMP #$00
                    BNE UP3
                    LDA $0F
                    CMP #$80
                    BCC UP2
                    LDA #$7F
UP2                 STA $0F
                    BRA UP5
UP3                 CMP #$02
                    BNE UP4
                    JSR UP1_1
                    BRA UP5
UP4                 JSR UP1_2
UP5                 LDA #$00
                    SEC
                    SBC $0F
                    STA $1594,x
                    RTS

DOWN_SPEED          LDA #$00
                    SEC
                    SBC $0F
                    STA $0F
                    LDA $0F38
                    CMP #$00
                    BNE DOWN3
                    LDA $0F
                    CMP #$80
                    BCC DOWN2
                    LDA #$7F
DOWN2               STA $1594,x
                    RTS
DOWN3               CMP #$02
                    BNE DOWN4
                    JSR UP1_1
                    BRA DOWN5
DOWN4               JSR UP1_2
DOWN5               LDA $0F
                    STA $1594,x
                    RTS
UP1_1
LOOPUP1             LDA $0F37
                    BEQ LOOPUP1E
                    LDA $0F
                    LSR A
                    STA $0F
                    DEC $0F37
                    LDA $0F37
                    BNE LOOPUP1
LOOPUP1E            LDA $0F
                    CMP #$80
                    BCC LOOPUP1EE
                    LDA #$7F
                    STA $0F
LOOPUP1EE           RTS

UP1_2               LDA $0F
                    CMP #$80
                    BCC LOOPUP3
                    LDA #$7F
                    STA $0F
                    STZ $0F37
                    RTS
LOOPUP3             LDA $0F37
                    BEQ LOOPUP2E
                    LDA $0F
                    ASL A
                    STA $0F
                    DEC $0F37
                    LDA $0F37
                    BNE UP1_2
LOOPUP2E            LDA $0F
                    CMP #$80
                    BCC LOOPUP2EE
                    LDA #$7F
                    STA $0F
LOOPUP2EE           RTS







LEFT_SPEED1         STZ $0F38
                    LDA $0F
                    CMP $1570,x
                    BCC LEFT1_2
                    LDA #$02
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_40
                    BRA LEFT1_3
LEFT1_2             CMP $151C,x
                    BCS LEFT1_3
                    LDA #$01
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_20
                    BRA LEFT1_3
LEFT1_3             LDA #$00
                    SEC
                    SBC $0F
                    STA $1504,x
                    RTS

LEFT1_40            
LOOP140             LDA $0F
                    CMP $1570,x
                    BCC LOOP140E
                    LSR A
                    STA $0F
                    INC $0F37
                    BRA LOOP140
LOOP140E            RTS
LEFT1_20            
LOOP120             LDA $0F
                    CMP $151C,x
                    BCS LOOP120E
                    ASL A
                    STA $0F
                    INC $0F37
                    BRA LOOP140
LOOP120E            RTS

LEFT_SPEED2         STZ $0F37
                    INC $0F37
                    LDA $0F
                    LSR A
                    CLC
                    ADC #$80
                    STA $0F
                    LDA #$02
                    STA $0F38
                    JSR LEFT1_40
                    LDA #$00
                    SEC
                    SBC $0F
                    STA $1504,x
                    RTS

RIGHT_SPEED         STZ $0F38
                    LDA #$00
                    SEC
                    SBC $0F
                    STA $0F
                    CMP $1570,x
                    BCC RIGHT_2
                    LDA #$02
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_40
                    BRA RIGHT_3
RIGHT_2             CMP $151C,x
                    BCS RIGHT_3
                    LDA #$01
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_20
                    BRA RIGHT_3
RIGHT_3             LDA $0F
                    STA $1504,x
                    RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /




