;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Vipdeath
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"
					STZ $1528,x
					STZ $151C,x
					STZ $14AF
					STZ $1594,x
					STZ $18D4
					STZ $18D5
                    RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                     ; return           
CODE_START          LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
                    
					INC $1570,x
					JSR SHAKE
					LDA $1528,x
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$01
					BNE NOT_MODE2
					JSR MODE2
					RTS
NOT_MODE2			CMP #$02
					BNE NOT_MODE3
					JSR MODE3
					RTS
NOT_MODE3			CMP #$03
					BNE NOT_MODE4
					JSR MODE4
					RTS
NOT_MODE4			JSR MODE5
					RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ETC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SHAKE				LDA $1570,x
					CMP #$80
					BCS SHAKE2
					LDA $1468
					CMP #$FF
					BEQ SHAKE_E
					LDA $1570,x
					CMP #$66
					BCS SHAKE1_2
					CMP #$1A
					BCC SHAKE1_2
					INC $1468
SHAKE1_2			INC $1468
					RTS
SHAKE2				LDA $1468
					BEQ SHAKE_E
					LDA $1570,x
					CMP #$E6
					BCS SHAKE2_2
					CMP #$9A
					BCC SHAKE2_2
					DEC $1468
SHAKE2_2			DEC $1468
SHAKE_E				RTS

MODE1				LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					STA $D8,x
					LDA $97
					STA $14D4,x
					LDA #$08
					STA $1B9A
					LDA $151C,x
					BNE MODE1_3
					LDA $1462
					CMP #$68
					BCC MODE1_2
					LDA $13
					AND #$03
					BNE MODE1_E
MODE1_2				LDA $94
					CLC
					ADC #$01
					STA $94
					LDA $95
					ADC #$00
					STA $95
					LDA $1462
					CLC
					ADC #$01
					STA $1462
					LDA $1463
					ADC #$00
					STA $1463
					CMP #$01
					BNE MODE1_E
					LDA #$01
					STA $1426
					INC $151C,x
MODE1_E				RTS
MODE1_3				LDA #$02
 					STA $1426
					INC $1528,x
					STZ $151C,x
					LDA #$90
					STA $E4,x
					LDA #$01
					STA $14E0,x
					LDA #$50
					STA $D8,x
					STZ $14D4,x
					LDA #$73
					STA $15AC,x
					RTS

MODE2				LDA $18D5
					BEQ MODE2C
					JSR MIRROR
MODE2C				LDA $14AD
					BEQ MODE2A
					LDA $1497
					BEQ MODE28
					STZ $14AD
					STZ $18BD
					BRA MODE2A
MODE28				LDA $14AD
					CMP #$80
					BCS MODE29
					STZ $14AD
					STZ $18BD
					BRA MODE2A
MODE29				LDA #$F0
					STA $18BD
MODE2A				LDA $151C,x
					CMP #$03
					BEQ MODE2A_2
					CMP #$07
					BEQ MODE2B
					CMP #$0B
					BEQ MODE2_1
					BRA MODE2_0
MODE2A_2			INC $1528,x
					LDA #$FF
					STA $14AD
					RTS
MODE2_0				JSR DAMAGE_CHECK
					LDA $15AC,x
					BNE MODE2_E
					JSR SUB_GET_DIR
					LDA #$F3
					STA $15AC,x
					JSR SPRITE_MODE
					RTS
MODE2_1				LDA #$03
					STA $1528,x
					JSR SPRITE_DEL
					LDA #$1E
					STA $1DFB
					LDA #$80
					STA $15AC,x
					RTS
MODE2B				LDA #$01
					STA $18D4
					JSR SPRITE_DEL
					LDA #$FF
					STA $14AD
					LDA #$04
					STA $1528,x
MODE2_E				RTS

MODE3				LDA $14AD
					CMP #$C8
					BNE MODE3_1
					LDA #$03
					STA $18D4
					JSR SPRITE_DEL
					DEC $14AD
					RTS
MODE3_1				CMP #$C0
					BCC MODE3_2
					LDA $1887
					BNE MODE3_E
					LDA #$30
					STA $1887
					LDA #$7F
					STA $15AC,x
MODE3_E				RTS
MODE3_2				LDA $15AC,x
					BEQ MODE3_3
					AND #$1F
					BNE MODE3_4
					LDA #$18
					STA $1DFC
					LDA #$01
					STA $14AF
					LDA #$FF
                    STA $18BD
					RTS
MODE3_4				CMP #$10
					BNE MODE3_E
					STZ $14AF
					RTS
MODE3_3				LDA #$01
					STA $1528,x
					INC $151C,x
					LDA #$FF
					STA $14AD
					STZ $14AF
					RTS

MODE4				LDA $15AC,x
					BNE MODE4_E
					LDA $13
					AND #$07
					BNE MODE4_1
					LDA #$17
					STA $1DFC
MODE4_1				LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					STA $D8,x
					LDA $97
					STA $14D4,x
					LDA $1463
					BNE MODE4_2
					LDA $1462
					CMP #$70
					BCS MODE4_2
					STZ $1887
					LDA #$0B
                    STA $1DFB
					LDA #$FF
                    STA $13C6
                    STA $1493
					STZ $14C8,x
					RTS
MODE4_2				LDA $1887
					BNE MODE4_3
					LDA #$80
					STA $1887
MODE4_3				LDA $13
					AND #$03
					BNE MODE4_E
					LDA $1462
					SEC
					SBC #$01
					STA $1462
					LDA $1463
					SBC #$00
					STA $1463
					LDA $94
					SEC
					SBC #$01
					STA $94
					LDA $95
					SBC #$00
					STA $95
MODE4_E				RTS

MODE5				LDA $151C,x
					CMP #$08
					BEQ MODE5_5
					LDA #$21
					STA $40
					LDA $14AD
					CMP #$20
					BEQ MODE5_4
					LDA $15AC,x
					BNE MODE5_E
					JSR SUB_GET_DIR
					LDA #$F5
					STA $15AC,x
					JSR SPRITE_MODE2
MODE5_E				RTS
MODE5_4				STZ $14AD
					LDA #$02
					STA $18D4
					INC $151C,x
					JSR SPRITE_DEL
					LDA #$FF
					STA $14AD
					RTS
MODE5_5				LDA $14AD
					CMP #$F8
					BCS MODE5_E
					LDA #$01
					STA $14AF
					LDA $14AD
					CMP #$A1
					BCC MODE5_6
					AND #$07
					BNE MODE5_E
					DEC $14AD
					LDA #$02
					STA $14F8,x
					JSR GEN_GCROS
					LDA #$40
					STA $15AC,y
					LDA $18D5
					STA $1528,y
					INC $18D5
					LDA #$10
					STA $1DF9
					RTS
MODE5_6				LDA #$FF
					STA $15AC,x
					STZ $14AD
					STZ $14AF
					LDA #$20
					STA $40
					LDA #$01
					STA $1528,x
					RTS

DAMAGE_CHECK        LDA $E4,x
                    STA $7FFE01
                    LDA $14E0,x
                    STA $7FFE02
                    LDA $D8,x
                    STA $7FFE03
                    LDA $14D4,x
                    STA $7FFE04
                    PHX
                    LDX #$09
LOOP1               LDA $9E,x
                    CMP #$04
                    BNE LOOP3
					LDA $14C8,x
					BEQ LOOP3
                    JSR NEAR_CHECK
                    TYA
                    BEQ LOOP3
					STZ $14C8,x
                    LDA #$28
					STA $1DFC
					PLX
					INC $151C,x
					PHX
LOOP3               DEX
                    BPL LOOP1
                    PLX
                    RTS
					
NEAR_CHECK          LDY #$00
                    LDA $E4,x
                    SEC
                    SBC $7FFE01
                    STA $0F
                    LDA $14E0,x
                    SBC $7FFE02
                    CMP #$00
                    BEQ RIGHT_CHECK
                    CMP #$FF
                    BNE CHECK_E
                    LDA $0F
                    CMP #$F8
                    BCC CHECK_E
                    BRA VER_CHECK
RIGHT_CHECK         LDA $0F
                    CMP #$08
                    BCS CHECK_E
VER_CHECK           LDA $D8,x
                    SEC
                    SBC $7FFE03
                    STA $0F
                    LDA $14D4,x
                    SBC $7FFE04
                    CMP #$00
                    BEQ UNDER_CHECK
                    CMP #$FF
                    BNE CHECK_E
                    LDA $0F
                    CMP #$E0
                    BCC CHECK_E
                    BRA NEAR
UNDER_CHECK         LDA $0F
                    CMP #$20
                    BCS CHECK_E
NEAR                LDY #$01
CHECK_E             RTS

MIRROR				LDA $15
					AND #$03
					BEQ SPEED
					CMP #$01
					BNE LEFT
					STZ $76
					BRA SPEED
LEFT				LDA #$01
					STA $76
SPEED				LDA $7B
					CMP #$80
					BCS S_LEFT
					LDA $94
					CMP #$09
					BCS SPEED2
					LDA #$09
					STA $94
					RTS
SPEED2				LDA $7B
					LSR A
					LSR A
					LSR A
					STA $1602,x
					LDA $94
					SEC
					SBC $1602,x
					STA $94
					LDA $95
					SBC #$00
					STA $95
					RTS
S_LEFT				LDA $94
					CMP #$E8
					BCC S_LEFT2
					LDA #$E7
					STA $94
					RTS
S_LEFT2				LDA $7B
					STA $1602,x
					LDA #$00
					SEC
					SBC $1602,x
					LSR A
					LSR A
					LSR A
					STA $1602,x
					LDA $94
					CLC
					ADC $1602,x
					STA $94
					LDA $95
					ADC #$00
					STA $95
					RTS

SPRITE_DEL			PHX
                    LDX #$09
DEL1                LDA $9E,x
                    CMP #$36
                    BEQ DEL2
					STZ $14C8,x
DEL2                DEX
                    BPL DEL1
                    PLX
                    RTS
					
SPRITE_MODE			LDA $14AD
					BNE SPRITE_2_2
					LDA $13
					SEC
					SBC $94
					AND #$07
					BEQ SPRITE_4
					LDA $94
					CLC
					ADC $13
					AND #$03
					BNE SPRITE_1
					LDA #$09
					STA $14F8,x
					JSR GEN_SPRITE
					RTS
SPRITE_1			CMP #$01
					BNE SPRITE_2
					LDA #$20
					STA $14F8,x
					JSR SUB_GET_X_DIFF
					JSR SUB_GET_Y_DIFF
					JSR GEN_SPRITE
					RTS
SPRITE_2			CMP #$02
					BNE SPRITE_3
SPRITE_2_2			LDA #$B4
					STA $14F8,x
					JSR GEN_SPRITE
					RTS
SPRITE_3			LDA #$2B
					STA $14F8,x
					JSR GEN_SPRITE
					LDA $94
					STA $00E4,y
					LDA #$10
					STA $00D8,y
					RTS
SPRITE_4			JSR SPRITE_DEL
					LDA #$03
					STA $14F8,x
					JSR GEN_GCROS
					LDA #$5F
					STA $15AC,x
					LDA #$2B
					STA $1DFC
					LDA #$04
					STA $18D4
					RTS
					
SPRITE_MODE2		LDA $94
					CLC
					ADC $13
					AND #$03
					BNE SPRITE2_1
					JSR SPRITE_DEL
					LDA #$03
					STA $14F8,x
					JSR GEN_GCROS
					LDA #$5F
					STA $15AC,x
					LDA #$2B
					STA $1DFC
					LDA #$04
					STA $18D4
					RTS
SPRITE2_1			CMP #$01
					BNE SPRITE2_2
					LDA #$20
					STA $14F8,x
					JSR SUB_GET_X_DIFF
					JSR SUB_GET_Y_DIFF
					JSR GEN_SPRITE
					RTS
SPRITE2_2			CMP #$02
					BNE SPRITE2_3
					LDA #$B4
					STA $14F8,x
					JSR GEN_SPRITE
					RTS
SPRITE2_3			LDA #$2B
					STA $14F8,x
					JSR GEN_SPRITE
					LDA $94
					STA $00E4,y
					LDA #$10
					STA $00D8,y
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; generate sprite
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Y_MAGIC             dcb $0C,$0C,$06,$06,$F4,$F4,$FA,$FA
X_MAGIC             dcb $0C,$F4,$10,$F0

RETURNK68           RTS     
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURNK68            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    LDA $14F8,x
                    STA $009E,y
                    
                    LDA $E4,x               ;\ set x position for new sprite
                    STA $00E4,y

                    LDA $14E0,x             ;  |
                    STA $14E0,y             ; /

                    LDA $D8,x               ;\ set y position for new sprite
					STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
					STA $14D4,y             ; /

                    PHX
                    TYX
                    JSL $07F7D2             ;  
                    PLX
					LDA $157C,x
					STA $157C,y
					LDA $14F8,x
					CMP #$20
					BNE RETURNK68

                    PHX                     ; \ set y speed of fire ball
                    LDA $1602,x             ;  |
                    ASL A                   ;  |
                    ASL A                   ;  |
                    ORA $1504,x             ;  |
                    TAX                     ;  |
                    LDA Y_MAGIC,x            ;  |
                    STA $00AA,y             ;  |
                    PLX                     ; /     
                    
                    PHX                     ; \  set x speed of fire ball
                    LDA $1504,x             ;  |
                    TAX                     ;  |
                    LDA X_MAGIC,x            ;  |
                    STA $00B6,y             ; /
                    PLX
					LDA #$10
					STA $1DF9
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


RETURN67            RTS
GEN_GCROS           JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
                    CLC
					ADC $14F8,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
                    LDA $E4,x               ;\ set x position for new sprite
                    STA $00E4,y

                    LDA $14E0,x             ;  |
                    STA $14E0,y             ; /

                    LDA $D8,x               ;\ set y position for new sprite
                    STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; difference in y position
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_GET_Y_DIFF      LDY #$00                
                    LDA $D3                 
                    PHA
                    CLC                     
                    ADC #$10                
                    STA $D3                 
                    LDA $D4                 
                    PHA
                    ADC #$00                
                    STA $D4                 

                    LDA $D3                 
                    SEC                     
                    SBC $D8,x               
                    STA $0E                 
                    LDA $D4                 
                    SBC $14D4,x             
                    BPL LABEL14            
                    INY                     
LABEL14             TYA                     ;  | 
                    STA $1602,x 
                    
                    PLA
                    STA $D4
                    PLA
                    STA $D3
                    
                    RTS                    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; difference in x position
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   

SUB_GET_X_DIFF      LDY #$00                
                    LDA $D1                 
                    SEC                    
                    SBC $E4,x              
                    STA $0F                 
                    LDA $D2                 
                    SBC $14E0,x            
                    BPL TO_RIGHT            
TO_LEFT             INY                     
                    LDA $0F
                    CMP #$B0
                    BCS SET_VAL
                    INY
                    INY                 
                    BRA SET_VAL
TO_RIGHT            LDA $0F
                    CMP #$50
                    BCC SET_VAL
                    INY
                    INY 
SET_VAL             TYA
                    STA $1504,x
                    RTS                     


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817                ; Y = 1 if contact

SUB_GET_DIR         STZ $157C,x                
                    LDA $94                 
                    SEC                     
                    SBC $E4,x               
                    STA $0F                 
                    LDA $95               
                    SBC $14E0,x            
                    BPL LABEL16             
                    INC $157C,x                  
LABEL16             RTS                    
