;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Wanwan
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					DEF_X_POS_LW = $151C
                    DEF_X_POS_HI = $1504
					DEF_Y_POS_LW = $1594
					DEF_Y_POS_HI = $1528
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite initialization JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					JSR SUB_GET_DIR
                    TYA
					EOR #$01
                    STA $157C,x
					LDA $E4,x
					STA DEF_X_POS_LW,x
					LDA $14E0,x
					STA DEF_X_POS_HI,x
					LDA $D8,x
					STA DEF_Y_POS_LW,x
					LDA $14D4,x
					STA DEF_Y_POS_HI,x
					LDA #$30
					STA $15AC,x
					STZ $C2,x
                    RTL
                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
            
                    dcb "MAIN"                        
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_SPRITE_CODE   ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite sprite code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
XSPEED				dcb $10,$F0

START_SPRITE_CODE   JSR SUB_GFX             ; draw sprite gfx
					
                    LDA $14C8,x             ; \ if sprite status != 8...
                    CMP #$08                ;  }   ... not (killed with spin jump [4] or star[2])
                    BNE RETURN              ; /    ... return
                    LDA $9D                 ; \ if sprites locked...
                    BEQ ALIVE               ; /    ... return
RETURN              RTS                     ; return

ALIVE               JSL $27FAF4 ;SUB_OFF_SCREEN_HB
                    JSL $01A7DC
					JSL $01802A
					INC $1570,x             ; increment number of frames sprite has been on screen
					LDA $010B
					CMP #$71
					BNE NORMAL_LEVEL
					JSR POS_PAST
					LDA $C2,x
					CMP #$02
					BNE NOT_MODE2
					JSR MODE2
					RTS
NOT_MODE2			LDA $E4,x
					STA $02
					LDA $14E0,x
					STA $03
					REP #$20
					LDA $02
					SEC
					SBC $94
					SEP #$20
					BCS NORMAL_LEVEL
					LDA #$02
					STA $C2,x
					LDA #$09
					STA $1686,x
NORMAL_LEVEL		LDA $C2,x
					BNE AWAKE
					LDA $15AC,x
					BNE ALIVE2
					JSR SPEED_DEC
					LDA #$40
					STA $15AC,x
					LDA #$01
					STA $C2,x
					RTS
ALIVE2				JSR DIR_CHECK
					LDA $157C,x
					PHX
					TAX
					LDA XSPEED,x
					PLX
					STA $B6,x
					INC $AA,x
					LDA $D8,x
					SEC
					SBC DEF_Y_POS_LW,x
					LDA $14D4,x
					SBC DEF_Y_POS_HI,x
					CMP #$FF
					BEQ RETURN
                    LDA #$D8
					STA $AA,x
					RTS
AWAKE				INC $1570,x
					INC $1570,x
					LDA $15AC,x
					BEQ AWAKE3
					CMP #$30
					BCC AWAKE2
					LDA $1602,x
					STA $AA,x
					RTS
AWAKE2				STZ $AA,x
					STZ $B6,x
					RTS
AWAKE3				LDA #$80
					STA $15AC,x
					STZ $C2,x
					RTS

MODE2				LDA #$30
					STA $B6,x
					LDA $1588,x
					AND #$04
					BEQ MODE2_R
					LDA #$C8
					STA $AA,x
MODE2_R				RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine - specific to sprite
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


SUB_GFX_MODE2		STX $04
					STZ $05
					
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					PHX
					TAX
					LDA TILEMAP,x
					STA $0302,y
					LDA #$00
                    ORA $64
                    STA $0303,y
					PLX
					
					LDA $1570,x
					SEC
					SBC #$06
					AND #$1F
					STA $02
					STZ $03
					JSR GET_0E
					LDA $00
					CLC
					ADC $0E
					STA $0304,y
					LDA $01
					CLC
					ADC $0F
					STA $0305,y
					LDA #$C2
					STA $0306,y
					LDA #$00
					ORA $64
					STA $0307,y
					
					LDA $1570,x
					SEC
					SBC #$0C
					AND #$1F
					STA $02
					STZ $03
					JSR GET_0E
					LDA $00
					CLC
					ADC $0E
					STA $0308,y
					LDA $01
					CLC
					ADC $0F
					STA $0309,y
					LDA #$C2
					STA $030A,y
					LDA #$00
					ORA $64
					STA $030B,y
					
					LDA $1570,x
					SEC
					SBC #$12
					AND #$1F
					STA $02
					STZ $03
					JSR GET_0E
					LDA $00
					CLC
					ADC $0E
					STA $030C,y
					LDA $01
					CLC
					ADC $0F
					STA $030D,y
					LDA #$C2
					STA $030E,y
					LDA #$00
					ORA $64
					STA $030F,y
					
					LDA $1570,x
					SEC
					SBC #$18
					AND #$1F
					STA $02
					STZ $03
					JSR GET_0E
					LDA $00
					CLC
					ADC $0E
					STA $0310,y
					LDA $01
					CLC
					ADC $0F
					STA $0311,y
					LDA #$C2
					STA $0312,y
					LDA #$00
					ORA $64
					STA $0313,y
					
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$04               ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
					RTS
					
GET_0E				PHX
					REP #$30
					LDA $04
					ASL A
					ASL A
					ASL A
					ASL A
					ASL A
					CLC
					ADC $02
					TAX
					SEP #$20
					LDA $7FE000,x
					STA $0E
					LDA $7FF000,x
					STA $0F
					SEP #$10
					PLX
					LDA $0E
					SEC
					SBC $E4,x
					STA $0E
					LDA $0F
					SEC
					SBC $D8,x
					STA $0F
					RTS



TILEMAP             dcb $80,$A8,$AA,$A8
PROPERTIES			dcb $00,$40

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					LDA $010B
					CMP #$71
					BNE SUB_GFX_1
					LDA $C2,x
					CMP #$02
					BCC SUB_GFX_1
					JSR SUB_GFX_MODE2
					RTS
SUB_GFX_1			LDA $E4,x
					SEC
					SBC DEF_X_POS_LW,x
					STA $04
					STA $02
					CMP #$80
					BCS GFX0
					LSR A
					LSR A
					STA $02
					BRA GFX1
GFX0				EOR #$FF
					INC A
					LSR A
					LSR A
					EOR #$FF
					INC A
					STA $02
GFX1				LDA $D8,x
					SEC
					SBC DEF_Y_POS_LW,x
					STA $05
					STA $03
					CMP #$80
					BCS GFX2
					LSR A
					LSR A
					STA $03
					BRA GFX3
GFX2				EOR #$FF
					INC A
					LSR A
					LSR A
					EOR #$FF
					INC A
					STA $03
GFX3				LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					PHX
					TAX
					LDA TILEMAP,x
					STA $0302,y
					PLX
					LDA $00
					STA $0D
                    STA $0300,y
					
					LDA $01
					STA $0E
					STA $0301,y
					LDA $157C,x
					PHX
					TAX
                    LDA PROPERTIES,x
                    LDX $15E9               ;  |
                    ORA $15F6,x             ;  | get palette info
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					STA $0F

					LDX #$00
					
LOOP001				INY
					INY
					INY
					INY
					LDA #$C2
					STA $0302,y
					LDA $0D
					SEC
					SBC $02
					STA $0D
					STA $0300,y
					LDA $0E
					SEC
					SBC $03
					STA $0E
					STA $0301,y
					LDA $0F
					STA $0303,y
					INX
					CPX #$04
					BCC LOOP001
					PLX
					LDA $00
					SEC
					SBC $04
					STA $0300,y
					LDA $01
					SEC
					SBC $05
					STA $0301,y
					
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$04
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ; | set horizontal offscreen if necessary
                    LDA $14E0,x             ; |
                    SBC $1B                 ; |
                    BEQ ON_SCREEN_X         ; |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ; |
                    LDA $E4,x               ; |
                    REP #$20                ; |
                    SEC                     ; |
                    SBC $1A                 ; | mark sprite invalid if far enough off screen
                    CLC                     ; |
                    ADC.W #$0040            ; |
                    CMP.W #$0180            ; |
                    SEP #$20                ; |
                    ROL A                   ; |
                    AND #$01                ; |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ; | 
                    AND #$20                ; | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ; | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ; | set vertical offscreen if necessary
                    ADC TABLE1,y            ; |
                    PHP                     ; |
                    CMP $1C                 ; | (vert screen boundry)
                    ROL $00                 ; |
                    PLP                     ; |
                    LDA $14D4,x             ; | 
                    ADC #$00                ; |
                    LSR $00                 ; |
                    SBC $1D                 ; |
                    BEQ ON_SCREEN_Y         ; |
                    LDA $186C,x             ; | (vert offscreen)
                    ORA TABLE2,y            ; |
                    STA $186C,x             ; |
ON_SCREEN_Y         DEY                     ; |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ; | 
                    SBC $1A                 ; | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ; | 
                    SBC $1C                 ; | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ; |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817                ; Y = 1 if contact

SUB_GET_DIR         LDY #$00                ;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
                    LDA $94                 ;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
                    SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
                    SBC $E4,x               ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
                    STA $0F                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
                    LDA $95                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
                    SBC $14E0,x             ;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
                    BPL LABEL16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
                    INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
LABEL16             RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642

DIR_CHECK			LDA $E4,x
					SEC
					SBC DEF_X_POS_LW,x
					STA $0F
					LDA $14E0,x
					SBC DEF_X_POS_HI,x
					BNE LEFT_POS
					LDA $0F
					CMP #$30
					BCC RETURN30
					LDA #$01
					STA $157C,x
					RTS
LEFT_POS			CMP #$FF
					BNE RETURN30
					LDA $0F
					CMP #$D0
					BCS RETURN30
					STZ $157C,x
RETURN30			RTS




SPEED_DEC			LDA $94
					SEC
					SBC DEF_X_POS_LW,x
					STA $02
					LDA $95
					SBC DEF_X_POS_HI,x
					CMP #$80
					BCS FACE_LEFT1
					STZ $157C,x
					LDA DEF_Y_POS_LW,x
					SEC
					SBC $96
					STA $03
					LDA DEF_Y_POS_HI,x
					SBC $97
					CMP #$80
					BCC FACE_UP
GROUND1				LDA DEF_X_POS_LW,x
					CLC
					ADC #$40
					SEC
					SBC $E4,x
					STA $B6,x
					LDA DEF_Y_POS_LW,x
					SEC
					SBC $D8,x
					STA $AA,x
					STA $1602,x
					RTS
FACE_UP				CMP #$00
					BNE FACE_UP2
					LDA $03
					CMP #$18
					BCC GROUND1
					CMP #$30
					BCS FACE_UP2
					LDA DEF_X_POS_LW,x
					CLC
					ADC #$38
					SEC
					SBC $E4,x
					STA $B6,x
					LDA DEF_Y_POS_LW,x
					SEC
					SBC #$10
					SEC
					SBC $D8,x
					STA $AA,x
					STA $1602,x
					RTS
FACE_LEFT1			LDA #$01
					STA $157C,x
					BRA FACE_LEFT
FACE_UP2			LDA $02
					CMP #$20
					BCC FACE_UP3
					LDA DEF_X_POS_LW,x
					CLC
					ADC #$28
					SEC
					SBC $E4,x
					STA $B6,x
					LDA DEF_Y_POS_LW,x
					SEC
					SBC #$28
					SEC
					SBC $D8,x
					STA $AA,x
					STA $1602,x
					RTS
FACE_UP3			LDA DEF_X_POS_LW,x
					CLC
					ADC #$10
					SEC
					SBC $E4,x
					STA $B6,x
					LDA DEF_Y_POS_LW,x
					SEC
					SBC #$40
					SEC
					SBC $D8,x
					STA $AA,x
					STA $1602,x
					RTS
					
FACE_LEFT			LDA DEF_Y_POS_LW,x
					SEC
					SBC $96
					STA $03
					LDA DEF_Y_POS_HI,x
					SBC $97
					CMP #$80
					BCC LFACE_UP
GROUND2				LDA DEF_X_POS_LW,x
					SEC
					SBC #$40
					SEC
					SBC $E4,x
					STA $B6,x
					LDA DEF_Y_POS_LW,x
					SEC
					SBC $D8,x
					STA $AA,x
					STA $1602,x
					RTS
LFACE_UP			CMP #$00
					BNE LFACE_UP2
					LDA $03
					CMP #$18
					BCC GROUND2
					CMP #$30
					BCS LFACE_UP2
					LDA DEF_X_POS_LW,x
					SEC
					SBC #$38
					SEC
					SBC $E4,x
					STA $B6,x
					LDA DEF_Y_POS_LW,x
					SEC
					SBC #$10
					SEC
					SBC $D8,x
					STA $AA,x
					STA $1602,x
					RTS
LFACE_UP2			LDA $02
					CMP #$E0
					BCS LFACE_UP3
					LDA DEF_X_POS_LW,x
					SEC
					SBC #$28
					SEC
					SBC $E4,x
					STA $B6,x
					LDA DEF_Y_POS_LW,x
					SEC
					SBC #$28
					SEC
					SBC $D8,x
					STA $AA,x
					STA $1602,x
					RTS
LFACE_UP3			LDA DEF_X_POS_LW,x
					SEC
					SBC #$10
					SEC
					SBC $E4,x
					STA $B6,x
					LDA DEF_Y_POS_LW,x
					SEC
					SBC #$40
					SEC
					SBC $D8,x
					STA $AA,x
					STA $1602,x
					RTS

POS_PAST			LDA $1570,x
					AND #$1F
					STA $02
					STZ $03
					STX $04
					STZ $05
					LDA $E4,x
					STA $0E
					LDA $D8,x
					STA $0F
					PHX
					REP #$30
					LDA $04
					ASL A
					ASL A
					ASL A
					ASL A
					ASL A
					CLC
					ADC $02
					TAX
					SEP #$20
					LDA $0E
					STA $7FE000,x
					LDA $0F
					STA $7FF000,x
					SEP #$10
					PLX
					RTS
