;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Wily Machine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
					MARIO_STATUS    = $19 
                    MARIO_X_SPEED   = $7B
                    MARIO_Y_SPEED   = $7D
                    MARIO_X_POS     = $94
                    MARIO_X_POS_HI  = $95
                    MARIO_Y_POS     = $96 
                    MARIO_Y_POS_HI  = $97
                    SPRITE_Y_SPEED  = $AA
                    SPRITE_X_SPEED  = $B6
                    SPRITE_STATE    = $C2
                    SPRITE_Y_POS    = $D8
                    SPRITE_X_POS    = $E4
                    SPRITE_Y_POS_HI = $14D4
                    SPRITE_X_POS_HI = $14E0
                    SPR_OBJ_STATUS  = $1588
                    IS_ON_YOSHI     = $187A 
                    SPRITE_OAM      = $15EA
                    
                    ON_THIS         = $1528

                    YOSHI_OFFSET    = $10
                    SIZE            = $08
                    
                    Y_SPEED         = $10

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


TILEMAP             dcb $81,$82,$83,$90,$91,$92,$93,$A0,$A1,$A2,$A3,$A4
                    dcb $B1,$B2,$B3,$C2
HORZ_DISP           dcb $FC,$04,$0C,$F4,$FC,$04,$0C,$F4,$FC,$04,$0C,$14
                    dcb $FC,$04,$0C,$04
VERT_DISP           dcb $FC,$FC,$FC,$04,$04,$04,$04,$0C,$0C,$0C,$0C,$0C
                    dcb $14,$14,$14,$1C

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA $13BF
					CMP #$54
					BEQ COIND_I
					LDA #$01
                    STA $157C,x         ; direction set
                    STZ $15AC,x
					STZ $14AF
					RTL
COIND_I				PHY
                    JSR SUB_HORZ_POS
                    TYA
                    STA $157C,x
                    PLY
					LDA $D8,x
					STA $1504,x
					LDA $14D4,x
					STA $151C,x
					STZ $C2,x
					STZ $1656,x
					LDA #$29
					STA $1686,x
					LDA #$23
					STA $1662,x
					LDA #$FF
					STA $166E,x
					LDA #$A2
					STA $167A,x
					LDA #$45
					STA $190F,x
					RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

START_HB_CODE       LDA $13BF
					CMP #$54
					BNE NOT_COIND
					JSR COIND
					RTS
NOT_COIND
					JSR KROOL
					RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generate routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; KROOL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

K_RETURN			RTS
KROOL				LDA #$FA
					STA $1466
					LDA #$FF
					STA $1467
					LDA #$81
					STA $167A,x
					LDA #$07
					STA $1662,x
					STZ $1656,x
					LDA $1602,x
					BNE KGFX_2
					JSR KROOL_GFX
					BRA KMAIN
KGFX_2				CMP #$01
					BNE KGFX_3
					JSR KROOL_GFX2
					BRA KMAIN
KGFX_3				CMP #$02
					BNE KGFX_4
					JSR KROOL_GFX3
					BRA KMAIN
KGFX_4				CMP #$03
					BNE KGFX_5
					JSR KROOL_GFX4
					BRA KMAIN
KGFX_5				JSR KROOL_GFX5

KMAIN               LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE K_RETURN              ; /
                    LDA $9D
					BNE K_RETURN
					
					LDA $14AD
					BEQ KMAIN1
					JSR SLOW
KMAIN1				LDA $14AF
					BEQ KMAIN2
					JSR KSHAKE
KMAIN2				LDA $1528,x
					CMP #$0A
					BEQ KMAIN2_2
					STZ $AA,x
KMAIN2_2			JSL $01802A             ; update position based on speed values
					LDA $1528,x
					BNE NOT_KMODE1
					JSR KMODE1
					RTS
NOT_KMODE1			CMP #$01
					BNE NOT_KMODE2
					JSR KMODE2
					RTS
NOT_KMODE2			CMP #$02
					BNE NOT_KMODE3
					JSR KMODE3
					RTS
NOT_KMODE3			CMP #$03
					BNE NOT_KMODE4
					JSR MODE4
					RTS
NOT_KMODE4			CMP #$04
					BNE NOT_KMODE5
					JSR MODE5
					RTS
NOT_KMODE5			CMP #$05
					BNE NOT_KMODE6
					JSR MODE6
					RTS
NOT_KMODE6			CMP #$06
					BNE NOT_KMODE7
					JSR MODE7
					RTS
NOT_KMODE7			CMP #$07
					BNE NOT_KMODE8
					JSR MODE8
					RTS
NOT_KMODE8			CMP #$08
					BNE NOT_KMODE9
					JSR MODE9
					RTS
NOT_KMODE9			CMP #$09
					BNE NOT_KMODEA
					JSR KMODEA
					RTS
NOT_KMODEA			JSR KMODEB
					RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; KROOL ETC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
KMODE1				STZ $1602,x
					STZ $B6,x
					JSR CHECK_DAMAGE
					LDA $15AC,x
					BNE KMODE1_1
					LDA #$30
					STA $15AC,x
					LDA $151C,x
					CMP #$05
					BNE KMODE1_E
					LDA #$40
					STA $15AC,x
					LDA #$01
					STA $1528,x
					STZ $151C,x
					RTS
KMODE1_1			CMP #$10
					BNE KMODE1_3
					LDA $151C,x
					CMP #$04
					BEQ KMODE1_2
					LDA #$49
					STA $02
					JSR GEN_KBUL
					LDA #$01
					STA $1504,y
					LDA #$00
					STA $1528,y
					JSR SUB_SMOKE2
					INC $151C,x
					RTS
KMODE1_2			LDA #$49
					STA $02
					JSR GEN_KBUL
					LDA #$02
					STA $1504,y
					JSR SUB_SMOKE2
					INC $151C,x
KMODE1_3			CMP #$10
					BCS KMODE1_E
					LDA #$01
					STA $1602,x
KMODE1_E			RTS

KMODE2				STZ $1602,x
					JSR CHECK_DAMAGE
					LDA $151C,x
					BNE KMODE2_1
					LDA $15AC,x
					BNE KMODE2_E
					LDA #$49
					STA $02
					JSR GEN_KBUL
					LDA #$03
					STA $1504,y
					INC $151C,x
					LDA #$FF
					STA $151C,y
KMODE2_E			RTS
KMODE2_1			LDA $7FFA01
					CMP #$01
					BEQ KMODE2_4
					CMP #$02
					BEQ KMODE2_5
					LDA $15AC,x
					BNE KMODE2_2
					LDA #$10
					STA $15AC,x
					RTS
KMODE2_2			CMP #$08
					BCS KMODE2_3
					LDA #$08
					STA $B6,x
					RTS
KMODE2_3			LDA #$F8
					STA $B6,x
					RTS
KMODE2_4			LDA #$00
					STA $7FFA01
					LDA #$02
					STA $1528,x
					LDA #$80
					STA $15AC,x
					STZ $151C,x
					INC $1504,x
					RTS
KMODE2_5			LDA #$00
					STA $7FFA01
					LDA #$03
					STA $1528,x
					STZ $15AC,x
					STZ $151C,x
					RTS
					
KMODE3				STZ $1602,x
					JSR CHECK_DAMAGE
					STZ $B6,x
					LDA $151C,x
					BNE KMODE3_4
					LDA $15AC,x
					BEQ KMODE3_3
					CMP #$60
					BCS KMODE3_E
					AND #$07
					BNE KMODE3_2
					LDA #$17
					STA $1DFC
KMODE3_2			LDA $15AC,x
					AND #$04
					BNE KMODE3_1
					LDA #$10
					STA $B6,x
					RTS
KMODE3_1			LDA #$F0
					STA $B6,x
KMODE3_E			RTS
KMODE3_3			LDA #$49
					STA $02
					JSR GEN_KBUL
					LDA #$01
					STA $1504,y
					LDA #$00
					STA $1528,y
					JSR SUB_SMOKE2
					LDA #$01
					STA $151C,x
					LDA #$FF
					STA $15AC,x
					RTS
KMODE3_4			LDA $15AC,x
					CMP #$F0
					BCC KMODE3_5
					CMP #$F8
					BCS KMODE3_4_2
					LDA #$02
					STA $151C,x
KMODE3_4_2			LDA #$02
					STA $1602,x
					RTS
KMODE3_5			CMP #$A0
					BCS KMODE3_E
					CMP #$70
					BCC KMODE3_7
					AND #$04
					BNE KMODE3_6
					LDA #$10
					STA $B6,x
					RTS
KMODE3_6			LDA #$F0
					STA $B6,x
					RTS
KMODE3_7			CMP #$40
					BEQ KMODE3_8
					LDA #$03
					STA $151C,x
					LDA $1504,x
					CMP #$03
					BNE KMODE3_E
					LDA #$01
					STA $14AF
					JSR GEN_SMA
					INC $1504,x
					RTS
KMODE3_8			LDA #$03
					STA $1528,x
					STZ $151C,x
					LDA #$17
					STA $1DFC
					STZ $15AC,x
					RTS
					
MODE4				LDA $1602,x
					CMP #$04
					BEQ MODE4_1
					LDA #$03
					STA $1602,x
MODE4_1				LDA $15AC,x
					BEQ MODE4_2
					STZ $B6,x
					RTS
MODE4_2				JSR CHECK_DAMAGE
					LDA $157C,x
					BEQ MODE4_R
					LDA $E4,x
					AND #$F0
					BEQ MODE4_LE
					LDA #$E0
					STA $B6,x
					RTS
MODE4_LE			STZ $157C,x
					LDA $1504,x
					CMP #$05
					BNE MODE4_LE2
					LDA $1602,x
					CMP #$04
					BEQ MODE4_LE2
					LDA $40
					CMP #$34
					BEQ MODE4_LE1
					LDA #$03
					STA $1528,x
					STZ $151C,x
					LDA #$17
					STA $1DFC
					LDA #$20
					STA $15AC,x
					LDA #$34
					STA $40
					RTS
MODE4_LE1			LDA #$20
					STA $40
					LDA #$04
					STA $1602,x
					LDA #$03
					STA $1528,x
					STZ $151C,x
					LDA #$17
					STA $1DFC
					LDA #$20
					STA $15AC,x
					RTS
MODE4_LE2			JSR MODE_CHECK
					STZ $B6,x
					STZ $1602,x
					RTS
MODE4_R				LDA $E4,x
					AND #$F0
					CMP #$C0
					BEQ MODE4_RE
					LDA #$20
					STA $B6,x
					RTS
MODE4_RE			LDA #$01
					STA $157C,x
					LDA $1504,x
					CMP #$05
					BNE MODE4_RE2
					LDA $1602,x
					CMP #$04
					BEQ MODE4_RE2
					LDA $40
					CMP #$34
					BEQ MODE4_LE1
					LDA #$03
					STA $1528,x
					STZ $151C,x
					LDA #$17
					STA $1DFC
					LDA #$20
					STA $15AC,x
					LDA #$34
					STA $40
					RTS
MODE4_RE2			JSR MODE_CHECK
					STZ $B6,x
					STZ $1602,x
					RTS

MODE5				STZ $1602,x
					STZ $B6,x
					JSR CHECK_DAMAGE
					LDA $15AC,x
					BNE MODE5_1
					LDA #$32
					STA $15AC,x
					LDA $151C,x
					CMP #$09
					BNE MODE5_E
					LDA #$45
					STA $15AC,x
					LDA #$01
					STA $1528,x
					STZ $151C,x
					RTS
MODE5_1				CMP #$11
					BNE MODE5_3
					LDA $151C,x
					CMP #$08
					BEQ MODE5_2
					LDA #$49
					STA $02
					JSR GEN_KBUL
					LDA #$01
					STA $1504,y
					LDA #$01
					STA $1528,y
					JSR SUB_SMOKE2
					INC $151C,x
					RTS
MODE5_2				LDA #$49
					STA $02
					JSR GEN_KBUL
					LDA #$02
					STA $1504,y
					JSR SUB_SMOKE2
					INC $151C,x
MODE5_3				CMP #$10
					BCS MODE5_E
					LDA #$01
					STA $1602,x
MODE5_E				RTS


MODE6				STZ $1602,x
					STZ $B6,x
					JSR CHECK_DAMAGE
					LDA $15AC,x
					BNE MODE6_1
					LDA #$30
					STA $15AC,x
					LDA $151C,x
					CMP #$09
					BNE MODE6_E
					LDA #$43
					STA $15AC,x
					LDA #$01
					STA $1528,x
					STZ $151C,x
					RTS
MODE6_1				CMP #$10
					BNE MODE6_3
					LDA $151C,x
					CMP #$08
					BEQ MODE6_2
					LDA #$49
					STA $02
					JSR GEN_KBUL
					LDA #$01
					STA $1504,y
					LDA #$02
					STA $1528,y
					JSR SUB_SMOKE2
					INC $151C,x
					RTS
MODE6_2				LDA #$49
					STA $02
					JSR GEN_KBUL
					LDA #$02
					STA $1504,y
					JSR SUB_SMOKE2
					INC $151C,x
MODE6_3				CMP #$10
					BCS MODE6_E
					LDA #$01
					STA $1602,x
MODE6_E				RTS


MODE7				STZ $1602,x
					STZ $B6,x
					JSR CHECK_DAMAGE
					LDA $15AC,x
					BNE MODE7_1
					LDA #$1B
					STA $15AC,x
					RTS
MODE7_1				CMP #$11
					BNE MODE7_3
					LDA $151C,x
					CMP #$08
					BEQ MODE7_2
					LDA #$49
					STA $02
					JSR GEN_KBUL
					LDA #$04
					STA $1504,y
					LDA #$01
					STA $1528,y
					JSR SUB_SMOKE2
					INC $151C,x
					RTS
MODE7_2				LDA #$60
					STA $15AC,x
					STZ $151C,x
					LDA #$04
					STA $1528,x
					RTS
MODE7_3				CMP #$10
					BCS MODE7_E
					LDA #$01
					STA $1602,x
MODE7_E				RTS

MODE8				STZ $1602,x
					STZ $B6,x
					JSR CHECK_DAMAGE
					LDA $15AC,x
					BNE MODE8_1
					LDA #$28
					STA $15AC,x
					RTS
MODE8_1				CMP #$10
					BNE MODE8_3
					LDA $151C,x
					CMP #$08
					BEQ MODE8_2
					LDA #$49
					STA $02
					JSR GEN_KBUL
					LDA #$04
					STA $1504,y
					LDA #$02
					STA $1528,y
					JSR SUB_SMOKE2
					INC $151C,x
					RTS
MODE8_2				LDA #$FB
					STA $15AC,x
					STZ $151C,x
					LDA #$08
					STA $1528,x
					STZ $1570,x
					RTS
MODE8_3				CMP #$10
					BCS MODE8_E
					LDA #$01
					STA $1602,x
MODE8_E				RTS

MODE9				STZ $1602,x
					STZ $B6,x
					LDA $40
					CMP #$20
					BNE MODE9_0
					JSR CHECK_DAMAGE
MODE9_0				LDA #$20
					STA $40
					LDA $15AC,x
					CMP #$D8
					BCS MODE9_E
					CMP #$C0
					BCC MODE9_1
					LDA #$34
					STA $40
					RTS
MODE9_1				CMP #$80
					BCC MODE9_2
					LDA #$70
					STA $D8,x
					STZ $14D4,x
					RTS
MODE9_2				CMP #$7F
					BNE MODE9_3
					LDA $13
					CLC
					ADC $94
					AND #$0F
					ASL A
					ASL A
					ASL A
					ASL A
					STA $E4,x
					STZ $14E0,x
					JSR SUB_GET_DIR
					RTS
MODE9_3				CMP #$68
					BCC MODE9_4
					LDA #$40
					STA $D8,x
					LDA #$01
					STA $14D4,x
					LDA #$34
					STA $40
					RTS
MODE9_4				CMP #$50
					BCS MODE9_E
					LDA #$09
					STA $1528,x
					STZ $15AC,x
					STZ $151C,x
MODE9_E				RTS
					
KMODEA				STZ $1602,x
					JSR CHECK_DAMAGE
					LDA $151C,x
					BNE KMODEA_1
					LDA $15AC,x
					BNE KMODEA_E
					LDA $1570,x
					CMP #$04
					BEQ KMODEA_6
					LDA #$49
					STA $02
					JSR GEN_KBUL
					LDA #$03
					STA $1504,y
					INC $151C,x
					INC $1570,x
					LDA #$60
					STA $151C,y
KMODEA_E			RTS
KMODEA_1			LDA $7FFA01
					CMP #$01
					BEQ KMODEA_4
					CMP #$02
					BEQ KMODEA_5
					LDA $15AC,x
					BNE KMODEA_2
					LDA #$10
					STA $15AC,x
					RTS
KMODEA_2			CMP #$08
					BCS KMODEA_3
					LDA #$08
					STA $B6,x
					RTS
KMODEA_3			LDA #$F8
					STA $B6,x
					RTS
KMODEA_4			LDA #$00
					STA $7FFA01
					LDA #$0A
					STA $1528,x
					LDA #$80
					STA $15AC,x
					STZ $151C,x
					RTS
KMODEA_5			LDA #$00
					STA $7FFA01
					LDA #$08
					STA $1528,x
					LDA #$FB
					STA $15AC,x
					STZ $151C,x
					RTS
KMODEA_6			LDA #$49
					STA $02
					JSR GEN_KBUL
					LDA #$02
					STA $1504,y
					JSR SUB_SMOKE2
					LDA #$08
					STA $1528,x
					LDA #$FB
					STA $15AC,x
					STZ $151C,x
					STZ $1570,x
					RTS
					
KMODEB				STZ $1602,x
					STZ $AA,x
					JSR CHECK_DAMAGE
					STZ $B6,x
					LDA $151C,x
					BNE KMODEB_4
					LDA $15AC,x
					BEQ KMODEB_3
					CMP #$60
					BCS KMODEB_E
					AND #$07
					BNE KMODEB_2
					LDA #$17
					STA $1DFC
KMODEB_2			LDA $15AC,x
					AND #$04
					BNE KMODEB_1
					LDA #$10
					STA $B6,x
					RTS
KMODEB_1			LDA #$F0
					STA $B6,x
KMODEB_E			RTS
KMODEB_3			LDA #$49
					STA $02
					JSR GEN_KBUL
					LDA #$01
					STA $1504,y
					LDA #$00
					STA $1528,y
					JSR SUB_SMOKE2
					LDA #$01
					STA $151C,x
					LDA #$FF
					STA $15AC,x
					RTS
KMODEB_4			LDA $15AC,x
					CMP #$F0
					BCC KMODEB_5
					CMP #$F8
					BCS KMODEB_4_2
					LDA #$02
					STA $151C,x
					RTS
KMODEB_4_2			LDA #$02
					STA $1602,x
					RTS
KMODEB_5			CMP #$EF
					BNE KMODEB_5_2
					RTS
KMODEB_5_2			LDA #$B0
					STA $AA,x
					LDA $14D4,x
					BNE KMODEB_E
					LDA $D8,x
					CMP #$50
					BCS KMODEB_E
					LDA #$49
					STA $02
					JSR GEN_KBUL
					LDA #$00
					STA $1504,y
					LDA #$2B
					STA $1DFC
					LDA #$00
					STA $1570,y
					LDA #$40
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					STA $14E0,y
					LDA #$80
					STA $00E4,y
					LDA #$1E
					STA $1DFB
					STZ $1C48,x
					RTS
					


CHECK_DAMAGE		JSL $01A7DC             ; check for mario/sprite contact
                    BCC DAMAGE_E           ; (carry set = contact)
                    LDA $1497               ; \ if mario is invincible...
                    BNE DAMAGE_E             ; /   ... return
                    JSL $00F5B7
DAMAGE_E            RTS                     ; return 

MODE_CHECK			LDA $1504,x
					BNE CHECK2
					STZ $1528,x
					RTS
CHECK2				CMP #$01
					BNE CHECK3
					LDA #$04
					STA $1528,x
					RTS
CHECK3				CMP #$02
					BNE CHECK4
					LDA #$05
					STA $1528,x
					RTS
CHECK4				CMP #$04
					BNE CHECK5
					LDA #$06
					STA $1528,x
					RTS
CHECK5				LDA #$07
					STA $1528,x
					RTS

KSHAKE				INC $14F8,x
					LDA $14F8,x
					AND #$03
					BEQ KSHAKE1
					RTS
KSHAKE1				LDA $14F8,x
					AND #$0F
					CMP #$08
					BCS KSHAKE2
					INC $1468
					RTS
KSHAKE2				DEC $1468
					RTS
					
SLOW				LDA #$AA
                    STA $0D82
					LDA $14AD
					CMP #$90
					BCS SLOW2
					STZ $14AD
					RTS
SLOW2				LDA $7B
					CMP #$80
					BCS SLOW2_1
					CMP #$08
					BCC SLOW3
					LDA #$08
					STA $7B
					BRA SLOW3
SLOW2_1				CMP #$F8
					BCS SLOW3
					LDA #$F8
					STA $7B
SLOW3				LDA $7D
					CMP #$80
					BCS SLOW3_1
					CMP #$08
					BCC SLOW_E
					LDA #$08
					STA $7D
					RTS
SLOW3_1				CMP #$D0
					BCS SLOW_E
					LDA #$D0
					STA $7D
SLOW_E				RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817                ; Y = 1 if contact

SUB_GET_DIR         STZ $157C,x                
                    LDA $94                 
                    SEC                     
                    SBC $E4,x               
                    STA $0F                 
                    LDA $95               
                    SBC $14E0,x            
                    BPL LABEL16             
                    INC $157C,x                  
LABEL16             RTS                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

K_TILEMAP           dcb $83,$85,$A2,$A4,$A6,$C0,$C2,$C4,$C6,$C8,$E0,$E2,$E4,$E6,$E8,$8C,$8E
K_HORIZ_DISP        dcb $18,$08,$20,$10,$00,$30,$20,$10,$00,$F0,$30,$20,$10,$00,$F0,$10,$00
                    dcb $10,$20,$08,$18,$28,$F8,$08,$18,$28,$38,$F8,$08,$18,$28,$38,$18,$28
K_VERT_DISP         dcb $F8,$F8,$08,$08,$08,$18,$18,$18,$18,$18,$28,$28,$28,$28,$28,$38,$38
K_PROPERTIES        dcb $40,$00             ;

KROOL_GFX           JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300) #΍WɌŒ
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder                 
                   
                    LDA #$0F
					STA $0F
					LDA $1528,x
					CMP #$02
					BEQ BLK1
					CMP #$0A
					BNE NO_BLK
BLK1				LDA $151C,x
					CMP #$02
					BNE NO_BLK
					LDA #$0D
					STA $0F
NO_BLK				STZ $03
					LDA $157C,x             ; \ $02 = sprite direction
					STA $02
					BEQ K_NO_ADD
					LDA #$11
                    STA $03                 ; /

K_NO_ADD            PHX                     ; push sprite index

                    LDX #$10               ; loop counter = (number of tiles per frame) - 1
K_LOOP_START        PHX                     ; push current tile number
                    
                    
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC K_VERT_DISP,x         ;  |
                    STA $0301,y             ; /   set y position of the tile

					LDA K_TILEMAP,x           ; \ store tile
                    STA $0302,y             ; / 
					
					TXA
					CLC
					ADC $03
					TAX
					LDA $00                 ; \ tile x position = sprite x location ($00)
                    CLC                     ;  |
                    ADC K_HORIZ_DISP,x         ;  |
                    STA $0300,y             ; /   set x position of the tile
        
                    LDX $02                 ; \
                    LDA K_PROPERTIES,x        ;  | get tile properties using sprite direction
                    ORA $0F
                    ORA $64                 ;  | put in level properties  Unknown, level mode-related
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL K_LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$10                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

K_TILEMAP2          dcb $02,$04,$20,$22,$24,$26,$40,$42,$44,$46,$60,$62,$64,$66,$07,$09,$0B
K_HORIZ_DISP2       dcb $10,$00,$20,$10,$00,$F0,$20,$10,$00,$F0,$20,$10,$00,$F0,$1B,$0B,$FB
                    dcb $15,$25,$05,$15,$25,$35,$05,$15,$25,$35,$05,$15,$25,$35,$0D,$1D,$2D
K_VERT_DISP2        dcb $F2,$F2,$02,$02,$02,$02,$12,$12,$12,$12,$22,$22,$22,$22,$32,$32,$32
K_PROPERTIES2       dcb $40,$00             ;

KROOL_GFX2          JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300) #΍WɌŒ
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder                 
                   
                    STZ $03
					LDA $157C,x             ; \ $02 = sprite direction
					STA $02
					BEQ K_NO_ADD2
					LDA #$11
                    STA $03                 ; /

K_NO_ADD2           PHX                     ; push sprite index

                    LDX #$10               ; loop counter = (number of tiles per frame) - 1
K_LOOP_START2       PHX                     ; push current tile number
                    
                    
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC K_VERT_DISP2,x         ;  |
                    STA $0301,y             ; /   set y position of the tile

					LDA K_TILEMAP2,x           ; \ store tile
                    STA $0302,y             ; / 
					
					TXA
					CLC
					ADC $03
					TAX
					LDA $00                 ; \ tile x position = sprite x location ($00)
                    CLC                     ;  |
                    ADC K_HORIZ_DISP2,x         ;  |
                    STA $0300,y             ; /   set x position of the tile
        
                    LDX $02                 ; \
                    LDA K_PROPERTIES2,x        ;  | get tile properties using sprite direction
                    LDX $15E9               ;  | ;Sprite index for sprite being processed
                    ORA $15F6,x             ;  | get palette info
					ORA $64                 ;  | put in level properties  Unknown, level mode-related
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL K_LOOP_START2          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$10                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

K_TILEMAP3          dcb $48,$4A,$68,$6A,$48,$4A,$68,$6A,$48,$4A,$68,$6A,$48,$4A,$68,$6A
                    dcb $4C,$4E,$6C,$6E,$4C,$4E,$6C,$6E,$4C,$4E,$6C,$6E,$4C,$4E,$6C,$6E
K_HORIZ_DISP3       dcb $00,$10,$00,$10,$30,$20,$30,$20,$00,$10,$00,$10,$30,$20,$30,$20
K_VERT_DISP3        dcb $10,$10,$00,$00,$10,$10,$00,$00,$20,$20,$30,$30,$20,$20,$30,$30
K_PROPETIRE3        dcb $80,$80,$80,$80,$C0,$C0,$C0,$C0,$00,$00,$00,$00,$40,$40,$40,$40


KROOL_GFX3          JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300) #΍WɌŒ
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder 
					STZ $03
					LDA $151C,x
					CMP #$02
					BNE K_NO_ADD3
					LDA #$10
					STA $03
                   
K_NO_ADD3           PHX                     ; push sprite index

                    LDX #$0F               ; loop counter = (number of tiles per frame) - 1
K_LOOP_START3       PHX                     ; push current tile number
                    
                    
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC K_VERT_DISP3,x         ;  |
                    STA $0301,y             ; /   set y position of the tile
					

					LDA $00                 ; \ tile x position = sprite x location ($00)
                    CLC                     ;  |
                    ADC K_HORIZ_DISP3,x         ;  |
                    STA $0300,y             ; /   set x position of the tile
					
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA K_TILEMAP3,x           ; \ store tile
                    STA $0302,y
					PLX
					
                    LDA K_PROPETIRE3,x        ;  | get tile properties using sprite direction
                    ORA #$0B
					ORA $64                 ;  | put in level properties  Unknown, level mode-related
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL K_LOOP_START3          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$0F                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

K_TILEMAP4          dcb $82,$84,$A0,$A3,$A5,$A7,$C0,$C2,$C4,$C6,$C8,$CA,$CC,$E4,$E6,$E8,$EA,$EC,$86,$88
					dcb $82,$84,$A0,$A3,$A5,$A7,$C0,$C2,$C4,$C6,$C8,$AA,$AC,$E4,$E6,$E8,$E0,$E2,$86,$88
K_HORIZ_DISP4       dcb $28,$18,$38,$20,$10,$00,$38,$28,$18,$08,$F8,$E8,$D8,$18,$08,$F8,$E8,$D8,$08,$F8
                    dcb $08,$18,$F8,$10,$20,$30,$F8,$08,$18,$28,$38,$48,$58,$18,$28,$38,$48,$58,$28,$38
K_VERT_DISP4        dcb $F8,$F8,$08,$08,$08,$08,$18,$18,$18,$18,$18,$18,$18,$28,$28,$28,$28,$28,$38,$38
K_PROPERTIES4       dcb $40,$00             ;

KROOL_GFX4          JSR GET_DRAW_INFO

                    STZ $03
					STZ $0F
					LDA $157C,x             ; \ $02 = sprite direction
					STA $02
					BEQ K_NO_ADD40
					LDA #$14
                    STA $03                 ; /
K_NO_ADD40			LDA $13
					LSR A
					LSR A
					LSR A
					AND #$01
					BNE K_NO_ADD4
					LDA #$14
					STA $0F

K_NO_ADD4           PHX                     ; push sprite index

                    LDX #$13               ; loop counter = (number of tiles per frame) - 1
K_LOOP_START4       PHX                     ; push current tile number
                    
                    
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC K_VERT_DISP4,x         ;  |
                    STA $0301,y             ; /   set y position of the tile
					
					PHX
					TXA
					CLC
					ADC $0F
					TAX
					LDA K_TILEMAP4,x           ; \ store tile
                    STA $0302,y             ; / 
					PLX
					
					TXA
					CLC
					ADC $03
					TAX
					LDA $00                 ; \ tile x position = sprite x location ($00)
                    CLC                     ;  |
                    ADC K_HORIZ_DISP4,x         ;  |
                    STA $0300,y             ; /   set x position of the tile
        
                    LDX $02                 ; \
                    LDA K_PROPERTIES4,x        ;  | get tile properties using sprite direction
                    ORA #$0E
					ORA $64                 ;  | put in level properties  Unknown, level mode-related
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL K_LOOP_START4          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$13                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

K_TILEMAP5          dcb $AC,$AE
K_HORIZ_DISP5       dcb $00,$10
					dcb $20,$30
K_VERT_DISP5        dcb $30,$30
K_PROPERTIES5       dcb $40,$00             ;

KROOL_GFX5          JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300) #΍WɌŒ
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder                 
                   
                    STZ $03
					LDA $157C,x             ; \ $02 = sprite direction
					STA $02
					BEQ K_NO_ADD5
					LDA #$02
                    STA $03                 ; /

K_NO_ADD5           PHX                     ; push sprite index

                    LDX #$01               ; loop counter = (number of tiles per frame) - 1
K_LOOP_START5       PHX                     ; push current tile number
                    
                    
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC K_VERT_DISP5,x         ;  |
                    STA $0301,y             ; /   set y position of the tile

					LDA K_TILEMAP5,x           ; \ store tile
                    STA $0302,y             ; / 
					
					TXA
					CLC
					ADC $03
					TAX
					LDA $00                 ; \ tile x position = sprite x location ($00)
                    CLC                     ;  |
                    ADC K_HORIZ_DISP5,x         ;  |
                    STA $0300,y             ; /   set x position of the tile
        
                    LDX $02                 ; \
                    LDA K_PROPERTIES5,x        ;  | get tile properties using sprite direction
                    LDX $15E9               ;  | ;Sprite index for sprite being processed
                    ORA $15F6,x             ;  | get palette info
					ORA $64                 ;  | put in level properties  Unknown, level mode-related
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL K_LOOP_START5          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$01                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

KX_OFFSET           dcb $38,$F8
KX_OFFSET2          dcb $00,$FF

RETURNK67           RTS
GEN_KBUL            JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURNK67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    TYX
					LDA $02
                    STA NEW_SPRITE_NUM,x
                    PLX
                    PHX
                    LDA $157C,x
                    TAX
                    LDA KX_OFFSET,x
                    STA $02
                    LDA KX_OFFSET2,x
                    STA $03
                    PLX
                    
                    LDA $E4,x               ;\ set x position for new sprite
                    CLC
                    ADC $02
                    STA $00E4,y

                    LDA $14E0,x             ;  |
                    ADC $03
                    STA $14E0,y             ; /

                    LDA $D8,x               ;\ set y position for new sprite
					CLC
					ADC #$20
                    STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
					ADC #$00
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
					LDA $157C,x
					STA $157C,y
                    RTS                          ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; hammer routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURNK68           RTS     
GEN_SMA             JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURNK68            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    LDA #$75
                    STA $009E,y
                    
                    LDA #$80
                    STA $00E4,y

                    LDA #$00
                    STA $14E0,y             ; /

                    LDA #$B0
                    STA $00D8,y             ;  |
                    LDA #$00
                    STA $14D4,y             ; /

                    PHX
                    TYX
                    JSL $07F7D2             ;  
                    PLX
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; display smoke effect for diagonal shooter
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    ;up left, down right, down left, up right,
X_OFFSETS           dcb $38,$F8

SUB_SMOKE2          LDA #$09
					STA $1DFC
					LDY #$03                ; \ find a free slot to display effect
					LDA $157C,x
					PHX
					TAX
					LDA X_OFFSETS,x
					STA $03
					PLX

FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
                    RTS                     ; / return if no slots open

FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    LDA $178B,x             ; \
                                         ;  |
                    LDA $D8,x
					CLC
					ADC #$20
                    STA $17C4,y             ; /

                    
                    LDA #$1B                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    
					LDA $E4,x
                    CLC
					ADC $03
                    STA $17C8,y             ; /
                    RTS                    
					
					
X_SPEED				dcb $20,$E0
BOUND_SPEED			dcb $58,$A8



C_RETURN            RTS
COIND			    JSR C_SPRITE_GRAPHICS       ; graphics routine
                    LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE C_RETURN              ; /
                    JSL $27FAF4 ;SUB_OFF_SCREEN_X0
                    LDA $9D                 ; \ if sprites locked, return
                    BNE C_RETURN              ; /
					JSR SUB_HORZ_POS
                    TYA
                    STA $157C,x
					STZ $B6,x
					JSR C_MODE_CHECK
					LDA $C2,x
					BEQ C_RETURN
					CMP #$01
					BNE C_MAIN2
					LDA $157C,x
					PHX
					TAX
					LDA X_SPEED,x
					PLX
					STA $B6,x
C_MAIN2				JSR EDGE_CHECK
					LDA $C2,x
					BEQ C_MAIN_LAST
					CMP #$01
					BNE C_MAIN_L
					JSR BOUND
					BRA C_MAIN_LAST
C_MAIN_L			
					LDA $E4,x
					PHA
					SEC
					SBC #$10
					STA $E4,x
					LDA $14E0,x
					PHA
					SBC #$00
					STA $14E0,x
					LDA $D8,x
					PHA
					SEC
					SBC #$20
					STA $D8,x
					LDA $14D4,x
					PHA
					SBC #$00
					STA $14D4,x
					JSR SUB_B852
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
C_MAIN_LAST			JSL $01802A             ; update position based on speed values
					RTS
					
C_NEAR_CHECK		LDA $157C,x
					BNE C_NEAR_RIGHT
					LDA $94
					SEC
					SBC $E4,x
					STA $7FF00F
					LDA $95
					SBC $14E0,x
					BNE C_NEAR_CHECK_R
					LDA $7FF00F
					CMP #$50
					BCS C_NEAR_CHECK_R
					LDA #$01
					STA $C2,x
C_NEAR_CHECK_R		RTS
C_NEAR_RIGHT		LDA $E4,x
					SEC
					SBC $94
					STA $7FF00F
					LDA $14E0,x
					SBC $95
					BNE C_NEAR_CHECK_R
					LDA $7FF00F
					CMP #$50
					BCS C_NEAR_CHECK_R
					LDA #$01
					STA $C2,x
					RTS
C_MODE_CHECK		LDA $C2,x
					BEQ C_MODE_CHECK2
					LDA #$01
					STA $C2,x
					LDA $D8,x
					SEC
					SBC $96
					STA $0F
					LDA $14D4,x
					SBC $97
					BCC C_MODE_CHECK_R
					LDA $0F
					CMP #$38
					BCC C_MODE_CHECK_R
					LDA $157C,x
					BEQ C_FACE_RIGHT
					LDA $E4,x
					SEC
					SBC $94
					STA $0F
					LDA $14E0,x
					SBC $95
					CMP #$00
					BNE C_MODE_CHECK_R
					LDA $0F
					CMP #$20
					BCS C_MODE_CHECK_R
					LDA #$02
					STA $C2,x
C_MODE_CHECK_R		RTS
C_MODE_CHECK2		JSR C_NEAR_CHECK
					RTS
C_FACE_RIGHT		LDA $94
					SEC
					SBC $E4,x
					STA $0F
					LDA $95
					SBC $14E0,x
					CMP #$00
					BNE C_MODE_CHECK_R
					LDA $0F
					CMP #$20
					BCS C_MODE_CHECK_R
					LDA #$02
					STA $C2,x
					RTS
					
EDGE_CHECK			LDA $1588,x
					AND #$03
					BNE EDGE_CHECK_2
					LDA $D8,x
					CMP $1504,x
					BEQ EDGE_CHECK_R
					LDA $1504,x
					STA $D8,x
					LDA $151C,x
					STA $14D4,x
EDGE_CHECK_2		LDA $157C,x
					BEQ RIGHT_EDGE
					LDA $E4,x
					CLC
					ADC #$02
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
EDGE_CHECK_R		RTS
RIGHT_EDGE			LDA $E4,x
					SEC
					SBC #$02
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
					RTS
					
BOUND				JSL $01A7DC
					BCC NO_BOUND
					LDA $157C,x
					PHX
					TAX
					LDA BOUND_SPEED,x
					STA $7B
					PLX
					LDA #$28
					STA $1DFC
NO_BOUND			RTS



C_SPRITE_GRAPHICS	LDA $C2,x
					BNE C_GRAPHICS_2
					JSR C_SUB_GFX3
					RTS
C_GRAPHICS_2		CMP #$01
					BNE C_GRAPHICS_3
					JSR C_SUB_GFX
					RTS
C_GRAPHICS_3		JSR C_SUB_GFX2
					RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

C_TILEMAP             dcb $20,$22,$24,$40,$42,$44,$60,$62,$64,$36,$A0,$A2,$A4,$C0,$C2,$C4,$E0,$E2,$E4,$B6,
C_HORIZ_DISP          dcb $10,$00,$F0,$10,$00,$F0,$10,$00,$F0,$E0,$F0,$00,$10,$F0,$00,$10,$F0,$00,$10,$20
C_VERT_DISP           dcb $E2,$E2,$E2,$F2,$F2,$F2,$02,$02,$02,$EA
C_PROPERTIES          dcb $40,$00


C_SUB_GFX            JSR GET_DRAW_INFO
					LDA #$00
					STA $7FF002                
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					BEQ C_SUB_GFX_2
					LDA #$0A
					STA $7FF002
					
C_SUB_GFX_2			LDA #$00
					STA $7FF003
					LDA $157C,x
					BEQ C_SUB_GFX_3
					LDA #$0A
					STA $7FF003
C_SUB_GFX_3			PHX
					LDA $157C,x
					TAX
					LDA C_PROPERTIES,x
					STA $7FF00F

                    LDX #$09                ; run loop 4 times, cuz 4 tiles per frame
C_LOOP_START        PHX                     ; push, current tile
                    
					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC C_VERT_DISP,x         ; |
                    STA $0301,y             ; /
					
					PHX
					TXA
					CLC
					ADC $7FF003
					TAX
					
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC C_HORIZ_DISP,x        ; |
                    STA $0300,y             ; /
                    
					
					LDA $7FF00F
					ORA #$0F
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
					PLX

					PHX
					TXA
					CLC
					ADC $7FF002
					TAX
                    LDA C_TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /
					PLX

                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL C_LOOP_START

                    PLX                     ; pull, X = sprite index
					
					STZ $00       
                    STZ $01       
                    STZ $02       
                    STZ $03       
                    LDY #$00                 
                    LDA #SIZE   
                    STA $0000,y   
                    LSR A         
                    STA $0001,y   
                                        
                    LDA $00       
                    PHA           
                    LDA $02       
                    PHA
					
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$09                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
					
					PLA           
                    STA $02       
                    PLA           
                    STA $00
					
                    RTS                     ; return
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

C_TILEMAP2             dcb $8A,$8C,$8E,$AA,$AC,$AE,$CA,$CC,$CE
C_HORIZ_DISP2          dcb $F0,$00,$10,$F0,$00,$10,$F0,$00,$10
C_VERT_DISP2           dcb $E2,$E2,$E2,$F2,$F2,$F2,$02,$02,$02


C_SUB_GFX2          JSR GET_DRAW_INFO
					PHX
                    LDX #$08                ; run loop 4 times, cuz 4 tiles per frame
C_LOOP_START2       PHX                     ; push, current tile
                    
					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC C_VERT_DISP2,x         ; |
                    STA $0301,y             ; /
					
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC C_HORIZ_DISP2,x        ; |
                    STA $0300,y             ; /
                    

					LDA #$0F
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties

                    LDA C_TILEMAP2,x           ; \ store tile
                    STA $0302,y             ; /

                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL C_LOOP_START2

                    PLX                     ; pull, X = sprite index
					
					STZ $00       
                    STZ $01       
                    STZ $02       
                    STZ $03       
                    LDY #$00                 
                    LDA #SIZE   
                    STA $0000,y   
                    LSR A         
                    STA $0001,y   
                                        
                    LDA $00       
                    PHA           
                    LDA $02       
                    PHA
					
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$08                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
					
					PLA           
                    STA $02       
                    PLA           
                    STA $00
					
                    RTS                     ; return
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

C_TILEMAP3             dcb $28,$2A,$48,$4A,$4C,$68,$6A,$6C
C_HORIZ_DISP3          dcb $10,$00,$10,$00,$F0,$10,$00,$F0,$F0,$00,$F0,$00,$10,$F0,$00,$10
C_VERT_DISP3           dcb $E2,$E2,$F2,$F2,$F2,$02,$02,$02
C_PROPERTIES3          dcb $40,$00


C_SUB_GFX3          JSR GET_DRAW_INFO
					LDA #$00
					STA $7FF003
					LDA $157C,x
					BEQ C_SUB_GFX3_3
					LDA #$08
					STA $7FF003
C_SUB_GFX3_3		PHX
					LDA $157C,x
					TAX
					LDA C_PROPERTIES3,x
					STA $7FF00F

                    LDX #$07                ; run loop 4 times, cuz 4 tiles per frame
C_LOOP_START3       PHX                     ; push, current tile
                    
					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC C_VERT_DISP3,x         ; |
                    STA $0301,y             ; /
					
					PHX
					TXA
					CLC
					ADC $7FF003
					TAX
					
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC C_HORIZ_DISP3,x        ; |
                    STA $0300,y             ; /
                    
					
					LDA $7FF00F
					ORA #$0F
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
					PLX

                    LDA C_TILEMAP3,x           ; \ store tile
                    STA $0302,y             ; /


                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL C_LOOP_START3

                    PLX                     ; pull, X = sprite index
					
					STZ $00       
                    STZ $01       
                    STZ $02       
                    STZ $03       
                    LDY #$00                 
                    LDA #SIZE   
                    STA $0000,y   
                    LSR A         
                    STA $0001,y   
                                        
                    LDA $00       
                    PHA           
                    LDA $02       
                    PHA
					
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$07                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
					
					PLA           
                    STA $02       
                    PLA           
                    STA $00
					
                    RTS                     ; return
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817        

SUB_HORZ_POS        LDY #$00                
                    LDA $94                
                    SEC                     
                    SBC $E4,x               
                    STA $0F                 
                    LDA $95                
                    SBC $14E0,x             
                    BPL C_LABEL16             
                    INY                    
C_LABEL16             RTS                     



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; platform code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_B852            STZ ON_THIS,x
					LDA $15C4,x 
                    ORA $154C,x   
                    BNE RETURN05
                          
                    LDA $71       ;Action (5/6=Trigger screen exit)
                    CMP #$01                
                    BCS RETURN05     
                    
                    JSR SUB_B8FF
                    BCC RETURN05      
                    
                    LDA SPRITE_Y_POS,x    
                    SEC          
                    SBC $1C      
                    STA $02      
                    SEC          
                    SBC $0D      
                    STA $09      
                    LDA $80      
                    CLC          
                    ADC #$18     
                    CMP $09      
                    BCS LBL06      
                    LDA MARIO_Y_SPEED    
                    BMI RETURN05     
                    STZ MARIO_Y_SPEED  
                        
                    LDA #$01     
                    STA $1471    ;01 is for the floating rock
                    LDA $0D      
                    CLC          
                    ADC #$1C     
                    STA $00      
                    
                    LDA #$01
                    STA ON_THIS,x
					LDA EXTRA_BITS,x
					AND #$04
					BEQ LBL127
					STA $7FF001
					LDA #$08
					STA $1B9A
LBL127

                    LDA SPRITE_Y_POS,x    
                    SEC          
                    SBC $00      
                    STA MARIO_Y_POS      
                    LDA SPRITE_Y_POS_HI,x  
                    SBC #$00     
                    STA MARIO_Y_POS_HI      
                    LDY #$00     
                    LDA $1491               ;amount to move mario 
                    BPL LBL04      
                    DEY
LBL04
                    CLC                     
                    ADC MARIO_X_POS       
                    STA MARIO_X_POS       
                    TYA           
                    ADC MARIO_X_POS_HI       
                    STA MARIO_X_POS_HI       
RETURN05            RTS           

LBL06               LDA $02       
                    CLC           
                    ADC $0D       
                    STA $02       
                    LDA #$FF      
                    LDY $73       
                    BNE LBL07      
                    LDY MARIO_STATUS       
                    BNE SMALL_MARIO
LBL07
                    LDA #$08   
SMALL_MARIO
                    CLC                     
                    ADC $80      
                    CMP $02      
                    BCC LBL10      
                    LDA MARIO_Y_SPEED       
                    BPL LBL09    
                    LDA #$10                
                    ;STA MARIO_Y_SPEED    
LBL09
                    RTS       
LBL10
                    LDA $0E       
                    CLC           
                    ADC #$10      
                    STA $00       
                    LDY #$00      
                    LDA SPRITE_X_POS,x     
                    SEC           
                    SBC $1A       
                    CMP $7E       
                    BCC LBL11     
                    LDA $00       
                    EOR #$FF      
                    INC A         
                    STA $00       
                    DEY     
LBL11
                    LDA SPRITE_X_POS,x     
                    CLC           
                    ADC $00       
                    ;STA MARIO_X_POS       
                    TYA           
                    ADC SPRITE_X_POS_HI,x   
                    ;STA MARIO_X_POS_HI       
                    ;STZ MARIO_X_SPEED       
                    RTS                     


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; make standable
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_B8FF
                    LDA $00      
                    STA $0E      
                    LDA $02      
                    STA $0D      
                    LDA SPRITE_X_POS,x    
                    CLC               
					ADC #$06     ;#Jnʒu
                    STA $04      
                    LDA SPRITE_X_POS_HI,x  
                    ADC #$00     
                    STA $0A      
                    LDA $00      
                    ASL A        
                    CLC          
                    ADC #$14     ;#TCY
                    STA $06      

                    LDA SPRITE_Y_POS,x    
                    SEC          
                    SBC $02
                    STA $05      
                    LDA SPRITE_Y_POS_HI,x  
                    SBC #$00     
                    STA $0B      
                    LDA $02      
                    ASL A        
                    CLC          
                    ADC #$20    
                    STA $07      
                    JSL $03B664  
                    JSL $03B72B  
                    RTS
