;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Wily Machine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					JSR HDMA_SET
					RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

START_HB_CODE       LDA $1558,x
					BEQ MAIN301
					JSR DOGEZA
					RTS
MAIN301				JSR GET_DRAW_INFO
					LDA #$00
					STA $002126
					STA $002127
					LDA #$
					LDA #$13
					STA $00212C
					LDA #$04
					STA $00212D
					LDA #$02
					STA $00212E
MAIN                JSR CH_COLOR
					JSR MOVE_LAYER2
                    LDA $14C8,x             ; \ if hammer bro status != 8...
                    CMP #$08
                    BNE RETURN              ; /    ... return
                    LDA $9D                 ; \ if sprites locked...
                    BNE RETURN              ; /    ... return
					LDA $1528,x
					CMP #$08
					BCC MAIN01
					JSR FINISH
					LDA #$FF
					STA $1558,x
					LDA #$C0
					STA $15AC,x
					RTS
MAIN01				LDA $16
					ORA $18
					BEQ MAIN0
					INC $1570,x
MAIN0               LDA $C2,x
					BNE NOT_MODE0
					JSR MODE0
RETURN				RTS
NOT_MODE0			CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$02
					BNE NOT_MODE2
					;JSR MODE2
					RTS
NOT_MODE2			CMP #$03
					;BNE NOT_MODE3
					;JSR MODE3
					RTS
					
MODE0				;#Q[WL΂
					LDA #$60
					STA $E4,x
					STZ $14E0,x
					LDA #$F0
					STA $D8,x
					LDA #$00
					STA $14D4,x
					LDA #$01
					STA $C2,x
					RTS
					
					

MODE1				JSR DAMAGE
					LDA $1540,x
					BNE MODE1_6
					LDA $7FE000
					CMP #$71
					BCS MODE1_2
					LDA $7FE000
					CLC
					ADC #$02
					STA $7FE000
					STA $7FE002
					LDA #$FF
					STA $15AC,x
					RTS
MODE1_2				LDA $15AC,x
					CMP #$FE
					BEQ MODE1_3
					CMP #$D0
					BEQ MODE1_4
					CMP #$10
					BEQ MODE1_5
					RTS
MODE1_3				LDA #$01
					STA $151C,x
					RTS
MODE1_4				JSR SUB_GEN1
					RTS
MODE1_5				LDA $151C,x
					CMP #$02
					BNE MODE1_5_2
					JSR SUB_GEN2
MODE1_5_2			STZ $151C,x
					LDA #$80
					STA $1540,x
MODE1_R				RTS
MODE1_6				CMP #$01
					BEQ MODE1_7
					LDA $7FE000
					CMP #$01
					BEQ MODE1_R
					LDA $7FE000
					SEC
					SBC #$02
					STA $7FE000
					STA $7FE002
					RTS
MODE1_7				JSR TELEPORT
					RTS

					
DAMAGE				LDA $151C,x
					BEQ DAMAGE_R
					JSL $01A7DC
DAMAGE_R			RTS


FINISH				JSR SPRITE_DELETE
					LDA #$1E
					STA $1DFB
					STZ $14AD
					STZ $18BD
					LDA #$01
					STA $7FE002
					STA $7FE000
					LDA #$18
					STA $1DFC
					LDA #$3B
					STA $7FF001
					JSR ENER_GEN
					LDA #$00
					STA $1570,y
					LDA $E4,x
					CLC
					ADC #$18
					STA $00E4,y
					LDA #$00
					STA $14E0,y
					LDA $D8,x
					CLC
					ADC #$18
					STA $00D8,y
					LDA $14D4,x
					ADC #$00
					STA $14D4,y
					LDA #$80
					STA $D8,x
					STZ $14D4,x
					LDA #$C0
					STA $E4,x
					STZ $14E0,x
					STZ $1602,x
RETURND				RTS
					
DOGEZA				JSR SUB_GFX
					LDA $9D
					BNE RETURND
					LDA $15AC,x
					BEQ DOGEZA2
					LDA #$FF
					STA $1558,x
					RTS
DOGEZA2				STZ $B6,x
					JSL $01802A
					LDA $14D4,x
					BEQ RETURND
					LDA $D8,x
					CMP #$50
					BCC RETURND
					LDA #$50
					STA $D8,x
					LDA $1558,x
					CMP #$80
					BCS RETURND
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$03
					STA $1602,x
					LDA $1558,x
					CMP #$20
					BEQ DOGEZA3
					CMP #$11
					BCS RETURND
					LDA #$10
					STA $1558,x
					RTS
DOGEZA3				LDA #$0B
                    STA $1DFB
					LDA #$FF
                    STA $13C6
                    STA $1493
					RTS
					
SPRITE_DELETE		STX $0F
					LDY #$00
DELETE_1			CPY $0F
					BEQ DELETE_2
					LDA #$00
					STA $14C8,y
DELETE_2			INY
					CPY #$0A
					BNE DELETE_1
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; etc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MOVE_LAYER2			LDA #$20
					SEC
					SBC $D8,x
					STA $1468
					LDA #$F0
					SEC
					SBC $E4,x
					STA $1466
					RTS
					
X_OFT1				dcb $60,$C0,$00,$60,$C0,$00,$C0,$00
Y_OFT1				dcb $E0,$D0,$D0,$F0,$20,$20,$F0,$F0
Y_OFT2				dcb $00,$00,$00,$00,$01,$01,$00,$00

TELEPORT            LDA $94
					CLC
					ADC $1570,x
					AND #$07
					TAY
					LDA X_OFT1,y
					STA $E4,x
					STZ $14E0,x
					LDA Y_OFT1,y
					STA $D8,x
					LDA Y_OFT2,y
					STA $14D4,x
                    RTS

SUB_GEN1            LDA $13 ;#ꔭ
                    AND #$03
                    CMP #$00
                    BNE LBL1
                    LDA #$01
LBL1                STA $7FF003
                    LDA #$00
                    STA $7FF002
                    LDA #$91
					STA $7FF001
					JSR ENER_GEN
                    LDA $13 ;#񔭖
					CLC
                    ADC $94
                    LSR A
                    AND #$03
                    CMP #$00
                    BNE LBL2
                    LDA #$02
LBL2                STA $7FF003
                    LDA #$01
                    STA $7FF002
                    LDA #$91
					STA $7FF001
					JSR ENER_GEN
                    LDA $13 ;#O
					CLC
					ADC $1570,x
                    AND #$03
                    CMP #$00
                    BNE LBL3
                    LDA #$03
LBL3                STA $7FF003
                    LDA #$00
                    STA $7FF002
                    LDA #$02
                    STA $7FF002
                    LDA #$91
					STA $7FF001
					JSR ENER_GEN
                    LDA $13 ;#l
                    LSR A
                    LSR A
                    AND #$03
                    CMP #$00
                    BNE LBL4
                    LDA #$01
LBL4                STA $7FF003
                    LDA #$03
                    STA $7FF002
                    LDA #$91
					STA $7FF001
					JSR ENER_GEN
                    RTS

SUB_GEN2			LDA #$91
					STA $7FF001
					JSR ENER_GEN
					LDA #$03
					STA $1528,y
					LDA $E4,x
					CLC
					ADC #$18
					STA $00E4,y
					LDA $14E0,x
					ADC #$00
					STA $14E0,y
					LDA $D8,x
					CLC
					ADC #$30
					STA $00D8,y
					LDA $14D4,x
					ADC #$00
					STA $14D4,y
					RTS

CH_COLOR            LDA $14AD
                    CMP #$20
                    BNE COLOR0
                    STZ $14AD
                    RTS
COLOR0              LDA $18BD
                    BEQ COLOR1
					LDA $1497
					BEQ ICE_COLOR
					STZ $14AD
					STZ $18BD
					RTS
ICE_COLOR           LDA #$89 ;X
                    STA $0D82
					STZ $7B
					STZ $7D
					LDA $97
					BEQ MOVE_DOWN
					LDA $96
					CMP #$40
					BCC MOVE_DOWN
					LDA #$40
					STA $96
                    RTS
MOVE_DOWN			REP #$30
					INC $96
					INC $96
					INC $96
					SEP #$30
					RTS
COLOR1              LDA $14AD
                    BEQ COLOR_R
                    LDA #$AA
                    STA $0D82
COLOR_R             RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generate routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


X_OFFSET            dcb $F8,$38,$F8,$38
X_OFFSET2           dcb $FF,$00,$FF,$00
Y_OFFSET            dcb $F0,$F0,$38,$38
Y_OFFSET2           dcb $FF,$FF,$00,$00

RETURN68            RTS     
ENER_GEN            JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
					LDA $7FF002
					STA $02
                    PHX
                    TYX
					LDA $7FF001
                    STA NEW_SPRITE_NUM,x
                    PLX

					PHX
                    LDA $E4,x
					LDX $02
					CLC
					ADC X_OFFSET,x
					STA $00E4,y
					PLX
					
                    PHX
                    LDA $14E0,x
					LDX $02
					ADC X_OFFSET2,x
					STA $14E0,y
					PLX

                    PHX
                    LDA $D8,x
					LDX $02
					CLC
					ADC Y_OFFSET,x
					STA $00D8,y
					PLX

                    PHX
                    LDA $14D4,x
					LDX $02
					ADC Y_OFFSET2,x
					STA $14D4,y
					PLX



                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX                     ; / 

                    LDA #$FF
                    STA $15AC,y             ;Time untill change mode
					LDA $7FF003
					DEC A
					STA $1528,y
					LDA #$00
					STA $151C,y
                    
RETURN67            RTS                     ; return



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HORIZ_DISP          dcb $E8,$F8,$08,$E8,$F8,$08
VERT_DISP           dcb $F0,$F0,$F0,$00,$00,$00
TILEMAP             dcb $80,$A2,$A4,$80,$C2,$C4
					dcb $A6,$A8,$AA,$C6,$C8,$CA
					dcb $80,$A2,$A4,$80,$C2,$C4
					dcb $80,$AC,$AE,$80,$CC,$CE


SUB_GFX             JSR GET_DRAW_INFO
					
					LDA $1602,x
					ASL A
					ASL A
					CLC
					ADC $1602,x
					CLC
					ADC $1602,x
					STA $03
					
					PHX
                    LDX #$05                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START          
					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP,x         ; |
                    STA $0301,y             ; /


                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP,x        ; |
                    STA $0300,y             ; /
					
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /
					
                    LDA #$0D
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties


                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$05                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /


HDMA_SET			LDA #$08
					STA $7FFB18
					LDA #$00
					STA $7FFB19
					LDA #$23
					STA $7FFB1A
					LDA #$00
					STA $7FFB1B
					LDA #$E0
					STA $7FFB1C
					LDA #$7F
					STA $7FFB1D
					
					LDA #$01
					STA $7FE000
					LDA #$00
					STA $7FE001
					LDA #$01
					STA $7FE002
					LDA #$00
					STA $7FE003
					LDA #$01
					STA $7FE004
					LDA #$30
					STA $7FE005
					LDA #$00
					STA $7FE006
					RTS
