;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; wily_energy
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
                    RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RETURN1				RTS
ELE					JSR SUB_GFX2
					LDA $9D
					BNE RETURN1
					LDA $1528,x
					CMP #$04
					BEQ ELE2
					STZ $B6,x
					LDA #$30
					STA $AA,x
					JSL $01802A
					LDA $14D4,x
					BEQ ELE_2
					LDA $D8,x
					CMP #$50
					BCC ELE_2
					LDA #$30
					STA $B6,x
					STZ $AA,x
					LDA #$04
					STA $1528,x
					JSR ENER_GEN
					LDA #$60
					STA $00B6,y
					LDA #$00
					STA $00AA,y
					JSR ENER_GEN
					LDA #$D0
					STA $00B6,y
					LDA #$00
					STA $00AA,y
					JSR ENER_GEN
					LDA #$A0
					STA $00B6,y
					LDA #$00
					STA $00AA,y
					RTS
ELE2				STZ $AA,x
					JSL $01802A
					LDA $14E0,x
					BEQ ELE_2
					STZ $14C8,x
					RTS
ELE_2				JSL $01A7DC
                    BCC RETURN
					LDA $1497               ; \ if mario is invincible...
                    BNE RETURN
					JSL $00F5B7             ; hurt mario
					RTS


RETURN              RTS                    
START_HB_CODE       LDA $1528,x
					CMP #$03
					BCC MAIN00
					JSR ELE
					RTS
MAIN00
					JSR SUB_GFX             ; draw gfx
                    LDA $14C8,x             ; \ if hammer bro status != 8...
                    CMP #$08                ;  }   ... not (killed with spin jump [4] or star[2])
                    BNE RETURN              ; /    ... return
                    LDA $9D                 ; \ if sprites locked...
                    BNE RETURN              ; /    ... return

                    INC $1570,x             ; increment number of frames hammer bro has been on screen
                    LDA $1570,x
                    LSR A
                    LSR A                   ;  | 
                    LSR A 
                    AND #$03
                    STA $1602,x             ; / write frame to show
                    LDA $1594,x
                    STA $AA,x
                    LDA $1504,x
                    STA $B6,x
                    LDA $15AC,x
					CMP #$40
                    BEQ DELETE
                    CMP #$E0
                    BNE MAIN2
                    JSR SPEED_DEC
                    BRA MAINE
DELETE				STZ $14C8,x
					RTS
MAIN2               CMP #$C8
                    BNE MAIN3
                    STZ $1594,x
                    STZ $1504,x
MAIN3               CMP #$A8
                    BNE MAINE
                    JSR SPEED_DEC
MAINE               JSL $01802A 
                    JSL $01A7DC
                    BCC RETURN2
					LDA $1497               ; \ if mario is invincible...
                    BNE RETURN2             ; /   ... return
					LDA $1528,x
					BEQ YELLOW_MAIN
					CMP #$01
					BEQ RED_MAIN
					CMP #$02
					BEQ BLUE_MAIN
RETURN2				RTS
YELLOW_MAIN			JSL $00F5B7             ; hurt mario
					RTS
RED_MAIN            LDA $18BD
                    BNE RETURN2
                    LDA $14AD
                    BNE RETURN2
                    LDA #$17
                    STA $1DFC
                    LDA #$F0
                    STA $14AD       
                    RTS      
BLUE_MAIN			LDA $18BD
                    BNE RETURN2
                    LDA $14AD
                    BNE RETURN2
                    LDA #$1C
                    STA $1DFC
                    LDA #$F0
                    STA $18BD          
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
PROPETIES           dcb $0F,$4F,$8F,$CF
HORZ_DISP           dcb $F8,$08,$F8,$08
VERT_DISP           dcb $F8,$F8,$08,$08

SUB_GFX2            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)

					PHX                     ; push sprite index
                    LDX #$03
LOOP_START          
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP,x         ;  |
                    STA $0301,y             ; /   set y position of the tile
                    
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
					CLC                     ;  |
                    ADC HORZ_DISP,x         ;  |
                    STA $0300,y             ; /   set y position of the tile
					
                    LDA #$84
                    STA $0302,y             ; / 
					
					LDA PROPETIES,x
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

TILEMAP             dcb $86,$88,$8C,$88
					dcb $86,$88,$8A,$88
					dcb $86,$88,$8E,$88
PROPETIES			dcb $05,$09,$07
					
SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                    LDA $1528,x
					ASL A
					ASL A
					STA $03
					PHY
					LDA $1528,x
					TAY
					LDA PROPETIES,y
					STA $02
					PLY
					
                    PHX
					LDA $1602,x             ; \Sprite Image Table 
                    CLC
					ADC $03
                    TAX                     ; \ 
                    
                    LDA $00                 ; \ tile x position = sprite x location ($00)
                    STA $0300,y             ; /
                    
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y             ; /
                    
                    LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; / 

                    LDA $02
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

					
					

RETURN68            RTS     
ENER_GEN            JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
					LDA $7FF002
					STA $02
                    PHX
					LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX

					LDA $E4,x
					STA $00E4,y
					
                    LDA $14E0,x
					STA $14E0,y

                    LDA $D8,x
					STA $00D8,y

                    LDA $14D4,x
					STA $14D4,y



                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX                     ; / 

                    LDA #$04
					STA $1528,y
					LDA #$00
					STA $151C,y
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ETC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPEED_DEC           LDA $E4,x
                    SEC
                    SBC $94
                    STA $0F
                    LDA $14E0,x
                    SBC $95
                    BPL FACE_LEFT
                    JSR RIGHT_SPEED
                    BRA VERC
FACE_LEFT           CMP #$01
                    BEQ LEFT2
                    JSR LEFT_SPEED1
                    BRA VERC
LEFT2               JSR LEFT_SPEED2
VERC                LDA $D8,x
                    SEC
                    SBC $96
                    STA $0F
                    LDA $14D4,x
                    SBC $97
                    BPL FACE_UP
                    JSR DOWN_SPEED
                    LDA $1594,x
                    CMP #$10
                    BCS VER_E
                    LDA #$10
                    STA $1594,x
                    BRA VER_E
FACE_UP             JSR UP_SPEED
                    LDA $1594,x
                    CMP #$F0
                    BCC VER_E
                    LDA #$F0
                    STA $1594,x
VER_E               RTS

UP_SPEED            LDA $0F38
                    CMP #$00
                    BNE UP3
                    LDA $0F
                    CMP #$80
                    BCC UP2
                    LDA #$7F
UP2                 STA $0F
                    BRA UP5
UP3                 CMP #$02
                    BNE UP4
                    JSR UP1_1
                    BRA UP5
UP4                 JSR UP1_2
UP5                 LDA #$00
                    SEC
                    SBC $0F
                    STA $1594,x
                    RTS

DOWN_SPEED          LDA #$00
                    SEC
                    SBC $0F
                    STA $0F
                    LDA $0F38
                    CMP #$00
                    BNE DOWN3
                    LDA $0F
                    CMP #$80
                    BCC DOWN2
                    LDA #$7F
DOWN2               STA $1594,x
                    RTS
DOWN3               CMP #$02
                    BNE DOWN4
                    JSR UP1_1
                    BRA DOWN5
DOWN4               JSR UP1_2
DOWN5               LDA $0F
                    STA $1594,x
                    RTS






UP1_1
LOOPUP1             LDA $0F37
                    BEQ LOOPUP1E
                    LDA $0F
                    LSR A
                    STA $0F
                    DEC $0F37
                    LDA $0F37
                    BNE LOOPUP1
LOOPUP1E            LDA $0F
                    CMP #$80
                    BCC LOOPUP1EE
                    LDA #$7F
                    STA $0F
LOOPUP1EE           RTS

UP1_2               LDA $0F
                    CMP #$80
                    BCC LOOPUP3
                    LDA #$7F
                    STA $0F
                    STZ $0F37
                    RTS
LOOPUP3             LDA $0F37
                    BEQ LOOPUP2E
                    LDA $0F
                    ASL A
                    STA $0F
                    DEC $0F37
                    LDA $0F37
                    BNE UP1_2
LOOPUP2E            LDA $0F
                    CMP #$80
                    BCC LOOPUP2EE
                    LDA #$7F
                    STA $0F
LOOPUP2EE           RTS







LEFT_SPEED1         STZ $0F38
                    LDA $0F
                    CMP #$40
                    BCC LEFT1_2
                    LDA #$02
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_40
                    BRA LEFT1_3
LEFT1_2             CMP #$20
                    BCS LEFT1_3
                    LDA #$01
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_20
                    BRA LEFT1_3
LEFT1_3             LDA #$00
                    SEC
                    SBC $0F
                    STA $1504,x
                    RTS

LEFT1_40            
LOOP140             LDA $0F
                    CMP #$40
                    BCC LOOP140E
                    LSR A
                    STA $0F
                    INC $0F37
                    BRA LOOP140
LOOP140E            RTS
LEFT1_20            
LOOP120             LDA $0F
                    CMP #$20
                    BCS LOOP120E
                    ASL A
                    STA $0F
                    INC $0F37
                    BRA LOOP140
LOOP120E            RTS

LEFT_SPEED2         STZ $0F37
                    INC $0F37
                    LDA $0F
                    LSR A
                    CLC
                    ADC #$80
                    STA $0F
                    LDA #$02
                    STA $0F38
                    JSR LEFT1_40
                    LDA #$00
                    SEC
                    SBC $0F
                    STA $1504,x
                    RTS

RIGHT_SPEED         STZ $0F38
                    LDA #$00
                    SEC
                    SBC $0F
                    STA $0F
                    CMP #$40
                    BCC RIGHT_2
                    LDA #$02
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_40
                    BRA RIGHT_3
RIGHT_2             CMP #$20
                    BCS RIGHT_3
                    LDA #$01
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_20
                    BRA RIGHT_3
RIGHT_3             LDA $0F
                    STA $1504,x
                    RTS






;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

