;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Wily Lift
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;symbolic names for ram addresses
                    MARIO_STATUS    = $19 
                    MARIO_X_SPEED   = $7B
                    MARIO_Y_SPEED   = $7D
                    MARIO_X_POS     = $94
                    MARIO_X_POS_HI  = $95
                    MARIO_Y_POS     = $96 
                    MARIO_Y_POS_HI  = $97
                    SPRITE_Y_SPEED  = $AA
                    SPRITE_X_SPEED  = $B6
                    SPRITE_STATE    = $C2       
                    SPRITE_Y_POS    = $D8
                    SPRITE_X_POS    = $E4
                    SPRITE_Y_POS_HI = $14D4
                    SPRITE_X_POS_HI = $14E0
                    SPR_OBJ_STATUS  = $1588
                    SPRITE_OAM      = $15EA
                    EXTRA_BITS = $7FAB10
					NEW_SPRITE_NUM = $7FAB9E

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA $010B
					CMP #$55
					BEQ INIT_BOMB
					CMP #$59
					BEQ INIT_BOMB
					CMP #$58
					BEQ INIT_WATER
					LDA $14E0,x
					CMP #$07
					BEQ INIT_1
					CMP #$08
					BEQ INIT_2
					CMP #$0B
					BEQ INIT_3
					CMP #$0E
					BEQ INIT_4
					LDA EXTRA_BITS,x
					AND #$04
					BEQ INIT_R
					LDA #$01
					STA $1504,x
					LDA #$10
					STA $1656,x
					STZ $1686,x
					LDA #$B7
					STA $1662,x
					LDA #$05
					STA $166E,x
					LDA #$01
					STA $167A,x
					STZ $190F,x
INIT_R				RTL
INIT_BOMB			LDA #$44
					STA $190F,x
					LDA #$09
					STA $1504,x
					LDA $E4,x
					ORA #$08
					STA $E4,x
					LDA $D8,x
					ORA #$08
					STA $D8,x
					STZ $15AC,x
					RTL
INIT_WATER			LDA #$0A
					STA $1504,x
					LDA $E4,x
					ORA #$08
					STA $E4,x
					RTL
INIT_1				LDA #$02
					STA $1504,x
					LDA #$80
					STA $15AC,x
					LDA #$02
					STA $1540,x
					RTL
INIT_2				LDA #$03
					STA $1504,x
					LDA #$80
					STA $15AC,x
					LDA #$02
					STA $1540,x
					RTL
INIT_3				LDA #$04
					STA $1504,x
					LDA #$40
					STA $15AC,x
					RTL
INIT_4				LDA #$05
					STA $1504,x
					LDA #$80
					STA $1558,x
					LDA #$00
					STA $7FFD02
					STA $7FFD03
					STA $7FFD04
					STZ $1528,x
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                    
START_HB_CODE       LDA $1504,x
					BNE MAIN1
					JSR LIFT
					RTS
MAIN1				CMP #$01
					BNE MAIN2
					JSR WIND
					RTS
MAIN2				CMP #$02
					BNE MAIN3
					JSR BLOCK1
					RTS
MAIN3				CMP #$03
					BNE MAIN4
					JSR BLOCK2
					RTS
MAIN4				CMP #$04
					BNE MAIN5
					JSR BLOCK3
					RTS
MAIN5				CMP #$05
					BNE MAIN6
					JSR DRAGON
					RTS
MAIN6				CMP #$06
					BNE MAIN7
					JSR DRAGON_LIFT
					RTS
MAIN7				CMP #$07
					BNE MAIN8
					JSR FRAME
					RTS
MAIN8				CMP #$08
					BNE MAIN9
					JSR BUBBLE
					RTS
MAIN9				CMP #$09
					BNE MAINA
					JSR BOMB
					RTS
MAINA				JSR WATER
					RTS

LIFT				JSR SUB_GFX
					LDA $9D
					BNE LIFT_R
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSR SUB_B852
LIFT_2				JSR MOVEMENT
					JSR STATUS
LIFT_R				RTS

WATER				JSR SUB_GFX_WATER
					LDA $9D
					BNE WATER_R
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSR SUB_B852
					LDA $C2,x
					BEQ WATER_R
					LDA #$E0
					STA $AA,x
					JSL $01801A
WATER_R				RTS
	
BOMB_R				RTS
BOMB				LDA $1540,x
					BNE BOMB_1
					LDA EXTRA_BITS,x
					AND #$04
					BNE BOMB_0
					JSR SUB_GFX_BOMB
					BRA BOMB_1
BOMB_0				JSR SUB_GFX_BOMB2
BOMB_1				LDA $9D
					BNE BOMB_R
					LDA $14C8,x
					CMP #$08
					BCC BOMB_R
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA $1540,x
					BNE BOMBER
					JSR SUB_B852
					LDA $15AC,x
					CMP #$E0
					BEQ BOMB_2
					CMP #$A0
					BEQ BOMB_2
					CMP #$60
					BEQ BOMB_2
					CMP #$40
					BEQ BOMB_3
					RTS
BOMB_2				INC $1602,x
					LDA #$23
					STA $1DFC
					RTS
BOMB_3				LDA #$40
					STA $1540,x
					LDA #$09
					STA $1DFC
					LDA #$22
					STA $167A,x
BOMBER				LDA $1540,x
					CMP #$01
					BEQ DELETE
					PHB 
					LDA #$02
					PHA
					PLB
					JSL $028086
					PLB
BOMB_R				RTS
DELETE				STZ $14C8,x
					RTS
			
WIND				JSR SUB_GFXW
					LDA $9D
					BNE WIND_R
					LDA $14C8,x
					CMP #$08
					BCC WIND_R
					JSL $01A7DC
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA $15A0,x
                    ORA $186C,x             ;  |
                    BNE WIND_R
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					BNE WIND_2
					LDA #$17
					STA $1DFC
WIND_2				REP #$20
					INC $94
					SEP #$20
					LDA $77
					AND #$01
					BNE WIND_R
WIND_R				RTS


BLOCK1_X			dcb $30,$60,$90,$60,$30,$10,$30,$40,$50,$60,$70,$80,$90,$A0,$77,$77,$77,$77,$77
BLOCK1_X2			dcb $07,$07,$07,$07,$07,$07,$07,$07,$07,$07,$07,$07,$07,$07,$00,$00,$00,$00,$00
BLOCK1_Y			dcb $30,$20,$10,$00,$F0,$D0,$D0,$D0,$D0,$D0,$D0,$D0,$D0,$D0,$00,$00,$00,$00,$00
BLOCK1_Y2			dcb $01,$01,$01,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
DEL1_X				dcb $77,$77,$30,$60,$90,$60,$30,$77,$77,$77,$10,$30,$40,$50,$60,$70,$80,$90,$A0
DEL1_X2				dcb $00,$00,$07,$07,$07,$07,$07,$00,$00,$00,$07,$07,$07,$07,$07,$07,$07,$07,$07
DEL1_Y				dcb $00,$00,$30,$20,$10,$00,$F0,$00,$00,$00,$D0,$D0,$D0,$D0,$D0,$D0,$D0,$D0,$D0
DEL1_Y2				dcb $00,$00,$01,$01,$01,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
TIME				dcb $40,$40,$40,$40,$40,$40,$08,$08,$08,$08,$08,$08,$08,$08,$08,$08,$08,$08,$40

BLOCK1				LDA $9D
					BNE BLOCK1_R
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA $1540,x
					BEQ BLOCK1_0
					JSR DEL_BLOCK1
BLOCK1_0			LDA $15AC,x
					BNE BLOCK1_R
					LDA $1570,x
					CMP #$13
					BCC BLOCK1_1
					LDA #$00
					STA $1570,x
BLOCK1_1			INC $1570,x
					TAY
					LDA TIME,y
					STA $15AC,x
					LDA BLOCK1_X,y
					CMP #$77
					BEQ BLOCK1_2
					STA $9A
					LDA BLOCK1_X2,y
					STA $9B
					LDA BLOCK1_Y,y
					STA $98
					LDA BLOCK1_Y2,y
					STA $99
					JSR GEN_BLK
BLOCK1_2			LDA DEL1_X,y
					CMP #$77
					BEQ BLOCK1_R
					STA $9A
					LDA DEL1_X2,y
					STA $9B
					LDA DEL1_Y,y
					STA $98
					LDA DEL1_Y2,y
					STA $99
					JSR DEL_BLK
BLOCK1_R			RTS

DEL_BLOCK1			LDY #$00
DEL_BLOCK_L			LDA DEL1_X,y
					CMP #$77
					BEQ DEL_BLOCK1_2
					STA $9A
					LDA DEL1_X2,y
					STA $9B
					LDA DEL1_Y,y
					STA $98
					LDA DEL1_Y2,y
					STA $99
					JSR DEL_BLK
DEL_BLOCK1_2		INY
					CPY #$13
					BCC DEL_BLOCK_L
					RTS
					
BLOCK2_X			dcb $C0,$F0,$20,$20
BLOCK2_X2			dcb $08,$08,$09,$09
BLOCK2_Y			dcb $90,$90,$90,$60
BLOCK2_Y2			dcb $00,$00,$00,$00
DEL2_X				dcb $20,$20,$C0,$F0
DEL2_X2				dcb $09,$09,$08,$08
DEL2_Y				dcb $90,$60,$90,$90
DEL2_Y2				dcb $00,$00,$00,$00
TIME2				dcb $40,$40,$40,$40

BLOCK2				LDA $9D
					BNE BLOCK2_R
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA $1540,x
					BEQ BLOCK2_0
					JSR DEL_BLOCK2
BLOCK2_0			
					LDA $15AC,x
					BNE BLOCK2_R
					LDA $1570,x
					CMP #$04
					BCC BLOCK2_1
					LDA #$00
					STA $1570,x
BLOCK2_1			INC $1570,x
					TAY
					LDA TIME2,y
					STA $15AC,x
					LDA BLOCK2_X,y
					STA $9A
					LDA BLOCK2_X2,y
					STA $9B
					LDA BLOCK2_Y,y
					STA $98
					LDA BLOCK2_Y2,y
					STA $99
					JSR GEN_BLK
BLOCK2_2			LDA DEL2_X,y
					STA $9A
					LDA DEL2_X2,y
					STA $9B
					LDA DEL2_Y,y
					STA $98
					LDA DEL2_Y2,y
					STA $99
					JSR DEL_BLK
BLOCK2_R			RTS
DEL_BLOCK2			LDY #$00
DEL_BLOCK2_L		LDA DEL2_X,y
					STA $9A
					LDA DEL2_X2,y
					STA $9B
					LDA DEL2_Y,y
					STA $98
					LDA DEL2_Y2,y
					STA $99
					JSR DEL_BLK
DEL_BLOCK2_2		INY
					CPY #$04
					BCC DEL_BLOCK2_L
					RTS

GEN_BLK				LDA #$06
					STA $1DF9
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$05E5
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
DEL_BLK				PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0025
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
					
BLOCK3_X			dcb $70,$A0,$D0,$00,$30,$60
BLOCK3_X2			dcb $0B,$0B,$0B,$0C,$0C,$0C
BLOCK3_Y			dcb $40,$40,$40,$40,$40,$40
BLOCK3_Y2			dcb $01,$01,$01,$01,$01,$01
TIME3				dcb $40,$40,$40,$40,$40,$40

BLOCK3				LDA $9D
					BNE BLOCK3_R
					STZ $1411
					STZ $1412
					LDA $1463
					CMP #$0C
					BEQ BLOCK3_D
					REP #$20
					INC $1462
					SEP #$20
					LDA $7E
					CMP #$08
					BCS BLOCK3_0
					REP #$20
					INC $94
					SEP #$20
BLOCK3_0			LDA $15AC,x
					BNE BLOCK3_R
					LDA $1570,x
					CMP #$06
					BCS BLOCK3_R
BLOCK3_1			INC $1570,x
					TAY
					LDA TIME3,y
					STA $15AC,x
					LDA BLOCK3_X,y
					STA $9A
					LDA BLOCK3_X2,y
					STA $9B
					LDA BLOCK3_Y,y
					STA $98
					LDA BLOCK3_Y2,y
					STA $99
					JSR GEN_BLK
BLOCK3_R			RTS
BLOCK3_D			STZ $14C8,x
					RTS
					
DRAGON_TBL			dcb $60,$50,$40,$50
DRAGON				LDA $9D
					BNE DRAGON_R
					JSR FLASH
					LDA $7FFD00
					CMP #$17
					BCS DRAGON_1
					LDA $1558,x
					BEQ DRAGON_1
					CMP #$01
					BNE DRAGON_R
					LDA #$23
					STA $1DFB
					STZ $1570,x
DRAGON_R			RTS
DRAGON_1			JSR DRAGON_SCROL
					LDA $1540,x
					BNE DRAGON_2
					REP #$20
					LDA $1462
					CMP.W #$1040
					SEP #$20
					BCS DRAGON_2
					JSR GEN_SPRITE
					LDA #$06
					STA $1504,y
					LDA #$A0
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					LDA $1462
					CLC
					ADC #$C0
					STA $00E4,y
					LDA $1463
					ADC #$00
					STA $14E0,y
					PHY
					JSL $01ACF9
					CLC
					ADC $94
					AND #$03
					TAY
					LDA DRAGON_TBL,y
					PLY
					STA $1540,y
					LDA #$30
					STA $1540,x
DRAGON_2			LDA $C2,x
					BEQ DRAGON_R2
					CMP #$10
					BCS DRAGON_5
					JSR DAMAGE_CHECK
					LDA $C2,x
					CMP #$02
					BEQ DRAGON_4
					LDA $15AC,x
					BNE DRAGON_R2
					LDA #$6C
					STA $15AC,x
					JSR GEN_FRAME
					INC $1570,x
					LDA $1570,x
					CMP #$04
					BEQ DRAGON_3
DRAGON_R2			RTS
DRAGON_3			STZ $1570,x
					JSL $01ACF9
					CLC
					ADC $94
					AND #$01
					BEQ DRAGON_R2
					LDA #$02
					STA $C2,x
					RTS
DRAGON_4			LDA $15AC,x
					BNE DRAGON_R2
					LDA #$57
					STA $15AC,x
					JSR GEN_BUBBLE
					INC $1570,x
					LDA $1570,x
					CMP #$06
					BNE DRAGON_R2
					STZ $1570,x
					LDA #$01
					STA $C2,x
					LDA #$C0
					STA $15AC,x
					RTS
DRAGON_5			JSR DRAGON_LAST
					RTS


DRAGON_LIFT			JSR SUB_GFX_DRA
					LDA $9D
					BNE DRAGON_LIFT_R
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA $7FFD00
					CMP #$18
					BEQ DRAGON_LIFT_D
					LDA $1463
					CMP #$0F
					BNE DRAGON_LIFT_D
					LDA $14E0,x
					CMP #$0F
					BEQ DRAGON_LIFT_D
					LDA $E4,x
					CMP #$F0
					BCS DRAGON_LIFT_D
					STZ $14C8,x
					RTS
DRAGON_LIFT_D		LDA $7FFD00
					CMP #$17
					BNE DRAGON_LIFT_1
					LDA #$F0
					STA $B6,x
					JSL $018022 ;x speed
DRAGON_LIFT_1		LDA #$E8
					STA $AA,x
					LDA #$F8
					STA $B6,x
					JSR SUB_B852
					LDA $1540,x
					BNE DRAGON_LIFT_2
					LDA #$01
					STA $C2,x
					JSL $018022 ;x speed
					LDA $1570,x
					BEQ DRAGON_LIFT_R
					LDA $7E
					CMP #$08
					BCC DRAGON_LIFT_R
					LDA $14
					AND #$01
					BEQ DRAGON_LIFT_R
					REP #$20
					DEC $94
					SEP #$20
DRAGON_LIFT_R		RTS
DRAGON_LIFT_2		JSL $01801A ;y speed
					RTS
					
FRAME				JSR SUB_GFX_FR
					LDA $9D
					BNE FRAME_R
					LDA $14E0,x
					CMP #$0F
					BEQ FRAME_2
					STZ $14C8,x
					RTS
FRAME_2				LDA #$E0
					STA $B6,x
					JSL $018022
					JSL $01A7DC
FRAME_R				RTS

BUBBLE				JSR SUB_GFX_BU
					LDA $9D
					BNE BUBBLE_R
					LDA $14E0,x
					CMP #$0F
					BEQ BUBBLE_1
					LDA $E4,x
					CMP #$F0
					BCS BUBBLE_1
					STZ $14C8,x
					RTS
BUBBLE_1			LDA #$F0
					STA $B6,x
					LDA #$F8
					STA $AA,x
					INC $1570,x
					LDA $1570,x
					AND #$20
					BNE BUBBLE_2
					LDA #$08
					STA $AA,x
BUBBLE_2			JSL $01802A
					JSL $01A7DC
					BCC BUBBLE_R
					STZ $14C8,x
					LDA #$19
					STA $1DFC
					LDA $C2,x
					BEQ BUBBLE_3
					CMP #$01
					BEQ BUBBLE_4
					CMP #$02
					BEQ BUBBLE_5
BUBBLE_R			RTS
BUBBLE_3			LDA #$40
					STA $7FFD02
					RTS
BUBBLE_4			LDA #$09
					STA $7FFD08
					LDA #$04
					STA $7FFD09
					JSR NORMAL_GEN
					RTS
BUBBLE_5			LDA #$08
					STA $7FFD08
					LDA #$74
					STA $7FFD09
					JSR NORMAL_GEN
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; platform code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DRAGON_LAST			LDA $15AC,x
					CMP #$F8
					BEQ DRAGON_LAST_1
					CMP #$F0
					BEQ DRAGON_LAST_2
					CMP #$E8
					BEQ DRAGON_LAST_1
					CMP #$E0
					BEQ DRAGON_LAST_2
					CMP #$D8
					BEQ DRAGON_LAST_1
					CMP #$D0
					BEQ DRAGON_LAST_2
					CMP #$C8
					BEQ DRAGON_LAST_1
					CMP #$C0
					BEQ DRAGON_LAST_2
					CMP #$B8
					BEQ DRAGON_LAST_1
					CMP #$B0
					BEQ DRAGON_LAST_2
					CMP #$A8
					BEQ DRAGON_LAST_1
					CMP #$A0
					BEQ DRAGON_LAST_2
					CMP #$98
					BEQ DRAGON_LAST_1
					CMP #$90
					BEQ DRAGON_LAST_2
					CMP #$88
					BEQ DRAGON_LAST_1
					CMP #$80
					BEQ DRAGON_LAST_2
					CMP #$78
					BEQ DRAGON_LAST_1
					CMP #$70
					BEQ DRAGON_LAST_2
					CMP #$60
					BEQ DRAGON_LAST_3
					RTS
DRAGON_LAST_1		LDA #$00
					STA $2121
					LDA #$FF
					STA $2122
					STA $7F
					STA $2122
					LDA #$10
					STA $1DFC
					RTS
DRAGON_LAST_2		LDA #$00
					STA $2121
					STZ $2122
					STZ $2122
					RTS
DRAGON_LAST_3		LDA #$18
					STA $7FFD00
					REP #$20
					LDA $1464
					STA $7FF201
					SEP #$20
					LDA #$20
					STA $40
					RTS

DAMAGE_CHECK		LDY #$00
					PHX
					LDX #$00
DAMAGE_LOOP			LDA $14C8,x
					CMP #$09
					BCC DAMAGE_CHECK_1
					CMP #$0B
					BCS DAMAGE_CHECK_1
					LDA $9E,x
					CMP #$04
					BNE DAMAGE_CHECK_1
					LDA $14E0,x
					CMP #$0F
					BNE DAMAGE_CHECK_1
					LDA $E4,x
					CMP #$A0
					BCC DAMAGE_CHECK_1
					CMP #$F0
					BCS DAMAGE_CHECK_1
					LDA $D8,x
					STA $00
					LDA $14D4,x
					STA $01
					REP #$20
					LDA.W #$00D0
					SEC
					SBC $7FF201
					STA $02
					LDA $00
					SEC
					SBC $02
					CMP.W #$0040
					SEP #$20
					BCS DAMAGE_CHECK_1
					LDY #$01
					STZ $14C8,x
DAMAGE_CHECK_1		INX
					CPX #$0A
					BCC DAMAGE_LOOP
					PLX
					CPY #$00
					BEQ DAMAGE_CHECK_R
					INC $1528,x
					LDA #$28
					STA $1DFC
					LDA $1528,x
					CMP #$03
					BEQ DAMAGE_CHECK_2
DAMAGE_CHECK_R		RTS
DAMAGE_CHECK_2		JSR SPRITE_DEL
					LDA #$10
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					LDA #$15
					STA $212C
					LDA #$02
					STA $212D
					STZ $40
					LDA #$31
					STA $2121
					LDA #$FF
					STA $2122
					LDA #$7F
					STA $2122
					LDA #$32
					STA $2121
					LDA #$FF
					STA $2122
					LDA #$7F
					STA $2122
					LDA #$33
					STA $2121
					STZ $2122
					STZ $2122
					LDA #$34
					STA $2121
					STZ $2122
					STZ $2122
					LDA #$35
					STA $2121
					STZ $2122
					STZ $2122
					LDA #$36
					STA $2121
					STZ $2122
					STZ $2122
					LDA #$37
					STA $2121
					STZ $2122
					STZ $2122
					LDA #$38
					STA $2121
					STZ $2122
					STZ $2122
					LDA #$1E
					STA $1DFB
					RTS

SPRITE_DEL			PHX
					LDX #$00
DEL_LOOP			LDA $14C8,x
					CMP #$08
					BNE SPRITE_DEL_1
					LDA $1504,x
					CMP #$07
					BCC SPRITE_DEL_1
					STZ $14C8,x
SPRITE_DEL_1		INX
					CPX #$0A
					BCC DEL_LOOP
					PLX
					RTS

FLASH				LDA $7FFD02
					BEQ FLASH_0
					LDA #$00
					STA $2121
					LDA $7FFD03
					STA $2122
					LDA $7FFD04
					STA $2122
					LDA $7FFD02
					DEC A
					STA $7FFD02
					CMP #$30
					BCS FLASH_2
					CMP #$10
					BCC FLASH_3
					RTS
FLASH_0				LDA #$00
					STA $2121
					STA $2122
					STA $2122
					RTS
FLASH_2				REP #$20
					LDA $7FFD03
					CMP.W #$7BDE
					BCS FLASH_4
					CLC
					ADC.W #$0842
					STA $7FFD03
FLASH_4				SEP #$20
					RTS
FLASH_3				REP #$20
					LDA $7FFD03
					BEQ FLASH_4
					SEC
					SBC.W #$0842
					STA $7FFD03
					SEP #$20
					RTS


GEN_FRAME			LDA #$17
					STA $1DFC
					JSR GEN_SPRITE
					LDA #$07
					STA $1504,y
					LDA #$22
					STA $167A,y
					LDA #$80
					STA $00E4,y
					LDA #$0F
					STA $14E0,y
					REP #$20
					LDA.W #$00E0
					SEC
					SBC $7FF201
					STA $00
					SEP #$20
					LDA $00
					STA $00D8,y
					LDA $01
					STA $14D4,y
					RTS
GEN_BUBBLE			JSR GEN_SPRITE
					LDA #$08
					STA $1504,y
					LDA #$80
					STA $00E4,y
					LDA #$0F
					STA $14E0,y
					REP #$20
					LDA.W #$00E0
					SEC
					SBC $7FF201
					STA $00
					SEP #$20
					LDA $00
					STA $00D8,y
					LDA $01
					STA $14D4,y
					JSL $01ACF9
					CLC
					ADC $94
					AND #$03
					BEQ GEN_BUBBLE_R
					DEC A
					STA $00C2,y
GEN_BUBBLE_R		RTS
					
DRAGON_SCROL		LDA $7FFD00
					CMP #$17
					BEQ DRAGON_SCROL_3
					CMP #$18
					BEQ DRAGON_SCROL_1
					LDA $1463
					CMP #$0F
					BEQ DRAGON_SCROL_2
DRAGON_SCROL_1		LDA $7FFD00
					CMP #$18
					BNE DRAGON_SCROL_A
					LDA $1463
					CMP #$11
					BEQ DRAGON_SCROL_R
					JSR DRAGON_SCROL_5
DRAGON_SCROL_A		REP #$20
					INC $1462
					SEP #$20
					LDA $7E
					CMP #$08
					BCS DRAGON_SCROL_R
					REP #$20
					INC $94
					SEP #$20
DRAGON_SCROL_R		RTS
DRAGON_SCROL_2		LDA #$17
					STA $7FFD00
					LDA #$80
					STA $1558,x
					JSR HDMA_LAYER2
					JSR VRAM
					RTS
DRAGON_SCROL_3		JSR WING
					LDA $7E
					CMP #$08
					BCC DRAGON_SCROL_4
					REP #$20
					DEC $94
					SEP #$20
DRAGON_SCROL_4		LDA $1558,x
					BNE DRAGON_SCROL_5
					LDA $C2,x
					CMP #$10
					BCS DRAGON_SCROL_5
					LDA $7FF202
					CMP #$FF
					BNE DRAGON_SCROL_4_1
					LDA #$00
					SEC
					SBC $7FF201
					STA $7FF400
DRAGON_SCROL_4_1	LDA $7FFD01
					CMP #$17
					BEQ DRAGON_SCROL_4_2
					REP #$20
					LDA $7FF201
					DEC A
					STA $7FF201
					LDA $7FF201
					CMP.W #$FFC0
					SEP #$20
					BNE DRAGON_SCROL_5
					LDA #$17
					STA $7FFD01
					BRA DRAGON_SCROL_5
DRAGON_SCROL_4_2	LDA $C2,x
					BNE DRAGON_SCROL_4_3
					LDA #$01
					STA $C2,x
DRAGON_SCROL_4_3	REP #$20
					LDA $7FF201
					INC A
					STA $7FF201
					LDA $7FF201
					CMP.W #$0000
					SEP #$20
					BNE DRAGON_SCROL_5
					LDA #$00
					STA $7FFD01
DRAGON_SCROL_5		LDA $14
					AND #$01
					BEQ DRAGON_SCROL_R2
					REP #$20
					LDA $7FF301
					INC A
					STA $7FF301
					SEP #$20
DRAGON_SCROL_R2		RTS

WING_R				RTS
WING				LDA $14
					AND #$0F
					BNE WING_R
					LDA $C2,x
					CMP #$10
					BCS WING_R
					LDA $14
					AND #$10
					BEQ WING_2
					LDA #$80
					STA $2115
					REP #$20
					LDA.W #$1800
					STA $2116 ;#VRAMAhX
					SEP #$20
					LDA #$01 
					STA $4310
					LDA #$18 ;#VRAM݃f[^($2118)
					STA $4311
					LDA #$7E
					STA $4314 ;#Source bank address
					REP #$20
					LDA.W #$AD00 ;#Source address
					STA $4312
					LDA.W #$0180
					STA $4315 ;#]oCg(4bbp 16x16
					LDY #$02
					STY $420B
					LDA.W #$1900
					STA $2116 ;#VRAMAhX
					SEP #$20
					LDA #$01 
					STA $4310
					LDA #$18 ;#VRAM݃f[^($2118)
					STA $4311
					LDA #$7E
					STA $4314 ;#Source bank address
					REP #$20
					LDA.W #$AF00 ;#Source address
					STA $4312
					LDA.W #$0180
					STA $4315 ;#]oCg(4bbp 16x16
					LDY #$02
					STY $420B
					SEP #$20
					RTS
WING_2				LDA #$80
					STA $2115
					REP #$20
					LDA.W #$1800
					STA $2116 ;#VRAMAhX
					SEP #$20
					LDA #$01 
					STA $4310
					LDA #$18 ;#VRAM݃f[^($2118)
					STA $4311
					LDA #$7E
					STA $4314 ;#Source bank address
					REP #$20
					LDA.W #$B100 ;#Source address
					STA $4312
					LDA.W #$0180
					STA $4315 ;#]oCg(4bbp 16x16
					LDY #$02
					STY $420B
					LDA.W #$1900
					STA $2116 ;#VRAMAhX
					SEP #$20
					LDA #$01 
					STA $4310
					LDA #$18 ;#VRAM݃f[^($2118)
					STA $4311
					LDA #$7E
					STA $4314 ;#Source bank address
					REP #$20
					LDA.W #$B300 ;#Source address
					STA $4312
					LDA.W #$0180
					STA $4315 ;#]oCg(4bbp 16x16
					LDY #$02
					STY $420B
					SEP #$20
					RTS

VRAM				LDA #$80
					STA $2115
					REP #$20
					LDA.W #$1800
					STA $2116 ;#VRAMAhX
					SEP #$20
					LDA #$01 
					STA $4310
					LDA #$18 ;#VRAM݃f[^($2118)
					STA $4311
					LDA #$7E
					STA $4314 ;#Source bank address
					REP #$20
					LDA.W #$AD00 ;#Source address
					STA $4312
					LDA.W #$1000
					STA $4315 ;#]oCg(4bbp 16x16
					LDY #$02
					STY $420B
					SEP #$20
					
					LDA #$31
					STA $2121
					LDA #$21
					STA $2122
					LDA #$04
					STA $2122
					LDA #$32
					STA $2121
					LDA #$60
					STA $2122
					LDA #$02
					STA $2122
					LDA #$33
					STA $2121
					LDA #$1D
					STA $2122
					LDA #$2C
					STA $2122
					LDA #$34
					STA $2121
					LDA #$C0
					STA $2122
					LDA #$79
					STA $2122
					LDA #$35
					STA $2121
					LDA #$50
					STA $2122
					LDA #$0B
					STA $2122
					LDA #$36
					STA $2121
					LDA #$7F
					STA $2122
					LDA #$1E
					STA $2122
					LDA #$37
					STA $2121
					LDA #$1E
					STA $2122
					LDA #$23
					STA $2122
					LDA #$38
					STA $2121
					LDA #$FF
					STA $2122
					LDA #$7F
					STA $2122
					RTS

HDMA_LAYER2			LDA #$00
					STA $212C
					LDA #$17
					STA $212D
					LDA #$00
					STA $2126
					LDA #$FF
					STA $2127
					LDA #$01
					STA $212E
					STA $212F
					LDA #$08
					STA $7FFB18
					LDA #$10
					STA $7FFB20
					LDA #$20
					STA $7FFB28
					LDA #$02
					STA $7FFB19
					STA $7FFB21
					LDA #$00
					STA $7FFB29
					LDA #$0E
					STA $7FFB1A
					LDA #$0F
					STA $7FFB22
					LDA #$23
					STA $7FFB2A
					LDA #$00
					STA $7FFB1B
					STA $7FFB23
					STA $7FFB2B
					LDA #$F2
					STA $7FFB1C
					LDA #$F3
					STA $7FFB24
					LDA #$F4
					STA $7FFB2C
					LDA #$7F
					STA $7FFB1D
					STA $7FFB25
					STA $7FFB2D
					
					LDA #$01
					STA $7FF200
					STA $7FF300
					LDA #$C0
					STA $7FF201
					LDA #$00
					STA $7FF202
					LDA $1466
					STA $7FF301
					LDA $1467
					STA $7FF302
					LDA #$00
					STA $7FF203
					STA $7FF303
					LDA #$01
					STA $7FF400
					LDA #$02
					STA $7FF401
					LDA #$01
					STA $7FF402
					LDA #$00
					STA $7FF403
					LDA #$00
					STA $7FF404
					RTS



RETURN892			RTS
SUB_B852            JSR LENG_CHECK
					CPY #$01
					BEQ RETURN892
					LDA $1570,x
					TAY
					STZ $1570,x
					LDA $1504,x
					CMP #$09
					BEQ SUB_B852_2
					LDA $1602,x
					BNE RETURN892
SUB_B852_2			JSR SUB_B8FF
                    BCC RETURN05      
                    LDA $15C4,x
					ORA $154C,x
                    BNE RETURN05
					
                    LDA SPRITE_Y_POS,x    
                    SEC          
                    SBC $1C      
                    STA $02      
                    SEC          
                    SBC $0D      
                    STA $09      
                    LDA $80      
                    CLC          
                    ADC #$18     
                    CMP $09      
                    BCS LBL06
                    LDA MARIO_Y_SPEED    
                    BMI RETURN05     
                    STZ MARIO_Y_SPEED  ;#ɏĂ
                    LDA #$01     
                    STA $1471       
					STA $1570,x
					CPY #$01
					BEQ LBL187
					LDA $1504,x
					CMP #$0A
					BEQ LBL235
					LDA $1504,x
					CMP #$06
					BEQ LBL187
					LDA $1504,x
					CMP #$09
					BNE LBL1872
					LDA EXTRA_BITS,x
					AND #$04
					BNE LBL187
					LDA $15AC,x
					BNE LBL187
					LDA #$FF
					STA $15AC,x
					INC $1602,x
LBL1872				LDA #$3F
					STA $1DFC
					BRA LBL187
LBL235				LDA #$01
					STA $C2,x
LBL187				LDA $0D      
                    CLC          
                    ADC #$1F     ;#1F?
                    
					STA $00

                    LDA SPRITE_Y_POS,x    
                    SEC          
                    SBC $00      
                    STA MARIO_Y_POS      
                    LDA SPRITE_Y_POS_HI,x  
                    SBC #$00     
                    STA MARIO_Y_POS_HI      
                    LDY #$00     
RETURN05            RTS           
LBL06				LDA $1504,x
					CMP #$09
					BNE RETURN05
					LDA $02       
                    CLC           
                    ADC $0D       ;#^e/2
                    STA $02       
                    LDA #$FF      
                    LDY $73       
                    BNE LBL07      
                    LDY MARIO_STATUS       
                    BNE SMALL_MARIO
LBL07
                    LDA #$08   
SMALL_MARIO
                    CLC                     
                    ADC $80      
                    CMP $02      
                    BCC LBL10      
                    LDA MARIO_Y_SPEED       ;#ɂԂĂ
					BPL LBL09
                    LDA #$10                
                    STA MARIO_Y_SPEED    
LBL09				RTS       
LBL10
                    LDA $0E       ;#/2
                    CLC           
                    ADC #$10      
                    STA $00       
                    LDY #$00      
                    LDA SPRITE_X_POS,x     
                    SEC           
                    SBC $1A       
                    CMP $7E       
                    BCC LBL11     
                    LDA $00       
                    EOR #$FF      
                    INC A         
                    STA $00       
                    DEY
					
					LDA EXTRA_BITS,x
					AND #$04
					BEQ LBL11
					LDA $15AC,x
					BNE LBL11
					LDA #$FF
					STA $15AC,x
					INC $1602,x
					LDA #$3F
					STA $1DFC
LBL11
                    LDA SPRITE_X_POS,x     ;#ɐGĂ
                    CLC           
                    ADC $00       
                    STA MARIO_X_POS       
                    TYA           
                    ADC SPRITE_X_POS_HI,x   
                    STA MARIO_X_POS_HI       
                    STZ MARIO_X_SPEED       
                    RTS

LENG_CHECK			LDY #$01
					LDA $E4,x
					SEC
					SBC $94
					STA $0E
					LDA $14E0,x
					SBC $95
					STA $0F
					REP #$30
					LDA $0E
					CMP.W #$0040
					BCC LENG_CHECK_3
					CMP.W #$FFC0
					BCS LENG_CHECK_3
					SEP #$30
					RTS
					
LENG_CHECK_3		SEP #$30
					LDA $D8,x
					SEC
					SBC $96
					STA $0E
					LDA $14D4,x
					SBC $97
					STA $0F
					REP #$30
					LDA $0E
					CMP.W #$0040
					BCC LENG_CHECK_4
					CMP.W #$FFC0
					BCS LENG_CHECK_4
					SEP #$30
					RTS
LENG_CHECK_4		SEP #$30
					LDY #$00
					RTS

STATUS				JSR TILE_CHECK
					LDA $1528,x
					CMP #$60
					BEQ STATUS0_3
					CMP #$50
					BEQ STATUS0_4
					CMP #$51
					BEQ STATUS0_5
					CMP #$61
					BEQ STATUS0_6
					CMP #$46
					BEQ STATUS0_7
					CMP #$44
					BEQ STATUS0_8
					CMP #$45
					BEQ STATUS0_9
					CMP #$56
					BEQ STATUS0_A
					CMP #$52
					BEQ STATUS0_B
					CMP #$62
					BEQ STATUS0_B
					CMP #$71
					BEQ STATUS0_C
					CMP #$72
					BEQ STATUS0_C
					CMP #$76
					BEQ STATUS0_C
					RTS
STATUS0_C			STZ $1602,x
					STZ $157C,x
					RTS
STATUS0_B			LDA #$01
					STA $1602,x
					INC $157C,x
					RTS
STATUS0_3			STZ $1602,x
					STZ $157C,x
					JSR STATUS3
					RTS
STATUS0_4			STZ $1602,x
					STZ $157C,x
					JSR STATUS4
					RTS
STATUS0_5			STZ $1602,x
					STZ $157C,x
					JSR STATUS5
					RTS
STATUS0_6			STZ $1602,x
					STZ $157C,x
					JSR STATUS6
					RTS
STATUS0_7			LDA #$01
					STA $1602,x
					INC $157C,x
					JSR STATUS3
					RTS
STATUS0_8			LDA #$01
					STA $1602,x
					INC $157C,x
					JSR STATUS4
					RTS
STATUS0_9			LDA #$01
					STA $1602,x
					INC $157C,x
					JSR STATUS5
					RTS
STATUS0_A			LDA #$01
					STA $1602,x
					INC $157C,x
					JSR STATUS6
					RTS

STATUS3				LDA $C2,x
					BEQ STATUS3_1
					CMP #$01
					BEQ STATUS3_2
STATUS3_R			RTS
STATUS3_1			LDA $E4,x
					AND #$0F
					BNE STATUS3_R
					LDA #$03
					STA $C2,x
					RTS
STATUS3_2			LDA $D8,x
					AND #$0F
					BNE STATUS3_R
					LDA #$02
					STA $C2,x
					RTS
					
STATUS4				LDA $C2,x
					BEQ STATUS4_1
					CMP #$03
					BEQ STATUS4_2
STATUS4_R			RTS
STATUS4_1			LDA $E4,x
					AND #$0F
					BNE STATUS4_R
					LDA #$01
					STA $C2,x
					RTS
STATUS4_2			LDA $D8,x
					AND #$0F
					BNE STATUS4_R
					LDA #$02
					STA $C2,x
					RTS
					
STATUS5				LDA $C2,x
					CMP #$02
					BEQ STATUS5_1
					CMP #$03
					BEQ STATUS5_2
STATUS5_R			RTS
STATUS5_1			LDA $E4,x
					AND #$0F
					BNE STATUS5_R
					LDA #$01
					STA $C2,x
					RTS
STATUS5_2			LDA $D8,x
					AND #$0F
					BNE STATUS5_R
					STZ $C2,x
					RTS
					
STATUS6				LDA $C2,x
					CMP #$02
					BEQ STATUS6_1
					CMP #$01
					BEQ STATUS6_2
STATUS6_R			RTS
STATUS6_1			LDA $E4,x
					AND #$0F
					BNE STATUS6_R
					LDA #$03
					STA $C2,x
					RTS
STATUS6_2			LDA $D8,x
					AND #$0F
					BNE STATUS6_R
					STZ $C2,x
					RTS
					
MOVEMENT			LDA $C2,x
					BEQ MOVEMENT1
					CMP #$01
					BEQ MOVEMENT2
					CMP #$02
					BEQ MOVEMENT3
					CMP #$03
					BEQ MOVEMENT4
					RTS
MOVEMENT1			JSR MOVE_LEFT
					RTS
MOVEMENT2			JSR MOVE_DOWN
					RTS
MOVEMENT3			JSR MOVE_RIGHT
					RTS
MOVEMENT4			JSR MOVE_UP
					RTS
MOVE_LEFT			LDA $E4,x
					SEC
					SBC #$02
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
					LDA $1570,x
					BEQ MOVE_LEFT_R
					LDA $77
					AND #$02
					BNE MOVE_LEFT_R
					REP #$20
					DEC $94
					DEC $94
					SEP #$20
MOVE_LEFT_R			RTS
MOVE_RIGHT			LDA $E4,x
					CLC
					ADC #$02
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					LDA $1570,x
					BEQ MOVE_RIGHT_R
					LDA $77
					AND #$01
					BNE MOVE_RIGHT_R
					REP #$20
					INC $94
					INC $94
					SEP #$20
MOVE_RIGHT_R		RTS
MOVE_DOWN			LDA $D8,x
					CLC
					ADC #$02
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					LDA $1570,x
					BEQ MOVE_DOWN_R
					REP #$20
					INC $96
					INC $96
					SEP #$20
MOVE_DOWN_R			RTS
MOVE_UP				LDA $D8,x
					SEC
					SBC #$02
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					LDA $1570,x
					BEQ MOVE_UP_R
					LDA $77
					AND #$08
					BNE MOVE_UP_R
					REP #$20
					DEC $96
					DEC $96
					SEP #$20
MOVE_UP_R			RTS

TILE_CHECK			;LDA $E4,x
					;AND #$0E
					;BNE RETURN83
					;LDA $D8,x
					;AND #$0E
					;BNE RETURN83
					LDA $D8,x
					PHA
					SEC
					SBC #$08
					STA $D8,x
					LDA $14D4,x
					PHA
					SBC #$00
					STA $14D4,x
					LDA $E4,x
					PHA
					SEC
					SBC #$08
					STA $E4,x
					LDA $14E0,x
					PHA
					SBC #$00
					STA $14E0,x
					JSL $019138
					LDA $03
					STA $1528,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
RETURN83			RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; make standable
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_B8FF			;#$00XvCg̉ $01 0 $02 0
                    LDA $00      
                    STA $0E      ;#/2
                    LDA $02      
                    STA $0D      ;#^e/2
                    LDA SPRITE_X_POS,x    
                    SEC          
                    SBC $00      
                    STA $04      ;#XvCg̍Low
                    LDA SPRITE_X_POS_HI,x  
                    SBC #$00     
                    STA $0A      ;#XvCg̍Hi
                    LDA $00      
                    ASL A        
                    CLC          
                    ADC #$10     
                    STA $06      ;#XvCg̕{10
                    LDA SPRITE_Y_POS,x    
                    SEC          
                    SBC $02      ;#0
                    STA $05      ;#XvCg̏㑤Low
                    LDA SPRITE_Y_POS_HI,x  
                    SBC #$00     
                    STA $0B      ;#XvCg̏㑤Hi
                    LDA $02      
                    ASL A        
                    CLC          
                    ADC #$10     
                    STA $07      ;#XvCg̍+10
                    JSL $03B664  
                    JSL $03B72B  
                    RTS 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAPW			dcb $C0,$C2,$C4,$E0,$E2,$E4
					dcb $C0,$C2,$C4,$E6,$C6,$E4
HORZW				dcb $F8,$08,$18,$F8,$08,$18
VERTW				dcb $F0,$F0,$F0,$00,$00,$00

SUB_GFXW            JSR GET_DRAW_INFO
					STZ $02
					LDA $14
					LSR A
					AND #$01
					BEQ SUB_GFX_WS
					LDA #$06
					STA $02
SUB_GFX_WS			PHX
					LDX #$05
LOOPW				PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA TILEMAPW,x
					STA $0302,y
					PLX
					LDA $00
					CLC
					ADC HORZW,x
                    STA $0300,y
					LDA $01
					CLC
					ADC VERTW,x
					STA $0301,y
					
					LDA #$05
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					INY
					INY
					INY
					INY
					DEX
					BPL LOOPW
					PLX
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$05
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS



TILEMAP				dcb $80,$80,$A0,$A0
					dcb $84,$86,$A4,$A6
					dcb $88,$8A,$88,$8A
					dcb $A4,$A6,$84,$86
					dcb $A0,$A0,$80,$80
					dcb $A6,$A4,$86,$84
					dcb $8A,$88,$8A,$88
					dcb $86,$84,$A6,$A4
					dcb $82,$82,$A0,$A0
HORZ				dcb $F8,$08,$F8,$08
VERT				dcb $F8,$F8,$08,$08
PROP				dcb $07,$47,$07,$47
					dcb $07,$07,$07,$07
					dcb $07,$07,$87,$87
					dcb $87,$87,$87,$87
					dcb $87,$C7,$87,$C7
					dcb $C7,$C7,$C7,$C7
					dcb $47,$47,$C7,$C7
					dcb $47,$47,$47,$47
					dcb $07,$47,$07,$47

SUB_GFX             JSR GET_DRAW_INFO
					LDA $1602,x
					BNE SUB_GFX_2
					STZ $02
					LDA $1570,x
					BEQ SUB_GFX_1
					LDA #$20
					STA $02
SUB_GFX_1			BRA SUB_GFX_S
SUB_GFX_2			LDA $157C,x
					LSR A
					LSR A
					AND #$07
					ASL A
					ASL A
					STA $02
SUB_GFX_S			PHX
					LDX #$03
LOOP				LDA $00
					CLC
					ADC HORZ,x
                    STA $0300,y
					LDA $01
					CLC
					ADC VERT,x
					STA $0301,y
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA TILEMAP,x
					STA $0302,y
					LDA PROP,x
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					PLX
					INY
					INY
					INY
					INY
					DEX
					BPL LOOP
					PLX
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03
                    JSL $01B7B3             ; / don't draw if offscreen

					STZ $01       
					LDA #$05
                    STA $02       
                    STZ $03       
					LDA #$06
					STA $00
                    RTS
					
TILE_WATER			dcb $A4,$E6,$E6,$A4
HORZ_WATER			dcb $E8,$F8,$08,$18
PROP_WATER			dcb $4D,$4D,$0D,$0D
SUB_GFX_WATER		JSR GET_DRAW_INFO
					PHX
					LDX #$03
LOOP_WATER			LDA $00
					CLC
					ADC HORZ_WATER,x
					STA $0300,y
					LDA $01
					DEC A
					STA $0301,y
					LDA TILE_WATER,x
					STA $0302,y
					LDA PROP_WATER,x
					ORA $64
					STA $0303,y
					INY
					INY
					INY
					INY
					DEX
					BPL LOOP_WATER
					PLX
					LDY #$02
                    LDA #$03
                    JSL $01B7B3
					STZ $01       
					STZ $02       
                    STZ $03       
					LDA #$0A
					STA $00
                    RTS
					
TILE_BOMB			dcb $82,$82,$A0,$A0,$C4
					dcb $80,$80,$A0,$A0,$C4
					dcb $80,$80,$A0,$A0,$A4
					dcb $80,$80,$A0,$A0,$84
					dcb $80,$80,$A0,$A0,$A2
HORZ_BOMB			dcb $F8,$07,$F8,$07,$FF
VERT_BOMB			dcb $F6,$F6,$06,$06,$00
PROP_BOMB			dcb $07,$47,$07,$47,$07
SUB_GFX_BOMB		JSR GET_DRAW_INFO
					LDA $1602,x
					ASL A
					ASL A
					CLC
					ADC $1602,x
					STA $02
					PHX
					LDX #$04
LOOP_BOMB			LDA $00
					CLC
					ADC HORZ_BOMB,x
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_BOMB,x
					STA $0301,y
					LDA PROP_BOMB,x
					ORA $64
					STA $0303,y
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA TILE_BOMB,x
					STA $0302,y
					PLX
					INY
					INY
					INY
					INY
					DEX
					BPL LOOP_BOMB
					PLX
					LDY #$02
                    LDA #$04
                    JSL $01B7B3
					STZ $01       
					LDA #$08
                    STA $02       
                    STZ $03       
					LDA #$04
					STA $00
                    RTS
					
TILE_BOMB2			dcb $C0,$C2,$C0,$C2,$C4
					dcb $E0,$C2,$E0,$C2,$C4
					dcb $E0,$C2,$E0,$C2,$A4
					dcb $E0,$C2,$E0,$C2,$84
					dcb $E0,$C2,$E0,$C2,$A2
HORZ_BOMB2			dcb $F8,$08,$F8,$08,$04
VERT_BOMB2			dcb $F8,$F8,$07,$07,$FE
PROP_BOMB2			dcb $87,$87,$07,$07,$07
SUB_GFX_BOMB2		JSR GET_DRAW_INFO
					LDA $1602,x
					ASL A
					ASL A
					CLC
					ADC $1602,x
					STA $02
					PHX
					LDX #$04
LOOP_BOMB2			LDA $00
					CLC
					ADC HORZ_BOMB2,x
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_BOMB2,x
					STA $0301,y
					LDA PROP_BOMB2,x
					ORA $64
					STA $0303,y
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA TILE_BOMB2,x
					STA $0302,y
					PLX
					INY
					INY
					INY
					INY
					DEX
					BPL LOOP_BOMB2
					PLX
					LDY #$02
                    LDA #$04
                    JSL $01B7B3
					STZ $01       
					LDA #$08
                    STA $02       
                    STZ $03       
					LDA #$04
					STA $00
                    RTS

TILEMAP_FR			dcb $E8,$EA,$EC,$EE
HORZ_FR				dcb $00,$10
SUB_GFX_FR			JSR GET_DRAW_INFO
					STZ $02
					LDA $14
					AND #$04
					BEQ SUB_GFX_FR2
					LDA #$02
					STA $02
SUB_GFX_FR2			PHX
					LDX #$01
LOOP_FR				LDA $00
					CLC
					ADC HORZ_FR,x
                    STA $0300,y
					LDA $01
					STA $0301,y
					LDA #$05
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA TILEMAP_FR,x
					STA $0302,y
					PLX
					INY
					INY
					INY
					INY
					DEX
					BPL LOOP_FR
					PLX
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$01
                    JSL $01B7B3             ; / don't draw if offscreen
					RTS


TILEMAP_D			dcb $A8,$AA,$C8,$AC,$CE
					dcb $A8,$AA,$C8,$CA,$CC
HORZ_D				dcb $F8,$08,$F8,$08,$18
VERT_D				dcb $F4,$F4,$04,$04,$04

SUB_GFX_DRA			JSR GET_DRAW_INFO
					STZ $02
					LDA $C2,x
					BEQ SUB_GFX_D
					LDA $14
					AND #$02
					BEQ SUB_GFX_D
					LDA #$05
					STA $02
SUB_GFX_D			PHX
					LDX #$04
LOOP_D				LDA $00
					CLC
					ADC HORZ_D,x
                    STA $0300,y
					LDA $01
					CLC
					ADC VERT_D,x
					STA $0301,y
					LDA #$0D
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA TILEMAP_D,x
					STA $0302,y
					PLX
					INY
					INY
					INY
					INY
					DEX
					BPL LOOP_D
					PLX
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$04
                    JSL $01B7B3             ; / don't draw if offscreen

					STZ $01       
                    STZ $02       
                    STZ $03       
					LDA #$08
					STA $00
                    RTS
					
TILEMAP_BU			dcb $AE,$8C,$8E,$8E,$8E
					dcb $8A,$8C,$8E,$8E,$8E
					dcb $24,$8C,$8E,$8E,$8E
HORZ_BU				dcb $00,$F8,$08,$F8,$08
VERT_BU				dcb $00,$F8,$F8,$08,$08
PROP_BU				dcb $0D,$0D,$0D,$CD,$8D
					dcb $0A,$0D,$0D,$CD,$8D
					dcb $08,$0D,$0D,$CD,$8D
SUB_GFX_BU			JSR GET_DRAW_INFO
					LDA $C2,x
					STA $02
					ASL A
					ASL A
					CLC
					ADC $02
					STA $02
					PHX
					LDX #$04
LOOP_BU				LDA $00
					CLC
					ADC HORZ_BU,x
                    STA $0300,y
					LDA $01
					CLC
					ADC VERT_BU,x
					STA $0301,y
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA TILEMAP_BU,x
					STA $0302,y
					LDA PROP_BU,x
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					PLX
					INY
					INY
					INY
					INY
					DEX
					BPL LOOP_BU
					PLX
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$04
                    JSL $01B7B3             ; / don't draw if offscreen
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN67            RTS
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
					LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

					LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN68            RTS
NORMAL_GEN          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots ful
                    BMI RETURN68            ; / after: Y has index of sprite being generated
					
					LDA $7FFD08              ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    
					LDA $7FFD09
                    STA $009E,y
                    
                    LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

                    LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    PLX
                    RTS                          ; return
