;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; X'mas
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;symbolic names for ram addresses
                    MARIO_STATUS    = $19 
                    MARIO_X_SPEED   = $7B
                    MARIO_Y_SPEED   = $7D
                    MARIO_X_POS     = $94
                    MARIO_X_POS_HI  = $95
                    MARIO_Y_POS     = $96 
                    MARIO_Y_POS_HI  = $97
                    SPRITE_Y_SPEED  = $AA
                    SPRITE_X_SPEED  = $B6
                    SPRITE_STATE    = $C2       
                    SPRITE_Y_POS    = $D8
                    SPRITE_X_POS    = $E4
                    SPRITE_Y_POS_HI = $14D4
                    SPRITE_X_POS_HI = $14E0
                    SPR_OBJ_STATUS  = $1588
                    SPRITE_OAM      = $15EA
                    EXTRA_BITS = $7FAB10
					NEW_SPRITE_NUM = $7FAB9E
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA $010B
					CMP #$26
					BNE INIT_R
					JSL $01ACF9
					CLC
					ADC $E4,x
					STA $1602,x
					LDA #$44
					STA $190B,x
					LDA $E4,x
					CMP #$40
					BEQ INIT_2
					CMP #$70
					BEQ INIT_3
					LDA #$02
					STA $C2,x
					TXA
					STA $7FFDD2
INIT_R				RTL
INIT_2				STZ $C2,x
					TXA
					STA $7FFDD0
					RTL
INIT_3				LDA #$01
					STA $C2,x
					TXA
					STA $7FFDD1
					JSR HDMA_COLOR
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                    
START_HB_CODE       LDA $1504,x
					BNE NOT_SANTA
					LDA EXTRA_BITS,x
					AND #$04
					BNE LBL202
					LDA $010B
					CMP #$26
					BEQ SLOT_MAIN
LBL202				JSR SANTA_MAIN
					RTS
NOT_SANTA			CMP #$01
					BNE NOT_LIFT
					JSR LIFT
RETURN2				RTS
NOT_LIFT			CMP #$02
					BNE NOT_TONAKAI
					JSR TONAKAI
					RTS
NOT_TONAKAI			CMP #$03
					BNE NOT_PRESENT
					JSR PRESENT
					RTS
NOT_PRESENT			CMP #$04
					BNE NOT_BOMB
					JSR BOMB
					RTS
NOT_BOMB			JSR KEY
					RTS
SLOT_MAIN			JSR SLOT
					RTS

LIFT				JSR SUB_GFX
					LDA $9D
					BNE LIFT_R
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSR SUB_B852
					LDA $1570,x
					CMP #$10
					BCC LIFT_2
					JSL $01801A
					LDA $AA,x
					CMP #$20
					BCS LIFT_R
					INC $AA,x
LIFT_R				RTS
LIFT_2				INC $1570,x
					RTS
					
SANTA_MAIN			JSR SUB_GFX_S
					LDA $9D
					BNE SANTA_R
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA #$D8
					STA $B6,x
					JSL $018022
					JSR STAR_DUST
					LDA $010B
					CMP #$26
					BEQ SANTA_3
					LDA $1540,x
					CMP #$E0
					BEQ SANTA_G
					CMP #$B0
					BEQ SANTA_G
SANTA_R				RTS
SANTA_G				LDA #$2B
					STA $1DFC
					JSR SPRITE_GEN
					LDA #$03
					STA $1504,y
					LDA #$29
					STA $1686,y
					LDA #$20
					STA $167A,y
					RTS
SANTA_3				LDA $1540,x
					CMP #$8A
					BEQ SANTA_G
					RTS
					
TONAKAI				JSR SUB_GFX_T
					LDA $9D
					BNE TONAKAI_R
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA #$D8
					STA $B6,x
					JSL $018022
TONAKAI_R			RTS

PRESENT				JSR SUB_GFX_P
					LDA $9D
					BNE PRESENT_R
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					STZ $B6,x
					JSL $01802A
					LDA $1588,x
					AND #$04
					BEQ PRESENT_R
					LDA $010B
					CMP #$26
					BEQ PRESENT_2
					LDA #$40
					STA $1540,x
					LDA #$09
					STA $1DFC
					LDA #$04
					STA $1504,x
PRESENT_R			RTS
PRESENT_2			JSR SUB_SMOKE
					LDA $7FFDD9
					CMP #$2C
					BEQ PRESENT_3
					LDA $7FFDD8
					TAY
					LDA #$00
					STA $14C8,y
PRESENT_3			LDA $7FFDD0
					TAY
					LDA $1602,y
					LSR A
					LSR A
					LSR A
					AND #$07
					TAY
					LDA $7FFDDD
					BNE PRESENT_4
					LDA SPRITE_TABLE,y
					STA $7FFDDF
					BRA PRESENT_5
PRESENT_4			LDA SPRITE_TABLE2,y
					STA $7FFDDF
PRESENT_5			CMP #$0D
					BNE PRESENT_6
					JSR SPRITE_GEN
					LDA #$05
					STA $1504,y
					LDA #$FF
					STA $1540,y
					BRA PRESENT_7
PRESENT_6			
					JSR GEN_NORMAL
 PRESENT_7			TYA
					STA $7FFDD8
					LDA $009E,y
					STA $7FFDD9
					STZ $14C8,x
					LDA $7FFDD0
					TAY
					LDA #$00
					STA $1528,y
					LDA $7FFDD1
					TAY
					LDA #$00
					STA $1528,y
					LDA $7FFDD2
					TAY
					LDA #$00
					STA $1528,y
					STA $7FFDD3
					RTS
SPRITE_TABLE		dcb $78,$4A,$77,$2C,$78,$4A,$77,$0D
SPRITE_TABLE2		dcb $78,$4A,$77,$2C,$78,$4A,$77,$2C

STAR_DUST			LDA $14
					AND #$03
					BNE STARDUST_R
					JSL $01ACF9
					AND #$0F
					CLC
					LDY #$00
					ADC #$FC
					BPL STARDUST_2
					DEY
STARDUST_2			CLC
					ADC $E4,x
					STA $02
					TYA
					ADC $14E0,x
					PHA
					LDA $02
					CMP $1A
					PLA
					SBC $1B
					BNE STARDUST_R
					LDA $148E
					AND #$0F
					CLC
					ADC #$FE
					ADC $D8,x
					STA $00
					LDA $14D4,x
					ADC #$00
					STA $01
					JSL $0285BA
STARDUST_R			RTS

BOMB				LDA $1540,x
					CMP #$01
					BEQ DELETE
					PHB 
					LDA #$02
					PHA
					PLB
					JSL $028086
					PLB
BOMB_R				RTS
DELETE				STZ $14C8,x
					RTS
					
SLOT				JSR SUB_GFX_SL
					LDA $9D
					BNE SLOT_R
					JSR SUB_B852
					LDA $1528,x
					BNE SLOT_2
					INC $1602,x
SLOT_R				RTS
SLOT_2				LDA $C2,x
					BNE SLOT_R
					JSR SLOT_CHECK
					RTS
					
SUB_SMOKE           LDY #$03                ; \ find a free slot to display effect
FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
                    RTS                     ; / return if no slots open
FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    LDA $D8,x
                    STA $17C4,y             ; /
                    LDA #$1B                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $E4,x
                    STA $17C8,y             ; /
                    RTS 
					
KEY					JSR SUB_GFX_K
					LDA $9D
					BNE KEY_R
					LDA #$00
					STA $00212C
					LDA #$1F
					STA $00212D
					LDA $1540,x
					BEQ KEY_DEL
					CMP #$61
					BCC KEY_3
					CMP #$62
					BEQ KEY_1
					AND #$1F
					BEQ KEY_2
					RTS
KEY_DEL				STZ $14C8,x
					RTS
KEY_1				LDA #$17
					STA $1DFC
					RTS
KEY_2				LDA #$23
					STA $1DFC
					RTS
KEY_3				CMP #$40
					BCC KEY_4
					REP #$30
					LDA $7FE301
					CMP.W #$7FFF
					BEQ KEY_5
					CLC
					ADC.W #$0421
					STA $7FE301
KEY_5				SEP #$30
					RTS
KEY_4				CMP #$22
					BCC KEY_6
					CMP #$30
					BNE KEY_R2
					JSR TILE_CHANGE
					JSR GEN_KEY
KEY_R2				RTS
KEY_6				REP #$30
					LDA $7FE301
					BEQ KEY_R
					SEC
					SBC.W #$0421
					STA $7FE301
KEY_R				SEP #$30
					RTS
					
TILE_CHANGE			LDA #$50
					STA $9A
					LDA #$00
					STA $9B
					LDA #$60
					STA $98
					LDA #$01
					STA $99
                    REP #$30
                    LDA.W #$0BBE
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					SEP #$30
					
					LDA #$70
					STA $98
					REP #$30
                    LDA.W #$0BCE
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					SEP #$30
					
					LDA #$80
					STA $98
					REP #$30
                    LDA.W #$0A72
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					SEP #$30
					
					LDA #$60
					STA $9A
					REP #$30
                    LDA.W #$0BDF
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					SEP #$30
					
					LDA #$70
					STA $9A
					REP #$30
                    LDA.W #$0BEF
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					SEP #$30
					
					LDA #$80
					STA $9A
					REP #$30
                    LDA.W #$0BDF
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					SEP #$30
					
					LDA #$90
					STA $9A
					REP #$30
                    LDA.W #$0BEF
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					SEP #$30
					
					LDA #$A0
					STA $9A
					REP #$30
                    LDA.W #$0A71
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					SEP #$30
					
					LDA #$70
					STA $98
					REP #$30
                    LDA.W #$0BFF
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					SEP #$30
					
					LDA #$60
					STA $98
					REP #$30
                    LDA.W #$0BBF
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					SEP #$30
					
					LDA #$60
					STA $9A
					LDA #$60
					STA $98
					REP #$30
                    LDA.W #$0025
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					SEP #$30
					
					LDA #$70
					STA $9A
					REP #$30
                    LDA.W #$0025
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					SEP #$30
					
					LDA #$80
					STA $9A
					REP #$30
                    LDA.W #$0025
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					SEP #$30
					
					LDA #$90
					STA $9A
					REP #$30
                    LDA.W #$0025
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					SEP #$30
					
					LDA #$60
					STA $9A
					LDA #$70
					STA $98
					REP #$30
                    LDA.W #$0025
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					SEP #$30
					
					LDA #$70
					STA $9A
					REP #$30
                    LDA.W #$0025
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					SEP #$30
					
					LDA #$80
					STA $9A
					REP #$30
                    LDA.W #$0025
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					SEP #$30
					
					LDA #$90
					STA $9A
					REP #$30
                    LDA.W #$0025
                    STA.W $03                 ;  |
                    JSL $2E8DF0
					SEP #$30
					
					RTS
					
GEN_KEY				LDA $7FFDE0
					BNE GEN_KEY_R
					LDA #$80
					STA $7FFDDF
					JSR GEN_NORMAL
					LDA #$09
					STA $14C8,y
					LDA #$70
					STA $00E4,y
					LDA #$00
					STA $14E0,y
					LDA #$70
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					LDA #$0E
					STA $7FFDDF
					JSR GEN_NORMAL
					LDA #$90
					STA $00E4,y
					LDA #$00
					STA $14E0,y
					LDA #$70
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					LDA #$01
					STA $7FFDE0
GEN_KEY_R			RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; platform code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					
SUB_B852            JSR SUB_B8FF
                    BCC RETURN05      
                    LDA $15C4,x
					ORA $154C,x
                    BNE RETURN05
					
                    LDA SPRITE_Y_POS,x    
                    SEC          
                    SBC $1C      
                    STA $02      
                    SEC          
                    SBC $0D      
                    STA $09      
                    LDA $80      
                    CLC          
                    ADC #$18     
                    CMP $09      
                    BCS LBL06      
                    LDA MARIO_Y_SPEED    
                    BMI RETURN05     
                    STZ MARIO_Y_SPEED  ;#ɏĂ
                    LDA #$01     
                    STA $1471       
					LDA $AA,x
					STA $7D
                    LDA $0D      
                    CLC          
                    ADC #$1F     ;#1F?
                    LDY $187A
                    BEQ NO_YOSHI      
                    CLC
                    ADC #$10
NO_YOSHI
                    STA $00

                    LDA SPRITE_Y_POS,x    
                    SEC          
                    SBC $00      
                    STA MARIO_Y_POS      
                    LDA SPRITE_Y_POS_HI,x  
                    SBC #$00     
                    STA MARIO_Y_POS_HI      
                    LDY #$00     
RETURN05            RTS           

LBL06               LDA $02       
                    CLC           
                    ADC $0D       ;#^e/2
                    STA $02       
                    LDA #$FF      
                    LDY $73       
                    BNE LBL07      
                    LDY MARIO_STATUS       
                    BNE SMALL_MARIO
LBL07
                    LDA #$08   
SMALL_MARIO
                    CLC                     
                    ADC $80      
                    CMP $02      
                    BCC LBL10      
					LDA $010B
					CMP #$26
					BNE LBL09
                    LDA MARIO_Y_SPEED       ;#ɂԂĂ
					BPL LBL09
					LDA #$10                
                    STA MARIO_Y_SPEED    
					LDA $1528,x
					BNE LBL09
					LDA #$3F
					STA $1DFC
					LDA #$01
					STA $1528,x
					JSR REACH
LBL09				RTS       
LBL10
                    LDA $0E       ;#/2
                    CLC           
                    ADC #$10      
                    STA $00       
                    LDY #$00      
                    LDA SPRITE_X_POS,x     
                    SEC           
                    SBC $1A       
                    CMP $7E       
                    BCC LBL11     
                    LDA $00       
                    EOR #$FF      
                    INC A         
                    STA $00       
                    DEY     
LBL11				LDA $010B
					CMP #$26
					BNE LBL12
                    LDA SPRITE_X_POS,x     ;#ɐGĂ
                    CLC           
                    ADC $00       
                    STA MARIO_X_POS       
                    TYA           
                    ADC SPRITE_X_POS_HI,x   
                    STA MARIO_X_POS_HI       
                    STZ MARIO_X_SPEED       
LBL12               RTS                    

REACH				LDA $C2,x
					BNE REACH_1
					LDA $7FFDD1
					TAY
					LDA $1528,y
					BEQ REACH_R
					LDA $151C,y
					STA $0F
					LDA $7FFDD2
					TAY
					LDA $1528,y
					BEQ REACH_R
					LDA $151C,y
					CMP $0F
					BNE REACH_R
					LDA $1602,y
					STA $1602,x
					LDA $151C,y
					STA $151C,x
REACH_R				RTS
REACH_1				CMP #$02
					BEQ REACH_2
					LDA $7FFDD0
					TAY
					LDA $1528,y
					BEQ REACH_R
					LDA $151C,y
					STA $0F
					LDA $7FFDD2
					TAY
					LDA $1528,y
					BEQ REACH_R
					LDA $151C,y
					CMP $0F
					BNE REACH_R
					LDA $1602,y
					STA $1602,x
					LDA $151C,y
					STA $151C,x
					RTS
REACH_2				LDA $7FFDD0
					TAY
					LDA $1528,y
					BEQ REACH_R
					LDA $151C,y
					STA $0F
					LDA $7FFDD1
					TAY
					LDA $1528,y
					BEQ REACH_R
					LDA $151C,y
					CMP $0F
					BNE REACH_R
					LDA $1602,y
					STA $1602,x
					LDA $151C,y
					STA $151C,x
					RTS
					
SLOT_CHECK			LDA $7FFDD3
					BNE SLOT_CHECK_R
					LDA $1540,x
					BEQ SLOT_CHECK_1
					LDA $7FFDD1
					TAY
					LDA $1528,y
					BEQ SLOT_CHECK_1
					LDA $7FFDD2
					TAY
					LDA $1528,y
					BEQ SLOT_CHECK_1
					LDA $1540,x
					CMP #$01
					BEQ SLOT_CHECK_2
					RTS
SLOT_CHECK_1		LDA #$20
					STA $1540,x
					RTS
SLOT_CHECK_2		LDA $151C,x
					STA $0F
					LDA $7FFDD1
					TAY
					LDA $151C,y
					CMP $0F
					BNE HAZURE
					LDA $7FFDD2
					TAY
					LDA $151C,y
					CMP $0F
					BNE HAZURE
					LDA #$29
					STA $1DFC
					LDA #$01
					STA $7FFDD3
					LDA #$00
					STA $7FFDD4
					JSR SANTA_GEN
					LDA #$02
					STA $1504,y
					LDA #$20
					STA $7FFDD4
					JSR SANTA_GEN
SLOT_CHECK_R		RTS
HAZURE				LDA #$2A
					STA $1DFC
					STZ $1528,x
					LDA $7FFDD1
					TAY
					LDA #$00
					STA $1528,y
					LDA $7FFDD2
					TAY
					LDA #$00
					STA $1528,y
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; make standable
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_B8FF			;#$00XvCg̉ $01 0 $02 0
                    LDA $00      
                    STA $0E      ;#/2
                    LDA $02      
                    STA $0D      ;#^e/2
                    LDA SPRITE_X_POS,x    
                    SEC          
                    SBC $00      
                    STA $04      ;#XvCg̍Low
                    LDA SPRITE_X_POS_HI,x  
                    SBC #$00     
                    STA $0A      ;#XvCg̍Hi
                    LDA $00      
                    ASL A        
                    CLC          
                    ADC #$10     
                    STA $06      ;#XvCg̕{10
                    LDA SPRITE_Y_POS,x    
                    SEC          
                    SBC $02      ;#0
                    STA $05      ;#XvCg̏㑤Low
                    LDA SPRITE_Y_POS_HI,x  
                    SBC #$00     
                    STA $0B      ;#XvCg̏㑤Hi
                    LDA $02      
                    ASL A        
                    CLC          
                    ADC #$10     
                    STA $07      ;#XvCg̍+10
                    JSL $03B664  
                    JSL $03B72B  
                    RTS 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP_K           dcb $2D,$2D,$4D,$4D
HORZ_DISP_K			dcb $F8,$08,$F8,$08
VERT_DISP_K			dcb $F0,$F0,$00,$00
PROPETIES_K			dcb $0B,$4B,$0B,$4B

SUB_GFX_R			RTS
SUB_GFX_K           LDA $1540,x
					CMP #$24
					BCC SUB_GFX_R
					JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                    PHX                     ; push sprite index
					LDX #$03
LOOP_START_K          
					LDA $01
					CLC
					ADC VERT_DISP_K,x
					STA $0301,y
					LDA $00
					CLC
					ADC HORZ_DISP_K,x
                    STA $0300,y             ; /
					
					LDA TILEMAP_K,x           ; \ store tile
                    STA $0302,y
					LDA PROPETIES_K,x
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START_K          ; / 

      
					
                    PLX                     ; pull, X = sprite index
					
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen

                    RTS   
					
					
TILEMAP             dcb $64,$68,$6A,$6C
HORZ_DISP			dcb $E8,$F8,$08,$18

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                    PHX                     ; push sprite index
					LDX #$03
LOOP_START          
					LDA $01
					STA $0301,y
					LDA $00
					CLC
					ADC HORZ_DISP,x
                    STA $0300,y             ; /
					
					LDA TILEMAP,x           ; \ store tile
                    STA $0302,y
					LDA #$03
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

      
					
                    PLX                     ; pull, X = sprite index
					
					STZ $00       
                    STZ $01       
                    STZ $02       
                    STZ $03       
                    LDY #$00                 
                    LDA #$18  
                    STA $0000,y   ;#???
                    LSR A         
                    STA $0001,y   ;#????
                                        
                    LDA $00       
                    PHA           
                    LDA $02       
                    PHA       
					
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen

					PLA           
                    STA $02       
                    PLA                    
                    STA $00
					
                    RTS                     
					
					
TILEMAP0            dcb $27,$29,$47,$49
HORZ_DISP0			dcb $F8,$08,$F8,$08
					dcb $08,$F8,$08,$F8
VERT_DISP0			dcb $F0,$F0,$00,$00

SUB_GFX_S           STZ $02
					LDA #$0D
					STA $03
					LDA $157C,x
					BNE SUB_GFX_S2
					LDA #$04
					STA $02
					LDA #$4D
					STA $03
SUB_GFX_S2
					JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                    PHX                     ; push sprite index
					LDX #$03
LOOP_START0          
					LDA $01
					CLC
					ADC VERT_DISP0,x
					STA $0301,y
										
					LDA TILEMAP0,x           ; \ store tile
                    STA $0302,y
					LDA $03
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $00
					CLC
					ADC HORZ_DISP0,x
                    STA $0300,y             ; /
					PLX

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START0          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					


TILEMAP1            dcb $23,$25,$43,$45
HORZ_DISP1			dcb $F8,$08,$F8,$08
					dcb $08,$F8,$08,$F8
VERT_DISP1			dcb $F0,$F0,$00,$00

SUB_GFX_T           STZ $02
					LDA #$0F
					STA $03
					LDA $157C,x
					BNE SUB_GFX_T2
					LDA #$04
					STA $02
					LDA #$4F
					STA $03
SUB_GFX_T2
					JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                    PHX                     ; push sprite index
					LDX #$03
LOOP_START1          
					LDA $01
					CLC
					ADC VERT_DISP1,x
					STA $0301,y
										
					LDA TILEMAP1,x           ; \ store tile
                    STA $0302,y
					LDA $03
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $00
					CLC
					ADC HORZ_DISP1,x
                    STA $0300,y             ; /
					PLX

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START1          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS             

SUB_GFX_P			JSR GET_DRAW_INFO
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
										
					LDA #$08
                    STA $0302,y
					LDA #$0B
                    ORA $64                 ;  | put in level properties
                    STA $0303,y  
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3 
					RTS
					
SLOT_TILE			dcb $24,$8C,$0E,$00,$24,$8C,$0E,$06
SLOT_TILE2			dcb $24,$8C,$0E,$8C,$24,$8C,$0E,$06
SLOT_PRO			dcb $0A,$4B,$04,$07,$0A,$4B,$04,$0B
SLOT_PRO2			dcb $0A,$4B,$04,$4B,$0A,$4B,$04,$0B
SUB_GFX_SL			JSR GET_DRAW_INFO
					LDA $00
					STA $0300,y
					LDA $01
					CLC
					ADC #$FF
					STA $0301,y
										
					LDA $1602,x
					PHX
					LSR A
					LSR A
					LSR A
					;CLC
					;ADC $15E9
					AND #$07
					TAX
					LDA $7FFDDD
					BNE SUB_GFX_SL_2
					LDA SLOT_TILE,x
                    STA $0302,y
					LDA SLOT_PRO,x
                    STA $0303,y
					BRA SUB_GFX_SL_3
SUB_GFX_SL_2		LDA SLOT_TILE2,x
                    STA $0302,y
					LDA SLOT_PRO2,x
                    STA $0303,y  
SUB_GFX_SL_3		PLX
					LDA $0302,y
					STA $151C,x
					STZ $00       
                    STZ $01       
                    STZ $02       
                    STZ $03       
                    LDY #$00                 
                    LDA #$00  
                    STA $0000,y   ;#???
                    LSR A         
                    STA $0001,y   ;#????
                                        
                    LDA $00       
                    PHA           
                    LDA $02       
                    PHA       
					
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3 
					
					PLA           
                    STA $02       
                    PLA                    
                    STA $00
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite erator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN67            RTS
SPRITE_GEN          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    LDA NEW_SPRITE_NUM,x
					TYX
                    STA NEW_SPRITE_NUM,x
					PLX
					
					LDA $E4,x
					STA $00E4,y
					LDA $14E0,x
					STA $14E0,y
					LDA $D8,x
					STA $00D8,y
					LDA $14D4,x
					STA $14D4,y
                    
                    PHX
					TYX
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return
					
RETURN68            RTS
SANTA_GEN           JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    LDA NEW_SPRITE_NUM,x
					TYX
                    STA NEW_SPRITE_NUM,x
                    
                    LDA #$E0
					STA $D8,x
					STZ $14D4,x
					LDA $7FFDD4
					STA $E4,x
					LDA #$01
					STA $14E0,x
									
                                         ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$8C
                    STA EXTRA_BITS,x
					LDA #$01
					STA $157C,x
					LDA #$D0
					STA $1540,x
                    PLX
                    RTS 
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; generate sprite
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RETURNK66           RTS     
GEN_NORMAL          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURNK66            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    LDA $7FFDDF
                    STA $009E,y
                    
                    LDA $E4,x               ;\ set x position for new sprite
                    STA $00E4,y

                    LDA $14E0,x             ;  |
                    STA $14E0,y             ; /

                    LDA $D8,x
					;CLC
					;ADC #$10
					AND #$F0
					STA $00D8,y             ;  |
                    LDA $14D4,x
					STA $14D4,y             ; /

                    PHX
                    TYX
                    JSL $07F7D2             ;  
                    PLX
					LDA $009E,y
					CMP #$77
					BEQ GEN_NORMAL_2
					CMP #$78
					BEQ GEN_NORMAL_2
					CMP #$2C
					BEQ GEN_NORMAL_3
                    RTS                     ; return
GEN_NORMAL_2		LDA #$01
					STA $00C2,y
					RTS
GEN_NORMAL_3		LDA #$07
					STA $15F6,y
					LDA #$01
					STA $187B,y
					LDA #$01
					STA $7FFDDD
					RTS
					
HDMA_COLOR			LDA #$08
					STA $7FFB18
					LDA #$10
					STA $7FFB20
					LDA #$00
					STA $7FFB19
					LDA #$02
					STA $7FFB21
					LDA #$21
					STA $7FFB1A
					LDA #$22
					STA $7FFB22
					LDA #$00
					STA $7FFB1B
					STA $7FFB23
					LDA #$E2
					STA $7FFB1C
					LDA #$E3
					STA $7FFB24
					LDA #$7F
					STA $7FFB1D
					STA $7FFB25
					
					LDA #$01
					STA $7FE200
					STA $7FE300
					LDA #$00
					STA $7FE201
					STA $7FE301
					STA $7FE302
					STA $7FE202
					STA $7FE303
					RTS
