;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ZanBie
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					EXTRA_BITS = $7FAB10
					NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite initialization JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA #$FF
					STA $15AC,x
					STZ $1528,x
					STZ $1570,x
					STZ $151C,x
					LDA #$00
					STA $7FFEE1
					LDA #$0D
					STA $C2,x
					LDA #$01
					STA $7FFFDF
					LDA #$21
					STA $7FFFE0
					LDA #$0A
					STA $7FFFE1
					LDA #$17
					STA $7FFFE2
					LDA #$FC
					STA $7FFFE3
					LDA #$0B
					STA $7FFFE4
					LDA #$12
					STA $7FFFE5
					LDA #$0E
					STA $7FFFE6
					LDA #$00
					STA $7FFC01
                    RTL
                    
                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
            
                    dcb "MAIN"                        
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_SPRITE_CODE   ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite sprite code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
START_SPRITE_CODE   LDA $1602,x
					BNE SUB_MAIN
					JSR SUB_GFX             ; draw sprite gfx
                    LDA $14C8,x             ; \ if sprite status != 8...
                    CMP #$08                ;  }   ... not (killed with spin jump [4] or star[2])
                    BNE RETURN              ; /    ... return
                    JSR SAVE_POS
					LDA $9D                 ; \ if sprites locked...
                    BEQ ALIVE               ; /    ... return
RETURN              RTS                     ; return

ALIVE               LDA $7FFDDD
					INC A
					STA $7FFDDD
					JSL $01802A
					JSR LIFE_GAGE
					STZ $AA,x
					STZ $B6,x
					LDA $1528,x
					BNE NOT_MODE0
					JSR MODE0
					RTS
NOT_MODE0			CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$02
					BNE NOT_MODE2
					JSR MODE2
					RTS
NOT_MODE2			CMP #$03
					BNE NOT_MODE3
					JSR MODE3
					RTS
NOT_MODE3			CMP #$04
					BNE NOT_MODE4
					JSR MODE4
					RTS
NOT_MODE4			CMP #$05
					BNE NOT_MODE5
					JSR MODE5
					RTS
NOT_MODE5			JSR MODE6
					RTS

RETURN2 			RTS
SUB_MAIN			JSR SUB_GFX2
					LDA $14C8,x             ; \ if sprite status != 8...
                    CMP #$08                ;  }   ... not (killed with spin jump [4] or star[2])
                    BNE RETURN2              ; /    ... return
                    LDA $9D                 ; \ if sprites locked...
                    BNE RETURN2              ; /    ... return
					JSL $01802A
					JSR CHECK_DAMAGE
					INC $1570,x
					STZ $AA,x
					STZ $B6,x
					LDA $1528,x
					BNE NOT_SMODE0
					JSR SMODE0
					RTS
NOT_SMODE0			CMP #$01
					BNE NOT_SMODE1
					JSR SMODE1
					RTS
NOT_SMODE1			JSR SMODE2
					RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Y_MAGIC             dcb $18,$18,$0C,$0C,$E8,$E8,$F4,$F4
X_MAGIC             dcb $18,$E8,$20,$E0

MODE0				JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
					JSR CHECK_DAMAGE
					LDA $15AC,x
					CMP #$D1
					BCS MODE_UP
					CMP #$D0
					BEQ MODE0_G
					CMP #$A8
					BEQ MODE0_G
					CMP #$80
					BEQ MODE0_G
					CMP #$58
					BEQ MODE0_G
					CMP #$00
					BNE MODE0_E
					LDA #$01
					STA $1528,x
					STZ $151C,x
					LDA #$48
					STA $15AC,x
MODE0_E				RTS
MODE0_G				JSR FIRE_GEN
					LDA #$89
					STA $1686,y
					LDA #$28
					STA $1504,y
					LDA #$17
					STA $1DFC
					LDA #$00
					STA $151C,y
					LDA #$01
					STA $1602,y
					LDA #$00
					STA $1528,y
					PHX
					LDA $151C,x
					TAX
					TYA
					STA $7FFC02,x
					PLX
					INC $151C,x
					RTS
MODE_UP				LDA #$28
					STA $AA,x
					RTS
					
MODE1				JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
					JSR CHECK_DAMAGE
					LDA $15AC,x
					BEQ MODE1_2
					LDA #$02
					STA $7FFC01
					LDA #$E0
					STA $B6,x
					RTS
MODE1_2				LDA #$00
					STA $7FFC01
					STZ $B6,x
					LDA #$02
					STA $1528,x
					LDA #$FF
					STA $15AC,x
					RTS
					
MODE2				JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
					JSR CHECK_DAMAGE
					LDA #$01
					STA $1570,x
					LDA $15AC,x
					CMP #$E8
					BEQ MODE2_G
					CMP #$A8
					BEQ MODE2_G
					CMP #$68
					BEQ MODE2_G
					CMP #$28
					BEQ MODE2_G
					CMP #$00
					BEQ MODE2_E
					RTS
MODE2_E				STZ $151C,x
					LDA #$03
					STA $1528,x
					STZ $15AC,x
					STZ $1570,x
					RTS
MODE2_G				PHX
					LDA $151C,x
					TAX
					LDA $7FFC02,x
					TAY
					PLX
					LDA #$17
					STA $1DFC
					LDA #$FF
					STA $15AC,y
					LDA #$01
					STA $1528,y
					INC $151C,x
					RTS
					
MODE3				JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
					LDA #$07
					STA $C2,x
					JSR CHECK_MARIO
					LDA #$20
					STA $1570,x
					LDA #$10
					STA $151C,x
					LDA $94
					STA $7FFA00
					LDA $95
					STA $7FFA01
					LDA $96
					STA $7FFA02
					LDA $97
					STA $7FFA03
					JSR SPEED_DEC
					LDA $13
					LSR A
					LSR A
					LSR A
					AND #$01
					STA $1570,x
					LDA $1594,x
                    STA $AA,x
                    LDA $1504,x
                    STA $B6,x
MODE3_0				LDA $1594,x
					CMP #$80
					BCS MODE3_4
					CMP #$18
					BCC MODE3_E
					LSR A
					STA $AA,x
MODE3_3_1			LDA $B6,x
					CMP #$80
					BCS MODE3_3_2
					LSR A
					STA $B6,x
					RTS
MODE3_3_2			LDA #$00
					SEC
					SBC $B6,x
					LSR A
					STA $B6,x
					LDA #$00
					SEC
					SBC $B6,x
					STA $B6,x
MODE3_E				RTS
MODE3_4				CMP #$F8
					BCS MODE3_E
					LDA #$F8
					STA $AA,x
					BRA MODE3_3_1
					RTS
					
MODE4				JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
					LDA $15AC,x
					BNE MODE4_2
					LDA $1588,x
					AND #$04
					BNE MODE4_G
					STZ $B6,x
					LDA #$20
					STA $AA,x
					RTS
MODE4_G				LDA $D8,x
					CMP #$60
					BCC NO_DAMAGE
					LDA $7FFEE1
					INC A
					INC A
					STA $7FFEE1
					LDA #$28
					STA $1DFC
					LDA $7FFEE1
					CMP #$06
					BNE NO_DAMAGE
					LDA #$06
					STA $1528,x
					LDA #$FF
					STA $15AC,x
					RTS
NO_DAMAGE			LDA #$0D
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					STZ $151C,x
					LDA #$10
					STA $1504,x
MODE4_E				RTS
MODE4_2				LDA $15AC,x
					CMP #$D0
					BCS MODE4_E
					LDA #$E0
					STA $AA,x
					LDA #$0D
					STA $C2,x
					LDA $15AC,x
					CMP #$C0
					BEQ MODE4_3
					CMP #$B0
					BEQ MODE4_3
					CMP #$A0
					BEQ MODE4_3
					CMP #$90
					BEQ MODE4_3
					CMP #$70
					BEQ MODE4_4
					RTS
MODE4_3				JSR FIRE_GEN
					LDA #$89
					STA $1686,y
					LDA #$17
					STA $1DFC
					LDA #$01
					STA $1602,y
					LDA #$02
					STA $1528,y
					PHX
					LDA $151C,x
					TAX
					TYA
					STA $7FFC02,x
					PLX
					INC $151C,x
					LDA $1504,x
					STA $1504,y
					LDA $1504,x
					CLC
					ADC #$10
					STA $1504,x
					RTS
MODE4_4				LDA #$C0
					STA $15AC,x
					STZ $1504,x
					LDA #$03
					STA $151C,x
					LDA #$05
					STA $1528,x
					RTS
					
X5_SPEED			dcb $20,$E0
Y5_SPEED			dcb $10,$F0
MODE5				LDA $13
					LSR A
					LSR A
					LSR A
					AND #$01
					STA $1570,x
					JSR CHECK_DAMAGE
					LDA $151C,x
					CMP #$FF
					BNE MODE5_0
					LDA $15AC,x
					BEQ MODE5_5
MODE5_0				LDA $157C,x
					PHX
					TAX
					LDA X5_SPEED,x
					PLX
					STA $B6,x
					LDA $1504,x
					PHX
					TAX
					LDA Y5_SPEED,x
					PLX
					STA $AA,x
					LDA $E4,x
					CMP #$E8
					BCC MODE5_1
					LDA #$01
					STA $157C,x
					BRA MODE5_2
MODE5_1				CMP #$08
					BCS MODE5_2
					STZ $157C,x
MODE5_2				LDA $14D4,x
					BEQ MODE5_3
					LDA $D8,x
					CMP #$40
					BCC MODE5_E
					LDA #$01
					STA $1504,x
					BRA MODE5_E
MODE5_3				LDA $D8,x
					CMP #$C0
					BCS MODE5_E
					STZ $1504,x
MODE5_E				LDA $15AC,x
					BEQ MODE5_4
					RTS
MODE5_4				PHX
					LDA $151C,x
					TAX
					LDA $7FFC02,x
					TAY
					PLX
					LDA #$17
					STA $1DFC
					LDA #$FF
					STA $15AC,y
					LDA #$01
					STA $1528,y
					DEC $151C,x
					LDA #$C0
					STA $15AC,x
					RTS
MODE5_5				LDA #$40
					STA $1570,x
					LDA #$20
					STA $151C,x
					LDA #$C3
					STA $7FFA00
					LDA #$00
					STA $7FFA01
					LDA #$0D
					STA $7FFA02
					LDA #$01
					STA $7FFA03
					JSR SPEED_DEC
					STZ $1570,x
					LDA #$FF
					STA $151C,x
					LDA $1594,x
                    STA $AA,x
                    LDA $1504,x
                    STA $B6,x
					LDA $14D4,x
					BEQ MODE5_R
					LDA $D8,x
					AND #$F0
					BNE MODE5_R
					LDA $E4,x
					AND #$F0
					CMP #$C0
					BNE MODE5_R
					LDA #$D1
					STA $15AC,x
					STZ $1528,x
					STZ $1570,x
					STZ $1504,x
					STZ $151C,x
MODE5_R				RTS

MODE6				STZ $AA,x
					STZ $B6,x
					LDA $15AC,x
					CMP #$F0
					BNE MODE6_1
					LDA #$1E
					STA $1DFB
MODE6_E				RTS
MODE6_1				CMP #$E0
					BCS MODE6_E
					CMP #$DF
					BNE MODE6_2
					LDA #$22
					STA $1DFC
					RTS
MODE6_2				LDA #$FF
					STA $14AD
					RTS

SMODE0				LDA $13
					AND #$1F
					BNE SMODE0_0
					LDA $D8,x
					CLC
					ADC #$01
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
SMODE0_0			LDA $13
					AND #$1F
					BNE SMODE0_1
					LDA $E4,x
					CLC
					ADC #$01
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
SMODE0_1
					LDA $1504,x
					STA $B6,x
					LDA $151C,x
					STA $AA,x
					LDA $13
					AND #$01
					;BNE SMODE0_E
					LDA $151C,x
					CMP #$80
					BCS SMODE0_2
					DEC $1504,x
					BRA SMODE0_3
SMODE0_2			INC $1504,x
SMODE0_3			LDA $1504,x
					CMP #$80
					BCS SMODE0_4
					INC $151C,x
					BRA SMODE0_E
SMODE0_4			DEC $151C,x
SMODE0_E			LDA $E4,x
					SEC
					SBC $7FFC01
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
					RTS

SMODE1				LDA $14E0,x
					BEQ SMODE1_2
					STZ $14C8,x
					RTS
SMODE1_2			LDA $15AC,x
					BNE SMODE1_3
					LDA $1594,x
                    STA $AA,x
                    LDA $1504,x
                    STA $B6,x
					RTS
SMODE1_3			LDA #$30
					STA $1570,x
					LDA #$20
					STA $151C,x
					LDA $94
					STA $7FFA00
					LDA $95
					STA $7FFA01
					LDA $96
					STA $7FFA02
					LDA $97
					STA $7FFA03
					JSR SPEED_DEC
					STZ $15AC,x
MODE5A_0			LDA $1594,x
					CMP #$80
					BCS MODE5A_4
					CMP #$20
					BCC MODE5A_E
					LSR A
					STA $1594,x
MODE5A_3_1			LDA $1504,x
					CMP #$80
					BCS MODE5A_3_2
					LSR A
					STA $1504,x
					BRA MODE5A_0
MODE5A_3_2			LDA #$00
					SEC
					SBC $1504,x
					LSR A
					STA $1504,x
					LDA #$00
					SEC
					SBC $1504,x
					STA $1504,x
					BRA MODE5A_0
MODE5A_E			RTS
MODE5A_4			CMP #$E0
					BCS MODE5A_E
					LDA #$E0
					STA $1594,x
					BRA MODE5A_3_1

SMODE2				LDA $7FFDDD
					AND #$7F
					SEC
					SBC $1504,x
					AND #$7F
					PHX
					TXY
					TAX
					LDA $7FF100,x
					STA $00E4,y
					LDA $7FF200,x
					STA $14E0,y
					LDA $7FF300,x
					STA $00D8,y
					LDA $7FF400,x
					STA $14D4,y
					PLX
					RTS

GAGE_E				RTS
LIFE_GAGE			LDA #$FD
					STA $7FFFE7
					STA $7FFFE8
					STA $7FFFE9
					STA $7FFFEA
					STA $7FFFEB
					STA $7FFFEC
					LDA #$FC
					STA $7FFFED
					STA $7FFFEE
					STA $7FFFEF
					LDA $7FFEE1
					CMP #$01
					BCS GAGE_2
					RTS
GAGE_2				LDA #$FC
					STA $7FFFE7
					LDA $7FFEE1
					CMP #$02
					BCS GAGE_3
					RTS
GAGE_3				LDA #$FC
					STA $7FFFE8
					LDA $7FFEE1
					CMP #$03
					BCS GAGE_4
					RTS
GAGE_4				LDA #$FC
					STA $7FFFE9
					LDA $7FFEE1
					CMP #$04
					BCS GAGE_5
					RTS
GAGE_5				LDA #$FC
					STA $7FFFEA
					LDA $7FFEE1
					CMP #$05
					BCS GAGE_6
					RTS
GAGE_6				LDA #$FC
					STA $7FFFEB
					LDA $7FFEE1
					CMP #$06
					BCS GAGE_7
					RTS
GAGE_7				LDA #$FC
					STA $7FFFEC
					RTS
					
DAMAGE_E			RTS
CHECK_DAMAGE		JSL $01A7DC
					BCC DAMAGE_E
					LDA $97
					BEQ DAMAGE_E
					LDA $1497               ; \ if mario is invincible...
                    BNE DAMAGE_E
					JSL $00F5B7
					RTS
					
CHECK_MARIO			JSL $01A7DC             ; check for mario/sprite contact
                    BCC RETURN_242           ; (carry set = contact)
                    LDA $7D                 ; \  if mario's y speed < 10 ...
                    CMP #$10                ;  }   ... sprite will hurt mario
                    BMI ENE_WINS2           ; / 
					LDA $D8,x
					SEC
					SBC $96
					STA $0F
					LDA $14D4,x
					SBC $97
					BCC ENE_WINS2
					LDA $0F
					CMP #$08
					BCC ENE_WINS2
MARIO_WINS2         JSL $01AA33             ; set mario speed
					JSL $01AB99             ; display contact graphic
					LDA #$03
                    STA $1DF9
					LDA #$04
					STA $1528,x
					RTS
ENE_WINS2           LDA $1497               ; \ if mario is invincible...
                    BNE RETURN_242             ; /   ... return
                    JSL $00F5B7
RETURN_242			RTS                     ; return

SAVE_POS			PHX
					TXY
					LDA $7FFDDD
					AND #$7F
					TAX
					LDA $00E4,y
					STA $7FF100,x
					LDA $14E0,y
					STA $7FF200,x
					LDA $00D8,y
					STA $7FF300,x
					LDA $14D4,y
					STA $7FF400,x
					PLX
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine - specific to sprite
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP             dcb $84,$86,$A4,$A6,$80,$82,$A0,$A2
HORZ_DISP           dcb $08,$F8,$08,$F8,$F8,$08,$F8,$08
VERT_DISP           dcb $00,$00,$10,$10
PROPERTIES			dcb $40,$40,$40,$40,$00,$00,$00,$00

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
					LDA $1570,x
					ASL A
					ASL A
					STA $03
					LDA $157C,x
					ASL A
					ASL A
					STA $02
					LDA $C2,x
					STA $0F
                    PHX                     ; push sprite index
                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START          
					LDA $01
					CLC
					ADC VERT_DISP,x
					STA $0301,y
					
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA HORZ_DISP,x
					CLC
					ADC $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0300,y             ; /
					PLX
					
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILEMAP,x           ; \ store tile
                    STA $0302,y
					PLX

					PHX
					TXA
					CLC
					ADC $02
					TAX
                    LDA PROPERTIES,x             ;  |
                    ORA $0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    PLX

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine - specific to sprite
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP2             dcb $88,$8A,$A8,$AA,$8C,$8E,$AC,$AE
HORZ_DISP2           dcb $F8,$08,$F8,$08
VERT_DISP2           dcb $00,$00,$10,$10
PROPERTIES2			dcb $00,$00,$00,$00

SUB_GFX2            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$01
					ASL A
					ASL A
					STA $03
                    PHX                     ; push sprite index
                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START2          
					LDA $01
					CLC
					ADC VERT_DISP2,x
					STA $0301,y
					
					LDA HORZ_DISP2,x
					CLC
					ADC $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0300,y             ; /
					
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILEMAP2,x           ; \ store tile
                    STA $0302,y
					PLX

					PHX
                    LDA PROPERTIES2,x               ;  |
                    ORA #$0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    PLX

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START2          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ; | set horizontal offscreen if necessary
                    LDA $14E0,x             ; |
                    SBC $1B                 ; |
                    BEQ ON_SCREEN_X         ; |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ; |
                    LDA $E4,x               ; |
                    REP #$20                ; |
                    SEC                     ; |
                    SBC $1A                 ; | mark sprite invalid if far enough off screen
                    CLC                     ; |
                    ADC.W #$0040            ; |
                    CMP.W #$0180            ; |
                    SEP #$20                ; |
                    ROL A                   ; |
                    AND #$01                ; |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ; | 
                    AND #$20                ; | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ; | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ; | set vertical offscreen if necessary
                    ADC TABLE1,y            ; |
                    PHP                     ; |
                    CMP $1C                 ; | (vert screen boundry)
                    ROL $00                 ; |
                    PLP                     ; |
                    LDA $14D4,x             ; | 
                    ADC #$00                ; |
                    LSR $00                 ; |
                    SBC $1D                 ; |
                    BEQ ON_SCREEN_Y         ; |
                    LDA $186C,x             ; | (vert offscreen)
                    ORA TABLE2,y            ; |
                    STA $186C,x             ; |
ON_SCREEN_Y         DEY                     ; |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ; | 
                    SBC $1A                 ; | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ; | 
                    SBC $1C                 ; | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ; |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generate routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN68            RTS     
FIRE_GEN            JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX

                    LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

                    LDA $D8,x
					SEC
					SBC #$32
                    STA $00D8,y             ;  |
					LDA $14D4,x
					SBC #$00
                    STA $14D4,y             ; /

                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX                     ; / 
                    
RETURN67            RTS                     ; return
					
              

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SPEED_DEC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   

SPEED_DEC           LDA $E4,x
                    SEC
                    SBC $7FFA00
                    STA $0F
                    LDA $14E0,x
                    SBC $7FFA01
                    BPL FACE_LEFT
                    JSR RIGHT_SPEED
                    BRA VERC
FACE_LEFT           CMP #$01
                    BEQ LEFT2
                    JSR LEFT_SPEED1
                    BRA VERC
LEFT2               JSR LEFT_SPEED2
VERC                LDA $D8,x
                    SEC
                    SBC $7FFA02
                    STA $0F
                    LDA $14D4,x
                    SBC $7FFA03
                    BPL FACE_UP
                    JSR DOWN_SPEED
                    LDA $1594,x
                    CMP #$10
                    BCS VER_E
                    LDA #$10
                    STA $1594,x
                    BRA VER_E
FACE_UP             JSR UP_SPEED
                    LDA $1594,x
                    CMP #$F0
                    BCC VER_E
                    LDA #$F0
                    STA $1594,x
VER_E               RTS

UP_SPEED            LDA $0F38
                    CMP #$00
                    BNE UP3
                    LDA $0F
                    CMP #$80
                    BCC UP2
                    LDA #$7F
UP2                 STA $0F
                    BRA UP5
UP3                 CMP #$02
                    BNE UP4
                    JSR UP1_1
                    BRA UP5
UP4                 JSR UP1_2
UP5                 LDA #$00
                    SEC
                    SBC $0F
                    STA $1594,x
                    RTS

DOWN_SPEED          LDA #$00
                    SEC
                    SBC $0F
                    STA $0F
                    LDA $0F38
                    CMP #$00
                    BNE DOWN3
                    LDA $0F
                    CMP #$80
                    BCC DOWN2
                    LDA #$7F
DOWN2               STA $1594,x
                    RTS
DOWN3               CMP #$02
                    BNE DOWN4
                    JSR UP1_1
                    BRA DOWN5
DOWN4               JSR UP1_2
DOWN5               LDA $0F
                    STA $1594,x
                    RTS
UP1_1
LOOPUP1             LDA $0F37
                    BEQ LOOPUP1E
                    LDA $0F
                    LSR A
                    STA $0F
                    DEC $0F37
                    LDA $0F37
                    BNE LOOPUP1
LOOPUP1E            LDA $0F
                    CMP #$80
                    BCC LOOPUP1EE
                    LDA #$7F
                    STA $0F
LOOPUP1EE           RTS

UP1_2               LDA $0F
                    CMP #$80
                    BCC LOOPUP3
                    LDA #$7F
                    STA $0F
                    STZ $0F37
                    RTS
LOOPUP3             LDA $0F37
                    BEQ LOOPUP2E
                    LDA $0F
                    ASL A
                    STA $0F
                    DEC $0F37
                    LDA $0F37
                    BNE UP1_2
LOOPUP2E            LDA $0F
                    CMP #$80
                    BCC LOOPUP2EE
                    LDA #$7F
                    STA $0F
LOOPUP2EE           RTS







LEFT_SPEED1         STZ $0F38
                    LDA $0F
                    CMP $1570,x
                    BCC LEFT1_2
                    LDA #$02
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_40
                    BRA LEFT1_3
LEFT1_2             CMP $151C,x
                    BCS LEFT1_3
                    LDA #$01
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_20
                    BRA LEFT1_3
LEFT1_3             LDA #$00
                    SEC
                    SBC $0F
                    STA $1504,x
                    RTS

LEFT1_40            
LOOP140             LDA $0F
                    CMP $1570,x
                    BCC LOOP140E
                    LSR A
                    STA $0F
                    INC $0F37
                    BRA LOOP140
LOOP140E            RTS
LEFT1_20            
LOOP120             LDA $0F
                    CMP $151C,x
                    BCS LOOP120E
                    ASL A
                    STA $0F
                    INC $0F37
                    BRA LOOP140
LOOP120E            RTS

LEFT_SPEED2         STZ $0F37
                    INC $0F37
                    LDA $0F
                    LSR A
                    CLC
                    ADC #$80
                    STA $0F
                    LDA #$02
                    STA $0F38
                    JSR LEFT1_40
                    LDA #$00
                    SEC
                    SBC $0F
                    STA $1504,x
                    RTS

RIGHT_SPEED         STZ $0F38
                    LDA #$00
                    SEC
                    SBC $0F
                    STA $0F
                    CMP $1570,x
                    BCC RIGHT_2
                    LDA #$02
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_40
                    BRA RIGHT_3
RIGHT_2             CMP $151C,x
                    BCS RIGHT_3
                    LDA #$01
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_20
                    BRA RIGHT_3
RIGHT_3             LDA $0F
                    STA $1504,x
                    RTS

SUB_GET_DIR         LDY #$00                ;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
                    LDA $94                 ;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
                    SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
                    SBC $E4,x               ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
                    STA $0F                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
                    LDA $95                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
                    SBC $14E0,x             ;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
                    BPL LABEL16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
                    INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
LABEL16             RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31
